<?php
//
// HTML Form class
//

class CTForm {
	var $action;
    var $totalwidth   = 754;
	var $method      = 'post';
	var $width 	     = '100%';
	var $align 	     = 'left';
	var $cellspacing = '0';
	var $cellpadding = '2';
	var $hidden      = array();
	var $fields      = array();
	var $buttons     = array();
	var $wysiwyg	 = array();
	var $enctype     = '';
	var $waitmessage = false; // Show Please wait...
	var $warningmessage = false; // Show warning message if user leaves the page
	var $return2tab = false; // Add JavaScript Code that handles Return as TAB
	var $upload		 = false; // is this an upload form?
	var $fieldconter = false; // Show number of characters/words...
	var $demomode 	 = false; // Disable submit bottom
	var $has_datefield = false; // is there at least one date field?
	var $formname    = "";
	var $width_left="30%";
	var $width_left1="4%";
	var $width_left2="26%";
	var $width_right="70%";
	var $width_right1="55%";
	var	$width_right2="15%";

	// Create a new form
	// $action is the page name (OR the full target URL) for post queries BUT
	// 			  the page name for GET querys.
	// $method is POST or GET
	// $errors is used to highlight fields that were not filled in correctly.
	function CTForm($_action, $_method='post', $_errors=array()) {
		$this->action = $_action;
		$this->method = $_method;
		$this->errors = $_errors;
		$this->formname = md5(time());
	}

	function add_hidden($hidval) {
		$this->hidden = array_merge($this->hidden, $hidval);
	}

	function add_text($label, $name, $value, $size, $len, $readonly=false, $hint='' ) {
		$field = array();
		$field['type'] = 'TEXT';
		$field['label'] = $label;
		$field['name'] = $name;
		$field['value'] = $value;
		$field['size'] = $size;
		$field['length'] = $len;
		$field['readonly'] = $readonly;
		$field['hint'] = $hint;
		$this->fields[] = $field;
	}

	function add_text_lang($label, $name, $value,$value2,$value3,$value4, $size, $len, $readonly=false, $hint='') {
		$field = array();
		$field['type'] = 'TEXT_LANG';
		$field['label'] = $label;
		$field['name'] = $name;
		$field['value'] = $value;
		$field['value2'] = $value2;
		$field['value3'] = $value3;
		$field['value4'] = $value4;
		$field['size'] = $size;
		$field['length'] = $len;
		$field['readonly'] = $readonly;
		$field['hint'] = $hint;
		$this->fields[] = $field;
	}

	function add_pass($label, $name, $value, $size, $len, $readonly=false, $hint='') {
		$field = array();
		$field['type'] = 'PASS';
		$field['label'] = $label;
		$field['name'] = $name;
		$field['value'] = $value;
		$field['size'] = $size;
		$field['length'] = $len;
		$field['readonly'] = $readonly;
		$field['hint'] = $hint;
		$this->fields[] = $field;
	}

	function add_label($label, $value, $name='') {
		$field = array();
		$field['type'] = 'LABEL';
		$field['label'] = $label;
		$field['value'] = $value;
		$field['name'] = $name;  // optional name of this field to allow errors as well...
		$this->fields[] = $field;
	}

	function add_label_3col($label, $value, $hint='', $thirdcol='', $name='') {
		$field = array();
		$field['type'] = 'LABEL_3COL';
		$field['label'] = $label;
		$field['value'] = $value;
		$field['hint'] = $hint;
		$field['thirdcol'] = $thirdcol;
		$field['name'] = $name;  // optional name of this field to allow errors as well...
		$this->fields[] = $field;
	}

	function add_textarea($label, $name, $value, $cols, $rows, $hint='', $hint2='', $counter=0, $extra_attribute='', $readonly=false ) {
		$field = array();
		$field['type'] = 'TEXTAREA';
		$field['label'] = $label;
		$field['name']  = $name;
		$field['value'] = $value;
		$field['cols']  = $cols;
		$field['rows']  = $rows;
		$field['hint']  = $hint;
		$field['hint2'] = $hint2;
		$field['counter']  = $counter;
		$field['extra']    = $extra_attribute;
		$field['readonly'] = $readonly;
		$this->fields[] = $field;
		if ($counter!=0) $this->fieldcounter = true;
	}

	function add_textarea_lang($label, $name, $value,$value2,$value3,$value4, $cols, $rows, $hint='') {
		$field = array();
		$field['type'] = 'TEXTAREA_LANG';
		$field['label'] = $label;
		$field['name'] = $name;
		$field['value'] = $value;
		$field['value2'] = $value2;
		$field['value3'] = $value3;
		$field['value4'] = $value4;
		$field['cols'] = $cols;
		$field['rows'] = $rows;
		$field['hint'] = $hint;
		$field['counter'] = 0;
		$this->fields[] = $field;
	}

	function add_textarea_wysiwyg($label, $name, $value, $cols, $rows, $hint='', $hint2='', $counter=0, $extra_attribute='' ) {
		$field = array();
		$field['type'] = 'WYSIWYG';
		$field['label'] = $label;
		$field['name'] = $name;
		$field['value'] = $value;
		$field['cols'] = $cols;
		$field['rows'] = $rows;
		$field['hint'] = $hint;
		$field['hint2'] = $hint2;
		$field['counter'] = $counter;
		$field['extra'] = $extra_attribute;
		$this->fields[] = $field;
		// if ($counter!=0) $this->fieldcounter = true; // does not work, yet.
		$this->wysiwyg[] = $name;
	}


	/**
	 * Add HTML Form Checkbox Fields -------------------------------------
	 * $label = Text in the left area of this form field
	 * $boxes = array with the checkboxes, each represented by and 5 field array, e.g.
	 *   $form->add_check(ct('S_TEXT_ON_LEFT'), array(
	 *			array( 'form_fieldname_1', 'form_fieldvalue_1', "Label of Field 1", <boolean - is it selected or not? >, <boolean - readonly box? >),
	 *			array( 'form_fieldname_2', 'form_fieldvalue_2', "Label of Field 2", true, false ) ));
	*/
	function add_check($label, $boxes) {
		$field = array();
		$field['type'] = 'CHECK';
		$field['label'] = $label;
		$field['boxes'] = $boxes;
		$this->fields[] = $field;
	}

	function add_check_3col($label, $boxes, $thirdcol, $hint='',$unit='') {
		$field = array();
		$field['type'] = 'CHECK_3COL';
		$field['label'] = $label;
		$field['boxes'] = $boxes;
		$field['thirdcol'] = $thirdcol;
		$field['hint'] = $hint;
		$field['unit'] = $unit;
		$this->fields[] = $field;
	}

	/**
	 * Add radio boxes
	 *	$form->add_radio(ct('S_TEXT_ON_LEFT'), 'form_fieldname', array(
	 *					array('false',ct('S_RADIOTEXT_TRUE')),
	 *					array('true',ct('S_RADIOTEXT_FALSE')),
	 *						), $this->get('fieldname'));
	 *
	 * @param string $label label on left side
	 * @param string $name  name of form field like "form_radio"
	 * @param array $boxes array of arrays with the single select boxes.
	 * @param string $checked value of the box that is selected
	 * @param string $hint text to show below select boxes...
	 */
	function add_radio($label, $name, $boxes, $checked, $hint='') {
		$field = array();
		$field['type'] = 'RADIO';
		$field['label'] = $label;
		$field['name']  = $name;
		$field['boxes'] = $boxes;
		$field['checked'] = $checked;
		$field['hint'] = $hint;
		$this->fields[] = $field;
	}

	function add_radio_3col($label, $name, $boxes, $checked, $thirdcol, $hint='') {
		$field = array();
		$field['type'] = 'RADIO_3COL';
		$field['label'] = $label;
		$field['name'] = $name;
		$field['boxes'] = $boxes;
		$field['checked'] = $checked;
		$field['thirdcol'] = $thirdcol;
		$field['hint'] = $hint;
		$this->fields[] = $field;
	}

	/**
	* -- Create a HTML Form Select Box ----------------------------------------------
	* $label = Text in the left area of this form field
	* $name  = form name of this field (in the HTML code)
	* $size  = number of lines of this select box. If >1, it is not a popup box but a scroll field.
	* $values   = an array of 2 field arrays with the values for the select box.
	*             e.g. array(array("code_1", "displayed name for code 1"), array("code_2", "displayed name for code 2"), ...)
	* $selected = an array of the (pre-)selected values of this select box, e.g. array("code_1")
	* $multi    = true or false - is the user allowed to select several items in this box?
	*             Does only work if $size > 1
	* $hint     = a little hint shown right of the select box. Add "<br>" before this text to show it below the box.
	*/
	function add_select($label, $name, $size, $values, $selected=array(), $multi=false, $hint='') {
		$field = array();
		$field['type'] = 'SELECT';
		$field['name'] = $name;
		$field['label'] = $label;
		$field['size'] = $size;
		$field['values'] = $values;
		$field['selected'] = $selected;
		$field['multi'] = $multi;
		$field['hint'] = $hint;
		$this->fields[] = $field;
	}

	function add_select_autosubmit($label, $name, $values, $selected=array() ) {
		$field = array();
		$field['type'] = 'SELECT_AUTOSUBMIT';
		$field['label'] = $label;
		$field['name'] = $name;
		$field['size'] = 1;
		$field['values'] = $values;
		$field['selected'] = $selected;
		$field['multi'] = false;
		$field['hint'] = '';
		$this->fields[] = $field;
	}

	/**
	* Create a HTML Form Select Box (3 columns, left side)
	* The box will be shown on the left side of the form.
	* $label = Text in the left area of this form field
	* $name  = form name of this field (in the HTML code)
	* $size  = number of lines of this select box. If >1, it is not a popup box but a scroll field.
	* $values   = an array of 2 field arrays with the values for the select box.
	*             e.g. array(array("code_1", "displayed name for code 1"), array("code_2", "displayed name for code 2"), ...)
	* $selected = an array of the (pre-)selected values of this select box, e.g. array("code_1")
	* $multi    = true or false - is the user allowed to select several items in this box?
	*             Does only work if $size > 1
	* $hint     = a little hint shown right of the select box. Add "<br>" before this text to show it below the box.
	* $thirdcol = text for third column (usually the price)
	* $unit     = a unit text to show before the selectbox.
	*/
	function add_select_3col($label, $name, $size, $values, $selected=array(), $multi=false, $hint='', $thirdcol='', $unit='') {
		$field = array();
		$field['type']   = 'SELECT_3COL';
		$field['name']   = $name;
		$field['label']  = $label;
		$field['size']   = $size;
		$field['values'] = $values;
		$field['selected'] = $selected;
		$field['multi']  = $multi;
		$field['hint']   = $hint;
		$field['thirdcol'] = $thirdcol;
		$field['unit']   = $unit;
		$this->fields[]  = $field;
	}

	function add_select_3col_right($label, $name, $size, $values, $selected=array(), $multi=false, $hint='') {
		$field = array();
		$field['type'] = 'SELECT_3COL_RIGHT';
		$field['name'] = $name;
		$field['label'] = $label;
		$field['size'] = $size;
		$field['values'] = $values;
		$field['selected'] = $selected;
		$field['multi'] = $multi;
		$field['hint'] = $hint;
		$this->fields[] = $field;
	}

	function add_select_3col_right_double($label, $name, $name2, $values, $values2, $selected=array(),$selected2=array(), $separator='', $size=1, $multi=false, $hint='') {
		$field = array();
		$field['type'] = 'SELECT_3COL_RIGHT_DOUBLE';
		$field['label'] = $label;
		$field['name'] = $name;
		$field['name2'] = $name2;
		$field['values'] = $values;
		$field['values2'] = $values2;
		$field['selected'] = $selected;
		$field['selected2'] = $selected2;
		$field['separator'] = $separator;
		$field['size'] = $size;
		$field['multi'] = $multi;
		$field['hint'] = $hint;
		$this->fields[] = $field;
	}

	function add_text_3col_right($label, $name, $value, $size, $len, $readonly=false, $hint='' ) {
		$field = array();
		$field['type'] = 'TEXT_3COL_RIGHT';
		$field['label'] = $label;
		$field['name'] = $name;
		$field['value'] = $value;
		$field['size'] = $size;
		$field['length'] = $len;
		$field['readonly'] = $readonly;
		$field['hint'] = $hint;
		$this->fields[] = $field;
	}

	function add_textarea_3col_right($label, $name, $value, $cols, $rows, $hint='' ) {
		$field = array();
		$field['type'] = 'TEXTAREA_3COL_RIGHT';
		$field['label'] = $label;
		$field['name'] = $name;
		$field['value'] = $value;
		$field['cols'] = $cols;
		$field['rows'] = $rows;
		$field['hint'] = $hint;
		$this->fields[] = $field;
	}

	function add_description($value){
		$field = array();
		$field['type'] = 'DESCRIPTION';
		$field['value'] = $value;
		$this->fields[] = $field;
	}

	function add_upload($label, $name, $size, $maxfilesize, $hint="") {
		$field = array();
		$field['type'] = 'UPLOAD';
		$field['label'] = $label;
		$field['name'] = $name;
		$field['size'] = $size;
		$field['maxfilesize'] = $maxfilesize;
		$field['hint'] = $hint;
		$this->fields[] = $field;
		$this->enctype = 'multipart/form-data';
		$this->method = 'post';
		$this->upload = true;
	}

	function add_separator($label) {
		$field = array();
		$field['type'] = 'SEPARATOR';
		$field['label'] = $label;
		$this->fields[] = $field;
	}

	function add_separator3($label1, $info="&nbsp;", $label2="&nbsp;") {
		$field = array();
		$field['type'] = 'SEPARATOR3';
		$field['label1'] = $label1;
		$field['info'] = $info;
		$field['label2'] = $label2;
		$this->fields[] = $field;
	}

	function add_subseparator($label, $info=null) {
		$field = array();
		$field['type'] = 'SUBSEPARATOR';
		$field['label'] = $label;
		$field['info'] = $info;
		$this->fields[] = $field;
	}

	function add_subseparator3($label1, $info="&nbsp;", $label2="&nbsp;") {
		$field = array();
		$field['type'] = 'SUBSEPARATOR3';
		$field['label1'] = $label1;
		$field['info'] = $info;
		$field['label2'] = $label2;
		$this->fields[] = $field;
	}

	function add_submit_not_bottom($name, $label, $highlight=false) {
		$field[] = array();
		$field['type'] = 'SUBMIT_NOT_BOTTOM';
		$field['name'] = $name;
		$field['label'] = $label;
		$field['highlight'] = $highlight;
		$this->fields[] = $field;
	}

	function add_submit($name, $label, $extra_attributes="") {
		$field[] = array();
		$field['type'] = 'SUBMIT';
		$field['name'] = $name;
		$field['label'] = $label;
		$field['extra_attributes'] = $extra_attributes;
		$this->buttons[] = $field;
	}

	function add_submit_noscriptonly($name, $label, $extra_attributes="") {
		$field[] = array();
		$field['type'] = 'SUBMIT_NOSCRIPTONLY';
		$field['name'] = $name;
		$field['label'] = $label;
		$field['extra_attributes'] = $extra_attributes;
		$this->buttons[] = $field;
	}

	function add_reset($label) {
		$field[] = array();
		$field['type'] = 'RESET';
		$field['label'] = $label;
		$this->buttons[] = $field;
	}

	function add_date($label,$name,$show_day,$selected=array(),$hint=''){
		$field[] = array();
		$field['type'] = 'DATE';
		$field['name'] = $name;
		$field['label'] = $label;
		$field['show_day'] = $show_day;
		$field['selected'] = $selected;
		$field['hint'] = $hint;
		$this->fields[] = $field;
		$this->has_datefield=true;
	}

	function add_datetime($label,$name,$show_day,$selected=array(),$hint=''){
		$field[] = array();
		$field['type'] = 'DATETIME';
		$field['name'] = $name;
		$field['label'] = $label;
		$field['show_day'] = $show_day;
		$field['selected'] = $selected;
		$field['hint'] = $hint;
		$this->fields[] = $field;
		$this->has_datefield=true;
	}

	function add_checkbox_datetime($label,$name,$enabled,$enabled_hint,$selected=array(),$hint=''){
		$field[] = array();
		$field['type'] = 'CHECKBOXDATETIME';
		$field['name'] = $name;
		$field['label'] = $label;
		$field['show_day'] = true;
		$field['enabled'] = $enabled;
		$field['enabled_hint'] = $enabled_hint;
		$field['selected'] = $selected;
		$field['hint'] = $hint;
		$this->fields[] = $field;
		$this->has_datefield=true;
	}

	function add_time($label,$name,$selected=array(),$hint=''){
		$field[] = array();
		$field['type'] = 'TIME';
		$field['name'] = $name;
		$field['label'] = $label;
		$field['selected'] = $selected;
		$field['hint'] = $hint;
		$this->fields[] = $field;
	}

	function add_crosstable($tables,$row,$column,$cells){
		$field[]=array();
		$field['type'] ='CROSSTABLE';
		$field['tables'] = $tables;
		$field['row'] = $row;
		$field['column'] = $column;
		$field['cells'] =$cells;
		$this->fields[] = $field;
	}

	function add_spacer(){
		$field[]=array();
		$field['type'] ='SPACER';
		$this->fields[] = $field;
	}

	function add_spacer2(){
		$field[]=array();
		$field['type'] ='SPACER2';
		$this->fields[] = $field;
	}


	// generate and show the form object
	function show() {
		global $ctconf, $session;
		$browser=ct_detect_browser();
		$onSubmit=array();
		$onKeyPress=array();

		if ($this->waitmessage) {  // JavaScript code for "please wait" message on buttons...
			ct_load_lib('javascript.lib');
			echo get_js_waitmessage();
			if ($this->upload) echo get_js_waitwindow();
			$onSubmit[]="disableForm(this)";
			if ($this->upload) $onSubmit[]="show_wait_message()";
		}

		if ($this->fieldcounter) {  // JavaScript-Code to show number of Characters/Words.
			ct_load_lib('javascript.lib');
			echo get_js_fieldcounter();
		}

		if ($this->has_datefield) {  // JavaScript-Code to verify the entered date (day of month).
			ct_load_lib('javascript.lib');
			echo get_js_checkdate();
		}

		if ($this->warningmessage) {  // Show warning if a user leaves a page and has not submitted the data...
			ct_load_lib('javascript.lib');
			echo get_js_checkDataSaved($this->formname);
			$onSubmit[]="noNeedToConfirm()";	// If user selects sumbit, no confirm message is required.
		}

		if ($this->return2tab) {  // Handle Return key as Tab key to enter next field.
			ct_load_lib('javascript.lib');
			echo get_js_return2tab($this->formname);
			$onKeyPress[]="return2tab(event)";	// If user selects sumbit, no confirm message is required.
		}

		if (count($this->wysiwyg)>0) { // use WYSIWYG-Editor for at least one textarea.
			ct_load_lib('javascript_wysiwyg.lib');
			echo get_js_wysiwyg_editor($this->wysiwyg);
		}

		// form element
		if (strtolower($this->method)=="get") {
			$this->add_hidden(array(array("page",$this->action)));
			echo "<form action=\"".ct_pageurl("")."\" method=\"get\"";
			if ($this->enctype != "") {
				echo " enctype=\"".$this->enctype."\"";
			}
			echo " name=\"".$this->formname."\"";
			echo ">\n";
		} else { // post
			if (strpos($this->action,"page=") === FALSE)
				echo "<form action=\"".ct_pageurl($this->action)."\"";
			else
				echo "<form action=\"".$this->action."\"";
				echo " method=\"post\"";
			if ($this->enctype != "") {
				echo " enctype=\"".$this->enctype."\"";
			}
			if (count($onSubmit)>0)
				echo " onsubmit=\"return (".implode(' && ',$onSubmit).");\" ";
			if (count($onKeyPress)>0)
				echo " onkeypress=\"(".implode(' && ',$onKeyPress).");\" ";
			echo " name=\"".$this->formname."\"";
			echo ">\n";
		}

		// hidden fields
		if (sizeof($this->hidden) > 0) {
			while (list(,$h) = each($this->hidden)) {
				echo "<input type=\"hidden\" name=\"".$h[0]."\" value=\"".ct_form_encode($h[1])."\">\n";
			}
		}

		if ($this->cellspacing==0 && $browser['name']=="netscape")
		 	$this->cellspacing=1;

		// table header
		echo "\n<table align=\"".$this->align."\" ";
		if ($this->width!="") echo "width=\"".$this->width."\" ";
		echo "class=\"form_table\" cellspacing=\"$this->cellspacing\" cellpadding=\"$this->cellpadding\" border=0>\n";

		// Calculate width of the 2/3/4 columns. Only possible if the with is set in
		// absolute values (pixels) and not in percent.
		if (($this->width>1) && (strpos($this->width,"%")>0)) {
			$this->width = round($this->width*$this->totalwidth/100,0);
		}

		if (($this->width>1) && (strpos($this->width,"%")===false)) {
			$this->width_left=round(0.30*$this->width,0); // "30%";
			$this->width_left1=round(0.04*$this->width,0); // "4%";
			$this->width_left2=round(0.26*$this->width,0); // "26%";

			$this->width_right=round(0.70*$this->width,0); //  "70%";
			$this->width_right1=round(0.55*$this->width,0); //  "55%";
			$this->width_right2=round(0.15*$this->width,0); //  "15%";
		}

		// output all other fields
		reset($this->fields);
		while (list(,$field) = each($this->fields)) {
			$css_label = "topline_white form_td_label";
			$css_field = "topline_white form_td_field";
			$css_entry = "topline_white form_td_entry";
			$css_field_sub = "form_td_field_sub";
			$erroricon = '';
			// Normal fields
			if (isset($field['name']) && $field['name']!='' &&
					is_array($this->errors) && !empty($this->errors) &&
					(in_array($field['name'], $this->errors) || in_array($field['label'], $this->errors))) {
				$css_label     .= "_error";
				$css_field     .= "_error";
				$css_entry     .= "_error";
				$css_field_sub .= "_error";
				$erroricon = '<img src="icons/warning.gif" align="top" alt="Warning">';
			}
			// Check boxes and radio buttons
			if (isset($field['boxes']) && is_array($this->errors) && !empty($this->errors)) {
				while (list($k,$v) = each($field['boxes'])) {
					if (in_array($v[0], $this->errors)) {
						$css_label     .= "_error";
						$css_field     .= "_error";
						$css_entry     .= "_error";
						$css_field_sub .= "_error";
						$erroricon = '<img src="icons/warning.gif" align="top" alt="Warning">';
						break;
					}
				}
				reset ($field['boxes']);
			}
			switch ($field['type']) {
				case 'TEXT':
				case 'TEXT_LANG':
				echo "<tr >\n";
				echo "<td width=\"$this->width_left\" valign=top align=right class=\"$css_label\" colspan=\"2\" >\n";
				if (isset($field['label']) && !empty($field['label']))
					echo "<span class=\"form_label\">".$field['label']."</span>";
				echo "&nbsp;\n";
				if ($field['type'] == "TEXT_LANG") echo "<span class=\"form_label_sub\">(".substr($ctconf['lang'][$session->get('langno')]['languages']['0'],0,3).".)</span>\n";
				echo $erroricon;
				echo "</td><td width=\"$this->width_right\" align=left valign=top class=\"$css_field\" colspan=\"2\">\n";
				echo "<input type=\"text\" name=\"".$field['name']."\" ";
				echo "value=\"".ct_form_encode($field['value'])."\" size=\"".$field['size']."\" ";
				if ($field['readonly']) {
					echo "readonly class=\"disabled\" ";
				}
				echo "maxlength=\"".$field['length']."\">\n";
				if ($field['hint'] != '') {
					echo "<span class=\"form_hint\">".$field['hint']."</span>\n";
				}
				echo "</td></tr>\n";
				if ($field['type'] == "TEXT" || !isset($ctconf['lang']['2']))
				break; // ------------------------

				$css_label = "form_td_label_sub";
				echo "<tr><td width=\"$this->width_left1\" valign=top align=right class=\"form_td_label\" rowspan=\"".(count($ctconf['lang'])-1)."\">\n";
				echo "<td width=\"$this->width_left2\" valign=top align=right class=\"$css_label\">\n";
				echo "<span class=\"form_label_sub\">(".substr($ctconf['lang'][$session->get('langno')]['languages']['1'],0,3).".)</span>\n";
				echo "</td><td width=\"$this->width_right\" align=left valign=top class=\"$css_field_sub\" colspan=\"2\">\n";
				echo "<input type=\"text\" name=\"".$field['name']."2\" ";
				echo "value=\"".ct_form_encode($field['value2'])."\" size=\"".$field['size']."\" ";
				if ($field['readonly']) {
					echo "readonly class=\"disabled\" ";
				}
				echo "maxlength=\"".$field['length']."\">\n";
				echo "</td></tr>\n";
				if (!isset($ctconf['lang']['3']))
				break; // ------------------------

				echo "<tr>"; //<td width=\"$this->width_left1\" valign=top align=right class=\"form_td_label\">\n";
				echo "<td width=\"$this->width_left2\" valign=top align=right class=\"$css_label\">\n";
				echo "<span class=\"form_label_sub\">(".substr($ctconf['lang'][$session->get('langno')]['languages']['2'],0,3).".)</span>\n";
				echo "</td><td width=\"$this->width_right\" align=left valign=top class=\"$css_field_sub\" colspan=\"2\">\n";
				echo "<input type=\"text\" name=\"".$field['name']."3\" ";
				echo "value=\"".ct_form_encode($field['value3'])."\" size=\"".$field['size']."\" ";
				if ($field['readonly']) {
					echo "readonly class=\"disabled\" ";
				}
				echo "maxlength=\"".$field['length']."\">\n";
				echo "</td></tr>\n";
				if (!isset($ctconf['lang']['4']))
				break; // ------------------------

				echo "<tr>"; // <td width=\"$this->width_left1\" valign=top align=right class=\"form_td_label\">\n";
				echo "<td width=\"$this->width_left2\" valign=top align=right class=\"$css_label\">\n";
				echo "<span class=\"form_label_sub\">(".substr($ctconf['lang'][$session->get('langno')]['languages']['3'],0,3).".)</span>\n";
				echo "</td><td width=\"$this->width_right\" align=left valign=top class=\"$css_field_sub\" colspan=\"2\">\n";
				echo "<input type=\"text\" name=\"".$field['name']."4\" ";
				echo "value=\"".ct_form_encode($field['value4'])."\" size=\"".$field['size']."\" ";
				if ($field['readonly']) {
					echo "readonly class=\"disabled\" ";
				}
				echo "maxlength=\"".$field['length']."\">\n";
				echo "</td></tr>\n";
				break; // ------------------------ END OF TEXT_LANG



				case 'PASS':
				echo "<tr><td width=\"$this->width_left\" valign=top align=right class=\"$css_label\" colspan=\"2\">\n";
				echo "<span class=\"form_label\">".$field['label']."</span>&nbsp;\n";
				echo $erroricon;
				echo "</td><td width=\"$this->width_right\" align=left valign=top class=\"$css_field\" colspan=\"2\">\n";
				echo "<input type=\"password\" name=\"".$field['name']."\" ";
				echo "value=\"".ct_form_encode($field['value'])."\" size=\"".$field['size']."\" ";
				if ($field['readonly']) {
					echo "readonly class=\"disabled\" ";
				}
				echo "maxlength=\"".$field['length']."\" autocomplete=\"off\">\n";
				if ($field['hint'] != '') {
					echo "<br><span class=\"form_hint\">".$field['hint']."</span>\n";
				}
				echo "</td></tr>\n";
				break; // ------------------------


				case 'LABEL':
				echo "<tr><td width=\"$this->width_left\" valign=top align=right class=\"$css_label\" colspan=\"2\">\n";
				if (isset($field['label']) && !empty($field['label']))
					echo "<span class=\"form_label\">".$field['label']."</span>";
			 	echo "&nbsp;\n";
				echo "</td><td width=\"$this->width_right\" align=left valign=top class=\"$css_field\" colspan=\"2\">\n";
				echo "<span class=\"font10\">".$field['value']."</span>\n";
				echo "</td></tr>\n";
				break; // ------------------------


				case 'TEXTAREA':
				case 'TEXTAREA_LANG':
				case 'WYSIWYG':
				echo "<tr><td width=\"$this->width_left\" valign=top align=right class=\"$css_label\" colspan=\"2\">\n";
				echo "<span class=\"form_label\">".$field['label']."</span>&nbsp;\n";
				if ($field['type'] == "TEXTAREA_LANG") echo "<span class=\"form_label_sub\">(".substr($ctconf['lang'][$session->get('langno')]['languages']['0'],0,3).".)</span>\n";
				echo $erroricon;
				echo "</td><td width=\"$this->width_right\" align=left valign=top class=\"$css_field\" colspan=\"2\">\n";
				if ($field['hint'] != '') {
					echo "<span class=\"form_hint\">".$field['hint']."</span><br>\n";
				}
				echo "<textarea name=\"".$field['name']."\" id=\"".$field['name']."\" ";
				echo "cols=\"".$field['cols']."\" ";
				echo "rows=\"".$field['rows']."\" ";
				if ($this->fieldcounter && $field['counter']!=0) {  // JavaScript-Code to show number of Characters/Words.
					echo "onFocus=\"showLength(this,'".$field['name']."_help',".$field['counter'].");\" ";
					echo "onKeyUp=\"showLength(this,'".$field['name']."_help',".$field['counter'].");\" ";
				}
				if (isset($field['extra']) and $field['extra']!='') {
					echo ' '.$field['extra'];
				}
				if (isset($field['readonly']) and $field['readonly']) {
					echo " readonly class=\"disabled\" ";
				}
				echo ">\n";
				echo ct_form_encode($field['value']);
				echo "</textarea>\n";
				if ($this->fieldcounter && $field['counter']!=0) // add div to display output...
					echo "<div class=\"fontlabel font10\" id=\"".$field['name']."_help\" >&nbsp;</div>";
				if ($field['hint2'] != '')
					echo "<div class=\"form_hint\">".$field['hint2']."</div>\n";

				echo "</td></tr>\n";
				if ($field['type'] != "TEXTAREA_LANG" || !isset($ctconf['lang']['2']))
					break; // ------------------------

				$css_label = "form_td_label_sub";
				echo "<tr><td width=\"$this->width_left1\" valign=top align=right class=\"form_td_label\" rowspan=\"".(count($ctconf['lang'])-1)."\">\n";
				echo "<td width=\"$this->width_left2\" valign=top align=right class=\"$css_label\">\n";
				echo "<span class=\"form_label_sub\">(".substr($ctconf['lang'][$session->get('langno')]['languages']['1'],0,3).".)</span>\n";
				echo "</td><td width=\"$this->width_right\" align=left valign=top class=\"$css_field_sub\" colspan=\"2\">\n";
				echo "<textarea name=\"".$field['name']."2\" cols=\"".$field['cols']."\"";
				echo "rows=\"".$field['rows']."\">\n";
				echo ct_form_encode($field['value2']);
				echo "</textarea>\n</td></tr>\n";

				if (!isset($ctconf['lang']['3']))
					break; // ------------------------
				echo "<tr>"; //<td width=\"$this->width_left1\" valign=top align=right class=\"form_td_label\">\n";
				echo "<td width=\"$this->width_left2\" valign=top align=right class=\"$css_label\">\n";
				echo "<span class=\"form_label_sub\">(".substr($ctconf['lang'][$session->get('langno')]['languages']['2'],0,3).".)</span>\n";
				echo "</td><td width=\"$this->width_right\" align=left valign=top class=\"$css_field_sub\" colspan=\"2\">\n";
				echo "<textarea name=\"".$field['name']."3\" cols=\"".$field['cols']."\"";
				echo "rows=\"".$field['rows']."\">\n";
				echo ct_form_encode($field['value3']);
				echo "</textarea>\n</td></tr>\n";

				if (!isset($ctconf['lang']['4']))
					break; // ------------------------
				echo "<tr>"; //<td width=\"$this->width_left1\" valign=top align=right class=\"form_td_label\">\n";
				echo "<td width=\"$this->width_left2\" valign=top align=right class=\"$css_label\">\n";
				echo "<span class=\"form_label_sub\">(".substr($ctconf['lang'][$session->get('langno')]['languages']['3'],0,3).".)</span>\n";
				echo "</td><td width=\"$this->width_right\" align=left valign=top class=\"$css_field_sub\" colspan=\"2\">\n";
				echo "<textarea name=\"".$field['name']."4\" cols=\"".$field['cols']."\"";
				echo "rows=\"".$field['rows']."\">\n";
				echo ct_form_encode($field['value4']);
				echo "</textarea>\n</td></tr>\n";
				break; // ------------------------


				case 'CHECK':
				echo "<tr><td width=\"$this->width_left\" valign=top align=right class=\"$css_label\" colspan=\"2\">\n";
				echo "<span class=\"form_label\">".$field['label']."</span>&nbsp;\n";
				echo $erroricon;
				echo "</td><td width=\"$this->width_right\" align=left valign=top class=\"$css_field\" colspan=\"2\">\n";
				while (list($k,$v) = each($field['boxes'])) {
					if ($v[0]=="" && $v[1]=="") {	// Only text, no checkbox
						echo "<span class=\"form_checkbox\">".$v[2]."&nbsp;</span><br>\n";
					} elseif (!isset($v[5]) || !$v[5]) {	// Active Checkbox
						$id = preg_replace('|\[\]|','',$v[0]."_".$v[1]); // create id, remove '[]'
						echo "<input type=\"checkbox\" class=\"checkboxradio\" id=\"".$id."\"  name=\"".$v[0]."\" value=\"".$v[1]."\"";
						if ($v[3]) {
							echo " checked";
						}
						echo ">\n";
						if ($v[2]!="")
							echo " <label for=\"".$id."\"><span class=\"form_checkbox\">".$v[2]."&nbsp;</span></label><br>\n";
					} else { // read-only
						if ($v[3]) {
							echo "<input type=\"hidden\" name=\"".$v[0]."\" value=\"".$v[1]."\">\n";
							echo "<span class=\"form_checkbox\">";
							echo "<img src=\"".ct_getbaseurl()."icons/checkboxOn.gif\" align=top> ";
						} else {
							echo "<span class=\"form_checkbox\">";
							echo "<img src=\"".ct_getbaseurl()."icons/checkboxOff.gif\" align=top> ";
						}
						echo trim($v[2])."</span><br>\n";
					}
					if (isset($v[4]) && $v[4] != '') {
						echo "<span class=\"form_hint\">".$v[4]."</span><br>\n";
					}
				}
				echo "</td></tr>\n";
				break; // ------------------------


				case 'RADIO':
				echo "<tr><td width=\"$this->width_left\" valign=top align=right class=\"$css_label\" colspan=\"2\">\n";
				echo "<span class=\"form_label\">".$field['label']."</span>&nbsp;\n";
				echo $erroricon;
				echo "</td><td width=\"$this->width_right\" align=left valign=top class=\"$css_field\" colspan=\"2\">\n";
				if ($field['hint'] != '') {
					echo "<span class=\"form_hint\">".$field['hint']."</span><br>\n";
				}
				$i = 1;
				while (list($k,$v) = each($field['boxes'])) {
					if ($i++>1) echo "\n<br>";
					echo "<input type=\"radio\"  class=\"checkboxradio\" id=\"".$field['name'].$v[0]."\" name=\"".$field['name']."\" value=\"".$v[0]."\"";
					if ($field['checked'] == $v[0]) {
						echo " checked";
					}
					echo ">&nbsp;<label for=\"".$field['name'].$v[0]."\"><span class=\"form_radio\">".trim($v[1])."</span></label>";
					if (isset($v[2]) && $v[2] != '') {
						echo "<br>\n<span class=\"form_hint\">".$v[2]."</span>\n";
					}
				}
				echo "</td></tr>\n";
				break; // ------------------------


				case 'SELECT':
				echo "<tr><td valign=top align=right class=\"$css_label\" colspan=\"2\">\n";
				echo "<span class=\"form_label\">".$field['label']."</span>&nbsp;\n";
				echo $erroricon;
				echo "</td><td align=left valign=top class=\"$css_field\" colspan=\"2\">\n";
				echo "<select name=\"".$field['name']."\" size=\"".$field['size']."\"";
				if ($field['multi']) {
					echo " multiple";
				}
				echo ">\n";
				$alreadyselected=array();
				while (list($k,$v) = each($field['values'])) {
					echo "<option value=\"".ct_form_encode_noentities($v[0])."\"";
					if (in_array($v[0], $field['selected']) && !in_array($v[0], $alreadyselected)) {
						echo " selected";
						$alreadyselected[] = $v[0]; // if entries repeat, select them only the first time! (Used in country select-box)
					}
					if (strlen($v[1])>85) $v[1]=substr($v[1],0,83)."...";
					echo ">".ct_form_encode_noentities($v[1])."&nbsp;</option>\n";
				}
				echo "</select>\n";
				if ($field['hint'] != '') {
					echo "<span class=\"form_hint\">".$field['hint']."</span>\n";
				}
				echo"</td></tr>\n";
				break; // ------------------------


				case 'SELECT_AUTOSUBMIT':
				echo "<tr><td valign=top align=right class=\"$css_label\" colspan=\"2\">\n";
				echo "<span class=\"form_label_small\">".$field['label']."</span>&nbsp;\n";
				echo $erroricon;
				echo "</td><td align=left valign=top class=\"$css_field\" colspan=\"2\">\n";
				echo "<select class=\"optionsmall\" name=\"".$field['name']."\" size=\"".$field['size']."\" onChange=\"this.form.submit();\" >";
				$alreadyselected=array();
				while (list($k,$v) = each($field['values'])) {
					echo "<option class=\"optionsmall\" value=\"".ct_form_encode_noentities($v[0])."\"";
					if (in_array($v[0], $field['selected']) && !in_array($v[0], $alreadyselected)) {
						echo " selected";
						$alreadyselected[] = $v[0];
					}
					if (strlen($v[1])>85) $v[1]=substr($v[1],0,83)."...";
					echo ">".ct_form_encode_noentities($v[1])."&nbsp;</option>\n";
				}
				echo "</select>\n";
				echo"</td></tr>\n";
				break; // ------------------------


				// 3 - Column form elements for participant registration...

				case 'LABEL_3COL':
				echo "<tr><td width=\"$this->width_left\" valign=top align=right class=\"$css_entry\" colspan=\"2\">\n";
				echo "<span class=\"fontbold font10\">".$field['value']."</span>&nbsp;\n";
				echo $erroricon;
				echo "</td><td width=\"$this->width_right1\" align=left valign=top class=\"$css_field\">\n";
				echo "<span class=\"fontbold font10\">".$field['label']."</span>\n";
				if ($field['hint'] != '') {
					echo "<br><span class=\"form_hint\">".$field['hint']."</span>\n";
				}
				echo "</td><td width=\"$this->width_right2\" align=right valign=top class=\"$css_field\">&nbsp;\n";
				echo $field['thirdcol'];
				echo "</td></tr>\n";
				break; // ------------------------

				case 'CHECK_3COL':
				echo "<tr>";
				echo "<td width=\"$this->width_left\" align=right valign=top class=\"$css_entry\" colspan=\"2\">\n";
				if ($field['unit'] != '') {
					echo "<span class=\"form_label_sub\">".$field['unit']."</span>&nbsp;\n";
				}
				while (list($k,$v) = each($field['boxes'])) {
					echo "<input type=\"checkbox\" class=\"checkboxradio\" id=\"".$v[0]."\" name=\"".$v[0]."\" value=\"".$v[1]."\"";
					if ($v[3]) {
						echo " checked";
					}
					echo "> ";
					if ($v[2]!="")
						echo "<label for=\"".$v[0]."\"><span class=\"form_checkbox\">".trim($v[2])."&nbsp;</span></label>\n";
				}
				echo "&nbsp;<BR></td>";
				echo "<td width=\"$this->width_right1\" align=left valign=top class=\"$css_field\">\n";
				echo "<b>".$field['label']."</b>&nbsp;\n";
				if ($v[4] != '') {
					echo "<span class=\"form_hint\">".$v[4]."</span><br>\n";
				}
				if ($field['hint'] != '') {
					echo "<br><span class=\"form_hint\">".$field['hint']."</span>\n";
				}
				echo "</td><td width=\"$this->width_right2\" align=right valign=top class=\"$css_field\">\n";
				echo $field['thirdcol'];
				echo "</td></tr>\n";
				break; // ------------------------


				case 'RADIO_3COL':
				echo "<tr>";
				echo "<td width=\"$this->width_left\" align=right valign=top class=\"$css_entry\" colspan=\"2\">\n";
				while (list($k,$v) = each($field['boxes'])) {
					echo "<input type=\"radio\" class=\"checkboxradio\" id=\"".$field['name'].$v[0]."\" name=\"".$field['name']."\" value=\"".$v[0]."\"";
					if ($field['checked'] == $v[0]) {
						echo " checked";
					}
					echo ">";
					if ($v[1]!="")
						echo "<label for=\"".$field['name'].$v[0]."\"><span class=\"form_radio\">".trim($v[1])."</span></label>";
					echo "\n";

				}
				echo "&nbsp;<BR></td>";
				if ($field['thirdcol']=='') // Is the third column empty? Use the space for the second column as well...
					echo "<td colspan=2 align=left valign=top class=\"$css_field\">\n";
  				else
					echo "<td align=left valign=top class=\"$css_field\">\n";

				echo "<b>".$field['label']."</b>&nbsp;\n";
				if ($field['hint'] != '') {
					echo "<br><span class=\"form_hint\">".$field['hint']."</span>\n";
				}
				echo "</td><td align=right valign=top class=\"$css_field\">\n";

				if ($field['thirdcol']!='') { // When not empty do show
					echo $field['thirdcol'];
				} else {
					echo "&nbsp;";
				}
				echo "</td></tr>\n";
				break; // ------------------------


				case 'SELECT_3COL':
				echo "<tr>";
				echo "<td width=\"$this->width_left\" align=right valign=top class=\"$css_entry\" colspan=\"2\">\n";
				if ($field['unit'] != '') {
					echo "<span class=\"form_label_sub\">".$field['unit']."</span>&nbsp;\n";
				}
				echo "<select name=\"".$field['name']."\" size=\"".$field['size']."\"";
				if ($field['multi']) {
					echo " multiple";
				}
				echo ">\n";
				while (list($k,$v) = each($field['values'])) {
					echo "<option value=\"".$v[0]."\"";
					if (in_array($v[0], $field['selected'])) {
						echo " selected";
					}
					if (strlen($v[1])>70) $v[1]=substr($v[1],0,65)."...";
					echo ">".$v[1]."&nbsp;&nbsp;</option>\n";
				}
				echo "</select>\n";
				echo "&nbsp;<BR></td>";
				echo "<td width=\"$this->width_right1\" valign=top align=left class=\"$css_field\">\n";
				echo "<b>".$field['label']."</b>&nbsp;\n";
				if ($field['hint'] != '') {
					echo "<br><span class=\"form_hint\">".$field['hint']."</span>\n";
				}
				echo "</td>";
				echo "<td width=\"$this->width_right2\" align=right valign=top class=\"$css_field\">\n";
				echo $field['thirdcol'];
				echo"</td></tr>\n";
				break; // ------------------------

				case 'SELECT_3COL_RIGHT':
				echo "<tr>";
				echo "<td width=\"$this->width_left1\" valign=top align=right class=\"form_td_entry\">&nbsp;";
				echo "</td>\n";
				echo "<td width=\"$this->width_left2\" align=right valign=top class=\"form_td_label_sub\">\n";
				echo "<span class=\"form_label\">".$field['label']."</span>&nbsp;\n";
				echo $erroricon;
				echo "</td>";
				echo "<td width=\"$this->width_right\" valign=top align=left class=\"$css_field_sub\" colspan=\"2\">\n";
				echo "<select name=\"".$field['name']."\" size=\"".$field['size']."\"";
				if ($field['multi']) {
					echo " multiple";
				}
				echo ">\n";
				while (list($k,$v) = each($field['values'])) {
					echo "<option value=\"".$v[0]."\"";
					if (in_array($v[0], $field['selected'])) {
						echo " selected";
					}
					if (strlen($v[1])>70) $v[1]=substr($v[1],0,65)."...";
					echo ">".$v[1]."&nbsp;&nbsp;</option>\n";
				}
				echo "</select>\n";
				if ($field['hint'] != '') {
					echo "<br><span class=\"form_hint\">".$field['hint']."</span>\n";
				}
				echo "</td>";
				break; // ------------------------

				case 'SELECT_3COL_RIGHT_DOUBLE':
				echo "<tr>";
				echo "<td width=\"$this->width_left1\" valign=top align=right class=\"form_td_entry\">&nbsp;</td>\n";
				echo "<td width=\"$this->width_left2\" align=right valign=top class=\"form_td_label_sub\">\n";
				echo "<span class=\"form_label\">".$field['label']."</span>&nbsp;\n";
				echo $erroricon;
				echo "</td>";
				echo "<td width=\"$this->width_right\" valign=top align=left class=\"$css_field_sub\" colspan=\"2\">\n";
				echo "<select name=\"".$field['name']."\" size=\"".$field['size']."\"";
				if ($field['multi']) {
					echo " multiple";
				}
				echo ">\n";
				while (list($k,$v) = each($field['values'])) {
					echo "<option value=\"".$v[0]."\"";
					if (in_array($v[0], $field['selected'])) {
						echo " selected";
					}
					if (strlen($v[1])>70) $v[1]=substr($v[1],0,65)."...";
					echo ">".$v[1]."&nbsp;&nbsp;</option>\n";
				}
				echo "</select>\n";
				echo $field['separator'];
				echo " <select name=\"".$field['name2']."\" size=\"".$field['size']."\"";
				if ($field['multi']) {
					echo " multiple";
				}
				echo ">\n";
				while (list($k,$v) = each($field['values2'])) {
					echo "<option value=\"".$v[0]."\"";
					if (in_array($v[0], $field['selected2'])) {
						echo " selected";
					}
					if (strlen($v[1])>70) $v[1]=substr($v[1],0,65)."...";
					echo ">".$v[1]."&nbsp;&nbsp;</option>\n";
				}
				echo "</select>\n";
				if ($field['hint'] != '') {
					echo "<br><span class=\"form_hint\">".$field['hint']."</span>\n";
				}
				echo "</td>";
				break; // ------------------------


				case 'TEXT_3COL_RIGHT':
				echo "<tr>";
				echo "<td width=\"$this->width_left1\" valign=top align=right class=\"form_td_entry\">&nbsp;";
				echo "</td>\n";
				echo "<td width=\"$this->width_left2\" align=right valign=top class=\"form_td_label_sub\">\n";
				echo "<span class=\"form_label\">".$field['label']."</span>&nbsp;\n";
				echo $erroricon;
				echo "</td><td width=\"$this->width_right\" align=left valign=top class=\"$css_field_sub\" colspan=\"2\">\n";
				echo "<input type=\"text\" name=\"".$field['name']."\" ";
				echo "value=\"".ct_form_encode($field['value'])."\" size=\"".$field['size']."\" ";
				if ($field['readonly']) {
					echo "readonly class=\"disabled\" ";
				}
				echo "maxlength=\"".$field['length']."\">\n";
				if ($field['hint'] != '') {
					echo "<span class=\"form_hint\">".$field['hint']."</span>\n";
				}
				echo "</td></tr>\n";
				break; // ------------------------

				case 'TEXTAREA_3COL_RIGHT':
				echo "<tr>";
				echo "<td width=\"$this->width_left1\" valign=top align=right class=\"form_td_entry\">&nbsp;";
				echo "</td>\n";
				echo "<td width=\"$this->width_left2\" align=right valign=top class=\"form_td_label_sub\">\n";
				echo "<span class=\"form_label\">".$field['label']."</span>&nbsp;\n";
				echo $erroricon;
				echo "</td><td width=\"$this->width_right\" align=left valign=top class=\"$css_field_sub\" colspan=\"2\">\n";
				if ($field['hint'] != '') {
					echo "<span class=\"form_hint\">".$field['hint']."</span><br>\n";
				}
				echo "<textarea name=\"".$field['name']."\" cols=\"".$field['cols']."\"";
				echo "rows=\"".$field['rows']."\">\n";
				echo ct_form_encode($field['value']);
				echo "</textarea>\n</td></tr>\n";
				break; // ------------------------


				case 'UPLOAD':
				echo "<tr><td width=\"$this->width_left\" valign=top align=right class=\"$css_label\" colspan=\"2\">\n";
				echo "<span class=\"form_label\">".$field['label']."</span>&nbsp;\n";
				echo $erroricon;
				echo "</td><td width=\"$this->width_right\" align=left valign=top class=\"$css_field\" colspan=\"2\">\n";
				echo "<input type=\"hidden\" name=\"MAX_FILE_SIZE\" value=\"".$field['maxfilesize']."\">\n";
				echo "<input type=\"file\" size=\"40\" maxlength=\"".$field['maxfilesize']."\" name=\"".$field['name']."\">\n";
				if ($field['hint'] != '') {
					echo "<br><span class=\"form_hint\">".$field['hint']."</span>\n";
				}
				echo "</td></tr>\n";
				break; // ------------------------

				case 'SEPARATOR':
				echo "<tr><td colspan=\"4\" valign=top align=left class=\"form_td_separator_gradient\">\n";
				echo "<span class=\"form_separator_label\">".$field['label']."</span>\n";
				echo "</td></tr>\n";
				break; // ------------------------

				case 'SEPARATOR3':
				echo "<tr><td width=\"$this->width_left\" valign=top align=left class=\"form_td_separator\" colspan=\"2\">\n";
				echo "<span class=\"form_separator_label\">".$field['label1']."</span>\n";
				echo "</td><td width=\"$this->width_right1\"  class=\"form_td_separator\"  align=\"center\"><span class=\"form_label\">".$field['info']."</span>\n";
				echo "</td><td width=\"$this->width_right2\"  class=\"form_td_separator\"  align=\"center\"><span class=\"form_label\">".$field['label2']."</span>\n";
				echo "</td></tr>\n";
				break; // ------------------------

				case 'SUBSEPARATOR':
				echo "<tr><td valign=top align=left class=\"form_td_subseparator_left\" colspan=\"".($field['info']==null?4:2)."\">\n";
				echo "<span class=\"form_subseparator_label\">".$field['label']."</span>\n";
				echo "</td>";
				if ($field['info']!=null)
					echo "<td class=\"form_td_subseparator_right\" colspan=\"2\" align=\"center\"><span class=\"fontbold font9\">".$field['info']."&nbsp;</span></td>\n";
				echo "</tr>\n";
				break; // ------------------------

				case 'SUBSEPARATOR3':
				echo "<tr><td align=left class=\"form_td_subseparator_left\" colspan=\"2\">\n";
				echo "<span class=\"form_subseparator_label\">".$field['label1']."</span>\n";
				echo "</td><td class=\"form_td_subseparator_right\" align=\"center\"><span class=\"fontbold font9\">".$field['info']."&nbsp;</span>\n";
				echo "</td><td class=\"form_td_subseparator_right\" align=\"right\"><span class=\"form_subseparator_label\">&nbsp;".$field['label2']."</span>\n";
				echo "</td></tr>\n";
				break; // ------------------------

				case 'SPACER':
				case 'SPACER2':
				echo '<tr>';
				if ($field['type']=='SPACER')
					echo '<td colspan="4" valign=top align=left class="form_td_separator_gradient">';
				else
					echo '<td colspan="4" valign=top align=left class="form_td_subseparator_left">';
				//	echo '<td colspan="4" valign=top align=left class="mediumbg_gradient">';
				echo "<img src=\"".ct_getbaseurl()."icons/spacer.gif\" alt=\"-\" width=1 height=1>";
				echo "</td></tr>\n";
				break; // ------------------------

				case 'DATE':
				case 'DATETIME':
				case 'CHECKBOXDATETIME':
				case 'TIME':
				echo "<tr><td width=\"$this->width_left\" valign=top align=right class=\"$css_label\" colspan=\"2\">\n";
				echo "<span class=\"form_label\">".$field['label']."</span>&nbsp;\n";
				echo $erroricon;
				echo "</td><td width=\"$this->width_right\" align=left valign=top class=\"$css_field\" colspan=\"2\">\n";
				if ($field['type']=='CHECKBOXDATETIME') {
					echo "<input type=\"checkbox\" class=\"checkboxradio\" name=\"".$field['name']."_enabled\" value=\"true\"";
					if ($field['enabled']) {
						echo " checked";
					}
					echo ">\n";
					if ($field['enabled_hint'] != '') {
						echo "<span class=\"form_hint\">".$field['enabled_hint']."</span>\n";
					}
				}
				if ($field['type']!='TIME') {
					if ($field['show_day']==true){
						echo "<select name=\"".$field['name']."_day\" size=\"1\" ";
						echo " onChange=\"checkdate(this.form.".$field['name']."_day,".$field['name']."_month,".$field['name']."_year);\">\n";
						for ($i=1;$i<=31;$i++){
							echo "<option value=\"".sprintf("%02d",$i)."\"";
							if ($i==$field['selected'][2]) echo " selected";
							echo ">".$i."</option>\n";
						}
						echo "</select>";
					}
					echo "<select name=\"".$field['name']."_month\" size=\"1\" ";
					if ($field['show_day']==true)
						echo " onChange=\"checkdate(this.form.".$field['name']."_day,".$field['name']."_month,".$field['name']."_year);\" ";
					echo ">\n";
					for ($j=1;$j<=12;$j++){
						echo "<option value=\"".sprintf("%02d",$j)."\"";
						if ($j== $field['selected'][1]) echo " selected";
						echo ">".$j."</option>\n";
					}
					echo "</select>";
					echo "<select name=\"".$field['name']."_year\" size=\"1\" ";
					if ($field['show_day']==true)
						echo " onChange=\"checkdate(this.form.".$field['name']."_day,".$field['name']."_month,".$field['name']."_year);\" ";
					echo ">\n";
					for ($k=2005;$k<=2020;$k++){
						echo "<option value=\"".sprintf("%04d",$k)."\"";
						if ($k==$field['selected'][0]) echo " selected";
						echo ">".$k."</option>\n";
					}
					echo "</select>\n";
				} else
				// display time?
				if ($field['type']=="TIME") {
					echo '&nbsp;';
					echo '<img src="'.ct_getbaseurl().'icons/spacer.gif" width=145 height=10 alt="">';
					#echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
				}
				if ($field['type']!="DATE") {
					echo "&nbsp;&nbsp;&nbsp;";
					echo "<select name=\"".$field['name']."_hour\" size=\"1\">\n";
					for ($k=0;$k<=23;$k++){
						echo "<option value=\"".sprintf("%02d",$k)."\"";
						if ($k==$field['selected'][3]) echo " selected";
						echo ">".$k."</option>\n";
					}
					echo "</select><B>:</B>";
					echo "<select name=\"".$field['name']."_minute\" size=\"1\">\n";
					for ($k=0;$k<60;$k++){
						if ($k%5==0 || $k==59 || $k==$field['selected'][4]) {
							echo "<option value=\"".sprintf("%02d",$k)."\"";
							if ($k==$field['selected'][4]) echo " selected";
							echo ">".$k."</option>\n";
						}
					}
					echo "</select><B>:</B>";
					echo "<select name=\"".$field['name']."_second\" size=\"1\">\n";
					for ($k=0;$k<60;$k++){
						if ($k==0 || $k==59 || $k==$field['selected'][5]) {
							echo "<option value=\"".sprintf("%02d",$k)."\"";
							if ($field['selected'][5]==$k) echo " selected";
							echo ">".$k."</option>\n";
						}
					}
					echo "</select>";
				}
				if ($field['hint'] != '') {
					echo "<BR><span class=\"form_hint\">".$field['hint']."</span>";
				}
				echo "</td></tr>\n";
				break;

				case 'DESCRIPTION':
				echo "<tr><td width=\"$this->width_left\" class=\"form_td_label topline_white\" colspan=\"2\">&nbsp;\n";
				echo "</td><td width=\"$this->width_right\" align=left valign=top class=\"$css_field\" colspan=\"2\">\n";
				echo "<span class=\"font10\">".$field['value']."&nbsp;</span>\n";
				echo "</td></tr>\n";
				break;

				case 'SUBMIT_NOT_BOTTOM':
				echo "<tr><td width=\"$this->width_left\" class=\"topline_white form_td_label".($field['highlight']?"_yellow":"")."\" colspan=\"2\">&nbsp;\n";
				echo "</td><td width=\"$this->width_right\" align=right valign=top class=\"topline_white form_td_field".($field['highlight']?"_yellow":"")."\" colspan=\"2\">\n";
				echo "<input class=\"button\" type=\"submit\" name=\"".$field['name']."\" ";
				// Hack for Internet Explorer: Set width if much text exists, as the buttons get to wide otherwise
				if ($browser['name']=='msie' && $browser['version']>=5 && strlen($field['label'])>20) {
					$with=min(560,strlen($field['label'])*7);
					echo "style='width:".$with."px' ";
				}
				echo "value=\"".ct_form_encode($field['label'])."\">\n";
				echo "</td></tr>\n";
				break;

				case 'CROSSTABLE':
				foreach ($field['tables'] as $tkey =>$tvalue){
					echo "<tr><td width=\"15%\" valign=top align=right class=\"$css_label\">\n";
					echo"<span class=\"form_label\">".stripslashes($tvalue)."</span>&nbsp;\n";
					echo "</td><td width=\"85%\" align=left colspan=\"2\">\n";
					echo "<table><tr><td>&nbsp;</td>";

					foreach ($field['row'] as $rkey =>$rvalue){
						echo "<td align=\"center\"><span class=\"fontbold font8\">".stripslashes($rvalue)."</span></td>";
					}
					echo "</tr>";
					foreach ($field['column'] as $ckey =>$cvalue){
						echo"<tr><td align=\"right\"><span class=\"fontbold font8\">".stripslashes($cvalue)."</span></td>";
						foreach ($field['row'] as $rkey =>$rvalue){
							echo"<td align=\"center\"><input type=\"text\" name=\"".$tkey."_".$rkey."_".$ckey."\" ";
							echo"value=\"".$field['cells'][$tkey][$rkey][$ckey]."\" size=\"8\" maxlength=\"11\"></td>";
						}
						echo"</tr>";
					}
					echo "</table>";
					echo "</td></tr>\n";
				}
				break;
			}
		}

		reset($this->buttons);
		if (count($this->buttons) > 0) {
			echo "<tr><td valign=top align=right colspan=4 class=\"form_td_buttons\">\n";
			while (list(,$button) = each($this->buttons)) {
				if ( $button['type'] == 'SUBMIT_NOSCRIPTONLY' )
					echo "\n<noscript>\n";
				if ($button['type'] == 'SUBMIT' || $button['type'] == 'SUBMIT_NOSCRIPTONLY' ) {
					if ($this->demomode && !(strtolower($button['name'])=="cancel" || $button['label']==ct('S_BUTTON_CANCEL') ))
						echo "<input disabled class=\"waitbutton\" type=\"submit\" name=\"cancel\" value=\"".ct_form_encode($button['label'])." ".ct('S_BUTTON_DEMO')."\">";
					else {
						echo "<input class=\"button\" type=\"submit\" name=\"".$button['name']."\" ";
						echo "value=\"".ct_form_encode($button['label'])."\" ";
						// Hack for Internet Explorer: Set width if much text exists, as the buttons get to wide otherwise
						if ($browser['name']=='msie' && $browser['version']>=5 && strlen($button['label'])>20) {
							$with=min(560,strlen($button['label'])*7);
							echo "style='width:".$with."px' ";
						}
						if ($button['extra_attributes']!="")
							echo $button['extra_attributes']." ";
						echo ">\n";
					}
				} else if ($button['type'] == 'RESET') {
					echo "<input class=\"button\" type=\"reset\" value=\"".$button['label']."\">\n";
				}
				if ( $button['type'] == 'SUBMIT_NOSCRIPTONLY' )
					echo "\n</noscript>\n";
			}
			echo "</td></tr>\n";
		}

		echo "</table>\n";
		echo "</form>\n";
	}

}
?>
