<?php
//
// CLASS:		CTPCMessage
//			    Used for the reviewdiscussion phase where PC members can comment the papers and the reviews
//

class CTPCMessage {
	
	// holds corresponding row from pcdiscussionmessages
	var $data = array();
	
	//## DATABASE FUNCTIONS ##############################################
	
	// load message data from database by id
	function load_by_id($id) {
		global $db;
		$id = (int)$id; // sanitize.
		
		$r = $db->query("select * from pcdiscussionmessages where ID='$id'");
		if ($db->num_rows($r) == 1) {
			$this->data = $db->fetch($r);
			return true;
		} else {
			return false;
		}
	}

	// reload personidentity data from database
	function reload() {
		return $this->load_by_id($this->data['ID']);
	}
	
	// update data in database from object
	function persist() {
		global $db;
		
		if ($this->data['personID']=="" || $this->data['paperID']=="" ) { // the personID and the paperID has to be set!!!
			echo "ERROR SAVING PCMESSAGE!";
			return false;
		} else {
			$db->replace_into('pcdiscussionmessages', $this->data);
		}
		return true;
	}
	
	// delete Message
	function delete() {
		global $db;
		$this->data['deleted']="1";
		return true;
	}
	
	// undelete Identity
	function undelete() {
		global $db;
		$this->data['deleted']="0";
		return true;
	}
	
	
	//## ACCESSOR FUNCTIONS ###############################################
	
	// get a record field`s value, fieldname is key
	function get($key) {
		return isset($this->data[$key]) ? $this->data[$key] : '';
	}
	
	// get a record field`s value, with html special chars converted
	function get_special($key) {
		return ct_form_encode($this->get($key));
	}
	
	// set a record field`s value
	function set($key, $value) {
		$this->data[$key] = $value;
	}
	
	function get_id() {
		return $this->data['ID'];
	}
	
	function get_personID() {
		return $this->data['personID'];
	}
	
	function get_paperID() {
		return $this->data['paperID'];
	}
	

	//## FORM PROCESSING AND GENERATION #######################################
	
	function _require($field, $name) {
		global $http;
		
		if (isset($http[$name]) && ($http[$name] != "")) {
			$this->set($field, $http[$name]);
			return true;
		} else {
			if (isset($http[$name])) {
				$this->set($field, '');
			}
			$this->errors[] = $name;
			return false;
		}
	}
	
	// process a request that results from a form generated by CTPerson-object
	
	function process_form() {
		global $http;
		
		$this->errors = array();
		
		// $this->set('ID', $http['form_id']);
		$this->_require('personID', 'form_personID');
		$this->_require('paperID', 'form_paperID');
		$this->set('creationdate', ct_timestamp_2_datetime(ct_time()));
		$this->_require('vote', 'form_vote');
		$this->_require('subject', 'form_subject');
		$this->_require('message', 'form_message');

		return $this->errors;
	}

	
	// Creates a HTML form to create/edit message data
	function show_form($action,$errors) {
		ct_load_class('CTForm');
		ct_load_lib('datetime.lib');
		global $session;
		
		$user =& $session->get_user();
		
		$form = new CTForm($action, "post", $errors);
		$form->width = '90%';
		$form->align = 'center';
		$form->add_separator(ct('S_PC_MESSAGE_EDIT'));
		$form->add_hidden(array(array('form_paperID', $this->get_paperID()), array('form_personID', $this->get_personID())));
		$form->add_label(ct('S_PC_MESSAGE_AUTHOR'),ct_form_encode($user->get_reversename()));
		$form->add_label(ct('S_PC_MESSAGE_DATETIME'),ct_datetime_format(ct_time()));
		$form->add_select(ct('S_PC_MESSAGE_VOTE'), 'form_vote', 1, array(array("",$this->get_vote("")), array("2",$this->get_vote("2")), array("1",$this->get_vote("1")), array("0",$this->get_vote("0")), array("-1",$this->get_vote("-1")), array("-2",$this->get_vote("-2")) ), array($this->get('vote')), false);
		$form->add_text(ct('S_PC_MESSAGE_SUBJECT'), 'form_subject', $this->get('subject'), 60, 200 );
		$form->add_textarea(ct('S_PC_MESSAGE_TEXT'), 'form_message', $this->get('message'), 60, 6, '');
		
		$form->add_submit('cmd_create', ct('S_PC_MESSAGE_CREATE'));
		$form->show();
	}
	
	
	//## DISPLAY FUNCTIONS ########################################################
	
	// show row in userlist or PC-list
	function show_row($class) {
		ct_load_lib('datetime.lib');
		global $session;
		$user =& $session->get_user();
		$colors = array("-2"=>"review0","-1"=>"review3","0"=>"noreview","1"=>"review7","2"=>"review10");

		
		echo "<tr class=\"$class\" >";		
		echo "<td valign=top rowspan=\"2\" class=\"".$class."2\" >";
		$person=new CTPerson();
		$person->load_by_id($this->get('personID'));
#		if ($user->is_admin() || $user->is_assistant() ) {
#			echo "<a href=\"".ct_pageurl('editIdentity', array('form_id' => $this->get('ID')))."\">".$this->data['name'].", ".$this->data['firstname']."</a></span>";
#		}
		echo "<span class=\"fontbold font10\">".ct_form_encode($person->get_fullname())."</span>&nbsp;";
		echo "<a class=\"fontnormal font8\" href=\"mailto:".$person->get_special('email')."\">";
		echo "<img src=\"icons/e-mail.gif\" border=\"0\" title=\"".$person->get_special('email')."\"></a><br>";
		echo "<span class=\"fontbold font8\">".$person->get_special('organisation')."</span><br>";
		echo "<span class=\"fontnormal font8\">".$person->get_special('country')."</span><br>";
		if ($person->is_conferenceChair())
			echo "<span class=\"fontlabel font8\">".ct('S_USER_STATUS_CONFERENCECHAIR')."</span><br>";
		elseif ($person->is_chair() )
			echo "<span class=\"fontlabel font8\">".ct('S_USER_STATUS_CHAIR')."</span><br>";
		elseif ($person->is_admin())
			echo "<span class=\"fontlabel font8\">".ct('S_USER_STATUS_ADMIN')."</span><br>";
	    echo "</td>\n";

	    echo "<td align=left valign=top>";
	    if ($user->is_admin() || $user->is_chair() || $user->is_conferenceChair() || $this->get_personID()==$user->get_id()) {
			echo "<a href=\"".ct_pageurl('editMessagePC', array('messageID' => $this->get('ID'),'paperID' => $this->get('paperID'),'delete' => "true"))."\">";
		    echo "<img border=\"0\" align=\"right\" src=\"icons/delete.png\" title=\"".ct('S_PC_DISCUSS_RESULTS_DELETE_MESSAGE')."\">";
		    echo "</a>\n";
	    }
	    echo "<span class=\"fontlabel font8\">".ct('S_PC_MESSAGE_DATETIME').":</span> ";
	    echo "<span class=\"fontnormal font8\">".ct_datetime_format($this->get('creationdate'))."</span><br>";
	    echo "<span class=\"fontlabel font10\">".ct('S_PC_MESSAGE_SUBJECT').":</span> ";
		echo "<span class=\"fontbold font10\">".$this->get_special('subject')."</span><br>";
		echo "</td>\n";

		echo "<td align=\"center\" valign=\"middle\" class=\"".$colors[$this->get('vote')]."\">";
		echo "<span class=\"fontnormal font10\">".$this->get_vote($this->get('vote'))."</span>";
		echo "</td>\n";
		
		echo "<tr class=\"$class\" >";
		echo "<td colspan=\"2\" align=\"left\" valign=\"top\">";
		echo "<span class=\"fontnormal font9\">".ct_nl2br($this->get('message'))."</span>";
		echo "</td>\n";
	}

	// show row in userlist or PC-list
	function show_shortinfo($width="70%") {
		ct_load_lib('datetime.lib');
		global $session;
		$user =& $session->get_user();
		$colors = array("-2"=>"review0","-1"=>"review3","0"=>"noreview","1"=>"review7","2"=>"review10");

		echo "<table width=\"$width\" cellspacing=1 cellpadding=2 border=0 align=\"center\">";
		echo "<tr  class=\"mediumbg\" >";		
		echo "<td valign=top colspan=\"2\">";
		$person=new CTPerson();
		$person->load_by_id($this->get('personID'));
		echo "<span class=\"fontbold font10\">".ct_form_encode($person->get_fullname())."</span><br>";
		echo "<span class=\"fontbold font8\">".$person->get_special('organisation')."</span> ";
		echo "<span class=\"fontnormal font8\">".$person->get_special('country')."</span><br>";
		echo "</td></tr>";
		
		echo "<tr class=\"evenrow\" width=\"80%\">";		
	    echo "<td align=left valign=top>";
	    echo "<span class=\"fontlabel font8\">".ct('S_PC_MESSAGE_DATETIME').":</span> ";
	    echo "<span class=\"fontnormal font8\">".ct_datetime_format($this->get('creationdate'))."</span><br>";
	    echo "<span class=\"fontlabel font10\">".ct('S_PC_MESSAGE_SUBJECT').":</span> ";
		echo "<span class=\"fontbold font10\">".$this->get_special('subject')."</span><br>";
		echo "</td>\n";
		echo "<td align=\"center\" valign=\"middle\" width=\"20%\" class=\"".$colors[$this->get('vote')]."\">";
		echo "<span class=\"fontnormal font10\">".$this->get_vote($this->get('vote'))."</span>";
		echo "</td>\n";
		
		echo "<tr class=\"oddrow\" >";
		echo "<td colspan=\"2\" align=\"left\" valign=\"top\">";
		echo "<span class=\"fontnormal font9\">".ct_nl2br($this->get('message'))."</span>";
		echo "</td>\n";
		echo "</table>";
	}
	
	
	function show_tendency($votes) {
		echo "-";
		if ($votes<0) 
			echo "<img src=\"".ct_getbaseurl()."spacer.gif\" height=12 width=".(21+(10*$votes))."><img src=\"".ct_getbaseurl()."icons/negative_left.gif\" height=12 width=3><img src=\"".ct_getbaseurl()."icons/negative.gif\" height=12 width=".(1-10*$votes)."><img src=\"".ct_getbaseurl()."spacer.gif\" height=12 width=21>";
		elseif ($votes>0) 
			echo "<img src=\"".ct_getbaseurl()."spacer.gif\" height=12 width=21><img src=\"".ct_getbaseurl()."icons/positive.gif\"  height=12 width=".(1+10*$votes)."><img src=\"".ct_getbaseurl()."icons/positive_right.gif\" height=12 width=3><img src=\"".ct_getbaseurl()."spacer.gif\" height=12 width=".(21-(10*$votes)).">";
		else // ==0
			echo "<img src=\"".ct_getbaseurl()."spacer.gif\" height=12 width=19><img src=\"".ct_getbaseurl()."icons/middle.gif\" height=12 width=8><img src=\"".ct_getbaseurl()."spacer.gif\" height=12 width=19>";
		echo "+";
	}
	
	
	// ### Further functions ###########################################################
	
	// get messages to a certain paper ID
	function get_messages($paperID="",$order="creationdate") {
		global $db;
		// $res = $db->select("pcdiscussionmessages", "*", ($paperID!=""?"paperID='".$paperID."'":""), $order);
		$res = $db->query("select m.ID as ID, paperID, personID, m.creationdate as creationdate, vote, subject, message from pcdiscussionmessages as m left join persons as p ON p.ID=m.personID WHERE m.deleted=0 && ".($paperID!=""?"m.paperID='".$paperID."'":"")." ORDER BY ".$order);
		$num = $db->num_rows($res);
		if ($num > 0) {
			$pcmessages = array();
			for ($i = 0; $i < $num; $i++) {
				$row = $db->fetch($res);
				$pcmessages[]= $row;
			}
			return $pcmessages;
		} else {
			return array();
		}
	}
	
	// get number of messages to a certain paperID
	function count_messages($paperID="") {
		global $db;
		$res = $db->select("pcdiscussionmessages", "count(ID) as messages", ($paperID!=""?"paperID='".$paperID."' AND ":"")." deleted=0");
		if ($res and ($db->num_rows($res) > 0)) {
			$row = $db->fetch($res);
			return $row['messages'];
		} else {
			return "0";
		}
	}

	// get number of MY messages to a certain paperID
	function count_mymessages($paperID="") {
		global $db,$session;
		$user=$session->get_user();
		$res = $db->select("pcdiscussionmessages", "count(ID) as messages", ($paperID!=""?"paperID='".$paperID."'":" 1 ")." AND personID=".$user->get_id()." AND deleted=0" );
		if ($res and ($db->num_rows($res) > 0)) {
			$row = $db->fetch($res);
			return $row['messages'];
		} else {
			return "0";
		}
	}

	
	// get number of messages to a certain paperID
	function get_average_vote($paperID="") {
		global $db;
		$res = $db->select("pcdiscussionmessages", "avg(vote) as votes", ($paperID!=""?"paperID='".$paperID."' AND ":"")."deleted=0");
		if ($res and ($db->num_rows($res) > 0)) {
			$row = $db->fetch($res);
			return $row['votes'];
		} else {
			return "0";
		}
	}
	
	function get_vote($id) {
		switch ($id) {
			case "":	return ct('S_PC_MESSAGE_VOTE_NULL'); break;
			case "-2":	return ct('S_PC_MESSAGE_VOTE_N2'); break;
			case "-1":	return ct('S_PC_MESSAGE_VOTE_N1'); break;
			case "0":	return ct('S_PC_MESSAGE_VOTE_0'); break;
			case "1":	return ct('S_PC_MESSAGE_VOTE_P1'); break;
			case "2":	return ct('S_PC_MESSAGE_VOTE_P2'); break;
		}
	}
			
}

?>