<?php
//
// CLASS:       CTParticipation
//				Standard class for participants. Most functions are here apart from
//				form generation and processing.
//

class CTParticipation extends CTParticipationData {


	function CTParticipation() {
		parent::CTParticipationData();
	}

	// Extended accessors and modifiers ------------------------------

	/**
	 * returns the status-tile of a statusID.
	 */
	function _get_status($statusID){
		global $db;
		$r = $db->query("select title,title2,title3,title4 from groups where ID='$statusID'");
		if ($r && ($db->num_rows($r)) == 1){
			$g = $db->fetch($r);
			return  $g[ctlx($g,'title')];
		}
	}

	/**
	 * returns the status-regular expression of a statusID.
	 */
	function _get_status_regexpression($statusID){
		global $db;
		$r = $db->query("select regexpression from groups where ID='$statusID'");
		if ($r && ($db->num_rows($r)) == 1){
			$g = $db->fetch($r);
			return  $g['regexpression'];
		}
	}

	/**
	 * Get salutation for invoices
	 *
	 * @param id $gender id of gender
	 * @return text for salutation
	 */
	function get_invoice_form_of_address($gender=0) {
		if ($gender==0) $gender=$this->person->get['gender'];
		switch ($gender) {
			case 1:	return ct('S_INVOICE_ADDRESSES_M');
			case 2:	return ct('S_INVOICE_ADDRESSES_F');
			case 3: return ct('S_INVOICE_ADDRESSES_DR');
			case 4:	return ct('S_INVOICE_ADDRESSES_PROF');
		}
		return '';
	}


	/**
	 * Get title of invoice / participation confirmation
	 *
	 * @return string title string.
	 */
	function get_invoice_title() {
		if ($this->get('total')==0)  // No total amount: This is only a registration confirmation, no invoice!
			return ct('S_INVOICE_CONFIRMATIONONLY_TITLE');
		elseif ($this->get('total')<0)  // This is a credit note.
			return ct('S_INVOICE_CREDITNOTE_TITLE');
		elseif ($this->get('payamount')<$this->get('total') && ctconf_get('invoiceProforma','0'))  // Pro-Forma Invoice
			return ct('S_INVOICE_PROFORMA_TITLE');
		else
			return ct('S_INVOICE_TITLE');
	}



	function _check_frontdesk_status($status) {
		return (!(strpos($this->pdata['frontdesk'], $status) === false));
	}

	function is_arrived() 	{ return $this->_check_frontdesk_status("arrived"); }
	function is_confirmed() { return $this->_check_frontdesk_status("confirmed"); }
	function is_onlist() 	{ return $this->_check_frontdesk_status("onlist"); }

	/**
	 * set that invoice was just printed.
	 */
	function set_invoice_printed_now(){
		if ($this->get('invoice')!='true') {
			$this->set('invoicedate',ct_timestamp_2_datetime(ct_time()));
			$this->set('invoice','true');
		}
	}

	/**
	 * Delete credit card data
	 */
	function delete_cc_data() {
		ct_load_lib('participation.lib');
		$this->set('ccnumber',ct_mask_ccnumber($this->get('ccnumber')));
		if ($this->get('ccvc')!='')	$this->set('ccvc','XXX');
	}


	#### show invoice ################
	/**
	 * Show an complete invoice.
	 */
	function show_invoice_data($width, $align){
		ct_load_lib('payment.lib');
		ct_load_lib('participation.lib');
		ct_load_lib('datetime.lib');
		global $db,$session,$http;
		$user=$session->get_user();

		$paydate=ct_date_format($this->pdata['paydate']);
		$invoicedate=ct_date_format($this->pdata['invoicedate']);
		$regdate=ct_date_format($this->pdata['regdate']);
		$timediscountID=get_timediscountID($this->pdata['regdate']);
		$timediscountTitle=get_timediscount($timediscountID);

		$status=strip_tags(stripslashes($this->_get_status($this->pdata['status'])));

		echo "<table border=0 cellpadding=3 cellspacing=0 width=\"$width\">";

		$this->_show_print_header($width);

		echo "<tr>";
		echo "<td colspan=2 valign=\"top\" align=\"center\"><span class=\"printfunctions\">&nbsp;";
		// Show previous/next, ordered by registration date!!! (to be able to print only the new registrations!)
		if ($http['page']=='adminParticipantsInvoice' && ($user->is_admin() || $user->is_assistant() || $user->is_frontdesk())) {
			$r = $db->select("participants","personID","regdate<'".$this->get('regdate')."' && deleted=0 ","regdate desc LIMIT 1");
			if ($r && ($db->num_rows($r) > 0)) {
				$row = $db->fetch($r);
				echo "<a class=\"fontbold font14\" href=\"".ct_pageurl('adminParticipantsInvoice', array('form_userID' => $row['personID'],'print' =>'yes'))."\">";
				echo ct('S_ADMIN_NAVBAR_PREVIOUS');
				echo "</a><span class=\"fontbold font14\">&nbsp;&nbsp;&middot;&nbsp;&nbsp;</span>";
			}
			echo "<a class=\"fontbold font14\" href=\"".ct_pageurl('adminParticipantsInvoice', array('form_userID' => $this->person->get('ID'),'doprint'=>'yes','print' =>'yes'))."\">".ct('S_PARTICIPATE_PRINT')."</a>&nbsp;&nbsp;";
			$r = $db->select("participants","personID","regdate>'".$this->get('regdate')."' && deleted=0 ","regdate asc LIMIT 1");
			if ($r && ($db->num_rows($r) > 0)) {
				$row = $db->fetch($r);
				echo "&middot;&nbsp;&nbsp;";
				echo "<a class=\"fontbold font12\" href=\"".ct_pageurl('adminParticipantsInvoice', array('form_userID' => $row['personID'],'print' =>'yes'))."\">";
				echo ct('S_ADMIN_NAVBAR_NEXT');
				echo "</A>";
			} else
				echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
		} else {
			echo "<a class=\"fontbold font14\" href=\"javascript:printWindow()\">".ct('S_PARTICIPATE_PRINT')."</a>&nbsp;&nbsp;";
		}
		echo "</span></td></tr>\n";

		// Add logo...
		echo "<tr>";
		echo "<td colspan=2 valign=\"top\" align=\"right\">";
		echo "<img src='logo-invoice.gif' alt='Logo' border=0>";
		echo "</td></tr>";

		// Receiver...
		echo "<tr>";
		echo "<td valign=\"bottom\">";
		echo "<div style=\"padding: 35px;\"><span class=\"fontbold font12\">";
		$this->_show_addressee();
		echo "</span></div>";
		echo"</td>";

		// sender
		echo "<td align=right>\n";
		echo "<span class=\"normal11\"><br>".ctconf_get('invoiceSender')."<br>";
		if (ctconf_get('invoiceTaxNo')!='')
			echo "<br>".ct('S_INVOICE_TAXNO', array(ctconf_get('invoiceTaxNo')))."<br>";
		echo "</span></td>";
		echo "</tr>\n";
		echo "</table>\n\n";

		// Reference and date
		echo "<table border=0 cellpadding=6 cellspacing=0 width=\"$width\">\n";
		echo "<tr><td>";
		echo ct('S_INVOICE_REFERENCENUMBER').": ".$this->person->get('ID')."<br>";
		if ($this->get('invoiceNo')!='') // Only if it exists...
			echo "<span class=\"fontbold font10\">".ct('S_INVOICE_INVOICENUMBER').": ".$this->get_special('invoiceNo')."</span><br>\n";
		if ($this->get('reference')!='') // Only if it exists...
			echo "<span class=\"fontbold font10\">".ct('S_INVOICE_REFERENCE').": ".$this->get_special('reference')."</span><br>\n";
		echo ct('S_PARTICIPATE_REGDATE').": ".ct_datetime_format($this->pdata['regdate']).' ';
		echo '('.$timediscountTitle.")<br>\n";
		echo ct('S_PARTICIPATE_GROUPS').': '.$status;
		echo"</td><td align=right>".ctconf_get('invoiceSenderCity').", ".$regdate;
		echo "</td></tr>";
		echo "</table>\n\n";

		// Title...
		echo "<table border=0 cellpadding=6 cellspacing=0 width=\"$width\">";
		if ($this->get('total')==0)  // No total amount: This is only a registration confirmation, no invoice!
			echo "<tr><td colspan=2><h3>".ct('S_INVOICE_CONFIRMATIONONLY_TITLE')."</h3></td></tr>\n";
		elseif ($this->get('total')<0)  // This is a credit note.
			echo "<tr><td colspan=2><h3>".ct('S_INVOICE_CREDITNOTE_TITLE')."</h3></td></tr>\n";
		elseif ($this->get('payamount')<$this->get('total') && ctconf_get('invoiceProforma','0'))  // Pro-Forma Invoice
			echo "<tr><td colspan=2><h3>".ct('S_INVOICE_PROFORMA_TITLE')."</h3></td></tr>\n";
		else
			echo "<tr><td colspan=2><h3>".ct('S_INVOICE_TITLE')."</h3></td></tr>\n";

		echo "<tr><td colspan=2>";
		echo $this->get_invoice_form_of_address($this->person->get('gender'));
		echo " ".$this->person->get_special('firstname')." ".$this->person->get_special('name').",</td></tr>\n";
		echo "<tr><td colspan=2><span class='fontnormal'>".ct('S_INVOICE_TEXT1').' ';
		echo "<strong> ".strip_tags(ctconf_get('conferenceName'))." </strong> ";
		echo ct('S_INVOICE_TEXT2')."</span></td></tr>\n\n";

		echo "<tr><td colspan=2>";
		$this->show_participant_costs($width, "center", "invoice_table", "invoice_head_tr", "invoice_tr", "invoice_td");
		echo "</td></tr>\n\n";

		if ($this->get('total')>$this->get('payamount')) {
			if (strlen(ct('S_INVOICE_PAYMENT_TERMS'))>1)
				echo "<tr><td colspan=2><span class='fontnormal'>".ct('S_INVOICE_PAYMENT_TERMS')."</span></td></tr>\n";
			echo "<tr><td colspan=2>";
			ct_show_paymethod_details($this);
			echo "</td></tr>\n";
		} elseif ($this->get('total')==$this->get('payamount')) {
			echo "<tr><td colspan=2><span class='fontnormal'>".ct('S_PARTICIPATE_FULLY_PAID')."</span></td></tr>\n";
		}

		echo "<tr><td colspan=2>".ct('S_INVOICE_TEXT3')."<br><strong>".ctconf_get('conferenceOrganizer')."</strong><br>(".ct('S_RECEIPT_LOCAL_ORGANIZER').")</td></tr>\n";

		$this->_show_print_footer($width);
		echo "</table>";
	}

	/**
	 * #### show statement for fax ################
	 */
	function show_statement($width, $align){
		global $db,$session,$http;
		$user=$session->get_user();

		ct_load_lib('participation.lib');
		ct_load_lib('datetime.lib');

		$paydate=ct_date_format($this->pdata['paydate']);
		$invoicedate=ct_date_format($this->pdata['invoicedate']);
		$regdate=ct_date_format($this->pdata['regdate']);
		$timediscountID=get_timediscountID($this->pdata['regdate']);
		$timediscountTitle=get_timediscount($timediscountID);

		$status=strip_tags(stripslashes($this->_get_status($this->pdata['status'])));

		echo "<table width=$width border=0 cellpadding=6 cellspacing=0>";
		$this->_show_print_header();
		echo "<tr>";
		echo "<td colspan=2 valign=\"top\" align=\"center\" class=\"yellowbg\"><div class=\"printfunctions\">&nbsp;";
		echo "<a class=\"fontbold font14\" href=\"".ct_pageurl($http['page'], ct_http_array(array('doprint'=>'yes')))."\">".ct('S_PARTICIPATE_PRINT')."</a>";
		echo "<span class=\"fontbold font14\"></span>";
		// Show "continue"-Link...
		if (isset($http['continue'])) {
			if (in_http('nextpage','submissions'))
				$nextpage="submissions";
			else
				$nextpage="index";

			echo "&nbsp;&nbsp;&middot;&nbsp;&nbsp;<a class=\"fontbold font14\" href=\"";
			if (ctconf_get('participation/identities')) {
				echo ct_pageurl('editIdentity',array('nextpage'=>$nextpage));	// Enter Identity Data!
			} else {
				echo ct_pageurl($nextpage);			// Registration finished.
			}
			echo "\">";
			echo ct('S_PARTICIPATE_CONTINUE');
			echo "</A>";
		}
		echo "<BR>\n";

		echo "<span class=\"fontnormal font10\">".ct('S_STATEMENT_TODO')."</span><br>";

		echo "<span class=\"fontbold font10\">".ct('S_INVOICE_PAYMENT_FAX_NO',array(ctconf_get('faxNoNational')))."</span><br>\n";
		if (ctconf_get('faxNoInternational')!='')
			echo "<span class=\"fontbold font10\">".ct('S_INVOICE_PAYMENT_FAX_NO_INT',array(ctconf_get('faxNoInternational')))."</span>\n";
		echo "</div>";
		echo "</td></tr>\n";
		echo "</table>";

		// logo
		echo "<img src='logo-statement.gif' border=0><br>";

		// Addresses
		echo "<table width=$width border=0 cellpadding=6 cellspacing=0>";
		echo "<tr>";
		// organizer
		echo '<td width="48%" class="statementtitle" align=left valign="top">';
		echo '<div class="fontbold font12">'.ct('S_PARTICIPATION_ORGANIZER').'</div>';
		echo "</td>\n";
		echo '<td width="4%">&nbsp;</td>';
		echo '<td width="48%" class="statementtitle" align="left" valign="top">';
		echo '<div class="fontbold font12">'.ct('S_PARTICIPATION_PARTICIPANT').'</div>';
		echo "</td></tr>\n";

		echo '<tr><td width="48%" class="statementcell" align=left valign="top">';
		echo "<div class=\"fontnormal font10\">";
		echo ctconf_get('faxReceiver');
		echo "</div>\n";
		echo "<div class=\"fontbold font10\">".ct('S_INVOICE_PAYMENT_FAX_NO',array(ctconf_get('faxNoNational')))."</div>\n";
		if (ctconf_get('faxNoInternational')!='')
			echo "<div class=\"fontbold font10\">".ct('S_INVOICE_PAYMENT_FAX_NO_INT',array(ctconf_get('faxNoInternational')))."</div>\n";
		echo "</td>\n";

		echo '<td width="4%">&nbsp;</td>';

		// Addressee
		echo '<td width="48%" class="statementcell" align="left" valign="top">';
		echo '<div class="fontbold font12">'.ct('S_INVOICE_REFERENCENUMBER').": ".$this->get('personID')."</div><br>";
		echo "<div class=\"fontbold font10\">";
		$this->_show_addressee();
		echo "</div>";
		echo "</td>";
		echo "</tr>\n";
		echo "</table>\n";
		echo "<br>\n\n";

		// Subject
		echo "<table class=\"statementcell\" width=$width border=0 cellpadding=1 cellspacing=0>";
		echo "<tr><td class=\"statementtitle\" colspan=2><span class=\"fontbold font12\">".ct('S_STATEMENT_TITLE')." '".ctconf_get('conferenceName')."'</span></td></tr>";

		echo "<tr><td align=left width=\"60%\">";
		echo ct('S_PARTICIPATE_REGDATE').": ".ct_datetime_format($this->pdata['regdate']).' ';
		echo '('.$timediscountTitle.")</td>";
		echo '<td align=left>'.ct('S_PARTICIPATE_GROUPS').': '.$status;
		echo "</td></tr>\n";
		echo "</table>\n";
		// greeting
		echo "<table class=\"statementcell\" width=$width border=0 cellpadding=0 cellspacing=0>";
		echo "<tr><td>";
		echo $this->get_invoice_form_of_address($this->person->get('gender'));
		echo " ".$this->person->get_special('firstname')." ".$this->person->get_special('name').", ";
		echo ct('S_STATEMENT_CONFIRMATION', array(ctconf_get('conferenceName')))."</td></tr>\n";
		echo "</table>\n\n";

		#echo "<tr><td>";
		$this->show_participant_costs($width-2, "left", "invoice_table", "invoice_head_tr", "invoice_tr", "invoice_td");
		#echo "</td></tr>";
		echo "&nbsp;<br clear=all>";

		ct_vspacer();

		# show remark
		if ($this->get('externalremark')!="") {
			echo "<table width=$width border=0 cellpadding=5 cellspacing=0>";
			echo '<tr><td class="statementtitle" align=left valign=top><span class="fontbold font12">'.ct('S_PARTICIPATE_EXTERNALREMARK')."</span></td></tr>\n";
			echo '<tr><td class="statementcell">';
			echo '<span class="fontnormal font10">'.$this->get_special('externalremark').'</span>';
			echo "</td></tr>\n";
			echo "</table>\n";
			ct_vspacer();
		}

		$this->_show_cc_printform($width);

		ct_vspacer();

		$this->_show_debit_agreement($width);

		#ct_vspacer();
		#echo "<table width=$width border=0 cellpadding=5 cellspacing=0>";
		#echo '<tr><td class="statementtitle" align=left valign=top><span class="fontbold font12">'."Registration Confirmation by Conference Chair (Please leave empty!)</span></td></tr>\n";
		#echo "<tr><td class=\"statementcell\"><span class=\"fontnormal font12\"><br>".ct('S_RECEIPT_SIGNSPACE')."<br><br></span></td></tr>\n";
		#echo "</table>\n";

		$this->_show_print_footer();
	}

	/**
	 * Invoice Header for printout
	 */
	function _show_print_header($width='640') {
		if (ctconf_get('invoiceHeader')!="") {
			echo "<thead style=\"display: table-header-group;\" >\n";
			echo "<tr>\n";
			echo "<td colspan=2 width=\"$width\" align=\"center\">".ctconf_get('invoiceHeader')."</td>\n";
			echo "</tr>\n";
			echo "</thead>\n";
		}
	}

	/**
	 * Invoice footer for printout
	 */
	function _show_print_footer($width='640') {
		if (ctconf_get('invoiceFooter')!="") {
			echo "<tfoot style=\"display: table-footer-group;\">\n";
			echo "<tr>\n";
			echo "<td colspan=2 width=\"$width\" align=\"center\">".ctconf_get('invoiceFooter')."</td>\n";
			echo "</tr>\n";
			echo "</tfoot>\n";
		}
	}

	/**
	 * Output Addresse
	 */
	function _show_addressee() {
		ct_load_lib("address.lib");
		if ($this->get('billingaddress')=='true') {  // Use billing address entered for participant...
			if (strlen($this->get('organisation'))>1)
				echo $this->get_special('organisation')."<br>";
			echo $this->person->get_title($this->get('gender'))." ".$this->get_special('firstname')." ".$this->get_special('name')."<br>";
			echo $this->get_special('addr1')."<br>";
			if ($this->get('addr2')!="")
				echo $this->get_special('addr2')."<br>";
			echo ct_address_format($this->get_special('country'),$this->get_special('zip'),$this->get_special('state'),$this->get_special('city'));
			echo ct_get_country($this->get_special('country'))."\n";
		} else { // use person data for billing address
			echo $this->person->get_special('organisation')."<br>";
			echo $this->person->get_title($this->person->get('gender'))." ".$this->person->get_special('firstname')." ".$this->person->get_special('name')."<br>";
			echo $this->person->get_special('addr1')."<br>";
			if ($this->person->get('addr2')!="")
				echo $this->person->get_special('addr2')."<br>";
			echo ct_address_format($this->person->get_special('country'),$this->person->get_special('zip'),$this->person->get_special('state'),$this->person->get_special('city'));
			echo ct_get_country($this->person->get_special('country'))."\n";
		}
	}

	/**
	 * Show printout for credit card data
	 *
	 * @param number $width width of form
	 */
	function _show_cc_printform($width=600) {
		echo "\n<table width=$width border=0 cellpadding=5 cellspacing=0>";
		echo "<tr>";
		echo "<td class=\"statementtitle\" colspan=\"3\" align=left valign=top><span class=\"fontbold font12\">".ct('S_PARTICIPATE_PAYMENT_INTRO')."</span></td></tr>";

		echo "<tr><td class=\"statementcell\" width=\"55%\">";
		echo "<span class=\"fontlabel font10\">".ct('S_PARTICIPATE_CCTYPE').":</span><br>\n<span class=\"font10\">";

		$cctypes_array = ct_csv_explode(ctconf_get('paymentCreditCardTypes'));
		foreach ($cctypes_array as $c)
			echo "<img src=\"icons/manualcheckbox.gif\" align=\"top\">&nbsp;".$c."<BR>";
		echo "</span></td>";

		echo "<td class=\"statementcell\" colspan=\"2\" >";
		echo "<span class=\"fontlabel font10\">".ct('S_PARTICIPATE_CCHOLDER').":</span><br>";
		echo "<img src=\"icons/namebox.gif\"></td>";
		echo "</tr>\n";

		echo "<tr>";
		echo "<td class=\"statementcell\" width=\"55%\" valign=\"top\">";
		echo "<span class=\"fontlabel font10\">".ct('S_PARTICIPATE_CCNUMBER').":</span><br>";
		$this->_show_form_boxes(4); echo "&nbsp;\n";
		$this->_show_form_boxes(4); echo "&nbsp;\n";
		$this->_show_form_boxes(4); echo "&nbsp;\n";
		$this->_show_form_boxes(4);
		echo "</td>\n";

		echo "<td class=\"statementcell\" width=\"25%\" valign=\"top\">";
		if (ctconf_get('paymentCreditCardUseIssueNo',1)) {	// enter Valid From and Issue Number?
			$this->_show_form_validfrom();
		} else {
			$this->_show_form_cvcbox();
		}
		echo "</td>\n";

		echo "<td class=\"statementcell\" width=\"20%\" valign=\"top\">";
		echo "<span class=\"fontlabel font10\">".ct('S_PARTICIPATE_CCEXPDATE').":</span><br>";
		$this->_show_form_boxes(2);
		echo "<img src=\"icons/slash.gif\">";
		$this->_show_form_boxes(2);
		echo "</td>\n";

		echo "</tr>\n";

		if (ctconf_get('paymentCreditCardUseIssueNo',1)) {	// enter Valod From and Issue Number?
			echo "<tr>";
			echo "<td class=\"statementcell\" width=\"55%\" valign=\"top\">";
			echo "<span class=\"font10\">* ".ct('S_PARTICIPATE_CCISSUE_HINT')."</span>";
			echo "</td>\n";

			echo "<td class=\"statementcell\" width=\"25%\" valign=\"top\">";
			$this->_show_form_cvcbox();
			echo "</td>\n";

			echo "<td class=\"statementcell\" width=\"20%\" valign=\"top\">";
			echo "<span class=\"fontlabel font10\">".ct('S_PARTICIPATE_CCISSUENO')."*: </span><br>";
			$this->_show_form_boxes(2);
	    	#echo '<img src="icons/numberboxdotted.gif">';
			echo "</tr>\n";
		}

		echo "</table>\n\n";
	}

	function _show_form_validfrom() {
			echo "<span class=\"fontlabel font10\">".ct('S_PARTICIPATE_CCISSUEDATE')."*: </span><br>";
			$this->_show_form_boxes(2);
			echo "<img src=\"icons/slash.gif\">";
			$this->_show_form_boxes(2);
			echo "</td>\n";
	}

	function _show_form_cvcbox() {
		if (ctconf_get('paymentCreditCardUseCVC',1)) {	// enter CVC?
			echo "<a href=\"".ct_pageurl('ccvc')."\" target=\"_blank\" class=\"fontlabel font10\">".ct('S_PARTICIPATE_CCVC').":</a><br>";
			$this->_show_form_boxes(3);
	    	echo '<img src="icons/numberboxdotted.gif">';
			echo "&nbsp;\n";
			echo "<a href=\"".ct_pageurl('ccvc')."\" target=\"_blank\"><img src=\"icons/help.png\" border=\"0\"></a>";
		} else {
			echo "&nbsp;\n";
		}
	}

	function _show_form_boxes($cnt=1) {
		for ($i=0; $i<$cnt; $i++)
	    	echo '<img src="icons/numberbox.gif" width=20 height=26>';
	}

	/**
	 * Output of debit agreement box
	 *
	 * @param int $width with of box
	 * @param number $total total of statement
	 */
	function _show_debit_agreement($width=600,$total=0){
		echo "<table width=$width border=0 cellpadding=5 cellspacing=0>";
		echo '<tr><td class="statementtitle" align=left valign=top><span class="fontbold font12">'.ct('S_PARTICIPATE_DEBITAGREEMENT')."</span></td></tr>\n";

		echo '<tr><td class="statementcell">';
		echo '<span class="fontnormal font10">'.ct('S_PARTICIPATE_I_AGREE', array(ctconf_get('conferenceShortName'),$this->get('total').' '.ctconf_get('currencyCode'))).'</span>';
		echo "</td></tr>\n";
		echo "<tr><td class=\"statementcell\"><span class=\"fontnormal font12\"><br>".ct('S_RECEIPT_SIGNSPACE')."<br><br></span></td></tr>\n";
		echo "</table>\n";
	}

	/**
	 * Show receipt
	 */
	function show_receipt_data($width, $align){
		ct_load_lib('participation.lib');
		ct_load_lib('payment.lib');
		ct_load_lib('datetime.lib');
		global $db,$session;
		$user=$session->get_user();

		$this->_calculate_fee();	// Show receipt data

		$today=ct_date_format(ct_time());

		$regdate=ct_date_format($this->pdata['regdate']);
		$timediscountID=get_timediscountID($this->pdata['regdate']);
		$timediscountTitle=get_timediscount($timediscountID);

		$status=strip_tags(stripslashes($this->_get_status($this->pdata['status'])));

		echo "<table border=0 cellpadding=6 cellspacing=0 width='$width'>";

		echo "<tr>";
		echo "<td colspan=2 valign=\"top\" align=\"center\"><span class=\"printfunctions\">&nbsp;";
		if ($user->is_admin() || $user->is_assistant() || $user->is_frontdesk()) {
			// Prev and next by registration date...
			$r = $db->select("participants","personID","regdate<'".$this->get('regdate')."' && deleted=0 ","regdate desc LIMIT 1");
			if ($r && ($db->num_rows($r) > 0)) {
				$row = $db->fetch($r);
				// echo $row['personID']."-".$row['invoiceNo']."<br>";
				echo "<a class=\"fontbold font12\" href=\"".ct_pageurl('adminParticipantsReceipt', array('form_userID' => $row['personID'],'print' =>'yes'))."\">";
				echo ct('S_ADMIN_NAVBAR_PREVIOUS');
				echo "</A>&nbsp;&nbsp;&middot;&nbsp;&nbsp;";
			}
			echo "<a class=\"fontbold font14\" href=\"".ct_pageurl('adminParticipantsReceipt', array('form_userID' => $this->person->get('ID'),'doprint'=>'yes','print' =>'yes'))."\">".ct('S_PARTICIPATE_PRINT')."</a>&nbsp;&nbsp;";
			$r = $db->select("participants","personID","regdate>'".$this->get('regdate')."' && deleted=0 ","regdate asc LIMIT 1");
			if ($r && ($db->num_rows($r) > 0)) {
				$row = $db->fetch($r);
				echo "&middot;&nbsp;&nbsp;";
				echo "<a class=\"fontbold font12\" href=\"".ct_pageurl('adminParticipantsReceipt', array('form_userID' => $row['personID'],'print' =>'yes'))."\">";
				echo ct('S_ADMIN_NAVBAR_NEXT');
				echo "</A>";
			} else
				echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
		}
		echo "</span></td></tr>\n";

		echo "<tr><td colspan=2 valign=\"top\" align=\"right\">";
		echo "<img src='logo-invoice.gif' border=0>\n";
		echo "</td></tr>\n";

		echo "<tr><td><span class=\"fontnormal font12\">";
		$this->_show_addressee();
		echo "</span>\n";
		echo"</td><td align=right>".ctconf_get('invoiceSender')."<br><br>".ctconf_get('conferenceCity').", ".$today."</td></tr>\n";

		echo "<tr><td colspan=2>".ct('S_RECEIPT_REFERENCENUMBER').": ".$this->person->get('ID')."<br>\n";
		echo ct('S_PARTICIPATE_REGDATE').": ".ct_datetime_format($this->pdata['regdate']).' ';
		echo '('.$timediscountTitle.") <br>\n";
		echo ct('S_PARTICIPATE_GROUPS').': '.$status;
		// echo $this->pdata['status'];
		if ($this->get('memberID')!='')
			echo " (".$this->get('memberID').")";
		echo "<br><br>\n";
		echo "</td></tr>\n";

		echo "<tr><td colspan=2><h3>".ct('S_RECEIPT_TITLE')." ".ctconf_get('conferenceName')."</h3></td></tr>";
		echo "<tr><td colspan=2>";
		echo $this->get_invoice_form_of_address($this->person->get('gender'));
		echo " ".$this->person->get('firstname')." ".$this->person->get('name').",";
		echo "</td>\n<td>";

		echo "<tr><td colspan=2>";

		if ($this->pdata['payamount'] < $this->pdata['total']) {
			echo "<table border=1 cellspacing=0 cellpadding=4 class=\"invoice_table\"><tr>\n";
			echo "<td valign=top><span class=\"fontbold font12\">O</span></td>\n<td>";
		}

		echo "<p><span class=\"fontnormal font10\">".ct('S_INDEX_YOUAREPARTICIPANT')." ";
		echo ct('S_PARTICIPATE_TOTALFEE').": ".ct_currency_format($this->pdata['total'])."</span><br>\n";
		echo "<span class=\"fontlabel font10\">".ct('S_PARTICIPATE_PAYMENT_SELECTEDMETHOD').":</span> <span class=\"fontnormal font10\">";
		echo ct_get_payment_description($this->pdata['paymethod']);
		echo "</span></p>\n";

		if ($this->pdata['total']>0 || $this->pdata['payamount']!=0){
			ct_show_payment_info($this);
		}

		if ($this->pdata['payamount'] < $this->pdata['total']) {
			echo "</tr>\n<tr><td valign=top><span class=\"fontbold font12\">O</span></td>\n<td>";
			echo ct('S_RECEIPT_TEXT1');
			echo " ".ct_currency_format($this->fee['total']);
			echo ct('S_RECEIPT_TEXT2');
			echo "</td></tr></table>";
		}

		echo "</td>\n</tr>\n";

		echo "<tr><td colspan=2><br>".ct('S_RECEIPT_TEXT3')."<br><br><br></td></tr>";

		echo "<tr><td colspan=2><hr noshade></td></tr>";

		echo "<tr><td colspan=2><H3>".ct('S_RECEIPT_TEXT4')."</H3>";
		echo ct('S_RECEIPT_TEXT5')." ".ctconf_get('conferenceName')."<br><br>";
		echo ct('S_RECEIPT_TEXT6')."<br><br></td></tr>";

		echo "<tr><td colspan=2>".ctconf_get('conferenceCity').", ".ct('S_RECEIPT_SIGNSPACE')."<br><br><br></td></tr>";

		echo "</table>";
	}

	/**
	 * shows a row of participant data. Usually called from adlin.lib
	 */
	function show_row($class,$i,$event=0,$page="",$datemode="false", $pricecategory=0, $texthint="") {
		ct_load_lib('participation.lib');
		ct_load_lib('payment.lib');
		ct_load_lib('datetime.lib');
		global $db,$session;

		// Is an event selected? => Add extra row!
		$eventrowspan = "";
		// if ($event!=0) $eventrowspan = " rowspan=2 ";
		$eventrowspan = " rowspan=2 ";

		if ($this->pdata['deleted'] != '0' || $this->pdata['deleted'] != '0') {
			$class = $class."_del";
		}
		echo "<tr class=\"$class\" ";
		if (0) { // $event==0) {
			echo "onmouseover=\"ct_row( this, 'on', '$class', '".$class."_highlight');\" ";
			echo "onmouseout=\"ct_row( this, 'off', '$class', '".$class."_highlight');\">\n";
		} else {
			echo ">\n";
		}

		echo "<td $eventrowspan align=center valign=middle><span class=\"fontnormal font9\">".($i+1)."</span></td>\n";

		// ID
		if ($this->is_arrived()) // if participant has arrived, show id in green
			echo "<td align=center valign=middle class=\"positivebg\"><span class=\"fontlight fontbold font9\">".$this->person->get_id()."</span></td>\n";
		else
			echo "<td align=center valign=middle><span class=\"fontbold font9\">".$this->person->get_id()."</span></td>\n";

		// Name
		echo "<td align=left valign=top><span class=\"fontbold font9\">";
		echo "<a href=\"".ct_pageurl('adminParticipantsDetails')."&amp;form_id=".$this->person->get_id()."\">";
		echo ct_form_encode($this->person->get_reversename())."</a></span>";
		if ($this->get('externalremark') != "" || $this->get('internalremark') != "") {
        	echo ' <a class="fontlabel" href="'.ct_pageurl('adminParticipantsDetails', array('form_id'=>$this->person->get_id())).'" ';
        	echo 'title="'.ct('S_PARTICIPATE_DETAILED_REMARKSECTION').'" ';
			if (strlen($this->get('externalremark'))>1) {
				echo 'ext_title="'.ct('S_PARTICIPATE_EXTERNALREMARK').'" ' ;
				echo 'ext_remark="'.substr($this->get_special('externalremark'),0,512).'" ' ;
			}
			if (strlen($this->get('internalremark'))>1) {
				echo 'int_title="'.ct('S_PARTICIPATE_INTERNALREMARK').'" ' ;
				echo 'int_remark="'.substr($this->get_special('internalremark'),0,512).'" ' ;
			}
	       	echo '>';
        	echo '<img src="icons/remark.png" border="0" alt="">'; // alt="Remark" // annoying tooltip in IE!
        	echo '</a>';
		}
		echo "<br>";
		echo "<span class=\"fontnormal font8\"><a href=\"mailto:".$this->person->get_special('email')."\">";
		echo $this->person->get_special('email')."</a></span>";
		echo "</td>\n";

		echo "<td align=left valign=top>";
		echo "<span class=\"fontnormal font9\">".$this->person->get_special('organisation')."</span><br>";
		ct_load_lib("address.lib");
		echo "<span class=\"fontnormal font8\">";
		if (strlen($this->person->get('country'))==2) echo $this->person->get_special('country').", ";
		echo ct_get_country($this->person->get_special('country'))."</span>";
		echo "</td>\n";

		$regdate = ct_date_format($this->pdata['regdate']);
		echo "<td align=\"center\" valign=top><span class=\"";
		if ($this->pdata['paymethod']=="cash")
			echo "fontnegative fontbold font8";
		elseif ($this->pdata['paymethod']=="free")
			echo "fontpositive fontbold font8";
		else
			echo "fontnormal font8";
		echo "\">". ct_get_payment_description_short($this->pdata['paymethod'])."</span><br>";
		echo "<span class=\"fontnormal font8\">".$regdate."</span>";
		echo "</td>\n";

		// Total and invoice date
		$total      = ct_number_format($this->pdata['total']);
		echo "<td align=right valign=top><span class=\"fontnormal font9\">".$total."</span><br>";

		echo "<a target=\"_blank\" class=\"fontnormal font8\" href=\"".ct_pageurl('adminParticipantsInvoice', array('form_userID' => $this->person->get_id(),'print' =>'yes'))."\">";

		if ($this->pdata['invoicedate']==0)
			echo ct('S_ADMIN_PARTICIPANTS_ACTION_INVOICE');
		else
			echo ct_date_format($this->pdata['invoicedate']);
		echo "</a>";
		echo "</td>\n";

		// ---------------------
		echo "<td align=right valign=top><span class=\"";
		$payamount  = ct_number_format($this->pdata['payamount']);
		if ($this->pdata['payamount']==0 && $this->pdata['total']>0)
			echo "fontnegative font9";
		elseif ($this->pdata['payamount']==$this->pdata['total'] && $this->pdata['total']>0)
			echo "fontpositive font9";
		elseif ($this->pdata['payamount']!=$this->pdata['total'] && ($this->pdata['total']>0 || $this->pdata['payamount']>0))
			echo "fontnegative fontbold font9";
		else
			echo "fontnormal font9";
		echo "\">".$payamount."</span><br>";

		echo "<a target=\"_blank\" class=\"fontnormal font8\" href=\"".ct_pageurl('adminParticipantsReceipt', array('form_userID' => $this->person->get_id(),'print' =>'yes'))."\">";
		if ($this->pdata['paydate']==0)
			echo ct('S_ADMIN_PARTICIPANTS_ACTION_RECEIPT');
		else
			echo ct_date_format($this->pdata['paydate']);
		echo "</a>";
		echo "</td>\n";

		// RIGHT ROW: Action!
		// echo "<td align=right valign=top $eventrowspan><span class=\"fontnormal font9\">";
		echo "<td $eventrowspan align=right valign=top>";
		$user =& $session->get_user();
		if ($page=="frontdesk") {
			echo "<a class=\"fontbold font9\" href=\"".ct_pageurl('frontdeskStatus', array('form_userID' => $this->person->get_id()))."\">";
			if (!$this->is_arrived()) {
				echo ct('S_ADMIN_PARTICIPANTS_ACTION_ARRIVAL')."</a><br>";
			} else {
				echo ct('S_ADMIN_PARTICIPANTS_ACTION_ISARRIVED')."</a><br>";
			}
		}

		if ($user->is_admin() || $user->is_assistant()) {
			if ($this->pdata['deleted'] == '0' || $this->pdata['payamount']!=0)
				echo "<a class=\"fontbold font8\" href=\"".ct_pageurl('adminParticipantsPayments', array('form_personID' => $this->pdata['personID'] ))."\">".ct('S_ADMIN_PARTICIPANTS_ACTION_PAYMENTS')."</a><br>";
				// echo "<a target=\"_blank\" href=\"".ct_pageurl('adminParticipantsPayments', array('form_personID' => $this->pdata['personID'] ))."\"><img src=\"icons/newwindow.gif\" border=0></a><br>";
			if ($this->pdata['deleted'] == '0') {
				echo "<a class=\"fontnormal font8\" href=\"".ct_pageurl('adminParticipantsEditDelete', array('form_personID' => $this->person->get_id()))."\">".ct('S_ADMIN_PARTICIPANTS_ACTION_EDIT')."</a><BR> ";
				#if ($this->pdata['payamount']==0)
					echo "<a class=\"fontnormal font8\" href=\"".ct_pageurl('adminParticipantsEditDelete', array('form_delete_ID' => $this->person->get_id()))."\">".ct('S_ADMIN_PARTICIPANTS_ACTION_DELETE')."</a>";
			} else {
				echo "<a class=\"fontnormal font8\" href=\"".ct_pageurl('adminParticipantsEditDelete', array('form_personID' => $this->person->get_id()))."\">".ct('S_ADMIN_PARTICIPANTS_ACTION_REGISTER')."</a><br> ";
			}
		}
		echo "</td>\n";
		echo "</tr>\n";

		// One event was selected! Show extra row...
		if ($event==0) {

			echo "<tr class=\"$class\" >\n";

			echo "<td colspan=2><span class=\"font8\">";
			if ($page=="frontdesk") {
				if ($this->is_arrived()) { echo ct('S_USER_FRONTDESK_ARRIVED'); }
				if ($this->is_arrived() && $this->is_confirmed()) { echo '<br>'; }
				if ($this->is_confirmed()) { echo ct('S_USER_FRONTDESK_CONFIRMED'); }
			}
			echo "&nbsp;</span></td>\n";

			// Rg-No.
			echo "<td>";
			echo "<span class=\"fontlabel font8\">".ct('S_INVOICE_INVOICENUMBER').": </span>";
			echo "<span class=\"fontnormal font8\">".$this->pdata['invoiceNo']."</span>";
			echo "</td>\n";

			// Timediscount
			$timediscountID=get_timediscountID($this->pdata['regdate']);
			$timediscountTitle=get_timediscount($timediscountID);
			echo "<td colspan=3 align=center>";
			// echo "<span class=\"fontlabel font8\">".ct('S_PARTICIPATE_TIMEDISCOUNT').": </span>";
			echo "<span class=\"fontnormal font8\">".$timediscountTitle."&nbsp;</span>";
			echo "</td>\n";

			// echo "<td><span class=\"fontnormal font8\">&nbsp;</span></td>\n";
			echo "</tr>";

		} else {
			echo "<tr class=\"$class\" >\n";


			// Show user text to this event
			if ($datemode!="false")
				echo "<td colspan=2>";
			else
				echo "<td colspan=3>";

			$text = ct_nl2br($this->eventdata_text[$event]);
			if (!empty($text)){
				echo "<span class=\"fontlabel font8\">".$texthint.": </span>";
				echo "<span class=\"fontbold font8\">".$text."</span>";
			} else {
				echo "<span class=\"fontnormal font8\">&nbsp;</span>";
			}

			echo "</td>\n";

			// Show datemode if != false (othewise use col in line above...
			if ($datemode!="false") {
				$start = $this->eventdata_start[$event];
				$end   = $this->eventdata_end[$event];
				echo "<td>";
				if ($datemode=="selectday") {
					echo "<span class=\"fontlabel font8\">".ct('S_PARTICIPATE_DATE').": </span><span class=\"fontbold font8\">";
					echo ct_date_format(ct_timestamp_2_datetime($start));
					echo "</span>";
				}
				if ($datemode=="perdiem" || $datemode=="pernight" || $datemode=="selectspan") {
					echo "<span class=\"fontlabel font8\">".ct('S_PARTICIPATE_DATES').": </span>";
					echo "<span class=\"fontbold font8\">";
					echo ct_date_format(ct_timestamp_2_datetime($start));
					echo " - ".ct_date_format(ct_timestamp_2_datetime($end));
					echo "</span>";
				}
				echo "</td>\n";
			}

			// Qty
			echo "<td align=center>";
			echo "<span class=\"fontnormal font8\">".ct('S_PARTICIPATE_EVENTNUMBER').": </span>";
			echo "<span class=\"fontbold font8\">".$this->eventdata_number[$event]."&nbsp;</span>";
			echo "</td>\n";

			// Nights etc.
			echo "<td align=right>";
			$stay_factor = 1;
			if ($datemode=="perdiem")  $stay_factor = ct_count_days($start,$end);
			if ($datemode=="pernight") $stay_factor = ct_count_nights($start,$end);

			if ($datemode=="pernight") {
			if ($stay_factor==1)
				echo "<span class=\"fontbold font8\">".$stay_factor."&nbsp;</span><span class=\"fontnormal font8\">".ct(S_PARTICIPATE_NIGHT)."</span>";
			else
				echo "<span class=\"fontbold font8\">".$stay_factor."&nbsp;</span><span class=\"fontnormal font8\">".ct(S_PARTICIPATE_NIGHTS)."</span>";
			}
			if ($datemode=="perdiem") {
				if ($stay_factor==1)
					echo "<span class=\"fontbold font8\">".$stay_factor."&nbsp;</span><span class=\"fontnormal font8\">".ct(S_PARTICIPATE_DAY)."</span>";
				else
					echo "<span class=\"fontbold font8\">".$stay_factor."&nbsp;</span><span class=\"fontnormal font8\">".ct(S_PARTICIPATE_DAYS)."</span>";
			}
			echo "</td>\n";

			// Sum...
			echo "<td align=right>";
			if ($pricecategory>0) {
				echo "<span class=\"fontbold font8\">".ct_number_format($this->eventdata_number[$event]*$stay_factor*$this->_calculate_singlefee($pricecategory,$this->get('status'),get_timediscountID($this->pdata['regdate'])))."</span>";
			}
			echo "</td>\n";

			//echo "<td><span class=\"fontnormal font8\">&nbsp;</span></td>\n";
			echo "</tr>\n";
		}

	}

	/**
	 * shows status and payment information of particpant.
	 */
	function show_participant_billingaddress($width, $align="center"){
		echo "<table width=\"$width\" align=\"$align\" class=\"infoview_table\">\n";
		echo "<tr class=\"lightbg\"><td align=\"left\" valign=\"top\">\n";
		echo "<span class=\"fontlabel fontbold  font10\">".ct('S_PARTICIPATE_BILLINGADDRESS_OTHER')."</span>\n";
		echo "</td></tr>\n";
		echo "<tr class=\"infoview_sep\"><td align=\"left\" valign=\"top\">";
		echo "<img src=\"spacer.gif\" width=1 height=1 border=0 alt=''>";
		echo "</td></tr>\n";

		echo "<tr class=\"evenrow\"><td width=\"100%\" align=left valign=top>\n";
		$this->_show_addressee();
		echo "</td></tr>";

		echo "</table>";
	}

	/**
	 * shows a page with full participant data.
	 */
	function show_participant_data($width, $align="center"){
		global $db,$session;

		$this->show_participant_status($width,$align);
		// echo "&nbsp;<br>";
		$this->show_participant_costs($width,$align);

		$this->show_participant_payment($width,$align);

		$this->show_remarks($width,$align);

		$user =& $session->get_user();
		echo "<table width=\"$width\" align=\"$align\" class=\"infoview_table\" >\n";
		if ($session->loggedin() && $user->is_admin()) {
			echo "<tr class=\"lightbg\"><td align=\"left\" valign=\"top\" colspan=5>\n";
			echo "<span class=\"fontlabel fontbold font10\">".ct('S_ADMIN_PARTICIPANTS_COMMANDSSECTION')."</span>\n";
			echo "</td></tr>\n";
			echo "<tr class=\"infoview_sep\"><td align=\"left\" valign=\"top\" colspan=5>";
			echo "<img src=\"spacer.gif\" width=1 height=1 border=0 alt=''>";
			echo "</td></tr>\n";
			echo "<tr class=\"mediumbg\"><td colspan=5 align=left valign=top>\n";
			echo "<span class=\"fontbold font9\">\n";
			echo "<a href=\"".ct_pageurl('adminUsersLoginAs', array('form_id' => $this->pdata['personID']))."\">".ct('S_ADMIN_USERS_ACTION_LOGINAS')."</a> &middot; \n";
			echo "<a href=\"".ct_pageurl('adminParticipantsEditDelete', array('form_personID' => $this->pdata['personID']))."\">".ct('S_ADMIN_PARTICIPANTS_ACTION_EDIT')."</a> &middot; \n";
			echo "<a href=\"".ct_pageurl('adminParticipantsEditDelete', array('form_delete_ID' => $this->pdata['personID']))."\">".ct('S_ADMIN_PARTICIPANTS_ACTION_DELETE')."</a> &middot; \n";
			echo "<a href=\"".ct_pageurl('adminParticipantsPayments', array('form_personID' => $this->pdata['personID'] ))."\">".ct('S_ADMIN_PARTICIPANTS_ACTION_PAYMENTS')."</a>&nbsp;&nbsp;|&nbsp;&nbsp;\n";
			if ($this->get('paymethod')=='fax')
				echo "<a target=_blank href=\"".ct_pageurl('adminParticipantsStatement', array('form_userID' => $this->pdata['personID'],'print' =>'yes' ))."\">".ct('S_ADMIN_PARTICIPANTS_ACTION_STATEMENT')."</a> &middot; ";
			echo "<a target=_blank href=\"".ct_pageurl('adminParticipantsInvoice', array('form_userID' => $this->pdata['personID'],'print' =>'yes' ))."\">".ct('S_ADMIN_PARTICIPANTS_ACTION_INVOICE')."</a> &middot; ";
			echo "<a target=_blank href=\"".ct_pageurl('adminParticipantsReceipt', array('form_userID' => $this->pdata['personID'],'print' =>'yes' ))."\">".ct('S_ADMIN_PARTICIPANTS_ACTION_RECEIPT')."</a>";
			// echo "<a target=\"_blank\" href=\"".ct_pageurl('adminParticipantsPayments', array('form_personID' => $this->pdata['personID'] ))."\"><img src=\"icons/newwindow.gif\" border=0></a>";
			echo "</span>\n</td></tr>\n";
		}
		echo "</table>";
	}

	/**
	 * shows status and payment information of particpant.
	 */
	function show_participant_status($width, $align="center"){
		ct_load_lib('datetime.lib');
		ct_load_lib('address.lib');
		ct_load_lib('participation.lib');
		global $db,$session;

		$paydate     = ct_date_format($this->pdata['paydate']);
		$invoicedate = ct_date_format($this->pdata['invoicedate']);
		$regdate     = ct_date_format($this->pdata['regdate']);
		ct_load_lib('participation.lib');
		$timediscountID=get_timediscountID($this->pdata['regdate']);
		$timediscountTitle=get_timediscount($timediscountID);

		$user =& $session->get_user();
		echo "<table width=\"$width\" align=\"$align\" class=\"infoview_table\">\n";
		echo "<tr class=\"lightbg\"><td align=\"left\" valign=\"top\" colspan=2>\n";
		echo "<span class=\"fontlabel fontbold  font10\">".ct('S_PARTICIPATE_PERSON_INTRO')."</span>\n";
		echo "</td></tr>\n";
		echo "<tr class=\"infoview_sep\"><td align=\"left\" valign=\"top\" colspan=2>";
		echo "<img src=\"spacer.gif\" width=1 height=1 border=0 alt=''>";
		echo "</td></tr>\n";

		$status=stripslashes($this->_get_status($this->pdata['status']));
		echo "<tr class=\"evenrow\"><td width=\"100%\" align=left valign=top colspan=2>\n";
		echo "<span class=\"fontlabel font10\">".ct('S_PARTICIPATE_REGDATE').":</span> <span class=\"fontnormal font10\">".$regdate." (".$timediscountTitle.")</span><br>\n";
		echo "<span class=\"fontlabel font10\">".ct('S_PARTICIPATE_GROUPS').":</span> <span class=\"fontnormal font10\">".$status."</span><br>\n";
		if ($this->get('memberID')!='')
			echo "<span class=\"fontlabel font10\">".ct('S_PARTICIPATE_MEMBERID').":</span> <span class=\"fontnormal font10\">".$this->get('memberID')."</span><br>\n";
		#else
		#	echo "<span class=\"fontlabel font10\">".ct('S_PARTICIPATE_MEMBERID').":</span> <span class=\"fontnormal font10\">".ct('S_PARTICIPATE_NOMEMBERID')."</span><br>\n";

		if ($session->loggedin() && $user->is_admin() &&
		   ($this->is_arrived() || $this->is_confirmed() || $this->is_onlist())) {
			echo "</td></tr>";
			echo "<tr class=\"oddrow\"><td width=\"100%\" align=left valign=top colspan=2>\n";
			if ($this->is_arrived()) { echo "<span class=\"fontlabel font10\">".ct('S_USER_FRONTDESK_ARRIVED')."</span><br>"; }
			if ($this->is_confirmed()) { echo "<span class=\"fontlabel font10\">".ct('S_USER_FRONTDESK_CONFIRMED')."</span><br>"; }
			if ($this->is_onlist()) { echo "<span class=\"fontlabel font10\">".ct('S_USER_FRONTDESK_ONLIST')."</span><br>"; }
		}
		// Show extra options if they are available...
		if (ct_test_lib('participation_extraoption.lib')) {	// if extra selection exisits
			ct_load_lib('participation_extraoption.lib');
			if (function_exists('pse_show_extraoptions')) {
				echo "</td></tr>";
				echo "<tr class=\"oddrow\"><td width=\"100%\" align=left valign=top colspan=2>\n";
				pse_show_extraoptions($this);
			} else {
				// default output...
				if ($this->get("extraoption_1")>0 || $this->get("extraoption_2")>0 || $this->get("extraoption_3")>0) {
					echo "</td></tr>";
					echo "<tr class=\"oddrow\"><td width=\"100%\" align=left valign=top colspan=2>\n";
					#if (ct_test_lib('participation_extraoptions.lib')) {	// if extra selection exisits
					#	ct_load_lib('participation_extraoptions.lib');
					if ($this->get("extraoption_1")>0) echo "<span class=\"fontlabel font10\">".ct('S_PARTICIPATE_EXTRAOPTION_1').":</span> <span class=\"fontnormal font10\">".pse_get_extraoptions_title_1($this->get('extraoption_1'))."</span><br>\n";
					if ($this->get("extraoption_2")>0) echo "<span class=\"fontlabel font10\">".ct('S_PARTICIPATE_EXTRAOPTION_2').":</span> <span class=\"fontnormal font10\">".pse_get_extraoptions_title_2($this->get('extraoption_2'))."</span><br>\n";
					if ($this->get("extraoption_3")>0) echo "<span class=\"fontlabel font10\">".ct('S_PARTICIPATE_EXTRAOPTION_3').":</span> <span class=\"fontnormal font10\">".pse_get_extraoptions_title_3($this->get('extraoption_3'))."</span><br>\n";
					#}
				}
				if ($this->get("extratext_1")!='' || $this->get("extratext_2")!='' || $this->get("extratext_3")!='') {
					echo "</td></tr>";
					echo "<tr class=\"evenrow\"><td width=\"100%\" align=left valign=top colspan=2>\n";
					if ($this->get("extratext_1")!='') echo "<span class=\"fontlabel font10\">".ct('S_PARTICIPATE_EXTRATEXT_1').":</span> <span class=\"fontnormal font10\">".$this->get_special('extratext_1')."</span><br>\n";
					if ($this->get("extratext_2")!='') echo "<span class=\"fontlabel font10\">".ct('S_PARTICIPATE_EXTRATEXT_2').":</span> <span class=\"fontnormal font10\">".$this->get_special('extratext_2')."</span><br>\n";
					if ($this->get("extratext_3")!='') echo "<span class=\"fontlabel font10\">".ct('S_PARTICIPATE_EXTRATEXT_3').":</span> <span class=\"fontnormal font10\">".$this->get_special('extratext_3')."</span><br>\n";
				}
			} // end default output
		} // show extraoptions and extratext

		echo "</td></tr>";

		echo "</table>";

	}

	/**
	 * shows payment information of particpant.
	 */
	function show_participant_payment($width, $align="center"){
		ct_load_lib('address.lib');
		ct_load_lib('payment.lib');
		ct_load_lib('participation.lib');
		global $db,$session;

		$user =& $session->get_user();

		// Payment information
		if (ctconf_get('payment/enabled')=='true') {
			echo "<table width=\"$width\" align=\"$align\" class=\"infoview_table\">\n";
			echo "<tr class=\"lightbg\"><td align=\"left\" valign=\"top\" colspan=2>\n";
			echo "<span class=\"fontlabel fontbold  font10\">".ct('S_PARTICIPATE_PAYMENT_INTRO').":</span>\n";
			echo "</td></tr>\n";
			echo "<tr class=\"infoview_sep\"><td align=\"left\" valign=\"top\" colspan=2>";
			echo "<img src=\"spacer.gif\" width=1 height=1 border=0 alt=''>";
			echo "</td></tr>\n";

			echo "<tr class=\"evenrow\">\n";
			echo "<td width=\"50%\" align=left valign=top>\n";
			echo "<span class=\"fontlabel font9\">".ct('S_PARTICIPATE_PAYMETHOD').":</span> <span class=\"fontnormal font9\">";
			echo ct_get_payment_description($this->pdata['paymethod']);
			echo "</span><br>\n";
			if ($this->pdata['paymethod']=='cc'){
				echo "<span class=\"fontlabel font9\">".ct('S_PARTICIPATE_PAYMENT_CCTYPE').":</span> <span class=\"fontnormal font9\">".$this->get_special('cctype')."</span><br>\n";

				echo "<span class=\"fontlabel font9\">".ct('S_PARTICIPATE_PAYMENT_CCHOLDER').":</span> <span class=\"fontnormal font9\">".$this->get_special('ccholder')."</span><br>\n";
				if ($user->is_admin() || $user->is_assistant()) {
					echo "<span class=\"fontlabel font9\">".ct('S_PARTICIPATE_PAYMENT_CCNUMBER').":</span> <span class=\"fontnormal font9\">".$this->get_special('ccnumber')."</span><br>\n";
					if ($this->get('ccvc')!='')
						echo "<span class=\"fontlabel font9\">".ct('S_PARTICIPATE_CCVC').":</span> <span class=\"fontnormal font9\">".$this->get_special('ccvc')."</span><br>\n";
				} else {
					echo "<span class=\"fontlabel font9\">".ct('S_PARTICIPATE_PAYMENT_CCNUMBER').":</span> <span class=\"fontnormal font9\">".ct_mask_ccnumber($this->get_special('ccnumber'))."</span><br>\n";
				}
				if ($this->get('ccissueno')!='')
					echo "<span class=\"fontlabel font9\">".ct('S_PARTICIPATE_PAYMENT_CCISSUENO').":</span> <span class=\"fontnormal font9\">".$this->get_special('ccissueno')."</span><br>\n";
				if ($this->get('ccissuedate')!='')
					echo "<span class=\"fontlabel font9\">".ct('S_PARTICIPATE_PAYMENT_CCISSUEDATE').":</span> <span class=\"fontnormal font9\">".$this->get_special('ccissuedate')."</span><br>\n";
				echo "<span class=\"fontlabel font9\">".ct('S_PARTICIPATE_PAYMENT_CCEXPDATE').":</span> <span class=\"fontnormal font9\">".$this->get_special('ccexpdate')."</span><br>\n";
				if ($this->get('ccaddress')) {
					echo "<br><span class=\"fontbold font8\">".ct('S_PARTICIPATE_CCADDRESS')."</span><br>\n";
					echo "<span class=\"fontlabel font8\">".ct('S_PARTICIPATE_CCSTREETPO').":</span> <span class=\"fontnormal font8\">".$this->get_special('ccaddress')."</span><br>\n";
					echo "<span class=\"fontlabel font8\">".ct('S_PARTICIPATE_CCZIPCODE').":</span> <span class=\"fontnormal font8\">".$this->get_special('cczip')."</span><br>\n";
					echo "<span class=\"fontlabel font8\">".ct('S_USER_CITY').":</span> <span class=\"fontnormal font8\">".$this->get_special('cccity')."</span><br>\n";
					echo "<span class=\"fontlabel font8\">".ct('S_USER_STATE').":</span> <span class=\"fontnormal font8\">".$this->get_special('ccstate')."</span><br>\n";
					echo "<span class=\"fontlabel font8\">".ct('S_USER_COUNTRY').":</span> <span class=\"fontnormal font8\">".ct_get_country($this->get_special('cccountry'))."</span><br>\n";
					echo "<span class=\"fontlabel font8\">".ct('S_USER_EMAIL').":</span> <span class=\"fontnormal font8\">".$this->get_special('ccemail')."</span><br>\n";
				}
			}
			echo "</td>\n";
			echo "<td width=\"50%\" align=left valign=top>\n";
			if ($user->is_admin()) {
				if ($this->pdata['invoice']=='true'){
					echo "<span class=\"fontlabel font9\">".ct('S_PARTICIPATE_INVOICEDATE').":</span> <span class=\"fontnormal font9\">".$invoicedate."</span><br>\n";
				}
				else{
					echo "<span class=\"fontnormal font9\">".ct('S_PARTICIPATE_NOINVOICE')."</span><br>\n";
				}
			}
			if (!isset($this->pdata['payamount']) || $this->pdata['payamount']=='0.00'){
				echo "<span class=\"fontnormal font9\">".ct('S_PARTICIPATE_NOT_PAID')."</span><br>\n";
			} else {
				echo "<span class=\"fontlabel font9\">".ct('S_PARTICIPATE_TOTALFEE').":</span> <span class=\"fontnormal font9\">".ct_currency_format($this->get('total'))."</span><br>\n";
				echo "<span class=\"fontlabel font9\">".ct('S_PARTICIPATE_PAYAMOUNT').":</span> <span class=\"fontnormal font9\">".ct_currency_format($this->get('payamount'))."</span><br>\n";
			}
			if (!($this->get('ccresult')==="")) { // Result code of automatic CC processing
				echo "<br><br>\n";
				echo "<span class=\"fontlabel font8\">Reference, ID:</span> <span class=\"fontnormal font8\">".substr($this->get('ccpnref'),0,32)."</span><br>\n";
				if ($user->is_admin() || $user->is_assistant()) {
					if ($this->get('ccholder')!='')   echo "<span class=\"fontlabel font8\">".ct('S_PARTICIPATE_PAYMENT_CCHOLDER').":</span> <span class=\"fontnormal font8\">".$this->get_special('ccholder')."</span><br>\n";
					if ($this->get('ccresult')!='')   echo "<span class=\"fontlabel font8\">Result Code:</span> <span class=\"fontnormal font8\">".substr($this->get_special('ccresult'),0,32)."</span><br>\n";
					if ($this->get('ccrespmsg')!='')  echo "<span class=\"fontlabel font8\">Resp Msg:</span> <span class=\"fontnormal font8\">".substr($this->get_special('ccrespmsg'),0,128)."</span><br>\n";
					if ($this->get('ccauthcode')!='') echo "<span class=\"fontlabel font8\">Auth Code:</span> <span class=\"fontnormal font8\">".substr($this->get_special('ccauthcode'),0,32)."</span><br>\n";
					if ($this->get('ccavsdata')!='')  echo "<span class=\"fontlabel font8\">AVS Data:</span> <span class=\"fontnormal font8\">".$this->get('ccavsdata')."</span><br>\n";
				}
			}

			if ($this->get('ccpaylink')!='' && ($user->is_admin() || $user->is_assistant())) {
				echo "<span class=\"fontlabel font8\">CC Paylink:</span> <a target=\"_blank\" href=\"".$this->get('ccpaylink')."\"class=\"fontbold font8\">".ct_form_encode(substr(urldecode($this->get('ccpaylink')),0,40))."...</a><br>\n";
			}

			echo "</td></tr>\n";
			echo "</table>";
		} // end payment information

	}

	/**
	 * shows participant event and product details and costs
	 */
	function show_participant_costs($width, $align="center", $tableclass="infoview_table", $headrowclass="oddrow", $rowclass="evenrow", $tdclass=""){
		ct_load_lib('participation.lib');
		ct_load_lib('datetime.lib');
		global $db,$session,$http;

		$timediscountID=get_timediscountID($this->pdata['regdate']);

		// Start with list of costs
		echo "<table width=\"$width\" align=\"$align\" class=\"$tableclass\" >\n";
		echo "<tr class=\"$headrowclass\">";
		echo "<td class=\"$tdclass\" width=\"8%\" align=\"center\" valign=bottom>\n";
		echo "<span class=\"fontlabel font10\">".ct('S_PARTICIPATE_EVENTNUMBER')."</span>";
		echo "</td>\n";
		echo "<td class=\"$tdclass\" width=\"45%\" align=left valign=bottom>\n";
		echo "<span class=\"fontlabel font10\">".ct('S_PARTICIPATE_EVENTS')."</span>";
		echo "</td>\n";
		echo "<td class=\"$tdclass\" width=\"10%\" align=right valign=bottom>\n";
		echo "<span class=\"fontlabel font10\">&nbsp;</span>";
		echo "</td>\n";
		if (ctconf_get('payment/enabled')=='true') {
			if (ctconf_get('conferenceNetPrices')==1) {
				echo "<td class=\"$tdclass\" width=\"10%\" align=right valign=bottom>\n";
				echo "<span class=\"fontlabel font10\">".ct('S_PARTICIPATE_EVENTFEE')." <br>(".ct('S_INVOICE_NET').")</span>";
				echo "</td>\n";
				echo "<td class=\"$tdclass\" width=\"15%\" align=right valign=bottom>\n";
				echo "<span class=\"fontlabel font10\">".ct('S_PARTICIPATE_EVENTTOTALFEE');
				if (ctconf_get('conferenceWithVAT','1')) echo " <br>(".ct('S_INVOICE_NET').")";
				echo "</span>";
				echo "</td>\n";
				if (ctconf_get('conferenceWithVAT','1')) { 	// Conference with VAT?
					echo "<td class=\"$tdclass\" width=\"12%\" align=right valign=bottom>\n";
					echo "<span class=\"fontlabel font10\">".ct('S_PARTICIPATE_PLUSVAT')."</span>";
					echo "</td>\n";
				}
			} else {
				echo "<td class=\"$tdclass\" width=\"10%\" align=right valign=bottom>\n";
				echo "<span class=\"fontlabel font10\">".ct('S_PARTICIPATE_EVENTFEE')."</span>";
				echo "</td>\n";
				echo "<td class=\"$tdclass\" width=\"15%\" align=right valign=bottom>\n";
				echo "<span class=\"fontlabel font10\">".ct('S_PARTICIPATE_EVENTTOTALFEE');
				if (ctconf_get('conferenceWithVAT','1')) echo " (".ct('S_INVOICE_GROSS').")";
				echo "</span>";
				echo "</td>\n";
				if (ctconf_get('conferenceWithVAT','1')) { 	// Conference with VAT?
					echo "<td class=\"$tdclass\" width=\"12%\" align=right valign=bottom>\n";
					echo "<span class=\"fontlabel font10\">".ct('S_PARTICIPATE_VAT')."</span>";
					echo "</td>\n";
				}
			}
		}
		echo "</tr>\n";

		$totalnet=0.00;
		$totalgross=0.00;
		$totalvat=0.00;
		$totalvats=array();
		$totalnets=array();
		$vatrates = ct_list_vats();
		foreach ($vatrates as $v){
			$totalvats[$v[0]]=0.00;
			$totalnets[$v[0]]=0.00;
		}

		$etypes = ct_get_eventtypes();
		foreach ($etypes as $etype){
			$events = ct_get_events($etype['ID']);
			foreach ($events as $e){
				if (isset($this->eventdata_number[$e['ID']]) && $this->eventdata_number[$e['ID']]!=0){

					$singlefee=$this->_calculate_singlefee($e['pricecategory'],$this->pdata['status'],$timediscountID);
					if ($singlefee==0 && $etype['nocharge']=='hideoninvoice' &&
						($http['page']=='adminParticipantsInvoice' || $http['page']=='invoice' || $http['page']=='adminParticipantsReceipt')) {
						// Do not display this event/product!
					} elseif ($singlefee==0 && $e['style']=='hidden2') {
						// Do not display this event/product!
					} else {
						if ($etype['negative']!='normal' && $singlefee<0) $singlefee=-$singlefee; // negative is used to disable/hide events.

						$start       = 0;
						if ($e['datemode']!="false") $start = $this->eventdata_start[$e['ID']];

						$end         = 0;
						if ($e['datemode']!="false" && $e['datemode']!="selectday") $end = $this->eventdata_end[$e['ID']];

						$stay_factor = 1;
						if ($e['datemode']=="perdiem")  $stay_factor = ct_count_days($start,$end);
						if ($e['datemode']=="pernight") $stay_factor = ct_count_nights($start,$end);


						$vat=$this->_get_vat($e['vat']);
						if (ctconf_get('conferenceNetPrices')==1) {
							$eventTotal=$this->eventdata_number[$e['ID']]*$singlefee*$stay_factor;
							$vatamount=$eventTotal*($vat/100);
							// Add to total
							$totalnet+=$eventTotal;
							$totalvat+=$vatamount;
							$totalgross+=$eventTotal+$vatamount;
							$totalnets[$e['vat']]+=$eventTotal;
							$totalvats[$e['vat']]+=$vatamount;
						} else {
							$eventTotal=$this->eventdata_number[$e['ID']]*$singlefee*$stay_factor;
							$vatamount=$eventTotal-($eventTotal/(($vat/100)+1));
							// Add to total
							$totalnet+=$eventTotal-$vatamount;
							$totalvat+=$vatamount;
							$totalgross+=$eventTotal;
							$totalnets[$e['vat']]+=$eventTotal-$vatamount;
							$totalvats[$e['vat']]+=$vatamount;
						}
						$text = ct_nl2br($this->eventdata_text[$e['ID']]);

						echo "<tr class=\"$rowclass\">";

						echo "<td class=\"$tdclass\" width=\"8%\" align=\"center\" valign=top>\n";
						echo "<span class=\"fontnormal font10\">".$this->eventdata_number[$e['ID']]."</span></td>\n";

						// Second column: Description
						echo "<td class=\"$tdclass\" width=\"45%\" align=left valign=top>\n";
						echo "<span class=\"fontnormal font8\">".stripslashes($etype[ctlx($etype,'title')])."</span><br>\n";
						echo "<span class=\"fontbold font10\">".stripslashes($e[ctlx($e,'title')])."</span>\n";

						if ($e[ctlx($e,'eventdate')]!="")
							echo "<br><span class=\"fontbold font8\">".ct('S_ADMIN_TOOL_EVENTS_DATE').":</span><span class=\"fontnormal font8\"> ".stripslashes($e[ctlx($e,'eventdate')])."</span>\n";
						if ($e[ctlx($e,'eventlocation')]!="")
							echo "<br><span class=\"fontbold font8\">".ct('S_ADMIN_TOOL_EVENTS_LOCATION').":</span><span class=\"fontnormal font8\"> ".stripslashes($e[ctlx($e,'eventlocation')])."</span>\n";
						if ($e[ctlx($e,'info')]!="")
							echo "<br><span class=\"fontlabel font8\"> ".stripslashes($e[ctlx($e,'info')])."</span>\n";

						if ($e['datemode']!="false") {
							if ($e['datemode']=="selectday")
								echo "<br><span class=\"fontlabel font10\">".ct('S_PARTICIPATE_DATE').": </span>";
							else
								echo "<br><span class=\"fontlabel font10\">".ct('S_PARTICIPATE_DATES').": </span>";

							echo ct_date_format(ct_timestamp_2_datetime($start));
							if ($e['datemode']=="pernight" || $e['datemode']=="perdiem" || $e['datemode']=="selectspan") {
								echo " - ".ct_date_format(ct_timestamp_2_datetime($end));
							}
						}

						if (!empty($text))
							echo "<br><span class=\"fontlabel font10\">".stripslashes($e[ctlx($e,'texthint')]).": </span><span class=\"fontnormal font10\">".$text."</span>";

						echo "</td>\n";

						// Third: Extra
						echo "<td class=\"$tdclass\" width=\"10%\" align=right valign=top>\n";
						if ($e['datemode']!="false") {
							if ($e['datemode']=="pernight") {
								if ($stay_factor==1)
									echo "<span class=\"fontnormal font10\">".$stay_factor."&nbsp;".ct(S_PARTICIPATE_NIGHT)."</span>";
								else
									echo "<span class=\"fontnormal font10\">".$stay_factor."&nbsp;".ct(S_PARTICIPATE_NIGHTS)."</span>";
							} elseif ($e['datemode']=="perdiem") {
								if ($stay_factor==1)
									echo "<span class=\"fontnormal font10\">".$stay_factor."&nbsp;".ct(S_PARTICIPATE_DAY)."</span>";
								else
									echo "<span class=\"fontnormal font10\">".$stay_factor."&nbsp;".ct(S_PARTICIPATE_DAYS)."</span>";
							} else {
								echo "&nbsp;";
							}
						} else {
							echo "&nbsp;";
						}
						echo "</td>\n";

						if (ctconf_get('payment/enabled')=='true') {
							// Fourth column
							echo "<td class=\"$tdclass\" width=\"10%\" align=right valign=top>\n";
							if ($etype['nocharge']!='false' && $singlefee == 0) {
								echo "&nbsp;";
							} else {
								echo "<span class=\"fontnormal font10\">".ct_currency_format($singlefee,false)."</span><br>\n";
								if ($e['datemode']=="perdiem") {  // 'false','selectday','selectspan','perdiem','pernight'
									echo "<span class=\"fontnormal font10\">".ct('S_PARTICIPATE_FEEPERDAY')."</span>";
								}
								elseif ($e['datemode']=="pernight") {
									echo "<span class=\"fontnormal font10\">".ct('S_PARTICIPATE_FEEPERNIGHT')."</span>";
								}
								elseif ($e['datemode']=="selectspan") {
									echo "<span class=\"fontnormal font10\">".ct('S_PARTICIPATE_FLATFEE')."</span>";
								}
							}
							if ($this->get('discount')!=0)
								echo '<br><span class="fontlabel font10">'.ct('S_PARTICIPATE_DISCOUNT').':&nbsp;'.ct_number_format($this->get('discount'),0).'%</span>';

							echo "</td>\n";

							// Fifth: total
							echo "<td class=\"$tdclass\" width=\"15%\" align=right valign=top>\n";
							if ($singlefee==0 && $etype['nocharge']=='hideoninvoice') {
								echo "&nbsp;";
							} else {
								echo "<span class=\"fontnormal font10\">".ct_currency_format($eventTotal,false)."</span>";
							}
							echo "</td>\n";

							// Sixth: vat
							if (ctconf_get('conferenceWithVAT','1')) { 	// Conference with VAT?
								echo "<td class=\"$tdclass\" width=\"12%\" align=right valign=top>\n";
								if ($etype['nocharge']!='false' && $singlefee == 0) {
									echo "&nbsp;";
								} else {
									echo "<span class=\"fontnormal font10\">".ct_number_format($vat,1)."%</span>";
									if ($vatamount>0) echo "<br><span class=\"fontnormal font9\">".ct_currency_format($vatamount,false)."</span>";
								}
								echo "</td>\n";
							}

						}

					} // End hide events with 0,00 prices.
				}
			}
		}

		echo "</tr>";
		// footer with sums etc.
		if (ctconf_get('payment/enabled')=='true') {

			$numberofVATrates = 0;
			reset($totalvats);
			foreach ($totalvats as $k=>$v) {
				if ($totalnets[$k]!=0) $numberofVATrates++;
			}

			if (ctconf_get('conferenceNetPrices')==1) {
				if (ctconf_get('conferenceWithVAT','1') || $totalvat>0.01) { 	// Conference with VAT?
					echo "<tr class=\"$rowclass\">";
					echo "<td class=\"$headrowclass\" align=right valign=top colspan=4>\n";
					echo "<span class=\"fontbold font10\">".ct('S_INVOICE_NETSUM')."</span> ";
					echo "</td>\n";
					echo "<td class=\"$tdclass\" align=right valign=top colspan=1>\n";
					echo "<span class=\"fontnormal font10\">".ct_currency_format($totalnet,false)."</span></td>";
					if (ctconf_get('conferenceWithVAT','1')) { 	// Conference with VAT?
						echo "<td class=\"$headrowclass\" align=right valign=top colspan=1>&nbsp;</td></tr>\n";
					}
				}

				reset($totalvats);
				foreach ($totalvats as $k=>$v) {
					if ($totalnets[$k]!=0) {
					 	if ($this->_get_vat($k)!=0) {
							echo "<tr class=\"$rowclass\">";
							echo "<td class=\"$headrowclass\" align=right valign=top colspan=4>\n";
							echo "<span class=\"fontbold font10\">".ct('S_INVOICE_VATSUM_ADDED',array(ct_number_format($this->_get_vat($k),1),ct_currency_format($totalnets[$k],false)))."</span> ";
							echo "</td>\n";
							echo "<td class=\"$tdclass\" align=right valign=top colspan=1>\n";
							echo "<span class=\"fontnormal font10\">".ct_currency_format($v,false)."</span></td>";
							if (ctconf_get('conferenceWithVAT','1'))
								echo "<td class=\"$headrowclass\" align=right valign=top colspan=1>&nbsp;</td></tr>\n";
					 	}
					}

				}

				echo "<tr class=\"$rowclass\">";
				echo "<td class=\"$headrowclass\" align=right valign=top colspan=4>\n";
				echo "<span class=\"fontbold font10\">".ct('S_INVOICE_GROSSSUM')."</span> ";
				echo "</td>\n";
				echo "<td class=\"$tdclass\" align=right valign=top colspan=1>\n";
				echo "<span class=\"fontbold font10\">".ct_currency_format($totalgross,false)."</span></td>";
				if (ctconf_get('conferenceWithVAT','1')) { 	// Conference with VAT?
					# echo "<td class=\"$tdclass\" align=right valign=top colspan=1><span class=\"fontnormal font10\">".ct_currency_format($totalvat,false)."</span></td></tr>\n";
					echo "<td class=\"$headrowclass\" align=right valign=top colspan=1>&nbsp;</td></tr>\n";
				}
			} else { // gross prices
				reset($totalvats);
				if ($numberofVATrates>1) {
					foreach ($totalvats as $k=>$v) {
						if ($totalnets[$k]!=0) {
							if ($this->_get_vat($k)!=0) {
								echo "<tr class=\"$rowclass\">";
								echo "<td class=\"$headrowclass\" align=right valign=top colspan=4>\n";
								echo "<span class=\"fontbold font10\">".ct('S_INVOICE_SUM_VAT_INCLUDED',array(ct_number_format($this->_get_vat($k),1),ct_currency_format($totalnets[$k],false)))."</span> ";
								echo "</td>\n";
								echo "<td class=\"$tdclass\" align=right valign=top colspan=1>\n";
								echo "<span class=\"fontnormal font10\">".ct_currency_format($v+$totalnets[$k],false)."</span></td>";
								if (ctconf_get('conferenceWithVAT','1'))
									echo "<td class=\"$tdclass\" align=right valign=top colspan=1><span class=\"fontnormal font10\">".ct_currency_format($totalvats[$k],false)."</span></td></tr>\n";
							} else {
								echo "<tr class=\"$rowclass\">";
								echo "<td class=\"$headrowclass\" align=right valign=top colspan=4>\n";
								echo "<span class=\"fontbold font10\">".ct('S_INVOICE_SUM_NOVAT')."</span> ";
								echo "</td>\n";
								echo "<td class=\"$tdclass\" align=right valign=top colspan=1>\n";
								echo "<span class=\"fontnormal font10\">".ct_currency_format($totalnets[$k],false)."</span></td>";
								if (ctconf_get('conferenceWithVAT','1'))
									echo "<td class=\"$tdclass\" align=right valign=top colspan=1><span class=\"fontnormal font10\">-</span></td></tr>\n";
							}
						}
					}
				}

				echo "<tr class=\"$rowclass\">";
				echo "<td class=\"$headrowclass\" align=right valign=top colspan=4>\n";
				echo "<span class=\"fontbold font10\">".ct('S_PARTICIPATE_TOTALFEE')."</span> ";
				echo "</td>\n";
				echo "<td class=\"$tdclass\" align=right valign=top colspan=1>\n";
				echo "<span class=\"fontbold font10\">".ct_currency_format($totalgross,false)."</span></td>";
				if (ctconf_get('conferenceWithVAT','1')) { 	// Conference with VAT?
					#echo "<td class=\"$tdclass\" align=right valign=top colspan=1><span class=\"fontnormal font10\">".ct_currency_format($totalvat,false)."</span></td></tr>\n";
					echo "<td class=\"$headrowclass\" align=right valign=top colspan=1>&nbsp;</td></tr>\n";
				}
			}

			if (ctconf_get('conferenceNetPrices')!=1 && $totalvat>0.01) { 	// Conference with VAT?
				echo "<tr class=\"$headrowclass\">";
				echo "<td align=left valign=top colspan=6>\n";
				echo "<span class=\"fontbold font10\">".ct('S_INVOICE_TOTAL1')." ".ct_currency_format($totalgross)." ";
				echo ct('S_INVOICE_TOTAL2')." ".ct_currency_format($totalnet)." ";
				echo ct('S_INVOICE_TOTAL3')." ";
				echo ct_currency_format($totalvat)." ".ct('S_INVOICE_TOTAL4')."</span>\n";
				echo "</td></tr>\n";
			}
		} // Costs footer end
		echo "</table>\n";
	}


	/**
	 * shows remarks from/for participant
	 */
	function show_remarks($width, $align='center'){
		global $db,$session,$ctconf;
		// Remarks
		echo "<table width=\"$width\" align=\"$align\" class=\"infoview_table\">\n";
		echo "<tr class=\"lightbg\"><td align=\"left\" valign=\"top\" colspan=2>\n";
		echo "<span class=\"fontlabel fontbold  font10\">".ct('S_PARTICIPATE_DETAILED_REMARKSECTION')."</span>\n";
		echo "</td></tr>\n";
		echo "<tr class=\"infoview_sep\"><td align=\"left\" valign=\"top\" colspan=2>";
		echo "<img src=\"spacer.gif\" width=1 height=1 border=0 alt=''>";
		echo "</td></tr>\n";
		$user =& $session->get_user();
		if ($session->loggedin() && $user->is_admin()) {
			echo "<tr class=\"oddrow\"><td align=left valign=top width='50%'>\n";
			echo "<span class=\"fontlabel font10\">".ct('S_PARTICIPATE_EXTERNALREMARK').":</span><br>\n";
			echo "<span class=\"fontnormal font10\">".ct_nl2br($this->get('externalremark'))."</span>\n";
			echo "</td><td align=left valign=top>\n";
			echo "<span class=\"fontlabel font10\">".ct('S_PARTICIPATE_INTERNALREMARK').":</span><br>\n";
			echo "<span class=\"fontnormal font10\">".ct_nl2br($this->get('internalremark'))."</span>\n";
			echo "&nbsp;</td></tr>";
		} else {
			echo "<tr class=\"oddrow\"><td align=left valign=top colspan=2>\n";
			echo "<span class=\"fontlabel font10\">".ct('S_PARTICIPATE_EXTERNALREMARK').":</span><br>\n";
			echo "<span class=\"fontnormal font10\">".ct_nl2br($this->get('externalremark'))."</span>\n";
			echo "</td></tr>\n";
		}
		echo "</table>";
	}

}

?>