<?php
//
// CLASS:       CTParticipation
//

class CTParticipation_Form extends CTParticipation {

	function CTParticipation_Form() {
		parent::CTParticipation();
	}


	//## FORM PROCESSING AND GENERATION #######################################


	//## A) FORM GENERATION FUNCTIONS ############################################
	// ###########################################################################

	
	// shows part one of the participantform.
	function show_form_status($action, $errors) {
		ct_load_class('CTForm');
		ct_load_lib('participation.lib');
		global $db,$session,$http;

		$this->form = new CTForm($action, 'post', $errors);
		$this->form->width='650';
		$this->form->align='center';
		$this->form->waitmessage=true;// show waitmessage!
		$this->_get_form_status();

		$this->form->add_hidden(array(array('step_status', '1')));
		$this->form->add_submit_not_bottom('go_events', ct('S_BUTTON_SEND_X',array('2')).': '.ct('S_PARTICIPATE_STEP_EVENTS'),true);
		$this->form->show();
	}

	// shows part two of the participantform.
	function show_form_events($action, $errors) {
		ct_load_class('CTForm');
		ct_load_lib('participation.lib');
		global $db,$session,$http;

		$this->form = new CTForm($action, 'post', $errors);
		$this->form->width='95%';
		$this->form->align='center';
		$this->form->waitmessage=true;// show waitmessage!

		$this->_get_form_events();
		$this->_get_form_discount_extra();
		$this->_get_form_remark();

		$this->form->add_hidden(array(array('step_events', '1')));
		$this->form->add_submit_not_bottom('go_billing', ct('S_BUTTON_SEND_X',array('3')).': '.ct('S_PARTICIPATE_STEP_PAYMENT'),true);
		$this->form->add_submit('go_status', ct('S_BUTTON_BACK_TO_X',array('1')).': '.ct('S_PARTICIPATE_STEP_STATUS'));
		$this->form->show();
	}

	// shows part two of the participantform.
	function show_form_billing($action, $errors) {
		ct_load_class('CTForm');
		ct_load_lib('participation.lib');
		global $db,$session,$http;

		$this->form = new CTForm($action, 'post', $errors);
		$this->form->width='97%';
		$this->form->align='center';
		$this->form->waitmessage=true;// show waitmessage!
		$this->form->formname='billing';
		$this->form->return2tab=true; // allow return key...

		$this->_get_form_billingaddress();
		$this->_get_form_paymode();
		$this->_get_form_remark();

		$this->form->add_hidden(array(array('step_billing', '1')));
		$this->form->add_submit_not_bottom('go_confirmation', ct('S_BUTTON_SEND_X',array('4')).': '.ct('S_PARTICIPATE_STEP_CONFIRM'),true);
		$this->form->add_submit('go_status', ct('S_BUTTON_BACK_TO_X',array('1')).': '.ct('S_PARTICIPATE_STEP_STATUS'));
		$this->form->add_submit('go_events', ct('S_BUTTON_BACK_TO_X',array('2')).': '.ct('S_PARTICIPATE_STEP_EVENTS'));
		$this->form->show();
	}


	// shows part three of the participantform: save the data.
	function show_form_confirmation($action, $errors) {
		ct_load_class('CTForm');
		global $http,$db,$session;
		$user = $session->get_user();
		
		$this->form = new CTForm($action, 'post', $errors);
		$this->form->width='95%';
		$this->form->align='center';
		$this->form->waitmessage=true;// show waitmessage!

		$this->_get_form_confirmation();

		$this->form->add_hidden(array(array('step_confirmation', '1')));
		$this->form->add_spacer();
		$this->form->add_submit_not_bottom('cmd_save_participant', ct('S_PARTICIPATE_CREATECMD'),true);
		// Optional go directly to submission page - some users didn't find it...
		if (ctconf_get('submission/enabled') && ct_check_phases('submission') && // Only if submission is enabled
			$user->count_submitted_papers()==0 &&	// and user didn't submit anything, yet.
			$this->get('paymethod')!='paypal' && $this->get('paymethod')!='ccexternal') {	// Better not for these, as people shall do something on overview page to pay...
			$this->form->add_submit_not_bottom('cmd_save_participant_submit', ct('S_PARTICIPATE_CREATECMD_SUBMIT'),true);
		}
		$this->form->add_spacer();
		$this->form->add_submit('go_status', ct('S_BUTTON_BACK_TO_X',array('1')).': '.ct('S_PARTICIPATE_STEP_STATUS'));
		$this->form->add_submit('go_events', ct('S_BUTTON_BACK_TO_X',array('2')).': '.ct('S_PARTICIPATE_STEP_EVENTS'));
		$this->form->add_submit('go_billing', ct('S_BUTTON_BACK_TO_X',array('3')).': '.ct('S_PARTICIPATE_STEP_PAYMENT'));
		$this->form->show();
	}

	// show form for admin and assistant in Backoffice
	function show_form_adminpart($action, $errors) {
		ct_load_class('CTForm');
		ct_load_lib('participation.lib');
		global $db,$session;

		$this->person->show_shortinfo('96%');

		$timediscountTitle=get_timediscount(get_timediscountID($this->get('regdate')));
		$this->form = new CTForm($action, 'post', $errors);
		$this->form->width='96%';
		$this->form->align='center';

		//also display registration date and status
		$this->form->add_separator(ct('S_PARTICIPATE_REGDATE'));
		$this->form->add_datetime(ct('S_PARTICIPATE_REGDATE'),'form_regdate', true, explode(" ",str_replace("-"," ", str_replace(":"," ", $this->get('regdate') ) ) ),ct('S_PARTICIPATE_REGDATEHINT'));
		$this->form->add_label('',ct('S_PARTICIPATE_TIMEDISCOUNTINTRO3').": <b>".$timediscountTitle."</b> ".ct('S_PARTICIPATE_TIMEDISCOUNTINTRO4'));
		$this->form->add_submit_not_bottom('cmd_update_participant', ct('S_PARTICIPANT_UPDATE'));
		// Show status...
		$this->_get_form_status();
		// Allow update...
		$this->form->add_spacer();
		$this->form->add_submit_not_bottom('cmd_update_participant', ct('S_PARTICIPANT_UPDATE'));

		$this->_get_form_events();
		$this->_get_form_discount_extra();
		$this->_get_form_remark();
		$this->_get_form_billingaddress();
		$this->_get_form_paymode();
		$this->_get_form_frontdeskpart();
		$this->_get_form_adminpart();
		$this->form->add_hidden(array(array('form_personID', $this->pdata['personID'])));
		$this->form->add_submit('cmd_save_participant', ct('S_PARTICIPANT_SUBMIT'));
		$this->form->show();
	}

	// show form for frontdesk!
	function show_form_frontdesk($action, $errors) {
		ct_load_class('CTForm');
		global $db,$session;

		$this->form = new CTForm($action, 'post', $errors);
		$this->form->width='620';
		$this->form->align='center';
		$this->form->add_hidden(array(array('form_personID', $this->pdata['personID'])));
		$this->_get_form_frontdeskpart();
		$this->form->add_submit('cmd_save_participant', ct('S_PARTICIPANT_SUBMIT'));
		$this->form->show();
	}

	// show edit form to user
	function show_form_useredit($action, $errors) {
		ct_load_class('CTForm');
		ct_load_lib('participation.lib');
		global $db,$session,$http;

		$this->form = new CTForm($action, 'post', $errors);
		$this->form->width='99%';
		$this->form->align='center';

		$this->_get_form_events();
		$this->_get_form_billingaddress();
		$this->_get_form_paymode();
		$this->_get_form_remark();

		$this->form->add_submit('cmd_save_participant', ct('S_PARTICIPANT_SUBMIT'));
		$this->form->add_submit('cmd_cancel', ct('S_BUTTON_CANCEL'));
		$this->form->show();
	}

	// INTERNAL FUNCTION FOR FORM GENERATION -----


	// Enter status and Code number
	function _get_form_status(){
		global $session;
		ct_load_lib('participation.lib');
		$user = $session->get_user();
		$this->form->add_separator(ct('S_PARTICIPATE_STATUS_SECTION'));
		$timediscountTitle=get_timediscount(get_timediscountID($this->get('regdate')));
		$this->form->add_label(ct('S_PARTICIPATE_TIMEDISCOUNT'),$timediscountTitle);
		#$this->form->add_select(ct('S_PARTICIPATE_GROUPS'), 'form_status', 1, ct_list_groups($user->is_admin()||$user->is_frontdesk()||$user->is_assistant()||$user->is_conferenceChair()), array($this->get('status')), false, (ct('S_PARTICIPATE_GROUPS_HINT')!='')?'<br>'.ct('S_PARTICIPATE_GROUPS_HINT'):'');
		$this->form->add_radio("* ".ct('S_PARTICIPATE_GROUPS'), 'form_status', ct_list_groups($user->is_admin()||$user->is_frontdesk()||$user->is_assistant()||$user->is_conferenceChair()), $this->get('status'), (ct('S_PARTICIPATE_GROUPS_HINT')!='')?ct('S_PARTICIPATE_GROUPS_HINT'):'');

		if (ctconf_get('memberNumber',ctconf_get('participation/status_membernumber')) || 
			    $this->get('memberID')!='' || // Is there something already? Show it!
			    is_array($this->errors) && in_array('form_memberID',$this->errors) ) {	// if this field is required, show it!
			$this->form->add_text(ct('S_PARTICIPATE_MEMBERID'),'form_memberID', $this->get('memberID'),20,20,false,'<br>'.ct('S_PARTICIPATE_MEMBERHINT'));
		}

		// Show extra options if they are available...
		if (ct_test_lib('participation_extraoption.lib')) {	// if extra selection exisits
			ct_load_lib('participation_extraoption.lib');
			if (function_exists('pse_get_form_status_extraoptions')) { 
				pse_get_form_status_extraoptions($this);
			}
		}
		
	}


	function _get_form_events(){
		global $session;
		ct_load_lib('participation.lib');
		ct_load_lib('datetime.lib');

		$user =& $session->get_user();

		$timediscountID=get_timediscountID($this->get('regdate'));

		// Check if already an event was selected: Don't use default values any more...
		$eventselected=false;
		$events = ct_get_events($etype['ID']);
		foreach ($events as $e){
			// If any event was selected, dont use the default values any more!
			if(isset($this->eventdata_number[$e['ID']])){
				$eventselected=true;
			}
		}

		// events ordered by eventtypes
		$this->form->add_separator(ct('S_PARTICIPATE_EVENT_SECTION'));
		ct_load_lib('participation.lib');
		$etypes = ct_get_eventtypes();
		foreach ($etypes as $etype){

			## NEW GROUP: ADD HEADER ################################################
			// Show small header for every event type...
		    if ($etype['style']=='normal' && $etype['nocharge']!='false')
				$this->form->add_subseparator(stripslashes($etype[ctlx($etype,'title')]),stripslashes(nl2br($etype[ctlx($etype,'info')])));
		    elseif ($etype['style']=='normal' && $etype['nocharge']=='false')
				$this->form->add_subseparator3(stripslashes($etype[ctlx($etype,'title')]),stripslashes(nl2br($etype[ctlx($etype,'info')])),ct('S_PARTICIPATE_FEE'));
		    elseif ($etype['style']=='main' && $etype[ctlx($etype,'info')]=="")
				$this->form->add_separator(stripslashes($etype[ctlx($etype,'title')]));
		    elseif ($etype['style']=='main')
				$this->form->add_separator3(stripslashes($etype[ctlx($etype,'title')]),stripslashes(nl2br($etype[ctlx($etype,'info')])));
		    elseif ($etype['style']=='spacer')
				$this->form->add_spacer();
		    // style='hidden' will not be displayed


			// helper variable needed for exclusive and joint selection.
			$etypehelper = 0;

			// Show all events of this event type
			$events = ct_get_events($etype['ID']);
			foreach ($events as $e){
				$eventinformation='';
				if ($e[ctlx($e,'eventdate')]!=''){ $eventinformation=stripslashes(nl2br($e[ctlx($e,'eventdate')]));}
				if (($e[ctlx($e,'eventdate')]!='') && (($e[ctlx($e,'eventlocation')]!='') || ($e[ctlx($e,'info')]!='' ))){ $eventinformation.='<br>';}
				if ($e[ctlx($e,'eventlocation')]!=''){  $eventinformation.=stripslashes(nl2br($e[ctlx($e,'eventlocation')]));}
				if ($e[ctlx($e,'eventlocation')]!='' && $e[ctlx($e,'info')]!=''){ $eventinformation.='<br>';}
				if ($e[ctlx($e,'info')]!=''){ $eventinformation.="<span class=\"fontbold font9\">".stripslashes(nl2br($e[ctlx($e,'info')]))."</span>";}
				$unit='';
				if ($e[ctlx($e,'unit')]!=''){ $unit=stripslashes($e[ctlx($e,'unit')]); }
				$fee=$this->_calculate_singlefee($e['pricecategory'],$this->get('status'),$timediscountID);

				if ($etype['negative']!='normal' && $fee<0) // negative is used to disable/hide events.
					$fee_formatted="<span class=\"fontother font10\">".ct_currency_format(-$fee)."</span>";
				elseif ($fee<0) // negative is used to disable/hide events.
					$fee_formatted="<span class=\"fontnegative font10\">".ct_currency_format($fee)."</span>";
				else
					$fee_formatted="<span class=\"fontnormal font10\">".ct_currency_format($fee)."</span>";

				if ($e['maxnumber']>1) {
					$fee_formatted.="<br><span class=\"fontnormal font9\">".ct('S_PARTICIPATE_FEEINFO')."</span>";
				}

				// date mode of this event
				if ($e['datemode']=="perdiem") {  // 'false','selectday','selectspan','perdiem','pernight'
					$fee_formatted.="<br><span class=\"fontnormal font9\">".ct('S_PARTICIPATE_FEEPERDAY')."</span>";
				}
				elseif ($e['datemode']=="pernight") {
					$fee_formatted.="<br><span class=\"fontnormal font9\">".ct('S_PARTICIPATE_FEEPERNIGHT')."</span>";
				}
				elseif ($e['datemode']=="selectspan") {
					$fee_formatted.="<br><span class=\"fontnormal font9\">".ct('S_PARTICIPATE_FLATFEE')."</span>";
				}
				$vatrate=$this->_get_vat($e['vat']);
				if ($vatrate!=0 && $fee>0) {
					if (ctconf_get('conferenceNetPrices')==1) {
						$fee_formatted.="<br><span class=\"fontnormal font9\">".ct('S_PARTICIPATE_PLUS_VAT',array(ct_number_format($vatrate,1)))."</span>";
					} else {
						$fee_formatted.="<br><span class=\"fontnormal font9\">".ct('S_PARTICIPATE_VAT_INCLUDED',array(ct_number_format($vatrate,1)))."</span>";
					}										
				}
				
				if ($etype['nocharge']!='false' && $fee == 0) $fee_formatted="&nbsp"; // Hide if true or hideoninvoice

				// Event disabled for normal users?
				$event_all_bookings = $this->_event_all_bookings($e['ID']);  // get values from DB
				$event_user_bookings = $this->_event_user_bookings($e['ID']);
				// echo "all:".$event_all_bookings." - user:".$event_user_bookings." - avail:".$e['availability']."<br>";

				if (($e['disable']!='true' &&  // Disabled: Show but user cannot select event
					 $e['style']!='hidden' &&  // Hidden: Do not show.
						($fee>=0 || $etype['negative']=='normal') && // hide/disable events with negative prices?
						(($event_all_bookings-$event_user_bookings)<$e['availability'] || $e['availability']<1)) ||
						($etype['mode']=='joint' && $e['style']!='hidden' && $etype['negative']!='hidden') ||  // Joint have to be shown as joint also when booked out
						$user->is_admin() || $user->is_assistant()) {	// Can always access

					// How many are still available?
					$max_available = $e['maxnumber'];
					$min_available = $e['minnumber'];
					if ( !$user->is_admin() && !$user->is_assistant() && // They can still book this, frontdesk must not!
							$e['availability']>0 && $e['maxnumber']>($e['availability']-($event_all_bookings-$event_user_bookings)) ) {
						$max_available = $e['availability'] - ($event_all_bookings -$event_user_bookings);
						if ($event_user_bookings>$max_available) $max_available=$event_user_bookings;
					}
					if ($max_available<0) {
						$min_available=0;
						$max_available=0;
					}
					// DEBUG: echo $max_available."|".$event_all_bookings."-".$event_user_bookings."<br>";
					// event disabled or booked out and user has already X reserved.
					if ($event_user_bookings > 0 && $e['availability']>0 && ($e['disable']=='true' || $etype['showremaining']=='true' ||
							(($e['availability']-$event_all_bookings)<=$e['maxnumber'] && $e['availability']>0))) {
						$eventinformation = "<span class=\"fontother font10\">".ct('S_PARTICIPATE_EVENT_RESERVED', array($event_user_bookings, $e['availability'] - ($event_all_bookings-$event_user_bookings)))."</span><br>".$eventinformation;
					}

					// Event disabled but admin? Add message!
					if ($e['disable']=='true' || (($event_all_bookings-$event_user_bookings)>=$e['availability'] && $e['availability']>0)) {
						$eventinformation = "<span class=\"fontnegative fontbold font10\">".ct('S_PARTICIPATE_EVENT_DISABLED')."</span><br>".$eventinformation;
					} elseif ($e['availability']>0 &&
							($etype['showremaining']=='true' || ($e['availability']-$event_all_bookings)<=$e['maxnumber'])) {
						$eventinformation = "<span class=\"fontnegative font10\">".ct('S_PARTICIPATE_EVENT_REMAINING',array($e['availability'] - ($event_all_bookings-$event_user_bookings)))."</span><br>".$eventinformation;
					}
					if ($e['style']=='hidden') {// hidden: add info for admin
						$eventinformation = "<span class=\"fontnegative fontbold font10\">".ct('S_ADMIN_TOOL_EVENTS_STYLE_HIDDEN')." ".ct('S_PARTICIPATE_EVENT_FORNORMAL')."</span><br>".$eventinformation;
					}
					if ($etype['negative']=='disabled' && $fee<0) { // disabled: add info for admin
						$eventinformation = "<span class=\"fontnegative fontbold font10\">".ct('S_PARTICIPATE_EVENT_UNAVAILABLE')." ".ct('S_PARTICIPATE_EVENT_FORNORMAL')."</span><br>".$eventinformation;
					} elseif ($etype['negative']=='hidden' && $fee<0) {// hidden: add info for admin
						$eventinformation = "<span class=\"fontnegative fontbold font10\">".ct('S_PARTICIPATE_EVENT_HIDDEN')." ".ct('S_PARTICIPATE_EVENT_FORNORMAL')."</span><br>".$eventinformation;
					}

					// Create choice interface element for this element according to the
					// 1.) mode of this event type and the
					// 2.) min and max settings of the event (and the default value...)

					// Pre-Selection of this event
					$selected = 0;
					if($eventselected) { // event was already selected or not?
						// use previous selection
						$selected = $this->eventdata_number[$e['ID']];
					} else {
						// select default if checkboxes or none was selected before...
						if ($fee>=0 || $etype['negative']=='normal') // hide/disable events with negative prices?
							$selected = $e['defaultnumber']; // use default
						else
							$selected = 0;
					}

					#### NOW ADD FORM ELEMENT FOR EVENT ###################################

					// Create array for selectboxes
					$numbers = array();
					for ($n=$min_available;$n <= $max_available; $n++) { $numbers[] = array ($n,$n); }
					// ###  Normal group
					// All events have their independent settings
					if ($etype['mode']!='exclusive' && $etype['mode']!='joint') {
						// Case 1: A selected choice-box that cannot be deselected as min and max are 1
						if (($e['minnumber']==1 && $e['maxnumber']==1 && $selected==1) && // Normally show pre-selected radio button...
								  !($fee<0 && $etype['negative']!='normal' && ($user->is_admin() || $user->is_assistant() ))) {// hide/disable events with negative prices: This may be unchecked by admin
							$this->form->add_radio_3col(stripslashes($e[ctlx($e,'title')]),'form_event_'.$e['ID'].'_number', array(array('1','','')), '1', $fee_formatted, $eventinformation);
						}
						// Case 2: A choice-box as 0 or 1 of this event can be selected (and selected is 0 or 1)
						elseif ($e['maxnumber']==1) {
							$this->form->add_check_3col(stripslashes($e[ctlx($e,'title')]),array(array('form_event_'.$e['ID'].'_number', '1', '', ($selected>=1)?'1':'0', '')),$fee_formatted, $eventinformation, $unit );
						}
						// Case 3: 0 to n can be selected: Use a selectbox.
						else{
							$this->form->add_select_3col(stripslashes($e[ctlx($e,'title')]),'form_event_'.$e['ID'].'_number',1, $numbers, array($selected), false, $eventinformation, $fee_formatted, $unit );
						}
					}

					// ### Exclusive group
					// Exclusive: Only one of this event type (group) can be selected.
					// Do not consider min and max values and consider only the first
					// Event that has a default of 1 (as only one may be pre-selected!
					elseif ($etype['mode']=='exclusive') {
						if ($etypehelper>0) $selected=0;    // There was already a selection in this group!
						$this->form->add_radio_3col(stripslashes($e[ctlx($e,'title')]),'form_eventtype_'.$etype['ID'].'_exclusive',array(array('form_event_'.$e['ID'].'_number','','')),($selected >= 1) ? 'form_event_'.$e['ID'].'_number' : '', $fee_formatted, $eventinformation);
						if ($selected!=0) $etypehelper++;   // note that one radio element was already selected
					}

					// ### Joint Group
					// Joint: Add a choice-box or a select field only for the first of this group. All other will
					// have the same selection. This may be used e.g. if positions have to be split on the
					// invoice (for instance if they have different V.A.T.-Rates
					elseif ($etype['mode']=='joint') {
						if ($etypehelper==0) { // first of this group: show select-options
							// Case 1: A selected choice-box that cannot be deselected as min and max are 1
							if ($e['minnumber']==1 && $e['maxnumber']==1 && $selected==1){
								$this->form->add_radio_3col(stripslashes($e[ctlx($e,'title')]),'form_eventtype_'.$etype['ID'].'_joint', array(array('1','','')), '1', $fee_formatted, $eventinformation);
							}
							// Case 2: A choice-box as 0 or 1 of this event can be selected (and selected is 0 or 1)
							elseif ($e['maxnumber']==1) {
								#$this->form->add_check_3col($e[ctlx($e,'title')],array(array('form_eventtype_'.$etype['ID'].'_joint', '1', '', ($selected>=1)?'1':'0', '')),$fee_formatted, $eventinformation, $unit);
								// Checkbox as checkbox led to errors...!
								$this->form->add_select_3col(stripslashes($e[ctlx($e,'title')]),'form_eventtype_'.$etype['ID'].'_joint',1, $numbers, array($selected), false, $eventinformation, $fee_formatted );
							}
							// Case 3: 0 to n can be selected: Use a selectbox.
							else{
								$this->form->add_select_3col(stripslashes($e[ctlx($e,'title')]),'form_eventtype_'.$etype['ID'].'_joint',1, $numbers, array($selected), false, $eventinformation, $fee_formatted );
							}
							$etypehelper++;   // note that the first was already display
						} else {
							$this->form->add_label_3col(stripslashes($e[ctlx($e,'title')]), "<span class=\"fontother font10\">".ct('S_PARTICIPATE_EVENT_JOINT')."</span><br>", $eventinformation, $fee_formatted, 'form_event_'.$e['ID'].'_number');
						}
					}
					// ----------------------------------------------------------------

					// ### Date entry ----------------
					// Date entry box(es) needed?
					if ($e['datemode']!='false') {
						$dates = array();
						$dates[] = array(0, ct('S_PARTICIPATE_EVENT_PLEASESELECT')."&nbsp;&nbsp;");
						$start = ct_datetime_2_timestamp($e['start']);
						$end   = ct_datetime_2_timestamp($e['end']);
						// set default values ----
						//$defaultstart=array($start);
						$defaultstart=array(0);
						if ($eventselected)
							$defaultstart=array($this->eventdata_start[$e['ID']]);
						//$defaultend=array($end);
						$defaultend=array(0);
						if ($eventselected)
							$defaultend=array($this->eventdata_end[$e['ID']]);
						// create array with values ---
						for ($n=$start; $n <= $end; $n=$n+(24*60*60)) {
							$dates[] = array ($n,ct_date_format($n));
						}
						if ($e['datemode']=="selectday") {  // 'false','selectday','selectspan','perdiem','pernight'
							$this->form->add_select_3col_right(ct('S_PARTICIPATE_EVENT_DATE'),'form_event_'.$e['ID'].'_start', 1, $dates, $defaultstart );
						}
						if ($e['datemode']=="selectspan" || $e['datemode']=="perdiem" || $e['datemode']=="pernight") {  // 'false','selectday','selectspan','perdiem','pernight'
							#$this->form->add_select_3col_right(ct('S_PARTICIPATE_EVENT_BEGIN'),'form_event_'.$e['ID'].'_start', 1, $dates, $defaultstart );
							#$this->form->add_select_3col_right(ct('S_PARTICIPATE_EVENT_END'),'form_event_'.$e['ID'].'_end', 1, $dates, $defaultend );
							$this->form->add_select_3col_right_double(ct('S_PARTICIPATE_EVENT_DATES'),'form_event_'.$e['ID'].'_start','form_event_'.$e['ID'].'_end', $dates, $dates, $defaultstart, $defaultend, ct('S_PARTICIPATE_EVENT_TO') );
						}
					}

					// ### Text entry box (field or area) needed?
					if ($e['hastext']!="false") {
						$defaulttext="";
						if ($eventselected)
							$defaulttext=$this->eventdata_text[$e['ID']];
						if ($e['hastext']=="textfield") $this->form->add_text_3col_right(stripslashes($e[ctlx($e,'texthint')]),'form_event_'.$e['ID'].'_text', $defaulttext, 40, 255 );
						elseif ($e['hastext']=="textarea") $this->form->add_textarea_3col_right(stripslashes($e[ctlx($e,'texthint')]),'form_event_'.$e['ID'].'_text', $defaulttext, 40, 3 );
					}
					// $this->form->add_text_3col_right("Discount",'form_event_'.$e['ID'].'_discount', ct_number_format($e['discount'],1), 3, 6 , false ,"%");

				// ### Different hidden and disabled fields.
				} elseif ( $e['style']=='hidden' ) { // hidden - event not visible
					if ($this->person==null || !is_object($this->person) || !$this->person->is_participant() ) { // if user is not yet registered, do not keep this data!
						#if ($this->eventdata_number[$e['ID']]>0) $this->form->add_hidden(array( array('form_event_'.$e['ID'].'_number',$this->eventdata_number[$e['ID']])));
						if ($this->eventdata_number[$e['ID']]>0) $this->form->add_hidden(array( array('form_event_'.$e['ID'].'_number',0)));
					}
					if ($this->eventdata_start[$e['ID']]>0)  $this->form->add_hidden(array( array('form_event_'.$e['ID'].'_start',$this->eventdata_start[$e['ID']])));
					if ($this->eventdata_end[$e['ID']]>0)    $this->form->add_hidden(array( array('form_event_'.$e['ID'].'_end',$this->eventdata_end[$e['ID']])));
					if ($this->eventdata_text[$e['ID']]!="") $this->form->add_hidden(array( array('form_event_'.$e['ID'].'_text',$this->eventdata_text[$e['ID']])));
				} elseif ( $fee<0 && ($etype['negative']=='disabled' || $etype['negative']=='hidden')) { // negative price - deactivated or hidden for this group...
					if ($etype['negative']=='disabled') // just disabled: Show info
						$this->form->add_label_3col($e[ctlx($e,'title')], "<span class=\"fontnegative fontbold font10\">".ct('S_PARTICIPATE_EVENT_UNAVAILABLE')."</span><br>", $eventinformation, '', 'form_event_'.$e['ID'].'_number' );
					if ($this->person==null || !is_object($this->person) || !$this->person->is_participant() ) { // if user is not yet registered, do not keep this data!
						if ($this->eventdata_number[$e['ID']]>0) $this->form->add_hidden(array( array('form_event_'.$e['ID'].'_number',0)));
					}
					if ($this->eventdata_start[$e['ID']]>0)  $this->form->add_hidden(array( array('form_event_'.$e['ID'].'_start',$this->eventdata_start[$e['ID']])));
					if ($this->eventdata_end[$e['ID']]>0)    $this->form->add_hidden(array( array('form_event_'.$e['ID'].'_end',$this->eventdata_end[$e['ID']])));
					if ($this->eventdata_text[$e['ID']]!="") $this->form->add_hidden(array( array('form_event_'.$e['ID'].'_text',$this->eventdata_text[$e['ID']])));
				} else { // deactivated event, booked out event.
					$this->form->add_label_3col($e[ctlx($e,'title')], "<span class=\"fontnegative fontbold font10\">".ct('S_PARTICIPATE_EVENT_DISABLED')."</span><br>", $eventinformation, $fee_formatted, 'form_event_'.$e['ID'].'_number' );
					if ($this->person==null || !is_object($this->person) || !$this->person->is_participant() ) { // if user is not registered or registers again, do not keep this data!
						if ($this->eventdata_number[$e['ID']]>0) $this->form->add_hidden(array( array('form_event_'.$e['ID'].'_number',0)));
					}
					if ($this->eventdata_start[$e['ID']]>0)  $this->form->add_hidden(array( array('form_event_'.$e['ID'].'_start',$this->eventdata_start[$e['ID']])));
					if ($this->eventdata_end[$e['ID']]>0)    $this->form->add_hidden(array( array('form_event_'.$e['ID'].'_end',$this->eventdata_end[$e['ID']])));
					if ($this->eventdata_text[$e['ID']]!="") $this->form->add_hidden(array( array('form_event_'.$e['ID'].'_text',$this->eventdata_text[$e['ID']])));
				}

				// ### Add extra spacer elements
				if ($e['style']=='spacer') {// event-style: spacer: add spacer
					$this->form->add_spacer();
				}
				if ($e['style']=='spacer2') {// event-style: spacer: add spacer
					$this->form->add_spacer2();
				}
			}
		}
	}

	/**
	 * Extra details for this payment, discount and in future also extra events...
	 *
	 */
	function _get_form_discount_extra() {
		global $session;
		$user =& $session->get_user();
		// Discount?
		if ($session->loggedin() && ($user->is_admin() || $user->is_assistant())) { // discounts possible?
			$this->form->add_separator(ct('S_PARTICIPATE_DISCOUNT').' ('.ct('S_PARTICIPATE_PAYMENT_ONLYADMIN').')');
			$this->form->add_text(ct('S_PARTICIPATE_DISCOUNT'),'form_discount',ct_number_format($this->get('discount'),1), 4, 6, false, '%');
		}
	}

	// show form for billing address.
	function _get_form_billingaddress() {
		global $session;
		$user =& $session->get_user();

		$this->form->add_separator(ct('S_PARTICIPATE_BILLINGADDRESS'));
		$this->form->add_radio("*	".ct('S_PARTICIPATE_BILLINGADDRESS_REQUIRED'), 'form_billingaddress', array(
							array('false',ct('S_PARTICIPATE_BILLINGADDRESS_NO')),
							),
							$this->get('billingaddress'));
		$this->_load_persondata();
		$this->form->add_label(ct('S_PARTICIPATE_BILLINGADDRESS_USER'), nl2br($this->person->get_fulladdress()).'<br>'.$this->person->get('email'));
		$this->form->add_subseparator(ct('S_PARTICIPATE_BILLINGADDRESS_OTHER'));
		$this->form->add_radio("*	".ct('S_PARTICIPATE_BILLINGADDRESS_REQUIRED'), 'form_billingaddress', array(
							array('true',ct('S_PARTICIPATE_BILLINGADDRESS_YES'))),
							$this->get('billingaddress'));
		$this->form->add_text(ct('S_USER_ORGANISATION'), 'form_organisation', $this->get('organisation'), 50, 255);
		$this->form->add_radio("*	".ct('S_USER_GENDER'), 'form_gender', array(
							array('2',ct('S_USER_GENDER_FEMALE')),
							array('1',ct('S_USER_GENDER_MALE')),
							array('3',ct('S_USER_GENDER_DR')),
							array('4',ct('S_USER_GENDER_PROF'))),	$this->get('gender'));
		$this->form->add_text("* ".ct('S_USER_FIRSTNAME'), 'form_firstname', $this->get('firstname'),	40,	255);
		$this->form->add_text("* ".ct('S_USER_NAME'),	'form_name', $this->get('name'), 40, 255);
		$this->form->add_text("* ".ct('S_USER_ADDRESS1'),	'form_addr1', $this->get('addr1'), 40, 255);
		$this->form->add_text(ct('S_USER_ADDRESS2'), 'form_addr2', $this->get('addr2'), 40, 255);
		$this->form->add_text("* ".ct('S_USER_ZIPCODE'), 'form_zip', $this->get('zip'), 10, 10);
		$this->form->add_text("* ".ct('S_USER_CITY'),	'form_city', $this->get('city'), 40, 255);
		ct_load_lib('address.lib');
		$states	= ct_list_states();
		$this->form->add_select( ct('S_USER_STATE'),'form_state',1, $states, array($this->get('state')));
		$countries = ct_list_countries();
		$this->form->add_select("* ".ct('S_USER_COUNTRY'),'form_country',1, $countries, array($this->get('country')), false, (strlen($this->get('country'))>2)?"<br>(".$this->get('country').")":"" );
		$this->form->add_text(ct('S_USER_PHONE'),	'form_phone', $this->get('phone'), 40, 255);
		$this->form->add_text(ct('S_USER_FAX'), 'form_fax', $this->get('fax'), 40, 255);
		$this->form->add_text("* ".ct('S_USER_EMAIL'), 'form_email', $this->get('email'),	50,	255);
	}

	function _get_form_paymode(){
		global $session;
		$user =& $session->get_user();

		//## payment
		if (ctconf_get('payment/enabled')=='true') {
			$this->form->add_separator(ct('S_PARTICIPATE_PAYMENT_INTRO'));
			// Payment options...
			$payment_modes = array();
			if ($session->loggedin() && ($user->is_admin() || $user->is_assistant())) { // free registration possible?
				$payment_modes[] =  array('free','<span class="fontpositive fontbold font10">'.ct('S_PARTICIPATE_PAYMENT_FREE').'</span> <span class="fontnegative font10">('.ct('S_PARTICIPATE_PAYMENT_ONLYADMIN').')</span>');
			}
			if (ctconf_get('paymentTransfer')) { // Transfer enabled?
				$payment_modes[] = array('transfer',ct('S_PARTICIPATE_PAYMENT_TRANSFER'));
			}
			if (ctconf_get('paymentCash')) { // Cash enabled?
				$payment_modes[] = array('cash',ct('S_PARTICIPATE_PAYMENT_CASH'));
			}
			if (ctconf_get('paymentCheque')) { // Cheque enabled?
				$payment_modes[] = array('cheque',ct('S_PARTICIPATE_PAYMENT_CHEQUE'));
			}
			if (ctconf_get('paymentExtra1')) { // Extra Payment Mode 1
				$payment_modes[] = array('extra1',ct('S_PARTICIPATE_PAYMENT_EXTRA1'));
			}
			if (ctconf_get('paymentExtra2')) { // Extra Payment Mode 2
				$payment_modes[] = array('extra2',ct('S_PARTICIPATE_PAYMENT_EXTRA2'));
			}
			if (ctconf_get('paymentExtra3')) { // Extra Payment Mode 3
				$payment_modes[] = array('extra3',ct('S_PARTICIPATE_PAYMENT_EXTRA3'));
			}
			if (ctconf_get('paymentPaypal')) { // Paypal enabled?
				$payment_modes[] = array('paypal',ct('S_PARTICIPATE_PAYMENT_PAYPAL').'<br>'.ct('S_PARTICIPATE_PAYMENT_PAYPAL_HINT'));
			}
			$this->form->add_radio("*&nbsp;".ct('S_PARTICIPATE_PAYMETHOD'),'form_paymethod', $payment_modes ,$this->get('paymethod'));

			if (ctconf_get('paymentFax')) { // Fax Payment (Credit Card) Information?
				$cctypes = str_replace(',','<li>',ctconf_get('paymentCreditCardTypes'));
				$this->form->add_radio('','form_paymethod', array(array('fax',ct('S_PARTICIPATE_PAYMENT_FAX'),'<em>'.ct('S_PARTICIPATE_PAYMENT_FAX_INFO').':</em><ul><li>'.$cctypes.'</ul>')) ,$this->get('paymethod'));
			}

			if (ctconf_get('paymentCreditCardExternal')) { // external credit card processor?
				$cctypes = str_replace(',','<li>',ctconf_get('paymentCreditCardTypes'));
				$this->form->add_radio('','form_paymethod', array(array('ccexternal',ct('S_PARTICIPATE_PAYMENT_CCEXTERNAL'),'<em>'.ct('S_PARTICIPATE_PAYMENT_CCEXTERNAL_INFO').':</em><ul><li>'.$cctypes.'</ul>')) ,$this->get('paymethod'));
			} 
			
			elseif (ctconf_get('paymentCreditCard') || ctconf_get('paymentCreditCardUsePayflow')) { // Credit Card enabled?
				#$this->form->add_spacer();
				$this->form->add_radio('','form_paymethod', array(array('cc',ct('S_PARTICIPATE_PAYMENT_CC').' '.ct('S_PARTICIPATE_PAYMENT_CC_INFO'))) ,$this->get('paymethod'));

				$this->form->add_spacer();
				$cctypes = array(array('',ct('S_PARTICIPATE_EVENT_PLEASESELECT')));
				$cctypes_array = ct_csv_explode(ctconf_get('paymentCreditCardTypes'));
				foreach ($cctypes_array as $c) $cctypes[] = array($c,$c);
				$this->form->add_select("* ".ct('S_PARTICIPATE_CCTYPE'), 'form_cctype', 1, $cctypes, array($this->get('cctype')), false);
				$this->form->add_text("* ".ct('S_PARTICIPATE_CCNUMBER'),'form_ccnumber',$this->get('ccnumber'), 20, 20);
				if (ctconf_get('paymentCreditCardUseCVC',1))	// enter CVC?
					$this->form->add_text("* ".ct('S_PARTICIPATE_CCVC'),'form_ccvc',$this->get('ccvc'), 4, 4, false, '<br><a href="'.ct_pageurl('ccvc').'" target="_blank"><img src="images/ccvc.jpg" border=0 align="right">'.ct('S_PARTICIPATE_CCVC_INFO').'</a>');

				// enter Start Date and Issue Number?
				if (ctconf_get('paymentCreditCardUseIssueNo',0)) {	
					// Issue No
					$this->form->add_text(ct('S_PARTICIPATE_CCISSUENO'),'form_ccissueno',$this->get('ccissueno'), 4, 4, false, '<br>'.ct('S_PARTICIPATE_CCISSUE_HINT'));
					// validity start date
					$ccissuedate = explode('-',$this->pdata['ccissuedate']);
					$ccissuedate_month = $ccissuedate[0];
					$ccissuedate_year  = $ccissuedate[1];
					$this->form->add_date(ct('S_PARTICIPATE_CCISSUEDATE'),'form_ccissuedate','',array($ccissuedate_year,$ccissuedate_month));
				}
					
				$ccexpdate = explode('-',$this->pdata['ccexpdate']);
				$ccexpdate_month = $ccexpdate[0];
				$ccexpdate_year  = $ccexpdate[1];
				$this->form->add_date("* ".ct('S_PARTICIPATE_CCEXPDATE'),'form_ccexpdate','',array($ccexpdate_year,$ccexpdate_month));

				$this->form->add_text("* ".ct('S_PARTICIPATE_CCHOLDER'),'form_ccholder',$this->get('ccholder'), 20, 32);

				// => Optional address of cc-owner...
				if (ctconf_get('paymentCreditCardUseAddress',0)) {	//
					// now show form for address...
					#$this->form->add_spacer2();
					$this->form->add_label("<i>".ct('S_PARTICIPATE_CCADDRESS')."</i>", "<i>".ct('S_PARTICIPATE_CCADDRESS_HINT')."</i>");
					$this->form->add_text("* ".ct('S_PARTICIPATE_CCSTREETPO'),	'form_ccaddress', $this->get('ccaddress'), 40, 120);	# Pro: Address of CC-Holder. Here only one line: street of credit card holder (len: 120)
					$this->form->add_text("* ".ct('S_USER_CITY'),	'form_cccity', $this->get('cccity'), 40, 32);	# City (len: 32)
					$this->form->add_text("* ".ct('S_PARTICIPATE_CCZIPCODE'), 'form_cczip', $this->get('cczip'), 10, 10);	# ZIP-Code (len: 15)
					ct_load_lib('address.lib');
					$states	= ct_list_states();
					$this->form->add_select( ct('S_USER_STATE'),'form_ccstate',1, $states, array($this->get('ccstate')));	# State-Code (len: 20)
					$countries = ct_list_countries();
					$this->form->add_select("* ".ct('S_USER_COUNTRY'),'form_cccountry',1, $countries, array($this->get('cccountry')) );	# Country (len: 32)
					$this->form->add_text("* ".ct('S_PARTICIPATE_CCEMAIL'), 'form_ccemail', $this->get('ccemail'),	50,	255);	# e-mail Addresse (len: 40)
				}
			}
		} else {
			// No payment -> all for free
			$this->form->add_hidden(array( array('form_paymethod',"free")));
		}
	}

	function _get_form_remark(){
		global $session;
		$user =& $session->get_user();

		//## remark
		$this->form->add_separator(ct('S_PARTICIPATE_REMARK_SECTION'));
		$this->form->add_textarea(ct('S_PARTICIPATE_EXTERNALREMARK'), 'form_externalremark', $this->get('externalremark'), 50,5);
	}


	// Get form data for administrator part
	function _get_form_adminpart(){
		global $session;
		$user =& $session->get_user();
		if ($session->loggedin() && $user->is_admin()) {
			$this->form->add_separator(ct('S_USER_ADMINSECTION').' ('.ct('S_PARTICIPATE_PAYMENT_ONLYADMIN').')');
			$this->form->add_text(ct('S_INVOICE_INVOICENUMBER'), 'form_invoiceNo', $this->get('invoiceNo'), 16, 32);

			($this->get('invoice')=='true') ? $sel='true' : $sel='';
			$invoicelink="<a target=_blank href=\"".ct_pageurl('adminParticipantsInvoice', array('form_userID' => $this->pdata['personID'],'print' =>'yes'))."\">".ct('S_ADMIN_PARTICIPANTS_ACTION_INVOICE')."</a>";
			$this->form->add_check(ct('S_PARTICIPATE_INVOICE'),array(array('form_invoice','true',ct('S_PARTICIPATE_INVOICE_SEND'),$sel,$invoicelink)));

			if ($this->get('invoicedate')=='0000-00-00 00:00:00' || $this->get('invoicedate')==0){
				$invoicedate_day=date("d",ct_time());
				$invoicedate_month=date("m",ct_time());
				$invoicedate_year=date("Y",ct_time());
			} else {
				$invdate = explode(' ',$this->pdata['invoicedate']);
				$invdate = explode ('-',$invdate[0]);
				$invoicedate_day=$invdate[2];
				$invoicedate_month=$invdate[1];
				$invoicedate_year=$invdate[0];
			}
			$this->form->add_date(ct('S_PARTICIPATE_INVOICEDATE'),'form_invoicedate','true',array($invoicedate_year,$invoicedate_month,$invoicedate_day));
			$this->form->add_text(ct('S_INVOICE_REFERENCE'), 'form_reference', $this->get('reference'), 32, 255);

			$this->form->add_textarea(ct('S_PARTICIPATE_INTERNALREMARK'), 'form_internalremark', $this->get('internalremark'), 50, 6);
		}
	}

	// show info for registration desk (arriced, confirmed, onlist etc.)
	function _get_form_frontdeskpart(){
		global $session;
		$user =& $session->get_user();
		if ($session->loggedin() && ($user->is_admin() || $user->is_assistant() || $user->is_frontdesk())) {
			$this->form->add_separator(ct('S_USER_FRONTDESKSECTION'));
			$this->form->add_check(ct('S_USER_FRONTDESK'), array(
			array( 'form_frontdesk_arrived', 'arrived', ct('S_USER_FRONTDESK_ARRIVED'), $this->is_arrived()),
			array( 'form_frontdesk_confirmed', 'confirmed', ct('S_USER_FRONTDESK_CONFIRMED'), $this->is_confirmed()),
			array( 'form_frontdesk_onlist', 'onlist', ct('S_USER_FRONTDESK_ONLIST'), $this->is_onlist()) ));
		}
	}

	// shows participant confirmation of registration terms field!
	function _get_form_confirmation(){
		global $db,$session;
		if (ctconf_get('registrationTerms',ctconf_get('participation/confirmation'))) {
			$this->form->add_separator(ct('S_PARTICIPATION_TERMS_SECTION'));
			$this->form->add_label(ct('S_PARTICIPATION_TERMS_TITLE'),ct('S_PARTICIPATION_REGISTRATIONTERMS'));
			$this->form->add_check("* ".ct('S_PARTICIPATION_CONFIRM_TITLE'),array(array('form_participant_confirmation','1',ct('S_PARTICIPATION_CONFIRM'),0)));
		} else {
			$this->form->add_hidden(array(array('form_participant_confirmation', '1')));
		}
	}




	// ### B) Form Processing functions ##########################################
	// ###########################################################################


	// Process page 1 data (Status and Member ID)
	function process_form_status(){
		global $http;
		$this->errors = array();
		$this->_process_form_status();
		return $this->errors;
	}

	/**
	 * get form data for events / products. Check data.
	 */
	function process_form_events(){
		global $http;

		$this->errors = array();

		// Process data
		$this->_process_form_events();
		$this->_test_eventdata();

		$this->_process_form_discount_extra();
		$this->_process_form_remarks();

		$this->_calculate_fee();	// Now the fee can be calculated.

		return $this->errors;
	}

	/**
	 * Extra test if event data is OK (not booked out, dates are not missing and in correct order)
	 *
	 * @return error fields
	 */
	function test_eventdata() {
		$this->errors = array();
		$this->_test_eventdata();
		return $this->errors;
	}

	/**
	 * get form data from page for billing data and payment mode
	 */
	function process_form_billing(){
		global $http;

		$this->errors = array();

		// Process data
		$this->_process_form_billingaddress();

		$this->_process_form_payment();
		$this->_check_form_payment();

		$this->_process_form_remarks();

		return $this->errors;
	}


	/**
	 * check if selected events are still available
	 */
	function check_event_availability() {
		ct_load_lib('participation.lib');

		$this->errors = array();
		$events=ct_get_events();
		foreach ($events as $e){
			// finally check and save selected number
			if ($e['availability'] > 0 &&
					$this->eventdata_number[$e['ID']] > ($e['availability'] - ($event_all_bookings - $event_user_bookings)) &&
					$this->eventdata_number[$e['ID']] > $event_user_bookings)
				$this->errors[] = 'form_event_'.$e['ID'].'_number';
		}
		return $this->errors;
	}


	// Process last (confirmation) page.
	function process_form_confirmation(){
		global $http;
		$this->errors = array();
		if (!in_http('form_participant_confirmation') || $http['form_participant_confirmation'] != "1")
			$this->errors[] = 'form_participant_confirmation';
		return $this->errors;
	}

	// save data from admin page
	function process_form_admin(){
		global $http;

		$this->errors = array();
		// undelete participant!
		$this->set('deleted',0);

		// Process data
		$this->_process_form_status();
		$this->_process_form_events();
		$this->_test_eventdata();
		$this->_process_form_discount_extra();

		$this->_process_form_billingaddress();
		$this->_process_form_payment();
		#$this->_check_form_payment(); # Do NOT check for Admins, otherwise he may not change registration details
		$this->_process_form_remarks();

		$this->_process_form_adminpart();
		$this->_process_form_frontdeskpart();

		return $this->errors;
	}

	// save data after user edited his own data...
	function process_form_useredit(){
		global $http;

		$this->errors = array();

		// Process data
		$this->_process_form_events();
		$this->_test_eventdata();

		$this->_process_form_billingaddress();
		$this->_process_form_payment();
		$this->_check_form_payment();
		$this->_process_form_remarks();
		return $this->errors;
	}


	// Now the sub-methods to process the form data...
	// -----------------------------------------------------


	/**
	 * Check if user entered the required data...
	 */
	function _require($field, $name) {
		global $http;
		if (isset($http[$name]) && ($http[$name] != "")) {
			$this->set($field, $http[$name]);
			return true;
		} else {
			if (isset($http[$name])) {
				$this->set($field, '');
			}
			$this->errors[] = $name;
			return false;
		}
	}

	/**
	 * calculates how many places are already booked
	 *
	 * @param int $eventID ID of the event
	 * @return number booked by all users
	 */
	function _event_all_bookings($eventID){
		global $db;
		$query = 'select sum(number) as bookings ';
		$query .=  ' from participants2events ';
		$query .=  ' where eventID="'.$eventID.'"';
		$query .=  ' AND deleted=0';
		$r = $db->query($query);
		if ($r && ($db->num_rows($r) == 1)) {
			$p = $db->fetch($r);
			return $p['bookings'];
		}
		return 0;
	}

	/**
	 * calculates how many places a person has already booked
	 *
	 * @param int $eventID ID of the event
	 * @return number booked by user
	 */
	function _event_user_bookings($eventID){
		global $db;
		$query = 'select number ';
		$query .=  ' from participants2events ';
		$query .=  ' where eventID="'.$eventID.'"';
		$query .=  ' AND personID="'.$this->get('personID').'"';
		$query .=  ' AND deleted=0';
		$r = $db->query($query);
		if ($r && ($db->num_rows($r) == 1)) {
			$p = $db->fetch($r);
			return $p['number'];
		}
		return 0;
	}


	/**
	 * Process data of step1: Participant Status
	 */
	function _process_form_status() {
		global $http;
		$this->_require('status', 'form_status');
		$this->set('memberID', $http['form_memberID']);
		$rx = $this->_get_status_regexpression($http['form_status']);
		if ($rx!="" && !preg_match("/".$rx."/",$http['form_memberID']))
			$this->errors[] = 'form_memberID';
			
		// Process and store extra options if they are available...
		if (ct_test_lib('participation_extraoption.lib')) {	// if extra selection exisits
			ct_load_lib('participation_extraoption.lib');
			if (function_exists('pse_process_form_status_extraoptions')) { 
				pse_process_form_status_extraoptions($this);
			}
		}
			
	}

	/**
	 * Process admin part of page
	 */
	function _process_form_adminpart(){
		global $http;

		//registration set in separate fields
		if ($http['form_regdate_day'] > 0 && $http['form_regdate_year'] > 0) {
			$http['form_regdate'] = $http['form_regdate_year']."-".$http['form_regdate_month']."-".$http['form_regdate_day']." ".$http['form_regdate_hour'].":".$http['form_regdate_minute'].":".$http['form_regdate_second'];
		}
		// no registrtion date set
		if ($http['form_regdate']=='0000-00-00 00:00:00' || !isset($http['form_regdate']) ){
			$http['form_regdate']=ct_timestamp_2_datetime(ct_time());
		}
		$this->set('regdate',$http['form_regdate']);

		if ($http['form_invoice'] == 'true'){
			$this->set('invoicedate',date("Y-m-d H:i:s",mktime(0,0,0,$http['form_invoicedate_month'],$http['form_invoicedate_day'],$http['form_invoicedate_year'])));
			$this->set('invoice','true');
		}
		else{
			$this->set('invoicedate','0000-00-00 00:00:00');
			$this->set('invoice','false');
		}
		$this->set('invoiceNo',$http['form_invoiceNo']);
		$this->set('reference',$http['form_reference']);
		$this->set('internalremark', $http['form_internalremark']);
	}


	/**
	 * Frontdesk form functions.
	 */
	function _process_form_frontdeskpart() {
		global $http;
		// set frontdesk status
		$stat = array();
		if (isset($http['form_frontdesk_arrived'])) { $stat[] = 'arrived'; }
		if (isset($http['form_frontdesk_confirmed'])) { $stat[] = 'confirmed'; }
		if (isset($http['form_frontdesk_onlist'])) { $stat[] = 'onlist'; }
		$this->set('frontdesk', implode($stat, ','));
	}

	/**
	 * form processing function for all events of the event selection page...
	 */
	function _process_form_events() {
		global $http, $session;
		ct_load_lib('participation.lib');

		$user =& $session->get_user();

		// delete old event data
		$this->eventdata_number = array();

		// evaluate grouped eventtype data
		$etypes = ct_get_eventtypes();
		foreach ($etypes as $etype){
			// Exclusive
			if (isset($http['form_eventtype_'.$etype['ID'].'_exclusive'])){
				preg_match("/^form\_event\_([\d]+)\_number$/i", $http['form_eventtype_'.$etype[0].'_exclusive'], $matches);
				$eventnumber = $matches[1];
				$http['form_event_'.$eventnumber.'_number'] = 1;
			}
			// Joint
			if (isset($http['form_eventtype_'.$etype['ID'].'_joint'])){
    			$events = ct_get_events($etype['ID']);
	    		foreach ($events as $e) {
	    			// Even if joint: Hidden and disabled products shall NOT be selected!!
					$event_all_bookings = $this->_event_all_bookings($e['ID']);
					$event_user_bookings = $this->_event_user_bookings($e['ID']);
					$fee=$this->_calculate_singlefee($e['pricecategory'],$this->get('status'),get_timediscountID($this->get('regdate')));
					if (($e['disable']!='true' &&  // Disabled: Show but user cannot select event
							 $e['style']!='hidden' &&  // Hidden: Do not show.
							($fee>=0 || $etype['negative']=='normal') && // hide/disable events with negative prices?
							(($event_all_bookings-$event_user_bookings)<$e['availability'] || $e['availability']<1)))
    					$http['form_event_'.$e['ID'].'_number'] = $http['form_eventtype_'.$etype['ID'].'_joint'];
    				else
    					$http['form_event_'.$e['ID'].'_number'] = 0;
    			}
			}
		}

		//## set eventdata
		$events=ct_get_events();
		foreach ($events as $e){
			// save selected number
			if (isset($http['form_event_'.$e['ID'].'_number']) && $http['form_event_'.$e['ID'].'_number']!=0) {
				$this->eventdata_number[$e['ID']] = $http['form_event_'.$e['ID'].'_number'];
			} else {
				$this->eventdata_number[$e['ID']] = 0 ;
			}
			// save starting date
			if ($e['datemode']!='false' && $this->eventdata_number[$e['ID']]>0 ) {  // Always save the startdate, except for false...
				$this->eventdata_start[$e['ID']] = $http['form_event_'.$e['ID'].'_start'];
			} else {
				$this->eventdata_start[$e['ID']] = 0;
			}
			// save ending date
			if (($e['datemode']=="selectspan" || $e['datemode']=="perdiem" || $e['datemode']=="pernight" ) && $this->eventdata_number[$e['ID']]>0 ) {
				$this->eventdata_end[$e['ID']] = $http['form_event_'.$e['ID'].'_end'];
			} else {
				$this->eventdata_end[$e['ID']] = 0;
			}
			// save text entry box
			if ($e['hastext']!='false' && isset($http['form_event_'.$e['ID'].'_text'])) {
				$this->eventdata_text[$e['ID']] = $http['form_event_'.$e['ID'].'_text'];
			} else {
				$this->eventdata_text[$e['ID']] = "";
			}
		}
		
		if (ct_test_lib('participation_processevents.lib')) {	// if extra form processing exists
			ct_load_lib('participation_processevents.lib');
			if (function_exists('ppe_process_form_events')) { 
				ppe_process_form_events($this);
			}
		}

		
	}


	/**
	 * tests if events are still available
	 */
	function _test_eventdata() {
		global $session;
		ct_load_lib('participation.lib');

		$user =& $session->get_user();

		$events=ct_get_events();
		foreach ($events as $e){
			//  check and selected number
			$event_all_bookings = $this->_event_all_bookings($e['ID']);
			$event_user_bookings = $this->_event_user_bookings($e['ID']);
			if ($this->eventdata_number[$e['ID']]>0 &&
					(!$user->is_admin() && !$user->is_assistant() && $e['availability'] > 0 &&
						$this->eventdata_number[$e['ID']] > ($e['availability'] - ($event_all_bookings - $event_user_bookings)) &&
						$this->eventdata_number[$e['ID']] > $event_user_bookings)) {
				$this->errors[] = 'form_event_'.$e['ID'].'_number';
			}

			// check starting date
			if ($e['datemode']!='false' && $this->eventdata_number[$e['ID']]>0 &&
						$this->eventdata_start[$e['ID']] == 0) {
				$this->errors[] = 'form_event_'.$e['ID'].'_number';
				$this->errors[] = 'form_event_'.$e['ID'].'_start';
			}

			// save and check ending date
			if ((($e['datemode']=="selectspan" || $e['datemode']=="perdiem" || $e['datemode']=="pernight" ) && $this->eventdata_number[$e['ID']]>0 ) &&
					(($this->eventdata_end[$e['ID']] < $this->eventdata_start[$e['ID']]) ||
					 ($this->eventdata_end[$e['ID']] == $this->eventdata_start[$e['ID']] && $e['datemode']=="pernight") ||
					 ($this->eventdata_end[$e['ID']] == 0)) )  {
				$this->errors[] = 'form_event_'.$e['ID'].'_number';
				$this->errors[] = 'form_event_'.$e['ID'].'_start';
				$this->errors[] = 'form_event_'.$e['ID'].'_end';
			}
		}
		if (ct_test_lib('participation_processevents.lib')) {	// if extra form processing exists
			ct_load_lib('participation_processevents.lib');
			if (function_exists('ppe_test_form_events')) { 
				ppe_test_form_events($this);
			}
		}
		#echo '<br><pre>'; print_r($this->errors); echo '</pre><br>'; // debugging...
		#echo '<br><pre>'; print_r($this->eventdata_number); echo '</pre><br>'; // debugging...
	}




	// Process billing address
	function _process_form_billingaddress() {
		global $http;
		ct_load_lib('mail.lib');
		if (in_http('form_billingaddress') && $http['form_billingaddress']=='false') {
			$this->set('billingaddress',$http['form_billingaddress']);
		} elseif (in_http('form_billingaddress') && $http['form_billingaddress']=='true') {
			$this->set('billingaddress',$http['form_billingaddress']);
			ct_http_trim(array('organisation','firstname','name','addr1','addr2','city','zip','phone','fax','email'));
			
			$this->set('organisation', $http['form_organisation']);
			$this->_require('gender', 'form_gender');
			$this->_require('firstname', 'form_firstname');
			$this->_require('name', 'form_name');
			$this->_require('addr1', 'form_addr1');
			$this->set('addr2',	$http['form_addr2']);
			$this->_require('city', 'form_city');

			$this->set('country', $http['form_country']);
			if (in_http('form_country') && $http['form_country'] != "-") {
				// Check state:	Some countries need	a state!
				if (in_array($this->get('country'),array('US','CA','AU'))) {
					if	(in_http('form_state')	&& $http['form_state'] != "-")
						$this->set('state',	$http['form_state']);
					else
						$this->errors[]	= 'form_state';
				} else {
					$this->set('state',	'');
				}
				// Check postal	code: Some countries don't need	a postal code.
				if (in_array($this->get('country'),array('IE','HK')) ||
						(in_http('form_zip') && $http['form_zip'] != "")) {
					$this->set('zip', $http['form_zip']);
				} else {
					$this->errors[]	= 'form_zip';
				}
			} else {
				$this->errors[]	= 'form_country';
				$this->_require('zip', 'form_zip');
			}
			$this->set('phone',	$http['form_phone']);
			$this->set('fax', $http['form_fax']);
			if (isset($http['form_email']) && ($http['form_email'] != "")) {
				$this->set('email',	$http['form_email']);
				// Check if	email-adress is	valid. This	function checks	the	syntax and the existance of	the	domain.
				if (!ct_validate_email($this->get('email')))	{
					$this->errors[]	= 'form_email';
				}
			} else {
				$this->errors[]	= 'form_email';
			}
		} else {
			$this->errors[]	= 'form_billingaddress';
		}
	}


	// Process payment information and check basic data (that is also required for admin and assistant)
	function _process_form_payment() {
		global $http;
		ct_load_lib('participation.lib');
		$this->_require('paymethod', 'form_paymethod');
		ct_http_trim(array('ccholder','ccnumber','ccvc','ccaddress','cccity','cczip','ccemail'));
		if($http['form_paymethod'] == 'cc'){ // Credit cards need further checks
			if ($http['form_ccnumber']!="" && stristr($http['form_ccnumber'],"X")===FALSE) {
				$http['form_ccnumber'] = ct_format_ccnumber($http['form_ccnumber']);
				if (!ct_check_ccnumber($http['form_ccnumber']))
					$this->errors[] = 'form_ccnumber';

				if (ctconf_get('paymentCreditCardUseCVC',1)) {	// enter CVC?
					$this->_require('ccvc','form_ccvc');
					if (strlen($http['form_ccvc'])<3)
						$this->errors[] = 'form_ccvc';
				}
				$this->_require('ccholder','form_ccholder');
			}
		}
		$this->set('ccholder', $http['form_ccholder']);
		$this->set('cctype', $http['form_cctype']);
		$this->set('ccnumber', $http['form_ccnumber']);
		$this->set('ccexpdate', $http['form_ccexpdate_month']."-".$http['form_ccexpdate_year']);
		if (ctconf_get('paymentCreditCardUseCVC',1)) 	// enter CVC?
			$this->set('ccvc', $http['form_ccvc']);

		if (ctconf_get('paymentCreditCardUseIssueNo',0)) {	// enter issue date and number?
			$this->set('ccissuedate', $http['form_ccissuedate_month']."-".$http['form_ccissuedate_year']);
			$this->set('ccissueno', $http['form_ccissueno']);
		}
			
		if (ctconf_get('paymentCreditCardUseAddress',0)) {	// enter Address?
			$this->set('ccaddress',$http['form_ccaddress']);
			$this->set('cccity',$http['form_cccity']);
			$this->set('cczip',$http['form_cczip']);
			$this->set('ccstate',$http['form_ccstate']);
			$this->set('cccountry',$http['form_cccountry']);
			$this->set('ccemail',$http['form_ccemail']);
		}
	}

	function _process_form_discount_extra() {
		global $session,$http;
		$user =& $session->get_user();
		if ($session->loggedin() && ($user->is_admin() || $user->is_assistant())) { // discounts possible?
			$this->set('discount', ct_number_unformat($http['form_discount']));
		}
	}

	// Process and check payment information (for useredit and step2 of form)
	// check, if all required payment fields are filled out
	function _check_form_payment() {
		global $http;
		ct_load_lib('participation.lib');

		$paymethod = $http['form_paymethod'];

		$this->_calculate_fee(); // calculate fee to see if user did only select free things => no payment method needed!
		if($paymethod == 'transfer' || $paymethod == 'cash' || $paymethod == 'cheque' || 
					$paymethod == 'fax' || $paymethod == 'ccexternal' ||
					$paymethod == 'extra1' || $paymethod == 'extra2' || $paymethod == 'extra3' ||
					$this->fee['total']<=0 )
			return;  // fine, no errors...
		if($paymethod == 'cc'){ // Credit cards need further checks
			$this->_require('cctype','form_cctype');
			$this->_require('ccholder','form_ccholder');

			$http['form_ccnumber'] = ct_format_ccnumber($http['form_ccnumber']);
			$this->_require('ccnumber','form_ccnumber');
			if (!ct_check_ccnumber($http['form_ccnumber']))
				$this->errors[] = 'form_ccnumber';

			// check expiry date.
			$this->set('ccexpdate', $http['form_ccexpdate_month']."-".$http['form_ccexpdate_year']);
			if ($http['form_ccexpdate_year'] < date('Y',ct_time()) || ($http['form_ccexpdate_year'] == date('Y',ct_time()) && $http['form_ccexpdate_month'] < date('n',ct_time()))) {
				$this->errors[] = 'form_ccexpdate';
			}

			// valid from date and issue number
			if (ctconf_get('paymentCreditCardUseIssueNo',0)) {	// enter issue date and number?
				$this->set('ccissuedate', $http['form_ccissuedate_month']."-".$http['form_ccissuedate_year']);
				if ($http['form_ccissuedate_year'] > date('Y',ct_time()) || ($http['form_ccissuedate_year'] == date('Y',ct_time()) && $http['form_ccissuedate_month'] > (date('n',ct_time()))+1)) {
					$this->errors[] = 'form_ccissuedate'; // Not valid, yet?
				}
				$this->set('ccissueno', $http['form_ccissueno']);
			}
			
			// enter CVC?
			if (ctconf_get('paymentCreditCardUseAddress',1)) {
				$this->_require('ccvc','form_ccvc');
				if (strlen(ereg_replace("[^0-9]", "", $http['form_ccvc']))<3)
					$this->errors[] = 'form_ccvc';
			}

			// Check address of credit card
			if (ctconf_get('paymentCreditCardUseAddress',0)) {	// enter CVC?
				$this->_require('ccaddress','form_ccaddress');
				$this->_require('cccity','form_cccity');
				$this->_require('ccemail','form_ccemail');
				#$this->set('ccemail',$http['form_ccemail']);
				if ($this->get('ccemail')!='' && !ct_validate_email($this->get('ccemail')))	{
					$this->errors[]	= 'form_ccemail';
				}
				$this->set('cczip',$http['form_cczip']);
				$this->set('ccstate',$http['form_ccstate']);
				$this->set('cccountry',$http['form_cccountry']);


				$this->set('cccountry', $http['form_cccountry']);
				if (isset($http['form_cccountry']) &&	($http['form_cccountry'] != "") && ($http['form_cccountry']	!= "-")) {
					// Check state:	Some countries need	a state!
					if (in_array($this->get('cccountry'),array('US','CA','AU'))) {
						 if	(in_http('form_ccstate') && $http['form_ccstate'] != "-")
							$this->set('ccstate',	$http['form_ccstate']);
						else
							$this->errors[]	= 'form_ccstate';
					} else {
						$this->set('ccstate', '');
					}
					// Check postal	code: Some countries don't need	a postal code!
					if (in_array($this->get('cccountry'),array('IE','HK')) ||
							(in_http('form_cczip') && $http['form_cczip'] != "")) {
						$this->set('cczip', $http['form_cczip']);
					} else {
						$this->errors[]	= 'form_cczip';
					}
				} else {
					$this->errors[]	= 'form_cccountry';
					$this->_require('cczip','form_cczip');
				}
			}

		}
		$this->_require('paymethod','form_paymethod');
	}

	// Process remark of user
	function _process_form_remarks() {
		global $http;
		$this->set('externalremark', $http['form_externalremark']);
	}

}

?>