<?php
//
// CLASS:		CTPerson
// 				Every user of conftool is a CTPerson. This class has all the basic
//				functions for every user.
//

class CTPerson {

	// holds corresponding row from	persons-database
	var	$pdata = array();

	function CTPerson() {
		$this->_init();
	}

	function _init() {
		$this->pdata = array();
		$this->pdata['ID'] = 0;
	}

	function login($uname, $passwd)	{
		global $db;
		ct_load_lib('person.lib');
		ct_load_lib('password.lib');
		// These strings are already excaped, just for security reasons again!
		$uname = trim(ct_mysql_escape_string(stripslashes($uname)));
		$passwd = trim(ct_mysql_escape_string(stripslashes($passwd)));
		// EMail-Address was entered
		if (preg_match("/^.*@.*\.[a-z]+/i",$uname))	{	// for compatibility only: Previously the email could be used as well for logins (and passwords were not encrypted).
			$query = "select * from persons where deleted=0 and ".
				 "((passwordencrypted=0 and (username='$uname' or email='$uname') and password='$passwd') or ". // query for un-encrypted passwords.
				 " (passwordencrypted=1 and username='$uname' and password='".md5($passwd)."' ) )"; // query for encrypted passwords.
			$r = $db->query($query);
			#echo "<!-- $query -->"; die();

		} else {
			// no email-Address
			$query = "select * from persons where deleted=0 and username='$uname' and ".
				"( ( passwordencrypted=0 and password='$passwd' ) or  ". // query for un-encrypted passwords.
				"  ( passwordencrypted=1 and password='".md5($passwd)."' ) )"; // query for un-encrypted passwords.
			$r = $db->query($query);
		}
		if ($db->num_rows($r) == 1)	{
			$this->pdata = $db->fetch($r);
			$this->pdata['logindate'] =	ct_timestamp_2_datetime(ct_time());  // Save last login...
			$this->pdata['lastactiondate'] = ct_timestamp_2_datetime(ct_time());  // Save last action
			$this->pdata['logoutdate'] = '0000-00-00 00:00:00';
			$this->pdata['loginhost'] = ct_get_client_ip();
			$this->pdata['passwordrequestkey'] = '';  // delete request key - user did obvously log in so his password is recovered.
			$this->persist();
			// Save	Session	key	as password	in identities database for external	Meeting	Mirror
			ct_load_class('CTIdentity');
			$identity	= new CTIdentity;
			if ($identity->load_by_personID($this->get_id()))	{
				$identity->set('password',ct_randString());
				$identity->persist();
			}
			return true;
		} else {
			return false;
		}
	}

	function logout() {
		if ($this->get_id()>0) {
			$this->reload();
			$this->pdata['logoutdate'] = ct_timestamp_2_datetime(ct_time());  // Save logout...
			$this->persist();
			// Delete Session key for external Meeting Mirror
			ct_load_class('CTIdentity');
			$identity	= new CTIdentity;
			if ($identity->load_by_personID($this->get_id()))	{
				$identity->set('password','');
				$identity->persist();
			}
			return true;
		} else {
			return false;
		}
	}


	//## DATABASE FUNCTIONS	##############################################

	// load	person data	from database by id
	function load_by_id($id) {
		global $db;
		$id = (int)$id; // sanitize.
		$r = $db->query("select	* from persons where id='$id'");
		if ($db->num_rows($r) == 1)	{
			$this->pdata = $db->fetch($r);
			return true;
		} else {
			$this->_init();
			if ($id>0) $this->pdata['ID'] = (int)$id;
			return false;
		}
	}

	// load	person data	from database by id
	function load_by_email($email) {
		global $db;
		$r = $db->query("select	* from persons where email='$email'");
		if ($db->num_rows($r) == 1)	{
			$this->pdata = $db->fetch($r);
			return true;
		} else {
			return false;
		}
	}

	// load	person data	from database by id
	function load_by_requestkey($key) {
		global $db;
		$key = trim(ct_mysql_escape_string(stripslashes($key)));
		$r = $db->query("select	* from persons where passwordrequestkey='$key' and deleted=0");
		if ($db->num_rows($r) == 1)	{
			$this->pdata = $db->fetch($r);
			return true;
		} else {
			return false;
		}
	}


	// reload person data from database
	function reload() {
		return $this->load_by_id($this->pdata['ID']);
	}

	// reload person data from database
	function reload_save_useraction() {
		$this->load_by_id($this->pdata['ID']);
		$this->pdata['lastactiondate'] = ct_timestamp_2_datetime(ct_time());  // Save last action
		$this->persist();
	}


	// update data in database from	object
	function persist($doencrypt=true) {
		global $db;

		// if password is still un-encrypted - encrypt it now!
		if ($this->pdata['passwordencrypted']==0 && $doencrypt) {
			$this->pdata['password'] = md5($this->pdata['password']);
			$this->pdata['passwordencrypted']=1;
		}
		if ($this->pdata['ID'] == "" or $this->pdata['ID'] == 0) {
			if (!$this->pdata['username']=="") { //	the	username has to	be set - check to avoid	errors...
				$this->pdata['ID'] = "0";
				$this->pdata['creationdate'] = ct_timestamp_2_datetime(ct_time());
				$this->pdata['deleted']	= "0";
				$this->pdata['logindate'] = '0000-00-00 00:00:00';
				$this->pdata['logoutdate'] = '0000-00-00 00:00:00';
				$this->pdata['lastactiondate'] = '0000-00-00 00:00:00';
				$this->pdata['accounttype'] = 'normal';
				$db->insert_into('persons',	$this->pdata);
				$r = $db->query("select	* from persons where username='".$this->pdata['username']."'");
				if ($db->num_rows($r) == 1)	{
					$this->pdata = $db->fetch($r);
					return true;
				} else {
					return false;
				}
			}
		} else {
			// Do this double check, to make sure the user will have the right options.
			$this->check_author();
			$this->check_coauthor();
			$this->check_participant();
			// Save to database.
			$db->replace_into('persons', $this->pdata);
			return true;
		}
		return false;
	}

	// delete Person
	function delete() {
		global $db;
		if ($this->get_id()!=1 && !$this->is_author() && !$this->is_participant() && $this->count_assigned_reviews()==0) {
			$this->pdata['deleted']	= '1';
			$this->persist();
			return true;
		} else
			return false;
	}

	// undelete	Person
	function undelete()	{
		if ($this->pdata['ID']!="") {
			$this->pdata['deleted']	= '0';
			$this->persist();
			return true;
		} else {
			return false;
		}
	}

	//## ACCESSOR FUNCTIONS	###############################################

	// get a record	field`s	value, fieldname is	key
	function get($key) {
		return isset($this->pdata[$key]) ? $this->pdata[$key] :	'';
	}

	// get a record	field`s	value, with	html special chars converted
	function get_special($key) {
		return ct_form_encode($this->get($key));
	}

	// set a record	field`s	value
	function set($key, $value) {
		$this->pdata[$key] = $value;
	}

	function _check_status($status)	{
		if (isset($this->pdata['status'])) {
			$starr = explode(",", $this->pdata['status']);
			if (in_array($status, $starr))	{
				return true;
			} else {
				return false;
			}
		} else {
			return false;
		}
	}

	/**
	 * quick checks	for user status
	 */
	function is_admin()		{ return $this->_check_status("admin"); }
	function is_chair()		{ return $this->_check_status("chair");	}
	function is_conferenceChair()	{ return $this->_check_status("conferenceChair"); }
	function is_frontdesk()	{ return $this->_check_status('frontdesk'); }
	function is_assistant()	{ return $this->_check_status("assistant");	}

	function is_pc() 	    { return $this->_check_status("pc");	}
	function is_reviewer() 	{ return $this->_check_status("reviewer");	}

	function is_author() 	{ return $this->_check_status("author"); }
	function is_coauthor() 	{ return $this->_check_status("coauthor"); }
	function is_participant() { return $this->_check_status("participant"); }

	/**
	 * Add new Status / Role to user
	 *
	 * @param string $status name of status: admin, chair, conferenceChair, frontdesk, pc, reviewer, author, coauthor, participant
	 */
	function add_status($status) {
		$starr = ct_csv_explode($this->pdata['status']);
		if (!in_array($status, $starr))	{
			array_push($starr, $status);
		}
		$this->pdata['status'] = implode(",", $starr);
	}

	/**
	 * Revoke a status / role from a user
	 *
	 * @param string $status name of the status: admin, chair, conferenceChair, frontdesk, pc, reviewer, author, coauthor, participant
	 */
	function remove_status($status)	{
		$starr = explode(",", $this->pdata['status']);
		if (in_array($status, $starr)) {
			reset($starr);
			while (list($k,$v) = each($starr)) {
				if ($v == $status) {
					unset($starr[$k]);
					break;
				}
			}
		}
		$this->pdata['status'] = implode(",", $starr);
	}

	/**
	 * Check if user is really (still) an author
	 */
	function check_author()	{
		ct_load_lib('papers.lib');
		if (!($this->get_id()>0)) return false;
		$papersexist = ct_papers_exist("personID='".$this->get_id()."'");
		if ($this->is_author() && !$papersexist) {
			$this->remove_status('author');
		}
		if (!$this->is_author()	&& $papersexist) {
			$this->add_status('author');
		}
		return true;
	}


	/**
	 * Check if user is really (still) an coauthor - check by mail address
	 * if a paperID is given the papers of this id will be IGNORED!
	 *
	 * @param int $ignorePaperID the ID of the paper that shall be ignored.
	 */
	function check_coauthor($ignorePaperID=0)	{
		global $db;
		if ($this->get('email')!="") {
			$exclude="";
			if ($ignorePaperID!=0)
				$exclude = " AND p.ID!='$ignorePaperID'";
			$query="select count(DISTINCT(p.ID)) as count from papers as p, emails2papers as e where p.ID=e.paperID and p.withdrawn=0 and (e.email='".$this->get('email')."' or e.email='".$this->get('email2')."') and p.personID!='".$this->get_id()."' ".$exclude;
			$r = $db->query($query);
			if ($r and $db->num_rows($r)==1) {
				$p = $db->fetch($r);
				if ($p['count']>0 && !$this->is_coauthor()) {
					$this->add_status('coauthor');
					return true;
				}
				if ($p['count']==0 && $this->is_coauthor()) {
					$this->remove_status('coauthor');
					return true;
				}
			}
		}
		return false; // status not changed...
	}

	// Check if user is really (still) an participant
	function check_participant()	{
		global $db;
		if ($this->get_id()>0) {
			$query='select count(p.personID) as count from participants as p where p.deleted=0 and p.personID="'.$this->get_id().'"';
			$r = $db->query($query);
			if ($r and $db->num_rows($r)==1) {
				$p = $db->fetch($r);
				if ($p['count']>0) {
					$this->add_status('participant');
				} else {
					$this->remove_status('participant');
				}
			}
			return true;
		} else {
			return false;
		}
	}


	function get_id() {
		return $this->pdata['ID'];
	}

	// Prof. Dr. Peter Smith
	function get_fullname()	{
		// return $this->pdata['name'].", ".$this->pdata['title']."	".$this->pdata['firstname'];
		return trim($this->get_title()." ".$this->pdata['firstname']." ".$this->pdata['name']);
	}

	// P. Smith
	function get_shortname() {
		// return $this->pdata['name'].", ".$this->pdata['title']."	".$this->pdata['firstname'];
		return trim(substr($this->pdata['firstname'],0,1).".	".$this->pdata['name']);
	}

	// Smith, Dr. Peter
	function get_reversename() {
		return trim($this->pdata['name'].", ".$this->get_title()." ".$this->pdata['firstname']);
	}

	/**
	 * Get Title of person, such as Dr. and Prof. Dr.
	 */
	function get_title($gender=0) {
		if ($gender==0) $gender=$this->get('gender');
		switch ($gender) {
			#case 1: return ct('S_USER_GENDER_MALE');
			#case 2: return ct('S_USER_GENDER_FEMALE');
			case 3: return ct('S_USER_GENDER_DR');
			case 4: return ct('S_USER_GENDER_PROF');
		}
		return '';
	}

	/**
	 * Full address for invoices etc.
	 */
	function get_fulladdress() {
		$addr = "";
		$addr .= $this->get_special('organisation')."\n";
		$addr .= $this->get_title()." ".$this->get_special('firstname')." ".$this->get_special('name')."\n";
		$addr .= $this->get_special('addr1')."\n";
		if ($this->get('addr2')!="")
			$addr .= $this->get_special('addr2')."\n";
		ct_load_lib("address.lib");
		$addr .= ct_address_format($this->get_special('country'),$this->get_special('zip'),$this->get_special('state'),$this->get_special('city'));
		$addr .= ct_get_country($this->get_special('country'))."\n";
		return $addr;
	}

	/**
	 * return all papers submitted by this person
	 */
	function get_papers() {
		global $db;

		ct_load_class('CTPaper');
		$papers	= array();
		if ($this->get_id()>0) {
			$r = $db->query("SELECT * FROM papers WHERE withdrawn=0 AND personID='".$this->pdata['ID']."' ORDER BY ID");
			if ($r)	{
				for	($i=0; $i <	$db->num_rows($r); $i++) {
					$p = new CTPaper;
					$p->pdata =	$db->fetch($r);
					$papers[] =	$p;
				}
			}
		}
		return $papers;
	}

	/**
	 * how many	reviews	did this person already submit?
	 */
	function count_submitted_papers() {
		global $db;

		$papers = 0;
		if ($this->get_id()>0) {
			$r = $db->query("select	count(*) as	count from papers where withdrawn=0 and personID=".$this->pdata['ID']);
			if ($r && ($db->num_rows($r) > 0)) {
				$t = $db->fetch($r);
				$papers = $t['count'];
			}
		}
		return $papers;
	}



	/**
	 * return all papers where this person is listed as co_author
	 */
	function get_coauthor_papers() {
		global $db;

		ct_load_class('CTPaper');
		$papers	= array();
		$query="select p.* from papers as p, emails2papers as e where p.ID=e.paperID AND p.withdrawn=0 and (e.email='".$this->get('email')."' or e.email='".$this->get('email2')."') and p.personID!='".$this->pdata['ID']."' group by p.ID";
		$r = $db->query($query);
		if ($r)	{
			for	($i=0; $i <	$db->num_rows($r); $i++) {
				$p = new CTPaper;
				$p->pdata =	$db->fetch($r);
				$papers[] =	$p;
			}
		}
		return $papers;
	}

	/**
	 * Check if the user is reviewing a specific paper.
	 */
	function is_coauthor_for($paperID) {
		global $db;

		$query="select p.* from papers as p, emails2papers as e where p.ID=e.paperID AND p.withdrawn=0 and (e.email='".$this->get('email')."' or e.email='".$this->get('email2')."') and p.ID='".$paperID."' group by p.ID";
		$r = $db->query($query);
		if ($r)	{
			if ( $db->num_rows($r) > 0 ) { return true;	} else { return	false; }
		} else {
			return false;
		}
	}

	/**
	 * Check if the user is reviewing a specific paper.
	 */
	function is_reviewer_for($paperID) {
		global $db;

		$r = $db->query("select	* from reviews where personID=".$this->pdata['ID']." and paperID='".$paperID."'");
		if ($r)	{
			if ( $db->num_rows($r) > 0 ) { return true;	} else { return	false; }
		} else {
			return false;
		}
	}


	/**
	 * get an array	with all assigned reviews to this expert (as objects)
	 */
	function get_reviews() {
		global $db;

		ct_load_class('CTReview');

		$reviews = array();
		if ($this->get_id()>0) {
			$r = $db->query('select * from reviews where personID="'.$this->pdata['ID'].'" order by paperID asc');
			if ($r)	{
				for	($i	= 0; $i	< $db->num_rows($r); $i++) {
					$row = $db->fetch($r);

					$review = new CTReview();
					$review->load( $row['paperID'], $row['personID']);
					$classname = $review->get_reviewClass();
					ct_load_class($classname);
					eval('$review_new = new '.$classname.'();');
					$review_new = ct_type_cast($review,$classname);

					$reviews[] = $review_new;
				}
			}
		}
		return $reviews;
	}

	/**
	 * how many	reviews	assigned to	this pc	member?
	 */
	function count_assigned_reviews() {
		global $db;

		$reviews = 0;
		if ($this->get_id()>0) {
			$r = $db->query("select	count(*) as	count from reviews where personID=".$this->pdata['ID']);
			if ($r && ($db->num_rows($r) > 0)) {
				$t = $db->fetch($r);
				$reviews = $t['count'];
			}
		}
		return $reviews;
	}

	/**
	 * How many reviews were already entered by this pc member?
	 */
	function count_entered_reviews() {
		global $db;

		$reviews = 0;
		if ($this->get_id()>0) {
			$r = $db->query("select	count(*) as	count FROM reviews WHERE creationdate!=0 AND personID=".$this->pdata['ID']);
			if ($r && ($db->num_rows($r) > 0)) {
				$t = $db->fetch($r);
				$reviews = $t['count'];
			}
		}
		return $reviews;
	}



	/**
	 * Get number of reviews to a person/paper
	 */
	function get_review_count($personID="",	$paperID="", $entered=1) {
		global $db;

		$query="select count(*)	as count from reviews where	1 ";
		if ($entered==1) {
			$query.="and creationdate>0	";
		}
		if ($personID!="") {
			$query.="and personID='$personID' ";
		}
		if ($paperID!="") {
			$query.="and paperID='$paperID' ";
		}

		$r = $db->query($query);
		if ($r && ($db->num_rows($r) > 0)) {
			$t = $db->fetch($r);
			return $t['count'];
		} else {
			return 0;
		}

	}

	/**
	 * Get number of reviews to a person/paper
	 */
	function is_metareviewer_for($paperID=0,$personID=0) {
		global $db, $session;
		$user =& $session->get_user();

		if ($paperID<1) return false;
		if ($personID<1) $personID=$user->get_id();

		$query="select reviewtype from reviews where personID='$personID' and paperID='$paperID'";
		$r = $db->query($query);
		if ($r && ($db->num_rows($r) == 1)) {
			$t = $db->fetch($r);
			return ($t['reviewtype']=='meta');
		} else {
			return false;
		}
	}


	// returns an array	that contains all available	topics.	Each element is	an array with two
	// elements, first is topic	ID,	second is topic	title -	also available in CTPaper
	function list_topics() {
		ct_load_lib('papers.lib');

		return ct_list_topics();
	}

	// returns an array	that contains all IDs of topics	assigned to	person (as PC-member)
	//
	function get_topicIDs()	{
		global $db;

		$topics	= array();
		$rows =	$db->get_links('pc2topics',	$this->get('ID'), '');
		for	($i	= 0; $i	< sizeof($rows); $i++) {
			array_push($topics,	$rows[$i]['topicID']);
		}
		return $topics;
	}

	// returns an array	that contains all titles of	topics assigned	to this	paper
	//
	function get_topics() {
		global $db;

		$topics	= array();
		$r = $db->query("select	topics.* from topics, pc2topics where topics.id=pc2topics.topicID and pc2topics.personID=".$this->get('ID'));
		for	($i	= 0; $i	< $db->num_rows($r); $i++) {
			$row = $db->fetch($r);
			array_push($topics,	$row[ctlx($row,'title')]);
		}
		return $topics;
	}

	/**
	 * returns the text to a bidding code number
	 *
	 * @param int $bidding bidding code
	 * @return string
	 */
	function get_bidding_text($bidding="") {
		if (!isset($bidding) ||	$bidding=="" ||	$bidding==NULL)
			return ct('S_BIDDING_NULL');
		switch ($bidding) {
			case '-2':
				return ct('S_BIDDING_CONFLICT'); break;
			case '-1':
				return ct('S_BIDDING_DISLIKE');	break;
			case '0':
				return ct('S_BIDDING_DEFAULT');	break;
			case '1':
				return ct('S_BIDDING_LIKE'); break;
			case '2':
				return ct('S_BIDDING_WANTED'); break;
		}
		return ct('S_BIDDING_NULL');
	}

	/**
	 * Check if username exists. Return number of found entries...
	 */
	function testusername($u,$considerDeletedUsers=true) {
		global $db;
		//$w="";
		//if ($this->get_id()!=0 && $this->get_id()!="")
		//	$w = " and ID!=".$this->get_id();
		if ($considerDeletedUsers)
			$r = $db->query("select ID from persons where (username='$u')");
		else
			$r = $db->query("select ID from persons where (username='$u') and (deleted=0)");
		return $db->num_rows($r);
	}

	/**
	 * returns an array	that contains all titles of	topics assigned	to this	paper
	 */
	function count_topics()	{
		global $db;

		$topics	= 0;
		$r = $db->query("select	count(*) as	count from pc2topics where pc2topics.personID='".$this->get('ID')."'");
		if ($r && ($db->num_rows($r) > 0)) {
			$row = $db->fetch($r);
			$topics	= $row['count'];
		}
		return $topics;
	}


	/**
	 * Save	topics assigned	to this	person.	The	topics are contained as	array in the parameter if this function.
	 */
	function save_topics($topics=array()) {
		global $db;

		$db->unlink('pc2topics', $this->pdata['ID'], "");
		if (is_array($topics)) {
			while (list($k,$v) = each($topics))	{
				$db->link('pc2topics', $this->pdata['ID'], $v);
			}
		}
	}

	/******** Track-Chair-Functions

	/**
	 * Return contributiontypes for this person as chair.
	 * ConferenceChairs and Admins always have all Contributiontypes available!
	 * REQUIRES Track-Chair-Module if assignment of Chairs to Tracks is required.
	 *
	 * @return array array with IDs of all assigned contributiontypes...
	 */
	function get_contributiontypes_as_chair() {
		if (ctconf_get('chairTrackSelect',false) && ct_test_lib('multi_track.lib')) {	// if multi-track library exists...
			ct_load_lib('multi_track.lib');
			return mt_get_contributiontypes_as_chair($this);
		} else {
			// list all topics...
			return ct_get_contributiontypeIDs();
		}
	}

	/**
	 * Check if an person as pc member or reviewer has a conflict of interest with a paper
	 *
	 * @param CTPaper $paper the paper to check if a conflict exists.
	 * @return boolean true if conflict exists.
	 */
	function has_review_conflict($paper) {
		global $db;
		# Author is himself -> Conflict
		if ($paper->get('personID')==$this->get_id()) return true;
		$coauthors = $paper->get_emails();
		# Check for conflict as coauthor
		if (in_array($this->get('email'),$coauthors)) return true;
		if ($this->get('email2')!='' && in_array($this->get('email2'),$coauthors)) return true;
		$ra = $db->query("SELECT count(DISTINCT(p.ID)) as conflict FROM papers as p LEFT JOIN biddings as b ON p.ID = b.paperID AND b.personID='".$this->get_id()."' WHERE (p.ID='".$paper->get_id()."' AND b.bidding<=-2)");
		if ($ra and ($db->num_rows($ra) > 0)) {
			$row = $db->fetch($ra);
			if ($row['conflict']>0) return true;
		}
		return false;
	}

	/**
	 * Return if a contributiontype was assigned to this "chair".
	 * ConferenceChairs and Admins always have access to all contribution types/tracks!
	 * REQUIRES Track-Chair-Module if assignment of Chairs to Tracks is required.
	 *
	 * @return boolean value to show if this ctype is assigned to this chair
	 */
	function has_chair_access($ctypeID=0) {
		if (ctconf_get('chairTrackSelect',false) && ct_test_lib('multi_track.lib')) {
			ct_load_lib('multi_track.lib');
			return mt_has_chair_access($this, $ctypeID);
		} else {
			return ($this->is_chair() || $this->is_admin() || $this->is_conferenceChair());
		}
	}

	/**
	 * Return contributiontypes for this person as pc member.
	 * REQUIRES Track-Chair-Module if assignment of PCs to Tracks is required.
	 *
	 * @return array array with IDs of all assigned contributiontypes...
	 */
	function get_contributiontypes_as_pc() {
		if (ctconf_get('pcTrackSelect',false) && ct_test_lib('multi_track.lib')) {
			ct_load_lib('multi_track.lib');
			return mt_get_contributiontypes_as_pc($this);
		} else {
			// list all topics...
			return ct_get_contributiontypeIDs();
		}
	}

	/**
	 * Return if a contributiontype was assigned to this pc member of reviewer.
	 * REQUIRES Track-Chair-Module if assignment of PCs to Tracks is required.
	 *
	 * @return boolean value to show if this ctype is assigned to this pc member of reviewer
	 */
	function has_pc_access($ctypeID=0) {
		if (ctconf_get('pcTrackSelect',false) && ct_test_lib('multi_track.lib')) {
			ct_load_lib('multi_track.lib');
			return mt_has_pc_access($this, $ctypeID);
		} else {
			return (true);
		}
	}


	//## DISPLAY FUNCTIONS ########################################################

	// show	row	in userlist	or PC-list
	function show_row($class, $page="")	{
		ct_load_lib('datetime.lib');


		global $session,$http;
		$user =& $session->get_user();

		$param = array('form_id' => $this->get('ID'));

		$is_his_pc_member=false;
		if (ctconf_get('chairTrackSelect',false) && ctconf_get('pcTrackSelect',false)) {
			$assigned_ctypeIDs = $this->get_contributiontypes_as_pc();
			if ($user->has_chair_access($assigned_ctypeIDs) &&
					($this->is_pc() || $this->is_reviewer()) )
				$is_his_pc_member=true;
		} elseif ($this->is_pc() || $this->is_reviewer()) {
			$is_his_pc_member = true;
		}

		if ($this->get('deleted') != '0')  {
			$class = $class."_del";
		}

		echo "<tr class=\"$class\" ";
		echo "onmouseover=\"ct_row(	this, 'on',	'$class', '".$class."_highlight');\" ";
		echo "onmouseout=\"ct_row( this, 'off',	'$class', '".$class."_highlight');\">\n";

		// Col 1: ID
		echo "<td align=right valign=top><span class=\"fontbold font9\">";
		if ($this->get('deleted') != '0') echo ' <img src="icons/deleted.gif">&nbsp;';
		echo $this->pdata['ID']."</span></td>\n";
		// Col 2: Name, Email, username
		echo "<td align=left valign=top><span class=\"fontbold font9\">";
		if ($user->is_admin() || $user->is_assistant() || $user->is_chair()	||  $user->is_conferenceChair()) {
			echo "<a href=\"".ct_pageurl('adminUsersDetails',$param)."\">";
			echo ct_form_encode($this->get_reversename())."</a>";
		} else {
			echo ct_form_encode($this->get_reversename());
		}
		##if ($this->pdata['externalremark'] != "") echo ' <sup><a class="fontnormal font8" href="'.ct_pageurl('adminUsersDetails', array(array('form_id',$this->get('ID'))))."\" title=\"External Remark:<br>".$this->get_special('externalremark').'" external="'.$this->get_special('externalremark').'">REMARKS</a></sup>';
		#if ($this->pdata['externalremark'] != "") echo ' <img src="icons/extern.gif" title="'.$this->get_special('externalremark').'">';
		#if ($this->pdata['internalremark'] != "") echo ' <img src="icons/intern.gif" title="'.$this->get_special('internalremark').'">';
		if ($this->pdata['externalremark'] != "" || $this->pdata['internalremark'] != "") {
        	echo ' <a class="fontlabel" href="'.ct_pageurl('adminUsersDetails', $param).'" ';
        	echo 'title="'.ct('S_USER_DETAILED_REMARKSECTION').'" ';
			if (strlen($this->pdata['externalremark'])>1) {
				echo 'ext_title="'.ct('S_USER_EXTERNALREMARK').'" ' ;
				echo 'ext_remark="'.substr($this->get_special('externalremark'),0,512).'" ' ;
			}
			if (strlen($this->pdata['internalremark'])>1) {
				echo 'int_title="'.ct('S_USER_INTERNALREMARK').'" ' ;
				echo 'int_remark="'.substr($this->get_special('internalremark'),0,512).'" ' ;
			}
	       	echo '>';
        	echo '<img src="icons/remark.png" border="0" alt="">'; // alt="Remark" // annoying tooltip in IE!
        	echo '</a>';
		}
		echo "</span><br>\n";
		if ($page=="adminUsersPC" && $this->get('title')!='')
			echo "<span	class=\"fontnormal font8\">".$this->get_special('title')."</span><br>";
		echo "<span	class=\"fontnormal font8\"><a href=\"mailto:".$this->get_special('email')."\">";
		echo $this->get_special('email')."</a>\n";
		if ($this->get('username')!=$this->get('email'))
		echo " (".$this->get_special('username').")\n";
		echo "</span>";
		echo "</td>\n";
		// Col 3: Organisation, Country
		echo "<td align=left valign=top>";
		echo "<span	class=\"fontnormal font9\">".$this->get_special('organisation')."</span><br>";
		ct_load_lib("address.lib");
		echo "<span	class=\"fontnormal font8\">";
		if (strlen($this->get('country'))==2)	echo $this->get_special('country').",	";
		echo ct_get_country($this->get('country'))."</span>";
		echo "</td>\n";

		// Column 4: PC-Overview page with numer of	reviews
		if ($page=="adminUsersPC") {
			echo "<td align=\"center\" valign=top nowrap>";
			if ($this->is_pc())
				echo "<span	class=\"fontnormal font8\">".ct('S_USER_STATUS_PC_SHORT')."</span> ";
			elseif ($this->is_reviewer())
				echo "<span	class=\"fontnormal font8\">".ct('S_USER_STATUS_REVIEWER_SHORT')."</span> ";
			if ($this->is_conferenceChair())
				echo "<span	class=\"fontpositive fontbold font8\">".ct('S_USER_STATUS_CONFERENCECHAIR_SHORT')."</SPAN>";
			elseif ($this->is_chair())
				echo "<span class=\"fontpositive fontbold font8\">".ct('S_USER_STATUS_CHAIR_SHORT')."</SPAN>";
			echo "<BR>";

			if ($is_his_pc_member) {
				echo "<a class=\"fontbold font8\" href=\"".ct_pageurl('adminUsersPCDetails', $param)."\">".ct('S_ADMIN_USERS_REVIEWS')."</a>";
				echo "<BR>";
				$reviewcount=$this->get_review_count($this->pdata['ID']	, "" , 0);
				$reviewsdone=$this->get_review_count($this->pdata['ID']);
				if ($reviewcount!=$reviewsdone)	{
					echo "<span	class=\"fontnegative fontbold font8\">";
				} else {
					echo "<span	class=\"fontpositive fontbold font8\">";
				}
				echo $reviewsdone."</span>&nbsp;/&nbsp;";
				echo "<span	class=\"fontbold font8\">".$reviewcount."</span><BR>";
			}
			#echo "<a class=\"fontnormal font8\" href=\"".ct_pageurl('adminReviewAssignPC', array('form_id'=>$this->get('ID')))."\">".ct('S_REVIEW_ASSIGN_PC_SHORT')."</a>";
			echo "</td>\n";
		} else {	// else	show user status
			echo "<td align=left valign=top>";
			if ($this->is_admin())
				echo "<span	class=\"fontnegative fontbold font8\">".ct('S_USER_STATUS_ADMIN_SHORT')."</SPAN><br>";
			if ($this->is_conferenceChair())
				echo "<span	class=\"fontother fontbold font8\">".ct('S_USER_STATUS_CONFERENCECHAIR_SHORT')."</SPAN><br>";
			if ($this->is_frontdesk() || $this->is_assistant()) {
				if ($this->is_assistant()) { echo "<span class=\"fontother fontbold font8\">".ct('S_USER_STATUS_ASSISTANT_SHORT')."&nbsp;</SPAN>"; }
				if ($this->is_frontdesk()) { echo "<span class=\"fontpositive fontbold font8\">".ct('S_USER_STATUS_FRONTDESK_SHORT')."&nbsp;</SPAN>"; }
				echo "<br>";
			}
			if (!$this->is_admin() && !$this->is_conferenceChair() && !$this->is_frontdesk() && !$this->is_assistant()) {
				echo "&nbsp;&nbsp;";
				echo "<br>";
			}
			if ($this->is_reviewer() && !($this->is_pc() && $this->is_chair())) // This would be too much for one line!
				echo "<span	class=\"fontnormal font8\">".ct('S_USER_STATUS_REVIEWER_SHORT')."</span>&nbsp;";
			if ($this->is_pc())
				echo "<span	class=\"fontbold font8\">".ct('S_USER_STATUS_PC_SHORT')."</span>&nbsp;";
			if ($this->is_chair())
				echo "<span class=\"fontpositive fontbold font8\">".ct('S_USER_STATUS_CHAIR_SHORT')."</SPAN>";
			echo "</td>\n";
		}


		// 4,5:	second subcolumn
		echo "<td align=left valign=top><span class=\"fontnormal font8\">";

		if ($this->is_author()) {
			echo ct('S_USER_STATUS_AUTHOR_SHORT');
			// Papers are counted in adminUsersBrowse
			if (isset($this->pdata['papercount']) && $this->pdata['papercount']>1) echo "(".$this->pdata['papercount'].")";
			echo "<br>";
		}
		if ($this->is_coauthor()) { echo ct('S_USER_STATUS_COAUTHOR_SHORT')."<br>"; }
		if (!$this->is_author() && !$this->is_coauthor()) { echo	"&nbsp;&nbsp;<br>";	}

		if ($this->is_participant()) {
			if ($user->is_admin() || $user->is_conferenceChair() || $user->is_frontdesk() || $user->is_assistant()) {
				echo "<b><a	href=\"".ct_pageurl('adminParticipantsDetails',	$param)."\">".ct('S_USER_STATUS_PARTICIPANT_SHORT')."</a></b>";
			} else { // No link!
				echo "<b>".ct('S_USER_STATUS_PARTICIPANT_SHORT')."</b>";
			}
		}
		echo "</span></td>\n";

		// 5 last column
		echo "<td align=right valign=top>";
		if ($page == 'adminUsersLoginsBrowse') {
			if (ct_datetime_2_timestamp($this->get('logoutdate'))>=0)
				echo "<span	class=\"fontbold font8\">";
			else
				echo "<span	class=\"fontpositive fontbold font8\">";
			echo ct_datetime_format($this->get('logindate'))."</span><br>";
			echo "<span	class=\"fontnormal fontnegative font8\">".ct_datetime_format($this->get('logoutdate'))."</span><br>\n";
			echo "<span	class=\"fontlabel font8\">".ct_datetime_format($this->get('lastactiondate'))."</span><br>\n";
			#if ($this->get('loginhost')!='')
			#	echo "<span	class=\"fontnormal font8\">IP: ".$this->get('loginhost')."</span><br>\n";
			if ($user->is_admin() && $user->get_id()!=$this->get_id() && $this->get('deleted')==0)
				echo "<span	class=\"fontbold font8\"><a href=\"".ct_pageurl('adminUsersLoginAs', $param)."\">".ct('S_ADMIN_USERS_ACTION_LOGINAS')."</a></span>\n";
			else
				echo "<span	class=\"fontgray font8\">".ct('S_ADMIN_USERS_ACTION_LOGINAS')."</span>\n";
			if ($this->get('logoutdate')=='0000-00-00 00:00:00' && $user->is_admin() && $user->get_id()!=$this->get_id())
				echo "<br><span class=\"fontnormal font8\"><a href=\"".ct_pageurl('adminUsersKick', $param)."\">".ct('S_ADMIN_USERS_ACTION_KICKUSER')."</a></span>\n";

		} elseif ($page=="adminUsersPC") {
			if ($user->is_admin() || $user->is_chair() || $user->is_conferenceChair() ) {
				if ($is_his_pc_member) {
					$topics = $this->count_topics();
					if (isset($http['form_tracks']) && $http['form_tracks']!='0')
						$param['form_tracks'] = $http['form_tracks'];

					if ($topics)
						echo "<a class=\"fontnormal font8\" href=\"".ct_pageurl('pc2topics', $param)."\">$topics ".ct('S_ADMIN_USERS_ACTION_TOPICS')."</a><br>";
					else
						echo "<a class=\"fontnegative fontbold font8\" href=\"".ct_pageurl('pc2topics', $param)."\">$topics ".ct('S_ADMIN_USERS_ACTION_TOPICS')."</a><br>";
					echo "<a class=\"fontbold font8\" href=\"".ct_pageurl('adminReviewAssignPC', $param)."\">".ct('S_REVIEW_ASSIGN_PC')."</a><br>";
				}
			}
		} else {
			if ($user->is_admin() || $user->is_assistant() || $user->is_conferenceChair() ) {
				if ($this->pdata['deleted']	== '0')	{
					echo "<a class=\"fontbold font8\"	href=\"".ct_pageurl('adminUsersEditDelete', array('form_userID' => $this->get('ID')))."\">".ct('S_ADMIN_USERS_ACTION_EDIT')."</a>";
					if ($this->get_id()!=1 && $this->get_id()!=$user->get_id() && (!$this->is_admin() || $user->is_admin()))	{  // Admin	must not be	deleted!
						echo "<span	class=\"fontnormal font8\">&nbsp;&middot;&nbsp;<a href=\"".ct_pageurl('adminUsersEditDelete', array('form_delete_id' => $this->get('ID')))."\">".ct('S_ADMIN_USERS_ACTION_DELETE')."</a></span><BR>";
					} else {
						echo "<span	class=\"fontgray font8\">&nbsp;&middot;&nbsp;".ct('S_ADMIN_USERS_ACTION_DELETE')."</span><BR>";
					}
				} else {
					// better go to edit mode to check double entries...
					echo "<span	class=\"fontnormal font8\"><a href=\"".ct_pageurl('adminUsersEditDelete', array('form_userID' => $this->get('ID')))."\">".ct('S_ADMIN_USERS_ACTION_UNDELETE')."</a></span><BR>";
				}
				if ($user->is_admin() && $this->get_id()!=$user->get_id() && $this->get('deleted')==0)
					echo "<a class=\"fontnormal font8\" href=\"".ct_pageurl('adminUsersLoginAs', $param)."\">".ct('S_ADMIN_USERS_ACTION_LOGINAS')."</a><br>";
			} else {
				echo "&nbsp;";
			}
			//if (($user->is_admin()) &&	($page!="adminUsersPC" and $this->get_id()!=1 && $this->get_id()!=$user->get_id()) )
			//	echo "<a class=\"fontnormal font8\" href=\"".ct_pageurl('newPaper', array('form_personID' => $this->get('ID')))."\">".ct('S_ADMIN_USERS_ACTION_NEWPAPER')."</a><br>";

			if (ctconf_get('participation/enabled') && ($user->is_admin() || $user->is_assistant() || $user->is_frontdesk()) && (!strstr($this->pdata['status'], 'participant') && $page!="adminUsersPC"	&& $this->get_id()!=1 && $this->get_id()!=$user->get_id() && $this->get('deleted')==0) )
				echo "<span	class=\"fontnormal font8\"><a href=\"".ct_pageurl('adminParticipantsEditDelete',	array('form_personID'	=> $this->get('ID')))."\">".ct('S_ADMIN_USERS_ACTION_REGISTER')."</a></span>";

		}
		echo "</td>\n";
		echo "</tr>\n";
	}

	// Show	short info about user
	function show_shortinfo($width="98%", $align="center") {
		ct_load_lib("address.lib");
		global $session;
		$user =& $session->get_user();

		echo "<table width=\"$width\" align=\"$align\" cellspacing=0 cellpadding=1 border=0>\n";
		echo "<tr><td class=\"blackbg\">\n";

		echo "<table width=\"100%\" align=\"center\" cellspacing=0 cellpadding=2 border=0>\n";
		echo "<tr class=\"lightbg\">\n";
		echo "<td>\n";
		if ($this->get('title')!="")
			echo "<span	class=\"fontnormal font10\">".$this->get_special('title')."</span><br>\n";
		if ($user->is_admin() || $user->is_assistant() ) {
			echo "<a href=\"".ct_pageurl('adminUsersDetails', array('form_id'=>$this->get('ID')))."\" class=\"fontbold font10\">".ct_form_encode($this->get_fullname())."</a><br>\n";
		} else {
			echo "<span	class=\"fontbold font10\">".ct_form_encode($this->get_fullname())."</span><br>\n";
		}
		echo "<span	class=\"fontlabel font10\">".ct('S_USER_ORGANISATION').":</span>	";
		echo "<span	class=\"fontnormal font10\">".$this->get_special('organisation')."</span><br>\n";
		echo "<span	class=\"fontlabel font10\">".ct('S_USER_COUNTRY').":</span>";
		echo "<span	class=\"fontnormal font10\">".ct_get_country($this->get('country'))."</span><br>\n";
		echo "<span	class=\"fontlabel font10\">".ct('S_USER_EMAIL').":</span>";
		echo "<span	class=\"fontnormal font10\">".$this->get('email')."</span>\n";
		echo "</td><td width=\"15%\" align=center valign=middle	class=\"whitebg\">\n";
		echo "<span	class=\"fontbold font20\">".$this->get('ID')."</span>\n";
		echo "</td></tr>\n";
		echo "</table>\n";
		echo "</td></tr>\n";
		echo "</table>\n";
	}


	// show	detail information on this conftool	user
	// calles e.g. by adminUserDetails
	function show_detailed($width="100%", $align="center") {
		ct_load_lib("address.lib");
		ct_load_lib('datetime.lib');

		global $session;
		$user =& $session->get_user();

		echo "<table width=\"$width\" align=\"$align\" class=\"infoview_table\">\n";
		echo "<tr class=\"lightbg\"><td	align=\"left\" valign=\"top\" colspan=2>\n";
		echo "<span	class=\"fontlabel fontbold  font10\">".ct('S_USER_DETAILED_NAMESECTION')."</span>\n";
		echo "</td></tr>\n";
		echo "<tr class=\"infoview_sep\"><td align=\"left\"	valign=\"top\" colspan=2>";
		echo "<img src=\"spacer.gif\" width=1 height=1 border=0>";
		echo "</td></tr>\n";
		echo "<tr class=\"oddrow\"><td align=\"left\" valign=\"top\" width=\"80%\">\n";
		if ($this->get('title')	!= "") {
			echo "<span	class=\"fontnormal font10\">".$this->get_special('title')."</span><br>\n";
		}
		echo "<span	class=\"fontbold font14\">".ct_form_encode($this->get_reversename())."</span><br>\n";
		echo "<span	class=\"fontbold font10\">".$this->get_special('organisation').", ".ct_get_country($this->get('country'))."</span>\n";
		echo "</td><td width=\"20%\" align=center valign=middle	class=\"infoview_invert\">\n";
		echo "<span	class=\"fontlight fontbold font36\">".$this->get('ID')."</span>\n";
		echo "</td></tr>\n";
		echo "</table>\n";


		echo "<table width=\"$width\" align=\"$align\" class=\"infoview_table\">\n";
		echo "<tr class=\"lightbg\"><td	align=\"left\" valign=\"top\" colspan=2>\n";
		echo "<span	class=\"fontlabel fontbold  font10\">".ct('S_USER_DETAILED_CONTACTSECTION')."</span>\n";
		echo "</td></tr>\n";
		echo "<tr class=\"infoview_sep\"><td align=\"left\"	valign=\"top\" colspan=2>";
		echo "<img src=\"spacer.gif\" width=1 height=1 border=0>";
		echo "</td></tr>\n";

		echo "<tr class=\"evenrow\"><td	width=\"50%\" align=left valign=top>\n";
		echo "<span	class=\"fontnormal font10\">\n";
		echo $this->get_special('organisation')."<br>";
		echo ct_form_encode($this->get_title()." ".$this->get('firstname')." ".$this->get('name'))."<br>";
		echo $this->get_special('addr1')."<br>\n";
		if ($this->get_special('addr2')	!= "") {
			echo $this->get_special('addr2')."<br>\n";
		}
		echo ct_address_format($this->get_special('country'),$this->get_special('zip'),$this->get_special('state'),$this->get_special('city'));
		//echo $this->get('zip')." ".$this->get('city')."<br>\n";
		//echo $this->get('state')."<br>\n";
		echo ct_get_country($this->get('country'))."</span>\n";
		echo "</td><td width=\"50%\" align=left	valign=top>\n";
		if ($this->get('phone')!='') echo "<span class=\"fontlabel font10\">".ct('S_USER_PHONE')."</span> <span class=\"fontnormal font10\">".$this->get_special('phone')."</span><br>\n";
		if ($this->get('fax')!='')   echo "<span class=\"fontlabel font10\">".ct('S_USER_FAX')."</span> <span class=\"fontnormal font10\">".$this->get_special('fax')."</span><br>\n";
		echo "<span	class=\"fontlabel font10\">".ct('S_USER_EMAIL')."</span> <a href=\"mailto:".$this->get_special('email')."\" class=\"fontnormal font10\">".$this->get_special('email')."</a><br>\n";
		if ($this->get('homepage')!="")
			echo "<span	class=\"fontlabel font10\">".ct('S_USER_HOMEPAGE')."</span> <a href=\"".$this->get_special('url')."\" class=\"fontnormal font10\">".$this->get_special('url')."</a><br>\n";
		echo "</td></tr>\n";
		echo "</table>\n";


		echo "<table width=\"$width\" align=\"$align\" class=\"infoview_table\">\n";
		echo "<tr class=\"lightbg\"><td	align=\"left\" valign=\"top\" colspan=2>\n";
		echo "<span	class=\"fontlabel fontbold  font10\">".ct('S_USER_DETAILED_REMARKSECTION')."</span>\n";
		echo "</td></tr>\n";
		echo "<tr class=\"infoview_sep\"><td align=\"left\"	valign=\"top\" colspan=2>";
		echo "<img src=\"spacer.gif\" width=1 height=1 border=0>";
		echo "</td></tr>\n";

		echo "<tr class=\"oddrow\"><td width=\"50%\" align=left	valign=top>\n";
		echo "<span	class=\"fontlabel font10\">".ct('S_USER_EXTERNALREMARK').":</span><br>\n";
		echo "<span	class=\"fontnormal font10\">".ct_nl2br($this->get('externalremark'))."</span>\n";
		echo "</td><td width=\"50%\" align=left	valign=top>\n";
		echo "<span	class=\"fontlabel font10\">".ct('S_USER_INTERNALREMARK').":</span><br>\n";
		echo "<span	class=\"fontnormal font10\">".ct_nl2br($this->get('internalremark'))."</span>\n";
		echo "</table>\n";

		$this->show_statusbox($width,$align);

		ct_vspacer();

		// Show	possible actions
		if ($user->is_admin() || $user->is_assistant() ) {
			echo "<table width=\"$width\" align=\"$align\" class=\"infoview_table\">\n";
			echo "<tr class=\"lightbg\"><td	align=\"left\" valign=\"top\" colspan=2>\n";
			echo "<span	class=\"fontlabel fontbold  font10\">".ct('S_USER_DETAILED_COMMANDSSECTION')."</span>\n";
			echo "</td></tr>\n";
			echo "<tr class=\"infoview_sep\"><td align=\"left\"	valign=\"top\" colspan=2>";
			echo "<img src=\"spacer.gif\" width=1 height=1 border=0>";
			echo "</td></tr>\n";
			echo "<tr class=\"mediumbg\"><td colspan=2 align=left valign=top>\n";
			echo "<span	class=\"fontbold font10\">\n";
			echo "<a href=\"".ct_pageurl('adminUsersEditDelete', array('form_userID' => $this->get('ID')))."\">".ct('S_ADMIN_USERS_ACTION_EDIT')."</a>";
			echo " &middot; <a href=\"".ct_pageurl('adminUsersEditDelete', array('form_delete_id' => $this->get('ID')))."\">".ct('S_ADMIN_USERS_ACTION_DELETE')."</a>";
			if ($user->is_admin() && $user->get_id()!=$this->get_id() && $this->get('deleted')==0)
				echo " &middot; <a href=\"".ct_pageurl('adminUsersLoginAs', array('form_id' => $this->get('ID')))."\">".ct('S_ADMIN_USERS_ACTION_LOGINAS')."</a>";
			if ($user->is_admin() && $user->get_id()!=$this->get_id() && ctconf_get('submission/enabled'))
				echo " &middot; <a href=\"".ct_pageurl('newPaper', array('form_personID' => $this->get('ID')))."\">".ct('S_ADMIN_USERS_ACTION_NEWPAPER')."</a>";

			if (ctconf_get('participation/enabled')) {
				if (strstr($this->get('status'), 'participant')) {
					echo " &middot;	<a href=\"".ct_pageurl('adminParticipantsDetails', array('form_id' => $this->get('ID')))."\">".ct('S_INDEX_CMD_PARTICIPATE_INFO')."</a>";
				} else {
					echo " &middot;	<a href=\"".ct_pageurl('adminParticipantsEditDelete', array('form_personID' => $this->get('ID')))."\">".ct('S_PARTICIPATE_TITLE')."</a>";
				}
			}
			echo "</span>\n</td></tr>\n";
			echo "</table>\n\n";
		}

		// list	papers of users
		if ($this->is_author() && ($user->is_admin() ||	$user->is_chair() || $user->is_conferenceChair())	) {
			echo "<table width=\"$width\" align=\"$align\" class=\"infoview_table\">\n";
			echo "<tr class=\"lightbg\"><td	align=\"left\" valign=\"top\" colspan=2>\n";
			echo "<span	class=\"fontlabel fontbold  font10\">".ct('S_USER_DETAILED_PAPERSECTION')."</span>\n";
			echo "</td></tr>\n";
			echo "<tr class=\"infoview_sep\"><td align=\"left\"	valign=\"top\" colspan=2>";
			echo "<img src=\"spacer.gif\" width=1 height=1 border=0>";
			echo "</td></tr>\n";

			echo "<tr><td colspan=2	align=center valign=top>\n";
			$papers	= $this->get_papers();
			while (list(,$v) = each($papers)) {
				$v->show_infobox('100%');
				echo "<span style=\"font-size:2pt;\">&nbsp;</span><br>"; // small empty line.
			}
			echo "</td></tr>\n";
			echo "</table>\n\n";
		}

		// list	papers where user is listed (only) as co-author
		if ($this->is_coauthor() && ($user->is_admin() || $user->is_chair() || $user->is_conferenceChair())	) {
			echo "<table width=\"$width\" align=\"$align\" class=\"infoview_table\">\n";
			echo "<tr class=\"lightbg\"><td	align=\"left\" valign=\"top\" colspan=2>\n";
			echo "<span	class=\"fontlabel fontbold  font10\">".ct('S_USER_DETAILED_COAUTHOR_PAPERSECTION')."</span>\n";
			echo "</td></tr>\n";
			echo "<tr class=\"infoview_sep\"><td align=\"left\"	valign=\"top\" colspan=2>";
			echo "<img src=\"spacer.gif\" width=1 height=1 border=0>";
			echo "</td></tr>\n";

			echo "<tr><td colspan=2	align=center valign=top>\n";
			$papers	= $this->get_coauthor_papers();
			while (list(,$v) = each($papers)) {
				$v->show_infobox('100%');
				echo "<span style=\"font-size:2pt;\">&nbsp;</span><br>"; // small empty line.
			}
			echo "</td></tr>\n";
			echo "</table>\n\n";
		}

	}

	function show_mediuminfo($width="100%",	$align="center") {
		global $session;
		$user =& $session->get_user();
		echo "<table width=\"$width\" align=\"$align\" class=\"infoview_table\">\n";
		echo "<tr class=\"lightbg\"><td	align=\"left\" valign=\"top\" colspan=2>\n";
		echo "<span	class=\"fontlabel fontbold  font10\">".ct('S_USER_DETAILED_NAMESECTION')."</span>\n";
		echo "</td></tr>\n";
		echo "<tr class=\"infoview_sep\"><td align=\"left\"	valign=\"top\" colspan=2>";
		echo "<img src=\"spacer.gif\" width=1 height=1 border=0>";
		echo "</td></tr>\n";
		echo "<tr class=\"oddrow\"><td align=\"left\" valign=\"top\" width=\"80%\">\n";
		echo "<span	class=\"fontbold font14\">";
		if ($user->is_admin() || $user->is_assistant())	{
			echo "<a href=\"".ct_pageurl('adminUsersDetails', array('form_id'=>$this->get('ID')))."\">".ct_form_encode($this->get_fullname())."</a>";
		} else {
			echo ct_form_encode($this->get_fullname());
		}
		echo "</span><br>\n";
		echo "<span	class=\"fontbold font10\">".$this->get_special('organisation')."</span><br>\n";
		echo "<span	class=\"fontnormal font10\">".$this->get_special('addr1')."</span><br>\n";
		if ($this->get('addr2')!="")
			echo "<span	class=\"fontnormal font10\">".$this->get_special('addr2')."</span><br>\n";
		ct_load_lib("address.lib");
		echo ct_address_format($this->get_special('country'),$this->get_special('zip'),$this->get_special('state'),$this->get_special('city'));
		echo ct_get_country($this->get('country'))."</span><br>\n";
		//	echo "<span	class=\"fontnormal font10\">".$this->get('zip')." ".$this->get('city')."</span><br>\n";
		//if ($this->get('county')!="")
		//	echo "<span	class=\"fontnormal font10\">".$this->get('county')."</span><br>\n";
		//echo "<span class=\"fontbold font10\">".$this->get('country')."</span><br>\n";
		echo "<span	class=\"fontlabel font10\">".ct('S_USER_EMAIL').": </span><span class=\"fontbold font10\"><a href=\"mailto:".$this->get_special('email')."\">";
		echo $this->get_special('email')."</a>\n";

		echo "</td><td width=\"20%\" align=center valign=middle	class=\"infoview_invert\">\n";
		echo "<span	class=\"fontlight fontbold font36\">".$this->get('ID')."</span>\n";
		echo "</td></tr>\n";

		echo "</table>";

		echo "<table width=\"$width\" align=\"$align\" class=\"infoview_table\">\n";
		if (!$this->get('externalremark') == ""	|| !$this->get('internalremark') ==	"")	{

			echo "<tr class=\"lightbg\"><td	colspan=2><img src=\"spacer.gif\" width=1 height=1 border=0></td></tr>\n";
			echo "<tr class=\"lightbg\"><td	align=\"left\" valign=\"top\" colspan=2>\n";
			echo "<span	class=\"fontlabel fontbold  font10\">".ct('S_USER_DETAILED_REMARKSECTION')."</span>\n";
			echo "</td></tr>\n";
			echo "<tr class=\"infoview_sep\"><td align=\"left\"	valign=\"top\" colspan=2>";
			echo "<img src=\"spacer.gif\" width=1 height=1 border=0>";
			echo "</td></tr>\n";

			echo "<tr class=\"oddrow\"><td width=\"50%\" align=left	valign=top>\n";
			echo "<span	class=\"fontlabel font10\">".ct('S_USER_EXTERNALREMARK').":</span><br>\n";
			echo "<span	class=\"fontnormal font10\">".ct_nl2br($this->get('externalremark'))."</span>\n";
			echo "</td><td width=\"50%\" align=left	valign=top>\n";
			echo "<span	class=\"fontlabel font10\">".ct('S_USER_INTERNALREMARK').":</span><br>\n";
			echo "<span	class=\"fontnormal font10\">".ct_nl2br($this->get('internalremark'))."</span>\n";

			echo "<tr class=\"lightbg\"><td	colspan=2><img src=\"spacer.gif\" width=1 height=1 border=0></td></tr>\n";
		}
		echo "<tr class=\"lightbg\"><td	align=\"left\" valign=\"top\" colspan=2>\n";
		echo "<span	class=\"fontlabel fontbold  font10\">".ct('S_USER_DETAILED_LOGINSECTION')."</span>\n";
		echo "</td></tr>\n";
		echo "<tr class=\"infoview_sep\"><td align=\"left\"	valign=\"top\" colspan=2>";
		echo "<img src=\"spacer.gif\" width=1 height=1 border=0>";
		echo "</td></tr>\n";

		echo "<tr class=\"evenrow\"><td	width=\"50%\" align=left valign=top	colspan=2>\n";
		$this->show_status();
		echo "</td></tr>\n";
		echo "</table>\n";

	}

	function show_statusbox($width,$align) {
		echo "<table width=\"$width\" align=\"$align\" class=\"infoview_table\">\n";
		echo "<tr class=\"lightbg\"><td	align=\"left\" valign=\"top\" colspan=2>\n";
		echo "<span	class=\"fontlabel fontbold  font10\">".ct('S_USER_DETAILED_LOGINSECTION')."</span>\n";
		echo "</td></tr>\n";
		echo "<tr class=\"infoview_sep\"><td align=\"left\"	valign=\"top\" colspan=2>";
		echo "<img src=\"spacer.gif\" width=1 height=1 border=0>";
		echo "</td></tr>\n";

		echo "<tr class=\"evenrow\"><td	width=\"50%\" align=left valign=top>\n";
		$this->show_status();
		echo "</td><td width=\"50%\" align=left	valign=top>\n";
		echo "<span	class=\"fontlabel font10\">".ct('S_USER_USERNAME').":</span>	<span class=\"fontnormal font10\">".$this->get_special('username')."</span><br>\n";
		/*	if ($user->is_admin() || $user->is_assistant() && !$this->is_admin()) {
			echo "<span	class=\"fontlabel font10\">".ct('S_USER_PASSWORD').":</span>	<span class=\"fontlight font10\">".$this->get('password')."</span><br>\n";
		} */
		echo "<span	class=\"fontlabel font10\">".ct('S_USER_REGISTRATION_DATE').":</span> <span class=\"fontnormal font10\">".ct_datetime_format_timezone($this->get('creationdate'))."</span><br>\n";
		echo "<span	class=\"fontlabel font10\">".ct('S_USER_LOGIN_DATE').":</span> <span class=\"fontnormal font10\">".ct_datetime_format_timezone($this->get('logindate'))."</span><br>\n";
		echo "<span	class=\"fontlabel font10\">".ct('S_USER_LOGOUT_DATE').":</span> <span class=\"fontnormal font10\">".ct_datetime_format_timezone($this->get('logotdate'))."</span><br>\n";
		echo "<span	class=\"fontlabel font10\">".ct('S_USER_LASTACTION_DATE').":</span> <span class=\"fontnormal font10\">".ct_datetime_format_timezone($this->get('lastactiondate'))."</span><br>\n";
		// echo "<span class=\"fontlabel font10\">IP:</span> <span class=\"fontnormal font10\">".($this->get('loginhost'))."</span><br>\n";
		echo "</td></tr>\n";
		echo "</table>\n";
	}

	function show_status() {
		ct_load_lib("papers.lib");
		echo "<span	class=\"fontlabel font10\">".ct('S_USER_STATUS')."</span>\n<ul>\n";
		if ($this->is_participant()) { echo	"<li> <span	class=\"fontnormal font10\">".ct('S_USER_STATUS_PARTICIPANT')."</span>\n"; }
		if ($this->is_author())	{ echo "<li> <span class=\"fontnormal font10\">".ct('S_USER_STATUS_AUTHOR')."</span>\n";	}
		if ($this->is_coauthor())	{ echo "<li> <span class=\"fontnormal font10\">".ct('S_USER_STATUS_COAUTHOR')."</span>\n";	}
		if ($this->is_admin()) { echo "<li>	<span class=\"fontnormal fontnegative font10\">".ct('S_USER_STATUS_ADMIN')."</span>\n"; }
		if ($this->is_conferenceChair()) { echo "<li>	<span class=\"fontnormal fontother font10\">".ct('S_USER_STATUS_CONFERENCECHAIR')."</span>\n"; }
		if ($this->is_assistant()) { echo "<li>	<span class=\"fontnormal fontother font10\">".ct('S_USER_STATUS_ASSISTANT')."</span>\n"; }
		if ($this->is_frontdesk()) { echo "<li>	<span class=\"fontnormal font10\">".ct('S_USER_STATUS_FRONTDESK')."</span>\n"; }
		if ($this->is_pc())	{ echo "<li> <span class=\"fontbold font10\">".ct('S_USER_STATUS_PC')."</span>\n";	}
		if ($this->is_reviewer())	{ echo "<li> <span class=\"fontbold font10\">".ct('S_USER_STATUS_REVIEWER')."</span>\n";	}
		if ($this->is_pc() || $this->is_reviewer()) {
			if (ctconf_get('pcTrackSelect',false) && ct_test_lib('multi_track.lib')) {	// if multi-track library exists...
				$tracks = $this->get_contributiontypes_as_pc();
				if (count($tracks)>0) {
					echo "<br><span class=\"fontlabel font9\">".ct('S_USER_STATUS_TRACKS')."</span>\n";
					foreach ($tracks as $t) {
						$track = ct_get_contributiontypes($t);
						echo "<br><span class=\"fontnormal font9\">".$track['title']."</span>";
					}
				} else {
					echo "<br><span class=\"fontbold fontnegative font9\">".ct('S_USER_STATUS_NOTRACKS')."</span>";
				}
			}
			$reviewcount = $this->count_assigned_reviews();
			echo "<br><a class=\"fontnormal font9\" href=\"".ct_pageurl('adminUsersPCDetails', array('form_id' => $this->get('ID')))."\">".ct('S_REVIEW_PAPERS').": ".$reviewcount."</a>";
		}
		if ($this->is_chair()) {
			echo "<li>	<span class=\"fontbold font10\">".ct('S_USER_STATUS_CHAIR')."</span>\n";
			if (ctconf_get('chairTrackSelect',false) && ct_test_lib('multi_track.lib')) {	// if multi-track library exists...
				$tracks = $this->get_contributiontypes_as_chair();
				if (count($tracks)>0) {
					echo "<br><span class=\"fontlabel font9\">".ct('S_USER_STATUS_TRACKS')."</span>\n";
					foreach ($tracks as $t) {
						$track = ct_get_contributiontypes($t);
						echo "<br><span class=\"fontnormal font9\">".$track['title']."</span>";
					}
				} else {
					echo "<br><span class=\"fontbold fontnegative font9\">".ct('S_USER_STATUS_NOTRACKS')."</span>";
				}

			}
		}
		echo "</ul>\n";
	}

	//Show remarks
	function show_remarks($width,$align='center') {
		global $user, $session;
		echo "<table width=\"$width\" align=\"$align\" class=\"infoview_table\">\n";
		$user =& $session->get_user();
		if ($session->loggedin() &&	$user->is_admin()) {
			echo "<tr class=\"oddrow\"><td align=left width=\"50%\"	valign=top>\n";
			echo "<span	class=\"fontlabel font10\">".ct('S_USER_EXTERNALREMARK').":</span><br>\n";
			echo "<span	class=\"fontnormal font10\">".ct_nl2br($this->get('externalremark'))."</span>\n";
			echo "</td><td align=left valign=top  width=\"50%\">\n";
			echo "<span	class=\"fontlabel font10\">".ct('S_USER_INTERNALREMARK').":</span><br>\n";
			echo "<span	class=\"fontnormal font10\">".ct_nl2br($this->get('internalremark'))."</span>\n";
			echo "&nbsp;</td></tr>";
		} else {
			echo "<tr class=\"oddrow\"><td align=leftvalign=top>\n";
			echo "<span	class=\"fontlabel font10\">".ct('S_USER_EXTERNALREMARK').":</span><br>\n";
			echo "<span	class=\"fontnormal font10\">".ct_nl2br($this->get('externalremark'))."</span>\n";
			echo "</td></tr>\n";
		}
		echo "</table>";
	}

}

?>