<?php
//
// CLASS:		CTPerson_form: Form Generation for Person.
//

class CTPerson_Form extends CTPerson {

	// Constructor, callin super function
	function CTPerson_Form() {
		parent::CTPerson();
	}


	//## A) FORM GENERATION	#######################################

	// Creates a HTML form to edit person`s	data
	function show_form($action,$errors) {
		ct_load_class('CTForm');
		ct_load_lib('participation.lib');
		global $session, $ctconf, $http;

		$user =& $session->get_user();

		$form =	new	CTForm($action,	"post",	$errors);

		$form->width='98%';
		$form->align='center';
		$form->waitmessage=true;
		$form->formname='userdata';
		$form->return2tab=true;
		$form->warningmessage=true;

		$form->add_hidden(array(array('form_id', $this->get('ID'))));

		$form->add_separator(ct('S_USER_PERSONALSECTION'));
		$form->add_text("*&nbsp;".ct('S_USER_ORGANISATION'), 'form_organisation', $this->get('organisation'), 50, 255);
		$form->add_radio("*	".ct('S_USER_GENDER'), 'form_gender', array(
							array('2',ct('S_USER_GENDER_FEMALE')),
							array('1',ct('S_USER_GENDER_MALE')),
							array('3',ct('S_USER_GENDER_DR')),
							array('4',ct('S_USER_GENDER_PROF'))),	$this->get('gender'));
		$form->add_text(ct('S_USER_TITLE'),	'form_title', $this->get('title'), 20, 255);
		if (($session->loggedin() && ($user->is_admin()	|| $user->is_assistant() || $user->is_conferenceChair())) || (strlen($this->get('firstname'))<3 || strlen($this->get('name'))<3)  || !($session->loggedin())) {
			$form->add_text("* ".ct('S_USER_FIRSTNAME'), 'form_firstname', $this->get('firstname'),	40,	255);
			$form->add_text("* ".ct('S_USER_NAME'),	'form_name', $this->get('name'), 40, 255);
		} else { //	disallow changes to	the	name of	the	user!
			$form->add_hidden(array(array('form_firstname',	$this->get('firstname'))));
			$form->add_hidden(array(array('form_name', $this->get('name'))));
			$form->add_label("*	".ct('S_USER_FIRSTNAME'), $this->get_special('firstname'));
			$form->add_label("*	".ct('S_USER_NAME'), $this->get_special('name'));
		}
		$form->add_text("* ".ct('S_USER_ADDRESS1'),	'form_addr1', $this->get('addr1'), 40, 255);
		$form->add_text(ct('S_USER_ADDRESS2'), 'form_addr2', $this->get('addr2'), 40, 255);
		$form->add_text("* ".ct('S_USER_ZIPCODE'), 'form_zip', $this->get('zip'), 10, 10);
		$form->add_text("* ".ct('S_USER_CITY'),	'form_city', $this->get('city'), 40, 255);
		// $form->add_text(ct('S_USER_STATE'), 'form_state', $this->get('state'), 40, 255);
		ct_load_lib('address.lib');
		$states	= ct_list_states();
		$form->add_select( ct('S_USER_STATE'),'form_state',1, $states, array($this->get('state')));
		// $form->add_text(, 'form_state', $this->get('state'),	40,	255);

		// Select State/Territory
		//	$form->add_text("* ".ct('S_USER_COUNTRY'), 'form_country', $this->get('country'), 40, 255);
		$countries = ct_list_countries();
		if ($session->loggedin() || $this->get('country')!="")	{
			$defaultcountry = $this->get('country');
		} else { // give default country
			$defaultcountry = ctconf_get('web/defaultcountry');
		}
		$form->add_select("* ".ct('S_USER_COUNTRY'),'form_country',1, $countries, array($defaultcountry), false, (strlen($this->get('country'))>2)?"<br>(".$this->get('country').")":"" );
		$form->add_text(ct('S_USER_PHONE'),	'form_phone', $this->get('phone'), 40, 255);
		$form->add_text(ct('S_USER_FAX'), 'form_fax', $this->get('fax'), 40, 255);
		$form->add_text("* ".ct('S_USER_EMAIL'), 'form_email', $this->get('email'),	50,	255);
		$form->add_text(ct('S_USER_EMAIL2'), 'form_email2', $this->get('email2'),	50,	255);
		$form->add_text(ct('S_USER_HOMEPAGE'), 'form_url', $this->get('url'), 50, 255);
		if (false) {// && isset($ctconf['lang']['2'])) {
			$languages = array(array('0',ct('S_USER_LANGUAGE_NONE')));
			for($i=1;$i<=4 && isset($ctconf['lang'][$i]);$i++) $languages[]=array($i,$ctconf['lang'][$session->get('langno')]['languages'][$i-1]);
			$form->add_radio(ct('S_USER_LANGUAGE'), 'form_language', $languages, ($this->get('language')+0));
		}
		$form->add_textarea(ct('S_USER_EXTERNALREMARK'), 'form_externalremark',	$this->get('externalremark'), 60, 5);
		$indent="&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
		if ($session->loggedin()) {
			if ($user->is_admin() || $user->is_assistant() || $user->is_conferenceChair()) {
				$reviewcount = $this->count_assigned_reviews();
				$this->check_coauthor();
				$this->check_author();
				$this->check_participant();
				$form->add_separator(ct('S_USER_ADMINSECTION'));
				$status_array = array();
				if (ctconf_get('submission/enabled')) {
					$status_array[] = array( 'form_status_author', 'author', ct('S_USER_STATUS_AUTHOR'), $this->is_author(), '', true);
					$status_array[] = array( 'form_status_coauthor', 'coauthor', ct('S_USER_STATUS_COAUTHOR'), $this->is_coauthor(), '', true);
				}
				if (ctconf_get('participation/enabled'))
					$status_array[] = array( 'form_status_participant', 'participant', ct('S_USER_STATUS_PARTICIPANT'), $this->is_participant(), '', true);
				if (ctconf_get('submission/enabled')) {
					$status_array[] = array( '', '', '<br><i>'.ct('S_USER_STATUS_REVIEWER_SECTION').'</i>'.($reviewcount>0?"&nbsp;(<b>".ct('S_REVIEW_PAPERS').": ".$reviewcount.")</b>":""));
					$status_array[] = array( 'form_status_reviewer', 'reviewer', "<strong>".ct('S_USER_STATUS_REVIEWER')."</strong><br>$indent".ct('S_USER_STATUS_REVIEWER_HINT')."<br>$indent".ct('S_USER_STATUS_REVIEWER_HINT2'), $this->is_reviewer(), '', (!$user->is_admin() && !$user->is_conferenceChair() && !$user->is_assistant()) );
					$status_array[] = array( 'form_status_pc', 'pc', "<strong>".ct('S_USER_STATUS_PC')."</strong><br>$indent".ct('S_USER_STATUS_PC_HINT')."<br>$indent".ct('S_USER_STATUS_PC_HINT_PRO'), $this->is_pc(), '', (!$user->is_admin() && !$user->is_conferenceChair() && !$user->is_assistant()) );
				}
				$status_array[] = array( '', '', '<br><i>'.ct('S_USER_STATUS_ADMINISTRATIVE').':</i>');
				$status_array[] = array( 'form_status_admin',	'admin', '<span class="fontnegative fontbold font10">'.ct('S_USER_STATUS_ADMIN')."</span><br>$indent".ct('S_USER_STATUS_ADMIN_HINT'), $this->is_admin(), '', $this->get_ID()==1 || !$user->is_admin());
				$status_array[] = array( 'form_status_assistant',	'assistant', '<span class="fontbold font10">'.ct('S_USER_STATUS_ASSISTANT')."</span><br>$indent".ct('S_USER_STATUS_ASSISTANT_HINT'), $this->is_assistant(), '', (!$user->is_admin() && !$user->is_assistant()) || ($user->get_id()==$this->get_id() && !$user->is_admin()) );
				$status_array[] = array( 'form_status_conferenceChair',	'conferenceChair', '<span class="fontbold font10">'.ct('S_USER_STATUS_CONFERENCECHAIR')."</span><br>$indent".ct('S_USER_STATUS_CONFERENCECHAIR_HINT'), $this->is_conferenceChair(), '', (!$user->is_admin() && !$user->is_conferenceChair()) || ($user->get_id()==$this->get_id() && !$user->is_admin()) );
				$status_array[] = array( 'form_status_chair',	'chair', '<span class="fontbold font10">'.ct('S_USER_STATUS_CHAIR')."</span><br>$indent".ct('S_USER_STATUS_CHAIR_HINT'), $this->is_chair(),'', (!$user->is_admin() && !$user->is_conferenceChair()));
				$status_array[] = array( 'form_status_frontdesk',	'frontdesk', '<span class="fontbold font10">'.ct('S_USER_STATUS_FRONTDESK')."</span><br>$indent".ct('S_USER_STATUS_FRONTDESK_HINT'), $this->is_frontdesk());
				$form->add_check(ct('S_USER_STATUS'), $status_array);
				
			}
			if ($user->is_admin() || $user->is_assistant()) {
				$form->add_textarea(ct('S_USER_INTERNALREMARK'), 'form_internalremark',	$this->get('internalremark'), 60, 5);
			}
			## elseif ($user->is_pc()) {
			##	$form->add_separator(ct('S_USER_ADMINSECTION'));
			##	$form->add_check(ct('S_USER_STATUS'), array(
			##		array( 'form_status_author', 'author', ct('S_USER_STATUS_AUTHOR'), $this->is_author(), '', true),
			##		array( 'form_status_coauthor', 'coauthor', ct('S_USER_STATUS_COAUTHOR'), $this->is_coauthor(), '', true),
			##		array( 'form_status_participant', 'participant', ct('S_USER_STATUS_PARTICIPANT'), $this->is_participant(), '', true)
			##	) );
			##}
		}

		// Login data. Only displayed if:
		if ( !$session->loggedin() || 					// New user registers
		     ($session->loggedin() && $this->get_id()==0) || // A new user is created in the backoffice
			 ($this->get_id()==$user->get_id()) ||		// User is editing his own data
			  $user->is_admin() ) {						// Admin can EDIT this data as well

			$form->add_separator(ct('S_USER_LOGINSECTION'));
			// Registration of a new user in participation phase: Give him some details, why an account makes sense...
			if ( !($session->loggedin()) &&
					ctconf_get('participation/enabled') && ct_check_phases("participation")	&&
					!(ct_check_phases("submission")	) ) {
	  			#$form->add_radio(ct('S_USER_REG_ACCOUNT'), 'form_createaccount', array(array('1',ct('S_USER_REG_ACCOUNT_CREATE')),
				#													             array('0',ct('S_USER_REG_ACCOUNT_NOACCOUNT'))), 1);
				#$form->add_spacer();
	  			$form->add_label('',ct('S_USER_REG_ACCOUNT_CREATE'));
			}

			// Show field for username
			$form->add_text("* ".ct('S_USER_USERNAME'),	'form_username', $this->get('username'), 40, 255, false, '<br>'.ct('S_USER_USERNAME_HINT')	);
			// add password field only for admins! Do not show to assistants, if they are no admins
			$password = $password2 = $this->get('password');
			if (isset($http['form_pwd2']) && $http['form_pwd']!=$http['form_pwd2']) $password2 = $http['form_pwd2'];	// Password still set from last form
			if ($this->get('passwordencrypted')) { $password = $password2 = '********'; }	// Encrypted passwords shall not be shown!
			$form->add_pass("* ".ct('S_USER_PASSWORD'),	'form_pwd',	$password,	10,	64, false, ct('S_USER_PASSWORD_HINT_STRONG'));
			$form->add_pass("* ".ct('S_USER_PASSWORD2'), 'form_pwd2', $password2, 10, 64, false, ct('S_USER_PASSWORD_HINT2'));

			// Registration of a new user
			if ( !($session->loggedin()) ) {
	  			$form->add_radio(ct('S_USER_REG_EMAIL'), 'form_reg_options', array(array('normal',ct('S_USER_REG_EMAIL_CONFIRMATION')),
																	             #array('send_password',ct('S_USER_REG_EMAIL_DESCRIPTION')),
																	             array('generate',ct('S_USER_PASSWORD_GENERATE'))), (in_http('form_reg_options')?$http['form_reg_options']:'normal'));
			}

			// A new user is created: Generate password?
			if ($session->loggedin() && $this->get_id()==0) {
				$form->add_check("&nbsp;", array(array('form_pwdgenerate','pwdgenerate',ct('S_USER_PASSWORD_GENERATE'),1)));
	  			$form->add_radio(ct('S_USER_REG_EMAIL_ACTION'), 'form_pwdmail', array(array('sendmail',ct('S_USER_REG_EMAIL_VALIDATE')),
																	            array('nomail',ct('S_USER_REG_EMAIL_NOMAIL'))),	(isset($http['form_pwdmail']) && $http['form_pwdmail']=="nomail")?'nomail':'sendmail' );
			}
		} else {
			$form->add_separator(ct('S_USER_LOGINSECTION'));
			$form->add_label("* ".ct('S_USER_USERNAME'), $this->get('username'));
		}

		// New user in participation phase => lead to registration...
		if (ctconf_get('participation/enabled') && ct_check_phases("participation")	&&
				!(ct_check_phases("submission")	|| ct_check_phases("review")) &&
				!$session->loggedin()) { // Only participation phase is active - lead hin to registration page
			$form->add_submit('cmd_save_person_register', ct('S_USER_SUBMIT_PARTICIPATE'));

		// is not yet logged in? Allow hin to register for conference...
		} elseif (ctconf_get('participation/enabled') && ct_check_phases("participation") && !$session->loggedin() ) {
			$form->add_submit_not_bottom('cmd_save_person_register', ct('S_USER_SUBMIT_PARTICIPATE'),true);
			$form->add_submit('cmd_save_person', ct('S_USER_SUBMIT_PARTICIPATE_LATER'));

		// New user is created in backoffice and participation phase is active.
		} elseif (ctconf_get('participation/enabled') &&
						(ct_check_phase_active_or_over("participation") || ct_participants_exist()) &&
		            $session->loggedin() && $this->get_id()==0 &&  // Create new user by admin etc.?
				    ($user->is_admin() || $user->is_assistant() || $user->is_frontdesk()) )  {	// Onyl for assistant, admin and frontdesk
			$form->add_submit('cmd_save_person_register', ct('S_USER_SUBMIT_PARTICIPATE'));
			$form->add_submit('cmd_save_person', ct('S_USER_SUBMIT'));

			// is not yet logged in? Allow hin to register for conference...
		} elseif (ctconf_get('submission/enabled') && ct_check_phases('submission') && !$session->loggedin() ) {
			$form->add_submit_not_bottom('cmd_save_person_submit', ct('S_USER_SUBMIT_CONTRIBUTE'),true);
			$form->add_submit('cmd_save_person', ct('S_USER_SUBMIT_CONTRIBUTE_LATER'));

		// Just "save", maybe user is just changing his data...
		} else {
			$form->add_submit('cmd_save_person', ct('S_USER_SUBMIT'));
		}

		//$form->add_reset(ct('S_BUTTON_RESET'));

		// Admin user must not be changed in demo mode.
		if (ctconf_get('demomode') && $this->get_id()>0 && $this->get_id()<100) $form->demomode=true;
		$form->show();
	}




	// ## B) FORM PROCESSING	#######################################

	function _require($field, $name) {
		global $http;

		if (isset($http[$name])	&& ($http[$name] !=	"")) {
			$this->set($field, $http[$name]);
			return true;
		} else {
			if (isset($http[$name])) {
				$this->set($field, '');
			}
			$this->errors[]	= $name;
			return false;
		}
	}


	// process a request that results from a form generated	by CTPerson-object
	function process_form()	{
		global $http, $session;
		$user =& $session->get_user();
		ct_load_lib('mail.lib');
		ct_load_lib('person.lib');
		ct_load_lib('password.lib');

		$okay =	true;
		$this->errors =	array();

		ct_http_trim(array('username','title','firstname','lastname','email','email2','pwd','pwd2','url','organisation'));
		$this->set('ID', $http['form_id']);
		$okay &= $this->_require('organisation', 'form_organisation');
		$okay &= $this->_require('gender', 'form_gender');
		$this->set('title',	$http['form_title']);
		$okay &= $this->_require('firstname', 'form_firstname');
		$okay &= $this->_require('name', 'form_name');
		$okay &= $this->_require('addr1', 'form_addr1');
		$this->set('addr2',	$http['form_addr2']);
		$okay &= $this->_require('city', 'form_city');

		$this->set('country', $http['form_country']);
		if (isset($http['form_country']) &&	($http['form_country'] != "") && ($http['form_country']	!= "-")) {
			// Check state:	Some countries need	a state!
			if (in_array($this->get('country'),array('US','CA','AU'))) {
				 if	(isset($http['form_state'])	&& ($http['form_state']	!= "") && ($http['form_state'] != "-"))	{
					$this->set('state',	$http['form_state']);
				} else {
					$this->errors[]	= 'form_state';	$okay=false;
				}
			} else {
				$this->set('state',	'');
			}
			// Check postal	code: Some countries don't need	a postal code!
			if (in_array($this->get('country'),array('IE','HK')) ||
					isset($http['form_zip']) &&	($http['form_zip'] != "")) {
				$this->set('zip', $http['form_zip']);
			} else {
				$this->errors[]	= 'form_zip'; $okay=false;
			}
		} else {
			$this->errors[]	= 'form_country'; $okay=false;
			$okay &= $this->_require('zip',	'form_zip'); //	se below...
		}

		$this->set('phone',	$http['form_phone']);
		$this->set('fax', $http['form_fax']);
		// Check email adress(es)
		if (isset($http['form_email']) && ($http['form_email'] != "")) {
			$this->set('email',	$http['form_email']);
			// Check if	email-adress is	valid. This	function checks	the	syntax and the existance of	the	domain.
			if (!ct_validate_email($this->get('email')))	{
				$this->errors[]	= 'form_email';	$okay=false;
			}
		} else {
			$this->errors[]	= 'form_email';	$okay=false;
		}
		if (isset($http['form_email2']) && ($http['form_email2'] != "")) {
			$this->set('email2', $http['form_email2']);
			if (!ct_validate_email($this->get('email2')))	{
				$this->errors[]	= 'form_email2';	$okay=false;
			}
		}

		// URL of homepage. "http" will be added automatically...
		if (strtolower(substr($http['form_url'],0,4))!="http" && strlen($http['form_url'])>5) $http['form_url'] = 'http://'.$http['form_url'];
		if (substr($http['form_url'],-1)!="/" && substr_count($http['form_url'],'/')==2) $http['form_url'] = $http['form_url'].'/';
		$this->set('url', $http['form_url']);

		if (in_http('form_language')) $this->set('language', $http['form_language']);
		$this->set('externalremark', $http['form_externalremark']);

		// Login data. Only processed if:
		if ( !$session->loggedin() || 					// New user registers
		     ($session->loggedin() && $this->get_id()=="") || // A new user is created in the backoffice
			 ($this->get_id()==$user->get_id()) ||		// User is editing his own data
			  $user->is_admin() || 						// Admin can EDIT this data as well
			  (($user->is_assistant() || $user->is_conferenceChair() || $user->is_frontdesk()) && $this->get_id()==0)) {	// others can only create NEW users...

			// Check if (new) username is OK.
			$okay &= $this->_require('username', 'form_username');
			if (!ct_validate_username($http['form_username'])) {
				$okay = false;
				$this->errors[] = 'form_username';
			}


			// Check if both passwords match...
			if ($http['form_pwd'] != $http['form_pwd2']) { // fields do not match!
				$this->errors[] = 'form_pwd2';
			}

			// If encrypted password and password is unchanged (still ***...)
			if ($this->get('passwordencrypted') && stristr($http['form_pwd'],'*****') && stristr($http['form_pwd2'],'*****')) {
				//NOP - password was already encrypted, checked before and was not changed.
			} else {
				// New password was set and it is unencrypted...
				$this->set('passwordencrypted',0);
				// set password field
				$okay &= $this->_require('password', 'form_pwd');
				// Check if fields match?
				if ($http['form_pwd']!=$http['form_pwd2']) { // fields do not match!
					$this->errors[] = 'form_pwd2'; $okay = false;
				}
				$pwdcheck = ct_validate_password($http['form_pwd'],$this);
				if (count($pwdcheck)!=0) {
					$this->errors[] = 'form_pwd'; $okay = false;
					$this->errors[] = 'form_pwd2';
				}
			}
		}

		// Check and set status of user. Accessible only to admin, assistant and conference chair.
		if ($session->loggedin() &&	($user->is_admin() || $user->is_assistant()  || $user->is_conferenceChair())) {
			$stat =	array();
			if ($user->is_admin()) { // only admins may change the admin status.
				if (isset($http['form_status_admin'])) { $stat[] = 'admin';	}
			} elseif ($this->is_admin()) { // was admin and will stay admin
				$stat[] = 'admin';
			}
			if ($user->is_admin() || $user->is_assistant() ) { // only admins and assistants may change the status of assistants.
				if (isset($http['form_status_assistant'])) { $stat[] = 'assistant';	}
			} elseif ($this->is_assistant()) { // was assi and will stay assi
				$stat[] = 'assistant';
			}
			if ($user->is_admin() || $user->is_conferenceChair() ) { // only admins and conferenceChairs may change the status of conferenceChairs.
				if (isset($http['form_status_conferenceChair'])) { $stat[] = 'conferenceChair';	}
			} elseif ($this->is_conferenceChair()) { // was cc and will stay cc
				$stat[] = 'conferenceChair';
			}
			if ($user->is_admin() || $user->is_conferenceChair() ) { // only admins and conferenceChairs may change the status of chairs.
				if (isset($http['form_status_chair'])) { $stat[] = 'chair';	}
			} elseif ($this->is_chair()) { // was chair and will stay chair
				$stat[] = 'chair';
			}
			if (isset($http['form_status_frontdesk'])) { $stat[] = 'frontdesk';	}
			if (isset($http['form_status_pc']))	{ $stat[] =	'pc'; }
			if (isset($http['form_status_reviewer']))	{ $stat[] =	'reviewer'; }
			// if (isset($http['form_status_participant'])) { $stat[] = 'participant';	}
			// if (isset($http['form_status_author']))	{ $stat[] =	'author'; }
			// if (isset($http['form_status_coauthor']))	{ $stat[] =	'coauthor'; }
			$this->set('status', implode($stat,	','));
			$this->check_coauthor(); // As the co-author might have changed (when the mail-address was changed!)
			$this->check_author();
			$this->check_participant();
		}
		#elseif ($session->loggedin() &&	$user->is_pc()) { // pc members may introduce new pc members...
		#	if (isset($http['form_status_pc']))
		#		$this->add_status('pc');
		#	else
		#		$this->remove_status('pc');
		#}
		# echo "<p>Status: " .$this->get('status')."</p>";
		
		if ($session->loggedin() &&	($user->is_admin() || $user->is_assistant() )) {
			$this->set('internalremark', $http['form_internalremark']);
		}
		if ($okay) {
			return false;
		} else {
			return $this->errors;
		}
	}

}

?>
