<?php
//
// CLASS:	CTReview_Simple_Form
// Without summary, bestpaper and familarity
//

class CTReview_Simple_Form extends CTReview {

	function CTReview_Simple_Form() {
		parent::CTReview();
	}
	
	//#### display ##############################################################

	// show row ...
	function show_row() {
		$this->_init();
		echo "<tr>\n";
		echo "<td width=\"14%\" align=center class=\"".$this->get_style($this->data['evaluation'])."\">";
		echo "<span class=\"fontlabel font10\">".ct('S_REVIEW_SHORT_EVALUATION')."</span><br>\n";
		echo "<span class=\"fontbold font10\">".$this->data['evaluation']."</span><br>";
		if ($this->reviewfactor['evaluation']>0) echo "<span class=\"fontnormal font8\">(".$this->reviewfactor['evaluation']."%)</span>";
		echo "</td>";
		echo "<td width=\"14%\" align=center class=\"".$this->get_style($this->data['significance'])."\">";
		echo "<span class=\"fontlabel font10\">".ct('S_REVIEW_SHORT_SIGNIFICANCE')."</span><br>\n";
		echo "<span class=\"fontbold font10\">".$this->data['significance']."</span><br>\n";
		if ($this->reviewfactor['significance']>0) echo "<span class=\"fontnormal font8\">(".$this->reviewfactor['significance']."%)</span>";
		echo "</td>";
		echo "<td width=\"14%\" align=center class=\"".$this->get_style($this->data['originality'])."\">";
		echo "<span class=\"fontlabel font10\">".ct('S_REVIEW_SHORT_ORIGINALITY')."</span><br>\n";
		echo "<span class=\"fontbold font10\">".$this->data['originality']."</span><br>\n";
		if ($this->reviewfactor['originality']>0) echo "<span class=\"fontnormal font8\">(".$this->reviewfactor['originality']."%)</span>";
		echo "</td>";
		echo "<td width=\"14%\" align=center class=\"".$this->get_style($this->data['relevance'])."\">";
		echo "<span class=\"fontlabel font10\">".ct('S_REVIEW_SHORT_RELEVANCE')."</span><br>\n";
		echo "<span class=\"fontbold font10\">".$this->data['relevance']."</span><br>\n";
		if ($this->reviewfactor['relevance']>0) echo "<span class=\"fontnormal font8\">(".$this->reviewfactor['relevance']."%)</span>";
		echo "</td>";
		echo "<td width=\"14%\" align=center class=\"".$this->get_style($this->data['readability'])."\">";
		echo "<span class=\"fontlabel font10\">".ct('S_REVIEW_SHORT_READABILITY')."</span><br>\n";
		echo "<span class=\"fontbold font10\">".$this->data['readability']."</span><br>\n";
		if ($this->reviewfactor['readability']>0) echo "<span class=\"fontnormal font8\">(".$this->reviewfactor['readability']."%)</span>";
		echo "</td>";
		echo "<td width=\"14%\" align=center class=\"".$this->get_style($this->data['overall'])."\">";
		echo "<span class=\"fontlabel font10\">".ct('S_REVIEW_SHORT_OVERALL')."</span><br>\n";
		echo "<span class=\"fontbold font10\">".$this->data['overall']."</span><br>\n";
		if ($this->reviewfactor['overall']>0) echo "<span class=\"fontnormal font8\">(".$this->reviewfactor['overall']."%)</span>";
		echo "</td>";
		$total = $this->get_total();
		echo "<td width=\"16%\" align=center class=\"".$this->get_totalstyle()."\">";
		echo "<span class=\"fontlabel font10\">".ct('S_REVIEW_SHORT_TOTAL')."</span><br>\n";
		echo "<span class=\"fontbold font12\">".$total."</span></td></tr>\n";
	}
	

	// show overview of review results for one paper...
	function show_survey($reviews, $width="100%", $align="center") {
		global $session;
		$user =& $session->get_user();

		$this->_init();
		$rcount = count($reviews);
		$rwidth=15;
		if ($rcount>4) $rwidth=round(80/$rcount,0);

		echo "<table width=\"$width\" align=\"$align\" class=\"infoview_table\">\n";
		echo "<tr class=\"lightbg\"><td align=\"left\" valign=\"top\" colspan=2>\n";
		echo "<span class=\"fontlabel fontbold  font10\">".ct('S_PAPER_DETAILED_REVIEWSSECTION')."</span>\n";
		echo "</td></tr>\n";
		echo "<tr class=\"infoview_sep\"><td align=\"left\" valign=\"top\" colspan=2>";
		echo "<img src=\"spacer.gif\" width=1 height=1 border=0 alt=''>";
		echo "</td></tr>\n";
		
		echo "<tr><td align=\"left\" valign=\"top\" colspan=2>\n";
		echo "<table width=\"100%\" cellspacing=1 cellpadding=2 border=0>\n";

		// heading for review table
		echo "<tr class=\"listheader\"><td colspan=2 width=\"".(100-($rcount*$rwidth))."%\">\n<span class=\"listheader_label\">".ct('S_PAPER_DETAILED_QUESTIONHEADER')."</span></td>\n";
		for ($i=0; $i < $rcount; $i++) {
			$p = $reviews[$i]->get_reviewer();
			$access_to_reviewerdetails = ($user->is_admin() || $user->is_chair() || $user->is_conferenceChair() || $user->is_metareviewer_for($reviews[$i]->get('paperID')));

			echo "<td width=\"$rwidth%\" align=\"center\"><a class=\"listheader_label\" ";
			echo "href=\"".ct_pageurl("reviewDetails",array("form_paperID"=>$reviews[$i]->data['paperID'], "form_personID"=>$reviews[$i]->data['personID']))."\"";
			if ( $access_to_reviewerdetails ) echo "title=\"".ct_form_encode($p->get_fullname())."\"";
			echo ">";
			if ($rcount>5) echo '<span class="font8">'; else  echo '<span class="font10">';
			if ($reviews[$i]->get('reviewtype')=='meta') 
				echo "<u>".ct('S_PAPER_DETAILED_METAREVIEWHEADER')."&nbsp;".($i+1)."</u></span></a><BR>";
			else
				echo "<u>".ct('S_PAPER_DETAILED_REVIEWHEADER')."&nbsp;".($i+1)."</u></span></a><BR>";

			if ($p->get_id()==$user->get_id()) {
				echo "<span class=\"fontbold font8\">".ct('S_PAPER_DETAILED_YOURREVIEW')."</span>";
			} elseif ( $access_to_reviewerdetails )
				echo "<span class=\"fontnormal font8\">".ct_form_encode($p->get_shortname())."</span>";

			echo "</td>\n";
		}
		echo "</tr>\n";
		
		// reviewers familiarity with subject
	/*	echo "<tr class=\"oddrow\"><td colspan=2 width=\"".(100-($rcount*15))."%\">\n<span class=\"fontbold font10\">".ct('S_REVIEW_FORM_FAMILIARITY_LABEL')."</span></td>\n";
		for ($i=0; $i < $rcount; $i++) {
			echo "<td width=\"$rwidth%\" class=\"".$reviews[$i]->get_style($reviews[$i]->data['familiarity'])."\" align=center>";
			echo "<span class=\"fontbold font12\">".$reviews[$i]->data['familiarity']."</span></td>\n";
		}
		echo "</tr>\n";	*/

		// evaluation
		echo "<tr class=\"evenrow\"><td width=\"".(100-($rcount*$rwidth)-7)."%\">\n<span class=\"fontbold font10\">".ct('S_REVIEW_SHORT_EVALUATION')."</span></td>\n";
		echo "<td width=\"7%\" align=center><span class=\"fontnormal font10\">".$this->reviewfactor['evaluation']."%</span></td>\n";
		for ($i=0; $i < $rcount; $i++) {
			echo "<td width=\"$rwidth%\" class=\"".$reviews[$i]->get_style($reviews[$i]->data['evaluation'])."\" align=center>";
			echo "<span class=\"fontbold font12\">".$reviews[$i]->data['evaluation']."</span></td>\n";
		}
		echo "</tr>\n";

		// significance
		echo "<tr class=\"oddrow\"><td width=\"".(100-($rcount*$rwidth)-7)."%\">\n<span class=\"fontbold font10\">".ct('S_REVIEW_SHORT_SIGNIFICANCE')."</span></td>\n";
		echo "<td width=\"7%\" align=center><span class=\"fontnormal font10\">".$this->reviewfactor['significance']."%</span></td>\n";
		for ($i=0; $i < $rcount; $i++) {
			echo "<td width=\"$rwidth%\" class=\"".$reviews[$i]->get_style($reviews[$i]->data['significance'])."\" align=center>";
			echo "<span class=\"fontbold font12\">".$reviews[$i]->data['significance']."</span></td>\n";
		}
		echo "</tr>\n";

		// originality
		echo "<tr class=\"evenrow\"><td width=\"".(100-($rcount*$rwidth)-7)."%\">\n<span class=\"fontbold font10\">".ct('S_REVIEW_SHORT_ORIGINALITY')."</span></td>\n";
		echo "<td width=\"7%\" align=center><span class=\"fontnormal font10\">".$this->reviewfactor['originality']."%</span></td>\n";
		for ($i=0; $i < $rcount; $i++) {
			echo "<td width=\"$rwidth%\" class=\"".$reviews[$i]->get_style($reviews[$i]->data['originality'])."\" align=center>";
			echo "<span class=\"fontbold font12\">".$reviews[$i]->data['originality']."</span></td>\n";
		}
		echo "</tr>\n";

		// relevance
		echo "<tr class=\"oddrow\"><td width=\"".(100-($rcount*$rwidth)-7)."%\">\n<span class=\"fontbold font10\">".ct('S_REVIEW_SHORT_RELEVANCE')."</span></td>\n";
		echo "<td width=\"7%\" align=center><span class=\"fontnormal font10\">".$this->reviewfactor['relevance']."%</span></td>\n";
		for ($i=0; $i < $rcount; $i++) {
			echo "<td width=\"$rwidth%\" class=\"".$reviews[$i]->get_style($reviews[$i]->data['relevance'])."\" align=center>";
			echo "<span class=\"fontbold font12\">".$reviews[$i]->data['relevance']."</span></td>\n";
		}
		echo "</tr>\n";

		// readability
		echo "<tr class=\"evenrow\"><td width=\"".(100-($rcount*$rwidth)-7)."%\">\n<span class=\"fontbold font10\">".ct('S_REVIEW_SHORT_READABILITY')."</span></td>\n";
		echo "<td width=\"7%\" align=center><span class=\"fontnormal font10\">".$this->reviewfactor['readability']."%</span></td>\n";
		for ($i=0; $i < $rcount; $i++) {
			echo "<td width=\"$rwidth%\" class=\"".$reviews[$i]->get_style($reviews[$i]->data['readability'])."\" align=center>";
			echo "<span class=\"fontbold font12\">".$reviews[$i]->data['readability']."</span></td>\n";
		}
		echo "</tr>\n";

		// overall
		echo "<tr class=\"oddrow\"><td width=\"".(100-($rcount*$rwidth)-7)."%\">\n<span class=\"fontbold font10\">".ct('S_REVIEW_SHORT_OVERALL')."</span></td>\n";
		echo "<td width=\"7%\" align=center><span class=\"fontnormal font10\">".$this->reviewfactor['overall']."%</span></td>\n";
		for ($i=0; $i < $rcount; $i++) {
			echo "<td width=\"$rwidth%\" class=\"".$reviews[$i]->get_style($reviews[$i]->data['overall'])."\" align=center>";
			echo "<span class=\"fontbold font12\">".$reviews[$i]->data['overall']."</span></td>\n";
		}
		echo "</tr>\n";

		// total
		echo "<tr class=\"evenrow\"><td width=\"".(100-($rcount*$rwidth))."%\" colspan=2>\n<span class=\"fontbold font12\">".ct('S_REVIEW_SHORT_TOTAL')."</span></td>\n";
		for ($i=0; $i < $rcount; $i++) {
			echo "<td width=\"$rwidth%\" align=center>";
			echo "<span class=\"fontbold font14\">".$reviews[$i]->get_total()."</span></td>\n";
		}
		echo "</tr>\n";
		
		echo "</table>\n";

		echo "</td></tr>\n";
		echo "</table>\n";
		
		
	}

	/**
	 * Show header fror review results
	 *
	 * @param int $number Number to be displayed in header
	 * @param string $width width of header
	 * @param string $align alignment of header
	 */
	function show_detailed_header($number, $width="100%", $align="center") {
			echo "<table width=\"$width\" align=\"center\" class=\"infoview_table\">\n";
			echo "<tr class=\"listheader\"><td align=\"left\" valign=\"top\" colspan=2>\n";
			echo "<span class=\"fontbold font12\">";
			echo ct('S_PAPER_DETAILED_REVIEWHEADER');
			echo "&nbsp;".($number)."</span>\n";
			if ($this->get('reviewtype')=='meta') {
				echo "<span class=\"fontbold font12\">(";
				echo ct('S_PAPER_DETAILED_METAREVIEWHEADER');
				echo ")</span>";
			}				
			echo "</td></tr>\n";
			echo "</table>\n";
	}

	
	/**
	 * show detailed information on one review including info on the reviewer (if user has the rights)
	 * Calls show_infobox
	 */
	function show_detailed($width="100%", $align="center") {
		global $session, $ctconf;
		$this->_init();
	
		$user =& $session->get_user();
		
		if ($user->is_chair() || $user->is_conferenceChair() || $user->is_admin() || 
				$user->get_id()==$this->get('personID') ||
				$user->is_metareviewer_for($this->get('paperID'))) {
			echo "<table width=\"$width\" align=\"$align\" class=\"infoview_table\">\n";
			echo "<tr class=\"lightbg\"><td align=\"left\" valign=\"top\" colspan=2>\n";
			echo "<span class=\"fontlabel fontbold  font10\">".ct('S_REVIEW_DETAILED_REVIEWERSECTION')."</span>\n";
			echo "</td></tr>\n";
			echo "<tr class=\"infoview_sep\"><td align=\"left\" valign=\"top\" colspan=2>";
			echo "<img src=\"spacer.gif\" width=1 height=1 border=0 alt=''>";
			echo "</td></tr>\n";
			echo "<tr class=\"oddrow\"><td align=\"left\" valign=\"top\" width=\"80%\" colspan=2>\n";
			$reviewer = $this->get_reviewer();
			if ($user->is_admin() || $user->is_conferenceChair() || $user->is_chair()) 
				echo "<a href=\"".ct_pageurl("adminUsersPCDetails", array("form_id"=>$reviewer->get('ID')))."\" class=\"fontbold font12\">".ct_form_encode($reviewer->get_fullname())."</a><br>\n";
			else
				echo "<span class=\"fontbold font12\">".ct_form_encode($reviewer->get_fullname())."</span><br>\n";
			echo "<span class=\"fontbold font10\">(".$reviewer->get_special('organisation').")</span><br>";
			echo "<span	class=\"fontnormal font10\"><a href=\"mailto:".$reviewer->get_special('email')."\">";
			echo $reviewer->get_special('email')."</a>\n";
			echo "</td></tr>\n";
			echo "</table>\n";
		}
		$this->show_infobox($width,$align);		
	}
	
	/**
	 * Infobox shows "only" the details of the review result
	 */
	function show_infobox($width="100%", $align="center") {
		global $session, $ctconf;
		$this->_init();
	
		$user =& $session->get_user();
		$paper = $this->get_paper();
		$author = $paper->get_author();

		echo "<table width=\"$width\" align=\"$align\" class=\"infoview_table\">\n";
		echo "<tr class=\"lightbg\"><td align=\"left\" valign=\"top\" colspan=2>\n";
		echo "<span class=\"fontlabel fontbold  font10\">".ct('S_REVIEW_DETAILED_RESULTSECTION')."</span>\n";
		echo "</td></tr>\n";
		echo "<tr class=\"infoview_sep\"><td align=\"left\" valign=\"top\" colspan=2>";
		echo "<img src=\"spacer.gif\" width=1 height=1 border=0 alt=''>";
		echo "</td></tr>\n";
		echo "<tr class=\"oddrow\"><td align=\"left\" valign=\"top\" width=\"80%\" colspan=2>\n";
		echo "<table width=\"100%\">";
		$this->show_row();
		echo "</table>\n";
		echo "</td></tr>\n";
		echo "</table>\n";
		
		echo "<table width=\"$width\" align=\"$align\" class=\"infoview_table\">\n";
		echo "<tr class=\"lightbg\"><td align=\"left\" valign=\"top\" colspan=2>\n";
		echo "<span class=\"fontlabel fontbold  font10\">".ct('S_REVIEW_DETAILED_COMMENTSECTION')."</span>\n";
		echo "</td></tr>\n";
		echo "<tr class=\"infoview_sep\"><td align=\"left\" valign=\"top\" colspan=2>";
		echo "<img src=\"spacer.gif\" width=1 height=1 border=0 alt=''>";
		echo "</td></tr>\n";
		echo "<tr class=\"oddrow\"><td align=\"left\" valign=\"top\" width=\"80%\" colspan=2>\n";
		$reviewer = $this->get_reviewer();
		echo "<span class=\"fontlabel font10\">".ct('S_REVIEW_FORM_AUTHORCOMMENTS_LABEL').":</span><br>\n";
		echo "<span class=\"fontnormal font10\">".ct_nl2br($this->get('authorcomments'))."&nbsp;</span><br>\n";
		
		if ($user->is_conferenceChair() || $user->is_chair() || $user->is_admin() || // They may always access all data
			($user->is_pc() && $author->get_id()!=$user->get_id()) || // PC Members may see internal details from other PC members if it is not their own contribution...
			 $user->get_id()==$this->get('personID')) { //  seeing the data you entered yourself is OK
			echo "<hr size=1 noshade>\n";
			echo "<span class=\"fontlabel font10\">".ct('S_REVIEW_FORM_PCCOMMENTS_LABEL').":</span><br>\n";
			echo "<span class=\"fontnormal font10\">".ct_nl2br($this->get('pccomments'))."&nbsp;</span>\n";
			if ($this->get('bestpaper')) {
				echo "<hr size=1 noshade>\n";
				echo "<span class=\"fontlabel font10\">".ct('S_REVIEW_FORM_BESTPAPER').":</span><br>\n";
				echo "<span class=\"fontnormal font10\">".ct('S_REVIEW_FORM_BESTPAPER_INFO')."</span>\n";
			}
		}
		echo "</td></tr>\n";
		echo "</table>\n";
	}

	/**
	 * Get result as text, e.g. for mails
	 */
	function get_resulttext() {
		global $session;
		$this->_init();
		
		$text="";

		$user =& $session->get_user();
		$paper = $this->get_paper();
		$author = $paper->get_author();

		$text .= ct('S_REVIEW_DETAILED_RESULTSECTION')."\n";
		$text .= str_repeat("-",strlen(ct('S_REVIEW_DETAILED_RESULTSECTION')))."\n";

		$maxlen = max(array_map('strlen',array(ct('S_REVIEW_SHORT_EVALUATION'),ct('S_REVIEW_SHORT_SIGNIFICANCE'),ct('S_REVIEW_SHORT_ORIGINALITY'),ct('S_REVIEW_SHORT_RELEVANCE'),ct('S_REVIEW_SHORT_READABILITY'),ct('S_REVIEW_SHORT_OVERALL'),ct('S_REVIEW_SHORT_TOTAL'))));
		if ($maxlen>60) $maxlen=60;
		
		$text .= str_pad(ct('S_REVIEW_SHORT_EVALUATION'),$maxlen);
		$text .= $this->_get_factortext('evaluation');
		$text .= $this->data['evaluation']."\n";

		$text .= str_pad(ct('S_REVIEW_SHORT_SIGNIFICANCE'),$maxlen);
		$text .= $this->_get_factortext('significance');
		$text .= $this->data['significance']."\n";

		$text .= str_pad(ct('S_REVIEW_SHORT_ORIGINALITY'),$maxlen);
		$text .= $this->_get_factortext('originality');
		$text .= $this->data['originality']."\n";

		$text .= str_pad(ct('S_REVIEW_SHORT_RELEVANCE'),$maxlen);
		$text .= $this->_get_factortext('relevance');
		$text .= $this->data['relevance']."\n";

		$text .= str_pad(ct('S_REVIEW_SHORT_READABILITY'),$maxlen);
		$text .= $this->_get_factortext('readability');
		$text .= $this->data['readability']."\n";

		$text .= str_pad(ct('S_REVIEW_SHORT_OVERALL'),$maxlen);
		$text .= $this->_get_factortext('overall');
		$text .= $this->data['overall']."\n";

		$total = $this->get_total();
		$text .= str_pad(ct('S_REVIEW_SHORT_TOTAL'),$maxlen+6).": ";
		$text .= $total."\n";
		
		$text .= "\n\n";

		$text .= ct('S_REVIEW_FORM_AUTHORCOMMENTS_LABEL')."\n";
		$text .= str_repeat("-",strlen(ct('S_REVIEW_FORM_AUTHORCOMMENTS_LABEL')))."\n";
		$text .= $this->get('authorcomments');
		if ($this->get('authorcomments')=='') $text .= "--";

		$text .= "\n\n\n";
		
		return $text;
	}
	

	function _get_factortext($criteria) {
		if ($this->reviewfactor[$criteria]>0) 
			return " (".sprintf("%02d",$this->reviewfactor[$criteria])."%): ";
		else 
			return "       ";
	}
	
	
	
	//#### form processing ######################################################
	
	function process_form($ignore_errors=false) {
		global $http, $session;
		$this->_init();
		
		$this->errors = array();
		$okay = true;
		
		$this->set('paperID', $http['form_paperID']);
		$this->set('personID', $http['form_personID']);
		$this->set('creationdate', $http['form_creationdate']);
		$okay &= $this->_require('evaluation', 'form_evaluation');
		$okay &= $this->_require('significance', 'form_significance');
		$okay &= $this->_require('originality', 'form_originality');
		$okay &= $this->_require('relevance', 'form_relevance');
		$okay &= $this->_require('readability', 'form_readability');
		$okay &= $this->_require('overall', 'form_overall');
		$this->set('bestpaper', $http['form_bestpaper']);  // non-obligatory
		$this->set('familiarity', '10');
		$okay &= $this->_require('authorcomments', 'form_authorcomments');
		// $okay &= $this->_require('pccomments', 'form_pccomments');
		$this->set('pccomments', $http['form_pccomments']);
		
		if ($ignore_errors) {
			return false;
		} else {
			if ($okay) {
				return false;
			} else {
				return $this->errors;
			}
		}
	}
	
	function show_reviewform($width="100%", $errors = array()) {
		ct_load_class('CTForm');
		global $ctconf;
		$this->_init();
		
		$form = new CTForm(ct_pageurl('saveReview'), 'post', $errors);
		$form->align="center";
		$form->width=$width;
		$form->formname='review';
		$form->warningmessage=true;
		
		$form->add_hidden(array(array('form_paperID', $this->data['paperID']),
		array('form_personID', $this->data['personID']),
		array('form_creationdate', $this->data['creationdate'])));
		
		$paper = $this->get_paper();
		$ctype = $paper->_get_contributiontype();
		
		$form->add_separator(ct('S_REVIEW_FORM_INFOSEP'));
		$form->add_label(ct('S_REVIEW_FORM_ID_LABEL'), "<b>".$paper->get('ID')."</b>");
		$form->add_label(ct('S_PAPER_FORM_CONTRIBUTIONTYPE'), "<b>".ct_form_encode($ctype[ctlx($ctype,'title')])."</b>");
		$form->add_label(ct('S_REVIEW_FORM_TITLE_LABEL'), "<b>".$paper->get_special('title')."</b>");
		// The following line displays the authors of the contribution in the
		// review form unless anonymous reviewing.
		if ($ctype['review_anonymous']=='false') {
			$form->add_label(ct('S_REVIEW_FORM_AUTHOR_LABEL'), $paper->get_special('author'));
		}
		if (count($paper->get_topics())>0)
			$form->add_label(ct('S_REVIEW_FORM_TOPICS_LABEL'), ct_form_encode(implode(", ", $paper->get_topics())));
		if ($paper->get('keywords')!="")
			$form->add_label(ct('S_REVIEW_FORM_KEYWORDS_LABEL'), $paper->get_special('keywords'));
		
		// The review scale
		$form->add_separator(ct('S_REVIEW_FORM_VOTESEP'));
		
		$form->add_radio("* ".ct('S_REVIEW_FORM_EVALUATION_LABEL').'<br></span><span class="form_label_sub">'.$this->reviewfactor['evaluation'].'%','form_evaluation',
		array(
		array('10',ct('S_REVIEW_FORM_EVALUATION_10')),
		// array('9',ct('S_REVIEW_FORM_EVALUATION_9')),
		array('8',ct('S_REVIEW_FORM_EVALUATION_8')),
		// array('7',ct('S_REVIEW_FORM_EVALUATION_7')),
		array('6',ct('S_REVIEW_FORM_EVALUATION_6')),
		// array('5',ct('S_REVIEW_FORM_EVALUATION_5')),
		array('4',ct('S_REVIEW_FORM_EVALUATION_4')),
		// array('3',ct('S_REVIEW_FORM_EVALUATION_3')),
		array('2',ct('S_REVIEW_FORM_EVALUATION_2')),
		// array('1',ct('S_REVIEW_FORM_EVALUATION_1')),
		array('0',ct('S_REVIEW_FORM_EVALUATION_0'))), $this->data['evaluation'],
		ct('S_REVIEW_FORM_EVALUATION_HINT')
		);
		
		$form->add_radio("* ".ct('S_REVIEW_FORM_SIGNIFICANCE_LABEL').'<br></span><span class="form_label_sub">'.$this->reviewfactor['significance'].'%','form_significance',
		array(	array('10',ct('S_REVIEW_FORM_SIGNIFICANCE_10')),
		// array('9',ct('S_REVIEW_FORM_SIGNIFICANCE_9')),
		array('8',ct('S_REVIEW_FORM_SIGNIFICANCE_8')),
		// array('7',ct('S_REVIEW_FORM_SIGNIFICANCE_7')),
		array('6',ct('S_REVIEW_FORM_SIGNIFICANCE_6')),
		// array('5',ct('S_REVIEW_FORM_SIGNIFICANCE_5')),
		array('4',ct('S_REVIEW_FORM_SIGNIFICANCE_4')),
		// array('3',ct('S_REVIEW_FORM_SIGNIFICANCE_3')),
		array('2',ct('S_REVIEW_FORM_SIGNIFICANCE_2')),
		// array('1',ct('S_REVIEW_FORM_SIGNIFICANCE_1')),
		array('0',ct('S_REVIEW_FORM_SIGNIFICANCE_0'))), $this->data['significance'],
		ct('S_REVIEW_FORM_SIGNIFICANCE_HINT')
		);
		
		$form->add_radio("* ".ct('S_REVIEW_FORM_ORIGINALITY_LABEL').'<br></span><span class="form_label_sub">'.$this->reviewfactor['originality'].'%','form_originality',
		array(	array('10',ct('S_REVIEW_FORM_ORIGINALITY_10')),
		// array('9',ct('S_REVIEW_FORM_ORIGINALITY_9')),
		array('8',ct('S_REVIEW_FORM_ORIGINALITY_8')),
		// array('7',ct('S_REVIEW_FORM_ORIGINALITY_7')),
		array('6',ct('S_REVIEW_FORM_ORIGINALITY_6')),
		// array('5',ct('S_REVIEW_FORM_ORIGINALITY_5')),
		array('4',ct('S_REVIEW_FORM_ORIGINALITY_4')),
		// array('3',ct('S_REVIEW_FORM_ORIGINALITY_3')),
		array('2',ct('S_REVIEW_FORM_ORIGINALITY_2')),
		// array('1',ct('S_REVIEW_FORM_ORIGINALITY_1')),
		array('0',ct('S_REVIEW_FORM_ORIGINALITY_0'))), $this->data['originality'],
		ct('S_REVIEW_FORM_ORIGINALITY_HINT')
		);
		
		$form->add_radio("* ".ct('S_REVIEW_FORM_RELEVANCE_LABEL').'<br></span><span class="form_label_sub">'.$this->reviewfactor['relevance'].'%','form_relevance',
		array(	array('10',ct('S_REVIEW_FORM_RELEVANCE_10')),
		// array('9',ct('S_REVIEW_FORM_RELEVANCE_9')),
		array('8',ct('S_REVIEW_FORM_RELEVANCE_8')),
		// array('7',ct('S_REVIEW_FORM_RELEVANCE_7')),
		array('6',ct('S_REVIEW_FORM_RELEVANCE_6')),
		// array('5',ct('S_REVIEW_FORM_RELEVANCE_5')),
		array('4',ct('S_REVIEW_FORM_RELEVANCE_4')),
		// array('3',ct('S_REVIEW_FORM_RELEVANCE_3')),
		array('2',ct('S_REVIEW_FORM_RELEVANCE_2')),
		// array('1',ct('S_REVIEW_FORM_RELEVANCE_1')),
		array('0',ct('S_REVIEW_FORM_RELEVANCE_0'))), $this->data['relevance'],
		ct('S_REVIEW_FORM_RELEVANCE_HINT')
		);
		
		
		$form->add_radio("* ".ct('S_REVIEW_FORM_READABILITY_LABEL').'<br></span><span class="form_label_sub">'.$this->reviewfactor['readability'].'%','form_readability',
		array(	array('10',ct('S_REVIEW_FORM_READABILITY_10')),
		// array('9',ct('S_REVIEW_FORM_READABILITY_9')),
		array('8',ct('S_REVIEW_FORM_READABILITY_8')),
		// array('7',ct('S_REVIEW_FORM_READABILITY_7')),
		array('6',ct('S_REVIEW_FORM_READABILITY_6')),
		// array('5',ct('S_REVIEW_FORM_READABILITY_5')),
		array('4',ct('S_REVIEW_FORM_READABILITY_4')),
		// array('3',ct('S_REVIEW_FORM_READABILITY_3')),
		array('2',ct('S_REVIEW_FORM_READABILITY_2')),
		// array('1',ct('S_REVIEW_FORM_READABILITY_1')),
		array('0',ct('S_REVIEW_FORM_READABILITY_0'))), $this->data['readability'],
		ct('S_REVIEW_FORM_READABILITY_HINT')
		);
		
		
		$form->add_separator(ct('S_REVIEW_FORM_OVERALLSEP'));
		$form->add_radio("* ".ct('S_REVIEW_FORM_OVERALL_LABEL').'<br></span><span class="form_label_sub">'.$this->reviewfactor['overall'].'%','form_overall',
		array(	array('10',ct('S_REVIEW_FORM_OVERALL_10')),
		#array('9',ct('S_REVIEW_FORM_OVERALL_9')),
		array('8',ct('S_REVIEW_FORM_OVERALL_8')),
		#array('7',ct('S_REVIEW_FORM_OVERALL_7')),
		array('6',ct('S_REVIEW_FORM_OVERALL_6')),
		#array('5',ct('S_REVIEW_FORM_OVERALL_5')),
		array('4',ct('S_REVIEW_FORM_OVERALL_4')),
		#array('3',ct('S_REVIEW_FORM_OVERALL_3')),
		array('2',ct('S_REVIEW_FORM_OVERALL_2')),
		#array('1',ct('S_REVIEW_FORM_OVERALL_1')),
		array('0',ct('S_REVIEW_FORM_OVERALL_0'))), $this->data['overall'],
		ct('S_REVIEW_FORM_OVERALL_HINT')
		);

		#$form->add_check(ct('S_REVIEW_FORM_BESTPAPER'), array(array('form_bestpaper','1',ct('S_REVIEW_FORM_BESTPAPER_HINT'),$this->data['bestpaper'])));
		
		$form->add_separator(ct('S_REVIEW_FORM_COMMENTSSEP'));
		$form->add_textarea("* ".ct('S_REVIEW_FORM_AUTHORCOMMENTS_LABEL'), 'form_authorcomments',$this->get('authorcomments'), 70, 15, ct('S_REVIEW_FORM_AUTHORCOMMENTS_HINT'));
		
		$form->add_separator(ct('S_REVIEW_FORM_INTERNALSEP'));
/*		$form->add_radio("* ".ct('S_REVIEW_FORM_FAMILIARITY_LABEL'),'form_familiarity',
		array(	array('10',ct('S_REVIEW_FORM_FAMILIARITY_10')),
		// array('9',ct('S_REVIEW_FORM_FAMILIARITY_9')),
		array('8',ct('S_REVIEW_FORM_FAMILIARITY_8')),
		// array('7',ct('S_REVIEW_FORM_FAMILIARITY_7')),
		array('6',ct('S_REVIEW_FORM_FAMILIARITY_6')),
		// array('5',ct('S_REVIEW_FORM_FAMILIARITY_5')),
		array('4',ct('S_REVIEW_FORM_FAMILIARITY_4')),
		// array('3',ct('S_REVIEW_FORM_FAMILIARITY_3')),
		array('2',ct('S_REVIEW_FORM_FAMILIARITY_2')),
		// array('1',ct('S_REVIEW_FORM_FAMILIARITY_1')),
		array('0',ct('S_REVIEW_FORM_FAMILIARITY_0'))), $this->data['familiarity'],
		ct('S_REVIEW_FORM_FAMILIARITY_HINT')
		);		*/
		
		$form->add_textarea(ct('S_REVIEW_FORM_PCCOMMENTS_LABEL'), 'form_pccomments', $this->get('pccomments'), 70, 7, ct('S_REVIEW_FORM_PCCOMMENTS_HINT'));
		
		$form->add_submit('cmd_savereview', ct('S_REVIEW_FORM_SAVECMD'));
		$form->add_reset(ct('S_REVIEW_FORM_RESETCMD'));
		
		$form->show();
	}
	
}

?>