<?php
//
// ***** CONFIGURATON ************************************
//
// edit the information in this section according to your
// installation.
//
// Lines starting with // or # are remarks and examples.


// --- paths -----------

// [paths/prefix] points to the installation path for the
// conftool. This should be an absolute path.
// This is usually the only value you change in this section.
$ctconf['paths/prefix'] = '/home/conftool/';
// For Windows, e.g.:
#$ctconf['paths/prefix'] = 'D:/www/conftool/';

// [paths/etc] points to the directory where configuration
// files and language files are found. Relative path is
// appended to [paths/prefix].
$ctconf['paths/etc'] = 'etc/';

// [paths/uploads] is a directory where the tool will
// store files uploaded by users when they submit a paper
// to the conference.
$ctconf['paths/uploads'] = 'uploads/';

// [paths/lib] points to the directory, where class
// definitions and other libraries can be found. A relative
// path is appended to the [paths/prefix] directory.
$ctconf['paths/lib'] = 'lib/';

// [paths/lib] points to the directory, where class
// definitions and other libraries can be found. A relative
// path is appended to the [paths/prefix] directory.
$ctconf['paths/classes'] = 'classes/';

// [paths/pages] points to the directory, where page
// definitions can be found that are included by the
// dispatcher page. A relative path is appended to the
// [paths/preifx] directory.
$ctconf['paths/pages'] = 'pages/';



// --- database -----------

// [db/dbms] sets which DBMS should be used. Mappings to
// different databases are provided as library files that
// implement generic db-functions. At the moment, only mysql
// is supported.
$ctconf['db/dbms'] = 'mysql';

// [db/dbhost] holds the server's name where the database server
// is running.
$ctconf['db/host'] = 'localhost';

// [db/dbport] is the port number where the database server
// can be reached.
$ctconf['db/port'] = 3306;

// [db/database] is the name of the database on the DBMS where
// the conftool stores its data.
$ctconf['db/database'] = 'conference';

// [db/username] is the username used when connecting to the
// database server.
$ctconf['db/username'] = 'confuser';

// [db/password] is the password used when connecting to the
// server.
$ctconf['db/password'] = 'confpass';



// --- web ---------------

// [web/baseurl] is the absolute URL where the index-page can be found.
// ATTENTION: Leave empty if you want to disable a redirect to this URL and
// let conftool use the current URL als base URL.
#$ctconf['web/baseurl'] = 'http://yourdomain.edu/conftool/';
$ctconf['web/baseurl'] = '';

// Set to true if you use https AND have problems with downloading paper with
// Internet Explorer. This will force http for the downloads as workaround for
// the https bug in IE and certain PHP settings.
$ctconf['web/forcehttpdownloads'] = false;

// Do you want ConfTool to Redirect requests to the above defined baseurl?
// Only set to false if you have e.g. a firewall which recodes the http headers...
$ctconf['web/redirecttobaseurl'] = true;  // Has no effect if baseurl is not defined.

// A short string to identify the session name of this conftool instance.
// Just leave empty if you have only one conference on your server, otherwise
// Use a unique short alphanumeric string in upper case.
$ctconf['web/sessionname'] = '';  // leave empty if you handle only one conference.



// --- language, charset, decimal symbols, currency encoding etc. -----------

// Character set of language files. All applied files have to use the same
// character set, otherwise the database output is faulty.
// $ctconf['charset']='UTF-8';	// Supports all characters, use according language files.
$ctconf['charset']='iso-8859-1'; 	// Default for english, german, spanish, french


// This sections sets the language to be used for the tool.
// A corresponding language definition file must be available
// in [paths/etc]. If the language is set to 'german', there
// has to be a file called 'german.lang'.
// A maximum of 4 languages is supported. As default only English and German are enabled.

// Fields of the array:
// 1. "language":  Internal name of the language (and the language file)
// 2. "languages": Sub-Array with the names of the languages for the Conftool header
// 3. "currency/decimals": Number of decimals (for currencies)
// 4. "currency/thousands_separator": Thousands separator symbol, e.g. "1.000,00 Euro"
// 5. "currency/decimal_separator": Symbol to separater the decimals
// 6. "currency/style": Style for currency output: 0="EUR 123.50", 1="123.50 EUR"
// 7. "dateformat": Short dateformat (see php manual for coding)
// 8. "datefimeformat": Format to show date AND time.

$ctconf['lang'] = array();
$ctconf['lang']['1'] = array('language'=>'english','languages'=>array('English','German','Spanish','French')       ,'currency/decimals'=>'2','currency/thousands_separator'=>',','currency/decimal_separator'=>'.','dateformat'=>'d/m/Y','datetimeformat'=>'jS M Y, h:i:sa','timeformat'=>'g:ia','currency/style'=>'0');
#$ctconf['lang']['2'] = array('language'=>'german','languages'=>array('Englisch','Deutsch','Spanisch','Franzsisch'),'currency/decimals'=>'2','currency/thousands_separator'=>'.','currency/decimal_separator'=>',','dateformat'=>'d.m.Y','datetimeformat'=>'d.M Y H:i:s','timeformat'=>'G:i','currency/style'=>'1');
#$ctconf['lang']['3'] = array('language'=>'spanish','languages'=>array('Ingls','Alemn','Espaol','Francs')     ,'currency/decimals'=>'2','currency/thousands_separator'=>'','currency/decimal_separator'=>','   ,'dateformat'=>'d/m/Y','datetimeformat'=>'d/m/Y H:i:s','timeformat'=>'G:i','currency/style'=>'0');
#$ctconf['lang']['4'] = array('language'=>'french','languages'=>array('Anglais','Allemand','Espagnol','Franais')    ,'currency/decimals'=>'2','currency/thousands_separator'=>'','currency/decimal_separator'=>',','dateformat'=>'d.m.Y','datetimeformat'=>'d.m.Y H:i:s','timeformat'=>'G:i','currency/style'=>'0');

$ctconf['lang/default'] = '1';  // Number of the default language...



// web/favoritecountries are the countries listed first in the select box.
// Either you just use array values like "DE" and the default names will be used or
// you use associative key-value pairs where the key sets the favorite while the value
// replaces the original value from the list in "addresses.lib". Example "DE"=>"Deutschland"
#$ctconf['web/favoritecountries'] = array('DE','AT','CH','US');
$ctconf['web/favoritecountries'] = array();

// [web/defaultcountry] is the default country for the registration process, use ISO code
#$ctconf['web/defaultcountry'] = 'DE';
$ctconf['web/defaultcountry'] = '';  // leave empty for no default country.


// [conferenceKey] is the key to encrypt some of the database data
// e.g. the credit card details and to access some public but personal
// pages, e.g. the invoice.
// Use any unique string, but do NOT change it after system setup, once you have
// selected a key! The key has to be at least 10 characters long!
# Example: $ctconf['conferenceKey'] = 'MyCoNfErEnCe'; // use a secrect key for your conference.
$ctconf['conferenceKey'] = '';


// --- E-mail settings -------------

//  Main e-mail contact address for your conference. Please replace!!
$ctconf['mail/contact'] = 'info@conftool.net';

// Your SMTP host
$ctconf['mail/smtphost'] = 'localhost';
#$ctconf['mail/smtpport'] = 587;

// SMTP Authentification required?
$ctconf['mail/SMTPAuth'] = false;
#$ctconf['mail/username'] = 'username';
#$ctconf['mail/password'] = 'password';

// Send a BCC of every email to the following address (leave empty to disable)
$ctconf['mail/bcc'] = ''; # example: 'mail-backups@yourconference.org';

// Do also check the existance of the domain name of the e-mail address
// during user registration?
// Disable this if you have problem entering emails or registering new
// users (as it does not work an all systems).
$ctconf['mail/checkdns'] = true;



// --- Paper submission -----------

// Do you want to use paper submissions at all?
$ctconf['submission/enabled'] = true;

// Limit the maximum file size for uploads.
// You may also have to modify php.ini or .htacces or settings.php!!
// (see installation instructions and FAQs!)
$ctconf['paperupload/maxsize'] = 10000000;



// --- participant registration ------------

// Shall the participant registration be enabled or disabled for this conference.
// Only disable, if you don't need it at all.
$ctconf['participation/enabled'] = true;

// Request payment information during registration.
// If set to FALSE all participants can register for free and no payment information will be shown.
$ctconf['payment/enabled'] = true; // TRUE or FALSE

// Are users allowed to edit and delete their participation as long as payment was not registered?
// Usually DO NOT ENABLE THIS, AS REGISTRATIONS SHOULD BE BINDING!
// The problem is, that invoices and changes are not (yet) recorded. User edits may lead to confusion and incorrect data!
$ctconf['participation/useredit']   = false;
$ctconf['participation/userdelete'] = false;

// Is the registration confirmation, pro forma invoice and invoice accessible to
// the registered participant (Usually TRUE, except you only want to send it by mail to them).
$ctconf['participation/invoices'] = true;

// "Identity management" (participants may state their contact
// details like ICQ etc. and upload a picture - usually not required.
$ctconf['participation/identities'] = false;



// --- Debug options ------

$ctconf['demomode']=false;		 # lock critical backoffice functions
$ctconf['language/debug']=false; # reload language file for every page (SLOW!)
$ctconf['display/debug']=false;	 # show all queries.
$ctconf['offline']=false;  		 # use to set temporarily offline
$ctconf['offline/message']="<H3>The System is currently undergoing maintenance.</h3><h4>Please come back in about 5 minutes</h4>";  # Custom message



// -------------------------------------------

#==========================================================================
#
# User-configuration ends here.
#
#==========================================================================

# ATTENTION: Avoid any empty line after the next line!
?>