<?php
//
// functions for use on administrative pages
//


// list all users
function ctadm_listusers($res, $page) {
	global $db, $http, $ctconf;
	
	$person     = new CTPerson;
	$items      = $db->num_rows($res);

	ct_load_lib('navbar.lib');
	ct_navbar($page,$items);
	$perpage    = isset($http['navbar_perpage']) && $http['navbar_perpage']!=""?$http['navbar_perpage']:ctconf_get('display_perpage',20);
	$pageno     = isset($http['navbar_page'])?$http['navbar_page']:0; // default is 0
	$maxpage    = intval(($items-1)/($perpage));
	
	$page_i     = 0;
	
	if (($res) && ($db->num_rows($res) > 0)) {
		echo "<table width=\"100%\" cellspacing=1 cellpadding=2 border=0>\n";
		echo "<tr class=\"listheader\">\n";
		if ($page == 'adminUsersBrowse') {
			// show headers with links for different sorting...
			echo "<td width=\"5%\" align=\"right\"><a href=\"".ct_pageurl($page,ct_http_array(array('listorder' => 'id')))."\" class=\"listheader_label\">".ct('S_USER_ID')."</a></td>\n";
			echo "<td width=\"35%\"><a href=\"".ct_pageurl($page,ct_http_array(array('listorder' => 'name')))."\" class=\"listheader_label\">".ct('S_USER_FULLNAME')."</a></td>\n";
			echo "<td width=\"33%\"><a href=\"".ct_pageurl($page,ct_http_array(array('listorder' => 'org')))."\" class=\"listheader_label\">".ct('S_USER_ORGANISATION')."</a> &middot; <a class=\"fontbold font8\" href=\"".ct_pageurl($page,ct_http_array(array('listorder' => 'country')))."\" >".ct('S_USER_COUNTRY')."</a></td>\n";
			echo "<td width=\"12%\" colspan=2 align=\"center\"><span class=\"fontbold font8\">".ct('S_USER_STATUS')."</span></td>\n";
			echo "<td width=\"15%\" align=\"right\"><span class=\"listheader_label\">".ct('S_ADMIN_USERS_ACTIONS')."</span></td>\n";
		} elseif ($page == 'adminUsersLoginsBrowse') {
			// show headers with links for different sorting...
			echo "<td width=\"5%\" align=\"right\"><span class=\"listheader_label\">".ct('S_USER_ID')."</span></td>\n";
			echo "<td width=\"30%\"><span class=\"listheader_label\">".ct('S_USER_FULLNAME')."</span></td>\n";
			echo "<td width=\"30%\"><span class=\"listheader_label\">".ct('S_USER_ORGANISATION')." &middot;</span> ";
			echo "<span class=\"fontbold font8\">".ct('S_USER_COUNTRY')."</span></td>\n";
			echo "<td width=\"15%\" colspan=2 align=\"center\"><span class=\"listheader_label\">".ct('S_USER_STATUS')."</span></td>\n";
			echo "<td width=\"20%\" align=\"right\"><span class=\"fontbold font8\">".ct('S_USER_LOGIN_DATE')."</span><br><span class=\"fontstandard font8\">".ct('S_USER_LOGOUT_DATE')."</span><br><span class=\"fontlabel font8\">".ct('S_USER_LASTACTION_DATE')."</span></td>\n";
		} else {
			// no links, e.g. for PC list, frontdesk list...
			echo "<td width=\"5%\" align=\"right\"><span class=\"listheader_label\">".ct('S_USER_ID')."</span></td>\n";
			echo "<td width=\"35%\"><span class=\"listheader_label\">".ct('S_USER_FULLNAME')."</span></td>\n";
			echo "<td width=\"33%\"><span class=\"listheader_label\">".ct('S_USER_ORGANISATION')." &middot;</span> ";
			echo "<span class=\"fontbold font8\">".ct('S_USER_COUNTRY')."</span></td>\n";
			echo "<td width=\"12%\" colspan=2 align=\"center\"><span class=\"listheader_label\">".ct('S_USER_STATUS')."</span></td>\n";
			echo "<td width=\"15%\" align=\"right\"><span class=\"listheader_label\">".ct('S_ADMIN_USERS_ACTIONS')."</span></td>\n";
		}
		echo "</tr>\n";
		for ($i=0; $i < $db->num_rows($res); $i++) {
			$person->pdata = $db->fetch($res);
			if (intval($i/$perpage)==$pageno) {
				$person->show_row(($i%2?"oddrow":"evenrow"), $page);
				$page_i++;
			}
		}
		// show sums...
		if ($maxpage>0) {
			echo "<tr class=\"dimbg\">\n";
			echo "<td colspan=\"6\"><span class=\"form_label\">".ct('S_ADMIN_USERS_BROWSE_PAGE_SUM1')." $page_i ".ct('S_ADMIN_USERS_BROWSE_PAGE_SUM2')."</span></td>\n";
			echo "</tr>\n";
		}
		echo "<tr class=\"darkbg\">\n";
		echo "<td colspan=\"6\"><span class=\"form_label\">".ct('S_ADMIN_USERS_BROWSE_SUM1')." $i ".ct('S_ADMIN_USERS_BROWSE_SUM2')."</span></td>\n";
		echo "</tr>\n";
		echo "</table>\n";
		if ($maxpage>0) ct_navbar_small($page,$items);
	}
}


// list all participants
function ctadm_listparticipants($res,$page,$filter=array()) {
	global $db, $http, $ctconf;
	ct_load_lib('participation.lib');
	ct_load_lib('navbar.lib');
	ct_load_lib('datetime.lib');

	ct_load_class('CTParticipation');
	$participation= new CTParticipation;

	$feetotal = 0;
	$paidtotal = 0;
	$page_feetotal = 0;
	$page_paidtotal = 0;
	$page_eventdays = 0;
	$page_eventqty  = 0;
	$page_eventsum  = 0;
	$page_i			= 0;

	$datemode 	   = "false";
	$pricecategory = 0;
	$texthint      = "";
	
	$items      = $db->num_rows($res);
	ct_navbar($page,$items);
	$perpage    = isset($http['navbar_perpage']) && $http['navbar_perpage']!=""?$http['navbar_perpage']:ctconf_get('display_perpage',20);
	$pageno     = isset($http['navbar_page'])?$http['navbar_page']:0; // default is 0
	$maxpage    = intval(($items-1)/($perpage));
	
	if (($res >= 0) && ($db->num_rows($res) > 0)) {
		echo "<table width=\"100%\" cellspacing=1 cellpadding=2 border=0>\n";
		echo "<tr class=\"listheader\">\n";
		echo "<td width=\"3%\" align=\"center\"><span class=\"listheader_label\">".ct('S_USER_COUNT')."</span></td>\n";
		echo "<td width=\"4%\" align=\"center\"><a href=\"".ct_pageurl($page,ct_http_array(array('listorder' => 'id')))."\" class=\"listheader_label\">".ct('S_USER_ID')."</a></td>\n";
		echo "<td width=\"32%\"><a class=\"listheader_label\" href=\"".ct_pageurl($page,ct_http_array(array('listorder' => 'name')))."\">".ct('S_USER_FULLNAME')."</a><br><img src=\"".ct_getbaseurl()."icons/darkblue.gif\" height=1 width=80><br>\n";
		echo "<a class=\"fontnormal font8\" href=\"".ct_pageurl($page,ct_http_array(array('listorder' => 'email')))."\">".ct('S_USER_EMAIL')."</a></td>\n";
		echo "<td width=\"33%\"><a class=\"listheader_label\" href=\"".ct_pageurl($page,ct_http_array(array('listorder' => 'org')))."\">".ct('S_USER_ORGANISATION')."</a><br><img src=\"".ct_getbaseurl()."icons/darkblue.gif\" height=1 width=160><br>";
		echo "<a class=\"fontnormal font8\" href=\"".ct_pageurl($page,ct_http_array(array('listorder' => 'country')))."\">".ct('S_USER_COUNTRY')."</a>\n";
		if (!isset($http['form_event']) || $http['form_event']=="") {
			echo " &middot; <a class=\"fontnormal font8\" href=\"".ct_pageurl($page,ct_http_array(array('listorder' => 'invoiceNo')))."\">".ct('S_INVOICE_INVOICENUMBER')."</a>";
		}
		echo "</td>\n";
		echo "<td width=\"7%\" align=\"center\"><a class=\"listheader_label\" href=\"".ct_pageurl($page,ct_http_array(array('listorder' => 'paymethod')))."\">".ct('S_PARTICIPATE_PAYMENT_METHOD')."</a><br><img src=\"".ct_getbaseurl()."icons/darkblue.gif\" height=1 width=50><br>\n";
		echo "<a class=\"fontnormal font8\" href=\"".ct_pageurl($page,ct_http_array(array('listorder' => 'regdate')))."\">".ct('S_PARTICIPATE_REGDATE_SHORT')."</a></td>\n";
		echo "<td width=\"7%\" align=\"right\"><a class=\"listheader_label\" href=\"".ct_pageurl($page,ct_http_array(array('listorder' => 'total')))."\">".ct('S_PARTICIPATE_TOTALFEE')."</a><br><img src=\"".ct_getbaseurl()."icons/darkblue.gif\" height=1 width=40><br>\n";
		echo "<a class=\"fontnormal font8\" href=\"".ct_pageurl($page,ct_http_array(array('listorder' => 'invoicedate')))."\">".ct('S_PARTICIPATE_INVOICEDATE_SHORT')."</a></td>\n";
		echo "<td width=\"7%\" align=\"right\"><a class=\"listheader_label\" href=\"".ct_pageurl($page,ct_http_array(array('listorder' => 'payamount')))."\">".ct('S_PARTICIPATE_PAYAMOUNT')."</a><br><img src=\"".ct_getbaseurl()."icons/darkblue.gif\" height=1 width=40><br>\n";
		echo "<a class=\"fontnormal font8\" href=\"".ct_pageurl($page,ct_http_array(array('listorder' => 'paydate')))."\">".ct('S_PARTICIPATE_PAYDATE_SHORT')."</a></td>\n";
		echo "<td width=\"7%\" align=\"right\"><span class=\"listheader_label\">".ct('S_ADMIN_USERS_ACTIONS')."</span></td>\n";
		echo "</tr>\n";

		// If a Event was selected in the filter, get more information on this event!
		if (isset($http['form_event']) && $http['form_event']) {
			$datemode = "false";
			$r = $db->query("select pricecategory, datemode, texthint, texthint2, texthint3, texthint4 from events where ID='".$http['form_event']."'");
			if ($r && ($db->num_rows($r) == 1)) {
				$p = $db->fetch($r);
				$pricecategory = $p['pricecategory'];
				$datemode      = $p['datemode'];
				$texthint      = $p[ctlx($p,'texthint')];
			}
		}
		for ($i=0; $i < $db->num_rows($res); $i++) {
			$row = $db->fetch($res);
			$feetotal+=$row['total'];
			$paidtotal+=$row['payamount'];
			if (intval($i/$perpage)==$pageno) {
				$page_i++ ;
				//$participation->load_by_id($row['personID']);
				$participation->_init(); 		
				$participation->pdata=$row; 		 // Fill participant data from query output
				$participation->_load_persondata();  // load the persondata
				$page_feetotal+=$participation->pdata['total'];
				$page_paidtotal+=$participation->pdata['payamount'];

				if (isset($http['form_event']) && $http['form_event']) {
					$participation->_load_eventdata();
					$stay_factor = 1;
					$start = $participation->eventdata_start[$http['form_event']];
					$end   = $participation->eventdata_end[$http['form_event']];
					if ($datemode=="perdiem")  $stay_factor = ct_count_days($start,$end);
					if ($datemode=="pernight") $stay_factor = ct_count_nights($start,$end);
					$page_eventdays+=$stay_factor;
					$page_eventqty+=$participation->eventdata_number[$http['form_event']];
					$page_eventsum+=$participation->eventdata_number[$http['form_event']]*$stay_factor*$participation->_calculate_singlefee($pricecategory,$participation->get(status),get_timediscountID($participation->pdata['regdate']));
				}
				$participation->show_row(($i%2?"oddrow":"evenrow"),$i,$http['form_event'],$page,$datemode,$pricecategory,$texthint);
		
			}
		}
		// show sum of event
		if (isset($http['form_event']) && $http['form_event']) {
			echo "<tr class=\"graybg\">\n";
			echo "<td colspan=\"4\" align=\"right\"><span class=\"form_label\">".ct('S_PARTICIPATE_EVENTSUMS').":</span></td>\n";
			echo "<td align=\"center\"><span class=\"form_label\">".$page_eventqty."</span></td>\n";
			echo "<td align=\"center\"><span class=\"form_label\">".$page_eventdays."</span></td>\n";
			echo "<td align=left colspan=2><span class=\"form_label\">&nbsp;&nbsp;".ct_number_format($page_eventsum).ctconf_get('currencySymbol')."</span></td>\n";
			echo "</tr>\n";
		} else {
			// Pagesums
			if ($maxpage>0) {
				echo "<tr class=\"dimbg\">\n";
				echo "<td colspan=\"3\"><span class=\"form_label\">".ct('S_ADMIN_PARTICIPANTS_BROWSE_PAGE_SUM1')." $page_i ".ct('S_ADMIN_PARTICIPANTS_BROWSE_PAGE_SUM2')."</span></td>\n";
				echo "<td align=right><span class=\"form_label\">".ct('S_PARTICIPATE_PAGESUMS').":</span></td>\n";
				echo "<td align=right colspan=\"2\"><span class=\"form_label\">".ct_number_format($page_feetotal).ctconf_get('currencySymbol')."</span></td>\n";
				echo "<td align=left colspan=2><span class=\"form_label\">&nbsp;&nbsp;".ct_number_format($page_paidtotal).ctconf_get('currencySymbol')."</span></td>\n";
				echo "</tr>\n";
			}
			// Footer with totals
			echo "<tr class=\"darkbg\">\n";
			echo "<td colspan=\"3\"><span class=\"form_label\">".ct('S_ADMIN_PARTICIPANTS_BROWSE_SUM1')." $i ".ct('S_ADMIN_PARTICIPANTS_BROWSE_SUM2')."</span></td>\n";
			echo "<td align=right><span class=\"form_label\">".ct('S_PARTICIPATE_TOTALFEE').":</span></td>\n";
			echo "<td align=right colspan=2><span class=\"form_label\">".ct_number_format($feetotal).ctconf_get('currencySymbol')."</span></td>\n";
			echo "<td align=left colspan=2><span class=\"form_label\">&nbsp;&nbsp;".ct_number_format($paidtotal).ctconf_get('currencySymbol')."</span></td>\n";
			echo "</tr>\n";
		}
		echo "</table>\n";
	}

	if ($maxpage>0) ct_navbar_small($page,$items);
}

?>