<?php
//
// html formatting: The following function will parse html formatted text in conftool to prevent XSS: Cross Site Scripting
//

function ct_html_strict_format($htmltext){
	$htmltext = ct_form_encode($htmltext);

	$allowed_elements=array('abbr','b','big','blockquote','br','center','code','dd','dl','dt','em','h1','h2','h3','h4','h5','h6','hr','i','li','ol','p','pre','q','s','small','strong','sub','sup','u','ul');
	$special_styles=array('<p>'=>'<p class="paper_abstract">', 
							'<ul>'=>'<ul class="paper_abstract_list">', 
							'<ol>'=>'<ol class="paper_abstract_orderedlist">');
	$allowed_single_elements=array('br','dd','hr','p');

	foreach ($allowed_elements as $index => $value) { 
		$pattern = "/&lt;".$value."[^\/]*&gt;(.*)&lt;\/".$value."&gt;/Usi"; // ungreedy, "." includes newlines, ignore case
		$format  = "<$value>\${1}</$value>";
		#echo ct_form_encode_noentities($pattern.":".$format)."<br>\n";
		$htmltext = preg_replace($pattern, $format, $htmltext);
	}
	$htmltext = strtr($htmltext, $special_styles);
	
	foreach ($allowed_single_elements as $index => $value) { 
		$pattern = "/&lt;".$value."[^&]*&gt;/Ui";
		$format  = "<$value>";
		#echo ct_form_encode($pattern.":".$format)."<br>";
		$htmltext = preg_replace($pattern, $format, $htmltext);
	}
	$htmltext=html_entity_decode($htmltext); // now return to html characters
	#$exceptions = array('<'=>'&lt;', '>'=>'&gt'); // but encode some special characters
	#$htmltext = strtr($htmltext, $exceptions);
	return $htmltext;	
}

?>