<?php
//
// special javascript functions for Conftool
//


/**
 * Return a JavaScript function to check/unckeck all checkboxes of a page. 
 *
 * @param unknown_type $res
 * @param unknown_type $page
 * @return string the javascript code
 */
function get_js_checkbox_selector($function_name, $checkbox_name) {
	$ret =  "\n<script type=\"text/javascript\" language=\"javascript\">\n";
	$ret .= "<!--\n";
	$ret .= "function $function_name(e) {\n";
	$ret .= "	var f = e.form\n";
  	$ret .= "	for(i=0; i<f.length;i++){\n";
	$ret .= " 		if (f[i].type == 'checkbox' && f[i].name=='$checkbox_name') f[i].checked = e.checked;\n";
	$ret .= "	}\n";
	$ret .= "}\n";
	$ret .= "//  End -->\n";
	$ret .= "</script>\n";
	return $ret;
}

function get_js_waitmessage() {
	$ret =  "\n<script type=\"text/javascript\" language=\"javascript\">\n";
	$ret .= "<!--\n";
	$ret .= "function disableForm(theform) {\n";
	$ret .= "	if (document.all || document.getElementById) {\n";
	$ret .= "		for (i = 0; i < theform.length; i++) {\n";
	$ret .= "			var tempobj = theform.elements[i];\n";
	$ret .= "			if (tempobj.type.toLowerCase() == \"submit\" || tempobj.type.toLowerCase() == \"reset\") {\n";
	// echo "				tempobj.disabled = true;";  // Causes problems...\n";
	$ret .= "				tempobj.value = \"         ".ct('S_WAIT')."        \";\n";
	$ret .= "				tempobj.className=\"waitbutton\";\n";
	// echo "				theform.submit();";
	$ret .= "			}\n";
	$ret .= "		}\n";
	$ret .= "	}\n";
	$ret .= "	return true;\n";
	$ret .= "}\n";
	$ret .= "// End -->\n";
	$ret .= "</script>	\n";
	return $ret;
}

/**
 * show a window "please wait..."
 *
 * @return unknown
 */
function get_js_waitwindow() {
	$ret =  "\n<script type=\"text/javascript\" language=\"javascript\">\n";
	$ret .= "<!--\n";
	$ret .= "document.write(\"<div id='ct_wait_message' style='visibility: hidden; position:absolute; top:0px; margin-top:0px; left:50%; width:300px; margin-left:-150px; background:#EEE; text-align:center; padding: 10px; border:1px solid #000;'><br><span class='fontbold font12'>".ct('S_WAIT')."</span><br><br><img id='ct_wait_image' src='images/waitbar.gif'><br><br><span class='fontbold font11'>".ct('S_PAPER_UPLOAD_WAITMINUTES')."</span><br><br><\/div>\");\n";
	$ret .= "function show_wait_message() {\n";
	$ret .= "	var strBrwsr = navigator.userAgent.toLowerCase();\n";
	$ret .= "	if ((strBrwsr.indexOf('msie') > -1 && parseInt(strBrwsr.charAt(strBrwsr.indexOf('msie')+5))>=7) || "; 
	$ret .= "  		(strBrwsr.indexOf('mozilla') > -1 && parseInt(strBrwsr.charAt(strBrwsr.indexOf('mozilla')+8))>=5) || "; // Test for IE7 and Mozilla 5 (Firefox etc.)
	$ret .= "  		(strBrwsr.indexOf('opera') > -1 && parseInt(strBrwsr.charAt(strBrwsr.indexOf('opera')+6))>=6) ) {\n"; // Test for Opera 6+
	$ret .= "		document.getElementById('ct_wait_message').style.position='fixed';\n";	// fixed positions for new browsers
	$ret .= "		document.getElementById('ct_wait_message').style.top=150;\n";	// set position
	$ret .= "		document.getElementById('ct_wait_message').style.visibility='visible';\n";	// make visible
	$ret .= "	} else {"; // For all other browsers use absolute position...
	$ret .= "		document.getElementById('ct_wait_message').style.top=(150+(document.documentElement.scrollTop?document.documentElement.scrollTop:document.body.scrollTop)+'px');\n";	// set new position
	$ret .= "		document.getElementById('ct_wait_message').style.visibility='visible';\n";	// make visible
	$ret .= "	}";
	$ret .= "	setTimeout('refresh_wait_image()', 100);\n";	// reload image, so the animation shows
	$ret .= "	return true;\n";
	$ret .= "}\n";
	$ret .= "function refresh_wait_image() {\n";
	$ret .= "	document.getElementById('ct_wait_image').src='images/waitbar.gif';\n";  // reload image...
	$ret .= "}\n";
	$ret .= "// End -->\n";
	$ret .= "</script>\n";
	return $ret;
}


/**
 * JavaScript Fieldcounter
 *
 * @return JavaScript-Code for Fieldcounter
 */
function get_js_fieldcounter() {
	$ret = "\n<script type=\"text/javascript\" language=\"javascript\">\n";
	$ret.= "<!--\n";
	$ret.= "function showLength(field, divID, maxlength) {\n";
	$ret.= " var text = field.value\n";	
	$ret.= " var chars = text.length;\n"; // Count characters
    $ret.= " var words=0;\n";  // count words.
	#$ret.= "	var w = text.match(/\b\w+\b/g);\n"; # does not work with special characters!
	#$ret.= "	var w = text.split(' ');\n"; # does not consider returns without spaces and tabs!
	$ret.= " var w = text.match(/[\s\/]+/g);\n"; # split by whitespace
	$ret.= " var wb = text.match(/^\s/g);\n"; # find whitespace at beginning
	$ret.= " var we = text.match(/\s$/g);\n"; # find whitespace at end
	$ret.= " var wp = text.match(/\s[-,.;:!\"\']+\s/g);\n"; # find punctuation symbols - do not count!
	$ret.= " if (w) words = w.length+1; else words = (chars>0?1:0);\n"; # Count number of whitespaces. Add 1. If no whitespace there is one word as soon as a character was entered.
	$ret.= " if (wb) words -= wb.length;\n";	# Do not count whitespaces at beginning
	$ret.= " if (we) words -= we.length;\n";	# Do not count whitespaces at end
	$ret.= " if (wp) words -= wp.length;\n";	# Do not count separate puncuation symbols

	$ret.= " if (maxlength==0) {\n";
	$ret.= "    var showtext = '';\n";
	$ret.= "    if (chars==1) showtext = chars + \" ".ct('S_FORM_CHARACTER')."\";\n";
	$ret.= "    else showtext = chars + \" ".ct('S_FORM_CHARACTERS')."\";\n";
	$ret.= "    if (words==1) showtext += \", \" + words + \" ".ct('S_FORM_WORD')."\";\n";
	$ret.= "    else showtext += \", \" + words + \" ".ct('S_FORM_WORDS')."\";\n";
	$ret.= "    document.getElementById(divID).firstChild.nodeValue = showtext;\n";
	$ret.= " } else if (maxlength>0)  {\n";	// count number of characters
	$ret.= "    remaining = maxlength-chars;\n";
	$ret.= "    if (remaining<0) document.getElementById(divID).firstChild.nodeValue = \"".ct('S_FORM_TOOLONG')."\";\n";
	$ret.= "    else if (remaining==1) document.getElementById(divID).firstChild.nodeValue = remaining + \" ".ct('S_FORM_CHARACTER_REMAINING')."\";\n";
	$ret.= "    else document.getElementById(divID).firstChild.nodeValue = remaining + \" ".ct('S_FORM_CHARACTERS_REMAINING')."\";\n";
	$ret.= " } else if (maxlength<0)  {\n";	// count number of words
	$ret.= "    remaining = -maxlength-words;\n";
	$ret.= "    if (remaining<0) document.getElementById(divID).firstChild.nodeValue = \"".ct('S_FORM_TOOLONG')."\";\n";
	$ret.= "    else if (remaining==1) document.getElementById(divID).firstChild.nodeValue = remaining + \" ".ct('S_FORM_WORD_REMAINING')."\";\n";
	$ret.= "    else document.getElementById(divID).firstChild.nodeValue = remaining + \" ".ct('S_FORM_WORDS_REMAINING')."\";\n";
	$ret.= " }\n";
	$ret.= "}\n";
	$ret.= "//  End showLength -->\n";
	$ret.= "</script>	\n";
	return $ret;
}

/**
 * Return a JavaScript function to check if the selected date is valid (checks only the day of the month)
 *
 * @return string the javascript code
 */
function get_js_checkdate() {
	$ret =  "\n<script type=\"text/javascript\" language=\"javascript\">\n";
	$ret .= "<!--\n";
	$ret .= "function checkdate(d, m, y) {\n";
	$ret .= "	day=d.value;month=m.value;year=y.value;\n";
	$ret .= "	var days=31;\n";
	$ret .= "	if (month==4 || month==6 || month==9 || month==11) days = 30;\n";
	$ret .= "	if (month==2) days = (((year%4 == 0) && ( (!(year%100 == 0)) || (year%400 == 0))) ? 29 : 28 );\n";
	#$ret .= "	alert (day+' '+month+' '+year+' : '+days);\n";
	$ret .= "	if (day>days) d.value=days;\n";
	$ret.= "}\n";
	$ret .= "// End checkdate -->\n";
	$ret .= "</script>\n";
	return $ret;
}

/**
 * Return a JavaScript function to jump from field to field by entering RETURN instead of TAB
 *
 * @return string the javascript code
 */
function get_js_return2tab($formname) {
	$ret =  "\n<script type=\"text/javascript\" language=\"javascript\">\n";
	$ret .= "<!--\n";
	$ret .= "function return2tab(e) {\n";
	$ret .= "	var o = e.target || e.srcElement;\n";
	$ret .= "	if (o && !/submit|reset|textarea|button/i.test(o.type)) {;\n";
	$ret .= "		if (e.keyCode == 13 ) {\n";
	$ret .= "			if (e.preventDefault) e.preventDefault();\n";
	$ret .= "			else e.returnValue = false;\n";
	$ret .= "			var objects = document.$formname.elements;\n";
	$ret .= "			newFocus = 0;\n";
	$ret .= "			for (var i = 0; i < objects.length; i++ ) {\n";
	$ret .= "				if ( objects[i] == o ) {\n";
	$ret .= "					for (var j = i + 1; j < objects.length; j++ ) {\n";
	$ret .= "						if ( objects[j] && !/hidden|radio|checkbox/i.test(objects[j].type) && !objects[j].disabled ) { newFocus = j; break; }\n";
	$ret .= "					};\n";
	$ret .= "				};\n";
	$ret .= "				if (newFocus>0) {o.blur(); objects[newFocus].focus(); break; }\n"; // the focus method creates an error in Firefox - but it's not critical. 
	$ret .= "			};\n";
	$ret .= "		};\n";
	$ret .= "		return true;\n";
	$ret.= "	};\n";
	$ret.= "};\n";
	$ret .= "// End return2tab -->\n";
	$ret .= "</script>\n";
	return $ret;
}

/**
 * JavaScript functions to check if changes were saved? 
 *
 * @param string $formname name of form
 */
function get_js_checkDataSaved($formname) {
	$ret =  "\n<script type=\"text/javascript\" language=\"javascript\">\n";
	$ret.=  "<!--\n";
	$ret.=  "formInitValues = '';\n";
	$ret.=  "noNeedToConfirmForm = true;\n";
	$ret.=  "function readFormValues() {\n";
	$ret.=  "	var values = '';\n";
	$ret.=  "	var formElement = document.forms.$formname;\n";
	$ret.=  "	if (formElement) {\n";
	$ret.=  "		for (x=0; x<formElement.length; x++) {\n";
	$ret.=  "			formField=formElement.elements[x];\n";
	$ret.=  "			if (formField.type == 'checkbox' || formField.type == 'radio') {\n";
	$ret.=  "				values += formField.checked;\n";
	$ret.=  "			} else {\n";
	$ret.=  "				values += formField.value;\n";
	$ret.=  "			}\n";
	$ret.=  "		}\n";
	#$ret.=  "		alert(values)\n;";
	$ret.=  "	}\n";
	$ret.=  "	return values;\n";
	$ret.=  "}\n";
	$ret.=  "function noNeedToConfirm() {\n";
	$ret.=  "	noNeedToConfirmForm = true;\n";
	$ret.=  "	return true;\n";
	$ret.=  "}\n";
	$ret.=  "function initValues() {\n";
	$ret.=  "	formInitValues = readFormValues();\n";
	$ret.=  "	noNeedToConfirmForm = false;\n";
	$ret.=  "}\n";
	$ret.=  "window.onload = function(){initValues();}\n";
	$ret.=  "\n";
	$ret.=  "function testValues() {\n";
	$ret.=  "	if (noNeedToConfirmForm || formInitValues == readFormValues()) { return; }\n";
	$ret.=  "	else { return '".addslashes(ct('S_FORM_NOTSUBMITTED_WARNINGMESSAGE'))."'; }\n";
	$ret.=  "}\n";
	$ret.=  "window.onbeforeunload = testValues;\n";
	$ret.=  "\n";
	$ret .= "// Show Warningmessage -->\n";
	$ret .= "</script>\n";
	return $ret;
}

?>