<?php
// ConfTool language functions (C) 2007 Harald Weinreich


// Read the language file(s) in to session variable for better performance.
function ct_read_language_file() {
	global $ctconf,$http,$session;

	// New language -> delete stored data with language-specific fields
	$session->del('db_ctconf'); // reload main configuration settings.
	$session->del('db_timediscounts'); // reset timediscounts
	$session->del('db_countries'); // reset countries
	$session->del('db_groups'); // delete cache!
	$session->del('db_contributiontypes'); // Also delete contributiontypes...
	$session->del('db_sessions'); // Also delete sessions...
	$session->del('db_session_room_names'); // Also delete session rooms...

	// read default language (english) if other definitions are still missing...
	if (file_exists(ct_get_path('etc')."english.lang"))
		ct_read_language_file_parse_lines(ct_get_path('etc')."english.lang");

	// Open and read english/default language file for the specific conference
	if ( !$session->get('conf')===false && !$session->get('conf')=="") { // Conference selecte?
		if (file_exists(ct_get_path('etc').$session->get('conf')."/english.lang")) {	// File exists?
			ct_read_language_file_parse_lines(ct_get_path('etc').$session->get('conf')."/english.lang");
		}
	} elseif (file_exists(ct_get_path('etc')."main/english.lang")) { // read language file of "main" conference if existing
		ct_read_language_file_parse_lines(ct_get_path('etc')."main/english.lang");
	}

	// Open and read other language if it is not english...
	if ($session->get('lang')!="english") {
		ct_read_language_file_parse_lines(ct_get_path('etc').$session->get('lang').".lang");

		// Open and read language file for the specific conference, if exists...
		if ( !$session->get('conf')===false && !$session->get('conf')=="") {
			if (file_exists(ct_get_path('etc').$session->get('conf')."/".$session->get('lang').".lang") ) {
				ct_read_language_file_parse_lines(ct_get_path('etc').$session->get('conf')."/".$session->get('lang').".lang");
			}
		} elseif (file_exists(ct_get_path('etc')."main/".$session->get('lang').".lang")) { // read other language file of "main" conference if existing
			ct_read_language_file_parse_lines(ct_get_path('etc')."main/".$session->get('lang').".lang");
		}
	}

}

/**
 * Parse one language file
 */
function ct_read_language_file_parse_lines($lang) {
	global $session;
	if ($lang=="" or !file_exists($lang)) {
		echo "<H1>ConfTool setup error! Language file not found.</H1><P>Please contact the conference organizers.</p>\n\n";
		return false;
	}
	$file = fopen($lang, "r");
	while ($file!==false && !feof($file)) {
		$line = trim(fgets($file, 4096));
		if (($line != "") && !preg_match("/^#/", $line)) {
			$x = explode("=", $line, 2);
			if (!$x[1]=="")
				$session->put($x[0], $x[1]);
			else
				$session->put($x[0], "|||"); // ||| for empty values...
		}
	}
	fclose($file);
}


?>