<?php
//
// general mail function
//

function ct_mail($mail_receiver,$mail_subject,$mail_content,$mail_sender="",$mail_replyto="",$mail_cc=array(),$mail_bcc=array()){
	global $ctconf,$session;

	/*
	// "Conventional" method to send mail using the build-in php mail function.
	// this sometimes caused problems, so I use phpmailer instead.
	if ($mail_sender=="") $mail_sender = ctconf_get('conferenceSenderEmail');
	if ($mail_replyto=="") $mail_replyto = ctconf_get('conferenceReplytoEmail');
	$mail_header="From: $mail_sender\nReply-To: $mail_replyto\nX-Mailer: ConfTool/PHP/" .phpversion();
	return mail($mail_receiver, $mail_subject, $mail_content, $mail_header);
	*/

	ct_load_lib('phpmailer/class.phpmailer');
	$mail = new PHPMailer();

    $mail->IsSMTP();       // set mailer to use SMTP
	if (isset($ctconf['charset'])) $mail->CharSet=$ctconf['charset'];
	#$mail->CharSet='UTF-8';

    $mail->Host = ctconf_get('mail/smtphost');      // specify main and backup server
	if (ctconf_get('mail/smtpport'))
    	$mail->Port = ctconf_get('mail/smtpport');  	 // SMTP port
    $mail->SMTPAuth = ctconf_get('mail/SMTPAuth');  // SMTP authentication req.?
	$mail->Username = ctconf_get('mail/username');  // SMTP username
	$mail->Password = ctconf_get('mail/password');  // SMTP password

	// Receiver
    $mail->AddAddress($mail_receiver);
    
    // Sender
    if ($mail_sender=="")  $mail_sender  = ctconf_get('conferenceSenderEmail');
    $mail->From = $mail_sender;

    // Name of sender
    if (strip_tags(ctconf_get('conferenceSenderName'))!='')
	    $mail->FromName = strip_tags(ctconf_get('conferenceSenderName'));
    
	// Reply-to email
    if ($mail_replyto=="") $mail_replyto = ctconf_get('conferenceReplytoEmail','');
    if ($mail_replyto!='') $mail->AddReplyTo($mail_replyto);
    
	// Add CCs if any given...
    if (is_array($mail_cc)) {foreach ($mail_cc as $c) { $mail->AddCC($c); }}
	// Add BCCs if any given...
    if (is_array($mail_bcc)) {foreach ($mail_bcc as $c) { $mail->AddBCC($c); }}
	// Add BCC to every mail if required
	if (isset($ctconf['mail/bcc']) && $ctconf['mail/bcc'] != '') $mail->AddBCC($ctconf['mail/bcc']);

	
    $mail->WordWrap = 78;
    $mail->IsHTML( false );

    $mail->Subject = $mail_subject;
    $mail->Body    = $mail_content;
    #$mail->Body    = html_entity_decode($mail_content,ENT_NOQUOTES,'UTF-8');

    return $mail->Send();

    if(!$mail->Send()) {
        ct_error_log("Mailer Error: " . $mail->ErrorInfo);
		#echo "Message was not sent <p>";
   		#echo "Mailer Error: " . $mail->ErrorInfo;
	    #die();
	}
}

/**
 * ct_validate_email - validate a supplied e-mail-address by regular expression and dns check
 *
 * @param  $email String
 * @return true if the address is valid
 */
function ct_validate_email($email, $check_dns=true){
	global $ctconf;
	$exp = "^[a-z0-9]+([._%+-][a-z0-9]+)*@([a-z0-9]+([._-]?[a-z0-9]{0,62}))+\.[A-Z]{2,6}$";	    // Check syntax (by HW :-)
	if(eregi($exp,$email)){	// correct!	:-)
		if (ctconf_get('mail/checkdns')===false || $check_dns===false) return true; // Do NOT check DNS of mail-address
		$emailarray = explode("@",$email);		// These lines could be less complicated but there is an PHP-Error in some versions of array_pop.
		$domain     = array_pop($emailarray).".";  // Get domain and add a dot
		// Additional sanity check
   		$domain = preg_replace("/\s/s", "", $domain);
   		if (strlen($domain)>3) {
	   		if(ct_checkdnsrr($domain,"MX")) return true; // Check MX record, works usually
	   		if(ct_checkdnsrr($domain,"CNAME")) return true; // also check CNAME and A, as MX is not obligatory
	   		if(ct_checkdnsrr($domain,"A")) return true; //
   		}
	}
	return false;
}


/**
 * ct_validate_uri - validate a supplied uri by regular expression
 *
 * URI can be HTTP and HTTPS
 * @param  $uri String
 * @return true if the address is valid
 */
function ct_validate_uri($uri) {
    return preg_match('|^http(s)?://[a-z0-9-]+(\.[a-z0-9-]+)*(:[0-9]+)?(/.*)+$|i', $uri );
}

// Check domain	name - our own function. Needed	as windows behaves differently...
function ct_checkdnsrr(	$host, $type=''	) {
	global $ct_starttime;
	// overall timeout of five seconds: After that don't check DNS any more (as some requests take very long!)
	if ( (ct_get_microtime()-(float)$ct_starttime) > 5 ) return true;
	if (!empty(	$host )) { 
		if (function_exists('checkdnsrr')) { //	Does php function exist? NOT on windows...
			##if (checkdnsrr($host,$type)) return true;  # This has a very long timeout. Might be annoying.
			// Workaround:
			if ($type!="") $type = " -t	".$type;
			@exec( "host $type $host", $output ); // use host function (unix...)
			if (is_array($output)) {
				while (list($k,$line ) = each( $output )) {
				   if (eregi("^$host", $line ))	return true; //	Valid records begin	with "hostname"
				}
			} else return true;	// system call did not work
		} else { //	function missing, so probably a	windows	machine...
			if ($type!="") $type = " -type=".$type;
			@exec( "nslookup $type $host", $output ); // use nslookup function...
			if (is_array($output)) {
				while (list($k,$line ) = each( $output )) {
				   if (eregi("^$host", $line ))	    return true; //	Valid records begin	with "hostname:"
				   if (eregi("UnKnown", $line ))	return true; //	Computer seems to be off-line: Skip DNS test!
				   if (eregi("request timed out", $line ))	return true; //	Computer seems to be off-line: Skip DNS test!
				}
			} else return true;	// system call did not work
		}
	}
	return false;
}

/**
 * Get the salutation part of an email like "Dear Prof...." or "Dear Mr...." - but without the name
 *
 * @param unknown_type $gender
 * @return unknown
 */
function ct_get_mail_salutation($gender) {
	switch ($gender) {
		case 1: return ct('S_USER_PART_EMAIL_ADDRESSES_M');
		case 2: return ct('S_USER_PART_EMAIL_ADDRESSES_F');
		case 3: return ct('S_USER_PART_EMAIL_ADDRESSES_DR');
		case 4: return ct('S_USER_PART_EMAIL_ADDRESSES_PROF');
	}
	return ct('S_USER_PART_EMAIL_ADDRESSES_N');
}

/**
 * Get the greeting to start an email with for all Mails of Conftool
 *
 * @param CTPerson $person person object to send the mail to...
 */
function ct_get_mail_greeting_fullname($person) {
	return trim(str_replace("  "," ",ct_get_mail_salutation($person->get('gender'))." ".stripslashes($person->get('firstname').' '.$person->get('name'))));
}

/**
 * Create signature for ConfTool email
 *
 * @return text with signature.
 */
function ct_get_mail_signature() {
	global $session;
	$mail_signature='';
	#$mail_signature.="\n";
	#$mail_signature.=ctconf_get('conferenceSenderName');
	$mail_signature.="\n-- \n";
	$mail_signature.=strip_tags(ctconf_get('conferenceName'))."\n";
	$mail_signature.=ct_get_loginurl();
	return $mail_signature;
}

/**
 * get the login url of this conftool instalation
 *
 * @return text with login url of conftool installation for this conference
 */
function ct_get_loginurl() {
	global $session;
	$mail_signature.=ct_getbaseurl();
	if (ct_test_lib('multi_conference.lib')) {
		$mail_signature.="index.php";
		if ( $session->get('conf')!="" ) 
			$mail_signature.='?conf='.$session->get('conf');
		else	 					
			$mail_signature.='?conf=main';
	}
	return $mail_signature;
}

/**
 * This function replaces special ISO-8859-1 Characters with their ASCII equivalents.
 * e.g. used for a bug in PayPal or to create the user name.
 *
 * @param string $s
 * @return string - the reformatted string.
 */

function ct_replace_iso_chars($s) {
	$s = htmlentities($s);
	$exceptions = array('&auml;'=>'ae', '&Auml;'=>'Ae', '&ouml;'=>'oe', '&Ouml;'=>'Oe', '&uuml;'=>'ue', '&Uuml;'=>'e', '&szlig;'=>'ss', '&OElig;'=>'Oe', '&oelig;'=>'oe', '&AElig;'=>'Ae', '&aelig;'=>'ae');
	$s = strtr($s, $exceptions); // replace some special characters with their 2 letter equivalents
	$s = preg_replace('/&([a-zA-Z])(uml|acute|grave|circ|tilde|slash|ring|cedil|caron);/','$1',$s); // replace other special characters with their 1 letter equivalent.
	return html_entity_decode($s);
}

/**
 * Opposite function to nl2br - used for emails
 *
 * @param string $text
 * @return string with new lines instead of <br>s
 */
function br2nl($text) {
    return  preg_replace('/<br\s*\/?>/i', "\n", $text);
}


?>