<?PHP
/**
 * Functions for the bulk mail pages
 */


/**
 * replace_mail_patterns - for person and author mails
 *
 * @param  $mail_content String
 * @param  $person String
 * @return string the message with the replaced, personalized text
 */
function replace_mail_patterns_persons($mail_content,$person) {
	GLOBAL $session;
	$user=$session->get_user();

	$addressee=str_replace("  "," ",stripslashes(ct('S_USER_REG_EMAIL_ADDRESS')." ".stripslashes($person->get_fullname())));
	$mail_content=str_replace("{dear_fullname}",$addressee,$mail_content);

	$addressee=str_replace("  "," ",ct_get_mail_salutation($person->get('gender'))." ".stripslashes($person->get('name')));
	$mail_content=str_replace("{dear_form_name}",$addressee,$mail_content);

	$mail_content=str_replace("{person_id}",$person->get_id(),$mail_content);
	$mail_content=str_replace("{person_name}",stripslashes($person->get('name')),$mail_content);
	$mail_content=str_replace("{person_username}",stripslashes($person->get('username')),$mail_content);
	if ($user->is_admin()) { // Only for admin!
		if ($person->get('passwordencrypted')>0) {
			$passwordtext = "********\n(".ct('S_ADMIN_MAILER_PASSWORD_ENCRYPTED',array(ct_pageurl('sendPassword')))." )\n";
		} else {
			$passwordtext = stripslashes($person->get('password'));
		}
		$mail_content=str_replace("{person_password}",$passwordtext,$mail_content);
	}
	return $mail_content;
}

/**
 * replace_mail_patterns - for mails to authors only
 *
 * @param  $mail_content String
 * @param  $person String
 * @return string the message with the replaced, personalized text
 */
function replace_mail_patterns_papers($mail_content,$paper) {

	if (ct_list_sessions($paper->get('track')>0)) {
		$sess_title=ct_list_sessions($paper->get('track'));
		$sess_title=stripslashes(strip_tags($sess_title[0][1]));
		$sess_short=ct_list_sessions($paper->get('track'),true);
		$sess_short=stripslashes(strip_tags($sess_short[0][1]));
	} else {
		$sess_short=$sess_title=ct('S_ADMIN_PAPERS_RESULTS_NOSESSION');
	}
	$mail_content=str_replace("{contribution_id}",$paper->get_id(),$mail_content);
	$mail_content=str_replace("{contribution_title}",stripslashes($paper->get('title')),$mail_content);
	$mail_content=str_replace("{contribution_type}",stripslashes($paper->_get_contributiontype_title()),$mail_content);
	$mail_content=str_replace("{contribution_status}",stripslashes($paper->get_acceptstatus()),$mail_content);
	$mail_content=str_replace("{contribution_session_short}",$sess_short,$mail_content);
	$mail_content=str_replace("{contribution_session_title}",$sess_title,$mail_content);

	return $mail_content;
}

/**
 * replace_mail_patterns - add review results
 *
 * @param  $mail_content String
 * @param  $person String
 * @return string the message with the replaced, personalized text
 */
function replace_mail_patterns_reviews($mail_content,$paper) {
	global $db;
	ct_load_class('CTReview');
	$reviews = $paper->get_reviews(false);	// get only reviews that are complete...
	$rcount = count($reviews);
	$result = '';
	$result_comments = '';
	for ($i=0; $i < $rcount; $i++) {
		$result .= "\n\n";
		if ($reviews[$i]->get('reviewtype')=='meta') 
			$reviewheader = ct('S_PAPER_DETAILED_METAREVIEWHEADER')." ".($i+1);
		else
			$reviewheader = ct('S_PAPER_DETAILED_REVIEWHEADER')." ".($i+1);
		
		$result .= $reviewheader."\n";
		$result .= str_repeat("=",strlen($reviewheader))."\n\n";
		$result .= stripslashes($reviews[$i]->get_resulttext());
		$result .= "\n\n-=-=-=-=-=-=-=-=-=-=-\n";
		
		$result_comments .= "\n\n";
		$result_comments .= $reviewheader."\n";
		$result_comments .= str_repeat("=",strlen($reviewheader))."\n";
		$result_comments .= ct('S_REVIEW_FORM_AUTHORCOMMENTS_LABEL')."\n";
		$result_comments .= str_repeat("-",strlen(ct('S_REVIEW_FORM_AUTHORCOMMENTS_LABEL')))."\n";
		$result_comments .= stripslashes($reviews[$i]->get('authorcomments'));
		if ($reviews[$i]->get('authorcomments')=='') $result_comments .= "--";
		$result_comments .= "\n\n-=-=-=-=-=-=-=-=-=-=-\n";
	}

	$mail_content=str_replace("{contribution_results}",$result,$mail_content);
	$mail_content=str_replace("{contribution_results_comments}",$result_comments,$mail_content);

	return $mail_content;
}

/**
 * replace_mail_patterns - mail to participants
 *
 * @param  $type String type of this mail: user, billing, cc
 * @param  $mail_content String content of mail
 * @param  $participant String participant object
 * @return string the message with the replaced, personalized text
 */
function replace_mail_patterns_participants($type,$mail_content,$row) {
	global $session;
	$user=$session->get_user();
	ct_load_lib('datetime.lib');
	ct_load_lib('participation.lib');
	ct_load_lib('papers.lib');
	
	#{dear_fullname} = Dear John Smith (greeting to receiver of mail),
	if ($type=="cc")
		$addressee = $row['ccholder'];
	elseif ($type=="billing")
		$addressee = $row['billingfirstname'].' '.$row['billingname'];
	else 
		$addressee = $row['firstname'].' '.$row['name'];
	$addressee=str_replace("  "," ",stripslashes($addressee));

	$mail_content=str_replace("{dear_fullname}", ct('S_USER_REG_EMAIL_ADDRESS')." ".$addressee, $mail_content);

	#{receiver_name} = full name of receiver of email,
	$mail_content=str_replace("{receiver_name}", $addressee, $mail_content);

	#{person_name} = full name of participant,
	$mail_content=str_replace("{person_name}", stripslashes($row['firstname'].' '.$row['name']), $mail_content);
	
	#{person_id} = ID of participant,
	$mail_content=str_replace("{person_id}",$row['ID'],$mail_content);
	#{person_username} = user name of participant
	$mail_content=str_replace("{person_username}",stripslashes($row['username']),$mail_content);
	
	if ($user->is_admin()) { // Only for admin!
		if ($row['passwordencrypted']>0) {
			$passwordtext = "********\n(".ct('S_ADMIN_MAILER_PASSWORD_ENCRYPTED',array(ct_pageurl('sendPassword')))." )\n";
		} else {
			$passwordtext = stripslashes($row['password']);
		}
		$mail_content=str_replace("{person_password}",$passwordtext,$mail_content);
	}
	
	#{invoice_total} = Total of invoice for the registered participant
	$mail_content=str_replace("{invoice_total}",ct_unhtmlentities(ct_currency_format($row['total'])),$mail_content);
	#{invoice_paid} = Amount already paid
	$mail_content=str_replace("{invoice_paid}",ct_unhtmlentities(ct_currency_format($row['amountpaid'])),$mail_content);
	#{invoice_open} = Amount still open
	$mail_content=str_replace("{invoice_open}",ct_unhtmlentities(ct_currency_format($row['total']-$row['amountpaid'])),$mail_content);
	#{invoice_date} = Date of invoice and participant registration.
	$mail_content=str_replace("{invoice_date}",ct_date_format($row['regdate']),$mail_content);
	#{invoice_link} = Direct link to invoice (does not require login).	
	$link = ct_get_invoicelink($row['ID']);
	if ($link) $mail_content=str_replace("{invoice_link}",$link,$mail_content);
	
	return $mail_content;
}


/**
 * Wraps message text to 78 characters per line
 * Original written by philippe for phpmailer
 *
 * @param string $message the message text
 * @return string the message with a maximum line length of 78 characters.
 */
function wrap_text($message, $line_length=78) {
    $LE = "\n";
    if (substr($message, -1) == $LE)
        $message = substr($message, 0, -1);

    $line = explode($LE, $message);
    $message = "";
    for ($i=0 ;$i < count($line); $i++) {
      $line_part = explode(" ", $line[$i]);
      $buf = "";
      for ($e = 0; $e<count($line_part); $e++) {
        $word  = $line_part[$e];
        $buf_o = $buf;
        $buf  .= ($e == 0) ? $word : (" " . $word);

        if (strlen($buf) > $line_length and $buf_o != "") {
            $message .= $buf_o . $LE;
            $buf = $word;
        }
      }
      $message .= $buf . $LE;
    }
    return $message;
}


?>