<?php
//
// send a mail to the participant
//

/**
 * send participation confirmation email...
 * send mail with registration and payment information
 */
function participant_registration_confirmation($participation,$extratext='') {
	ct_load_lib('mail.lib');
	ct_load_lib('participation.lib');
	global $session;

	if (!ctconf_get('participationRegistrationMail','1')) return false; // Do not send a mail...

	$mail_participation="";
	// if (ctconf_get('payment/enabled')) {
	$mail_participation.=ct_currency_format($participation->get('total'),true,true).".\n\n";
	if ($participation->get('paymethod')=='cc')
		$mail_participation.=ct('S_USER_PART_EMAIL_CC')."\n";
	if ($participation->get('paymethod')=='ccexternal')
		$mail_participation.=ct('S_USER_PART_EMAIL_CCEXTERNAL')."\n";
	if ($participation->get('paymethod')=='cash')
		$mail_participation.=ct('S_USER_PART_EMAIL_CASH')."\n";
	if ($participation->get('paymethod')=='fax')
		$mail_participation.=ct('S_USER_PART_EMAIL_FAX')."\n";
	if ($participation->get('paymethod')=='extra1')
		$mail_participation.=ct('S_INVOICE_PAYMENT_EXTRA1')."\n";
	if ($participation->get('paymethod')=='extra2')
		$mail_participation.=ct('S_INVOICE_PAYMENT_EXTRA2')."\n";
	if ($participation->get('paymethod')=='extra3')
		$mail_participation.=ct('S_INVOICE_PAYMENT_EXTRA3')."\n";
	if ($participation->get('paymethod')=="transfer") {
		$mail_participation.=ct('S_USER_PART_EMAIL_TRANSFER')."\n\n";
		$mail_participation.=ct('S_INVOICE_BANK_DETAILS')."\n";
		$mail_participation.=ct('S_INVOICE_ACCHOLDER').' '.ctconf_get('paymentTransferAccountHolder')."\n";
		$mail_participation.=ct('S_INVOICE_ACCOUNTNO').' '.ctconf_get('paymentTransferAccountNo')."\n";
		$mail_participation.=ct('S_INVOICE_BANK_NAME').' '.ctconf_get('paymentTransferBankName')."\n";
		$mail_participation.=ct('S_INVOICE_BANK_CODE').' '.ctconf_get('paymentTransferBankCode')."\n\n";
		$mail_participation.=ct('S_INVOICE_INTERNATIONAL_BANK_DETAILS')."\n";
		$mail_participation.=ct('S_INVOICE_SWIFTCODE').' '.ctconf_get('paymentTransferSWIFT')."\n";
		$mail_participation.=ct('S_INVOICE_IBAN_CODE').' '.ctconf_get('paymentTransferIBAN')."\n\n";
		$mail_participation.=ct('S_INVOICE_TRANSFER_REASON').' '.ct('S_USER_ID').' '.$participation->person->get('ID').', '.ctconf_get('conferenceShortName')."\n";
		#$mail_participation.=ct('S_INVOICE_TRANSFER_REASON').' '.$participation->get('invoiceNo').' '.ct('S_USER_ID').' '.$participation->person->get('ID')."\n";
	}
	if ($participation->get('paymethod')=='cheque') {
		$mail_participation.=ct('S_INVOICE_PAYMENT_CHEQUE')."\n";
		$mail_participation.=ct('S_INVOICE_PAYMENT_CHEQUE_PAYABLETO').": ".ctconf_get('paymentChequePayableTo')."\n\n";
		$mail_participation.=ct('S_INVOICE_PAYMENT_CHEQUE_SENDTO').":\n".ctconf_get('paymentChequeReceiver')."\n";
	}
	if ($participation->get('paymethod')=='paypal') {
		$mail_participation.=ct('S_USER_PART_EMAIL_PAYPAL')."\n";
	}

	// create mail content.
	$mail_content = ct_get_mail_greeting_fullname($participation->person).",\n\n";
	$mail_content .= ct('S_USER_PART_EMAIL_CONTENT1')." ".$mail_participation."\n";

	$link = ct_get_invoicelink($participation->person->get_id());
	if ($link)
		$mail_content .= ct('S_INVOICE_PUBLIC_LINK',array($participation->get_invoice_title())).":\n".$link."\n\n";
	
	// Add extra message
	if ($extratext!='')
		$mail_content.=$extratext;

	// Add another extra message entered in backoffice
	if (ctconf_get('participationRegistrationMailHintOK')!='')
		$mail_content.=ctconf_get('participationRegistrationMailHintOK')."\n\n";

	$mail_content.= ct('S_USER_PART_EMAIL_CONTENT2')."\n";
	$mail_content.= ct_get_mail_signature();
	$mail_content = strip_tags(br2nl($mail_content));

	$cc = array();
	if ($participation->get('email') && $participation->get('email')!=$participation->person->get('email'))
		$cc[]=$participation->get('email');	// Copy e-mail to receiver of invoice
	if ($participation->get('ccemail') && $participation->get('ccemail')!=$participation->person->get('email'))
		$cc[]=$participation->get('ccemail');	// Copy e-mail to credit card owner

	$bcc = array();
	if (ctconf_get('participationRegistrationMailBCC','')!='') $bcc[]=ctconf_get('participationRegistrationMailBCC');

	ct_mail(stripslashes($participation->person->get('email')),ct('S_USER_PART_EMAIL_SUBJECT').' "'.ctconf_get('conferenceShortName').'"',$mail_content,'','',$cc,$bcc);
}

// -------------------------------------------------------------------


/**
 * Send registrtion of participation failure mail
 *
 * @param CTparticipation $participation participant object
 * @param string $extratext extra text to add to mail...
 */
function participant_registration_cancelled($participation,$extratext='') {
	ct_load_lib('mail.lib');
	global $session;

	if (!ctconf_get('participationRegistrationMail','1')) return false; // Do not send a mail...

	$mail_content =ct_get_mail_greeting_fullname($participation->person).",\n\n";

	$mail_content.=ct('S_USER_PART_EMAIL_FAILED_CONTENT')."\n\n";

	// Add extra message
	if ($extratext!='')
		$mail_content.=$extratext;

	// Add another extra message entered in backoffice
	if (ctconf_get('participationRegistrationMailHintCancelled')!='')
		$mail_content.=ctconf_get('participationRegistrationMailHintCancelled')."\n\n";

	$mail_content.=ct_get_mail_signature();

	$cc = array();
	if ($participation->get('email')) $cc[]=$participation->get('email');	// Copy e-mail to receiver of invoice
	if ($participation->get('ccemail')) $cc[]=$participation->get('ccemail');	// Copy e-mail to credit card owner

	$bcc = array();
	if (ctconf_get('participationRegistrationMailBCC','')!='') $bcc[]=ctconf_get('participationRegistrationMailBCC');

	ct_mail(stripslashes($participation->person->get('email')),ct('S_USER_PART_EMAIL_FAILED_SUBJECT',array(ctconf_get('conferenceShortName'))),$mail_content,'','',$cc,$bcc);
}


?>