<?php
//
// Description: Navigational functions for overview pages
// CTNavbar is included in this file, as it is only accessed by the functions provided 
// by this library.
//


// show navigation bar with search and page navigation etc...
function ct_navbar($page,$items) {
	$navbar=new CTNavbar();
	$navbar->items=$items;
	$navbar->page=$page;
	$navbar->init_from_http_vars();
	return $navbar->show_navbar();
}

// show navigation bar with search and page navigation etc...
function ct_navbar_small($page,$items) {
	$navbar=new CTNavbar();
	$navbar->items=$items;
	$navbar->page=$page;
	$navbar->init_from_http_vars();
	return $navbar->show_navbar_small();
}

function ct_navbar_pageselector($page,$items) {
	$navbar=new CTNavbar();
	$navbar->items=$items;
	$navbar->page=$page;
	$navbar->init_from_http_vars();
	return $navbar->navbar_pageselector();
}

class CTNavbar {
	
	var $items   = 0;
	var $page	 = ''; // name of current page.

	var $navspan = 2;  // How many items before and after the current page to be shown

	var $search  = '';
	var $pageno  = 0; 
	var $perpage = 0;
	var $maxpage = 0;
	//echo "Maximum page number:".$maxpage."<br>";
	
	function CTNavbar() {
		$this->perpages= array(
						#array("2","2"),
						array("10","10"),
						array("15","15"),
						array("20","20"),
						array("25","25"),
						array("50","50"),
						array("100","100"),
						array("250","250"),
						array("500","500"),
						array("1000","1000"),
						array("999999",ct('S_ADMIN_NAVBAR_IFINITE')));
		
		$this->perpage    = ctconf_get('display_perpage',20);
	}						


	function init_from_http_vars() {
		global $db, $http, $ctconf;
		$this->search     = isset($http['navbar_search'])?$http['navbar_search']:"";
		$this->pageno     = isset($http['navbar_page'])?$http['navbar_page']:0; // default is 0
		//echo "Current page No. (Starts with 0):".$pageno."<br>";
		$this->perpage    = isset($http['navbar_perpage']) && $http['navbar_perpage']!=""?$http['navbar_perpage']:ctconf_get('display_perpage',20);
		//echo "Items per page:".$perpage."<br>";
		$this->maxpage    = intval(($this->items-1)/($this->perpage));
		//echo "Maximum page number:".$maxpage."<br>";

		if ($this->pageno>$this->maxpage) {
			$http['navbar_page'] = $this->pageno = $this->maxpage; // navbar_page may be changed here!
		}
	}

	function show_navbar() {
		//   echo "<br>\n";

		echo "<table width=\"100%\" align=\"center\" cellspacing=0 cellpadding=1 border=0>\n";
		echo "<tr><td class=\"navbarborder\">\n";
		
		echo "<table width=\"100%\" align=\"center\" cellspacing=0 cellpadding=2 border=0>\n";
		echo "<tr class=\"lightbg\">\n";
	
		// Show search box...
	
		echo "<td colspan=\"1\" width=\"25%\"";
		if ($this->search != "")  // Show in yellow is search word entered...
		echo " class=\"form_td_label_yellow\"";
		echo ">";
		// hidden fields
		echo "<form action=\"".ct_pageurl("")."\" method=\"get\">";
		$http_vars = hash2aa(ct_http_array()); // list all http variables with values (without navbar perpage...)
		if (sizeof($http_vars) > 0) {
			while (list(,$h) = each($http_vars)) {
				if ($h[0]!="navbar_search")
					echo "<input type=\"hidden\" name=\"".$h[0]."\" value=\"".$h[1]."\">\n";
			}
		}
		echo "<input type=\"hidden\" name=\"page\" value=\"$this->page\">\n";
		echo "<input type=\"text\" name=\"navbar_search\" value=\"".ct_form_encode($this->search)."\" size=\"12\" maxlength=\"25\">";
		echo "<input class=\"button\" type=\"submit\" name=\"cmd_search\" value=\"".ct('S_ADMIN_NAVBAR_SEARCH')."\">";
		echo "</form>\n";
		echo "</td>\n";
		
		// Show page selector
		// ----------------------------
		echo "<td colspan=\"1\" width=\"50%\" align=\"center\">&nbsp;";
		$this->navbar_pageselector();
		echo "</td>\n";
		
		// show "Items per page chooser" 
		// ------------------------------
		echo "<td colspan=\"1\" width=\"25%\" align=\"right\">";
		$this->navbar_itemsperpage();
		echo "</td>\n";
		
		// Second row with infos
		echo "</tr>\n";
		echo "<tr class=\"darkbg\">\n";
		echo "<td colspan=\"1\" align=\"left\"><span class=\"form_label\">";
		echo ct('S_ADMIN_NAVBAR_ONLIST1');
		echo " ".$this->items." ";
		echo ct('S_ADMIN_NAVBAR_ONLIST2');
		echo "</span></td>\n";
		echo "<td colspan=\"2\" align=\"right\">";
		echo "<span class=\"form_label\">";
		echo ct('S_ADMIN_NAVBAR_PAGEOF1');
		echo " ".($this->pageno+1)." ";
		echo ct('S_ADMIN_NAVBAR_PAGEOF2');
		echo " ".($this->maxpage+1);
		echo "</span>";
		echo "</td>\n";
		echo "</tr>\n";
		echo "</table>\n";
		
		echo "</td></tr>\n";
		echo "</table>\n";
		ct_vspacer();
			
		return $pageno;
	}

	function show_navbar_small() {
		//   echo "<br>\n";
		//echo "<table width=\"99%\" align=\"center\" cellspacing=0 cellpadding=1 border=0>\n";
		//echo "<tr><td class=\"navbarborder\">\n";
		
		echo "<table width=\"100%\" align=\"center\" cellspacing=0 cellpadding=1 border=0>\n";
		echo "<tr class=\"lightbg\">\n";
		/*
		echo "<td colspan=\"1\" width=\"25%\" align=\"left\">";
		echo "<span class=\"fontnormal font10\">&nbsp;";
		echo ct('S_ADMIN_NAVBAR_ONLIST1');
		echo " ".$this->items." ";
		echo ct('S_ADMIN_NAVBAR_ONLIST2');
		echo "</span></td>\n";
		*/
		// Show page selector
		// ----------------------------
		echo "<td colspan=\"1\" width=\"50%\" align=\"center\">&nbsp;";
		$this->navbar_pageselector();
		echo "</td>\n";
		
		/*
		echo "<td colspan=\"1\" width=\"25%\" align=\"right\">";
		echo "<span class=\"fontnormal font10\">";
		echo ct('S_ADMIN_NAVBAR_PAGEOF1');
		echo " ".($this->pageno+1)." ";
		echo ct('S_ADMIN_NAVBAR_PAGEOF2');
		echo " ".($this->maxpage+1);
		echo "&nbsp;</span>";
		echo "</td>\n"; 
		*/
		echo "</tr>\n";
		echo "</table>\n";
		
		//echo "</td></tr>\n";
		//echo "</table><br>\n";
		
		return $pageno;
	}

	function navbar_number($i) {
		echo "<a href=\"".ct_pageurl($this->page,ct_http_array(array('navbar_page' => $i)))."\" class=\"listheader_label\">".($i+1)."</a>";
	}
	
	
	function navbar_pageselector() {
		global $http, $ctconf;
		if ($this->pageno>0)
			echo "<a href=\"".ct_pageurl($this->page,ct_http_array(array('navbar_page' => $this->pageno-1)))."\" class=\"fontnormal font10\">".ct('S_ADMIN_NAVBAR_PREVIOUS')."</a>&nbsp;&middot;&nbsp;";
		
		if ($this->maxpage>0) {
			$navfrom = ($this->pageno-$this->navspan<0)?0:$this->pageno-$this->navspan;
			$navto   = ($this->pageno+$this->navspan<$this->maxpage)?$this->pageno+$this->navspan:$this->maxpage;
			if ($navfrom >= 1) {
				$this->navbar_number(0);
				if ($navfrom > 1) {
					echo " ... ";
				} else {
					echo "&nbsp;&nbsp;";
				}
			}
			for ($i=$navfrom; $i <= $navto; $i++) {
				if ($i==$this->pageno)
				echo "<span class=\"fontbold font12\">".($i+1)."</span>";
				else
				$this->navbar_number($i);
				if ($i<$navto) echo "&nbsp;&nbsp;"; // &middot; ";
			}
			if ($navto < $this->maxpage) {
				if ($navto == $this->maxpage-1) {
					echo "&nbsp;&nbsp;";
				} else {
					echo " ... ";
				}
				$this->navbar_number($this->maxpage);
			}
		}
		
		if ($this->pageno<$this->maxpage)
			echo "&nbsp;&middot;&nbsp;<a href=\"".ct_pageurl($this->page,ct_http_array(array('navbar_page' => $this->pageno+1)))."\" class=\"fontnormal font10\">".ct('S_ADMIN_NAVBAR_NEXT')."</a> ";
	}	
	
	function navbar_itemsperpage() {
		global $http, $ctconf;
		echo "<form action=\"".ct_pageurl("")."\" method=\"get\">";
		// hidden fields
		$http_vars = hash2aa(ct_http_array()); // list all http variables with values (without navbar perpage...)
		if (sizeof($http_vars) > 0) {
			while (list(,$h) = each($http_vars)) {
				if ($h[0]!="navbar_perpage")
					echo "<input type=\"hidden\" name=\"".$h[0]."\" value=\"".$h[1]."\">\n";
			}
		}
		echo "<input type=\"hidden\" name=\"page\" value=\"$this->page\">\n";
		echo "<table align=\"right\" class=\"form_table\" cellspacing=1 cellpadding=0 border=0>";
		// Title
		echo "<tr><td align=right class=\"listheader_label\">";
		echo "<span class=\"fontnormal font10\">".ct('S_ADMIN_NAVBAR_PERPAGE1')."</span></td>\n";
		// Select	
		echo "<td align=left valign=top class=\"listheader_label\">";
		echo "<select name=\"navbar_perpage\" size=\"1\" onChange=\"this.form.submit();\">";
		while (list($k,$v) = each($this->perpages)) {
			echo "<option value=\"".$v[0]."\"";
			if (in_array($v[0], array($this->perpage))) {
				echo " selected";
			}
		echo ">".$v[1]." </option>\n";
		}
		echo "</select>\n";
		echo "</td>\n";
		// Noscript
		echo "<td valign=top align=right class=\"listheader_label\">\n";
		echo "<noscript>\n";
		echo "<input class=\"button\" type=\"submit\" name=\"cmd_perpage\" ";
		echo "value=\"".ct('S_ADMIN_NAVBAR_PERPAGE2')."\">\n";
		echo "</noscript>\n";
		echo "</td>";
		echo "</tr>\n";
		echo "</table>\n";
		echo "</form>\n";
	}	
}
	
?>