<?php
//
// Description: Navigational functions for all assignment pages that require to submit data
// when the user navigates...
// CTNavbar_submitting is included in this file, as it is only accessed by the 
// functions provided by this library.
//


/**
 * show navigation bar with page navigation.
 */
function ct_navbar_submitting($items,$showperpageselector=false) {
	$navbar=new CTNavbar_Submitting();
	$navbar->items=$items;
	$navbar->init_from_http_vars();
	return $navbar->show_navbar($showperpageselector);
}

class CTNavbar_Submitting {
	
	var $items   = 0;

	var $navspan = 5;  // How many items before and after the current page to be shown

	var $search  = '';
	var $pageno  = 0; 
	var $perpage = 0;
	var $maxpage = 0;
	//echo "Maximum page number:".$maxpage."<br>";
	
	function CTNavbar_Submitting() {
		$this->perpages= array(
						array("10","10"),
						array("15","15"),
						array("25","25"),
						array("50","50"),
						array("100","100"),
						array("250","250"),
						array("500","500"),
						array("1000","1000"),
						array("999999",ct('S_ADMIN_NAVBAR_IFINITE')));
		
		$this->perpage    = ctconf_get('display_perpage_submitting',100);
	}						

	function init_from_http_vars() {
		global $db, $http, $ctconf;
		$this->pageno     = isset($http['navbar_page'])?$http['navbar_page']-1:(isset($http['navbar_lastpage'])?$http['navbar_lastpage']:0); // default is 0
		#echo "Current page No. (Starts with 0):".$this->pageno."<br>";
		$this->perpage    = isset($http['navbar_perpage']) && $http['navbar_perpage']!=""?$http['navbar_perpage']:$this->perpage;
		#echo "Items per page:".$this->perpage."<br>";
		$this->maxpage    = intval(($this->items-1)/($this->perpage));
		#echo "Maximum page number:".$this->maxpage."<br>";

		if ($this->pageno>$this->maxpage) {
			$http['navbar_page'] = $this->pageno = $this->maxpage; // navbar_page may be changed here!
		}
	}

	function show_navbar($showperpageselector) {
		//   echo "<br>\n";

		echo "<table width=\"100%\" align=\"center\" cellspacing=0 cellpadding=1 border=0>\n";
		echo "<tr><td class=\"navbarborder\">\n";
		
		echo "<table width=\"100%\" align=\"center\" cellspacing=0 cellpadding=2 border=0>\n";
		echo "<tr class=\"lightbg\">\n";

		// show "Items per page chooser" 
		// ------------------------------
		echo "<td colspan=\"1\" width=\"20%\" align=\"left\">";
		if ($showperpageselector)
			$this->navbar_itemsperpage();
		else
			echo "&nbsp;";
		echo "</td>\n";

		// Show page selector
		// ----------------------------
		echo "<td colspan=\"1\" width=\"60%\" align=\"center\">&nbsp;";
		$this->navbar_pageselector();
		echo "</td>\n";
		
		// show Save button
		// ------------------------------
		echo "<td colspan=\"1\" width=\"20%\" align=\"right\">";
		$this->navbar_savebutton();
		echo "</td>\n";
		
		// Second row with infos
		echo "</tr>\n";
		echo "<tr class=\"darkbg\">\n";
		echo "<td colspan=\"2\" align=\"left\"><span class=\"form_label\">";
		echo ct('S_ADMIN_NAVBAR_ONLIST1');
		echo " ".$this->items." ";
		echo ct('S_ADMIN_NAVBAR_ONLIST2');
		echo "</span></td>\n";
		echo "<td colspan=\"1\" align=\"right\">";
		echo "<span class=\"form_label\">";
		echo ct('S_ADMIN_NAVBAR_PAGEOF1');
		echo " ".($this->pageno+1)." ";
		echo ct('S_ADMIN_NAVBAR_PAGEOF2');
		echo " ".($this->maxpage+1);
		echo "</span>";
		echo "</td>\n";
		echo "</tr>\n";
		echo "</table>\n";
		
		echo "</td></tr>\n";
		echo "</table>\n";
		return $pageno;
	}

	function navbar_number($i) {
		echo "<input type=submit name='navbar_page' class='smallbutton' value='".($i+1)."'>";
	}
	
	
	function navbar_pageselector() {
		global $http, $ctconf;
		#if ($this->pageno>0)
			#echo "<a href=\"".ct_pageurl($this->page,ct_http_array(array('navbar_page' => $this->pageno-1)))."\" class=\"fontnormal font10\">".ct('S_ADMIN_NAVBAR_PREVIOUS')."</a>&nbsp;&middot;&nbsp;";
		
		if ($this->maxpage>0) {
			$navfrom = ($this->pageno-$this->navspan<0)?0:$this->pageno-$this->navspan;
			$navto   = ($this->pageno+$this->navspan<$this->maxpage)?$this->pageno+$this->navspan:$this->maxpage;
			if ($navfrom >= 1) {
				$this->navbar_number(0);
				if ($navfrom > 1) {
					echo " ... ";
				} else {
					echo "&nbsp;";
				}
			}
			for ($i=$navfrom; $i <= $navto; $i++) {
				if ($i==$this->pageno)
				echo "<span class=\"fontbold font12\">".($i+1)."</span>";
				else
				$this->navbar_number($i);
				if ($i<$navto) echo "&nbsp;"; // &middot; ";
			}
			if ($navto < $this->maxpage) {
				if ($navto == $this->maxpage-1) {
					echo "&nbsp;";
				} else {
					echo " ... ";
				}
				$this->navbar_number($this->maxpage);
			}
		}
		
		#if ($this->pageno<$this->maxpage)
			#echo "<input type=submit name='navbar_page' value='".($this->pageno+1+1)."'>";
			#echo "&nbsp;&middot;&nbsp;<a href=\"".ct_pageurl($this->page,ct_http_array(array('navbar_page' => $this->pageno+1)))."\" class=\"fontnormal font10\">".ct('S_ADMIN_NAVBAR_NEXT')."</a> ";
	}	
	
	function navbar_itemsperpage() {
		global $http, $ctconf;
		echo "<table align=\"left\" class=\"form_table\" cellspacing=1 cellpadding=0 border=0>";
		// Title
		echo "<tr><td align=left class=\"listheader_label\">";
		echo "<span class=\"fontnormal font10\">".ct('S_ADMIN_NAVBAR_PERPAGE1')."</span></td>\n";
		// Select	
		echo "<td align=left valign=top class=\"listheader_label\">";
		echo "<select name=\"navbar_perpage\" size=\"1\" onChange=\"this.form.submit();\">";
		while (list($k,$v) = each($this->perpages)) {
			echo "<option value=\"".$v[0]."\"";
			if (in_array($v[0], array($this->perpage))) {
				echo " selected";
			}
		echo ">".$v[1]." </option>\n";
		}
		echo "</select>\n";
		echo "</td>\n";
		// Noscript
		echo "<td valign=top align=left class=\"listheader_label\">\n";
		echo "<noscript>\n";
		echo "<input class=\"button\" type=\"submit\" name=\"cmd_perpage\" ";
		echo "value=\"".ct('S_ADMIN_NAVBAR_PERPAGE2')."\">\n";
		echo "</noscript>\n";
		echo "</td>";
		echo "</tr>\n";
		echo "</table>\n";
	}	

	function navbar_savebutton() {
		echo "<input type=\"hidden\" name=\"navbar_lastpage\" value=\"".$this->pageno."\">\n";
		echo "<input type=\"submit\" class=\"button\" value=\"".ct('S_BUTTON_SAVE')."\">\n";
	}		

}
	
?>