<?php

/**
 * Show a link to paypal or the paypal sandbox using the participant data.
 *
 * @param CTParticipant $participant The participant object
 */
function show_paypal_link($participant) {
	// Only show if no date is marked, yet...
	if ($participant->get('total')>$participant->get('payamount')) {
		global $session, $ctconf;
		ct_load_lib('mail.lib'); // here is the function to remove non-ascii characters: ct_replace_iso_chars 
		
		if (ctconf_get('paymentPaypalDemo',0))  // Paypal demo in sandbox only?
			echo "<form action=\"https://www.sandbox.paypal.com/cgi-bin/webscr\" method=\"post\">\n";
		else
			echo "<form action=\"https://www.paypal.com/cgi-bin/webscr\" method=\"post\">\n";

		echo "<input type=\"hidden\" name=\"notify_url\" value=\"".ct_pageurl('paypal_paymentReceived')."\">\n";
		echo "<input type=\"hidden\" name=\"return\" value=\"".ct_pageurl('paypal_paymentReceived')."\">\n";
		echo "<input type=\"hidden\" name=\"cancel_return\" value=\"".ct_pageurl('paypal_paymentCancelled')."\">\n";  // Payment cancelled page in ConfTool
		
		echo "<input type=\"hidden\" name=\"rm\" value=\"2\">\n"; // Return method: 2=Post
		echo "<input type=\"hidden\" name=\"amount\" value=\"".number_format($participant->get('total') - $participant->get('payamount'),2)."\">\n";
		echo "<input type=\"hidden\" name=\"currency_code\" value=\"".ctconf_get('paymentPaypalCurrency')."\">\n";
		echo "<input type=\"hidden\" name=\"item_name\" value=\"".ct_replace_iso_chars(ctconf_get('conferenceShortName')." - ".ct('S_USER_ID').":".$participant->get('personID'))."\">\n";	// name of "item"
		echo "<input type=\"hidden\" name=\"no_note\" value=\"1\">\n"; // User is NOT prompted to enter a note.
		echo "<input type=\"hidden\" name=\"no_shipping\" value=\"1\">\n"; // A shipping address is not required!
		// Charset does NOT work! An error in PayPal... (as Dez 2006)
		//echo "<input type=\"hidden\" name=\"charset\" value=\"".'UTF-8'."\">\n";
		echo "<input type=\"hidden\" name=\"charset\" value=\"".ctconf_get('charset','iso-8859-1')."\">\n";
		//echo "<input type=\"hidden\" name=\"display\" value=\"0\">\n"; // Do not show paypals shopping cart.

		//echo "<input type=\"hidden\" name=\"cmd\" value=\"_xclick\">\n"; // Not used, as the data is already "pre-populated"
		echo "<input type=\"hidden\" name=\"cmd\" value=\"_ext-enter\">\n";         // use these instead to pre-populate form
		echo "<input type=\"hidden\" name=\"redirect_cmd\" value=\"_xclick\">\n";   // "
		echo "<input type=\"hidden\" name=\"business\" value=\"".ctconf_get('paymentPaypalAccount')."\">\n"; // Paypal email address of receiver
		echo "<input type=\"hidden\" name=\"custom\" value=\"".$participant->get('personID')."\">\n";	// Custom field to return: User ID
		echo "<input type=\"hidden\" name=\"email\" value=\"".$participant->person->get('email')."\">\n";
		echo "<input type=\"hidden\" name=\"first_name\" value=\"".ct_replace_iso_chars(substr($participant->person->get('firstname'),0,32))."\">\n";
		echo "<input type=\"hidden\" name=\"last_name\" value=\"".ct_replace_iso_chars(substr($participant->person->get('name'),0,64))."\">\n";
		echo "<input type=\"hidden\" name=\"address1\" value=\"".ct_replace_iso_chars(substr($participant->person->get('addr1'),0,100))."\">\n";
		echo "<input type=\"hidden\" name=\"address2\" value=\"".ct_replace_iso_chars(substr($participant->person->get('addr2'),0,100))."\">\n";
		echo "<input type=\"hidden\" name=\"city\" value=\"".ct_replace_iso_chars(substr($participant->person->get('city'),0,100))."\">\n";
		echo "<input type=\"hidden\" name=\"state\" value=\"".substr($participant->person->get('state'),0,32)."\">\n";
		echo "<input type=\"hidden\" name=\"zip\" value=\"".substr($participant->person->get('zip'),0,32)."\">\n";
		echo "<input type=\"hidden\" name=\"country\" value=\"".substr($participant->person->get('country'),0,2)."\">\n";

		// Set language for login screen: Does not really work as language is mainly determined by country code! 
		// Allowed values: AU DE FR IT GB ES US 		
		$language="US";
		if (strpos($ctconf['lang'][$session->get('langno')]['language'],"german")===0) $language="DE";
		if (strpos($ctconf['lang'][$session->get('langno')]['language'],"french")===0) $language="FR";
		if (strpos($ctconf['lang'][$session->get('langno')]['language'],"spanish")===0) $language="ES";
		echo "<input type=\"hidden\" name=\"lc\" value=\"".$language."\">\n"; 
	
		echo "<input type=\"image\" name=\"submit\" border=\"0\" ";
		echo "src=\"images/x-click-but6.gif\" "; // Paypal image for button
		// echo "src=\"https://www.paypal.com/en_US/i/btn/x-click-but6.gif\" "; // Paypal image for button
		// echo "src=\"https://www.paypal.com/de_DE/i/btn/x-click-but6.gif\" ";
		echo "alt=\"\">\n"; // alternative text
	
		echo "</form>\n\n\n";
		echo '<p class="fontlabel font10">'.ct('S_INVOICE_PAYMENT_COOKIES_REQUIRED',array('<a href="mailto:'.ctconf_get('conferenceContactEmail').'">'.ctconf_get('conferenceContactEmail').'</a>')).'</p>';
	}
}

?>