<?php
//
// PAGE:        adminMailerParticipants
// DESC:        send bulk mails to all Participants of the conference
//				There are three kinds of receivers: user - the participant, billing - the receiver of the invoice, cc - the credit card holder
//

ct_requireassistantorconferencechair();
ct_pagepath(array('index','adminMailer'));
ct_load_lib('participation.lib');
ct_load_lib('payment.lib');
ct_load_lib('mail.lib');
ct_load_lib('mail_bulk.lib');
ct_load_lib('datetime.lib');
ct_load_class('CTForm');
ct_load_class('CTParticipation');

$person = new CTPerson();
$participation = new CTParticipation;

if( !ini_get('safe_mode') ){
	// Does _not_ work in SAFE MODE
	set_time_limit(1800);
}
ob_end_flush();

$form_errors=array();

if (in_http('cmd_checkmail')) {
	// Check the selected settings before sending the mails...
	if (ct_validate_email($http['form_mailfrom'])===false) $form_errors[]="form_mailfrom";
	if ($http['form_mailreplyto']!="" && ct_validate_email($http['form_mailreplyto'])===false) $form_errors[]="form_mailreplyto";
	if ($http['form_mailsubject']=="") $form_errors[]="form_mailsubject";
	if ($http['form_mailbody']=="") $form_errors[]="form_mailbody";
	
	if ($http['form_emails']=="") $form_errors[]="form_emails[]";
	
	if ( count($form_errors)!=0 ) {
		ct_errorbox(ct('S_ERROR_MAILER'), ct('S_ERROR_MAILER_INCOMPLETE'));
		mailer_header();
		show_form($form_errors);
	} else {
		// Show confirmation page before sending mails...
		mailer_header();
		echo "<p class=\"fontbold font10\">".ct('S_ADMIN_MAILER_SENDNOW')."</p>\n";
		echo "<p class=\"fontnegative fontbold font10\">".ct('S_ADMIN_MAILER_HINTS')."</p>\n";

		// Add hidden form elements ------------------------------
		echo "<form action=\"".ct_pageurl('adminMailerParticipants')."\" method=\"post\">\n";
		echo "<input type=\"hidden\" name=\"form_mailfrom\" value=\"".ct_form_encode($http['form_mailfrom'])."\">\n";
		echo "<input type=\"hidden\" name=\"form_mailreplyto\" value=\"".ct_form_encode($http['form_mailreplyto'])."\">\n";
		echo "<input type=\"hidden\" name=\"form_mailsubject\" value=\"".ct_form_encode($http['form_mailsubject'])."\">\n";
		echo "<input type=\"hidden\" name=\"form_mailbody\" value=\"".ct_form_encode($http['form_mailbody'])."\">\n";
		
		if (in_http('form_discounts'))
			echo "<input type=\"hidden\" name=\"form_discounts\" value=\"".ct_form_encode($http['form_discounts'])."\">\n";
		if (in_http('form_group'))
			echo "<input type=\"hidden\" name=\"form_group\" value=\"".ct_form_encode($http['form_group'])."\">\n";
		if (in_http('form_payment'))
			echo "<input type=\"hidden\" name=\"form_payment\" value=\"".ct_form_encode($http['form_payment'])."\">\n";
		if (in_http('form_notpaid') && $http['form_notpaid']!='-') 
			echo "<input type=\"hidden\" name=\"form_notpaid\" value=\"".ct_form_encode($http['form_notpaid'])."\">\n";
		if (is_array($http['form_event'])) {
			foreach ($http['form_event'] as $e)
				echo "<input type=\"hidden\" name=\"form_event[]\" value=\"".ct_form_encode($e)."\">\n";
		}
		if (in_http('form_eventtype'))
			echo "<input type=\"hidden\" name=\"form_eventtype\" value=\"".ct_form_encode($http['form_eventtype'])."\">\n";
		if (is_array($http['form_emails'])) {
			reset ($http['form_emails']);
			foreach ($http['form_emails'] as $e)
				echo "<input type=\"hidden\" name=\"form_emails[]\" value=\"".ct_form_encode($e)."\">\n";
		}
		
		
		// Write Mail preview info -----------------------------------
		echo '<table align="center" width="100%" class="form_table" cellspacing=1 cellpadding=2 border=0>';

		echo '<tr><td colspan="3" valign=top align=left class="form_td_separator_gradient">';
		echo "<span class=\"form_separator_label\">".ct('S_ADMIN_MAILER_MAIL_HEAD')."</span></td></tr>\n";

		if (in_http('form_group') && $http['form_group']>0) {
			echo '<tr><td width="25%" valign=top align=right class="form_td_label topline_white">';
			echo '<span class="form_label">'.ct('S_PARTICIPATION_FORM_GROUPS').'</span></td>';
			echo "<td width=\"75%\" align=left valign=top class=\"topline_white form_td_field\">".$participation->_get_status($http['form_group'])."</td></tr>\n";
		}
		if (in_http('form_discounts') && $http['form_discounts']>0) {
			echo '<tr><td width="25%" valign=top align=right class="form_td_label topline_white">';
			echo '<span class="form_label">'.ct('S_PARTICIPATION_FORM_DISCOUNTS').'</span></td>';
			echo "<td width=\"75%\" align=left valign=top class=\"topline_white form_td_field\">".get_timediscount($http['form_discounts'])."</td></tr>\n";
		}
		if (in_http('form_payment') && $http['form_payment']>0) {
			echo '<tr><td width="25%" valign=top align=right class="form_td_label topline_white">';
			echo '<span class="form_label">'.ct('S_ADMIN_TOOL_PAYMENT_CMD').'</span></td>';
			echo "<td width=\"75%\" align=left valign=top class=\"topline_white form_td_field\">".ct_get_payment_description($http['form_payment'])."</td></tr>\n";
		}
		if (in_http('form_notpaid') && $http['form_notpaid']!='-') {
			$paystatus = list_payment_status();
			echo '<tr><td width="25%" valign=top align=right class="form_td_label topline_white">';
			echo '<span class="form_label">'.ct('S_ADMIN_PARTICIPANTS_PAYMENT').'</span></td>';
			echo "<td width=\"75%\" align=left valign=top class=\"topline_white form_td_field\">";
			foreach ($paystatus as $p) {
				if ($p[0] == $http['form_notpaid']) echo $p[1];
			}
			echo "</td></tr>\n";
		}

		if (is_array($http['form_event'])) {
			echo '<tr><td width="25%" valign=top align=right class="form_td_label topline_white">';
			echo '<span class="form_label">'.ct('S_ADMIN_TOOL_EVENTS_CMD').'</span></td>';
			echo "<td width=\"75%\" align=left valign=top class=\"topline_white form_td_field\">";
			if (in_array('0',$http['form_event'])) {
				echo ct('S_ADMIN_TOOL_ALLPARTICIPANTS');
			} else {
				$events = ct_get_events();
				foreach ($http['form_event'] as $e) {
					foreach ($events as $f) {
						if ($f['ID'] == $e) echo $f['title'].'<br>';
					}
				}
			}
			echo "</td></tr>\n";
		}
		if (in_http('form_eventtype') && $http['form_eventtype']>0) {
			echo '<tr><td width="25%" valign=top align=right class="form_td_label topline_white">';
			echo '<span class="form_label">'.ct('S_ADMIN_TOOL_EVENTTYPES_CMD').'</span></td>';
			echo "<td width=\"75%\" align=left valign=top class=\"topline_white form_td_field\">";
			$eventtypes = ct_get_eventtypes();
			foreach ($eventtypes as $e) {
				if ($e['ID'] == $http['form_eventtype']) echo $e['title'];
			}
			echo "</td></tr>\n";
		}

		echo "<tr class=\"infoview_sep\"><td align=\"left\" valign=\"top\" colspan=2>";
		echo "<img src=\"spacer.gif\" width=1 height=1 border=0 alt=''>";
		echo "</td></tr>\n";
		
		if (is_array($http['form_emails'])) {
			echo '<tr><td width="25%" valign=top align=right class="form_td_label topline_white">';
			echo '<span class="form_label">'.ct('S_ADMIN_MAILER_PARTICIPANTS_RECEIVERS').'</span></td>';
			echo "<td width=\"75%\" align=left valign=top class=\"topline_white form_td_field\">";
			foreach ($http['form_emails'] as $e) {
				echo ct_form_encode(get_email_receiver($e)).'<br>';
			}
			echo "</td></tr>\n";
		}
			

		echo '<tr><td width="25%" valign=top align=right class="form_td_label topline_white">';
		echo '<span class="form_label">'.ct('S_ADMIN_MAILER_FROM').'</span></td>';
		echo "<td width=\"75%\" align=left valign=top class=\"topline_white form_td_field\">".ct_form_encode($http['form_mailfrom'])."</td></tr>\n";

		if (!$http['form_mailreplyto']=="") {
			echo '<tr><td width="25%" valign=top align=right class="form_td_label topline_white">';
			echo '<span class="form_label">'.ct('S_ADMIN_MAILER_REPLYTO').'</span></td>';
			echo "<td width=\"75%\" align=left valign=top class=\"topline_white form_td_field\">".ct_form_encode($http['form_mailreplyto'])."</td></tr>\n";
		}

		echo '<tr><td width="25%" valign=top align=right class="form_td_label topline_white">';
		echo '<span class="form_label">'.ct('S_ADMIN_MAILER_SUBJECT').'</span></td>';
		echo "<td width=\"75%\" align=left valign=top class=\"topline_white form_td_field\">".ct_form_encode($http['form_mailsubject'])."</td></tr>\n";

		echo '<tr><td valign=top align=left colspan=2 class="listheader">';
		echo '<span class="fontbold font10">'.ct('S_ADMIN_MAILER_BODY').'</span></td></tr>';
		$pattern = "/({\w*})/i";
		$format  = "<i><b>\$1</b></i>";
		$body = preg_replace($pattern, $format, ct_form_encode($http['form_mailbody'])); // underline presenting author

		echo "<tr><td align=left valign=top colspan=2 class=\"whitebg\"><span class=\"fontmonospaced font9\">".nl2br($body)."\n</span><br></td></tr>\n";
		echo "</table><BR>\n";

		$r = get_query();

		// JavaScript to Check/Uncheck all checkboxes.
		ct_load_lib("javascript.lib");
		$function_name = "checkAll";
		$checkbox_name = "f[]"; // also set in subroutine!!
		echo get_js_checkbox_selector($function_name,$checkbox_name);
		
		// List of receivers: Create header --------------------------
		echo "<div align=\"center\">\n";
		echo "<table width=\"100%\">\n";

		// Submit / Back
		echo "<tr><td colspan=7 align=right class=\"mediumbg\">";
		echo "<input type=submit name=\"cmd_back\" class=\"button\" value=\"".ct('S_BUTTON_BACK')."\">";
		echo "&nbsp;";
        if (ctconf_get('demomode')) {
			echo "<input disabled style=\"color: #000\"; type=\"submit\" name=\"cancel\" value=\"".ct('S_ADMIN_MAILER_SEND_SUBMIT')." ".ct('S_BUTTON_DEMO')."\">\n";
        } else {
   			echo "<input type=submit name=\"cmd_sendmail\" class=\"button\" value=\"".ct('S_ADMIN_MAILER_SEND_SUBMIT')."\">";
        }
		echo "</td></tr>\n";

		// Main header
		echo '<tr><td colspan="7" valign=top align=left class="form_td_separator_gradient">';
		echo "<span class=form_separator_label>".ct('S_ADMIN_MAILER_RECEIVER_HEAD').": ".ct('S_ADMIN_USERS_BROWSE_SUM1')." ".$db->num_rows($r)." ".ct('S_ADMIN_USERS_BROWSE_SUM2')."</span></td></tr>\n";

		// Table header ---------------------------------
		echo "<tr class=\"listheader\">\n";
		echo "<td align=right valign=top><span class=\"fontnormal font10\"><input type=\"checkbox\" class=\"checkboxradio\" checked onclick=\"$function_name(this);\"></span></td>\n";
		echo "<td align=right valign=top><span class=\"fontbold font8\">".ct('S_ID')."</span></td>\n";
		echo "<td align=left valign=top>";
		echo "<span class=\"fontbold font8\">".ct('S_ADMIN_MAILER_PARTICIPANTS_RECEIVERS_SHORT')."</span>";
		echo "</td>";
		echo "<td align=left valign=top>";
		echo "<span class=\"fontnormal font8\">".ct('S_USER_FULLNAME')."</span>";
		echo "</td>";
		echo "<td align=left valign=top>";
		echo "<span class=\"fontnormal font8\">".ct('S_USER_EMAIL')."</span>";
		echo "</td>";
		echo "<td align=left valign=top>";
		echo "<span class=\"fontnormal font8\">".ct('S_USER_COUNTRY')."</span>";
		echo "</td>";
		echo "<td align=left valign=top width=\"2%\">";
		echo "<span class=\"fontbold font8\">".ct('S_ADMIN_MAILER_PREVIEW')."</span><br>";
		echo "</td>";
		echo "</tr>\n";

		if ($r && ($db->num_rows($r) > 0)) {

			for ($i = 0; $i < $db->num_rows($r); $i++) {
				$row = $db->fetch($r);
				if ($i % 2) {
					$class="oddrow";
				} else {
					$class="evenrow";
				}
				$showcheckbox = true;
				// Send mail to participant
				if (in_http('form_emails') && is_array($http['form_emails']) &&
							in_array('user',($http['form_emails']))) {
					show_preview_row($class, $showcheckbox, $row['ID'], 'user', ct('S_ADMIN_MAILER_PARTICIPANTS_RECEIVERS_USER_SHORT'), ct_form_encode($row['firstname'].' '.$row['name']), array($row['email'],$row['email2']) , $row['organisation'],$row['country']);
					$showcheckbox = false;
				}
				// send mail to receiver of invoice
				if (in_http('form_emails') && is_array($http['form_emails']) &&
							in_array('billing',($http['form_emails']))) {
					if ($row['billingaddress']!='true') {
						if (in_array('user',($http['form_emails']))) { // don't send second mail!
							show_preview_row($class.'2', $showcheckbox, $row['ID'], '-', ct('S_ADMIN_MAILER_PARTICIPANTS_RECEIVERS_BILLING_SHORT'), ct('S_ADMIN_MAILER_PARTICIPANTS_RECEIVERS_BILLING_MISSING'));
						} else { // send mail to user, as he is the invoice recipient.
							show_preview_row($class, $showcheckbox, $row['ID'], 'user', ct('S_ADMIN_MAILER_PARTICIPANTS_RECEIVERS_BILLING_SHORT'), ct_form_encode($row['firstname'].' '.$row['name']), $row['email'], $row['organisation'],$row['country']);
						}
					} else {
						show_preview_row($class, $showcheckbox, $row['ID'], 'billing', ct('S_ADMIN_MAILER_PARTICIPANTS_RECEIVERS_BILLING_SHORT'), ct_form_encode($row['billingfirstname'].' '.$row['billingname']), $row['billingemail'], $row['billingorganisation'],$row['billingcountry']);
						$showcheckbox = false;
					}
				}
				// show extra rows if CC shall be sent to 
				if (in_http('form_emails') && is_array($http['form_emails']) &&
							in_array('cc',($http['form_emails']))) {
					if (($row['paymethod']!='cc' && $row['paymethod']!='ccexternal') || $row['ccemail']=='') {
						show_preview_row($class.'2', $showcheckbox, $row['ID'], '-', ct('S_ADMIN_MAILER_PARTICIPANTS_RECEIVERS_CC_SHORT'), ct('S_ADMIN_MAILER_PARTICIPANTS_RECEIVERS_CC_MISSING'));
					} else {
						show_preview_row($class, $showcheckbox, $row['ID'], 'cc', ct('S_ADMIN_MAILER_PARTICIPANTS_RECEIVERS_CC_SHORT'), ct_form_encode($row['ccholder']), $row['ccemail'], '', $row['cccountry']);
						$showcheckbox = false;
					}
				}
			}
			echo "</table>\n\n";

			echo "<table width=\"98%\">\n";

			// Send protocol to...
			echo '<tr><td colspan="6" valign=top align=left class="form_td_separator_gradient">';
			echo '<span class=form_separator_label>'.ct('S_ADMIN_MAILER_SEND_PROTOCOL').": </span></td></tr>\n";

			echo "<tr class=\"evenrow\">\n";
			echo "<td align=right valign=top><span class=\"fontnormal font10\"><input type=\"checkbox\" class=\"checkboxradio\" name=\"form_sendprotocol_to_user\" value=\"1\" checked></span></td>\n";
			echo "<td colspan=2 align=left valign=top><span class=\"fontbold font10\">";
			echo $user->get_special('name').", ".$user->get_special('firstname')."</span>";
			echo "</td>\n";
			echo "<td colspan=3 align=left valign=top>";
			echo "<span	class=\"fontnormal font10\">&nbsp;<a href=\"mailto:".$user->get_special('email')."\">";
			echo $user->get_special('email')."</a>\n";
			echo "</span>";
			echo "</td>\n";
			echo "</tr>\n";

			if ($user->get('email')!=$http['form_mailfrom']) {
				echo '<tr  class="evenrow">';
				echo "<td align=right valign=top><span class=\"fontnormal font10\"><input type=\"checkbox\" class=\"checkboxradio\" name=\"form_sendprotocol_to_from\" value=\"1\" checked></span></td>\n";
				echo "<td colspan=2 align=left valign=top><span class=\"fontbold font10\">".ct('S_ADMIN_MAILER_FROM')."</span></td>\n";
				echo '<td colspan="3" valign=top align=left>';
				echo "<span	class=\"fontnormal font10\">&nbsp;<a href=\"mailto:".$http['form_mailfrom']."\">".$http['form_mailfrom']."</a></span>";
				echo "</td></tr>\n";
			}

			if (!$http['form_mailreplyto']=="" && $http['form_mailreplyto']!=$http['form_mailfrom']) {
				echo '<tr  class="oddrow">';
				echo "<td align=right valign=top><span class=\"fontnormal font10\"><input type=\"checkbox\" class=\"checkboxradio\" name=\"form_sendprotocol_to_replyto\" value=\"1\" checked></span></td>\n";
				echo "<td colspan=2 align=left valign=top><span class=\"fontbold font10\">".ct('S_ADMIN_MAILER_REPLYTO')."</span></td>\n";
				echo '<td colspan="3" valign=top align=left>';
				echo "<span	class=\"fontnormal font10\">&nbsp;<a href=\"mailto:".$http['form_mailreplyto']."\">".$http['form_mailreplyto']."</a></span>";
				echo "</td></tr>\n";
			}

			// Submit button...
			echo "<tr><td colspan=3 align=left class=\"mediumbg\">".ct('S_ADMIN_USERS_BROWSE_SUM1')." $i ".ct('S_ADMIN_USERS_BROWSE_SUM2')."</td><td colspan=3 align=right class=\"mediumbg\">";
   			echo "<input type=submit name=\"cmd_back\" class=\"button\" value=\"".ct('S_BUTTON_BACK')."\">";
			echo "&nbsp;";
            if (ctconf_get('demomode')) {
				echo "<input disabled style=\"color: #000\"; type=\"submit\" name=\"cancel\" value=\"".ct('S_ADMIN_MAILER_SEND_SUBMIT')." ".ct('S_BUTTON_DEMO')."\">\n";
            } else {
    			echo "<input type=submit name=\"cmd_sendmail\" class=\"button\" value=\"".ct('S_ADMIN_MAILER_SEND_SUBMIT')."\">";
            }
			echo "</td></tr>\n";

		}
		echo "</table>\n</div>\n</form>\n";
	}
} else if (in_http('cmd_sendmail')) {

	// remove all slashes
	$http = ct_deepunslash($http);
	
	// Now send mails and show protocol...
	mailer_header();
	echo "<H3>".ct('S_ADMIN_MAILER_PROTOCOL')."</H3>\n\n";

	$r = get_query();
	
	if ($r && $db->num_rows($r) && is_array($http['f']) && count($http['f'])>0) {
		echo "<div align=\"center\">\n";
		echo "<table width=\"100%\">\n";

		// List of receivers: Create header
		echo "<tr class=\"listheader\">\n";
		echo "<td align=right valign=top><span class=\"fontnormal font10\">".ct('S_USER_ID')."</span></td>\n";
		echo "<td align=left valign=top><span class=\"fontbold font10\">".ct('S_USER_FULLNAME')."</span></td>\n";
		echo "<td align=left valign=top><span class=\"fontbold font10\">".ct('S_USER_EMAIL')."</span></td>\n";
		echo "<td align=left valign=top><span class=\"fontbold font10\">".ct('S_ADMIN_EMAIL_SENT_STATUS')."</span></td>\n";
		echo "</tr>\n";

		$confirmationmail = ct('S_ADMIN_MAILER_PROTOCOL')."\n---------------------------------\n";
		$line = 0;
		for ($i = 0; $i < $db->num_rows($r); $i++) {

			$row = $db->fetch($r);

			if (in_array($row[ID],$http['f'])) {
			
				if ($line % 2) $class="oddrow";
				else 	       $class="evenrow";
				$line++;

				// send to participant?
				if (in_array('user',$http['form_emails']) ||
						(in_array('billing',$http['form_emails']) && $row['billingaddress']!='true') ) {
					$mail_content = replace_mail_patterns_participants('user',$http['form_mailbody'],$row);
					$addressee = stripslashes($row['firstname'].' '.$row['name']);
					$email = stripslashes($row['email']);
					if ($row['email2']!='') 
						$cc = array(stripslashes($row['email2']));
					else
						$cc = array();
						
					$status = ct_mail($email, $http['form_mailsubject'], $mail_content, $http['form_mailfrom'], $http['form_mailreplyto'], $cc);
					show_sendmail_row($class, $status, $row['ID'], $addressee, $email, $cc);
					
					$confirmationmail.= $row['ID'].": ".$addressee." <".$email.">\n ";
					if ($row['email2']!='')	$confirmationmail.= "cc: ".$addressee." <".$row['email2'].">\n ";
					if ($status!=0) 
						$confirmationmail.= "           ".ct('S_ADMIN_EMAIL_SENT_SUCCESS')."\n";
					else       
						$confirmationmail.= "---------->".ct('S_ADMIN_EMAIL_SENT_FAILED')."\n\n";
				}
				
				// send to billing addressee?
				if (in_array('billing',$http['form_emails'])) {
					if ($row['billingaddress']!='true') { 
						// billingaddress is same as user address: mail was already sent to user (see above).
					} else {	
						$mail_content = replace_mail_patterns_participants('billing',$http['form_mailbody'],$row);
						$addressee = stripslashes($row['billingfirstname'].' '.$row['billingname']);
						$email = stripslashes($row['billingemail']);

						$status = ct_mail($email, $http['form_mailsubject'], $mail_content, $http['form_mailfrom'], $http['form_mailreplyto']);
						show_sendmail_row($class, $status, $row['ID'], $addressee, $email);
						
						$confirmationmail.= $row['ID'].": ".$addressee." <".$email.">\n ";
						if ($status!=0) 
							$confirmationmail.= "           ".ct('S_ADMIN_EMAIL_SENT_SUCCESS')."\n";
						else       
							$confirmationmail.= "---------->".ct('S_ADMIN_EMAIL_SENT_FAILED')."\n\n";
					}
				}

				// send to credit card holder?
				if (in_array('cc',$http['form_emails']) && 
						($row['paymethod']=='cc' || $row['paymethod']=='ccexternal')) {
					$mail_content = replace_mail_patterns_participants('cc',$http['form_mailbody'],$row);
					$addressee = stripslashes($row['ccholder']);
					$email = stripslashes($row['ccemail']);

					$status = ct_mail($email, $http['form_mailsubject'], $mail_content, $http['form_mailfrom'], $http['form_mailreplyto']);
					show_sendmail_row($class, $status, $row['ID'], $addressee, $email);
					
					$confirmationmail.= $row['ID'].": ".$addressee." <".$email.">\n ";
					if ($status!=0) 
						$confirmationmail.= "           ".ct('S_ADMIN_EMAIL_SENT_SUCCESS')."\n";
					else       		
						$confirmationmail.= "---------->".ct('S_ADMIN_EMAIL_SENT_FAILED')."\n\n";
				}
				
	
				if (($line % 5) == 4) {
					ob_flush();	flush();
					sleep(1);  // wait a bit to allow the mail server sending the mails...
				}
			}
		}
		echo "</table></div>\n";

		$mail_content = replace_mail_patterns_persons($http['form_mailbody'], $user);
		$mail_content.="\n\n=================================\n\n".$confirmationmail."\n";

		// Now send protocol mails...
		if (in_http('form_sendprotocol_to_user') && $http['form_sendprotocol_to_user']==1)
			$s = ct_mail($user->get('email'),ct('S_ADMIN_MAILER_PROTOCOL').": ".$http['form_mailsubject'],$mail_content,$http['form_mailfrom'],$http['form_mailreplyto']);
		if (in_http('form_sendprotocol_to_from') && $http['form_sendprotocol_to_from']==1)
			$s = ct_mail($http['form_mailfrom'],ct('S_ADMIN_MAILER_PROTOCOL').": ".$http['form_mailsubject'],$mail_content,$http['form_mailfrom'],$http['form_mailreplyto']);
		if (in_http('form_sendprotocol_to_replyto') && $http['form_sendprotocol_to_replyto']==1)
			$s = ct_mail($http['form_mailreplyto'],ct('S_ADMIN_MAILER_PROTOCOL').": ".$http['form_mailsubject'],$mail_content,$http['form_mailfrom'],$http['form_mailreplyto']);

		echo "<h3>\n".ct('S_INFO_MAILER_SUCCESS')."</h3>";

	} else {
		echo "<p class=\"fontnegative fontbold font10\">".ct('S_ADMIN_MAILER_NOMAILS')."</p>";
	}

	//  $session->put_infobox(ct('S_INFO_MAILER'), ct('S_INFO_MAILER_SUCCESS'));
	//  ct_redirect(ct_pageurl('index'));
} else if (in_http('cmd_preview') && in_http('form_personID') && in_http('form_type')) {
	// remove all slashes
	$http = ct_deepunslash($http);

	$id = (int)$http['form_personID'];
	$r = get_query($id);
	if ($r && ($db->num_rows($r) == 1)) {
		$row = $db->fetch($r);

		// Write Mail Info
		echo '<table align="center" width="640" class="form_table" cellspacing=0 cellpadding=2 border=1>';

		echo '<tr><td colspan="3" valign=top align=left class="form_td_separator_gradient">';
		echo "<span class=\"form_separator_label\">".ct('S_ADMIN_MAILER_MAIL_HEAD')."</span></td></tr>\n";

		echo '<tr><td width="25%" valign=top align=right class="form_td_label topline_white">';
		echo '<span class="form_label">'.ct('S_ADMIN_MAILER_TO').'</span></td>';
		################ Receiver of this mail...
		if ($http['form_type']=='billing')
			echo "<td width=\"75%\" align=left valign=top class=\"topline_white form_td_field\">".$row['billingemail']."</td>\n";
		elseif ($http['form_type']=='cc')
			echo "<td width=\"75%\" align=left valign=top class=\"topline_white form_td_field\">".$row['ccemail']."</td>\n";
		else {
			echo "<td width=\"75%\" align=left valign=top class=\"topline_white form_td_field\">".$row['email'];
			if ($row['email2']!='')
				echo "<br>".$row['email2'];
			echo "</td>\n";
		}
		echo "</tr>\n";
		
		echo '<tr><td width="25%" valign=top align=right class="form_td_label topline_white">';
		echo '<span class="form_label">'.ct('S_ADMIN_MAILER_FROM').'</span></td>';
		echo "<td width=\"75%\" align=left valign=top class=\"topline_white form_td_field\">".ct_form_encode($http['form_mailfrom'])."</td></tr>\n";

		if (!$http['form_mailreplyto']=="") {
			echo '<tr><td width="25%" valign=top align=right class="form_td_label topline_white">';
			echo '<span class="form_label">'.ct('S_ADMIN_MAILER_REPLYTO').'</span></td>';
			echo "<td width=\"75%\" align=left valign=top class=\"topline_white form_td_field\">".ct_form_encode($http['form_mailreplyto'])."</td></tr>\n";
		}

		echo '<tr><td width="25%" valign=top align=right class="form_td_label topline_white">';
		echo '<span class="form_label">'.ct('S_ADMIN_MAILER_SUBJECT').'</span></td>';
		echo "<td width=\"75%\" align=left valign=top class=\"topline_white form_td_field\">".ct_form_encode($http['form_mailsubject'])."</td></tr>\n";

		##################
		$mail_content = replace_mail_patterns_participants($http['form_type'],$http['form_mailbody'],$row);
		$mail_content = wrap_text($mail_content);

		echo '<tr><td valign=top align=left colspan=2 class="listheader">';
		echo '<span class="fontbold font10">'.ct('S_ADMIN_MAILER_BODY').'</span></td></tr>';
		echo "<tr><td align=left valign=top colspan=2 class=\"whitebg\"><span class=\"fontmonospaced font9\">".nl2br($mail_content)."\n</span><br></td></tr>\n";
		echo "</table><BR>\n";

		echo "</table><BR>\n";

	}
} else {
	mailer_header();
	show_form($form_errors);
}

// Mailer functions
// ----------------
function show_form($form_errors){
	GLOBAL $http,$session;
	$user=$session->get_user();

	$groups=array_merge (array(array('0',ct('S_ADMIN_TOOL_ALLPARTICIPANTS'))), ct_list_groups());
	$events=array_merge (array(array('0',ct('S_ADMIN_TOOL_ALLPARTICIPANTS'))), ct_list_events(true));
	$eventtypes=array_merge (array(array('0',ct('S_ADMIN_TOOL_ALLPARTICIPANTS'))), ct_list_eventtypes());
	$discounts=array_merge (array(array('0',ct('S_ADMIN_TOOL_ALLPARTICIPANTS'))), ct_list_timediscounts());
	$paymethods=array_merge(array(array('0',ct('S_ADMIN_TOOL_ALLPARTICIPANTS'))), ct_list_paymethods());
	
	// remove all "magic" slashes.
	if ($http['form_mailfrom']=="")    $http['form_mailfrom'] = ctconf_get('conferenceSenderEmail');
	if ($http['form_mailreplyto']=="") $http['form_mailreplyto'] = ctconf_get('conferenceReplytoEmail');
	if ($http['form_mailsubject']=="") $http['form_mailsubject'] = ctconf_get('conferenceShortName').": ";

	if ($http['form_mailbody']=="") {
		$mail_content = br2nl(ct('S_ADMIN_MAILER_PARTICIPANTS_EXAMPLETEXT', array(strip_tags(ctconf_get('conferenceName')),strip_tags(ctconf_get('conferenceShortName')))));
		$mail_content.= "\n\n-- \n";
		$mail_content.=strip_tags(ctconf_get('conferenceName'))."\n";
		$mail_content.=ct_get_loginurl();
	} else {
		$mail_content = $http['form_mailbody'];
	}

	echo "<p class=\"fontnormal font10\">".ct('S_ADMIN_MAILER_PARTICIPANTS_INTRO')."</p>\n";

	$form = new CTform(ct_pageurl('adminMailerParticipants'), 'post',$form_errors);
	$form->width='100%';
	$form->align='center';
	$form->add_separator(ct('S_ADMIN_MAILER_PARTICIPANTS_SELECT_HEAD'));

	if (count($groups)>2)
		$form->add_select(ct('S_PARTICIPATION_FORM_GROUPS'), 'form_group', 1, $groups, array($http['form_group']));
	if (count($discounts)>2)
		$form->add_select(ct('S_PARTICIPATION_FORM_DISCOUNTS'), 'form_discounts', 1, $discounts, array($http['form_discounts']));
	
	if (count($paymethods)>2)
		$form->add_select(ct('S_ADMIN_TOOL_PAYMENT_CMD'), 'form_payment', 1, $paymethods, array($http['form_payment']), false);

	$form->add_select(ct('S_ADMIN_PARTICIPANTS_PAYMENT'), 'form_notpaid', 1,
		list_payment_status(),
		array($http['form_notpaid']), false);
		
	$form->add_spacer();
		
	if (count($events)>2) {
		$size=3;
		if (count($events)>4) $size=7;
		if (is_array($http['form_event'])) $selected=$http['form_event'];
		else $selected=array('0');
		$form->add_select(ct('S_ADMIN_TOOL_EVENTS_CMD'), 'form_event[]', $size, $events, $selected, true);
	}
	if (count($eventtypes)>2) 
		$form->add_select(ct('S_ADMIN_TOOL_EVENTTYPES_CMD'), 'form_eventtype', 1, $eventtypes, array($http['form_eventtype']));
	
	$form->add_spacer();

	if (!in_http('form_emails') || !is_array($http['form_emails'])) $http['form_emails'] = array('user');
	$form->add_check(ct('S_ADMIN_MAILER_PARTICIPANTS_RECEIVERS'), array(
				 array( 'form_emails[]', 'user', get_email_receiver('user'), in_array('user',$http['form_emails']), false),
				 array( 'form_emails[]', 'billing',  get_email_receiver('billing'),  in_array('billing',$http['form_emails']), false),
				 array( 'form_emails[]', 'cc',  get_email_receiver('cc'), in_array('cc',$http['form_emails']), false)));
	
	$form->add_separator(ct('S_ADMIN_MAILER_MESSAGE_HEAD'));
	$form->add_text(ct('S_ADMIN_MAILER_FROM'),'form_mailfrom',$http['form_mailfrom'], 50, 100);
	$form->add_text(ct('S_ADMIN_MAILER_REPLYTO'),'form_mailreplyto',$http['form_mailreplyto'], 50, 100);
	$form->add_text(ct('S_ADMIN_MAILER_SUBJECT'),'form_mailsubject',$http['form_mailsubject'], 50, 200);
	$subject_hint = ct('S_ADMIN_MAILER_PARTICIPANTS_BODY_HINT');
	$subject_hint .='<br>'.ct('S_ADMIN_MAILER_PARTICIPANTS_BODY_HINT2');
	if (ct_get_invoicelink(1))
		$subject_hint .='<br>'.ct('S_ADMIN_MAILER_PARTICIPANTS_BODY_HINT3');
	// hightlight codes.
	$pattern = "/({\w*})/i";
	$format  = "<code><b>\$1</b></code>";
	$subject_hint = preg_replace($pattern, $format, $subject_hint); 
	$form->add_textarea(ct('S_ADMIN_MAILER_BODY'),'form_mailbody',$mail_content, 78,10,'',$subject_hint,0,'class="fontmonospaced font9"');
	$form->add_submit('cmd_checkmail', ct('S_ADMIN_MAILER_PREVIEW_SUBMIT'));
	$form->show();
}

function mailer_header(){
	echo "<h1>".ct('S_ADMIN_MAILER_PARTICIPANTS')."</h1>\n";
}

function list_payment_status(){
	$mail_status=array();
	$mail_status[]=array('-',ct('S_ADMIN_TOOL_ALLPARTICIPANTS'));
	$mail_status[]=array('0',ct('S_ADMIN_PARTICIPANTS_PAYMENT_OPEN'));
	$mail_status[]=array('7',ct('S_ADMIN_PARTICIPANTS_PAYMENT_OPENFOR',array('7',ct_date_format(ct_time()-7*24*60*60))));
	$mail_status[]=array('14',ct('S_ADMIN_PARTICIPANTS_PAYMENT_OPENFOR',array('14',ct_date_format(ct_time()-14*24*60*60))));
	$mail_status[]=array('21',ct('S_ADMIN_PARTICIPANTS_PAYMENT_OPENFOR',array('21',ct_date_format(ct_time()-21*24*60*60))));
	$mail_status[]=array('30',ct('S_ADMIN_PARTICIPANTS_PAYMENT_OPENFOR',array('30',ct_date_format(ct_time()-30*24*60*60))));
	$mail_status[]=array('60',ct('S_ADMIN_PARTICIPANTS_PAYMENT_OPENFOR',array('60',ct_date_format(ct_time()-60*24*60*60))));
	return $mail_status;
}


function get_email_receiver($code=0){
	$mail_rec=array();
	$mail_rec['user']=ct('S_ADMIN_MAILER_PARTICIPANTS_RECEIVERS_USER');
	$mail_rec['billing']=ct('S_ADMIN_MAILER_PARTICIPANTS_RECEIVERS_BILLING');
	$mail_rec['cc']=ct('S_ADMIN_MAILER_PARTICIPANTS_RECEIVERS_CC');
	if ($code) 
		return $mail_rec[$code];
	else
		return $mail_rec;
}


function get_query($id=''){
	GLOBAL $http, $db;

	$query ="SELECT p.ID, p.username, p.name, p.firstname, p.title, p.email, p.email2, p.organisation, p.country, p.password, p.passwordencrypted, ";
	$query.="participants.billingaddress, participants.email as billingemail, participants.name as billingname, participants.firstname as billingfirstname, participants.organisation as billingorganisation, participants.country as billingcountry, ";
	$query.="participants.paymethod, participants.ccemail, participants.ccholder, participants.cccountry, ";
	$query.="participants.total, participants.payamount, participants.regdate ";
	$query.=" FROM participants, persons as p";
	
	// required tables
	if ((in_http('form_event') && is_array($http['form_event']) && !in_array('0',$http['form_event'])) ||
			(isset($http['form_eventtype']) && $http['form_eventtype']>0) ){
		$query.=", participants2events";
	}
	if (isset($http['form_discounts']) && $http['form_discounts']>0){
		$query.=", timediscounts";
	}
	
	// where condition.
	$where=" WHERE participants.deleted=0 AND participants.personID=p.ID AND participants.regdate != '0000-00-00 00:00:00' ";
	
	if ((in_http('form_event') && is_array($http['form_event']) && !in_array('0',$http['form_event'])) ||
			(isset($http['form_eventtype']) && $http['form_eventtype']>0) ){
		$where.=" AND participants.personID=participants2events.personID AND participants2events.number>0";
	}
	if (in_http('form_event') && is_array($http['form_event']) && !in_array('0',$http['form_event'])) {
		$where.=" AND (1";
		foreach ($http['form_event'] as $e) {
			$where.=" or participants2events.eventID='".$e."'";
		}
		$where .=") ";
	}
	if (isset($http['form_eventtype']) && $http['form_eventtype']>0){
		$e = ct_get_events($http['form_eventtype']);
		if (count($e)>0) { // events found?	
			$eIDs = array();
			for ($i=0; $i < count($e); $i++) {
				$eIDs[] = $e[$i]['ID'];
			}
			$where.=" AND participants2events.eventID IN (".ct_csv_implode($eIDs).")";
		}
	}
	if (isset($http['form_discounts']) && $http['form_discounts']>0){
		$where.=" AND timediscounts.ID=".$http['form_discounts']." AND";
		$where.=" participants.regdate>=timediscounts.effectivefrom AND participants.regdate<=timediscounts.effectiveuntil ";
	}
	if (isset($http['form_group']) && $http['form_group']!=0){
		$where.=" AND participants.status=".$http['form_group'];
	}
	if (isset($http['form_payment']) && $http['form_payment']){
		$where.=" AND participants.paymethod=\"".$http['form_payment']."\"";
	}
	if (isset($http['form_notpaid']) && $http['form_notpaid']!="-"){
		$where.=" AND participants.regdate<\"".ct_timestamp_2_datetime(ct_time()-($http['form_notpaid']*60*60*24))."\" AND total!=payamount AND total>0";
	}
	
	$id = (int)$id;
	if ($id>0) {
		$where.=" AND participants.personID='$id'";
	}

	$order = ' ORDER BY p.ID';
	
	$query="$query $where GROUP BY p.ID $order";
	
	###echo $query;
	
	return $db->query($query);
}

function show_mailer_status($needle,$mail_status) {
	reset ($mail_status);
	while (list ($key, $val) = each ($mail_status)) {
		if ($val[0]==$needle)
	   		return $val[1];
	}
  	return "---";
}


// show	basic user information in one row
function show_preview_row($class,$showcheckbox=false,$id,$type,$typetext,$info,$email='',$organisation='',$country='') {
	echo "<tr class=\"$class\">\n";
	if ($showcheckbox) {
		echo "<td align=right valign=top><span class=\"fontnormal font8\"><input type=\"checkbox\" class=\"checkboxradio\" name=\"f[]\" value=\"".$id."\" checked></span></td>\n";
		echo "<td align=right valign=top><span class=\"fontnormal font8\">".$id."</span></td>\n";
	} else {
		echo "<td align=right valign=top><span class=\"fontnormal font8\">&nbsp;</span></td>\n";
		echo "<td align=right valign=top><span class=\"fontnormal font8\">&nbsp;</span></td>\n";
	} 
	echo "<td align=left valign=top><span class=\"fontnormal font8\">".$typetext."</td>\n";
	if (is_array($email) || $email!="") {
		echo "<td align=left valign=top>";
		echo "<span class=\"fontbold font8\">".$info."</span>";
		echo "</td>\n";

		echo "<td align=left valign=top>";
		echo "<span class=\"fontnormal font8\">";
		if (is_array($email)) {
			foreach ($email as $e)
				if ($e!="") echo "<a href=\"mailto:".$e."\">".$e."</a><br>";
		} else
			echo "<a href=\"mailto:".$email."\">".$email."</a>\n";
		echo "</span>";
		echo "</td>\n";
		echo "<td align=left valign=top colspan=1>";
		ct_load_lib("address.lib");
		echo "<span	class=\"fontnormal font8\">".$country."</span>";
		echo "</td>\n";
		echo "<td align=left valign=top><span class=\"fontbold font8\"><a target=\"blank\" href=\"".ct_pageurl('adminMailerParticipants',ct_http_array(array('cmd_preview'=>'1','form_personID'=>$id,'form_type'=>$type,'print'=>'yes')))."\"><img src=\"icons/newwindow.gif\" border=0></a></span></td>\n";
	} else {
		echo "<td align=left valign=top colspan=4><span class=\"fontnormal font8\">".$info."</td>\n";
	}		

	echo "</tr>\n";
}

// Show outcome of mail effort.
function show_sendmail_row($class, $status, $id, $name, $email, $cc=array()) {
	if ($status)
		echo "<tr class='$class'>\n";
	else
		echo "<tr class='".$class."_del'>\n";
	echo "<td align=right valign=top> <span class=\"fontbold font9\">".$id."</span></td>\n";
	echo "<td align=left valign=top> <span class=\"fontnormal font9\">".$name."</span> </td>\n";
	echo "<td align=left valign=top>";
	echo "<span class=\"fontbold font9\"><a href=\"mailto:".$email."\">".$email."</a>\n</span>";
	foreach ($cc as $c)
		if ($c!='') echo "<br><span class=\"fontnormal font9\">cc: <a href=\"mailto:".$c."\">".$c."</a>\n</span>\n";
	echo "</td>\n";
	if ($status!=0) echo "<td align=right valign=top><span class=\"fontnormal font9\">".ct('S_ADMIN_EMAIL_SENT_SUCCESS')."</span></td>\n";
	else    echo "<td align=right valign=top><span class=\"fontnormal font9\">".ct('S_ADMIN_EMAIL_SENT_FAILED')."</span></td>\n";
	echo "</tr>\n";
}

?>