<?php
//
// PAGE:        adminMailerPersons
// DESC:        send bulk mails to user groups.
//

ct_requireassistantorconferencechair();
ct_pagepath(array('index','adminMailer'));
ct_load_lib('participation.lib');
ct_load_lib('mail.lib');
ct_load_lib('mail_bulk.lib');
ct_load_lib('papers.lib');
ct_load_lib('datetime.lib');
ct_load_class('CTForm');

$person = new CTPerson();

if( !ini_get('safe_mode') ){
	// Does _not_ work in SAFE MODE
	set_time_limit(1800);
}
ob_end_flush();

$form_errors=array();

//if (in_http('cmd_sendmail','cmdcheckmail') && in_http('form_reviewer')) {
//  echo "Check mail gedrckt!";
//}

if (in_http('cmd_checkmail')) {
	// Check the selected settings before sending the mails...
	if (ct_validate_email($http['form_mailfrom'])===false) $form_errors[]="form_mailfrom";
	if ($http['form_mailreplyto']!="" && ct_validate_email($http['form_mailreplyto'])===false) $form_errors[]="form_mailreplyto";
	if ($http['form_mailsubject']=="") $form_errors[]="form_mailsubject";
	if ($http['form_mailbody']=="") $form_errors[]="form_mailbody";
	if ($http['form_mailselect']=="") $form_errors[]="form_mailselect";
	if ( count($form_errors)!=0 ) {
		ct_errorbox(ct('S_ERROR_MAILER'), ct('S_ERROR_MAILER_INCOMPLETE'));
		mailer_header();
		show_form($form_errors);
	} else {
		// Show confirmation page before sending mails...
		mailer_header();
		echo "<p class=\"fontbold font10\">".ct('S_ADMIN_MAILER_SENDNOW')."</p>\n";
		echo "<p class=\"fontnegative fontbold font10\">".ct('S_ADMIN_MAILER_HINTS')."</p>\n";

		echo "<form action=\"".ct_pageurl('adminMailerPersons')."\" method=\"post\">\n";
		echo "<input type=\"hidden\" name=\"form_mailselect\" value=\"".ct_form_encode($http['form_mailselect'])."\">\n";
		echo "<input type=\"hidden\" name=\"form_mailfrom\" value=\"".ct_form_encode($http['form_mailfrom'])."\">\n";
		echo "<input type=\"hidden\" name=\"form_mailreplyto\" value=\"".ct_form_encode($http['form_mailreplyto'])."\">\n";
		echo "<input type=\"hidden\" name=\"form_mailsubject\" value=\"".ct_form_encode($http['form_mailsubject'])."\">\n";
		echo "<input type=\"hidden\" name=\"form_mailbody\" value=\"".ct_form_encode($http['form_mailbody'])."\">\n";

		// Write Mail Info
		echo '<table align="center" width="90%" class="form_table" cellspacing=1 cellpadding=2 border=0>';

		echo '<tr><td colspan="3" valign=top align=left class="form_td_separator_gradient">';
		echo "<span class=\"form_separator_label\">".ct('S_ADMIN_MAILER_MAIL_HEAD')."</span></td></tr>\n";

		echo '<tr><td width="25%" valign=top align=right class="form_td_label topline_white">';
		echo '<span class="form_label">'.ct('S_USER_STATUS_ONLY').'</span></td>';
		echo "<td width=\"75%\" align=left valign=top class=\"topline_white form_td_field\">". show_mailer_status($http['form_mailselect'],list_receivers())."</td></tr>\n";

		echo '<tr><td width="25%" valign=top align=right class="form_td_label topline_white">';
		echo '<span class="form_label">'.ct('S_ADMIN_MAILER_FROM').'</span></td>';
		echo "<td width=\"75%\" align=left valign=top class=\"topline_white form_td_field\">".ct_form_encode($http['form_mailfrom'])."</td></tr>\n";

		if (!$http['form_mailreplyto']=="") {
			echo '<tr><td width="25%" valign=top align=right class="form_td_label topline_white">';
			echo '<span class="form_label">'.ct('S_ADMIN_MAILER_REPLYTO').'</span></td>';
			echo "<td width=\"75%\" align=left valign=top class=\"topline_white form_td_field\">".ct_form_encode($http['form_mailreplyto'])."</td></tr>\n";
		}

		echo '<tr><td width="25%" valign=top align=right class="form_td_label topline_white">';
		echo '<span class="form_label">'.ct('S_ADMIN_MAILER_SUBJECT').'</span></td>';
		echo "<td width=\"75%\" align=left valign=top class=\"topline_white form_td_field\">".ct_form_encode($http['form_mailsubject'])."</td></tr>\n";

		echo '<tr><td valign=top align=left colspan=2 class="listheader">';
		echo '<span class="fontbold font10">'.ct('S_ADMIN_MAILER_BODY').'</span></td></tr>';
		$pattern = "/({\w*})/i";
		$format  = "<i><b>\$1</b></i>";
		$body = preg_replace($pattern, $format, ct_form_encode($http['form_mailbody'])); // underline presenting author

		echo "<tr><td align=left valign=top colspan=2 class=\"whitebg\"><span class=\"fontmonospaced font9\">".nl2br($body)."\n</span><br></td></tr>\n";
		echo "</table><BR>\n";

		$r = get_query();

		// JavaScript to Check/Uncheck all checkboxes.
		ct_load_lib("javascript.lib");
		$function_name = "checkAll";
		$checkbox_name = "f[]"; // also set in subroutine!!
		echo get_js_checkbox_selector($function_name,$checkbox_name);
		
		// List of receivers: Create header
		echo "<div align=\"center\">\n";
		echo "<table width=\"100%\">\n";

		// Submit / Back
		echo "<tr><td colspan=7 align=right class=\"mediumbg\">";
		echo "<input type=submit name=\"cmd_back\" class=\"button\" value=\"".ct('S_BUTTON_BACK')."\">";
		echo "&nbsp;";
        if (ctconf_get('demomode')) {
			echo "<input disabled style=\"color: #000\"; type=\"submit\" name=\"cancel\" value=\"".ct('S_ADMIN_MAILER_SEND_SUBMIT')." ".ct('S_BUTTON_DEMO')."\">\n";
        } else {
   			echo "<input type=submit name=\"cmd_sendmail\" class=\"button\" value=\"".ct('S_ADMIN_MAILER_SEND_SUBMIT')."\">";
        }
		echo "</td></tr>\n";

		// Main header
		echo '<tr><td colspan="7" valign=top align=left class="form_td_separator_gradient">';
		echo "<span class=form_separator_label>".ct('S_ADMIN_MAILER_RECEIVER_HEAD').": ".ct('S_ADMIN_USERS_BROWSE_SUM1')." ".$db->num_rows($r)." ".ct('S_ADMIN_USERS_BROWSE_SUM2')."</span></td></tr>\n";

		// Column header
		echo "<tr class=\"listheader\">\n";
		echo "<td align=right valign=top><span class=\"fontnormal font10\"><input type=\"checkbox\" class=\"checkboxradio\" checked onclick=\"$function_name(this);\"></span></td>\n";
		echo "<td align=right valign=top><span class=\"fontnormal font8\">".ct('S_USER_ID')."</span></td>\n";
		echo "<td align=left valign=top><span class=\"fontbold font8\">".ct('S_USER_FULLNAME')."</span>";
		echo "<td align=left valign=top><span class=\"fontbold font8\">".ct('S_USER_EMAIL')."</span>";
		echo "<td align=left valign=top><span class=\"fontbold font8\">".ct('S_USER_ORGANISATION')."</span>";
		echo "<td align=left valign=top><span class=\"fontbold font8\">".ct('S_USER_COUNTRY')."</span>";
		echo "<td align=left valign=top width=\"1%\"><span class=\"fontbold font8\">".ct('S_ADMIN_MAILER_PREVIEW')."</span>";
		echo "</tr>\n";

		if ($r && ($db->num_rows($r) > 0)) {

			for ($i = 0; $i < $db->num_rows($r); $i++) {
				$t = $db->fetch($r);
				if ($i % 2) {
					show_simple_row("oddrow",$t);
				} else {
					show_simple_row("evenrow",$t);
				}
			}
			echo "</table>\n\n";

			echo "<table width=\"98%\">\n";

			// Send protocol to...
			echo '<tr><td colspan="6" valign=top align=left class="form_td_separator_gradient">';
			echo '<span class=form_separator_label>'.ct('S_ADMIN_MAILER_SEND_PROTOCOL').": </span></td></tr>\n";

			echo "<tr class=\"evenrow\">\n";
			echo "<td align=right valign=top><span class=\"fontnormal font10\"><input type=\"checkbox\" class=\"checkboxradio\" name=\"form_sendprotocol_to_user\" value=\"1\" checked></span></td>\n";
			echo "<td colspan=2 align=left valign=top><span class=\"fontbold font10\">";
			echo $user->get_special('name').", ".$user->get_special('firstname')."</span>";
			echo "</td>\n";
			echo "<td colspan=3 align=left valign=top>";
			echo "<span	class=\"fontnormal font10\">&nbsp;<a href=\"mailto:".$user->get_special('email')."\">";
			echo $user->get_special('email')."</a>\n";
			echo "</span>";
			echo "</td>\n";
			echo "</tr>\n";

			if ($user->get('email')!=$http['form_mailfrom']) {
				echo '<tr  class="evenrow">';
				echo "<td align=right valign=top><span class=\"fontnormal font10\"><input type=\"checkbox\" class=\"checkboxradio\" name=\"form_sendprotocol_to_from\" value=\"1\" checked></span></td>\n";
				echo "<td colspan=2 align=left valign=top><span class=\"fontbold font10\">".ct('S_ADMIN_MAILER_FROM')."</span></td>\n";
				echo '<td colspan="3" valign=top align=left>';
				echo "<span	class=\"fontnormal font10\">&nbsp;<a href=\"mailto:".$http['form_mailfrom']."\">".$http['form_mailfrom']."</a></span>";
				echo "</td></tr>\n";
			}

			if (!$http['form_mailreplyto']=="" && $http['form_mailreplyto']!=$http['form_mailfrom']) {
				echo '<tr  class="oddrow">';
				echo "<td align=right valign=top><span class=\"fontnormal font10\"><input type=\"checkbox\" class=\"checkboxradio\" name=\"form_sendprotocol_to_replyto\" value=\"1\" checked></span></td>\n";
				echo "<td colspan=2 align=left valign=top><span class=\"fontbold font10\">".ct('S_ADMIN_MAILER_REPLYTO')."</span></td>\n";
				echo '<td colspan="3" valign=top align=left>';
				echo "<span	class=\"fontnormal font10\">&nbsp;<a href=\"mailto:".$http['form_mailreplyto']."\">".$http['form_mailreplyto']."</a></span>";
				echo "</td></tr>\n";
			}

			// Submit button...
			echo "<tr><td colspan=3 align=left class=\"mediumbg\">".ct('S_ADMIN_USERS_BROWSE_SUM1')." $i ".ct('S_ADMIN_USERS_BROWSE_SUM2')."</td><td colspan=3 align=right class=\"mediumbg\">";
   			echo "<input type=submit name=\"cmd_back\" class=\"button\" value=\"".ct('S_BUTTON_BACK')."\">";
			echo "&nbsp;";
            if (ctconf_get('demomode')) {
				echo "<input disabled style=\"color: #000\"; type=\"submit\" name=\"cancel\" value=\"".ct('S_ADMIN_MAILER_SEND_SUBMIT')." ".ct('S_BUTTON_DEMO')."\">\n";
            } else {
    			echo "<input type=submit name=\"cmd_sendmail\" class=\"button\" value=\"".ct('S_ADMIN_MAILER_SEND_SUBMIT')."\">";
            }
			echo "</td></tr>\n";

		}
		echo "</table>\n</div>\n</form>\n";
	}
} else if (in_http('cmd_sendmail')) {

	// remove all slashes
	$http = ct_deepunslash($http);
	// Now send mails and show protocol...
	mailer_header();
	echo "<H3>".ct('S_ADMIN_MAILER_PROTOCOL')."</H3>\n\n";

	if (in_http('cmd_sendmail') && is_array($http['f'])) {
		echo "<div align=\"center\">\n";
		echo "<table width=\"90%\">\n";

		// List of receivers: Create header
		echo "<tr class=\"listheader\">\n";
		echo "<td align=right valign=top><span class=\"fontnormal font10\">".ct('S_USER_ID')."</span></td>\n";
		echo "<td align=left valign=top><span class=\"fontbold font10\">".ct('S_USER_FULLNAME')."</span></td>\n";
		echo "<td align=left valign=top><span class=\"fontbold font10\">".ct('S_USER_EMAIL')."</span></td>\n";
		echo "<td align=left valign=top><span class=\"fontbold font10\">".ct('S_ADMIN_EMAIL_SENT_STATUS')."</span></td>\n";
		echo "</tr>\n";

		$i=0;
		$confirmationmail = ct('S_ADMIN_MAILER_PROTOCOL')."\n---------------------------------\n";
 		foreach($http['f'] as $personID) {
 			$i++;
			$person->load_by_id($personID);

			$mail_content = replace_mail_patterns_persons($http['form_mailbody'],$person);

			$s = ct_mail($person->get('email'),$http['form_mailsubject'],$mail_content,$http['form_mailfrom'],$http['form_mailreplyto']);
			echo "<tr class=\"";
			if ($i % 2) {
				echo "oddrow";
			} else {
				echo "evenrow";
			}
			if ($s==0) echo "_del";
			echo "\">\n";
			echo "<td align=right valign=top> <span class=\"fontbold font10\">".$person->get('ID')."</span></td>\n";
			echo "<td align=left valign=top> <span class=\"fontnormal font10\">".$person->get_special('name').", ".$person->get_special('firstname')."</span> </td>\n";
			echo "<td align=left valign=top><span class=\"fontbold font10\"><a href=\"mailto:".$person->get_special('email')."\">".$person->get_special('email')."</a>\n</span></td>\n";
			if ($s!=0) echo "<td align=right valign=top><span class=\"fontnormal font10\">".ct('S_ADMIN_EMAIL_SENT_SUCCESS')."</span></td>\n";
			else    echo "<td align=right valign=top><span class=\"fontnormal font10\">".ct('S_ADMIN_EMAIL_SENT_FAILED')."</span></td>\n";
			echo "</tr>\n";

			$confirmationmail.= stripslashes($person->get('ID').": ".$person->get('name'))." <".$person->get('email').">\n ";
			if ($s!=0) $confirmationmail.= "           ".ct('S_ADMIN_EMAIL_SENT_SUCCESS')."\n";
			else       $confirmationmail.= "---------->".ct('S_ADMIN_EMAIL_SENT_FAILED')."\n\n";

			if (($i % 5) == 4) {
				ob_flush();	flush();
				sleep(1);  // wait a bit to allow the mail server sending the mails...
			}
			//echo ($person->get('email')."<BR>".$http['form_mailsubject']."<BR>".$http['form_mailbody']."<BR>".$http['form_mailfrom']."<BR>".$http['form_mailreplyto'])."<P>";
		}
		echo "</table></div>\n";

		$mail_content = replace_mail_patterns_persons($http['form_mailbody'], $user);
		$mail_content.="\n\n=================================\n\n".$confirmationmail."\n";

		// Now send protocol mails...
		if (in_http('form_sendprotocol_to_user') && $http['form_sendprotocol_to_user']==1)
			$s = ct_mail($user->get('email'),ct('S_ADMIN_MAILER_PROTOCOL').": ".$http['form_mailsubject'],$mail_content,$http['form_mailfrom'],$http['form_mailreplyto']);
		if (in_http('form_sendprotocol_to_from') && $http['form_sendprotocol_to_from']==1)
			$s = ct_mail($http['form_mailfrom'],ct('S_ADMIN_MAILER_PROTOCOL').": ".$http['form_mailsubject'],$mail_content,$http['form_mailfrom'],$http['form_mailreplyto']);
		if (in_http('form_sendprotocol_to_replyto') && $http['form_sendprotocol_to_replyto']==1)
			$s = ct_mail($http['form_mailreplyto'],ct('S_ADMIN_MAILER_PROTOCOL').": ".$http['form_mailsubject'],$mail_content,$http['form_mailfrom'],$http['form_mailreplyto']);

		echo "<h3>\n".ct('S_INFO_MAILER_SUCCESS')."</h3>";

	} else {
		echo "<p class=\"fontnegative fontbold font10\">".ct('S_ADMIN_MAILER_NOMAILS')."</p>";
	}

	//  $session->put_infobox(ct('S_INFO_MAILER'), ct('S_INFO_MAILER_SUCCESS'));
	//  ct_redirect(ct_pageurl('index'));
} else if (in_http('cmd_preview') && in_http('form_personID')) {
	// remove all slashes
	$http = ct_deepunslash($http);

	if ($person->load_by_id($http['form_personID'])) {

		// Write Mail Info
		echo '<table align="center" width="640" class="form_table" cellspacing=0 cellpadding=2 border=1>';

		echo '<tr><td colspan="3" valign=top align=left class="form_td_separator_gradient">';
		echo "<span class=\"form_separator_label\">".ct('S_ADMIN_MAILER_MAIL_HEAD')."</span></td></tr>\n";

		echo '<tr><td width="25%" valign=top align=right class="form_td_label topline_white">';
		echo '<span class="form_label">'.ct('S_ADMIN_MAILER_TO').'</span></td>';
		echo "<td width=\"75%\" align=left valign=top class=\"topline_white form_td_field\">".$person->get('email')."</td></tr>\n";

		echo '<tr><td width="25%" valign=top align=right class="form_td_label topline_white">';
		echo '<span class="form_label">'.ct('S_ADMIN_MAILER_FROM').'</span></td>';
		echo "<td width=\"75%\" align=left valign=top class=\"topline_white form_td_field\">".ct_form_encode($http['form_mailfrom'])."</td></tr>\n";

		if (!$http['form_mailreplyto']=="") {
			echo '<tr><td width="25%" valign=top align=right class="form_td_label topline_white">';
			echo '<span class="form_label">'.ct('S_ADMIN_MAILER_REPLYTO').'</span></td>';
			echo "<td width=\"75%\" align=left valign=top class=\"topline_white form_td_field\">".ct_form_encode($http['form_mailreplyto'])."</td></tr>\n";
		}

		echo '<tr><td width="25%" valign=top align=right class="form_td_label topline_white">';
		echo '<span class="form_label">'.ct('S_ADMIN_MAILER_SUBJECT').'</span></td>';
		echo "<td width=\"75%\" align=left valign=top class=\"topline_white form_td_field\">".ct_form_encode($http['form_mailsubject'])."</td></tr>\n";

		$mail_content = replace_mail_patterns_persons($http['form_mailbody'],$person);
		$mail_content = wrap_text($mail_content);

		echo '<tr><td valign=top align=left colspan=2 class="listheader">';
		echo '<span class="fontbold font10">'.ct('S_ADMIN_MAILER_BODY').'</span></td></tr>';
		echo "<tr><td align=left valign=top colspan=2 class=\"whitebg\"><span class=\"fontmonospaced font9\">".nl2br($mail_content)."\n</span><br></td></tr>\n";
		echo "</table><BR>\n";

		echo "</table><BR>\n";

	}
} else {
	mailer_header();
	show_form($form_errors);
}

// Mailer functions
// ----------------
function show_form($form_errors){
	GLOBAL $http,$session;
	$user=$session->get_user();

	// remove all "magic" slashes.
	if ($http['form_mailfrom']=="") $http['form_mailfrom'] = ctconf_get('conferenceSenderEmail');
	if ($http['form_mailreplyto']=="") $http['form_mailreplyto'] = ctconf_get('conferenceReplytoEmail');
	if ($http['form_mailsubject']=="") $http['form_mailsubject'] = ctconf_get('conferenceShortName').": ";

	if ($http['form_mailbody']=="") {
		$mail_content = "{dear_fullname}, \n\n";
		$mail_content.= "\n\n-- \n";
		$mail_content.=strip_tags(ctconf_get('conferenceName'))."\n";
		$mail_content.=ct_get_loginurl();
	} else {
		$mail_content = $http['form_mailbody'];
	}

	echo "<p class=\"fontnormal font10\">".ct('S_ADMIN_MAILER_PERSONS_INTRO')."</p>\n";

	$form = new CTform(ct_pageurl('adminMailerPersons'), 'post',$form_errors);
	$form->width='100%';
	$form->align='center';
	$form->add_separator(ct('S_ADMIN_MAILER_SELECT_HEAD'));
	$form->add_select(ct('S_USER_STATUS_ONLY'), 'form_mailselect', 1, list_receivers(), array($http['form_mailselect']), false);
	$form->add_separator(ct('S_ADMIN_MAILER_MESSAGE_HEAD'));
	$form->add_text(ct('S_ADMIN_MAILER_FROM'),'form_mailfrom',$http['form_mailfrom'], 50, 100);
	$form->add_text(ct('S_ADMIN_MAILER_REPLYTO'),'form_mailreplyto',$http['form_mailreplyto'], 50, 100);
	$form->add_text(ct('S_ADMIN_MAILER_SUBJECT'),'form_mailsubject',$http['form_mailsubject'], 50, 200);
	$pattern = "/({\w*})/i";
	$format  = "<code><b>\$1</b></code>";
	$subject_hint = preg_replace($pattern, $format, ct('S_ADMIN_MAILER_BODY_HINT').'<br>'.($user->is_admin()?'{person_password} = '.ct('S_USER_PASSWORD').'<br>':'')); // mark commands in bold.
	#$subject_hint = preg_replace($pattern, $format, ct('S_ADMIN_MAILER_BODY_HINT')); // mark commands in bold.
	$form->add_textarea(ct('S_ADMIN_MAILER_BODY'),'form_mailbody',$mail_content, 78,10,'',$subject_hint,0,'class="fontmonospaced font9"');
	$form->add_submit('cmd_checkmail', ct('S_ADMIN_MAILER_PREVIEW_SUBMIT'));
	$form->show();
}

function mailer_header(){
	echo "<h1>".ct('S_ADMIN_MAILER_PERSONS')."</h1>\n";
}

function list_receivers(){
	$mail_status=array();
	$mail_status[]=array('',ct('S_ADMIN_TOOL_NOPERSONS'));
	$mail_status[]=array('0',ct('S_ADMIN_TOOL_ALLPERSONS'));
	$mail_status[]=array('','---');
	$mail_status[]=array('status_pc',ct('S_USER_STATUS_PC'));
	$mail_status[]=array('status_reviewer',ct('S_USER_STATUS_REVIEWER'));
	$mail_status[]=array('reviewer_or_pc',ct('S_USER_STATUS_REVIEWER_OR_PC'));
	$mail_status[]=array('pc_lazy2',ct('S_ADMIN_MAILER_SELECT_TOLAZYREVIEWERS2'));
	$mail_status[]=array('pc_lazy',ct('S_ADMIN_MAILER_SELECT_TOLAZYREVIEWERS'));
	$mail_status[]=array('','---');
	$mail_status[]=array('status_author',ct('S_USER_STATUS_AUTHOR'));
	foreach (ct_list_accessstates() as $g){
		$mail_status[]=array('author_'.$g[0],ct('S_ADMIN_MAILER_SELECT_TOAUTHORS').": ".$g[1]);
	}
	$mail_status[]=array('','---');
	$mail_status[]=array('status_participant',ct('S_USER_STATUS_PARTICIPANT'));
	$mail_status[]=array('','---');
	$mail_status[]=array('participant_notpaid_0',ct('S_ADMIN_PARTICIPANTS_PAYMENT_OPEN'));
	$mail_status[]=array('participant_notpaid_7',ct('S_ADMIN_PARTICIPANTS_PAYMENT_OPENFOR',array('7',ct_date_format(ct_time()-7*24*60*60))));
	$mail_status[]=array('participant_notpaid_14',ct('S_ADMIN_PARTICIPANTS_PAYMENT_OPENFOR',array('14',ct_date_format(ct_time()-14*24*60*60))));
	$mail_status[]=array('participant_notpaid_21',ct('S_ADMIN_PARTICIPANTS_PAYMENT_OPENFOR',array('21',ct_date_format(ct_time()-21*24*60*60))));
	$mail_status[]=array('participant_notpaid_30',ct('S_ADMIN_PARTICIPANTS_PAYMENT_OPENFOR',array('30',ct_date_format(ct_time()-30*24*60*60))));
	$mail_status[]=array('participant_notpaid_60',ct('S_ADMIN_PARTICIPANTS_PAYMENT_OPENFOR',array('60',ct_date_format(ct_time()-60*24*60*60))));
	$mail_status[]=array('','---');
	foreach (ct_list_groups() as $g){
		$mail_status[]=array('participant_group_'.$g[0],ct('S_ADMIN_MAILER_SELECT_TOPARTICIPANTS_GROUP')." ".ct_form_encode($g[1]));
	}
	foreach (ct_list_events() as $e){
		$mail_status[]=array('participant_event_'.$e[0],ct('S_ADMIN_MAILER_SELECT_TOPARTICIPANTS_EVENT')." ".ct_form_encode($e[1]));
	}
	$mail_status[]=array('','---');
	$mail_status[]=array('NOTparticipant',ct('S_USER_STATUS_NOTPARTICIPANT'));
	$mail_status[]=array('authorNOTparticipant',ct('S_USER_STATUS_AUTHOR_NOTPARTICIPANT'));
	$mail_status[]=array('','---');
	$mail_status[]=array('status_chair',ct('S_USER_STATUS_CHAIR'));
	$mail_status[]=array('status_conferenceChair',ct('S_USER_STATUS_CONFERENCECHAIR'));
	$mail_status[]=array('status_admin',ct('S_USER_STATUS_ADMIN'));
	$mail_status[]=array('status_frontdesk',ct('S_USER_STATUS_FRONTDESK'));
	$mail_status[]=array('status_assistant',ct('S_USER_STATUS_ASSISTANT'));
	return $mail_status;
}

function get_query(){
	GLOBAL $http, $db;
	$query = "select * from persons where deleted=0 order by name, firstname";
	$where = "";
	if ( STRPOS($http['form_mailselect'],"status_")===0 ) {
		$where = " && FIND_IN_SET('".substr($http['form_mailselect'],7)."',status)>0";
		$query = "select * from persons where deleted=0 ".$where." order by name, firstname";
	}
	if ( $http['form_mailselect'] == "reviewer_or_pc" ) { // Both: PC or Reviewer
		$where = " && (FIND_IN_SET('pc',status)>0 || FIND_IN_SET('reviewer',status)>0)";
		$query = "select * from persons where deleted=0 ".$where." order by name, firstname";
	}
	if ( STRPOS($http['form_mailselect'],"author_")===0 ) {
		$where = " && papers.acceptstatus='".substr($http['form_mailselect'],7)."' ";
		$query = "select persons.* from persons, papers where persons.ID=papers.personID && persons.deleted=0 && papers.withdrawn=0 ".$where." group by persons.ID order by name, firstname";
	}
	if ( STRPOS($http['form_mailselect'],"participant_group_")===0 ) {
		$where = " && participants.status='".substr($http['form_mailselect'],18)."' ";
		$query = "select persons.* from persons, participants where persons.ID=participants.personID && persons.deleted=0 && participants.deleted=0 ".$where." group by persons.ID order by name, firstname";
	}
	if ( STRPOS($http['form_mailselect'],"participant_notpaid_")===0 ) {
		$where =" and participants.regdate<\"".ct_timestamp_2_datetime(ct_time()-(substr($http['form_mailselect'],20)*60*60*24))."\" and participants.total!=participants.payamount and participants.total>0";
		$query = "select persons.* from persons, participants where persons.ID=participants.personID && persons.deleted=0 && participants.deleted=0 ".$where." group by persons.ID order by name, firstname";
	}
	if ( STRPOS($http['form_mailselect'],"participant_event_")===0 ) {
		$where = " && participants2events.eventID='".substr($http['form_mailselect'],18)."' ";
		$query = "select persons.* from persons, participants2events where persons.ID=participants2events.personID && persons.deleted=0 && participants2events.deleted=0 && participants2events.number>0 ".$where." group by persons.ID order by name, firstname";
	}
	if ( $http['form_mailselect'] == "NOTparticipant" ) { // persons not registered, yet.
		$where = " && FIND_IN_SET('participant',status)=0";
		$query = "select * from persons where deleted=0 ".$where." order by name, firstname";
	}
	if ( $http['form_mailselect'] == "authorNOTparticipant" ) { // authors not registered, yet.
		$where = " && FIND_IN_SET('participant',status)=0 && FIND_IN_SET('author',status)>0";
		$query = "select * from persons where deleted=0 ".$where." order by name, firstname";
	}
	if ( $http['form_mailselect'] == "pc_lazy" ) {  // experts with open reviews.
		$where = " && reviews.creationdate=0 ";
		$query = "select persons.* from persons, reviews where persons.ID=reviews.personID && persons.deleted=0 ".$where." group by persons.ID order by name, firstname";
	}
	if ( $http['form_mailselect'] == "pc_lazy2" ) {  // experts without priority topic selection
		$select  = "select persons.*, count(pc2topics.topicID) as topiccount from persons LEFT JOIN pc2topics ON persons.ID=pc2topics.personID ";
		$where = " where persons.deleted=0 && (FIND_IN_SET('pc',persons.status)>0 || FIND_IN_SET('reviewer',persons.status)>0) ";
		$groupby = " GROUP BY persons.ID HAVING topiccount=0";
		$query = "$select $where $groupby ORDER BY name, firstname ";
	}
	#echo $query;
	return $db->query($query);
}

function show_mailer_status($needle,$mail_status) {
	reset ($mail_status);
	while (list ($key, $val) = each ($mail_status)) {
		if ($val[0]==$needle)
	   		return $val[1];
	}
  	return "---";
}

// show	basic user information in one row
function show_simple_row($class,$person) {
	global $session;
	$user =& $session->get_user();
	echo "<tr class=\"$class\">\n";
	echo "<td align=right valign=top><span class=\"fontnormal font8\"><input type=\"checkbox\" class=\"checkboxradio\" name=\"f[]\" value=\"".$person['ID']."\" checked></span></td>\n";
	echo "<td align=right valign=top><span class=\"fontnormal font8\">".$person['ID']."</span></td>\n";
	echo "<td align=left valign=top><span class=\"fontbold font8\">";
	echo ct_form_encode($person['name']).", ".ct_form_encode($person['firstname'])."</span>";
	echo "</td>\n";
	echo "<td align=left valign=top>";
	echo "<span	class=\"fontnormal font8\"><a href=\"mailto:".ct_form_encode($person['email'])."\">";
	echo ct_form_encode($person['email'])."</a>\n";
	echo "</span>";
	echo "</td>\n";
	echo "<td align=left valign=top>";
	echo "<span	class=\"fontbold font8\">".ct_form_encode($person['organisation'])."</span>";
	echo "</td>\n";
	echo "<td align=left valign=top>";
	ct_load_lib("address.lib");
	echo "<span	class=\"fontnormal font8\">".ct_get_country($person['country'])."</span>";
	echo "</td>\n";

	echo "<td align=left valign=top>";
	echo "<span	class=\"fontbold font8\"><a target=\"blank\" href=\"".ct_pageurl('adminMailerPersons',ct_http_array(array('cmd_preview'=>'1','form_personID'=>$person['ID'],'print'=>'yes')))."\"><img src=\"icons/newwindow.gif\" border=0></a></span>";
	echo "</td>\n";

	echo "</tr>\n";
}

?>