<?php
//
// PAGE:		adminPapersBrowse
// DESC:		Browse all papers/contributions
//

ct_requirechair();
ct_pagepath(array('index','adminPapers'));

ct_load_lib('papers.lib');
ct_load_lib('admin.lib');
ct_load_class('CTForm');


$tables = 'persons, papers';
$leftjoin = '';
$where  = 'where persons.id = papers.personID';
$having = '';

if (!in_http('form_withdrawn', 'yes')) {
	$where .= " AND papers.withdrawn=0 ";
}

// Search string from navbar
$search     = isset($http['navbar_search'])?$http['navbar_search']:"";
if ($search!="") {
 	if ( preg_match("/^[0-9]+$/", $search) ) {
		$where .= " AND (papers.ID = ".$search.") ";
	} else {
		$where .= " AND LOWER(CONCAT(persons.name,'|',persons.firstname,'|',persons.organisation,'|',persons.city,'|',papers.author,'|',papers.title)) LIKE '%".strtolower($search)."%' ";
	}
}

// Prepare for assigned contributiontypes to this chair...
$assigned_ctypes = ct_list_contributiontypes();
if (ctconf_get('chairTrackSelect',false)) { // Shall chairs be assigned to tracks?
	$assigned_ctypeIDs = $user->get_contributiontypes_as_chair(); 
	$where.= " AND papers.contributiontypeID IN ('".implode("', '", $assigned_ctypeIDs)."')";
	$assigned_ctypes = array();
	foreach ($assigned_ctypeIDs as $c) {
		$ctype = ct_get_contributiontypes($c);
		$assigned_ctypes[] = array($ctype['ID'], $ctype[ctlx($ctype,'title')]);
	}
}

// From Filter to Query...
if (isset($http['form_tracks']) && $http['form_tracks']!=0){
	$where.=" AND papers.contributiontypeID=".$http['form_tracks'];
}
if (isset($http['form_status']) && $http['form_status']!="-" && $http['form_status']>-5 && $http['form_status']<5 ){
	$where.=" AND papers.acceptstatus='".$http['form_status']."'";
}
if (isset($http['form_topic']) && $http['form_topic']!="-"){
	$tables.=", topics2papers ";
	$where.=" AND topics2papers.paperID=papers.ID and topics2papers.topicID='".$http['form_topic']."'";
}
if (isset($http['specialfilter']) && $http['specialfilter']!="-"){
	if ($http['specialfilter']=='missinguploads') {
		if (in_http('version','final')) {	// Test for final version
			$tables.=", contributiontypes ";
			$where.=" and contributiontypes.ID=papers.contributiontypeID ";
			$where.=" and ((contributiontypes.upload_final=1 and papers.originalname_final='') or ";
			$where.=     " (contributiontypes.upload_final=2 and (papers.originalname_final='' or papers.originalname_final_2='')) or ";
			$where.=     " (contributiontypes.upload_final=3 and (papers.originalname_final='' or papers.originalname_final_2='' or papers.originalname_final_3='')) ) ";
		} else { // for normal/first version
			$tables.=", contributiontypes ";
			$where.=" and contributiontypes.ID=papers.contributiontypeID ";
			$where.=" and ((contributiontypes.upload=1 and originalname='') or ";
			$where.=     " (contributiontypes.upload=2 and (originalname='' or originalname_2='')) or ";
			$where.=     " (contributiontypes.upload=3 and (originalname='' or originalname_2='' or originalname_3='')) ) ";
		}
	} elseif (STRPOS($http['specialfilter'],'open_')===0) {
		$leftjoin = "LEFT JOIN reviews ON reviews.paperID=papers.ID";
		$where   .= " && reviews.creationdate=0 ";
		$having  .= " HAVING COUNT(reviews.personID)>=".substr($http['specialfilter'],5)." ";
	} elseif (STRPOS($http['specialfilter'],'fewreviewers_')===0) {
		$leftjoin = "LEFT JOIN reviews ON reviews.paperID=papers.ID";
		$having  .= " HAVING COUNT(reviews.personID)<".substr($http['specialfilter'],13)." ";
	} elseif ($http['specialfilter']=='complete') {
		$leftjoin = "LEFT JOIN reviews ON reviews.paperID=papers.ID && reviews.creationdate=0 ";
		#$where   .= " && reviews.creationdate=0 ";
		$having  .= " HAVING COUNT(reviews.paperID)=0";
	}
}


$order = ' order by papers.ID asc';
if (isset($http['listorder'])) {
	switch ($http['listorder']) {
		case 'author':
		$order = ' order by persons.name, persons.firstname, papers.author asc';
		break;
		case 'title':
		$order = ' order by papers.title asc';
		break;
		case 'contributiontypeID':
		$order = ' order by papers.contributiontypeID, papers.title asc';
		break;
		case 'id':
		$order = ' order by papers.ID asc';
		break;
		case 'lastupload':
		$order = ' order by papers.lastupload desc';
		break;
	}
}

$query="SELECT papers.* FROM $tables $leftjoin $where group by papers.ID $having $order ";
#echo $query;
$res = $db->query($query);

$countSubmitted = 0;
$c = $db->query("select count(*) as count from papers where withdrawn=0");
if ($c && ($db->num_rows($c) > 0)) { $t = $db->fetch($c); $countSubmitted = $t['count']; }
$countWithdrawn = 0;
$c = $db->query("select count(*) as count from papers where withdrawn=1");
if ($c && ($db->num_rows($c) > 0)) { $t = $db->fetch($c); $countWithdrawn = $t['count']; }


// title etc. differs for normal and final version!
if (in_http('version','final')) {
	$session->set_besturl(ct('S_ADMIN_PAPERS_BROWSE_FINAL_QUICK'));
	echo "<h1>".ct('S_ADMIN_PAPERS_BROWSE_FINAL_CMD')."</h1>\n";
	echo "<p class=\"fontnormal font10\">".ct('S_ADMIN_PAPERS_BROWSE_FINAL_INTRO')."</p>\n";
} else {
	$session->set_besturl(ct('S_ADMIN_PAPERS_BROWSE_QUICK'));
	echo "<h1>".ct('S_ADMIN_PAPERS_BROWSE_CMD')."</h1>\n";
	echo "<p class=\"fontnormal font10\">".ct('S_ADMIN_PAPERS_BROWSE_INTRO')."\n";
	echo "<span class=\"fontlabel fontbold  font10\">".ct('S_ADMIN_PAPERS_BROWSE_TOTAL1')." ".($countSubmitted)." ".ct('S_ADMIN_PAPERS_BROWSE_TOTAL2')." ".($countWithdrawn)." ".ct('S_ADMIN_PAPERS_BROWSE_TOTAL3')."</span></p>\n";
}


// Here comes the filter...
if (isset($http['filter']) && $http['filter'] == "show") {
	echo "<table width=\"100%\" class=\"whitebg\" align=center><tr><td>\n";
	echo "&lt;&lt;&lt; <a class=\"fontbold font10\" href=\"".ct_pageurl('adminPapersBrowse', ct_http_array(array('filter'=>'hide','form_tracks'=>'')))."\">".ct('S_ADMIN_FILTER_HIDE')."</a>\n";
	echo "</td></tr></table>\n";
	$form1 = new CTform('adminPapersBrowse', 'get');
	$form1->width='100%';
	$form1->align='center';
	$form1->add_hidden(hash2aa(ct_http_array(array('filter'=>'show'))));
	if (count($assigned_ctypes)>1) {
		$tracks=array_merge (array(array(0,ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_ALLTYPES'))), $assigned_ctypes);
		$form1->add_select_autosubmit(ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_CONTRIBUTIONTYPE'), 'form_tracks', $tracks, array($http['form_tracks']));
	}
	$topics=ct_list_topics();
	if (count($topics)>1) {
		$selecttopics=array_merge (array(array("-",ct('S_ADMIN_FILTER_ALLTOPICS'))), $topics);
		$form1->add_select_autosubmit(ct('S_ADMIN_FILTER_TOPICS'), 'form_topic', $selecttopics, array($http['form_topic']));
	}
	$fstates=array_merge (array(array("-",ct('S_ADMIN_PAPERS_RESULTS_ALLSTATES'))), ct_list_accessstates());
	$form1->add_select_autosubmit(ct('S_ADMIN_PAPERS_RESULTS_STATUS'), 'form_status', $fstates, array($http['form_status']));
	$form1->add_select_autosubmit(ct('S_ADMIN_PAPERS_BROWSE_FILTER'), 'specialfilter',
								array(array('-',ct('S_ADMIN_PAPERS_BROWSE_FILTER_NO')),
	 							array('missinguploads',ct('S_ADMIN_PAPERS_BROWSE_FILTER_MISSINGUPLOADS')),
	 							array('open_1',ct('S_ADMIN_PAPERS_BROWSE_FILTER_OPENREVIEWS',array('1'))),array('open_2',ct('S_ADMIN_PAPERS_BROWSE_FILTER_OPENREVIEWS',array('2'))),array('open_3',ct('S_ADMIN_PAPERS_BROWSE_FILTER_OPENREVIEWS',array('3'))),array('open_4',ct('S_ADMIN_PAPERS_BROWSE_FILTER_OPENREVIEWS',array('4'))),
	 							array('fewreviewers_1',ct('S_ADMIN_PAPERS_BROWSE_FILTER_FEWREVIEWERS',array('1'))),array('fewreviewers_2',ct('S_ADMIN_PAPERS_BROWSE_FILTER_FEWREVIEWERS',array('2'))),array('fewreviewers_3',ct('S_ADMIN_PAPERS_BROWSE_FILTER_FEWREVIEWERS',array('3'))),array('fewreviewers_4',ct('S_ADMIN_PAPERS_BROWSE_FILTER_FEWREVIEWERS',array('4'))),array('fewreviewers_5',ct('S_ADMIN_PAPERS_BROWSE_FILTER_FEWREVIEWERS',array('5'))), 
	 							array('complete',ct('S_ADMIN_PAPERS_BROWSE_FILTER_COMPLETE'))),
	 							array($http['specialfilter']));
	$form1->add_select_autosubmit(ct('S_ADMIN_PAPERS_BROWSE_VERSION'), 'version', array(array("normal",ct('S_ADMIN_PAPERS_BROWSE_CMD')),array("final",ct('S_ADMIN_PAPERS_BROWSE_FINAL_CMD'))), array($http['version']));
	$form1->add_select_autosubmit(ct('S_ADMIN_PAPERS_BROWSE_WITHDRAWN'), 'form_withdrawn', array(array('no',ct('S_ADMIN_PAPERS_BROWSE_HIDEWITHDRAWN')),array('yes',ct('S_ADMIN_PAPERS_BROWSE_SHOWWITHDRAWN'))), array($http['form_withdrawn']));	
	$form1->add_submit_noscriptonly('cmd_search', ct('S_ADMIN_PAPERS_BROWSE_SUBMIT'));
	$form1->show();
	#echo "<br>\n";
} else {
	echo "<table width=\"100%\" class=\"whitebg\" align=center border=0><tr><td>\n";
	echo "&gt;&gt;&gt; <a class=\"fontbold font10\" href=\"".ct_pageurl('adminPapersBrowse', ct_http_array(array('filter'=>'show','form_status'=>'')))."\">".ct('S_ADMIN_FILTER_SHOW')."</a>\n";
	echo "</td></tr></table>\n";
}

ct_load_lib('navbar.lib');
$items      = $db->num_rows($res);
$perpage    = isset($http['navbar_perpage']) && $http['navbar_perpage']!=""?$http['navbar_perpage']:ctconf_get('display_perpage',20);
$pageno     = isset($http['navbar_page'])?$http['navbar_page']:0; // default is 0
$maxpage    = intval(($items-1)/($perpage));
ct_navbar($http['page'],$items);

// show list...
if ($res >= 0) {
	
	ct_load_class('CTPaper');
	$paper = new CTPaper;
	
	$submissions=0;
	$withdrawn = 0;
	$page_submissions = 0;
	$page_withdrawn = 0;
	
	// Create header...
	echo "<table width=\"100%\" cellspacing=0 cellpadding=2 border=0>\n";
	echo "<tr class=\"listheader\">\n";
	echo "<td width=\"5%\" align=\"center\"><a href=\"".ct_pageurl($page,ct_http_array(array('listorder' => 'id')))."\" class=\"listheader_label\">".ct('S_PAPER_ID')."</a></td>\n";
	echo "<td width=\"36%\"><a href=\"".ct_pageurl($page,ct_http_array(array('listorder' => 'title')))."\" class=\"listheader_label\">".ct('S_PAPER_TITLE')."</a><br><img src=\"".ct_getbaseurl()."icons/darkblue.gif\" height=1 width=30><br>\n";
	echo "<a class=\"font8\" href=\"".ct_pageurl($page,ct_http_array(array('listorder' => 'contributiontypeID')))."\">".ct('S_PAPER_CONTRIBUTIONTYPE')."</a></td>\n";
	echo "<td width=\"36%\"><span class=\"listheader_label\">".ct('S_PAPER_AUTHOR')."</span><br><img src=\"".ct_getbaseurl()."icons/darkblue.gif\" height=1 width=30><br>\n";
	echo "<a class=\"font8\" href=\"".ct_pageurl($page,ct_http_array(array('listorder' => 'author')))."\">".ct('S_PAPER_SUBMITTINGAUTHOR')."</a></td>\n";
	if (isset($http['version']) && $http['version']=='final')
		echo "<td width=\"12%\"><span class=\"listheader_label\">".ct('S_PAPER_STATUS')."</span></td>\n";
	else
		echo "<td width=\"12%\"><span class=\"listheader_label\">".ct('S_PAPER_REVIEWS')."</span></td>\n";
	echo "<td width=\"11%\" align=\"right\"><span class=\"listheader_label\">".ct('S_ADMIN_PAPERS_ACTIONS')."</span></td>\n";
	echo "</tr>\n";
	for ($i=0; $i < $db->num_rows($res); $i++) {
		$row= $db->fetch($res);
		#$paper->load_by_id($row['ID']);
		$paper->pdata=$row;
		if ($paper->get('withdrawn')==1) $withdrawn++; else $submissions++;
		if (intval($i/$perpage)==$pageno) {
			$paper->show_row(($i%2?"oddrow":"evenrow"));
			if ($paper->get('withdrawn')==1) $page_withdrawn++; else $page_submissions++;
		}
	}
	
	// show sums...
	if ($maxpage>0) {
		echo "<tr class=\"dimbg\">\n";
		echo "<td colspan=\"5\"><span class=\"form_label\">".ct('S_ADMIN_PAPERS_BROWSE_PAGE_SUM1')." ".($page_submissions)." ".ct('S_ADMIN_PAPERS_BROWSE_PAGE_SUM2')." ".($page_withdrawn)." ".ct('S_ADMIN_PAPERS_BROWSE_PAGE_SUM3')."</span></td>\n";
		echo "</tr>\n";
	}
	echo "<tr class=\"darkbg\">\n";
	echo "<td colspan=\"5\"><span class=\"form_label\">".ct('S_ADMIN_PAPERS_BROWSE_SUM1')." ".($submissions)." ".ct('S_ADMIN_PAPERS_BROWSE_SUM2')." ".($withdrawn)." ".ct('S_ADMIN_PAPERS_BROWSE_SUM3')."</span></td>\n";
	echo "</tr>\n";
	echo "</table>\n";
	if ($maxpage>0) ct_navbar_small($http['page'],$items);
}
	
?>