<?php
//
// PAGE:		adminPapersResults
// DESC:		This page shows all results... This is a bit of a hack and not really object-oriented
//           but we wanted it to be really FAST!!!
//

ct_requirechair();
ct_pagepath(array('index','adminPapers'));

ct_load_lib('papers.lib');
ct_load_lib('navbar.lib');
ct_load_class('CTForm');
ct_load_class('CTPaper');
ct_load_class('CTReview');
ct_load_class('CTPCMessage');

$session->set_besturl(ct('S_ADMIN_PAPERS_RESULTS_QUICK'));

$colors = array("review1","review2","review3","review4","review5","review6","review7","review8","review9","review10");
$accstatcolor = array("-5"=>"otherbg","-4"=>"otherbg","-3"=>"otherbg","-2"=>"dimbg","-1"=>"negativebg","0"=>"","1"=>"positivebg","2"=>"lightbg","3"=>"brightbg");
$sessions=array_merge(array(array('0'=>0,'1'=>'----')),ct_list_sessions('',true));

$paper  = new CTPaper();
$review = new CTReview();
$pcmessage=new CTPCMessage();

// Save new status or session of a paper if required.
if (in_http("cmd_action","status") and in_http("cmd_acceptance") and in_http("form_paperID")) {
	$paper->load_by_id($http['form_paperID']);
	$paper->set("acceptstatus", $http['cmd_acceptance']);
	$paper->persist();
} elseif (in_http("cmd_action","track") and in_http("cmd_track") and in_http("form_paperID")) {
	$paper = new CTPaper();
	$paper->load_by_id($http['form_paperID']);
	$paper->set("track", $http['cmd_track']);
	$paper->persist();
}

// change order.
$sort = "ORDER BY score desc, span desc, title asc";
if (isset($http['form_sort']) && $http['form_sort']=='score')
	$sort = "ORDER BY score desc, span desc, title asc";
if (isset($http['form_sort']) && $http['form_sort']=='count')
	$sort = "ORDER BY count desc, score desc, title asc";
if (isset($http['form_sort']) && $http['form_sort']=='span')
	$sort = "ORDER BY span desc, title asc";
if (isset($http['form_sort']) && $http['form_sort']=='ID')
	$sort = "ORDER BY ID";
if (isset($http['form_sort']) && $http['form_sort']=='title')
	$sort = "ORDER BY title asc";
if (isset($http['form_sort']) && $http['form_sort']=='author')
	$sort = "ORDER BY per.name, per.firstname, author asc, title asc";
if (isset($http['form_sort']) && $http['form_sort']=='acceptstatus')
	$sort = "ORDER BY acceptstatus desc, score desc, title asc";
if (isset($http['form_sort']) && $http['form_sort']=='track')
	$sort = "ORDER BY ses.shorttitle, title asc";

$tables = '';
$where = '';
$having = '';


// Search string from navbar
$search     = isset($http['navbar_search'])?$http['navbar_search']:"";
if ($search!="") {
 	if ( preg_match("/^[0-9]+$/", $search) ) {
		$where .= " && (p.ID = ".$search.") ";
	} else {
		$where .= " && UPPER(CONCAT(p.author,'|',p.title)) LIKE UPPER('%".$search."%')";
	}
}


// Prepare for assigned contributiontypes to this chair...
$assigned_ctypes = ct_list_contributiontypes();
if (ctconf_get('chairTrackSelect',false)) { // Shall chairs be assigned to tracks?
	$assigned_ctypeIDs = $user->get_contributiontypes_as_chair();
	$where.= " AND p.contributiontypeID IN ('".implode("', '", $assigned_ctypeIDs)."')";
	$assigned_ctypes = array();
	foreach ($assigned_ctypeIDs as $c) {
		$ctype = ct_get_contributiontypes($c);
		$assigned_ctypes[] = array($ctype['ID'], $ctype[ctlx($ctype,'title')]);
	}
}


// Filter
if (isset($http['form_tracks']) && $http['form_tracks']!=0){
	$where.=" && p.contributiontypeID=".$http['form_tracks'];
}
if (isset($http['form_status']) && $http['form_status']!="-" && $http['form_status']>-5 && $http['form_status']<5 ){
	$where.=" && p.acceptstatus='".$http['form_status']."'";
}
if (isset($http['form_session']) && $http['form_session']!="-" && $http['form_session']>=0 ){
	$where.=" && p.track='".$http['form_session']."'";
}
if (isset($http['form_topic']) && $http['form_topic']!="-"){
	$tables.=", topics2papers as t2p ";
	$where.=" and t2p.paperID=p.ID and t2p.topicID='".$http['form_topic']."'";
}
if (isset($http['specialfilter']) && $http['specialfilter']!="-"){
	if (STRPOS($http['specialfilter'],'fewreviews_')===0) {
		$having  .= " HAVING COUNT(r.personID)<=".substr($http['specialfilter'],11)." ";
	} elseif (STRPOS($http['specialfilter'],'span_')===0) {
		$having  .= " HAVING span>".substr($http['specialfilter'],5)." ";
	} elseif (STRPOS($http['specialfilter'],'extraoption')===0) {
		$having  .= " HAVING extraoption>0 ";
	}
}



// SELECT Statement to create the overview list.
// Here also the sums are calculated.
// If reviewfactor['familiarity'] is 1 each sum is multiplied by the
// familiarity (e.g. 6 and 8) and the total is then devided by the
// average familiarity ( would be 7) and - as always - the number of reviews.
$q = "select p.ID as id, p.personID as authorID, p.author, p.title, p.studentpaper, p.extraoption, ".
"per.name as name, per.firstname as firstname, ".
"round(greatest(0,(sum((".
"(evaluation*".  $review->reviewfactor['evaluation'].")+".
"(significance*".$review->reviewfactor['significance'].")+".
"(originality*". $review->reviewfactor['originality'].")+".
"(relevance*".   $review->reviewfactor['relevance'].")+".
"(readability*". $review->reviewfactor['readability'].")+".
"(overall*".     $review->reviewfactor['overall']."))".
($review->reviewfactor['familiarity']==1?"*familiarity":"").
"/10)".
"/count(r.paperID)".
($review->reviewfactor['familiarity']==1?"/avg(familiarity)":"").
")),1) as score, ".
"count(r.paperID) as count, ".
"sum(r.bestpaper) as bestpapers, ".
#"sum(r.poster) as posters, ".
#"sum(r.revision) as revisions, ".
#"sum(r.devaluation) as devaluations, ".
"round(max((evaluation*".$review->reviewfactor['evaluation']."+".
      "significance*".$review->reviewfactor['significance']."+".
      "originality*".$review->reviewfactor['originality']."+".
      "relevance*".$review->reviewfactor['relevance']."+".
      "readability*".$review->reviewfactor['readability']."+".
      "overall*".$review->reviewfactor['overall'].")/10)-".
  "min((evaluation*".$review->reviewfactor['evaluation']."+".
      "significance*".$review->reviewfactor['significance']."+".
      "originality*".$review->reviewfactor['originality']."+".
      "relevance*".$review->reviewfactor['relevance']."+".
      "readability*".$review->reviewfactor['readability']."+".
      "overall*".$review->reviewfactor['overall'].")/10),1) as span, ".
"acceptstatus, track, contributiontypeID ".
"FROM papers AS p $tables ".
"LEFT JOIN reviews AS r ON p.ID = r.paperID and r.creationdate > 0 ".
"LEFT JOIN persons AS per ON per.ID = p.personID ".
"LEFT JOIN sessions AS ses ON ses.ID = p.track ".
"WHERE p.withdrawn=0 $where ". // and r.creationdate != '' ".
"GROUP by p.ID ".
"$having ". // having...
"$sort "; // order by...
$r = $db->query($q);

// ------------

echo "<h1>".ct('S_ADMIN_PAPERS_RESULTS_CMD')."</h1>";
echo "<span class=\"fontnormal font10\">".ct('S_ADMIN_PAPERS_RESULTS_HINT')."</span><br>";
#echo "$q<br>\n";


// Here comes the filter...
if (isset($http['filter']) && $http['filter'] == "hide") {
	echo "<table width=\"100%\" class=\"whitebg\" align=center border=0><tr><td>\n";
	echo "&gt;&gt;&gt; <a class=\"fontbold font10\" href=\"".ct_pageurl('adminPapersResults', ct_http_array(array('filter'=>'show','form_paperID'=>'','form_status'=>'','form_session'=>'','form_topic'=>'','form_tracks'=>'','specialfilter'=>'')))."\">".ct('S_ADMIN_FILTER_SHOW')."</a>\n";
	echo "</td></tr></table>\n";
	#echo "<br>\n";
} else {
	echo "<table width=\"100%\" class=\"whitebg\" align=center border=0><tr><td>\n";
	echo "<span class=\"fontbold font8\">&lt;&lt;&lt;&nbsp;&nbsp;<a href=\"".ct_pageurl('adminPapersResults', ct_http_array(array('filter'=>'hide','form_paperID'=>'','form_status'=>'','form_session'=>'','form_topic'=>'','form_tracks'=>'','specialfilter'=>'')))."\">".ct('S_ADMIN_FILTER_HIDE')."</a></span>\n";
	echo "</td></tr></table>\n";
	$form1 = new CTform('adminPapersResults', 'get');
	$form1->width='100%';
	$form1->align='center';
	$form1->add_hidden(hash2aa(ct_http_array(array('filter'=>'show'))));
	if (count($assigned_ctypes)>1) {
		$ftracks=array_merge (array(array(0,ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_ALLTYPES'))), $assigned_ctypes);
		$form1->add_select_autosubmit(ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_CONTRIBUTIONTYPE'), 'form_tracks', $ftracks, array($http['form_tracks']));
	}
	$fstates=array_merge (array(array("-",ct('S_ADMIN_PAPERS_RESULTS_ALLSTATES'))), ct_list_accessstates());
	$form1->add_select_autosubmit(ct('S_ADMIN_PAPERS_RESULTS_STATUS'), 'form_status', $fstates, array($http['form_status']), false);
	$sstates=array_merge(array(array('-',ct('S_ADMIN_PAPERS_RESULTS_ALLSESSIONS')),array('0',ct('S_ADMIN_PAPERS_RESULTS_NOSESSION'))),ct_list_sessions());
	$form1->add_select_autosubmit(ct('S_ADMIN_PAPERS_RESULTS_SESSION'), 'form_session', $sstates, array($http['form_session']), false);

	$topics=ct_list_topics();
	if (count($topics)>1) {
		$selecttopics=array_merge (array(array("-",ct('S_ADMIN_FILTER_ALLTOPICS'))), $topics);
		$form1->add_select_autosubmit(ct('S_ADMIN_FILTER_TOPICS'), 'form_topic', $selecttopics, array($http['form_topic']));
	}

	$form1->add_select_autosubmit(ct('S_ADMIN_PAPERS_BROWSE_FILTER'), 'specialfilter',
								array(array('-',ct('S_ADMIN_PAPERS_BROWSE_FILTER_NO')),
	 							array('fewreviews_1',ct('S_ADMIN_PAPERS_BROWSE_FILTER_FEWREVIEWS',array('1'))),array('fewreviews_2',ct('S_ADMIN_PAPERS_BROWSE_FILTER_FEWREVIEWS',array('2'))),array('fewreviews_3',ct('S_ADMIN_PAPERS_BROWSE_FILTER_FEWREVIEWS',array('3'))),array('fewreviews_4',ct('S_ADMIN_PAPERS_BROWSE_FILTER_FEWREVIEWS',array('4'))),array('fewreviews_5',ct('S_ADMIN_PAPERS_BROWSE_FILTER_FEWREVIEWS',array('5'))),
	 							array('span_5',ct('S_ADMIN_PAPERS_BROWSE_FILTER_BIGSPAN',array('5'))), array('span_10',ct('S_ADMIN_PAPERS_BROWSE_FILTER_BIGSPAN',array('10'))),array('span_15',ct('S_ADMIN_PAPERS_BROWSE_FILTER_BIGSPAN',array('15'))),array('span_20',ct('S_ADMIN_PAPERS_BROWSE_FILTER_BIGSPAN',array('20'))),array('span_25',ct('S_ADMIN_PAPERS_BROWSE_FILTER_BIGSPAN',array('25'))),array('span_30',ct('S_ADMIN_PAPERS_BROWSE_FILTER_BIGSPAN',array('30'))),array('span_35',ct('S_ADMIN_PAPERS_BROWSE_FILTER_BIGSPAN',array('35'))),array('span_40',ct('S_ADMIN_PAPERS_BROWSE_FILTER_BIGSPAN',array('40'))),array('span_50',ct('S_ADMIN_PAPERS_BROWSE_FILTER_BIGSPAN',array('50'))),array('span_60',ct('S_ADMIN_PAPERS_BROWSE_FILTER_BIGSPAN',array('60'))),
	 							array('extraoption',ct('S_PAPER_EXTRAOPTION'))),
	 							array($http['specialfilter']));

	$form1->add_submit_noscriptonly('cmd_search', ct('S_ADMIN_PAPERS_BROWSE_SUBMIT'));
	$form1->show();
#	echo "<br>\n";
}

$items      = $db->num_rows($r);
ct_navbar("adminPapersResults",$items);
$perpage    = isset($http['navbar_perpage']) && $http['navbar_perpage']!=""?$http['navbar_perpage']:ctconf_get('display_perpage',20);
$pageno     = isset($http['navbar_page'])?$http['navbar_page']:0; // default is 0
$maxpage    = intval(($items-1)/($perpage));


// Show rows...
// ------------

$num = $db->num_rows($r);
if ($num > 0) {

	echo "<table width=\"100%\" cellspacing=1 cellpadding=3 border=0>";
	echo "<tr class=\"listheader\">";
	echo "<td align=center width=\"1%\"><span class=\"fontbold font8\">".ct('S_ADMIN_PAPERS_RESULTS_POS')."</span></td>";
	echo "<td align=center width=\"2%\"><a href=\"".ct_pageurl("adminPapersResults", ct_http_array(array("form_sort"=>"score")))."\" class=\"fontbold font8\">".ct('S_ADMIN_PAPERS_RESULTS_POINTS')."</a></td>";
	echo "<td align=center width=\"2%\"><a href=\"".ct_pageurl("adminPapersResults", ct_http_array(array("form_sort"=>"count")))."\" class=\"fontbold font8\">".ct('S_ADMIN_PAPERS_RESULTS_COUNT')."</a><br><img src=\"".ct_getbaseurl()."icons/darkblue.gif\" height=1 width=40><br>";
	echo "<a href=\"".ct_pageurl("adminPapersResults", ct_http_array(array("form_sort"=>"span")))."\" class=\"fontbold font8\">".ct('S_ADMIN_PAPERS_RESULTS_SPAN')."</a></td>";
	echo "<td align=center width=\"1%\"><a href=\"".ct_pageurl("adminPapersResults", ct_http_array(array("form_sort"=>"ID")))."\" class=\"listheader_label\">".ct('S_ADMIN_PAPERS_RESULTS_ID')."</a></td>";
	echo "<td width=\"58%\"><a href=\"".ct_pageurl("adminPapersResults", ct_http_array(array("form_sort"=>"title")))."\" class=\"listheader_label\">".ct('S_ADMIN_PAPERS_RESULTS_TITLE')."</a></td>";
	echo "<td width=\"30%\"><span class=\"listheader_label\">".ct('S_ADMIN_PAPERS_RESULTS_AUTHORS')."</span><br><img src=\"".ct_getbaseurl()."icons/darkblue.gif\" height=1 width=30><br>\n";
	echo "<a class=\"font8\" href=\"".ct_pageurl("adminPapersResults",ct_http_array(array("form_sort" => 'author')))."\">".ct('S_PAPER_SUBMITTINGAUTHOR')."</a></td>\n";
	echo "<td align=center width=\"3%\"><a href=\"".ct_pageurl("adminPapersResults", ct_http_array(array("form_sort"=>"acceptstatus")))."\" class=\"fontbold font8\">";
	echo ct('S_ADMIN_PAPERS_RESULTS_STATUS')."</a></td>";
	echo "<td align=center width=\"3%\"><a href=\"".ct_pageurl("adminPapersResults", ct_http_array(array("form_sort"=>"track")))."\" class=\"fontbold font8\">".ct('S_ADMIN_PAPERS_RESULTS_SESSION')."</a><br><img src=\"".ct_getbaseurl()."icons/darkblue.gif\" height=1 width=40><br>";
	echo "<span class=\"fontbold font8\">".ct('S_PC_DISCUSS_RESULTS_MESSAGES')."</span></td>";
	echo "</tr>\n";

	for ($i = 0; $i < $num; $i++) {

		$row = $db->fetch($r);

		if (intval($i/$perpage)==$pageno) {
			$class = $i%2?"oddrow":"evenrow";
			echo "<tr class=\"$class\" ";
			echo "onmouseover=\"ct_row( this, 'on', '$class', '".$class."_highlight');\" ";
			echo "onmouseout=\"ct_row( this, 'off', '$class', '".$class."_highlight');\">\n";

			echo "<td align=center><span class=\"fontbold font10\">".($i+1)."</span></td>\n";
			echo "<td align=center ";
			if ($row['count'] != 0) {
				echo "class=\"".$colors[round(($row['score']/10)-1)]."\" ";
			}
			echo ">";
			echo "<span class=\"fontbold font12\">".($row['score']!=""?$row['score']:"-")."</span><br>";
			for ($j = 0; $j < $row['bestpapers']; $j++)
				echo "<img src=\"".ct_getbaseurl()."icons/star.gif\" alt=\"".ct('S_REVIEW_FORM_BESTPAPER')."\" title=\"".ct('S_REVIEW_FORM_BESTPAPER')."\" align=top>";
			#for ($j = 0; $j < $row['devaluations']; $j++)
			#	echo "<img src=\"".ct_getbaseurl()."icons/critical.gif\" alt=\"".ct('S_REVIEW_DEVALUATION')."\" title=\"".ct('S_REVIEW_DEVALUATION')."\" align=top>";
			#for ($j = 0; $j < $row['posters']; $j++)
			#	echo "<img src=\"".ct_getbaseurl()."icons/poster.gif\" alt=\"".ct('S_REVIEW_POSTER')."\" title=\"".ct('S_REVIEW_POSTER')."\" align=top>";
			#for ($j = 0; $j < $row['revisions']; $j++)
			#	echo "<img src=\"".ct_getbaseurl()."icons/write.gif\" alt=\"".ct('S_REVIEW_REVISION')."\" title=\"".ct('S_REVIEW_REVISION')."\" align=top>";
			echo "</td>\n";
			echo "<td align=center nowrap>";
			if ($row['count'] < 2) { echo "<span class=\"fontnegative fontbold font10\">"; }
			else { echo "<span class=\"fontnormal font10\">"; }
			echo $row['count']." / ";
			echo "<a href=\"".ct_pageurl('adminReviewAssign', array('form_id' => $row['id']))."\" title=\"".ct('S_REVIEW_ASSIGN_PC')."\">";
			echo $user->get_review_count("",$row['id'],0);  // not optimized yet...
			echo "</a></span><br>";
			if ($row['span'] >= 30) { echo "<span class=\"fontnegative fontbold font10\">"; }
			else { echo "<span class=\"fontbold font10\">"; }
			echo ($row['span']!=""?$row['span']:"-");
			echo "</span></td>\n";

			echo "<td align=center><span class=\"fontbold font8\">".$row['id']."</span></td>\n";
			echo "<td valign=\"top\"><a class=\"fontbold font8\" href=\"".ct_pageurl("adminPapersDetails", array("form_id"=>$row['id']))."\">".ct_form_encode($row['title'])."</a>";
			if ($row['studentpaper']) echo ' <img src="icons/studentpaper.gif" title="'.ct('S_PAPER_FORM_STUDENTPAPER_HINT').'">';
			if ($row['extraoption']) echo ' <img src="icons/ok.gif" title="'.ct('S_PAPER_EXTRAOPTION').'">';
			echo "<BR>";
			echo "<span class=\"fontnormal font8\">".$paper->_get_contributiontype_title($row['contributiontypeID'])."</span>";
			echo "</td>";

			echo "<td align=left valign=top><span class=\"fontbold font8\">".ct_form_encode($row['author'])."</span><br>\n";
			echo "<a href=\"".ct_pageurl('adminUsersDetails', array('form_id'=>$row['authorID']))."\" class=\"fontnormal font8\">".ct_form_encode($row['name'].', '.$row['firstname'])."&nbsp;</a></td>\n";

			// Set status of paper (accepted, rejected etc.)
			echo "<form action=\"".ct_pageurl('adminPapersResults')."\" method=post>";
			echo "<td class=\"".$accstatcolor[$row['acceptstatus']]."\" align=center>";
			echo "<input type=hidden name=cmd_action value=status>\n";
			echo "<input type=hidden name=form_paperID value=\"".$row['id']."\">\n";  // id in lower letters!!!
			$fields = ct_http_array(array('form_paperID'=>''));
			foreach ($fields as $f => $g)
				if ($g!=='') echo "<input type=hidden name=\"$f\" value=\"$g\">\n";

			echo "<select size=1 name=\"cmd_acceptance\" class=\"optionsmall\" onChange=\"this.form.submit();\">";
			foreach (ct_list_accessstates() as $g){
				echo "<option class=\"optionsmall\" value=\"".$g[0]."\" ".($row['acceptstatus']==$g[0] ? "selected" : "").">".$g[1]."</option>\n";
			}
			echo "</select>\n";

			echo "</td></form>\n";

			$messages=$pcmessage->count_messages($row['id']);
			if ($row['acceptstatus']==0) { // not decided: Show messages
				$votes = 0;

				if ($messages>0) {
					$votes=round($pcmessage->get_average_vote($row['id']),1);
				}
				echo "<td align=center nowrap=\"nowrap\">\n";
				echo "<span class=\"fontbold font10\">";
				$pcmessage->show_tendency($votes);
				echo "</span><br>\n";
				if ($ctype['do_discussion']=='true') {
					if ($messages==0) {
						echo "<a href=\"".ct_pageurl('editMessagePC', array('paperID'=>$row['id']))."\" class=\"fontbold font8\">".ct('S_PC_DISCUSS_RESULTS_NUMBER_MESSAGES',array($messages))."</a><br>\n";

					} elseif ($messages==1)
						echo "<a href=\"".ct_pageurl('browsePCMessages', array('paperID'=>$row['id']))."\" class=\"fontbold font8\" >".ct('S_PC_DISCUSS_RESULTS_NUMBER_MESSAGE',array($messages))."</a><br>\n";
					else
						echo "<a href=\"".ct_pageurl('browsePCMessages', array('paperID'=>$row['id']))."\" class=\"fontbold font8\" >".ct('S_PC_DISCUSS_RESULTS_NUMBER_MESSAGES',array($messages))."</a><br>\n";
				}
				echo "</td>\n";
			} elseif ($row['acceptstatus']!=-1 || $row['track']!=0) { // if rejected do not show...

				// Select Session (formerly known as Track)
				echo "<form action=\"".ct_pageurl('adminPapersResults')."\" method=post>\n";
				echo "<td align=center nowrap>";
				echo "<input type=hidden name='cmd_action' value='track'>\n";
				echo "<input type=hidden name='form_paperID' value=\"".$row['id']."\">\n";
				$fields = ct_http_array(array('form_paperID'=>''));
				foreach ($fields as $f => $g)
					if ($g!=='') echo "<input type=hidden name=\"$f\" value=\"$g\">\n";

				echo "<select size=1 class=\"optionsmall\" name=\"cmd_track\" onChange=\"this.form.submit();\">\n";
				foreach ($sessions as $s) {
					echo "<option class=\"optionsmall\" value=\"".$s['0']."\" ".($row['track']==$s['0'] ? "selected" : "").">".$s['1']."</option>\n";
				}
				echo "</select><br>\n";

				$ctype = $paper->_get_contributiontype($row['contributiontypeID']);
				if ($ctype['do_discussion']=='true') {
					if ($messages==1)
						echo "<a href=\"".ct_pageurl('browsePCMessages', array('paperID'=>$row['id']))."\" class=\"fontbold font8\" >".ct('S_PC_DISCUSS_RESULTS_NUMBER_MESSAGE',array($messages))."</a><br>\n";
					else
						echo "<a href=\"".ct_pageurl('browsePCMessages', array('paperID'=>$row['id']))."\" class=\"fontbold font8\" >".ct('S_PC_DISCUSS_RESULTS_NUMBER_MESSAGES',array($messages))."</a><br>\n";
				}
				echo "</td>";
				echo "</form>";
			} else {
				echo "<td align=center nowrap=\"nowrap\">\n";
				if ($ctype['do_discussion']=='true') {
					if ($messages==1)
						echo "<a href=\"".ct_pageurl('browsePCMessages', array('paperID'=>$row['id']))."\" class=\"fontbold font8\" >".ct('S_PC_DISCUSS_RESULTS_NUMBER_MESSAGE',array($messages))."</a><br>\n";
					else
						echo "<a href=\"".ct_pageurl('browsePCMessages', array('paperID'=>$row['id']))."\" class=\"fontbold font8\" >".ct('S_PC_DISCUSS_RESULTS_NUMBER_MESSAGES',array($messages))."</a><br>\n";
				} else
					echo "&nbsp;";
				echo "</td>\n";
			}
			echo "</tr>\n\n";

		}
	}

	echo "</table>";
	if ($maxpage>0) ct_navbar_small("adminPapersResults",$items);
}

?>
