
<?php
//
// PAGE:		adminParticipantsBrowse
// DESC:		Browse all participants of conference
//

ct_requireassistantorconferencechair();

ct_load_class('CTForm');
ct_load_class('CTParticipation'); 
ct_load_lib('admin.lib');
ct_load_lib('participation.lib');
ct_load_lib('payment.lib');

ct_pagepath(array('index','adminUsers'));

$session->set_besturl(ct('S_ADMIN_PARTICIPANTS_BROWSE_QUICK'));


echo "<H1>".ct('S_ADMIN_PARTICIPANTS_BROWSE_CMD')."</H1>\n";

$participation = new CTParticipation;

$groups=array_merge (array(array(0,ct('S_ADMIN_TOOL_ALLPARTICIPANTS'))), ct_list_groups());
$events=array_merge (array(array(0,ct('S_ADMIN_TOOL_ALLPARTICIPANTS'))), ct_list_events());
$eventtypes=array_merge (array(array(0,ct('S_ADMIN_TOOL_ALLPARTICIPANTS'))), ct_list_eventtypes());
$discounts=array_merge (array(array(0,ct('S_ADMIN_TOOL_ALLPARTICIPANTS'))), ct_list_timediscounts());
$paymethods=array_merge(array(array('0',ct('S_ADMIN_TOOL_ALLPARTICIPANTS'))), ct_list_paymethods());

// if (isset($http['cmd_search'])){
// echo $http['form_group'].$http['form_event'].$http['form_payment'];

$query="select participants.* from participants, persons as p ";

// required tables
if ((isset($http['form_event']) && $http['form_event']>0) ||
		isset($http['form_eventtype']) && $http['form_eventtype']>0){
	$query.=", participants2events";
}
if (isset($http['form_discounts']) && $http['form_discounts']>0){
	$query.=", timediscounts";
}

// where condition.
$where=" where participants.personID=p.ID and participants.regdate != '0000-00-00 00:00:00' ";

if ((isset($http['form_event']) && $http['form_event']>0) ||
		isset($http['form_eventtype']) && $http['form_eventtype']>0){
	$where.=" and participants.personID=participants2events.personID and participants2events.number>0";
}
if ((isset($http['form_event']) && $http['form_event']>0)) {
	$where.=" and participants2events.eventID= \"".$http['form_event']."\"";
}
if (isset($http['form_eventtype']) && $http['form_eventtype']>0){
	$e = ct_get_events($http['form_eventtype']);
	if (count($e)>0) { // events found?	
		$eIDs = array();
		for ($i=0; $i < count($e); $i++) {
			$eIDs[] = $e[$i]['ID'];
		}
		$where.=" and participants2events.eventID IN (".ct_csv_implode($eIDs).")";
	}
}
if (isset($http['form_discounts']) && $http['form_discounts']>0){
	$where.=" and timediscounts.ID=".$http['form_discounts']." and participants.regdate>=timediscounts.effectivefrom and participants.regdate<=timediscounts.effectiveuntil ";
}
if (isset($http['form_group']) && $http['form_group']!=0){
	$where.=" and participants.status=".$http['form_group'];
}
if (isset($http['form_payment']) && $http['form_payment']){
	$where.=" and participants.paymethod=\"".$http['form_payment']."\"";
}
if (isset($http['form_notpaid']) && $http['form_notpaid']!="-"){
	$where.=" and participants.regdate<\"".ct_timestamp_2_datetime(ct_time()-($http['form_notpaid']*60*60*24))."\" and total!=payamount and total>0";
}
if (!isset($http['form_deleted']) || $http['form_deleted']=='' || (isset($http['form_deleted']) && $http['form_deleted']=="no")) {
	$where .= " and participants.deleted=0";
} elseif (isset($http['form_deleted']) && $http['form_deleted']=="only") {
	$where .= " and participants.deleted=1";
}

// Search string from navbar
$search = isset($http['navbar_search'])?$http['navbar_search']:"";
if ($search!="") {
 	if (preg_match("/^[0-9]+$/", $http['navbar_search']) ) {
		$where .= " AND (p.ID = ".$search.")";
	} else {
		$where .= " AND ( LOWER(CONCAT(p.name,'|',p.firstname,'|',p.organisation,'|',p.city,'|',p.country,'|',p.email)) LIKE '%".strtolower($search)."%' ";
		$where .= " OR LOWER(CONCAT(participants.name,'|',participants.firstname,'|',participants.organisation,'|',participants.city,'|',participants.email)) LIKE '%".strtolower($search)."%' ";
		$where .= " OR LOWER(CONCAT(participants.invoiceno,'|',participants.ccholder,'|',participants.ccaddress,'|',participants.cccity,'|',participants.ccemail)) LIKE '%".strtolower($search)."%' ";
		$where .= " OR CONCAT(participants.total) LIKE '%".strtolower($search)."%'";
		$where .= " OR CONCAT(participants.payamount) LIKE '%".strtolower($search)."%') ";
	}
}

$order = ' order by p.name asc, p.firstname asc';

if (isset($http['listorder'])) {
	switch ($http['listorder']) {
		case 'org':
		$order = ' order by p.organisation asc, p.name asc';
		break;
		case 'id':
		$order = ' order by p.ID asc';
		break;
		case 'name':
		$order = ' order by p.name asc, p.firstname asc';
		break;
		case 'paymethod':
		$order = ' order by participants.paymethod asc';
		break;
		case 'payamount':
		$order = ' order by participants.payamount asc';
		break;
		case 'country':
		$order = ' order by p.country asc, p.name asc';
		break;
		case 'regdate':
		$order = ' order by participants.regdate, p.name asc';
		break;
		case 'total':
		$order = ' order by participants.total, p.name asc';
		break;
		case 'invoicedate':
		$order = ' order by participants.invoicedate, p.name asc';
		break;
		case 'invoiceNo':
		$order = ' order by participants.invoiceNo, p.name asc';
		break;
		case 'paydate':
		$order = ' order by participants.paydate, p.name asc';
		break;
		case 'email':
		$order = ' order by p.email asc';
		break;
	}
	
}

$query="$query $where GROUP BY p.ID $order";

## echo $query;

$r = $db->query($query);

echo "<p class=\"fontnormal font10\">".ct('S_ADMIN_PARTICIPANTS_BROWSE_INTRO')."</p>\n";


if (isset($http['filter']) && $http['filter'] == "show") {
	echo "<table width=\"100%\" align=center class=\"whitebg\"><tr><td>\n";
	echo "&lt;&lt;&lt; <a class=\"fontbold font10\" href=\"".ct_pageurl('adminParticipantsBrowse', array('filter'=>'hide', 'listorder'=>$http['listorder'] ))."\">".ct('S_ADMIN_FILTER_HIDE')."</a>\n";
	echo "</td></tr></table>\n";
	$form1 = new CTform('adminParticipantsBrowse', 'get');
	$form1->width='100%';
	$form1->align='center';
	$form1->add_hidden(hash2aa(ct_http_array(array()))); // list all http variables with values
	$form1->add_select_autosubmit(ct('S_ADMIN_TOOL_EVENTS_CMD'), 'form_event', $events, array($http['form_event']));
	if (count($eventtypes)>2)
		$form1->add_select_autosubmit(ct('S_ADMIN_TOOL_EVENTTYPES_CMD'), 'form_eventtype', $eventtypes, array($http['form_eventtype']));
	if (count($discounts)>2)
		$form1->add_select_autosubmit(ct('S_PARTICIPATION_FORM_DISCOUNTS'), 'form_discounts', $discounts, array($http['form_discounts']));
	if (count($groups)>2)
		$form1->add_select_autosubmit(ct('S_PARTICIPATION_FORM_GROUPS'), 'form_group', $groups, array($http['form_group']));
	if (count($paymethods)>2)
		$form1->add_select_autosubmit(ct('S_ADMIN_TOOL_PAYMENT_CMD'), 'form_payment', $paymethods, array($http['form_payment']), false);
	$form1->add_select_autosubmit(ct('S_ADMIN_PARTICIPANTS_PAYMENT'), 'form_notpaid', 
		array(array('-',ct('S_ADMIN_TOOL_ALLPARTICIPANTS')),
		array('0',ct('S_ADMIN_PARTICIPANTS_PAYMENT_OPEN')),
		array('7',ct('S_ADMIN_PARTICIPANTS_PAYMENT_OPENFOR',array('7',ct_date_format(ct_time()-7*24*60*60)))),
		array('14',ct('S_ADMIN_PARTICIPANTS_PAYMENT_OPENFOR',array('14',ct_date_format(ct_time()-14*24*60*60)))),
		array('21',ct('S_ADMIN_PARTICIPANTS_PAYMENT_OPENFOR',array('21',ct_date_format(ct_time()-21*24*60*60)))),
		array('30',ct('S_ADMIN_PARTICIPANTS_PAYMENT_OPENFOR',array('30',ct_date_format(ct_time()-30*24*60*60)))),
		array('60',ct('S_ADMIN_PARTICIPANTS_PAYMENT_OPENFOR',array('60',ct_date_format(ct_time()-60*24*60*60))))),
		array($http['form_notpaid']), false);
	$form1->add_select_autosubmit(ct('S_ADMIN_PARTICIPANTS_BROWSE_DELETED'), 'form_deleted', array(
		array('no',ct('S_ADMIN_PARTICIPANTS_BROWSE_HIDEDELETED')),
		array('yes',ct('S_ADMIN_PARTICIPANTS_BROWSE_SHOWDELETED')),
		array('only',ct('S_ADMIN_PARTICIPANTS_BROWSE_ONLYDELETED'))),
		array($http['form_deleted']), false);

	$form1->add_submit_noscriptonly('cmd_search', ct('S_ADMIN_TOOL_SUBMIT'));
	$form1->show();
} else {
	echo "<table class=\"whitebg\" width=\"100%\" align=center><tr><td>\n";
	echo "&gt;&gt;&gt; <a class=\"fontbold font10\" href=\"".ct_pageurl('adminParticipantsBrowse', array('filter'=>'show', 'listorder'=>$http['listorder'] ))."\">".ct('S_ADMIN_FILTER_SHOW')."</a>\n";
	echo "</td></tr></table>\n";
}

if ($r >= 0) {
	ctadm_listparticipants($r, 'adminParticipantsBrowse'); // -> admin.lib
}

?>
