
<?php
//
// PAGE:		adminParticipantsEventsBrowse
// DESC:		Browse all users that booked an event or an product at the conference.
//

ct_requireassistantorconferencechair();
ct_pagepath(array('index','adminUsers'));

ct_load_lib('participation.lib');
ct_load_lib('datetime.lib');
ct_load_class('CTForm');
ct_load_class('CTParticipation');


$session->set_besturl(ct('S_ADMIN_PARTICIPANTS_EVENTS_BROWSE_QUICK'));

$participation = new CTParticipation;

$query="select participants.* from participants, persons";

if (isset($http['form_event']) && $http['form_event']){
	$query.=", participants2events";
}

$where=" where participants.personID=persons.ID and participants.regdate != '0000-00-00 00:00:00' ";
if (isset($http['form_event']) && $http['form_event']){
	$where.=" and participants2events.eventID='".$http['form_event']."' and participants.personID=participants2events.personID and participants2events.number>0";
}
if (!isset($http['form_deleted']) || $http['form_deleted']!="yes") {
	$where .= " and participants.deleted=0";
}

// Search string from navbar
$search     = isset($http['navbar_search'])?$http['navbar_search']:"";
if ($search!="") {
	$where .= " && UPPER(CONCAT(persons.name,'|',persons.firstname,'|',persons.organisation,'|',persons.city,'|',persons.country,'|',persons.email,'|',participants.total,'|',participants.payamount)) LIKE UPPER('%".$search."%')";
}

$order = ' order by persons.name asc, persons.firstname asc';

if (isset($http['listorder'])) {
	switch ($http['listorder']) {
		case 'org':
		$order = ' order by persons.organisation asc, persons.name asc';
		break;
		case 'id':
		$order = ' order by persons.ID asc';
		break;
		case 'name':
		$order = ' order by persons.name asc, persons.firstname asc';
		break;
		case 'country':
		$order = ' order by persons.country asc, persons.name asc';
		break;
		case 'regdate':
		$order = ' order by participants.regdate, persons.name asc';
		break;
		case 'email':
		$order = ' order by persons.email asc';
		break;
	}

}

$query="$query $where $order";

// echo $query;

$res = $db->query($query);

if (!in_http('print') ||  $http['print']!="yes") {
	$events = array_merge(array(array(0, ct('S_ADMIN_PARTICIPANTS_EVENTS_BROWSE_PLEASESELECT')."...&nbsp;&nbsp;&nbsp;")),ct_list_events());
	$eventtypes = array_merge (array(array(0,ct('S_ADMIN_PARTICIPANTS_EVENTS_BROWSE_PLEASESELECTGROUP')."...&nbsp;&nbsp;&nbsp;")), ct_list_eventtypes());
	
	echo "<H1>".ct('S_ADMIN_PARTICIPANTS_EVENTS_BROWSE_CMD')."</H1>\n";
	echo "<p class=\"fontnormal font10\">".ct('S_ADMIN_PARTICIPANTS_EVENTS_BROWSE_HINT')."\n";
	$qry = str_replace("&","&amp;",$_SERVER['QUERY_STRING'])."&amp;print=yes";
	echo " &nbsp;&nbsp;<a target=\"_blank\" class=\"cmda\" href=\"".$_SERVER['SCRIPT_NAME']."?".$qry."\" >".ct('S_CTFOOT_PRINTVIEW')."&nbsp;<img src=\"icons/printer.gif\" alt=\"".ct('S_CTFOOT_PRINTVIEW')."\" border=0 style=\"vertical-align: bottom\"></a>";
	echo "</p>\n\n";

	$form1 = new CTform('adminParticipantsEventsBrowse', 'get');
	$form1->width='100%';
	$form1->align='center';
	$form1->add_hidden(hash2aa(ct_http_array(array()))); // list all http variables with values
	$form1->add_select_autosubmit(ct('S_ADMIN_TOOL_EVENTS_CMD'), 'form_event', $events, array($http['form_event']), false);
#	if (count($eventtypes)>2)
#		$form1->add_select_autosubmit(ct('S_ADMIN_TOOL_EVENTTYPES_CMD'), 'form_eventtype', $eventtypes, array($http['form_eventtype']));
	$form1->add_submit_noscriptonly('cmd_search', ct('S_ADMIN_TOOL_SUBMIT'));
	$form1->show();
}

if (isset($http['form_event']) && $http['form_event']>0 || isset($http['form_eventtype']) && $http['form_eventtype']>0){

	$event=isset($http['form_event'])?$http['form_event']:0;
	$eventtype=isset($http['form_eventtype'])?$http['form_eventtype']:0;
	// Load event data.
	$datemode 	   = "false";
	$pricecategory = 0;
	$texthint      = "";
	$hastext       = false;
	$eventtitle    = "";
	$where = "where 1";
	if (isset($http['form_event']) && $http['form_event']>0)
		$where .= " and ID='".$event."'";
	if (isset($http['form_eventtype']) && $http['form_eventtype']>0) {
		$e = ct_get_events($http['form_eventtype']);
		if (count($e)>0) { // events found?	
			$eIDs = array();
			for ($i=0; $i < count($e); $i++) {
				$eIDs[] = $e[$i]['ID'];
			}
			$where.=" and ID IN (".ct_csv_implode($eIDs).")";
		}
	}

	$r = $db->query("select * from events $where");
	if ($r && ($db->num_rows($r) == 1)) {
		$p = $db->fetch($r);
		$pricecategory = $p['pricecategory'];
		$datemode      = $p['datemode'];
		$hastext	   = $p['hastext'];
		$texthint      = $p[ctlx($p,'texthint')];
		$eventtitle=$p[ctlx($p,'title')];
		if ($p[ctlx($p,'eventdate')]!=''){ $eventinformation=$p[ctlx($p,'eventdate')];}
		if (($p[ctlx($p,'eventdate')]!='') && (($p[ctlx($p,'eventlocation')]!='') || ($p[ctlx($p,'info')]!='' ))){ $eventinformation.='<br>';}
		if ($p[ctlx($p,'eventlocation')]!=''){	$eventinformation.=$p[ctlx($p,'eventlocation')];}
		if ($p[ctlx($p,'eventlocation')]!='' && $p[ctlx($p,'info')]!=''){ $eventinformation.='<br>';}
		if ($p[ctlx($p,'info')]!=''){ $eventinformation.=$p[ctlx($p,'info')];}
	}

	ct_load_lib('navbar.lib');
	$items      = $db->num_rows($res);
	if (!in_http('print') ||  $http['print']!="yes") ct_navbar($page,$items);
	$perpage    = isset($http['navbar_perpage']) && $http['navbar_perpage']!=""?$http['navbar_perpage']:ctconf_get('display_perpage',20);
	$pageno     = isset($http['navbar_page'])?$http['navbar_page']:0; // default is 0
	$maxpage    = intval(($items-1)/($perpage));


	echo "<H3>".$eventtitle."</H3>\n";
	echo '<span class="fontbold font10">'.$eventinformation.'</span><br><br>';

	if ($res >= 0) {
		$page_eventdays = 0;
		$page_eventqty  = 0;
		$eventdays = 0;
		$eventqty  = 0;
		$page_i			= 0;

		if (($res >= 0) && ($db->num_rows($res) > 0)) {
			echo "<table width=\"100%\" cellspacing=0 cellpadding=4 border=0>\n";
			echo "<tr class=\"listheader\">\n";
			echo "<td width=\"3%\" align=\"center\"><span class=\"listheader_label\">".ct('S_USER_COUNT')."</span></td>\n";
			echo "<td width=\"4%\" align=\"center\"><a href=\"".ct_pageurl($page,ct_http_array(array('listorder' => 'id')))."\" class=\"listheader_label\">".ct('S_USER_ID')."</a></td>\n";
			echo "<td width=\"33%\"><a class=\"listheader_label\" href=\"".ct_pageurl($page,ct_http_array(array('listorder' => 'name')))."\">".ct('S_USER_FULLNAME')."</a>\n";
			echo " / <a class=\"fontnormal font10\" href=\"".ct_pageurl($page,ct_http_array(array('listorder' => 'org')))."\">".ct('S_USER_ORGANISATION')."</a><br>";
			echo "<a class=\"fontnormal font8\" href=\"".ct_pageurl($page,ct_http_array(array('listorder' => 'email')))."\">".ct('S_USER_EMAIL')."</a></td>\n";
			echo "<td width=\"30%\"><SPAN CLASS=\"fontbold font10\">".ct('S_USER_ADDRESS')."</span><br>";
			echo "<a class=\"fontnormal font8\" href=\"".ct_pageurl($page,ct_http_array(array('listorder' => 'country')))."\">".ct('S_USER_COUNTRY')."</a></td>\n";
			echo "<td width=\"15%\" align=\"center\"><a class=\"listheader_label\" href=\"".ct_pageurl($page,ct_http_array(array('listorder' => 'regdate')))."\">".ct('S_PARTICIPATE_REGDATE_SHORT')."</a></td>\n";
			echo "<td width=\"5%\" align=\"center\"><span class=\"fontbold font10\">".ct('S_PARTICIPATE_EVENTNUMBER')."</span></td>\n";
			echo "<td width=\"10%\" align=\"center\"><span class=\fontnormal font10\">".ct('S_PARTICIPATE_DATES')."</span></td>\n";
			echo "</tr>\n";
	//		echo "<span class=\"fontlabel font8\">".ct('S_PARTICIPATE_DATES').": </span>";
	//		echo "<span class=\"fontlabel font8\">".ct('S_PARTICIPATE_DATE').": </span>";
	//		echo "<span class=\"fontnormal font8\">".ct('S_PARTICIPATE_EVENTNUMBER').": </span>";

			for ($i=0; $i < $db->num_rows($res); $i++) {
				$row = $db->fetch($res);
				$participation->_init();
				$participation->pdata=$row; 		 // Fill participant data from query output
				$participation->_load_eventdata();

				$eventqty+=$participation->eventdata_number[$event];

				$stay_factor = 1;
				$start = $participation->eventdata_start[$event];
				$end   = $participation->eventdata_end[$event];
				if ($datemode=="perdiem")  $stay_factor = ct_count_days($start,$end);
				if ($datemode=="pernight") $stay_factor = ct_count_nights($start,$end);
				$eventdays+=$stay_factor;
				if (intval($i/$perpage)==$pageno) {
					$page_i++ ;
					//$participation->load_by_id($row['personID']);
					$participation->_load_persondata();  // load the persondata
					$page_eventdays+=$stay_factor;
					$page_eventqty+=$participation->eventdata_number[$event];

					// ---------------------------------

						/* echo "<tr><td colspan=7>";
						echo "<hr style=\"border: 1; width: 100%; color: #000; background-color: #000; height: 0px;\">";
						#echo "<img src=\"".ct_getbaseurl()."icons/spacer.gif\" width=1 height=1>";
						echo "</td></tr>\n"; */

					// ---------------------------------

						$class = ($i%2?"whitebg":"evenrow2");
						echo "<tr class=\"$class\">";

						echo "<td align=center rowspan=2 valign=middle class=\"topline_black\"><span class=\"fontnormal font9\">".($i+1)."</span></td>\n";

						echo "<td align=center rowspan=2 valign=middle class=\"topline_black\"><span class=\"fontbold font10\">".$participation->person->get_id()."</span></td>\n";

						// 3. Column: Name and Mail
						echo "<td align=left valign=top class=\"topline_black\"><span class=\"fontbold font10\">";
						echo "<a href=\"".ct_pageurl('adminParticipantsDetails')."&amp;form_id=".$participation->person->get_id()."\">";
						echo ct_form_encode($participation->person->get_reversename())."</a></span>";
						echo "<br>";
						echo "<span class=\"fontnormal font10\">".$participation->person->get_special('organisation')."</span><br>";
						echo "<span class=\"fontnormal font8\"><a href=\"mailto:".$participation->person->get_special('email')."\">";
						echo $participation->person->get_special('email')."</a></span>";
						echo "</td>\n";

						// 4. Address
						echo "<td align=left valign=top class=\"topline_black\">";
						echo $participation->person->get_special('addr1')."<br>";
						if ($participation->person->get_special('addr2')!="")
							echo $participation->person->get_special('addr2')."<br>";
						ct_load_lib("address.lib");
						echo ct_address_format($participation->person->get_special('country'),$participation->person->get_special('zip'),$participation->person->get_special('state'),$participation->person->get_special('city'));
						echo "<span class=\"fontnormal font8\">".ct_get_country($participation->person->get('country'))."</span>\n";
						echo "</td>\n";

						// 5. Registration Date and status
						$regdate    = ct_date_format($participation->get('regdate'));
						$timediscountID=get_timediscountID($participation->get('regdate'));
						$timediscountTitle=substr(get_timediscount($timediscountID),0,30);
						echo "<td align=\"center\" valign=top class=\"topline_black\">";
						echo "<span class=\"fontnormal font10\">".$regdate."</span><br>";

						echo '<span class="fontnormal font8">('.ct_form_encode($timediscountTitle).")</span><br>\n";
						$status=substr($participation->_get_status($participation->get('status')),0,30);
						echo '<span class="fontbold font8">'.ct_form_encode($status).'</span>';
						echo "</td>\n";

						// 6. Qty
						echo "<td align=center class=\"topline_black\">";
						if ($participation->eventdata_number[$event]==1)
							echo "<span class=\"fontnormal font10\">";
						else
							echo "<span class=\"fontbold font10\">";
						echo $participation->eventdata_number[$event]."&nbsp;</span>";
						echo "</td>\n";

						// 7. Days (and from-to)
						$start = $participation->eventdata_start[$event];
						$end   = $participation->eventdata_end[$event];

						// Nights etc.
						echo "<td align=center class=\"topline_black\">";
						$stay_factor = 1;
						if ($datemode=="perdiem")  $stay_factor = ct_count_days($start,$end);
						if ($datemode=="pernight") $stay_factor = ct_count_nights($start,$end);

						if ($datemode=="pernight") {
						if ($stay_factor==1)
							echo "<span class=\"fontbold font8\">".$stay_factor."&nbsp;".ct(S_PARTICIPATE_NIGHT)."</span><br>";
						else
							echo "<span class=\"fontbold font8\">".$stay_factor."&nbsp;".ct(S_PARTICIPATE_NIGHTS)."</span><br>";
						}
						if ($datemode=="perdiem") {
							if ($stay_factor==1)
								echo "<span class=\"fontbold font8\">".$stay_factor."&nbsp;".ct(S_PARTICIPATE_DAY)."</span><br>";
							else
								echo "<span class=\"fontbold font8\">".$stay_factor."&nbsp;".ct(S_PARTICIPATE_DAYS)."</span><br>";
						}

						// Start - End
						if ($datemode=="selectday") {
							echo "<span class=\"fontbold font8\">";
							echo ct_date_format(ct_timestamp_2_datetime($start));
							echo "</span>";
						}
						if ($datemode=="perdiem" || $datemode=="pernight" || $datemode=="selectspan") {
							echo "<span class=\"fontnormal font8\">";
							echo ct_date_format(ct_timestamp_2_datetime($start));
							echo "</span>&nbsp;-<br>&nbsp;";
							echo "<span class=\"fontnormal font8\">";
							echo ct_date_format(ct_timestamp_2_datetime($end));
							echo "</span>";
						}
						if ($datemode=="false") echo "&nbsp;";

						echo "</td>\n";

						// Second line: Remark of user.
						echo "<tr class=\"$class\" >\n";
						echo "<td colspan=5 >";
						$text = ct_nl2br($participation->eventdata_text[$event]);
						if (!empty($text)){
							echo "<span class=\"fontlabel font8\">".$texthint."</span><br>";
							echo "<span class=\"fontbold font8\">".$text."</span>";
						} else {
							// echo "<span class=\"fontnormal font8\">&nbsp;</span>";
						}

						echo "</td>\n";

						echo "</tr>\n";


					// ---------------------------------
				}
			}
			// Pagesums
			if ($maxpage>0) {
				echo "<tr class=\"dimbg\">\n";
				echo "<td colspan=\"3\"><span class=\"form_label\">".ct('S_ADMIN_PARTICIPANTS_BROWSE_PAGE_SUM1')." $page_i ".ct('S_ADMIN_PARTICIPANTS_BROWSE_PAGE_SUM2')."</span></td>\n";
				echo "<td align=right colspan=2><span class=\"form_label\">".ct('S_PARTICIPATE_PAGESUMS').":</span></td>\n";
				echo "<td align=center><span class=\"form_label\">".$page_eventqty."</span></td>\n";
				echo "<td align=center><span class=\"form_label\">".$page_eventdays."</span></td>\n";
				echo "</tr>\n";
			}
			// Footer with totals
			echo "<tr class=\"darkbg\">\n";
			echo "<td colspan=\"3\"><span class=\"form_label\">".ct('S_ADMIN_PARTICIPANTS_BROWSE_SUM1')." $i ".ct('S_ADMIN_PARTICIPANTS_BROWSE_SUM2')."</span></td>\n";
			echo "<td colspan=\"2\" align=right><span class=\"form_label\">".ct('S_PARTICIPATE_TOTALFEE').":</span></td>\n";
			echo "<td align=center><span class=\"form_label\">".$eventqty."</span></td>\n";
			echo "<td align=center><span class=\"form_label\">".$eventdays."</span></td>\n";
			echo "</tr>\n";

			echo "</table>\n";
		}
	}
} else {
	echo "<H3>".ct('S_ADMIN_PARTICIPANTS_EVENTS_BROWSE_PLEASESELECT')."</H3>\n";
}

?>
