<?php
//
// PAGE:		adminParticipantsPayments
// DESC:		Define payments and manage them
//

ct_requireassistant();
ct_load_class('CTParticipation');
ct_load_class('CTPayment');
ct_load_lib('participation.lib');
ct_load_lib('mail_payments.lib');

ct_pagepath(array('index','adminUsersBrowse','adminParticipantsBrowse'));

//echo "form_personID = :". $http['form_personID']."<br>";
//echo "form_paymentID = :". $http['form_paymentID']."<br>";
$participation = new CTParticipation;

if (!isset($http['form_personID']) || !$http['form_personID']>0) {
	// personID is missing!
	ct_redirect($session->get_besturl());
}

if (!$participation->load_by_id($http['form_personID'])) {
	$session->put_errorbox(ct('S_ERROR_MANAGEPAYMENTS'), ct('S_ERROR_MANAGE_PAYMENTS_DIDNT_ENTER_ALL_DATA'));
	ct_redirect($session->get_besturl());
}

$payment = new CTPayment;
$oldpayment = new CTPayment;

if (isset($http['cmd_payments_cancel'])) {
	$payment->init();
	$http['form_paymentID']="";
}
// Edit payment: Cancel old and create new payment... Usually NOT USED! see CTPayment.
/*
if (isset($http['cmd_payments_save'])) {
	if ($oldpayment->load_by_id($http['form_paymentID'])) {
		$check = $payment->process_form_payment();
		if ($check) {
			mail_payment_cancelled_message($oldpayment,$participation,''); // Send mail "cancelled"
			$http['form_paymentID']="";
			if ($http['form_delete_ccnumber']=='yes' && $participation->get('paymethod')=='cc') {
				$participation->delete_cc_data();
				$participation->persist();
			}
			$payment->persist(); 		// persist and calculate new total
			$participation->reload();
			sleep(1); // wait so the mails will arrive in the right order!
			mail_payment_received_confirmation($payment,$participation,''); // Send confirmation about new value
			$payment->init();
		} else {
			ct_errorbox(ct('S_ERROR_MANAGEPAYMENTS'), ct('S_ERROR_MANAGE_PAYMENTS_DIDNT_ENTER_ALL_DATA'));
		}
	} else {
		ct_errorbox(ct('S_ERROR_MANAGEPAYMENTS'), ct('S_ERROR_MANAGE_PAYMENTS_DIDNT_ENTER_ALL_DATA'));
	}
}
*/
// Create: Save as new payment
if (isset($http['cmd_payments_create'])) {
	$check = $payment->process_form_payment();
	if ($check) {
		$http['form_paymentID']="";
		if ($http['form_delete_ccnumber']=='yes' && $participation->get('paymethod')=='cc') {
			$participation->delete_cc_data();
			$participation->persist();
		}
		$payment->persist(); 		// persist and calculate new total
		$participation->reload();
		// Send message...?
		if (isset($http['form_sendmail']) && $http['form_sendmail']=='yes') {
			// Received if >0, cancelled if <0
			if ($payment->get('payamount')>0)
				mail_payment_received_confirmation($payment,$participation,'');
			else
				mail_payment_cancelled_message($payment,$participation,'');
		}
		// Now delete payment object to show input box again.
		$payment->init();
	} else {
		ct_errorbox(ct('S_ERROR_MANAGEPAYMENTS'), ct('S_ERROR_MANAGE_PAYMENTS_DIDNT_ENTER_VALUE_TRY_AGAIN'));
	}
}
// Delete payment...
if (isset($http['cmd_payments_delete']) || isset($http['cmd_payments_delete_mail'])) {
	if ($oldpayment->load_by_id($http['form_paymentID'])) {
		$payment->load_by_id($http['form_paymentID']);
		$payment->delete();
		$participation->reload();
		$http['form_paymentID']="";
		if (isset($http['cmd_payments_delete_mail']))
			mail_payment_cancelled_message($oldpayment,$participation,'');
	}
	// SAFERPAY: Create a new link with the new amount!
	if ($participation->get('paymethod')=='ccexternal' &&
		$participation->get('total')>0.1 && $participation->get('total')-$participation->get('payamount')>0.1 && // at least 0.10$!
		ct_test_lib('cc_processor_saferpay.lib') ) {
		ct_load_lib('cc_processor_saferpay.lib'); 			// Use payflow link to process credit card data!
		cc_process_registration($participation);
	}
}

$number = array();
for ($i=0;$i < 11; $i++) {
	$number[] = array ($i,$i);
}

echo "<h1>".ct('S_MANAGE_PAYMENTS_TITLE')."</h1>\n";
echo "<p class=\"fontnormal font10\">".ct('S_MANAGE_PAYMENTS_INTRO')."</p>\n";

// Reload particpation data - it may have changed by now.
$participation->load_by_id($http['form_personID']);

$participation->person->show_shortinfo("90%");
$participation->show_participant_payment("90%");
$participation->show_remarks("90%");
$participation->person->show_remarks("90%");

$payment->show_form_payment1(ct_pageurl('adminParticipantsPayments'));

// editing existing payment:
if (isset($http['form_paymentID']) && $http['form_paymentID'] != "" &&  $http['form_paymentID'] >0 ) {
	echo "<H3>".ct('S_MANAGE_PAYMENTS_EDITINTRO')."</h3>\n";
	$payment->load_by_id($http['form_paymentID']);
	$payment->show_form_payment2(ct_pageurl('adminParticipantsPayments'));
}
// new payment
else {
	echo "<H3>".ct('S_MANAGE_PAYMENTS_NEWINTRO')."</H3>\n";
	$payment->show_form_payment2(ct_pageurl('adminParticipantsPayments'),$http['form_personID']);
}

echo "<br>\n<table border=0 cellpadding=3><tr><td class=\"boxmsgTD\">\n";
echo "<span class=\"fontbold font10\"><a href=\"".$session->get_besturl()."\">".ct('S_DONE')."</a></span>\n";
echo "</td></tr></table>\n";

?>
