<?php
//
// PAGE:		adminParticipantsTable
// DESC:		Show an overview (cross-classified table) of all events/products and all participants with prices and sums.
//

ct_requireassistantorconferencechair();
ct_pagepath(array('index','adminUsers'));

ct_load_lib("participation.lib");
ct_load_lib('datetime.lib');

$session->del('db_prices'); // reset prices
$session->del('db_timediscounts'); // reset timediscounts

echo "<h1>".ct('S_ADMIN_PARTICIPANTS_TABLE_CMD')."</h1>\n";
echo "<p class=\"fontnormal font10\">".ct('S_ADMIN_PARTICIPANTS_TABLE_HINT')."</p>\n";

// get all status groups
//
$groups = array(); 		// ID, title,
$groupCount = array(); 	// Sum of Persons
$groupAmount= array();	// Sum of Amounts

$timediscounts= ct_get_timediscounts();

$query = "SELECT * FROM groups order by ID";
$r = $db->query($query);
if ($r && ($db->num_rows($r) > 0)) {
	for ($i=0; $i < $db->num_rows($r); $i++) {
		$t = $db->fetch($r);
		$groups[] = array($t['ID'],$t[ctlx($t,'title')],0,0);
		$groupCount[$i] = 0;
		$groupAmount[$i]= 0;
	}
}

// get all events
//
$events = array(); // ID, title
$query = "SELECT events.ID as ID, events.availability as availability, events.datemode as datemode, events.title as title, events.title2 as title2, events.title3 as title3, events.title4 as title4, events.short as short, eventtypes.negative as eventtype_negativemode FROM events, eventtypes where events.eventtype=eventtypes.ID order by eventtypes.seqorder,events.seqorder";
$r = $db->query($query);
if ($r && ($db->num_rows($r) > 0)) {
	for ($i=0; $i < $db->num_rows($r); $i++) {
		$t = $db->fetch($r);
		$events[] = array($t['ID'],$t[ctlx($t,'title')],$t['short'], $t['datemode'], $t['availability'], $t['eventtype_negativemode']);
	}
}

//create HTML table
//
$row=0;
echo "<P><table cellpadding=2 cellspacing=1 border=0>";
echo "<tr class=\"listheader\"><td bgcolor=\"#F0F0F0\">&nbsp;</td>";
foreach ($groups as $group) {
	echo "<td align=center class=\"fontbold font9\">".strip_tags(stripslashes($group[1]))."</td>";
}
echo "<td align=center class=\"fontbold font9\">".ct('S_ADMIN_PARTICIPANTS_TABLE_COUNT')."</td>";
if (ctconf_get('conferenceNetPrices')==1) {
	echo "<td align=center class=\"fontbold font9\">".ct('S_ADMIN_PARTICIPANTS_TABLE_AMOUNT')." <br>(".ct('S_INVOICE_NET').")</td></tr>\n";
} else {
	echo "<td align=center class=\"fontbold font9\">".ct('S_ADMIN_PARTICIPANTS_TABLE_AMOUNT')."</td></tr>\n";
}
// show details
foreach ($events as $event) {
	$count = 0;
	$amount= 0;
	echo "<tr class=\"".($row%2?"oddrow":"evenrow")."\">\n";
	echo "<td><span class=\"fontbold font9\">".strip_tags(stripslashes($event[2]))."</span><br><span class=\"fontnormal font8\">".strip_tags(stripslashes($event[1]))."</span></td>";
	$col=0;
	foreach ($groups as $group) {
		$num = 0;
		$fee = 0;
		echo "<td align=\"center\" class=\"fontnormal font9\">";
		// echo "$event[0] / $group[0] / $event[5]";
		$query = "SELECT participants2events.number as number, participants2events.start as start, participants2events.end as end, participants.regdate AS regdate, participants.status AS status, events.pricecategory AS pricecategory, participants.paymethod AS paymethod, participants.discount AS discount  FROM participants, participants2events, events WHERE participants.personID=participants2events.personID and participants2events.eventID=events.ID and participants.status=$group[0] and participants2events.eventID=$event[0] and participants.deleted=0 and participants2events.deleted=0 and participants2events.number!=0";
		$r = $db->query($query);
		if ($r && ($db->num_rows($r) > 0)) {
			for ($i=0; $i < $db->num_rows($r); $i++) {
				$t = $db->fetch($r);
				$num += $t['number'];
				// calculate fee
				if ($t['paymethod']<>"free" && $t['number']>0) {
					// how many days / nights?
					$stay_factor = 1;
					if ($event[3]=="perdiem")  $stay_factor = ct_count_days(ct_datetime_2_timestamp($t['start']),ct_datetime_2_timestamp($t['end']));
					if ($event[3]=="pernight") $stay_factor = ct_count_nights(ct_datetime_2_timestamp($t['start']),ct_datetime_2_timestamp($t['end']));
					// the single price is?
					$pricecategory=$t['pricecategory'];
					$status=$t['status'];
					$timediscountID=get_timediscountID($t['regdate'],$timediscounts);
					$gross = ct_get_singlefee($pricecategory,$status,$timediscountID);
					if ($t['discount']!=0)
						$gross = $gross * (1- ($t['discount'] / 100));

					if ($event[5]!="normal" && $gross<0) // negative is used to disable/hide events.
						$fee -= ($gross*$t['number']*$stay_factor);  // use positive instead of negative value
					else
						$fee += ($gross*$t['number']*$stay_factor);
				}
			}
		}
		$count            += $num;
		$amount			  += $fee;
		$groupCount[$col] += $num;
		$groupAmount[$col]+= $fee;
		$col++;
		if ($num<>0) {
			echo "<span class=\"fontbold font9\">$num</span><BR><span class=\"fontnormal font9\">".ct_number_format($fee).ctconf_get('currencySymbol')."</span></td>";
		} else {
			echo "<span class=\"fontgray font9\">$num<BR>".ct_number_format($fee)."</span></td>";
		}
	}
	echo "<td align=center class=\"".($row%2?"oddrow2":"evenrow2")."\">\n";
	echo "<span class=\"fontbold font9\">$count</span>";
	if ($event[4]>0) echo "<br><span class=\"fontnormal font8\">".ct('S_ADMIN_TOOL_EVENTS_MAXAVAILABILITY_SHORT').":&nbsp;".$event[4]."</span>";
	echo "</td>";
	echo "<td align=center class=\"".($row%2?"oddrow2":"evenrow2")."\">\n";
	echo "<span class=\"fontbold font9\">".ct_number_format($amount).ctconf_get('currencySymbol')."</span></td>";
	echo "</tr>";
	$row++;
}
//show count
$i=0;
echo "<tr class=\"evenrow2\"><td class=\"fontbold font9\">".ct('S_ADMIN_PARTICIPANTS_TABLE_COUNT')."</td>";
foreach ($groups as $group) {
	echo "<td align=\"center\" class=\"fontbold font9\">$groupCount[$i]</td>";
	$i++;
}
echo "<td bgcolor=#F0F0F0></td><td bgcolor=#F0F0F0></td>";
echo "</tr>";
//show amounts
$i=0;
$total=0;
echo "<tr class=\"oddrow2\"><td class=\"fontbold font9\">".ct('S_ADMIN_PARTICIPANTS_TABLE_AMOUNT')." (".ct('S_INVOICE_NET').")</td>";
foreach ($groups as $group) {
	echo "<td align=\"center\" class=\"fontbold font9\">".ct_number_format($groupAmount[$i]).ctconf_get('currencySymbol')."</td>";
	$total += $groupAmount[$i];
	$i++;
}
echo "<td bgcolor=#F0F0F0>&nbsp;</td><td align=\"center\"><span class=\"fontbold font9\">".ct_number_format($total).ctconf_get('currencySymbol')."</span></td>";
echo "</tr>";
echo "</table></p>";


?>