<?php
//
// PAGE		adminReviewAssign
// DESC		Assign PC members to a paper (one paper and all PC members are shown)
//

ct_requirechair();
ct_pagepath(array('index', 'adminPapers', 'adminPapersBrowse'));

ct_load_lib('datetime.lib');
ct_load_class('CTForm');
ct_load_class('CTPaper');

// this page is useless without an ID for a paper, so redirect if missing
if (!isset($http['form_id'])) {
	ct_redirect($session->get_besturl());
}

$paper = new CTPaper();
if (!$paper->load_by_id($http['form_id'])) ct_redirect(ct_pageurl('adminPapersBrowse'));
$paper_topics = $paper->get_topics();
$author = new CTPerson();
$author = $paper->get_author();
$coauthors = $paper->get_emails();

// Check if access is allowed for this chair...
if (ctconf_get('chairTrackSelect',false) && $user->is_chair() && !$user->is_admin() && !$user->is_conferenceChair()) {
	if (!$user->has_chair_access($paper->get('contributiontypeID'))) {
		$session->put_errorbox(ct('S_ERROR_ACCESSDENIED'), ct('S_ERROR_ACCESS_ADMINONLY'));
		ct_redirect(ct_pageurl('error'));
	}
}


$didsave=false;
// unassign reviewers
if (in_http('form_cmd','cmd_unassign') && in_http('form_reviewer') && is_array($http['form_reviewer'])) {
	foreach ($http['form_reviewer'] as $reviewer) {
		$r = $db->delete('reviews',"paperID='".$http['form_id']."' and personID='".$reviewer."'");
		$didsave=true;
	}
}
// set as meta-reviewer - user is already assigned as reviewer, only update!
if (in_http('form_cmd','cmd_unassign')) {
	$r = $db->query("UPDATE reviews SET reviewtype='normal' WHERE paperID='".$http['form_id']."'");
	if (in_http('form_metareviewer')) {
		foreach ($http['form_metareviewer'] as $reviewer) {
			$r = $db->query("UPDATE reviews SET reviewtype='meta' WHERE paperID='".$http['form_id']."' and personID='".$reviewer."'");
			$didsave=true;
		}
	}
}

// -------------------------------------------------------------------------

// assign reviewers
if (in_http('form_cmd','cmdassign') && in_http('form_reviewer') && is_array($http['form_reviewer'])) {
	foreach ($http['form_reviewer'] as $reviewer) {
		$r = $db->delete("reviews","paperID='".$http['form_id']."' and personID='".$reviewer."'");
		$r = $db->insert_into('reviews',array('reviewtype'=>'normal','paperID'=>$http['form_id'],'personID'=>$reviewer));
		$didsave=true;
	}
}
// assign meta-reviewers
if (in_http('form_cmd','cmdassign') && in_http('form_metareviewer')) {
	foreach ($http['form_metareviewer'] as $reviewer) {
		$r = $db->delete("reviews", "paperID='".$http['form_id']."' and personID='".$reviewer."'");
		$r = $db->insert_into('reviews',array('reviewtype'=>'meta','paperID'=>$http['form_id'],'personID'=>$reviewer));
		$didsave=true;
	}
}
// set conflicts
if (in_http('form_cmd','cmdassign') && in_http('form_conflict')) {
	foreach ($http['form_conflict'] as $reviewer) {
		$r = $db->replace_into("biddings",array('paperID'=>$http['form_id'],'personID'=>$reviewer,'bidding'=>'-3'));
		$didsave=true;
	}
}
// UNset conflicts
if (in_http('form_cmd','cmdassign') && in_http('form_noconflict')) {
	foreach ($http['form_noconflict'] as $reviewer) {
		$r = $db->delete("biddings", "paperID='".$http['form_id']."' and personID='".$reviewer."'");
		$didsave=true;
	}
}
if ($didsave) ct_infobox(ct('S_INFO_SAVE'), ct('S_INFO_SAVE_SUCCESS'));


// show page -----------------------------------------------------------------
// Header
echo "<H1>".ct('S_REVIEW_ASSIGN')."</H1>\n";
echo "<p class=\"fontnormal font10\">".ct('S_REVIEW_ASSIGN_INTRO')."</p>\n";

// Details of paper to be assigned
echo "<table align=\"center\" width=\"90%\" cellspacing=1 border=0 cellpadding=2 class=\"darkbg\">\n";
echo "<tr><td class=\"tbldialog\" align=left valign=top width=\"70%\"><span class=\"fontlabel font10\">";
echo "<span class=\"fontlabel font10\">".ct('S_PAPER_TYPE').": </span><span class=\"fontnormal font10\">".$paper->_get_contributiontype_title()."</span><br>";
echo ct('S_PAPER_TITLE').": </span>";
echo "<a href=\"".ct_pageurl('adminPapersDetails', array('form_id'=>$paper->get_id()))."\" class=\"fontnormal font10\"><span class=\"fontbold font10\">".$paper->get_special('title')."</span></a>&nbsp;&nbsp;&nbsp;&nbsp;";
if ($paper->get('externalremark') != "") {
	echo ' <a href="'.ct_pageurl('adminPapersDetails', array('form_id'=>$paper->get_id())).'" title="'.substr($paper->get_special('externalremark'),0,512).'" ';
	echo 'ext_title="'.ct('S_PAPER_FORM_EXTERNALREMARK').'" ' ;
	echo 'ext_remark="'.substr($paper->get_special('externalremark'),0,512).'" >' ;
	echo '<img src="icons/remark.png" border=0 alt="Remark"></a>';
}
echo "<br>";
echo "<span class=\"fontlabel font10\">".ct('S_INDEX_PAPER_SUBMITTEDBY').":</span> <a href=\"".ct_pageurl('adminUsersDetails', array('form_id'=>$paper->get('personID')))."\" class=\"fontnormal font10\">".ct_form_encode($author->get_reversename())."</a><BR>";
echo "<span class=\"fontlabel font10\">".ct('S_USER_ORGANISATION').": </span><span class=\"fontbold font10\">";
echo $author->get_special('organisation')."</span><BR>";
echo "<span class=\"fontlabel font10\">".ct('S_PAPER_AUTHOR').": </span><span class=\"fontnormal font10\">".$paper->get_special('author')."</span><br>";
echo "<span class=\"fontlabel font8\">".ct('S_PAPER_FORM_EMAILS').": </span><span class=\"fontnormal font8\">". ct_form_encode(ct_csv_implode($paper->get_emails()))."</span><br>";
echo "<span class=\"fontlabel font10\">".ct('S_PAPER_TOPICS').":</span> ";
echo "<span class=\"fontbold font10\">";
$j=0;
while (list(,$v) = each($paper_topics)) {
	if ($j>0) echo ",";
	echo " ".$v;
	$j++;
}
if ($j == 0) echo "--";

echo "</span>\n";
echo "</td>\n";
echo "<td class=\"whitebg\" align=center valign=middle width=\"10%\"><span class=\"fontbold font20\">".$paper->get_id()."</span></td>";
echo "</tr>\n</table>\n";

echo "<p class=\"fontlabel fontbold  font12\">".ct('S_REVIEW_ASSIGN_ASSIGNEDMEMBERS').":</p>";

$person = new CTPerson();

// -------------------------------------------------

// Show assigned PC members
$qr = $db->query("select r.*, b.bidding as bidding, count(t2p.topicID) as matches from reviews r ".
			     "LEFT JOIN biddings as b ON r.paperID=b.paperID and r.personID=b.personID ".
				 "LEFT JOIN pc2topics as p2t ON r.personID=p2t.personID LEFT JOIN topics2papers as t2p ON t2p.topicID=p2t.topicID and t2p.paperID=".$paper->get_id()." ".
				 "where r.paperID=".$paper->get('ID')." ".
				 "group by r.personID ".
			     "order by r.personID asc");

	     
			     
echo "<form method=\"post\" action=\"".ct_pageurl('adminReviewAssign')."\">\n";
echo "<input type=hidden name=form_cmd value=\"cmd_unassign\">\n";
echo "<input type=hidden name=form_id value=\"".$http['form_id']."\">";
if (isset($http['form_tracks']) && $http['form_tracks']!=0)
	echo "<input type=hidden name='form_tracks' value=\"".$http['form_tracks']."\">\n";
if (isset($http['form_topic']) && $http['form_topic']!='-')
	echo "<input type=hidden name='form_topic' value=\"".$http['form_topic']."\">\n";
	
echo "<table width=\"100%\" align=\"center\">\n";
if ($qr && ($db->num_rows($qr) > 0)) {
	for ($i = 0; $i < $db->num_rows($qr); $i++) {
		$review = $db->fetch($qr);
		$person->load_by_id($review['personID']);
		show_potential_reviewers('unassign',$i,$person,$review,$author,$coauthors,$paper,$paper_topics);
	}
	echo "<tr><td colspan=1 align=left class=\"mediumbg\"><span class='font10 fontbold'>".ct('S_REVIEWER').":&nbsp;".$db->num_rows($qr)."</span></td>";
	echo "<td colspan=2 align=right class=\"mediumbg_gradient\"><input type=\"submit\" class=\"button\" value=\"".ct('S_BUTTON_SAVE')."\"></td></tr>\n";
} else {
	echo "<tr class=\"oddrow_del\"><td><span class=\"fontbold font10\">&nbsp;".ct('S_REVIEW_ASSIGN_NONEYET')."</span></td></tr>\n";
}
echo "</table>\n</form>\n";

// -------------------------------------------------

// Show all PC members...
echo "<p class=\"fontlabel fontbold  font12\">".ct('S_REVIEW_ASSIGN_PCMEMBERS').":</p>";

// Create queries
$tables = 'persons as p';
$where = '';

// get a list of all valid contributiontypes for this user, so only the assigned PC members will be shown...
$assigned_ctypes = array();
if (ctconf_get('pcTrackSelect',false)) { // Shall pcs be assigned to tracks, so only in this case filter by contributiontype
	$assigned_ctypeIDs = $user->get_contributiontypes_as_chair(); 
	$tables = "contributiontypes2pcs as c2p, ".$tables;
	$where.= " AND c2p.personID=p.ID AND c2p.typeID IN ('".implode("', '", $assigned_ctypeIDs)."')";
	$assigned_ctypes = array();
	foreach ($assigned_ctypeIDs as $c) {
		$ctype = ct_get_contributiontypes($c);
		$assigned_ctypes[] = array($ctype['ID'], $ctype[ctlx($ctype,'title')]);
	}
}



// Show filter...
$topics=ct_list_topics();
if (count($assigned_ctypes)>1 && count($topics)>1) {
	$form1 = new CTform('adminReviewAssign', 'get');
	$form1->width='100%';
	$form1->align='center';
	$form1->add_hidden(array(array('form_id',$http['form_id'])));
	if (count($assigned_ctypes)>1) {
		$tracks=array_merge (array(array(0,ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_ALLTYPES'))), $assigned_ctypes);
		$form1->add_select_autosubmit(ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_CONTRIBUTIONTYPE'), 'form_tracks', $tracks, array($http['form_tracks']), false);
	}
	$topics=ct_list_topics();
	if (count($topics)>1) {
		$selecttopics=array_merge (array(array("-",ct('S_ADMIN_FILTER_ALLTOPICS'))), $topics);
		$form1->add_select_autosubmit(ct('S_ADMIN_FILTER_TOPICS'), 'form_topic', $selecttopics, array($http['form_topic']));
	}
	$form1->add_submit_noscriptonly('cmd_search', ct('S_ADMIN_PAPERS_BROWSE_SUBMIT'));
	$form1->show();
}

// Start table output
echo "<form method=\"post\" action=\"".ct_pageurl('adminReviewAssign')."\">\n";
echo "<input type=hidden name=form_cmd value=\"cmdassign\">\n";
echo "<input type=hidden name=form_id value=\"".$http['form_id']."\">";
if (isset($http['form_tracks']) && $http['form_tracks']!=0)
	echo "<input type=hidden name='form_tracks' value=\"".$http['form_tracks']."\">\n";
if (isset($http['form_topic']) && $http['form_topic']!='-')
	echo "<input type=hidden name='form_topic' value=\"".$http['form_topic']."\">\n";
echo "<table width=\"100%\" align=\"center\">\n";



if (ctconf_get('pcTrackSelect',false) && isset($http['form_tracks']) && $http['form_tracks']!=0){
	$where.=' and c2p.typeID=\''.$http['form_tracks'].'\'';
}
if (isset($http['form_topic']) && $http['form_topic']!='' && $http['form_topic']!='-'){
	$tables.=", pc2topics";
	$where.=" and pc2topics.personID=p.ID and pc2topics.topicID='".$http['form_topic']."'";
}


// First list all persons that selected a positive bidding value or gave no statement.
$query = "select b.bidding as bidding, count(t2p.topicID) as matches, p.ID as ID, p.name as name, p.firstname as firstname, p.organisation as organisation, p.status as status, p.email as email FROM $tables ".
		    "LEFT JOIN biddings as b ON p.ID=b.personID AND b.paperID='".$paper->get_id()."' ".
		    "LEFT JOIN pc2topics as p2t ON p.ID=p2t.personID LEFT JOIN topics2papers as t2p ON t2p.topicID=p2t.topicID and t2p.paperID=".$paper->get_id()." ".
			"WHERE p.deleted=0 and (p.status like '%pc%' || p.status like '%reviewer%') and (b.bidding>0 OR b.bidding IS NULL) $where ".
			"GROUP BY p.ID ".
			"order by b.bidding desc, matches desc, p.name asc";
$qr = $db->query($query);
###echo $query;
if ($qr && ($db->num_rows($qr)>0)) {
	for ($i = 0; $i < $db->num_rows($qr); $i++) {
		$pdata = $db->fetch($qr);
		$person->pdata = $pdata;
		show_potential_reviewers('assign',$i,$person,$pdata,$author,$coauthors,$paper,$paper_topics);
	}
}

echo "<tr><td colspan=\"3\" valign=top align=left class=\"form_td_separator\">";
echo "<img src=\"".ct_getbaseurl()."icons/spacer.gif\" width=1 height=1 alt=''>";
echo "</td></tr>\n";

// now show the rest.
$qr = $db->query("select b.bidding as bidding, count(t2p.topicID) as matches, p.ID as ID, p.name as name, p.firstname as firstname, p.organisation as organisation, p.status as status, p.email as email FROM $tables ".
			     "LEFT JOIN biddings as b ON p.ID=b.personID AND b.paperID='".$paper->get_id()."' ".
				 "LEFT JOIN pc2topics as p2t ON p.ID=p2t.personID LEFT JOIN topics2papers as t2p ON t2p.topicID=p2t.topicID and t2p.paperID=".$paper->get_id()." ".
			     "WHERE p.deleted=0 and (p.status like '%pc%' || p.status like '%reviewer%') and b.bidding<=0 $where ".
			     "GROUP BY p.ID ".
			     "order by b.bidding desc, matches desc, p.name asc");


if ($qr && ($db->num_rows($qr)>0)) {
	for ($i = 0; $i < $db->num_rows($qr); $i++) {
		$pdata = $db->fetch($qr);
		$person->pdata = $pdata;
		show_potential_reviewers('assign',$i,$person,$pdata,$author,$coauthors,$paper,$paper_topics);
	}
}

echo "<tr><td colspan=3 align=\"right\" class=\"mediumbg_gradient\"><input type=\"submit\" class=\"button\" value=\"".ct('S_BUTTON_SAVE')."\"></td></tr>\n";
echo "</table>\n</form>\n";


// show reviewer...
function show_potential_reviewers($mode,$i,$person,$pdata,$author,$coauthors,$paper,$paper_topics) {
	global $session;
	$user = $session->get_user();
	if ($i % 2) {
		echo "<tr class=\"oddrow\"><td width=\"65%\">\n";
	} else {
		echo "<tr class=\"evenrow\"><td width=\"65%\">\n";
	}

	// show reviewer type
	if ($person->is_pc())	{ 		  echo "<span class=\"fontnormal font8\">".ct('S_USER_STATUS_PC')."</span><br>\n";	}
	elseif ($person->is_reviewer())	{ echo "<span class=\"fontnormal font8\">".ct('S_USER_STATUS_REVIEWER')."</span><br>\n";	}

	// show reviewer name
	echo "<span ";
	if ($author->get_id()==$person->get_id())
	echo "class=\"fontnegative fontbold font10\">";
	else
	echo "class=\"fontbold font10\">";
	echo ct_form_encode($person->get_reversename())."</span><br>";

	// show organization. Mark if similar to paper's
	echo "<span class=\"fontlabel font10\">".ct('S_USER_ORGANISATION').":</span> ";
	echo "<span ";
	$s = similar_text($author->get('organisation'),$person->get('organisation'));
	$l = max(strlen($author->get('organisation')),strlen($person->get('organisation')));
	if ($l>0) $similarity_pst = $s/$l * 100;
	else $similarity_pst=0;

	if (number_format($similarity_pst, 0) > 66)
	echo "class=\"fontnegative fontbold font10\">";
	elseif (number_format($similarity_pst, 0) > 33)

	echo "class=\"fontnegative font10\">";
	else
	echo "class=\"fontnormal font10\">";
	echo $person->get_special('organisation')."</span><BR>";

	echo "<span class=\"fontlabel font10\">".ct('S_USER_TOPICS').":</span> ";
	$j=0;
	$topics = $person->get_topics();
	while (list(,$v) = each($topics)) {
		if ($j>0) echo ",";
		if (in_array($v, $paper_topics)) echo " <span class=\"fontpositive fontbold font10\"> ".$v."</span>";
		else echo " <span class=\"fontnormal font10\">".$v."</span>";
		$j++;
	}
	if ($j == 0) echo "--";

	echo "<BR>\n";
	echo "<span class=\"fontnormal font8\">".ct('S_USER_EMAIL').": ".$person->get('email')."</span>";

	// if review already downloaded or entered, show dates
	if ($pdata['downloaddate'] > 0)
		echo "<br><span class=\"fontbold font8\">".ct('S_REVIEW_DATE_DOWNLOADED').": ".ct_datetime_format($pdata['downloaddate'])."</span>\n";
	if ($pdata['creationdate'] > 0)
		echo "<BR><span class=\"fontbold font8\">".ct('S_REVIEW_DATE_ENTERED').": ".ct_datetime_format($pdata['creationdate'])."</span>\n";
	elseif ($pdata['lastupdate'] > 0)
		echo "<BR><span class=\"fontbold fontother font8\">".ct('S_REVIEW_DATE_DRAFTENTERED').": ".ct_datetime_format($pdata['lastupdate'])."</span>\n";
	
	echo "</td>\n";

	// 2nd column
	if ($i % 2) {
		echo "<td class=\"oddrow2\"  align=\"center\" width=\"18%\" nowrap=\"nowrap\">\n";
	} else
		echo "<td class=\"evenrow2\"  align=\"center\" width=\"18%\" nowrap=\"nowrap\">\n";

	if ($author->get_id()==$person->get_id() || in_array($person->get('email'),$coauthors) || ($pdata['bidding']!=NULL && $pdata['bidding']<=-2) ) {
		echo "<span class=\"fontnegative fontbold font9\">".$person->get_bidding_text(-2);
		if ($author->get_id()==$person->get_id())
			echo " (".ct('S_USER_STATUS_AUTHOR_SHORT').")";
		elseif (in_array($person->get('email'),$coauthors))
			echo " (".ct('S_USER_STATUS_COAUTHOR_SHORT').")";
		echo "</span><br>\n";

		if ($pdata['bidding'] == -2)
			echo "<span class=\"fontnormal font8\">(".ct('S_BIDDING_CONFLICT_REVIEWER').")</span>";
		elseif ($pdata['bidding'] == -3)
			echo "<span class=\"fontnormal font8\">(".ct('S_BIDDING_CONFLICT_CHAIR').")</span>";
	} else {
		echo "<span class=\"fontnormal font9\">".$person->get_bidding_text($pdata['bidding'])."</span>";
		if (isset($pdata['matches'])) {
			echo '<br><br><span class="fontnormal font8">';
			echo ct('S_BIDDING_MATCHES').": ".$pdata['matches'];
			echo "</span>\n";
		}
	}
	
	echo "<BR>\n";
	show_link_assignPC($person,"<span class=\"fontnormal font8\">".ct('S_REVIEW_PAPERS').": ".$person->get_review_count($person->get_id(),"",0)."</span>");
	
	echo "</td>\n";

	// 3rd column
	if ($mode=='assign') {
		if ($i % 2) {
			echo "<td class=\"oddrow2\"  align=\"right\" width=\"17%\" nowrap=\"nowrap\">\n";
		} else
			echo "<td class=\"evenrow2\"  align=\"right\" width=\"17%\" nowrap=\"nowrap\">\n";
	
		$conflictset="";
	    if ($author->get_id()==$person->get_id() || in_array($person->get('email'),$coauthors)) $conflictset="checked";
	    if (!$person->is_reviewer_for($paper->get_id()) && ($pdata['bidding']>-2 || $pdata['bidding']==NULL)) {
	    	if (ctconf_get('metaReviews','0')) { // Meta-Reviews enabled?
				echo "&nbsp;<span class=\"fontnormal font9\">".ct('S_REVIEW_ASSIGN_ASSIGN_CMD')." <input type=\"checkbox\" class=\"checkboxradio\" name=\"form_reviewer[]\" id=\"ct_form_a_".$person->get('ID')."\" value=\"".$person->get('ID')."\" onClick=\"ct_form_c_".$person->get('ID').".checked=false;ct_form_b_".$person->get('ID').".checked=false;\">&nbsp;</span><BR>";
				echo "&nbsp;<span class=\"fontlabel font9\">".ct('S_REVIEW_ASSIGN_METAREVIEWER')." <input type=\"checkbox\" class=\"checkboxradio\" name=\"form_metareviewer[]\" id=\"ct_form_b_".$person->get('ID')."\" value=\"".$person->get('ID')."\" onClick=\"ct_form_a_".$person->get('ID').".checked=false;ct_form_c_".$person->get('ID').".checked=false\">&nbsp;</span><BR>";
				echo "&nbsp;<span class=\"fontnegative font9\">".ct('S_REVIEW_ASSIGN_SET_CONFLICT')." <input type=\"checkbox\" class=\"checkboxradio\" name=\"form_conflict[]\" id=\"ct_form_c_".$person->get('ID')."\" value=\"".$person->get('ID')."\" onClick=\"ct_form_a_".$person->get('ID').".checked=false;ct_form_b_".$person->get('ID').".checked=false\" $conflictset >&nbsp;</span>";
	    	} else { // no meta-reviews
				echo "&nbsp;<span class=\"fontnormal font9\">".ct('S_REVIEW_ASSIGN_ASSIGN_CMD')." <input type=\"checkbox\" class=\"checkboxradio\" name=\"form_reviewer[]\" id=\"ct_form_a_".$person->get('ID')."\" value=\"".$person->get('ID')."\" onClick=\"ct_form_c_".$person->get('ID').".checked=false\">&nbsp;</span><BR>";
				echo "&nbsp;<span class=\"fontnegative font9\">".ct('S_REVIEW_ASSIGN_SET_CONFLICT')." <input type=\"checkbox\" class=\"checkboxradio\" name=\"form_conflict[]\" id=\"ct_form_c_".$person->get('ID')."\" value=\"".$person->get('ID')."\" onClick=\"ct_form_a_".$person->get('ID').".checked=false\" $conflictset >&nbsp;</span>";
	    	}
		} elseif($pdata['bidding']==-3) {
			echo "&nbsp;<span class=\"fontpositive font9\">".ct('S_REVIEW_ASSIGN_UNSET_CONFLICT')." <input type=\"checkbox\" class=\"checkboxradio\" name=\"form_noconflict[]\" value=\"".$person->get('ID')."\">&nbsp;</span>";
		} else {
			echo "&nbsp;";
		}
		echo "</td>\n";
	} else {
		if ($i % 2)
			echo "<td align=\"right\" class=\"oddrow2\" width=\"15%\"nowrap>";
		else
			echo "<td align=\"right\" class=\"evenrow2\" width=\"15%\"nowrap>";

		$ismetareviewchecked=($pdata['reviewtype']=='meta')?'checked':'';
		// Meta-Reviews enabled?
		if (ctconf_get('metaReviews','0')) { 
			echo "&nbsp;<span class=\"fontlabel font10\">".ct('S_REVIEW_ASSIGN_METAREVIEWER')." <input type=\"checkbox\" class=\"checkboxradio\" name=\"form_metareviewer[]\" id=\"ct_form_x_".$person->get('ID')."\" onClick=\"ct_form_y_".$person->get('ID').".checked=false\" value=\"".$person->get('ID')."\" $ismetareviewchecked >&nbsp;</span><br><br>";
			if (!($pdata['creationdate'] > 0))
				echo "<span class=\"fontbold font10\">&nbsp;".ct('S_REVIEW_ASSIGN_UNASSIGN_CMD')." <input type=\"checkbox\" class=\"checkboxradio\" name=\"form_reviewer[]\" id=\"ct_form_y_".$person->get('ID')."\" onClick=\"ct_form_x_".$person->get('ID').".checked=false\" value=\"".$person->get('ID')."\">&nbsp;";
			elseif ($user->is_admin())
				echo "<span class=\"fontnegative fontbold font10\">&nbsp;".ct('S_REVIEW_ASSIGN_DELETE_CMD')." <input type=\"checkbox\" class=\"checkboxradio\" name=\"form_reviewer[]\" id=\"ct_form_y_".$person->get('ID')."\" onClick=\"ct_form_x_".$person->get('ID').".checked=false\" value=\"".$person->get('ID')."\">&nbsp;";
			echo "</span>";
    	} else {
			if (!($pdata['creationdate'] > 0))
				echo "<span class=\"fontbold font10\">&nbsp;".ct('S_REVIEW_ASSIGN_UNASSIGN_CMD')." <input type=\"checkbox\" class=\"checkboxradio\" name=\"form_reviewer[]\" value=\"".$person->get('ID')."\">&nbsp;";
			elseif ($user->is_admin())
				echo "<span class=\"fontnegative fontbold font10\">&nbsp;".ct('S_REVIEW_ASSIGN_DELETE_CMD')." <input type=\"checkbox\" class=\"checkboxradio\" name=\"form_reviewer[]\" value=\"".$person->get('ID')."\">&nbsp;";
			echo "</span>";
    	}		
		echo "</td>\n";
	}
	
	
	echo "</tr>\n";
}

// Show link to adminReviewAssignPC of this person
function show_link_assignPC($p,$text) {
	global $http;
	// Paramters for assignment page.
	$param = array('form_id' => $p->get('ID'));
	if ($http['form_tracks']!='') $param['form_tracks'] = $http['form_tracks'];
	if ($http['form_topic']!='') $param['form_topic'] = $http['form_topic'];
	echo "<a href=\"".ct_pageurl('adminReviewAssignPC',$param)."\">$text</a><br>";
}

?>