<?php
//
// PAGE		adminReviewAssignPC
// DESC		Assign papers to PC members (one PC members and all papers are shown)
//

ct_requirechair();
ct_pagepath(array('index', 'adminUsers', 'adminUsersPC'));

ct_load_lib('papers.lib');
ct_load_lib('datetime.lib');
ct_load_class('CTForm');
ct_load_class('CTPaper');


// this page is useless without an ID for a paper, so redirect if missing
if (!isset($http['form_id'])) {
	ct_redirect($session->get_besturl());
}

// Load person.
$person = new CTPerson();
if (!$person->load_by_id($http['form_id'])) ct_redirect(ct_pageurl('adminUsersPC'));

// Check if user has access to these contributiontypes.
if (ctconf_get('chairTrackSelect',false) && ctconf_get('pcTrackSelect',false)) {
	$assigned_ctypeIDs = $person->get_contributiontypes_as_pc();
	if (!$user->has_chair_access($assigned_ctypeIDs)) ct_redirect(ct_pageurl('adminUsersPC'));
}

$person_topics=$person->get_topics();


// SAVE assignments and unassignments ----------------------
$didsave=false;

// Unassign papers
if (in_http('form_cmd','cmd_unassign') && in_http('form_paper')) {
	foreach ($http['form_paper'] as $paper) {
		$r = $db->delete("reviews","personID='".$http['form_id']."' and paperID='".$paper."'");
		$didsave=true;
	}
}
// set as meta-reviewer - user is already assigned as reviewer, only update!
if (in_http('form_cmd','cmd_unassign')) {
	$r = $db->query("UPDATE reviews SET reviewtype='normal' WHERE personID='".$http['form_id']."'");
	if (in_http('form_metareviewer')) {
		foreach ($http['form_metareviewer'] as $paper) {
			$r = $db->query("UPDATE reviews SET reviewtype='meta' WHERE personID='".$http['form_id']."' and paperID='".$paper."'");
			$didsave=true;
		}
	}
}



// assign papers
if (in_http('form_cmd','cmdassign') && in_http('form_paper')) {
	foreach ($http['form_paper'] as $paper) {
		$r = $db->insert_into('reviews',array('reviewtype'=>'normal','personID'=>$http['form_id'],'paperID'=>$paper));
		$didsave=true;
	}
}
// assign papers to meta-reviews
if (in_http('form_cmd','cmdassign') && in_http('form_metareviewer')) {
	foreach ($http['form_metareviewer'] as $paper) {
		$r = $db->delete("reviews","personID='".$http['form_id']."' and paperID='".$paper."'");
		$r = $db->insert_into('reviews',array('reviewtype'=>'meta','personID'=>$http['form_id'],'paperID'=>$paper));
		$didsave=true;
	}
}
// Set conflicts
if (in_http('form_cmd','cmdassign') && in_http('form_conflict')) {
	foreach ($http['form_conflict'] as $paper) {
		$r = $db->replace_into('biddings', array('personID'=>$http['form_id'],'paperID'=>$paper,'bidding'=>'-3'));
		$didsave=true;
	}
}
// UNSet conflicts
if (in_http('form_cmd','cmdassign') && in_http('form_noconflict')) {
	foreach ($http['form_noconflict'] as $paper) {
		$r = $db->delete("biddings","personID='".$http['form_id']."' and paperID='".$paper."'");
		$didsave=true;
	}
}
if ($didsave) ct_infobox(ct('S_INFO_SAVE'), ct('S_INFO_SAVE_SUCCESS'));

// -----------------------------------------------

// Head of page
echo "<p class=\"fontbold font14\">".ct('S_REVIEW_ASSIGN_PC')."</p>";
echo "<p class=\"fontnormal font10\">".ct('S_REVIEW_ASSIGN_INTRO_PC')."</p>\n";

//echo "<p class=\"fontlabel fontbold  font12\">".ct('S_REVIEWER').":</p>";

// Show info about person ----------------------
echo "<div align=\"center\">\n";

$person->show_shortinfo("95%");
echo "<table class=\"darkbg\" width=\"95%\" align=\"center\" border=0 cellpadding=3 cellspacing=1>\n";
echo "<tr><td class=\"oddrow\">\n";
echo "<span class=\"fontlabel font10\">".ct('S_USER_TOPICS').":</span> ";
echo "<span class=\"fontbold font10\">";
$j=0;
while (list(,$v) = each($person_topics)) {
	if ($j>0) echo ",";
	echo " ".$v;
	$j++;
}
if ($j == 0) echo "--";
echo "</span><BR>\n";
echo "</td></tr>\n";

echo "<tr><td class=\"evenrow\">\n";
$person->show_status();
echo "</td></tr>\n";

echo "</table>\n";
echo "</div>\n";


// --------------------------------------------------------------------

// Show assigned reviews

$paper = new CTPaper();

echo "<p class=\"fontlabel fontbold  font12\">".ct('S_REVIEW_ASSIGNED_PAPERS').":</p>";

$where="";

// Show only papers that are in the track of this chair
if (ctconf_get('chairTrackSelect',false)) { 
	$assigned_ctypeIDs = $user->get_contributiontypes_as_chair(); 
	$where.= " AND p.contributiontypeID IN ('".implode("', '", $assigned_ctypeIDs)."')";
}

// get a list of all assigned contributiontypes for this chair, so only the assigned papers will be shown...
if ($user->is_admin() || $user->is_conferenceChair()) { // do not consider tracks!
	$qr = $db->query("select r.* from reviews r where r.personID='".$person->get('ID')."' ");
} else {
	$qr = $db->query("select r.* from reviews r, papers p where p.ID=r.paperID and r.personID='".$person->get('ID')."' $where group by r.paperID");
}

echo "<form method=\"post\" action=\"".ct_pageurl('adminReviewAssignPC')."\">\n";
echo "<input type=hidden name=form_cmd value=\"cmd_unassign\">\n";
echo "<input type=hidden name=form_id value=\"".$http['form_id']."\">";
if (isset($http['form_tracks']) && $http['form_tracks']!=0)
	echo "<input type=hidden name='form_tracks' value=\"".$http['form_tracks']."\">\n";
if (isset($http['form_topic']) && $http['form_topic']!='-')
	echo "<input type=hidden name='form_topic' value=\"".$http['form_topic']."\">\n";

// Start output of table with assigned papers.	
echo "<table width=\"100%\" align=\"center\">\n";
if ($qr && ($db->num_rows($qr) > 0)) {
	for ($i = 0; $i < $db->num_rows($qr); $i++) {
		$review = $db->fetch($qr);
		$paper->load_by_id($review['paperID']);
		$author=$paper->get_author();
		if ($i % 2) 
			echo "<tr class=\"oddrow\">\n";
		else 
			echo "<tr class=\"evenrow\">\n";
		
		if ($review['creationdate'] > 0)
			echo "<td class=\"positivebg\" align=center valign=middle width=\"5%\">";
		else
			echo "<td class=\"negativebg\" align=center valign=middle width=\"5%\">";
		echo "<span class=\"fontlight fontbold font14\">".$paper->pdata['ID']."</span></td>\n";

		// Main column...
		echo "<td width=\"68%\">";
		if ($paper->get('withdrawn'))
			echo "<span class=\"fontnegative yellowbg fontbold font12\">".ct('S_PAPER_WITHDRAWN')."</span><br>";
		echo "<span class=\"fontbold font8\">".$paper->_get_contributiontype_title()."</span><br>";
		echo "<span class=\"fontbold font10\"><a href=\"".ct_pageurl('adminPapersDetails')."&amp;form_id=".$paper->get('ID')."\">".$paper->get_special('title')."</a></span> &nbsp;&nbsp;&nbsp;\n";

		// Show author. mark if same as reviewer
		echo "<span class=\"fontlabel font10\">".ct('S_INDEX_PAPER_SUBMITTEDBY').": </span><a href=\"".ct_pageurl('adminUsersDetails', array('form_id'=>$author->get_id()))."\">";
		echo "<span ";
		if ($author->get_id()==$person->get_id())
			echo "class=\"fontnegative fontbold font10\">";
		else
			echo "class=\"fontnormal font10\">";
		echo ct_form_encode($author->get_reversename())."</span></a>&nbsp;";
		// show organization. Mark if similar to reviwers.
		$s = similar_text($author->get('organisation'),$person->get('organisation'));
		$l = max(strlen($author->get('organisation')),strlen($person->get('organisation')));
		if ($l>0) $similarity_pst = $s/$l * 100;
		else $similarity_pst=0;
		echo "<span ";
		if (number_format($similarity_pst, 0) > 66)
			echo "class=\"fontnegative fontbold font10\">";
		elseif (number_format($similarity_pst, 0) > 33)
			echo "class=\"fontnegative font10\">";
		else
			echo "class=\"fontnormal font10\">";
		echo " (".$author->get_special('organisation').")</span><BR>";

		echo "<span class=\"fontlabel font10\">".ct('S_PAPER_AUTHOR').":</span> <span class=\"fontlabel font10\">".$paper->get_special('author')."</span><br>\n";
		if ($review['downloaddate'] > 0)
			echo "<span class=\"fontbold font8\">".ct('S_REVIEW_DATE_DOWNLOADED').": ".ct_datetime_format($review['downloaddate'])."</span><br>\n";
		elseif ($paper->get('originalname')!='')
			echo "<span class=\"fontnegative fontbold font8\">".ct('S_REVIEW_DATE_NODOWNLOAD')."</span><br>\n";
		if ($review['creationdate'] > 0)
			echo "<span class=\"fontbold font8\">".ct('S_REVIEW_DATE_ENTERED').": ".ct_datetime_format($review['creationdate'])."</span><br>\n";
		else
			echo "<span class=\"fontnegative fontbold font8\">".ct('S_REVIEW_DATE_NOTENTERED')."</span><br>\n";
		echo "</td>\n";

		
		// Second column ------------------------------------------------------
		if ($i % 2)
			echo "<td class=\"oddrow2\"  align=\"center\" width=\"10%\">\n";
		else
			echo "<td class=\"evenrow2\"  align=\"center\" width=\"10%\">\n";
		show_link_assign($paper,"<span class=\"fontnormal font8\">".ct('S_REVIEW_COUNT').": ".$person->get_review_count("",$paper->pdata['ID'],0)."</span>");
		echo "</td>\n";
		
		
		// Third column... ----------------------------------------------------
		if ($i % 2) 
			echo "<td align=\"right\" class=\"oddrow2\" width=\"17%\" nowrap>";
		else 
			echo "<td align=\"right\" class=\"evenrow2\" width=\"17%\" nowrap>";

		$ismetareviewchecked=($review['reviewtype']=='meta')?'checked':'';
		// Are meta-reviews enabled?
		if (ctconf_get('metaReviews','0')) { 
			echo "&nbsp;<span class=\"fontlabel font10\">".ct('S_REVIEW_ASSIGN_METAREVIEWER')." <input type=\"checkbox\" class=\"checkboxradio\" name=\"form_metareviewer[]\" id=\"ct_form_x_".$paper->get('ID')."\" onClick=\"ct_form_y_".$paper->get('ID').".checked=false\" value=\"".$paper->get('ID')."\" $ismetareviewchecked >&nbsp;</span><br><br>";
			// if (!($review['creationdate'] > 0) && !($review['downloaddate'] > 0))
			if (!($review['creationdate'] > 0))
				echo "<span class=\"fontbold font10\">&nbsp;".ct('S_REVIEW_ASSIGN_UNASSIGN_CMD')." <input type=\"checkbox\" class=\"checkboxradio\" name=\"form_paper[]\" id=\"ct_form_y_".$paper->get('ID')."\" onClick=\"ct_form_x_".$paper->get('ID').".checked=false\" value=\"".$paper->get('ID')."\">&nbsp;";
			elseif ($user->is_admin())
				echo "<span class=\"fontnegative fontbold font10\">&nbsp;".ct('S_REVIEW_ASSIGN_DELETE_CMD')." <input type=\"checkbox\" class=\"checkboxradio\" name=\"form_paper[]\" id=\"ct_form_y_".$paper->get('ID')."\" onClick=\"ct_form_x_".$paper->get('ID').".checked=false\" value=\"".$paper->get('ID')."\">&nbsp;";
			echo "</span>";
    	} else {
			if (!($review['creationdate'] > 0))
				echo "<span class=\"fontbold font10\">&nbsp;".ct('S_REVIEW_ASSIGN_UNASSIGN_CMD')." <input type=\"checkbox\" class=\"checkboxradio\" name=\"form_paper[]\" value=\"".$paper->get('ID')."\">&nbsp;";
			elseif ($user->is_admin())
				echo "<span class=\"fontnegative fontbold font10\">&nbsp;".ct('S_REVIEW_ASSIGN_DELETE_CMD')." <input type=\"checkbox\" class=\"checkboxradio\" name=\"form_paper[]\" value=\"".$paper->get('ID')."\">&nbsp;";
			echo "</span>";
    	}		
		echo "</td>\n";
		echo "</tr>\n";
	
		
	}
	echo "<tr><td colspan=2 align=left class=\"mediumbg\"><span class='font10 fontbold'>".ct('S_PAPER_REVIEWS').":&nbsp;".$db->num_rows($qr)."</span></td>";
	echo "<td colspan=2 align=right class=\"mediumbg_gradient\"><input type=\"submit\" class=\"button\" value=\"".ct('S_BUTTON_SAVE')."\"></td></tr>\n";
} else {
	echo "<tr class=\"oddrow_del\"><td><span class=\"fontbold font10\">&nbsp;".ct('S_REVIEW_ASSIGN_NONEYET')."</span></td></tr>\n";
}
echo "</table>\n";
echo "</form>\n";

//-------------------------------------------------

// Create queries
$tables = 'papers as p';
$where = '';

echo "<p class=\"fontlabel fontbold  font12\">".ct('S_REVIEW_ASSIGN_PAPERS').":</p>";

// get a list of all assigned contributiontypes for this chair, so only the assigned papers will be shown...
$assigned_ctypes = ct_list_contributiontypes();
if (ctconf_get('chairTrackSelect',false)) { // Shall chairs be assigned to tracks?
	$assigned_ctypeIDs = $user->get_contributiontypes_as_chair(); 
	$where.= " AND p.contributiontypeID IN ('".implode("', '", $assigned_ctypeIDs)."')";
	$assigned_ctypes = array();
	foreach ($assigned_ctypeIDs as $c) {
		$ctype = ct_get_contributiontypes($c);
		$assigned_ctypes[] = array($ctype['ID'], $ctype[ctlx($ctype,'title')]);
	}
}

// Filter by contributiontype and topic
$topics=ct_list_topics();
if (count($assigned_ctypes)>1 && count($topics)>1) {
	$form1 = new CTform('adminReviewAssignPC', 'get');
	$form1->width='100%';
	$form1->align='center';
	$form1->add_hidden(array(array('form_id',$http['form_id'])));
	if (count($assigned_ctypes)>1) {
		$tracks=array_merge (array(array(0,ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_ALLTYPES'))), $assigned_ctypes);
		$form1->add_select_autosubmit(ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_CONTRIBUTIONTYPE'), 'form_tracks', $tracks, array($http['form_tracks']), false);
	}
	if (count($topics)>1) {
		$selecttopics=array_merge (array(array("-",ct('S_ADMIN_FILTER_ALLTOPICS'))), $topics);
		$form1->add_select_autosubmit(ct('S_ADMIN_FILTER_TOPICS'), 'form_topic', $selecttopics, array($http['form_topic']));
	}
	$form1->add_submit_noscriptonly('cmd_search', ct('S_ADMIN_PAPERS_BROWSE_SUBMIT'));
	$form1->show();
	
	ct_vspacer();
}
// ---------------------------------------------------------------

// Start with form for all (unassigned) papers
echo "<div align=\"center\">\n";
echo "<form method=\"post\" action=\"".ct_pageurl('adminReviewAssignPC')."\">\n";
echo "<input type=hidden name=form_cmd value=\"cmdassign\">\n";
echo "<input type=hidden name=form_id value=\"".$http['form_id']."\">";
if (isset($http['form_tracks']) && $http['form_tracks']!=0)
	echo "<input type=hidden name='form_tracks' value=\"".$http['form_tracks']."\">\n";
if (isset($http['form_topic']) && $http['form_topic']!='-')
	echo "<input type=hidden name='form_topic' value=\"".$http['form_topic']."\">\n";


// get valid contribution types for discussion (where reviews are enabled!)
$ctypes = ct_get_contributiontypes();
$valid_ctypes = array();
$valid_ctypeIDs = array();
while (list(,$v) = each($ctypes)) {
	if ($v['do_review']=='true') {
		$valid_ctypes[] = $v;
		$valid_ctypeIDs[] = $v['ID'];
	}
}
$where.= " AND p.contributiontypeID IN ('".implode("', '", $valid_ctypeIDs)."') ";


if (isset($http['form_tracks']) && $http['form_tracks']!=0){
	$where.=' and p.contributiontypeID=\''.$http['form_tracks'].'\'';
}
if (isset($http['form_topic']) && $http['form_topic']!='-'){
	$where.=" and topics2papers.paperID=p.ID and topics2papers.topicID='".$http['form_topic']."'";
	$tables.=", topics2papers";
}
	
	
// How many papers are on the current list?	
$papercount = 0;
$res = $db->query("SELECT count(*) as pcount from $tables where p.withdrawn=0 $where");
if ($res && ($db->num_rows($res)==1)) {
	$row = $db->fetch($res);
	$papercount = $row['pcount'];
}


if  ($papercount==0) {
	// No papers found for assignment...
	echo "<div class=\"fontbold font10\">".ct('S_REVIEW_ASSIGN_NOPAPERS')."</div>";
} else {

	// navigation bar....
	ct_load_lib('navbar_submitting.lib');
	$perpage    = isset($http['navbar_perpage']) && $http['navbar_perpage']!=""?$http['navbar_perpage']:ctconf_get('display_perpage_submitting',100);
	$pageno     = isset($http['navbar_page'])?$http['navbar_page']-1:(isset($http['navbar_lastpage'])?$http['navbar_lastpage']:0); // default is 0
	$maxpage    = intval(($papercount-1)/($perpage));
	$page_item  = 0;
	
	ct_navbar_submitting($papercount,true);
	
	// Start with table...
	echo "<table width=\"100%\">\n";
	
	// Output first part: Wanted papers or papers without bidding
	$qr = $db->query("SELECT count(p2t.topicID) as matches, p.ID as ID, p.personID as personID, p.author as author, p.title as title, p.contributiontypeID as contributiontypeID, p.keywords as keywords, b.bidding as bidding FROM $tables ".
						"LEFT JOIN biddings as b ON p.ID=b.paperID AND b.personID='".$person->get_id()."' ".
						"LEFT JOIN topics2papers as t2p ON p.ID=t2p.paperID LEFT JOIN pc2topics as p2t ON t2p.topicID=p2t.topicID and p2t.personID='".$person->get_id()."' ".
						"WHERE p.withdrawn=0 AND (b.bidding>0 OR b.bidding IS NULL) $where ".
						"GROUP by p.ID ".
						"ORDER BY b.bidding desc, matches desc, p.title asc");
	
	if ($qr && ($db->num_rows($qr)>0)) {
		for ($i = 0; $i < $db->num_rows($qr); $i++) {
			$pdata = $db->fetch($qr);
			if (intval($page_item/$perpage)==$pageno) {
				$paper->pdata = $pdata;
				show_potential_papers($i,$paper,$pdata,$person,$person_topics);
			}
			$page_item++;
		}
	}
	
	echo "<tr><td colspan=\"4\" valign=top align=left class=\"form_td_separator\">";
	echo "<img src=\"".ct_getbaseurl()."icons/spacer.gif\" width=1 height=1>";
	echo "</td></tr>\n";
	
	// Output second part: Unwanted papers
	$qr = $db->query("SELECT count(p2t.topicID) as matches, p.ID as ID, p.personID as personID, p.author as author, p.title as title, p.contributiontypeID as contributiontypeID, p.keywords as keywords, b.bidding as bidding FROM $tables ".
						"LEFT JOIN biddings as b ON p.ID=b.paperID AND b.personID='".$person->get_id()."' ".
						"LEFT JOIN topics2papers as t2p ON p.ID=t2p.paperID LEFT JOIN pc2topics as p2t ON t2p.topicID=p2t.topicID AND p2t.personID='".$person->get_id()."' ".
						"WHERE p.withdrawn=0 AND b.bidding<=0 $where ".
						"GROUP by p.ID ".
						"ORDER BY b.bidding desc, matches desc, p.title asc");
	
	if ($qr && ($db->num_rows($qr)>0)) {
		for ($i = 0; $i < $db->num_rows($qr); $i++) {
			$pdata = $db->fetch($qr);
			if (intval($page_item/$perpage)==$pageno) {
				$paper->pdata = $pdata;
				show_potential_papers($i,$paper,$pdata,$person,$person_topics);
			}
			$page_item++;
		}
	}
	
	echo "</table>\n";

	ct_navbar_submitting($papercount);
	
	echo "</form>\n</div>\n";
}


// show reviewer...
function show_potential_papers($i,$paper,$pdata,$person,$person_topics) {
	global $http;
	$author=$paper->get_author();
	if ($i % 2) {
		echo "<tr class=\"oddrow\">\n";
	} else {
		echo "<tr class=\"evenrow\">\n";
	}
	echo "<td class=\"darkbg\" align=center valign=middle width=\"5%\"><span class=\"fontlight fontbold font14\">";
	echo $paper->pdata['ID']."</span></td>\n";
	
	echo "<td width=\"70%\">";
	echo "<span class=\"fontbold font8\">".$paper->_get_contributiontype_title()."</span><br>";
	echo "<span class=\"fontbold font9\"><a href=\"".ct_pageurl('adminPapersDetails')."&amp;form_id=".$paper->get('ID')."\">".$paper->get_special('title')."</a></span><br>";

	// Show author. mark if same as reviewer
	echo "<span class=\"fontlabel font9\">".ct('S_INDEX_PAPER_SUBMITTEDBY').": </span><a href=\"".ct_pageurl('adminUsersDetails', array('form_id'=>$author->get_id()))."\">";
	echo "<span ";
	if ($author->get_id()==$person->get_id())
	echo "class=\"fontnegative fontbold font9\">";
	else
	echo "class=\"fontnormal font9\">";
	echo ct_form_encode($author->get_reversename())."</span></a>&nbsp;";
	// show organization. Mark if similar to reviwers.
	echo "<span ";
	$s = similar_text($author->get('organisation'),$person->get('organisation'));
	$l = max(strlen($author->get('organisation')),strlen($person->get('organisation')));
	if ($l>0) $similarity_pst = $s/$l * 100;
	else $similarity_pst=0;
	if (number_format($similarity_pst, 0) > 66)
	echo "class=\"fontnegative fontbold font9\">";
	elseif (number_format($similarity_pst, 0) > 33)
	echo "class=\"fontnegative font9\">";
	else
	echo "class=\"fontnormal font9\">";
	echo " (".$author->get_special('organisation').")</span><BR>";

	echo "<span class=\"fontlabel font8\">".ct('S_PAPER_AUTHOR').":</span> <span class=\"fontnormal font8\">".$paper->get_special('author')."</span><BR>\n";
	echo "<span class=\"fontlabel font8\">".ct('S_PAPER_FORM_EMAILS').":</span>";

	#echo "<span class=\"fontnormal font8\">".$author->get_special('email').'; '.ct_csv_implode($paper->get_emails())."</span><BR>\n";
	$domain = array_pop($t = explode("@",$person->get_special('email')));  
	$d = array_pop($t = explode("@",$author->get_special('email')));  
	if ($domain==$d)
		echo " <span class=\"fontnegative fontbold font8\"> ".$author->get_special('email')."</span>";
	else
		echo " <span class=\"fontnormal font8\">".$author->get_special('email')."</span>";
	
	$emails = $paper->get_emails();
	while (list(,$v) = each($emails)) {
		$v = ct_form_encode($v);
		$d = array_pop($t = explode("@",$v)); 
		if ($domain==$d)
			echo "<span class=\"fontnormal font8\">, </span><span class=\"fontnegative fontbold font8\">".$v."</span>";
		else
			echo "<span class=\"fontnormal font8\">, ".$v."</span>";
		$j++;
	}
	echo "<br>\n";
	
	echo "<span class=\"fontlabel font8\">".ct('S_PAPER_TOPICS').":</span> ";
	$j=0;
	$topics = $paper->get_topics();
	while (list(,$v) = each($topics)) {
		if ($j>0) echo ",";
		if (in_array($v, $person_topics))
			echo " <span class=\"fontpositive fontbold font8\"> ".$v."</span>";
		else
			echo " <span class=\"fontnormal font8\">".$v."</span>";
		$j++;
	}
	if ($j == 0) echo "--";

	echo "</td>\n";

	
	// Second column
	if ($i % 2)
		echo "<td class=\"oddrow2\"  align=\"center\" width=\"13%\" nowrap=\"nowrap\">\n";
	else
		echo "<td class=\"evenrow2\"  align=\"center\" width=\"13%\" nowrap=\"nowrap\">\n";

	$coauthors = $paper->get_emails();
	if ($author->get_id()==$person->get_id() || in_array($person->get('email'),$coauthors) || ($pdata['bidding']!=NULL && $pdata['bidding']<=-2) ) {
		echo "<span class=\"fontnegative fontbold font9\">".$person->get_bidding_text(-2);
		if ($author->get_id()==$person->get_id())
			echo " (".ct('S_USER_STATUS_AUTHOR_SHORT').")";
		elseif (in_array($person->get('email'),$coauthors))
			echo " (".ct('S_USER_STATUS_COAUTHOR_SHORT').")";
		echo "</span><br>\n";

		if ($pdata['bidding'] == -2)
			echo "<span class=\"fontnormal font8\">(".ct('S_BIDDING_CONFLICT_REVIEWER').")</span><br>";
		elseif ($pdata['bidding'] == -3)
			echo "<span class=\"fontnormal font8\">(".ct('S_BIDDING_CONFLICT_CHAIR').")</span><br>";
	} else {
		echo "<span class=\"fontnormal font9\">".$person->get_bidding_text($pdata['bidding'])."</span>";
		if (isset($pdata['matches'])) {
			echo '<br><span class="fontnormal font8">';
			echo ct('S_BIDDING_MATCHES').": ".$pdata['matches'];
			echo "</span><br>\n";
		}
	}
	echo "<br>\n";
	show_link_assign($paper,"<span class=\"fontnormal font8\">".ct('S_REVIEW_COUNT').": ".$person->get_review_count("",$paper->pdata['ID'],0)."</span>");
	
	echo "</td>\n";

	
	// Third column
	if ($i % 2)
		echo "<td class=\"oddrow2\" align=\"right\" width=\"17%\" nowrap=\"nowrap\">\n";
	else
		echo "<td class=\"evenrow2\" align=\"right\" width=\"17%\" nowrap=\"nowrap\">\n";

	$conflictset="";
    if ($author->get_id()==$person->get_id() || in_array($person->get('email'),$coauthors)) $conflictset="checked";
    if (!$paper->is_reviewed_by($http['form_id']) && ($pdata['bidding']>-2 || $pdata['bidding']==NULL)) {
    	if (ctconf_get('metaReviews','0')) { // Meta-Reviews enabled?
			echo "&nbsp;<span class=\"fontnormal font9\">".ct('S_REVIEW_ASSIGN_ASSIGN_CMD')." <input type=\"checkbox\" class=\"checkboxradio\" name=\"form_paper[]\" id=\"ct_form_a_".$paper->get('ID')."\" value=\"".$paper->get('ID')."\" onClick=\"ct_form_c_".$paper->get('ID').".checked=false;ct_form_b_".$paper->get('ID').".checked=false;\">&nbsp;</span><BR>";
			echo "&nbsp;<span class=\"fontlabel font9\">".ct('S_REVIEW_ASSIGN_METAREVIEWER')." <input type=\"checkbox\" class=\"checkboxradio\" name=\"form_metareviewer[]\" id=\"ct_form_b_".$paper->get('ID')."\" value=\"".$paper->get('ID')."\" onClick=\"ct_form_a_".$paper->get('ID').".checked=false;ct_form_c_".$paper->get('ID').".checked=false\">&nbsp;</span><BR>";
			echo "&nbsp;<span class=\"fontnegative font9\">".ct('S_REVIEW_ASSIGN_SET_CONFLICT')." <input type=\"checkbox\" class=\"checkboxradio\" name=\"form_conflict[]\" id=\"ct_form_c_".$paper->get('ID')."\" value=\"".$paper->get('ID')."\" onClick=\"ct_form_a_".$paper->get('ID').".checked=false;ct_form_b_".$paper->get('ID').".checked=false\" $conflictset >&nbsp;</span>";
    	} else { // no meta-reviews
			echo "&nbsp;<span class=\"fontnormal font9\">".ct('S_REVIEW_ASSIGN_ASSIGN_CMD')." <input type=\"checkbox\" class=\"checkboxradio\" name=\"form_paper[]\" id=\"ct_form_a_".$paper->get('ID')."\" value=\"".$paper->get('ID')."\" onClick=\"ct_form_c_".$paper->get('ID').".checked=false\">&nbsp;</span><BR>";
			echo "&nbsp;<span class=\"fontnegative font9\">".ct('S_REVIEW_ASSIGN_SET_CONFLICT')." <input type=\"checkbox\" class=\"checkboxradio\" name=\"form_conflict[]\" id=\"ct_form_c_".$paper->get('ID')."\" value=\"".$paper->get('ID')."\" onClick=\"ct_form_a_".$paper->get('ID').".checked=false\" $conflictset >&nbsp;</span>";
    	}
	} elseif($pdata['bidding']==-3) {
		echo "&nbsp;<span class=\"fontpositive font9\">".ct('S_REVIEW_ASSIGN_UNSET_CONFLICT')." <input type=\"checkbox\" class=\"checkboxradio\" name=\"form_noconflict[]\" value=\"".$paper->get('ID')."\">&nbsp;</span>";
	} else {
		echo "&nbsp;";
	}
	
	echo "</td></tr>\n";
}

// Show link to adminReviewAssignPC of this person
function show_link_assign($p,$text) {
	global $http;
	// Paramters for assignment page.
	$param = array('form_id' => $p->get('ID'));
	if ($http['form_tracks']!='0') $param['form_tracks'] = $http['form_tracks'];
	if ($http['form_topic']!='-') $param['form_topic'] = $http['form_topic'];
	echo "<a href=\"".ct_pageurl('adminReviewAssign',$param)."\">$text</a><br>";
}

?>
