<?php
//
// PAGE:		adminSessionsBrowse
// DESC:		This page shows all sessions for printout etc.
//

ct_requirechair();
ct_pagepath(array('index','adminPapers'));

ct_pagepath(array('index'));
ct_load_lib('sessions.lib');
ct_load_lib('papers.lib');
ct_load_lib('datetime.lib');
ct_load_class('CTPaper');
ct_load_class('CTPerson');

$session->set_besturl(ct('S_ADMIN_SESSIONS_BROWSE_QUICK'));

// If any track is not numbered correctly, renumber all
$unnumbered_papers = 0;

$r= $db->query("SELECT ID, max(numberInTrack) as maxno, count(ID) as count FROM papers WHERE withdrawn=0 AND track!=0 GROUP BY track");
if ($r && $db->num_rows($r) > 0) {
	$num = $db->num_rows($r);
	for ($i = 0; $i < $num; $i++) {
		$row = $db->fetch($r);
		if ((int)$row['count']!=(int)$row['maxno']) $unnumbered_papers = 1;
		#echo $row['ID'].": ".$row['count']."=".$row['maxno']." ".$unnumbered_papers."<br>";
	}
}

// If save changes, if there were any...
if (in_http("cmd_action","set") and in_http("cmd_acceptance") and ($http["cmd_acceptance"]>0 or $http["cmd_acceptance"]<-1) and in_http("form_paperID")) {
	$db->update("papers","ID='".$http['form_paperID']."'",array('acceptstatus'=>$http['cmd_acceptance']));
}
if (in_http("cmd_action","set") and in_http("cmd_track") and in_http("form_paperID")) {
	$db->update("papers","ID='".$http['form_paperID']."'",array('track'=>$http['cmd_track'],'numberInTrack'=>'99999'));
}
if (in_http("cmd_action","set") and in_http("cmd_numberInTrack") and in_http("form_paperID")) {
	$db->update("papers","ID='".$http['form_paperID']."'",array('numberInTrack'=>($http['cmd_numberInTrack']+0.5)));
}

// Renumber presentations in tracks...
if ($unnumbered_papers==1 || in_http("cmd_action","set")) {
	create_numberInTrack(); // Renumber all tracks!
}

// Basic variables
$paper  = new CTPaper();
$page = $http['page'];
$width = 640; // 640 is Fine for printouts

// Filter condition
$where = 'where 1 ';
$where2 = '';

if (isset($http['form_room']) && $http['form_room']!=0){
	$where.=" and s.roomID='".$http['form_room']."'";
	$where2.=" and s.roomID='".$http['form_room']."'";
}
if (isset($http['form_date']) && $http['form_date']!=""){
	$timestamp = ct_datetime_2_timestamp($http['form_date']." 00:00:00");
	$start     = ct_timestamp_2_datetime($timestamp);
	$end       = ct_timestamp_2_datetime($timestamp + 86400);
	$where.=" and s.starttime>='".$start."' and s.endtime<'".$end."'";
	$where2.=" and s.starttime>='".$start."' and s.endtime<'".$end."'";
}

if (isset($http['form_session']) && $http['form_session']!="-" && $http['form_session']>0 ){
	$where.=" and s.ID='".$http['form_session']."'";
	$where2.=" and p.track='".$http['form_session']."'";
	$http['presentations']='show';
}
/*
if (isset($http['cmd_tracks']) && $http['cmd_tracks']!=0){
	$where2.=" and p.contributiontypeID=".$http['cmd_tracks'];
}
if (isset($http['form_status']) && $http['form_status']!="-" && $http['form_status']>-5 && $http['form_status']<5 ){
	$where2.=" and p.acceptstatus='".$http['form_status']."'";
}
*/

// Show list of options
if (!in_http('print') || $http['print']!="yes") {
	echo "<h1>".ct('S_ADMIN_SESSIONS_BROWSE_TITLE')."</h1>";
	echo "<p class=\"fontnormal font10\">".ct('S_ADMIN_SESSIONS_BROWSE_INTRO')."</p>";

	echo "<table align=center cellspacing=0 cellpadding=4 border=1>";
	echo "<tr>";

	echo "<td align=center class=\"lightbg\">";
	if (in_http('editMode','on')) {
		echo "<a class=\"fontbold font8\" href=\"".ct_pageurl($page,ct_http_array(array('editMode' => 'off')))."\" >".ct('S_SESSIONS_BROWSE_EDITMODE_OFF')."</a>";
	} else {
		echo "<a class=\"fontbold font8\" href=\"".ct_pageurl($page,ct_http_array(array('editMode' => 'on')))."\" >".ct('S_SESSIONS_BROWSE_EDITMODE_ON')."</a>";
	}
	echo "</td>\n";

	echo "<td align=center class=\"lightbg\">";
	if (isset($http['form_session']) && $http['form_session']!="-" && $http['form_session']>0 ){
		echo "<span class=\"fontgray fontbold font8\" >".ct('S_SESSIONS_BROWSE_HIDE_PRESENTATIONS')."</span>";
	} else {
		if (in_http('presentations','show')) {
			echo "<a class=\"fontbold font8\" href=\"".ct_pageurl($page,ct_http_array(array('presentations' => 'hide')))."\" >".ct('S_SESSIONS_BROWSE_HIDE_PRESENTATIONS')."</a>";
		} else {
			echo "<a class=\"fontbold font8\" href=\"".ct_pageurl($page,ct_http_array(array('presentations' => 'show')))."\" >".ct('S_SESSIONS_BROWSE_SHOW_PRESENTATIONS')."</a>";
		}
	}
	echo "</td>\n";

	if (in_http('presentations','show') || (isset($http['form_session']) && $http['form_session']!="-" && $http['form_session']>0) ) {
		echo "<td align=center class=\"lightbg\">";
		if (in_http('unassigned_presentations','show')) {
			echo "<a class=\"fontbold font8\" href=\"".ct_pageurl($page,ct_http_array(array('unassigned_presentations' => 'hide')))."\" >".ct('S_SESSIONS_BROWSE_HIDE_UNASSIGNED_PRESENTATIONS')."</a>";
		} else {
			echo "<a class=\"fontbold font8\" href=\"".ct_pageurl($page,ct_http_array(array('unassigned_presentations' => 'show')))."\" >".ct('S_SESSIONS_BROWSE_SHOW_UNASSIGNED_PRESENTATIONS')."</a>";
		}
		echo "</td>\n";
	}

	if (in_http('presentations','show')) { // && (isset($http['form_session']) && $http['form_session']!="-" && $http['form_session']>0) ) {
		echo "<td align=center class=\"lightbg\">";
		if (in_http('abstracts','show')) {
			echo "<a class=\"fontbold font8\" href=\"".ct_pageurl($page,ct_http_array(array('abstracts' => 'hide')))."\" >".ct('S_SESSIONS_BROWSE_HIDE_ABSTRACTS')."</a>";
		} else {
			echo "<a class=\"fontbold font8\" href=\"".ct_pageurl($page,ct_http_array(array('abstracts' => 'show')))."\" >".ct('S_SESSIONS_BROWSE_SHOW_ABSTRACTS')."</a>";
		}
		echo "</td>\n";
	}

	if (in_http('presentations','show')) {
		echo "<td align=center class=\"lightbg\">";
		if (in_http('metadata','show')) {
			echo "<a class=\"fontbold font8\" href=\"".ct_pageurl($page,ct_http_array(array('metadata' => 'hide')))."\" >".ct('S_SESSIONS_BROWSE_HIDE_METADATA')."</a>";
		} else {
			echo "<a class=\"fontbold font8\" href=\"".ct_pageurl($page,ct_http_array(array('metadata' => 'show')))."\" >".ct('S_SESSIONS_BROWSE_SHOW_METADATA')."</a>";
		}
		echo "</td>\n";
	}

	echo "<td align=center class=\"lightbg\">";
	echo "<a class=\"fontbold font8\" target=\"_blank\" href=\"".ct_pageurl($page,ct_http_array(array('print' => 'yes')))."\" >".ct('S_CTFOOT_PRINTVIEW')."&nbsp;<img src=\"icons/printer.gif\" alt=\"".ct('S_CTFOOT_PRINTVIEW')."\" border=0 style=\"vertical-align: bottom\"></a>";
	echo "</td>\n";
	echo "</tr>";
	echo "</table>\n\n";

	ct_vspacer('8');

	// ------------
}

// Show overview only in not-print mode or if no session was selected, yet.
if (!in_http('print') ||  $http['print']!="yes" || !in_http('form_session')) {
	$q = "select s.*, ".
		" p.title as title1, p.gender as gender1, p.name as name1, p.firstname as firstname1, p.organisation as organisation1, p.country as country1, ".
		#" p2.title as title2, p2.gender as gender2, p2.name as name2, p2.firstname as firstname2, p2.organisation as organisation2, p2.country as country2, ".
		" COUNT(pa.ID) as countpapers".
	    " FROM sessions AS s ".
	    " LEFT JOIN persons AS p ON s.chairID=p.ID".
	    #" LEFT JOIN persons AS p2 ON s.chair2ID=p2.ID ".
	    " LEFT JOIN papers as pa ON s.ID=pa.track $where GROUP BY s.ID ORDER BY s.starttime, s.shorttitle, s.title "; // s.roomID,
	#echo "$q<br>\n";
	$s = $db->query($q);
	$num = $db->num_rows($s);
	if ($num > 0) {
		echo "<table  width=\"$width\" align=\"center\" cellspacing=1 border=0 cellpadding=2 class=\"blackbg\">";
		echo "<tr><td colspan=2 valign=top align=center class=\"whitebg\">\n";
		echo '<a class="fontbold font14" href="'.ct_pageurl($page).'">'.ct('S_SESSIONS_BROWSE_OVERVIEW').'</a><br>';
		echo "</td></tr>\n";

		if (!in_http('form_session')){
			$lastdate='';
			for ($i = 0; $i < $num; $i++) {
				$row = $db->fetch($s);
				if ($lastdate != ct_date_format($row['starttime'])) {
					$form_date=date("Y-m-d",ct_datetime_2_timestamp($row['starttime']));
					echo "<tr><td colspan=2 valign=top align=left class=\"listheader\">\n";
		  			echo '<a class="fontbold font12" href="'.ct_pageurl($page, ct_http_array(array('form_date'=>$form_date, 'form_room'=>'','form_session'=>''))).'">';
					echo ct('S_SESSIONS_BROWSE_DATE').': '.ct_get_dow($row['starttime']).', '.ct_date_format($row['starttime'])."</a>\n";
					echo "</td></tr>\n";
					$lastdate = ct_date_format($row['starttime']);
				}

				echo '<tr><td class="lightbg" align=center valign="middle" width="20%">';
				echo '<span class="fontbold font10">';
				echo ct_time_format($row['starttime']);
				if ($row['endtime']>0 && $row['starttime']!=$row['endtime']) {
					echo ' - ';
					echo ct_time_format($row['endtime']);
				}
				echo '</span></td>';

				echo '<td rowspan="2" class="whitebg" align=left valign=top>';
				echo get_session_header_small($page, $row, true, in_http('editMode','on'));
				echo "</td></tr>\n";

				// Room in extra row on left.
				echo '<tr><td class="oddrow" align=center valign="middle" width="20%">';
				if ($row['roomID']!="" && $row['roomID']!=0) {
		  			echo '<a class="fontbold font10" href="'.ct_pageurl($page ,ct_http_array(array('form_room'=>$row['roomID'], 'form_session'=>'', 'form_date'=>''))).'">';
		  			echo ct_get_session_room($row['roomID']).'</a>';
					if (in_http('editMode','on') && $row['roomID']>0)
		  				echo '<br><a class="fontnormal font8" target="editRoom" href="'.ct_pageurl('adminToolSessionRooms',array('form_room'=>$row['roomID'], 'cmd_session_rooms_edit'=>'')).'">('.ct('S_SESSIONS_BROWSE_EDIT_ROOM').')</a>';
				} else {
					echo "&nbsp;\n";
				}
				echo "</td></tr>\n";

			}
		}
		echo "</table>\n";
	}
} // Hide for printout.

ct_vspacer('16');

// Show presentations / contribtions to this session...
if ((in_http('form_session') && $http['form_session']!='') || (in_http('presentations') && $http['presentations']=='show')) {

	// Print view?
	if (in_http('print') &&  $http['print']=="yes")
		echo "<table  width=\"$width\" align=\"center\" cellspacing=1 border=0 cellpadding=2 class=\"whitebg\">";
	else
		echo "<table  width=\"$width\" align=\"center\" cellspacing=1 border=0 cellpadding=2 class=\"whitebg table_blackborder1px\">";

	if (isset($http['form_session']) && $http['form_session']!="-" && $http['form_session']>0 ){
		echo "<tr><td valign=top align=left class=\"form_td_separator_gradient\">\n";
		echo "<span class=\"form_separator_label\">".ct('S_ADMIN_PAPERS_RESULTS_SESSION')."</span>\n";
		echo "</td></tr>\n";

		echo get_session_header($http['form_session'], in_http('editMode','on'));

	}

	// Show presentations...
	// ------------
	$q = "select p.* FROM papers AS p, sessions AS s ";
	$q .= "WHERE p.withdrawn=0 AND p.track=s.ID $where2 GROUP by p.ID ";
	$q .= "ORDER BY s.starttime, s.shorttitle, s.title, p.numberInTrack, p.title";
	$r= $db->query($q);
	# echo "$q<br>\n";

	if ($r && $db->num_rows($r) > 0) {
		echo "<tr><td valign=top align=left class=\"form_td_separator_gradient\">\n";
		echo "<span class=\"form_separator_label\">".ct('S_SESSIONS_BROWSE_PRESENTATIONS')."</span>\n";
		echo "</td></tr>\n";
		echo "<tr><td class=\"whitebg topline_printonly\" align=left valign=top>";

		#show_session_presentations($r,(in_http('metadata') && $http['metadata']=='show'),(in_http('abstracts') && $http['abstracts']=='show'),(in_http('downloads') && $http['downloads']=='show'));
		show_edit_sessions($r,in_http('metadata','show'),in_http('abstracts','show'),in_http('downloads','show'));

		echo "</td></tr>\n";

	} else {
		echo "<tr><td class=\"whitebg\" align=left valign=top>";
		echo '<span class="fontnegative fontbold font10">'.ct('S_SESSIONS_BROWSE_NOCONTRIBUTIONS').'</span>';
		echo "</td></tr>\n";
	}
	// Show unassigned presentations?
	if (in_http('unassigned_presentations','show')) {
		$q = "select p.* FROM papers AS p ";
		$q .= "WHERE p.withdrawn=0 && p.track=0 && (p.acceptstatus>0 || p.acceptstatus<-1) ";
		$q .= "ORDER BY p.title";
		$r= $db->query($q);
		# echo "$q<br>\n";
		if ($r && $db->num_rows($r) > 0) {
			echo "<tr><td valign=top align=left class=\"form_td_separator_gradient\">\n";
			echo "<span class=\"form_separator_label\">".ct('S_SESSIONS_BROWSE_PRESENTATIONS_UNASSIGNED')."</span>\n";
			echo "</td></tr>\n";
			echo "<tr><td class=\"whitebg topline_printonly\" align=left valign=top>";

			#show_session_presentations($r,(in_http('metadata') && $http['metadata']=='show'),(in_http('abstracts') && $http['abstracts']=='show'),(in_http('downloads') && $http['downloads']=='show'));
			show_edit_sessions($r,in_http('metadata','show'),in_http('abstracts','show'),in_http('downloads','show'));

			echo "</td></tr>\n";
		}
	}

	echo "</table>\n";
}

echo "<br />\n";


/**
 * Show all presentations in the resultset.
 *
 * @param resultset $result resultset with the presentation to be shown.
 * @param boolean $metadata show metadata of the presentations?
 * @param boolean $abstracts show abstracts of the presentations?
 * @param boolean $downloads show downloads?
 */
function show_edit_sessions($result,$metadata=false,$abstracts=false,$downloads=false) {
	global $http, $db;
	$paper  = new CTPaper();
	$sessions=array_merge(array(array('0'=>0,'1'=>'----')),ct_list_sessions('',true));

	// Open table for edit mode.
	if (in_http('editMode','on')) {
		echo "<table border=0 cellpadding=3 cellspacing=0 width='100%'>";
	}

	$num = $db->num_rows($result);
	$lastsession=0;
	$maxnumberInTrack=1;
	for ($i = 0; $i < $num; $i++) {
		$row = $db->fetch($result);
		#$paper->load_by_id($row['ID']);
		$paper->pdata = $row;

		$ctype = $paper->_get_contributiontype();

		// get details about session
		if ($paper->get('track')!=$lastsession) {
			$lastsession=$paper->get('track');
			$maxnumberInTrack=get_max_numberInTrack($paper->get('track'));
			$sess = ct_get_sessions($paper->get('track'));

			if (!in_http('form_session') || $http['form_session']=='') {
				// Open left column for edit mode.
				if (in_http('editMode','on')) {
					echo "<tr class='lightbg'>\n";
					echo "<td colspan='2' valign='top'>\n";
				} else {
					echo "<div class='lightbg' style='padding:3px; spacing:0; border:0;'>\n";
				}
				echo "<p class='font10 fontbold'>";
				if ($sess[ctlx($sess,'title')]!='')
					echo $sess['shorttitle'].": ".$sess[ctlx($row,'title')].'</p>';
				else // If no longtitle found show only shorttitle...
					echo $sess['shorttitle'].'</p>';
				echo '<p><span class="fontlabel font8">'.ct('S_SESSIONS_BROWSE_TIME').": </span>";
				echo '<span class="font8">';
				echo ct_get_dow($sess['starttime']).', ';
				echo ct_date_format($sess['starttime']);
				echo  ': ';
				echo ct_time_format($sess['starttime']);
				if ($sess['starttime']>0 && $sess['endtime']!=$sess['starttime'])
					echo ' - '.ct_time_format($sess['endtime']).'</span></p>';

				// Close left column for edit mode.
				if (in_http('editMode','on')) {
					echo "</td></tr>\n";
				} else {
					echo "</div>\n";
				}
			}
		}

		// If edit mode is on, show select boxes...
		if (in_http('editMode','on')) {
			echo "<tr>\n";
			// left column for edit select boxes
			echo "<td class='topline_black' valign='top' width='15%'>\n";
			echo "<form action=\"".ct_pageurl($http['page'])."\" method=post>\n";
			echo "<input type=hidden name='cmd_action' value='set'>\n";
			echo "<input type=hidden name='form_paperID' value=\"".$paper->get_id()."\">\n";
			$fields = ct_http_array(array('cmd_action'=>'','form_paperID'=>'','cmd_track'=>'','cmd_numberInTrack'=>''));
			foreach ($fields as $f => $g) if ($g) echo "<input type=hidden name=\"$f\" value=\"$g\">\n";

			echo "<select size=1 class=\"optionsmall\" name=\"cmd_track\" onChange=\"this.form.submit();\">\n";
			foreach ($sessions as $s) {
				$attr="optionsmall";
				if ($paper->get('track')==$s['0']) $attr .= " fontbold";
				echo "<option class=\"$attr\" value=\"".$s['0']."\" ".($paper->get('track')==$s['0'] ? "selected" : "").">&nbsp;".$s['1']."&nbsp;</option>\n";
			}
			echo "</select><br>\n";

			if ($paper->get('track')!=0) {
				echo "<select size=1 class=\"optionsmall\" name=\"cmd_numberInTrack\" onChange=\"this.form.submit();\">\n";
				if ($paper->get('numberInTrack')!=1) echo "<option class=\"optionsmall\" value=\"0\">&nbsp;At beginning&nbsp;</option>\n";
				for ($n=1;$n<=$maxnumberInTrack;$n++) {
					$attr="optionsmall";
					if ($paper->get('numberInTrack')==$n) $attr .= " fontbold";
					if ($paper->get('numberInTrack')!=($n+1)) echo "<option class=\"$attr\" value=\"".$n."\" ".($paper->get('numberInTrack')==$n ? "selected" : "").">&nbsp;".($paper->get('numberInTrack')!=$n ? "After " : "").$n."&nbsp;</option>\n";
				}
				echo "</select><br>\n";
			} else {
				echo "<select size=1 class=\"optionsmall\" name=\"cmd_acceptance\" onChange=\"this.form.submit();\">";
				foreach (ct_list_accessstates() as $g){
					$attr="class=\"optionsmall\"";
					if ($g[0]==0)  $attr = "class=\"optionsmall lightbg fontgray disabled\" readonly";
					if ($g[0]==-1) $attr = "class=\"optionsmall lightbg fontgray disabled\" readonly";
					if ($g[0]==$paper->get('acceptstatus')) $attr = "class=\"optionsmall fontbold";
					echo "<option $attr value=\"".$g[0]."\" ".($paper->get('acceptstatus')==$g[0] ? "selected" : "").">".$g[1]."</option>\n";
				}
				echo "</select>\n";
			}
			echo "</form>\n";
			echo "</td>";

			// right Column for edit mode: Show info about this presentation
			echo "<td class='topline_black' valign='top' width='85%'>\n";
		} else {
			if (!in_http('print') || $http['print']!="yes") {
				echo "<div class='topline_black' style='padding:3px; spacing:0;'>\n";
			} else {
				echo "<div>\n";
			}
		}

		if (in_http('editMode','on')) {
			echo '<a class="fontnormal font8" href="'.ct_pageurl('editPaper',array('form_id'=>$paper->get_id())).'">('.ct('S_SESSIONS_BROWSE_EDIT_PAPER').')</a><br>';
		}

		// Show short form of session
		if ($paper->get('track')!=0) {
			echo '<span class="paper_session">';
			echo stripslashes($sess['shorttitle']);
			echo ": ";
			echo (int)$paper->get('numberInTrack'); // remove decimals
			echo '</span>';
		}

		// Get correct paper class name
		$classname = $paper->get_paperClass();
		ct_load_class($classname);
		eval('$paperclass = new '.$classname.'();');
		$paperclass = ct_type_cast($paper,$classname);
		// Show formatted details about presentation
		$paperclass->show_formatted($metadata,$abstracts && $sess['show_abstracts']=='true');

		// Close right column for edit mode.
		if (in_http('editMode','on')) {
			echo "</td></tr>";
		} else {
			if (!in_http('print') || $http['print']!="yes") {
				echo "</div>\n";
			} else {
				echo "&nbsp;<br>\n\n";
			}
		}

	}
	// Close table for edit mode.
	if (in_http('editMode','on')) {
		echo "</table>\n\n\n";
	}
}

?>
