<?php
//
// PAGE:		adminToolContributionTypes
// DESC:		Define different contribution types like papers, short papers, posters, workshops etc.
//

ct_requireadmin();
ct_pagepath(array('index','adminTool'));

ct_load_class('CTForm');
ct_load_class('CTPaper');
ct_load_lib('papers.lib');
ct_load_lib('datetime.lib');

$session->del('db_contributiontypes'); // reset contributiontypes...

// delete contributiontypes in $session so it will be reloaded
$session->del('contributiontypetitle' );
$session->del('contributiontypeactive');

$form_errors=array();
if (isset($http['cmd_contributiontypes_save']) || isset($http['cmd_contributiontypes_create'])) {
	if ($http['form_title']=="") $form_errors[]="form_title";
	if ($http['form_has_extratext']!='false' && $http['form_extratext_title']=='') $form_errors[]="form_extratext_title";
	#if ($http['form_has_extratext']!='false' && $http['form_extratext_info']=='') $form_errors[]="form_extratext_info";
	if ($http['form_has_extraoption']!='false' && $http['form_extraoption_info']=='') $form_errors[]="form_extraoption_info";
	$http['form_upload_filetype_A']= ct_csv_implode(ct_csv_explode(strtolower($http['form_upload_filetype_A'])));
	$http['form_upload_filetype_B']= ct_csv_implode(ct_csv_explode(strtolower($http['form_upload_filetype_B'])));
	$http['form_upload_filetype_C']= ct_csv_implode(ct_csv_explode(strtolower($http['form_upload_filetype_C'])));
	set_datetime_if_enabled('deadline', 		'2020-12-31 23:59:59');
	set_datetime_if_enabled('deadline_upload', 	'2005-01-01 00:00:00');
	set_datetime_if_enabled('deadline_final', 	'2020-12-31 23:59:59');
	set_datetime_if_enabled('deadline_review', 	'2020-12-31 23:59:59');
	set_datetime_if_enabled('deadline_results', '2005-01-01 00:00:00');

	$http_values = ct_create_hash_read_http(array('title?lang','shorttitle','email_chair','info?lang',
												  'has_abstract','abstract_maxlen',
												  'has_organisations?boolean','has_bibliography?boolean','has_keywords?boolean','has_studentcontribution?boolean',
												  'has_topics',
												  'has_extratext','extratext_title?lang','extratext_info?lang',
												  'has_extraoption','extraoption_info?lang',
    											  'deadline?datetime','deadline_upload?datetime','deadline_final?datetime','deadline_review?datetime','deadline_results?datetime',
    											  'upload',
    											  'upload_accessible_A','upload_accessible_B','upload_accessible_C',
    											  'upload_filetype_A','upload_filetype_B','upload_filetype_C',
												  'upload_info_A?lang','upload_info_B?lang','upload_info_C?lang',
												  'upload_final',
												  'upload_final_info_A?lang','upload_final_info_B?lang','upload_final_info_C?lang',
												  'active?boolean',
												  'review_anonymous?boolean',
												  'do_bidding?boolean','do_review?boolean','do_discussion?boolean','review_details_to_author?boolean',
												  'review_classname','paper_classname'));
}

if (isset($http['cmd_contributiontypes_save']) && $http['form_ID']!="" && count($form_errors)==0) {
	$db->replace_into('contributiontypes', array_merge(array('ID'=>$http['form_ID']), $http_values));
} elseif (isset($http['cmd_contributiontypes_create'])  && count($form_errors)==0) {
	$db->insert_into('contributiontypes', array_merge(array('ID'=>0), $http_values));
} elseif (isset($http['cmd_contributiontypes_delete']) && $http['form_ID']!="") {
	if (ct_papers_exist("contributiontypeID=".$http['form_ID'])) ct_errorbox(ct('S_ERROR_EDITPAPERDATA'),ct('S_ERROR_EDITPAPERDATA_NODELETE'));
	else $db->delete("contributiontypes","id='".$http['form_ID']."'");
} elseif (ct_papers_exist()) {
	ct_warningbox(ct('S_ERROR_EDITPAPERDATA'),ct('S_ERROR_EDITPAPERDATA_PAPERS_EXIST'));
}

$paper = new CTPaper;

echo "<h1>".ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_TITLE')."</h1>\n";
echo "<p class=\"fontnormal font10\">".ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_INTRO')."</p>\n";

$form1 = new CTform(ct_pageurl('adminToolContributionTypes'), 'post');
$form1->width='80%';
$form1->align='center';
$form1->add_select(ct('S_PAPER_FORM_CONTRIBUTIONTYPE'), 'form_ID', 6, $paper->_list_types(), array(), false);
$form1->add_submit('cmd_contributiontypes_delete', ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_DELETECMD'));
$form1->add_submit('cmd_contributiontypes_edit', ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_EDITCMD'));
$form1->add_submit('cmd_contributiontypes_copy', ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_COPYCMD'));
$form1->show();


$form2 = new CTForm(ct_pageurl('adminToolContributionTypes'), 'post', $form_errors);
$form2->width='100%';
$form2->align='center';
$form2->formname='contributiontypes';
$form2->warningmessage=true;

if (ctconf_get('demomode')) $form2->demomode=true;

if (isset($http['cmd_contributiontypes_edit']) && isset($http['form_ID']) && $http['form_ID'] != "") {
	// Load values from DB
	$r = $db->query("select * from contributiontypes where ID='".$http['form_ID']."'");
	if ($r && ($db->num_rows($r) > 0)) {
		$contributiontype = $db->fetch($r);
	}
} elseif (isset($http['cmd_contributiontypes_copy']) && isset($http['form_ID']) && $http['form_ID'] != "") {
	// Load values from DB
	$r = $db->query("select * from contributiontypes where ID='".$http['form_ID']."'");
	if ($r && ($db->num_rows($r) > 0)) {
		$contributiontype = $db->fetch($r);
	}
	$contributiontype['ID']='';
} elseif (count($form_errors)>0) {
	ct_errorbox(ct('S_ERROR_EDITPARTICIPATIONDATA'),ct('S_ERROR_EDITPARTICIPATIONDATA_DATAERROR'));
   	$contributiontype=ct_form_array_convert($http);
   	$contributiontype['has_organisations']=($http['form_has_organisations']==1?'true':'false');
   	$contributiontype['has_bibliography']=($http['form_has_bibliography']==1?'true':'false');
   	$contributiontype['has_keywords']=($http['form_has_keywords']==1?'true':'false');
   	$contributiontype['has_studentcontribution']=($http['form_has_studentcontribution']==1?'true':'false');
   	$contributiontype['active']=($http['form_active']==1?'true':'false');
   	$contributiontype['do_bidding']=($http['form_do_bidding']==1?'true':'false');
   	$contributiontype['do_review']=($http['form_do_review']==1?'true':'false');
   	$contributiontype['do_discussion']=($http['form_do_discussion']==1?'true':'false');
   	$contributiontype['review_details_to_author']=($http['form_review_details_to_author']==1?'true':'false');
   	$contributiontype['review_anonymous']=($http['form_review_anonymous']==1?'true':'false');
} else {
	// new contributiontype:
	// Set default values
	$contributiontype['title']=$contributiontype['title2']=$contributiontype['title3']=$contributiontype['title4']="";
	$contributiontype['shorttitle']="";
	$contributiontype['email_chair']=ctconf_get('conferenceContactEmail');
	$contributiontype['info']=$contributiontype['info2']=$contributiontype['info3']=$contributiontype['info4']="";
	$contributiontype['has_abstract']='true';
	$contributiontype['abstract_maxlen']='0';
	$contributiontype['has_organisations']='false';
	$contributiontype['has_bibliography']='false';
	$contributiontype['has_keywords']='true';
	$contributiontype['has_topics']='true';
	$contributiontype['has_studentcontribution']='false';
	$contributiontype['has_extratext']='false';
	$contributiontype['extratext_title']=$contributiontype['extratext_title2']=$contributiontype['extratext_title3']=$contributiontype['extratext_title4']="";
	$contributiontype['extratext_info']=$contributiontype['extratext_info2']=$contributiontype['extratext_info3']=$contributiontype['extratext_info4']="";
	$contributiontype['has_extraoption']='false';
	$contributiontype['extraoption_info']=$contributiontype['extraoption_info2']=$contributiontype['extraoption_info3']=$contributiontype['extraoption_info4']="";
	$contributiontype['deadline']       = "2020-12-31 23:59:59";
	$contributiontype['deadline_upload']= "2005-01-01 00:00:00";
	$contributiontype['upload']=1;
	$contributiontype['upload_info_A']=$contributiontype['upload_info_A2']=$contributiontype['upload_info_A3']=$contributiontype['upload_info_A4']="";
	$contributiontype['upload_info_B']=$contributiontype['upload_info_B2']=$contributiontype['upload_info_B3']=$contributiontype['upload_info_B4']="";
	$contributiontype['upload_info_C']=$contributiontype['upload_info_C2']=$contributiontype['upload_info_C3']=$contributiontype['upload_info_C4']="";
	$contributiontype['upload_filetype_A']=$contributiontype['upload_filetype_B']=$contributiontype['upload_filetype_C']=ctconf_get('uploadFileTypes');
	$contributiontype['upload_accessible_A']=$contributiontype['upload_accessible_B']=$contributiontype['upload_accessible_C']='true';
	$contributiontype['deadline_final'] = "2020-12-31 23:59:59";
	$contributiontype['deadline_review'] = "2020-12-31 23:59:59";
	$contributiontype['deadline_results'] = "2005-01-01 00:00:00";
	$contributiontype['upload_final']=1;
	$contributiontype['upload_final_info_A']=$contributiontype['upload_final_info_A2']=$contributiontype['upload_final_info_A3']=$contributiontype['upload_final_info_A4']="";
	$contributiontype['upload_final_info_B']=$contributiontype['upload_final_info_B2']=$contributiontype['upload_final_info_B3']=$contributiontype['upload_final_info_B4']="";
	$contributiontype['upload_final_info_C']=$contributiontype['upload_final_info_C2']=$contributiontype['upload_final_info_C3']=$contributiontype['upload_final_info_C4']="";
	$contributiontype['active']='true';
	$contributiontype['review_anonymous']='true';
	$contributiontype['do_bidding']='true';
	$contributiontype['do_review']='true';
	$contributiontype['do_discussion']='true';
	$contributiontype['review_details_to_author']='true';
	$contributiontype['has_studentcontribution']='false';
	$contributiontype['paper_classname']='Default';
	$contributiontype['review_classname']='Default_Form';
}

$abstractlengths = array();
for($i=-3000;$i<-1000;$i=$i+100) 	$abstractlengths[] = array($i,(-$i).' '.ct('S_FORM_WORDS'));
for($i=-1000;$i<=-50;$i=$i+50) 		$abstractlengths[] = array($i,(-$i).' '.ct('S_FORM_WORDS'));
$abstractlengths[] = array('0',ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_ABSTRACT_UNLIMITED'));
for($i=100;$i<3000;$i=$i+100) 		$abstractlengths[] = array($i,$i.' '.ct('S_FORM_CHARACTERS'));
for($i=3000;$i<=10000;$i=$i+500) 	$abstractlengths[] = array($i,$i.' '.ct('S_FORM_CHARACTERS'));

if (isset($contributiontype['ID']) && $contributiontype['ID'] != "") {
	echo "<p class=\"fontnormal font10\">".ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_EDITINTRO')."</p>\n";
	$form2->add_hidden(array(array('form_ID', $contributiontype['ID'])));
	$form2->add_label(ct('S_ID'), $contributiontype['ID']);
	$form2->add_submit('cmd_contributiontypes_save', ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_SAVECMD'));
	$form2->add_submit('cmd_contributiontypes_cancel', ct('S_BUTTON_CANCEL'));
} else {
	// new contributiontype:
	echo "<p class=\"fontnormal font10\">".ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_NEWINTRO')."</p>\n";
	$form2->add_submit('cmd_contributiontypes_create', ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_CREATECMD'));
	$form2->add_submit('cmd_contributiontypes_cancel', ct('S_BUTTON_CANCEL'));
}

$form2->add_text_lang(ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_CONTRIBUTIONTYPE'),'form_title', $contributiontype['title'], $contributiontype['title2'], $contributiontype['title3'], $contributiontype['title4'], 50, 255);
$form2->add_text(ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_SHORTTITLE'),'form_shorttitle', $contributiontype['shorttitle'], 10, 32);
$form2->add_text(ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_EMAILCHAIR'),'form_email_chair', $contributiontype['email_chair'], 40, 255);
$form2->add_textarea_lang(ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_INFO'),'form_info',$contributiontype['info'],$contributiontype['info2'],$contributiontype['info3'],$contributiontype['info4'], 50,3);
$form2->add_separator(ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_SUBMISSION'));
$form2->add_select(ct('S_PAPER_FORM_ABSTRACT'), 'form_has_abstract', 1, array(array('true',ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_HASABSTRACT_YES')), array('false',ct('S_NO')), array('plaintext',ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_HASABSTRACT_PLAINTEXT')), array('html',ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_HASABSTRACT_WYSIWYG'))), array($contributiontype['has_abstract']), false, '<br>'.ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_HASABSTRACT'));
$form2->add_select(ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_ABSTRACT_MAXLEN'), 'form_abstract_maxlen', 1, $abstractlengths, array($contributiontype['abstract_maxlen']), false);
$form2->add_check(ct('S_PAPER_FORM_ORGANISATION'),array(array('form_has_organisations','1',ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_HASORGANISATIONS'),(($contributiontype['has_organisations']=='true')?1:0))));
$form2->add_check(ct('S_PAPER_FORM_BIBLIOGRAPHY'),array(array('form_has_bibliography','1',ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_HASBIBLIOGRAPHY'),(($contributiontype['has_bibliography']=='true')?1:0))));
$form2->add_check(ct('S_PAPER_FORM_KEYWORDS'),array(array('form_has_keywords','1',ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_HASKEYWORDS'),(($contributiontype['has_keywords']=='true')?1:0))));
$form2->add_check(ct('S_PAPER_FORM_STUDENTPAPER'),array(array('form_has_studentcontribution','1',ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_HASSTUDENTCONTRIBUTION'),(($contributiontype['has_studentcontribution']=='true')?1:0))));
$form2->add_select(ct('S_PAPER_FORM_TOPICS'), 'form_has_topics', 1, array(array('true',ct('S_YES')), array('false',ct('S_NO')), array('1',ct('S_PAPER_FORM_TOPICS_MAX',array('1'))), array('2',ct('S_PAPER_FORM_TOPICS_MAX',array('2'))), array('3',ct('S_PAPER_FORM_TOPICS_MAX',array('3'))), array('4',ct('S_PAPER_FORM_TOPICS_MAX',array('4'))), array('5',ct('S_PAPER_FORM_TOPICS_MAX',array('5'))) ), array($contributiontype['has_topics']), false, '<br>'.ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_HASTOPICS'));
$form2->add_spacer();
$form2->add_select(ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_HASEXTRATEXT'), 'form_has_extratext', 1, array(array('false',ct('S_NO')),array('true',ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_OPTIONAL')),array('required',ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_REQUIRED'))), array($contributiontype['has_extratext']), false, ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_HASEXTRATEXT'));
$form2->add_text_lang(ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_EXTRATEXTTITLE'),'form_extratext_title', $contributiontype['extratext_title'], $contributiontype['extratext_title2'], $contributiontype['extratext_title3'], $contributiontype['extratext_title4'], 50, 255);
$form2->add_textarea_lang(ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_EXTRATEXTINFO'),'form_extratext_info', $contributiontype['extratext_info'], $contributiontype['extratext_info2'], $contributiontype['extratext_info3'], $contributiontype['extratext_info4'], 50, 2);
$form2->add_spacer();
$form2->add_select(ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_HASEXTRAOPTION'), 'form_has_extraoption', 1, array(array('false',ct('S_NO')),array('true',ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_OPTIONAL')),array('required',ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_REQUIRED'))), array($contributiontype['has_extraoption']), false, ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_HASEXTRAOPTION').'<br>'.ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_EXTRAOPTION_HINT'));
$form2->add_text_lang(ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_EXTRAOPTIONINFO'),'form_extraoption_info', $contributiontype['extraoption_info'], $contributiontype['extraoption_info2'], $contributiontype['extraoption_info3'], $contributiontype['extraoption_info4'], 50, 255);
$form2->add_separator(ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_DEADLINES'));
$form2->add_label('',ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_DEADLINES_HINT',array(ct_pageurl('adminToolPhases'))));
$form2->add_checkbox_datetime(ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_DEADLINE'),'form_deadline', is_deadline_enabled($contributiontype['deadline']), ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_DEADLINE_ENABLED'), ct_explode_datetime($contributiontype['deadline'] ), ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_DEADLINE_INFO').'<br><i>'.ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_DEADLINE_GLOBAL',array(ct_datetime_format_timezone(ct_get_phase_end('submission')))).'</i>');
$form2->add_checkbox_datetime(ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_DEADLINE_UPLOAD'),'form_deadline_upload', is_deadline_enabled($contributiontype['deadline_upload']), ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_DEADLINE_ENABLED'), ct_explode_datetime($contributiontype['deadline_upload'] ), ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_DEADLINE_UPLOAD_INFO'));
$form2->add_checkbox_datetime(ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_DEADLINE_REVIEW'),'form_deadline_review', is_deadline_enabled($contributiontype['deadline_review']), ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_DEADLINE_ENABLED'), ct_explode_datetime($contributiontype['deadline_review'] ) , ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_DEADLINE_REVIEW_INFO').'<br><i>'.ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_DEADLINE_GLOBAL',array(ct_datetime_format_timezone(ct_get_phase_end('reviewing')))).'</i>');
$form2->add_checkbox_datetime(ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_DEADLINE_RESULTS'),'form_deadline_results', is_deadline_enabled($contributiontype['deadline_results']), ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_DEADLINE_ENABLED'), ct_explode_datetime($contributiontype['deadline_results'] ) , ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_DEADLINE_RESULTS_INFO').'<br><i>'.ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_DEADLINE_GLOBAL',array(ct_datetime_format_timezone(ct_get_phase_start('reviewresults')))).'</i>');
$form2->add_checkbox_datetime(ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_DEADLINE_FINAL'),'form_deadline_final', is_deadline_enabled($contributiontype['deadline_final']), ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_DEADLINE_ENABLED'), ct_explode_datetime($contributiontype['deadline_final'] ) , ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_DEADLINE_FINAL_INFO').'<br><i>'.ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_DEADLINE_GLOBAL',array(ct_datetime_format_timezone(ct_get_phase_end('finalupload')))).'</i>');
$form2->add_separator(ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_UPLOAD'));
$form2->add_select(ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_UPLOADS'), 'form_upload', 1, array(array('0','0'), array('1','1'), array('2','2'), array('3','3') ), array($contributiontype['upload']), false);
$form2->add_text_lang(ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_UPLOADS_INFO',array('1')),'form_upload_info_A', $contributiontype['upload_info_A'],$contributiontype['upload_info_A2'],$contributiontype['upload_info_A3'],$contributiontype['upload_info_A4'], 50, 255);
$form2->add_text_lang(ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_UPLOADS_INFO',array('2')),'form_upload_info_B', $contributiontype['upload_info_B'],$contributiontype['upload_info_B2'],$contributiontype['upload_info_B3'],$contributiontype['upload_info_B4'], 50, 255);
$form2->add_text_lang(ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_UPLOADS_INFO',array('3')),'form_upload_info_C', $contributiontype['upload_info_C'],$contributiontype['upload_info_C2'],$contributiontype['upload_info_C3'],$contributiontype['upload_info_C4'], 50, 255);
$form2->add_subseparator(ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_UPLOAD_FINAL'));
$form2->add_select(ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_UPLOADS_FINAL'), 'form_upload_final', 1, array(array('0','0'), array('1','1'), array('2','2'), array('3','3')), array($contributiontype['upload_final']), false);
$form2->add_text_lang(ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_UPLOADS_INFO',array('1')),'form_upload_final_info_A', $contributiontype['upload_final_info_A'],$contributiontype['upload_final_info_A2'],$contributiontype['upload_final_info_A3'],$contributiontype['upload_final_info_A4'], 50, 255);
$form2->add_text_lang(ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_UPLOADS_INFO',array('2')),'form_upload_final_info_B', $contributiontype['upload_final_info_B'],$contributiontype['upload_final_info_B2'],$contributiontype['upload_final_info_B3'],$contributiontype['upload_final_info_B4'], 50, 255);
$form2->add_text_lang(ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_UPLOADS_INFO',array('3')),'form_upload_final_info_C', $contributiontype['upload_final_info_C'],$contributiontype['upload_final_info_C2'],$contributiontype['upload_final_info_C3'],$contributiontype['upload_final_info_C4'], 50, 255);
$form2->add_subseparator(ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_UPLOAD_FILETYPES'));
$form2->add_text(ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_UPLOAD_FILETYPE',array('1')),'form_upload_filetype_A', $contributiontype['upload_filetype_A'], 40, 255, false, '<br>'.ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_UPLOAD_FILETYPE_HINT', array(ctconf_get('uploadFileTypes'))).'<br>'.ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_REUSE_HINT'));
$form2->add_text(ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_UPLOAD_FILETYPE',array('2')),'form_upload_filetype_B', $contributiontype['upload_filetype_B'], 40, 255, false, '<br>'.ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_UPLOAD_FILETYPE_HINT', array(ctconf_get('uploadFileTypes'))).'<br>'.ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_REUSE_HINT'));
$form2->add_text(ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_UPLOAD_FILETYPE',array('3')),'form_upload_filetype_C', $contributiontype['upload_filetype_C'], 40, 255, false, '<br>'.ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_UPLOAD_FILETYPE_HINT', array(ctconf_get('uploadFileTypes'))).'<br>'.ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_REUSE_HINT'));
$form2->add_subseparator(ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_DOWNLOAD'));
$form2->add_select(ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_DOWNLOAD_ACCESSIBLE',array('1')), 'form_upload_accessible_A', 1, array(array('true',ct('S_YES')), array('false',ct('S_NO')) ), array($contributiontype['upload_accessible_A']), false, ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_DOWNLOAD_ACCESSIBLE_HINT').'<br>'.ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_REUSE_HINT'));
$form2->add_select(ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_DOWNLOAD_ACCESSIBLE',array('2')), 'form_upload_accessible_B', 1, array(array('true',ct('S_YES')), array('false',ct('S_NO')) ), array($contributiontype['upload_accessible_B']), false, ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_DOWNLOAD_ACCESSIBLE_HINT').'<br>'.ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_REUSE_HINT'));
$form2->add_select(ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_DOWNLOAD_ACCESSIBLE',array('3')), 'form_upload_accessible_C', 1, array(array('true',ct('S_YES')), array('false',ct('S_NO')) ), array($contributiontype['upload_accessible_C']), false, ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_DOWNLOAD_ACCESSIBLE_HINT').'<br>'.ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_REUSE_HINT'));
$form2->add_separator(ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_GENERAL'));
$form2->add_check(ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_ACTIVE'),array(array('form_active','1','',(($contributiontype['active']=='true')?1:0),ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_ACTIVE_INFO'))));
$form2->add_check(ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_ANONYMOUS'),array(array('form_review_anonymous','1','',(($contributiontype['review_anonymous']=='true')?1:0),ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_ANONYMOUS_INFO'))));
$form2->add_check(ct('S_BROWSEBIDPAPERS_TITLE'),array(array('form_do_bidding','1',ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_DOBIDDING'),(($contributiontype['do_bidding']=='true')?1:0))));
$form2->add_check(ct('S_BROWSEASSIGNEDPAPERS_TITLE'),array(array('form_do_review','1',ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_DOREVIEW'),(($contributiontype['do_review']=='true')?1:0))));
$form2->add_check(ct('S_PC_DISCUSS_RESULTS_TITLE'),array(array('form_do_discussion','1',ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_DODISCUSSION'),(($contributiontype['do_discussion']=='true')?1:0))));
$form2->add_check(ct('S_INDEX_PAPER_DETAILS'),array(array('form_review_details_to_author','1',ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_SHOWRESULTS'),(($contributiontype['review_details_to_author']=='true')?1:0))));
$form2->add_spacer();
$form2->add_select(ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_PAPER_CLASSNAME'), 'form_paper_classname', 1, get_classes("CTPaper_"), array($contributiontype['paper_classname']), false);
$form2->add_select(ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_REVIEW_CLASSNAME'), 'form_review_classname', 1, get_classes("CTReview_"), array($contributiontype['review_classname']), false);

$form2->show();

// get the names of all available subclasses for Papers or Reviews...
function get_classes($filter){
	global $ctconf;
	$a = array();
	// first look in "etc"
	if ($handle = opendir(ct_get_path('etc'))) {
		$file = readdir($handle);
    	while (false !== $file) {
    		if (stristr($file,$filter)) {
    			$name=substr($file,strlen($filter),-strlen('.ctcls.php'));
    			$a[] = array($name,$name);
    		}
			$file = readdir($handle);
    	}
	}
	// now look in "classes"!
	if ($handle = opendir(ct_get_path('classes'))) {
		$file = readdir($handle);
    	while (false !== $file) {
    		if (stristr($file,$filter)) {
    			$name=substr($file,strlen($filter),-strlen('.ctcls.php'));
    			$a[] = array($name,$name);
    		}
			$file = readdir($handle);
    	}
	}
	asort($a);
	return $a;
}

function is_deadline_enabled($datetime) {
	if (ct_datetime_2_timestamp($datetime)<=ct_datetime_2_timestamp("2005-01-01 00:00:00") || ct_datetime_2_timestamp($datetime)>ct_datetime_2_timestamp("2020-12-31 23:59:58")) return false;
	return true;
}

function set_datetime_if_enabled($field,$default_if_disabled) {
	global $http;
	if ($http["form_".$field."_enabled"]!="true") {
		$default = ct_explode_datetime($default_if_disabled);
		$http["form_".$field."_year"]  = $default[0];
		$http["form_".$field."_month"] = $default[1];
		$http["form_".$field."_day"]   = $default[2];
		$http["form_".$field."_hour"]  = $default[3];
		$http["form_".$field."_minute"]= $default[4];
		$http["form_".$field."_second"]= $default[5];
	}
}
?>