<?php
//
// PAGE:		adminToolEvents
// DESC:		Define events and products of the conference
//

ct_requireadmin();
ct_pagepath(array('index','adminTool'));

ct_load_class('CTForm');
ct_load_lib('participation.lib');
ct_load_lib('datetime.lib');

// Check if entered data makes sense...
if (isset($http['cmd_events_save']) || isset($http['cmd_events_create'])) {
	$form_errors=array();

	if ($http['form_eventtype']=="") $form_errors[]="form_eventtype";
	if ($http['form_short']=="") $form_errors[]="form_short";
	if ($http['form_title']=="") $form_errors[]="form_title";
	if ($http['form_pricecategory']=="") $form_errors[]="form_pricecategory";

	if (isset($http['form_hastext']) && $http['form_hastext']!='false' && $http['form_texthint']=="") $form_errors[]="form_texthint";

	if (!isset($http['form_datemode'])) $form_errors[]="form_datemode";

	if ($http['form_minnumber'] > $http['form_maxnumber'] || $http['form_maxnumber'] == 0) { $form_errors[]="form_minnumber"; $form_errors[]="form_maxnumber";}
	else if ($http['form_defaultnumber'] < $http['form_minnumber'] || $http['form_defaultnumber'] > $http['form_maxnumber']) { $form_errors[]="form_defaultnumber"; }

	if ($http['form_start_day'] > 0 && $http['form_start_year'] > 0) {
		$http['form_start'] = $http['form_start_year']."-".$http['form_start_month']."-".$http['form_start_day']." 00:00:00";
	}
	if ($http['form_end_day'] > 0 && $http['form_end_year'] > 0) {
		$http['form_end'] = $http['form_end_year']."-".$http['form_end_month']."-".$http['form_end_day']." 00:00:00";
	}
	if (ct_count_nights(ct_datetime_2_timestamp($http['form_start']),ct_datetime_2_timestamp($http['form_end']))<1 && $http['form_datemode']!="false") { $form_errors[]="form_start"; $form_errors[]="form_end";}
	if (ct_count_days(ct_datetime_2_timestamp($http['form_start']),ct_datetime_2_timestamp($http['form_end']))>50) { $form_errors[]="form_start"; $form_errors[]="form_end";}

	// Create correct sequence number
	if ($http['form_seqorder']=='' && $http['form_eventtype']>0) {
	    $seqorder=10;
		$r = $db->query('select max(seqorder) as max from events where eventtype="'.$http['form_eventtype'].'"');
		if ($r && ($db->num_rows($r) == 1)) {
			$event=$db->fetch($r);
			$seqorder=$event['max']+10;
		}
		$http['form_seqorder']=$seqorder;
	}

	$http_values = ct_create_hash_read_http(array('title?lang','short',
												  'eventdate?lang','eventlocation?lang','info?lang',
												  'minnumber','maxnumber','defaultnumber','pricecategory','eventtype','vat',
												  'unit?lang',
												  'hastext','texthint?lang',
												  'datemode','start?date','end?date',
												  'disable?boolean','availability','style','seqorder'));

} elseif (ct_participants_exist() && !isset($http['form_ID'])) {
	// Warning for users!!
	ct_warningbox(ct('S_ERROR_EDITPARTICIPATIONDATA'),ct('S_ERROR_EDITPARTICIPATIONDATA_PARTICIPATS_EXISTS'));
}


if ( count($form_errors)==0 ) {
	// Save data if no errors have occured...
	if (isset($http['cmd_events_save'])) {
   		$db->replace_into('events', array_merge(array('ID'=>$http['form_ID']), $http_values));
		ct_infobox(ct('S_INFO_SAVE'), ct('S_INFO_SAVE_SUCCESS'));
	}
	// Create new event if no errors have occured...
	if (isset($http['cmd_events_create'])) {
   		$db->replace_into('events', array_merge(array('ID'=>0), $http_values));
		ct_infobox(ct('S_INFO_SAVE'), ct('S_INFO_SAVE_SUCCESS'));
	}
} else {
	ct_errorbox(ct('S_ERROR_EDITPARTICIPATIONDATA'),ct('S_ERROR_EDITPARTICIPATIONDATA_DATAERROR'));
}

// Delete event.
if (isset($http['cmd_events_delete']) && isset($http['form_ID']) && $http['form_ID']!='') {
	if (ct_participants_exist($http['form_ID']))
		ct_errorbox(ct('S_ERROR_EDITPARTICIPATIONDATA'),ct('S_ERROR_EDITPARTICIPATIONDATA_NODELETE'));
    else {
    	$db->delete("events","ID='".$http['form_ID']."'");
    	$db->delete("participants2events","deleted=1 and eventID='".$http['form_ID']."'");
    }
}


// So many events may be selected
$select_number = array();
for ($i=0;$i <= 20; $i++) { $select_number[] = array ($i,$i); }
// Maximum availability
$select_availability = array();
$select_availability[] = array (0,ct('S_ADMIN_TOOL_EVENTS_UNLIMITEDAVAILABILITY'));
for ($i=1;$i <= 150; $i++) { $select_availability[] = array ($i,$i); }
for ($i=160;$i <= 1000; $i+=10) { $select_availability[] = array ($i,$i); }

echo "<h1>".ct('S_ADMIN_TOOL_EVENTS_TITLE')."</h1>\n";
echo "<p class=\"fontnormal font10\">".ct('S_ADMIN_TOOL_EVENTS_INTRO')."</p>\n";

$eventlist=ct_list_events(true);
$eventlistsize=(count($eventlist)>6?12:6);
$form1 = new CTform(ct_pageurl('adminToolEvents'), 'post');
$form1->width='85%';
$form1->align='center';
$form1->add_select(ct('S_ADMIN_TOOL_EVENTS_CMD'), 'form_ID', $eventlistsize, $eventlist, array(), false);
$form1->add_submit('cmd_events_delete', ct('S_ADMIN_TOOL_EVENTS_DELETECMD'));
$form1->add_submit('cmd_events_edit', ct('S_ADMIN_TOOL_EVENTS_EDITCMD'));
$form1->add_submit('cmd_events_copy', ct('S_ADMIN_TOOL_EVENTS_COPYCMD'));
$form1->show();

$form2 = new CTform(ct_pageurl('adminToolEvents'), 'post', $form_errors);
$form2->width='100%';
$form2->align='center';
$form2->formname='events';
$form2->warningmessage=true;
if (ctconf_get('demomode')) $form2->demomode=true;

$list_hastext = array(array('false',ct('S_ADMIN_TOOL_EVENTS_HASTEXT_FALSE')),array('textfield',ct('S_ADMIN_TOOL_EVENTS_HASTEXT_TEXTFIELD')),array('textarea',ct('S_ADMIN_TOOL_EVENTS_HASTEXT_TEXTAREA')) );


// edit event
if (isset($http['cmd_events_edit'])) {
    $r = $db->query("select * from events where ID='".$http['form_ID']."'");
   	if ($r && ($db->num_rows($r) > 0)) {
		$event = $db->fetch($r);
   	}
}
// copy event
elseif (isset($http['cmd_events_copy'])) {
    $r = $db->query("select * from events where ID='".$http['form_ID']."'");
   	if ($r && ($db->num_rows($r) > 0)) {
		$event = $db->fetch($r);
   	}
    $event['ID']='';
    $event['seqorder']='';
}
// error case
elseif (count($form_errors)>0) {
   	$event=ct_form_array_convert($http);
}
// new event:
else {
    $event['ID']='';
    $event['seqorder']='';
    $event['eventtype']='';
    $event['short']='';
    $event['title']=$event['title2']=$event['title3']=$event['title4']='';
    $event['eventdate']=$event['eventdate2']=$event['eventdate3']=$event['eventdate4']='';
    $event['eventlocation']=$event['eventlocation2']=$event['eventlocation3']=$event['eventlocation4']='';
    $event['info']=$event['info2']=$event['info3']=$event['info4']='';
    $event['minnumber']='0';
    $event['maxnumber']='1';
    $event['defaultnumber']='0';
    $event['unit']=$event['unit2']=$event['unit3']=$event['unit4']="";
    $event['pricecategory']='';
    $event['vat']='';
	$event['datemode']='false';
	$event['start']='';
	$event['end']='';
    $event['hastext']='false';
	$event['texthint']=$event['texthint2']=$event['texthint3']=$event['texthint4']='';
    $event['availability']='0';
    $event['disable']=='true';
	$event['style']='normal';
}

if (isset($event['ID']) && ($event['ID'] != "")) {
    echo "<h3>".ct('S_ADMIN_TOOL_EVENTS_EDITINTRO')."</h3>\n";
    $form2->add_submit('cmd_events_save', ct('S_ADMIN_TOOL_EVENTS_SAVECMD'));
    $form2->add_hidden(array(array('form_ID', $event['ID'])));
	$form2->add_label(ct('S_ID'),$event['ID']);
	$form2->add_spacer();
} else {
    echo "<h3>".ct('S_ADMIN_TOOL_EVENTS_NEWINTRO')."</h3>\n";
    $form2->add_submit('cmd_events_create', ct('S_ADMIN_TOOL_EVENTS_CREATECMD'));
}
$form2->add_submit('cmd_events_calcel', ct('S_BUTTON_CANCEL'));

$form2->add_hidden(array(array('form_seqorder',$event['seqorder'])));
$form2->add_select(ct('S_ADMIN_TOOL_EVENTS_TYPE'), 'form_eventtype', 1, array_merge(array(array('',ct('S_PARTICIPATE_EVENT_PLEASESELECT'))),ct_list_eventtypes()), array($event['eventtype']), false);
$form2->add_spacer();
$form2->add_text(ct('S_ADMIN_TOOL_EVENTS_SHORT'),'form_short',$event['short'], 10, 20);
$form2->add_text_lang(ct('S_ADMIN_TOOL_EVENTS_NAME'),'form_title', $event['title'],$event['title2'],$event['title3'],$event['title4'], 50, 255);
$form2->add_text_lang(ct('S_ADMIN_TOOL_EVENTS_DATE'),'form_eventdate', $event['eventdate'],$event['eventdate2'],$event['eventdate3'],$event['eventdate4'], 50, 255);
$form2->add_text_lang(ct('S_ADMIN_TOOL_EVENTS_LOCATION'),'form_eventlocation', $event['eventlocation'],$event['eventlocation2'],$event['eventlocation3'],$event['eventlocation4'], 50, 255);
$form2->add_textarea_lang(ct('S_ADMIN_TOOL_EVENTS_INFO'),'form_info', $event['info'],$event['info2'],$event['info3'],$event['info4'], 50,3);
$form2->add_separator(ct('S_ADMIN_TOOL_EVENTS_CHOICE'));
$form2->add_select(ct('S_ADMIN_TOOL_EVENTS_MIN'),'form_minnumber', 1,$select_number, array($event['minnumber']), false);
$form2->add_select(ct('S_ADMIN_TOOL_EVENTS_MAX'),'form_maxnumber', 1,$select_number, array($event['maxnumber']), false);
$form2->add_select(ct('S_ADMIN_TOOL_EVENTS_DEFAULT'),'form_defaultnumber', 1,$select_number,array($event['defaultnumber']),false);
$form2->add_text_lang(ct('S_ADMIN_TOOL_EVENTS_UNIT'),'form_unit', $event['unit'],$event['unit2'],$event['unit3'],$event['unit4'], 10, 32, false, ct('S_ADMIN_TOOL_EVENTS_UNIT_HINT'));
$form2->add_separator(ct('S_ADMIN_TOOL_EVENTS_PRICES'));
$form2->add_select(ct('S_ADMIN_TOOL_EVENTS_PRICECAT'),'form_pricecategory', 1, array_merge(array(array('',ct('S_PARTICIPATE_EVENT_PLEASESELECT'))),ct_list_pricecategories()), array($event['pricecategory']), false);
$form2->add_select(ct('S_ADMIN_TOOL_EVENTS_VAT'), 'form_vat', 1, ct_list_vats(), array($event['vat']), false);
$form2->add_spacer();
$form2->add_radio(ct('S_ADMIN_TOOL_EVENTS_DATEMODE'), 'form_datemode', array(array('false',ct('S_ADMIN_TOOL_EVENTS_DATEMODE_NODATE')),
																         	array('selectday',ct('S_ADMIN_TOOL_EVENTS_DATEMODE_SELECTDAY')),
																         	array('selectspan',ct('S_ADMIN_TOOL_EVENTS_DATEMODE_SELECTSPAN')),
																         	array('pernight',ct('S_ADMIN_TOOL_EVENTS_DATEMODE_PERNIGHT')),
																         	array('perdiem',ct('S_ADMIN_TOOL_EVENTS_DATEMODE_PERDIEM'))), $event['datemode']);
$form2->add_date(ct('S_ADMIN_TOOL_EVENTS_STARTDATE'),'form_start', true, explode(" ",str_replace("-"," ", str_replace(":"," ", $event['start'] ) ) ), ct('S_ADMIN_TOOL_EVENTS_STARTDATE_HINT') );
$form2->add_date(ct('S_ADMIN_TOOL_EVENTS_ENDDATE'),'form_end', true, explode(" ",str_replace("-"," ", str_replace(":"," ", $event['end'] ) ) ), ct('S_ADMIN_TOOL_EVENTS_ENDDATE_HINT') );
$form2->add_separator(ct('S_ADMIN_TOOL_EVENTS_EXTRAS'));
$form2->add_select(ct('S_ADMIN_TOOL_EVENTS_HASTEXT'),'form_hastext', 1, $list_hastext, array($event['hastext']), false,"<br>".ct('S_ADMIN_TOOL_EVENTS_HASTEXT_DESC') );
$form2->add_text_lang(ct('S_ADMIN_TOOL_EVENTS_TEXTHINT'),'form_texthint', $event['texthint'],$event['texthint2'],$event['texthint3'],$event['texthint4'], 50, 255);
$form2->add_spacer();
$form2->add_select(ct('S_ADMIN_TOOL_EVENTS_MAXAVAILABILITY'),'form_availability', 1,$select_availability, array($event['availability']), false, ct('S_ADMIN_TOOL_EVENTS_AVAILABILITY_DESC'));
$form2->add_check(ct('S_ADMIN_TOOL_EVENTS_DEACTIVATE'),array(array('form_disable', 'true',ct('S_ADMIN_TOOL_EVENTS_DEACTIVATE_DESC'), (($event['disable']=='true')?1:0))));
$form2->add_select(ct('S_ADMIN_TOOL_EVENTS_STYLE'), 'form_style', 1, array(array('normal',ct('S_ADMIN_TOOL_EVENTS_STYLE_NORMAL')),
																	         array('hidden',ct('S_ADMIN_TOOL_EVENTS_STYLE_HIDDEN')),
																	         array('spacer',ct('S_ADMIN_TOOL_EVENTS_STYLE_SPACER')),
																	         array('spacer2',ct('S_ADMIN_TOOL_EVENTS_STYLE_SPACER2'))), array($event['style']));
$form2->show();

?>