<?php
//
// PAGE:		adminToolEventtypes
// DESC:		Define different event types/groups to classify them, e.g. main event, tutorial, workshops
//

ct_requireadmin();
ct_pagepath(array('index','adminTool'));


ct_load_class('CTForm');
ct_load_lib('participation.lib');

// Choice boxes have to be converted...
if (isset($http['form_showremaining']))   $showremaining="true";    else 	$showremaining="false";

if (isset($http['cmd_eventtypes_save'])) {
	$db->replace_into('eventtypes', array('ID'=>$http['form_id'], 'seqorder'=>$http['form_seqorder'],
	                                            'title'=>$http['form_title'],'title2'=>$http['form_title2'],'title3'=>$http['form_title3'],'title4'=>$http['form_title4'],
	                                            'shorttitle'=>$http['form_shorttitle'],
												'info'=>$http['form_info'],'info2'=>$http['form_info2'],'info3'=>$http['form_info3'],'info4'=>$http['form_info4'],
												'mode'=>$http['form_mode'], 'style'=>$http['form_style'],
												'nocharge'=>$http['form_nocharge'], 'showremaining'=>$showremaining, 'negative'=>$http['form_negative']));
	ct_infobox(ct('S_INFO_SAVE'), ct('S_INFO_SAVE_SUCCESS'));
} elseif (isset($http['cmd_eventtypes_create']) && $http['form_title']!="") {
        $seqorder=10;
		$r = $db->query('select max(seqorder) as max from eventtypes');
		if ($r && ($db->num_rows($r) > 0)) {
			$eventtype = $db->fetch($r);
			$seqorder=$eventtype['max']+10;
		}
    $db->insert_into('eventtypes', array('ID'=>0, 'seqorder'=>$seqorder,
                                                'title'=>$http['form_title'],'title2'=>$http['form_title2'],'title3'=>$http['form_title3'],'title4'=>$http['form_title4'],
	                                            'shorttitle'=>$http['form_shorttitle'],
	                                            'info'=>$http['form_info'],'info2'=>$http['form_info2'],'info3'=>$http['form_info3'],'info4'=>$http['form_info4'],
												'mode'=>$http['form_mode'], 'style'=>$http['form_style'],
												'nocharge'=>$http['form_nocharge'], 'showremaining'=>$showremaining, 'negative'=>$http['form_negative']));
	ct_infobox(ct('S_INFO_SAVE'), ct('S_INFO_SAVE_SUCCESS'));
} elseif (isset($http['cmd_eventtypes_delete'])) {
	$r = $db->select('events','ID','eventtype="'.$http['form_eventtype'].'"');
	if ($r && ($db->num_rows($r) > 0)) 
		ct_errorbox(ct('S_ERROR_EDITPARTICIPATIONDATA'),ct('S_ERROR_EDITPARTICIPATIONDATA_NODELETE'));
    else 
	   	$db->delete("eventtypes","id='".$http['form_eventtype']."'");
} #elseif (ct_participants_exist()) {
#	ct_warningbox(ct('S_ERROR_EDITPARTICIPATIONDATA'),ct('S_ERROR_EDITPARTICIPATIONDATA_PARTICIPATS_EXISTS'));
#}


	echo "<h1>".ct('S_ADMIN_TOOL_EVENTTYPES_TITLE')."</h1>\n";
	echo "<p class=\"fontnormal font10\">".ct('S_ADMIN_TOOL_EVENTTYPES_INTRO')."</p>\n";

	$form1 = new CTform(ct_pageurl('adminToolEventtypes'), 'post');
	$form1->width='450';
	$form1->align='center';
	$form1->add_select(ct('S_PARTICIPATION_FORM_EVENTTYPES'), 'form_eventtype', 10, ct_list_eventtypes(), array(), false);
	$form1->add_submit('cmd_eventtypes_delete', ct('S_ADMIN_TOOL_EVENTTYPES_DELETECMD'));
	$form1->add_submit('cmd_eventtypes_edit', ct('S_ADMIN_TOOL_EVENTTYPES_EDITCMD'));
	if (ctconf_get('demomode')) $form1->demomode=true;
	$form1->show();

	$list_modes = array(array('normal',ct('S_ADMIN_TOOL_EVENTTYPES_FORM_MODE_NORMAL')),array('exclusive',ct('S_ADMIN_TOOL_EVENTTYPES_FORM_MODE_EXCLUSIVE')),array('joint',ct('S_ADMIN_TOOL_EVENTTYPES_FORM_MODE_JOINT')) );
	$list_styles = array(array('normal',ct('S_ADMIN_TOOL_EVENTTYPES_FORM_STYLE_NORMAL')),array('main',ct('S_ADMIN_TOOL_EVENTTYPES_FORM_STYLE_MAIN')),array('spacer',ct('S_ADMIN_TOOL_EVENTTYPES_FORM_STYLE_SPACER')),array('hidden',ct('S_ADMIN_TOOL_EVENTTYPES_FORM_STYLE_HIDDEN')));
	$list_negativetypes = array(array('normal',ct('S_ADMIN_TOOL_EVENTTYPES_FORM_NEGATIVE_NORMAL')),array('disabled',ct('S_ADMIN_TOOL_EVENTTYPES_FORM_NEGATIVE_DISABLED')),array('hidden',ct('S_ADMIN_TOOL_EVENTTYPES_FORM_NEGATIVE_HIDDEN')) );
	$list_nocharge= array(array('false',ct('S_ADMIN_TOOL_EVENTTYPES_FORM_NOCHARGE_SHOWPRICE')),array('true',ct('S_ADMIN_TOOL_EVENTTYPES_FORM_NOCHARGE_HIDEPRICE')),array('hideoninvoice',ct('S_ADMIN_TOOL_EVENTTYPES_FORM_NOCHARGE_HIDEONINVOICE')));

	$form2 = new CTForm(ct_pageurl('adminToolEventtypes'), 'post');
	$form2->width='98%';
	$form2->align='center';
	if (ctconf_get('demomode')) $form2->demomode=true;

	if (isset($http['cmd_eventtypes_edit']) && isset($http['form_eventtype']) && ($http['form_eventtype'] != "")) {
		echo "<p class=\"fontnormal font10\">".ct('S_ADMIN_TOOL_EVENTTYPES_EDITINTRO')."</p>\n";
		$form2->add_hidden(array(array('form_id', $http['form_eventtype'])));
		$r = $db->query("select * from eventtypes where id='".$http['form_eventtype']."'");
		if ($r && ($db->num_rows($r) > 0)) {
			$eventtype = $db->fetch($r);
		}
		$form2->add_text_lang(ct('S_ADMIN_TOOL_EVENTTYPES_FORM_EVENTTYPE'),'form_title', $eventtype['title'],$eventtype['title2'],$eventtype['title3'],$eventtype['title4'], 50, 255);
		$form2->add_text(ct('S_ADMIN_TOOL_EVENTTYPES_FORM_SHORTTITLE'),'form_shorttitle', $eventtype['shorttitle'], 12, 32);
		$form2->add_textarea_lang(ct('S_ADMIN_TOOL_EVENTTYPES_FORM_INFO'),'form_info', $eventtype['info'],$eventtype['info2'],$eventtype['info3'],$eventtype['info4'], 50,3);
		($eventtype['nocharge']			=='true')?$nocharge=1:$nocharge=0;
		($eventtype['showremaining']	=='true')?$showremaining=1:$showremaining=0;
	    $form2->add_spacer();
	    $form2->add_select(ct('S_ADMIN_TOOL_EVENTTYPES_FORM_MODE'),'form_mode', 1, $list_modes, array($eventtype['mode']), false,"<br>".ct('S_ADMIN_TOOL_EVENTTYPES_FORM_EXCLUSIVE_INFO') );
		//$form2->add_check(ct('S_ADMIN_TOOL_EVENTTYPES_FORM_EXCLUSIVE'),array(array('form_exclusive','1','',$excl,ct('S_ADMIN_TOOL_EVENTTYPES_FORM_EXCLUSIVE_INFO'))));
	    $form2->add_spacer();
	    $form2->add_select(ct('S_ADMIN_TOOL_EVENTTYPES_FORM_STYLE'),'form_style', 1, $list_styles, array($eventtype['style']),false);
		$form2->add_check(ct('S_ADMIN_TOOL_EVENTTYPES_FORM_SHOWREMAINING'),array(array('form_showremaining','1','',$showremaining,ct('S_ADMIN_TOOL_EVENTTYPES_FORM_SHOWREMAINING_INFO'))));
	    $form2->add_spacer();
	    $form2->add_select(ct('S_ADMIN_TOOL_EVENTTYPES_FORM_NOCHARGE'),'form_nocharge', 1,$list_nocharge, array($eventtype['nocharge']),false,"<br>".ct('S_ADMIN_TOOL_EVENTTYPES_FORM_NOCHARGE_INFO'));
	    $form2->add_select(ct('S_ADMIN_TOOL_EVENTTYPES_FORM_NEGATIVE'),'form_negative', 1,$list_negativetypes, array($eventtype['negative']),false,"<br>".ct('S_ADMIN_TOOL_EVENTTYPES_FORM_NEGATIVE_INFO'));
		$form2->add_hidden(array(array('form_seqorder',$eventtype['seqorder'])));
		$form2->add_submit('cmd_eventtypes_save', ct('S_ADMIN_TOOL_EVENTTYPES_SAVECMD'));
		$form2->add_submit('cmd_eventtypes_cancel', ct('S_BUTTON_CANCEL'));
		// new eventtype:
	} else {
		echo "<p class=\"fontnormal font10\">".ct('S_ADMIN_TOOL_EVENTTYPES_NEWINTRO')."</p>\n";
		$form2->add_text_lang(ct('S_ADMIN_TOOL_EVENTTYPES_FORM_EVENTTYPE'),'form_title', '','','','', 50, 255);
		$form2->add_text(ct('S_ADMIN_TOOL_EVENTTYPES_FORM_SHORTTITLE'),'form_shorttitle', '', 12, 32);
		$form2->add_textarea_lang(ct('S_ADMIN_TOOL_EVENTTYPES_FORM_INFO'),'form_info', '','','','', 50,3);
	    $form2->add_spacer();
	    $form2->add_select(ct('S_ADMIN_TOOL_EVENTTYPES_FORM_MODE'),'form_mode', 1, $list_modes, array('normal'),false,"<br>".ct('S_ADMIN_TOOL_EVENTTYPES_FORM_EXCLUSIVE_INFO') );
	    $form2->add_spacer();
	    $form2->add_select(ct('S_ADMIN_TOOL_EVENTTYPES_FORM_STYLE'),'form_style', 1, $list_styles, array('normal'),false);
		$form2->add_check(ct('S_ADMIN_TOOL_EVENTTYPES_FORM_SHOWREMAINING'),array(array('form_showremaining','1','','0',ct('S_ADMIN_TOOL_EVENTTYPES_FORM_SHOWREMAINING_INFO'))));
	    $form2->add_spacer();
	    $form2->add_select(ct('S_ADMIN_TOOL_EVENTTYPES_FORM_NOCHARGE'),'form_nocharge', 1,$list_nocharge,array('false'),false,"<br>".ct('S_ADMIN_TOOL_EVENTTYPES_FORM_NOCHARGE_INFO'));
	    $form2->add_select(ct('S_ADMIN_TOOL_EVENTTYPES_FORM_NEGATIVE'),'form_negative', 1,$list_negativetypes,array('normal'),false,"<br>".ct('S_ADMIN_TOOL_EVENTTYPES_FORM_NEGATIVE_INFO'));
		$form2->add_submit('cmd_eventtypes_create', ct('S_ADMIN_TOOL_EVENTTYPES_CREATECMD'));
	}
	$form2->show();
?>