<?php
//
// PAGE:		adminToolMailSettings
// DESC:		Set mail settings for conftool
//

ct_requireadmin();
ct_pagepath(array('index','adminTool'));

ct_load_lib('mail.lib');
ct_load_lib('ctconf_admintools.lib');
ct_load_class('CTForm');

$form_errors=array();

$session->del('db_ctconf'); // reset configuration in session...

if (isset($http['cmd_mailsettings_save'])) {
	$form_errors[]=save_ctconf_setting('conferenceContactEmail','email');
	$form_errors[]=save_ctconf_setting('conferenceSenderEmail','email');
	$form_errors[]=save_ctconf_setting('conferenceSenderName','required');
	$form_errors[]=save_ctconf_setting('conferenceReplytoEmail');

	$form_errors[]=save_ctconf_setting('userRegistrationMailBCC','');
	$form_errors[]=save_ctconf_setting('userRegistrationMailHint','');

	if (ctconf_get('submission/enabled')) {
		$form_errors[]=save_ctconf_setting('submissionMail','boolean');
		$form_errors[]=save_ctconf_setting('submissionMailBCC','');
		$form_errors[]=save_ctconf_setting('submissionMailMessage','');
		$form_errors[]=save_ctconf_setting('submissionMailFinalMessage','');
	}	
	
	if (ctconf_get('participation/enabled')) {
		$form_errors[]=save_ctconf_setting('participationRegistrationMail','boolean');
		$form_errors[]=save_ctconf_setting('participationRegistrationMailBCC','');
		$form_errors[]=save_ctconf_setting('participationRegistrationMailHintOK','');
		$form_errors[]=save_ctconf_setting('participationRegistrationMailHintCancelled','');

		$form_errors[]=save_ctconf_setting('participationPaymentMail','boolean');
		$form_errors[]=save_ctconf_setting('participationPaymentMailBCC','');
		$form_errors[]=save_ctconf_setting('participationPaymentMailHintOK','');
		$form_errors[]=save_ctconf_setting('participationPaymentMailHintCancelled','');
	}
		
	// remove empty entries
	foreach ($form_errors as $index => $value) { if (empty($value)) unset($form_errors[$index]); }
	// Show message to user
	if (count($form_errors)==0) {
		$session->put_infobox(ct('S_INFO_SAVE'),ct('S_INFO_SAVE_SUCCESS'));
		ct_redirect(ct_pageurl('adminToolMailSettings')); // Show new title etc.
	}
	//else
	//	ct_errorbox(ct('S_ERROR_SAVE'),ct('S_ERROR_SAVE_FAILED'));
	#ct_print_r($form_errors);
}

echo "<h1>".ct('S_ADMIN_TOOL_MAILSETTINGS_TITLE')."</h1>\n";
echo "<p class=\"fontnormal font10\">".ct('S_ADMIN_TOOL_MAILSETTINGS_INTRO')."</p>\n";


$form = new CTform(ct_pageurl('adminToolMailSettings'), 'post', $form_errors);
$form->width='99%';
$form->align='center';
$form->formname='mailsettings';
$form->warningmessage=true;
$form->return2tab=true;

$form->add_separator(ct('S_ADMIN_TOOL_MAILSETTINGS_MAIN'));
$form->add_text(ct('S_ADMIN_TOOL_MASTERDATA_CONTACTEMAIL'),'form_conferenceContactEmail', ctconf_get('conferenceContactEmail',ctconf_get('mail/contact','info@conftool.net')), 20, 255);
#$form->add_text(ct('S_ADMIN_TOOL_MASTERDATA_SENDERNAME'),'form_conferenceSenderName', ctconf_get('conferenceSenderName',ctconf_get('conferenceShortName','')), 20, 255);
$form->add_text(ct('S_ADMIN_TOOL_MASTERDATA_SENDERNAME'),'form_conferenceSenderName', ctconf_get('conferenceSenderName',''), 20, 255);
$form->add_text(ct('S_ADMIN_TOOL_MASTERDATA_SENDEREMAIL'),'form_conferenceSenderEmail', ctconf_get('conferenceSenderEmail',ctconf_get('mail/contact','info@conftool.net')), 20, 255);
$form->add_text(ct('S_ADMIN_TOOL_MASTERDATA_REPLYTOEMAIL'),'form_conferenceReplytoEmail', ctconf_get('conferenceReplytoEmail',''), 20, 255);

$form->add_separator(ct('S_ADMIN_TOOL_MAILSETTINGS_USERS'));
$form->add_text(ct('S_ADMIN_TOOL_MAILSETTINGS_USERS_BCC'),'form_userRegistrationMailBCC', ctconf_get('userRegistrationMailBCC',ctconf_get('mail/contact','info@conftool.net')), 20, 255);
$form->add_textarea(ct('S_ADMIN_TOOL_MAILSETTINGS_USERS_HINT'),'form_userRegistrationMailHint', ctconf_get('userRegistrationMailHint',''), 70, 3,'',ct('S_FORM_PLAINTEXT_ONLY'),0,'class="fontmonospaced font9"');

if (ctconf_get('submission/enabled')) {
	$form->add_separator(ct('S_ADMIN_TOOL_MAILSETTINGS_AUTHORS'));
	$form->add_select(ct('S_ADMIN_TOOL_MAILSETTINGS_AUTHORS_SENDMAIL'),'form_submissionMail', 1, array(array('1', ct('S_YES')), array('0', ct('S_NO'))), array(ctconf_get('submissionMail','0')), false, '');
	$form->add_text(ct('S_ADMIN_TOOL_MAILSETTINGS_AUTHORS_BCC'),'form_submissionMailBCC', ctconf_get('submissionMailBCC',ctconf_get('mail/contact','info@conftool.net')), 20, 255);
	$form->add_textarea(ct('S_ADMIN_TOOL_MAILSETTINGS_AUTHORS_MESSAGE'),'form_submissionMailMessage', ctconf_get('submissionMailMessage',''), 70, 3,'',ct('S_FORM_PLAINTEXT_ONLY'),0,'class="fontmonospaced font9"');
	$form->add_textarea(ct('S_ADMIN_TOOL_MAILSETTINGS_AUTHORS_FINAL_MESSAGE'),'form_submissionMailFinalMessage', ctconf_get('submissionMailFinalMessage',''), 70, 3,'',ct('S_FORM_PLAINTEXT_ONLY'),0,'class="fontmonospaced font9"');
}

if (ctconf_get('participation/enabled')) {
	$form->add_separator(ct('S_ADMIN_TOOL_MAILSETTINGS_PARTICIPANTS'));
	$form->add_select(ct('S_ADMIN_TOOL_MAILSETTINGS_PARTICIPANTS_SENDMAIL'),'form_participationRegistrationMail', 1, array(array('1', ct('S_YES')), array('0', ct('S_NO'))), array(ctconf_get('participationRegistrationMail','1')), false, '');
	$form->add_text(ct('S_ADMIN_TOOL_MAILSETTINGS_PARTICIPANTS_BCC'),'form_participationRegistrationMailBCC', ctconf_get('participationRegistrationMailBCC',ctconf_get('mail/contact','info@conftool.net')), 20, 255);
	$form->add_textarea(ct('S_ADMIN_TOOL_MAILSETTINGS_PARTICIPANTS_HINT_OK'),'form_participationRegistrationMailHintOK', ctconf_get('participationRegistrationMailHintOK',''), 70, 3,'',ct('S_FORM_PLAINTEXT_ONLY'),0,'class="fontmonospaced font9"');
	$form->add_textarea(ct('S_ADMIN_TOOL_MAILSETTINGS_PARTICIPANTS_HINT_CANCELLED'),'form_participationRegistrationMailHintCancelled', ctconf_get('participationRegistrationMailHintCancelled',''), 70, 3,'',ct('S_FORM_PLAINTEXT_ONLY'),0,'class="fontmonospaced font9"');
	$form->add_spacer();
	$form->add_select(ct('S_ADMIN_TOOL_MAILSETTINGS_PAYMENT_SENDMAIL'),'form_participationPaymentMail', 1, array(array('1', ct('S_YES')), array('0', ct('S_NO'))), array(ctconf_get('participationPaymentMail','1')), false, '');
	$form->add_text(ct('S_ADMIN_TOOL_MAILSETTINGS_PARTICIPANTS_BCC'),'form_participationPaymentMailBCC', ctconf_get('participationPaymentMailBCC',ctconf_get('mail/contact','info@conftool.net')), 20, 255);
	$form->add_textarea(ct('S_ADMIN_TOOL_MAILSETTINGS_PAYMENT_HINT_OK'),'form_participationPaymentMailHintOK', ctconf_get('participationPaymentMailHintOK',''), 70, 3,'',ct('S_FORM_PLAINTEXT_ONLY'),0,'class="fontmonospaced font9"');
	$form->add_textarea(ct('S_ADMIN_TOOL_MAILSETTINGS_PAYMENT_HINT_CANCELLED'),'form_participationPaymentMailHintCancelled', ctconf_get('participationPaymentMailHintCancelled',''), 70, 3,'',ct('S_FORM_PLAINTEXT_ONLY'),0,'class="fontmonospaced font9"');
}

$form->add_submit('cmd_mailsettings_save', ct('S_BUTTON_SAVE'));
$form->add_submit('cmd_mailsettings_cancel', ct('S_BUTTON_CANCEL'));

if (ctconf_get('demomode')) $form->demomode=true;
$form->show();


?>