<?php
//
// PAGE:		adminToolPhases
// DESC:		Define dates for different conference phases to activate and deactivate
//			several conftool functions (also automatically by date).
//

ct_requireadmin();
ct_pagepath(array('index','adminTool'));

ct_load_lib('papers.lib');
ct_load_lib('participation.lib');
ct_load_lib('mail.lib');
ct_load_lib('datetime.lib');
ct_load_lib('ctconf_admintools.lib');
ct_load_class('CTForm');

$form_errors=array();

$session->del('db_ctconf'); // reset configuration in session...

if (isset($http['cmd_masterdata_save'])) {
	$form_errors[]=save_ctconf_setting('conferenceName','required');
	$form_errors[]=save_ctconf_setting('conferenceShortName','required');
	$form_errors[]=save_ctconf_setting('conferenceURI','uri');
	$form_errors[]=save_ctconf_setting('conferenceOrganizer','required');
	$form_errors[]=save_ctconf_setting('conferenceCity','required');
	$form_errors[]=save_ctconf_setting('conferenceContactEmail','email');
	$form_errors[]=save_ctconf_setting('timezoneOffset','number');
	$form_errors[]=save_ctconf_setting('display_perpage','number');
	$form_errors[]=save_ctconf_setting('display_perpage_submitting','number');
	$form_errors[]=save_ctconf_setting('timezoneName','required');

	if (ctconf_get('submission/enabled')) {
		$http['form_uploadFileTypes']=strtolower($http['form_uploadFileTypes']);
	 	$form_errors[]=save_ctconf_setting('uploadFileTypes','csv');
	 	#$form_errors[]=save_ctconf_setting('uploadFileInfo','lang');
	 	$form_errors[]=save_ctconf_setting('metaReviews','boolean');
		if (ct_test_lib('multi_track.lib'))	{// if multi_track library exists...
		 	$form_errors[]=save_ctconf_setting('chairTrackSelect','boolean');
		 	$form_errors[]=save_ctconf_setting('pcTrackSelect','boolean');
	 		$form_errors[]=save_ctconf_setting('topicsTrackSelect','boolean');
		}
	 	$form_errors[]=save_ctconf_setting('forumDownloads','boolean');
	}
		
	if (ctconf_get('participation/enabled')) {
		$form_errors[]=save_ctconf_setting('memberNumber','boolean');
		$form_errors[]=save_ctconf_setting('registrationTerms','boolean');

		$form_errors[]=save_ctconf_setting('currencyCode','required');
		$form_errors[]=save_ctconf_setting('currencySymbol','required');
	
		$form_errors[]=save_ctconf_setting('conferenceWithVAT','boolean');
		$form_errors[]=save_ctconf_setting('conferenceNetPrices','boolean');

		$form_errors[]=save_ctconf_setting('invoiceProforma','boolean');
		$form_errors[]=save_ctconf_setting('invoiceSender','required');
		$form_errors[]=save_ctconf_setting('invoiceSenderCity');
		$form_errors[]=save_ctconf_setting('invoiceTaxNo');
		$form_errors[]=save_ctconf_setting('invoiceHeader');
		$form_errors[]=save_ctconf_setting('invoiceFooter');
		$form_errors[]=save_ctconf_setting('invoicePrefix');
		$form_errors[]=save_ctconf_setting('invoiceDigits','number5-11');
		if ($http['form_invoiceDigits']>=5 && $http['form_invoiceDigits']<=11)
			$http['form_invoiceNo']=substr('000000000000'.trim($http['form_invoiceNo']),-1*$http['form_invoiceDigits']);
		$form_errors[]=save_ctconf_setting('invoiceNo','number');
	
		$form_errors[]=save_ctconf_setting('paymentCash','boolean');
		$form_errors[]=save_ctconf_setting('paymentCheque','boolean');
		$form_errors[]=save_ctconf_setting('paymentChequePayableTo');
		$form_errors[]=save_ctconf_setting('paymentChequeReceiver');
		
		$form_errors[]=save_ctconf_setting('paymentCreditCardTypes','csv');
		$form_errors[]=save_ctconf_setting('paymentCreditCardUseCVC','boolean');
		$form_errors[]=save_ctconf_setting('paymentCreditCardUseIssueNo','boolean');

		$form_errors[]=save_ctconf_setting('paymentCreditCard','boolean');
		$form_errors[]=save_ctconf_setting('paymentCreditCardUseAddress','boolean');

		$form_errors[]=save_ctconf_setting('paymentFax','boolean');
		$form_errors[]=save_ctconf_setting('faxReceiver');
		$form_errors[]=save_ctconf_setting('faxNoNational');
		$form_errors[]=save_ctconf_setting('faxNoInternational');
		
		if (ct_test_lib('cc_processor_payflow_link.lib'))	// if payflow library exists...
			$form_errors[]=save_ctconf_setting('paymentCreditCardUsePayflow','boolean');
		if (ct_test_lib('cc_processor_saferpay.lib'))	// if saferpay library exists...
			$form_errors[]=save_ctconf_setting('paymentCreditCardExternal','boolean');
		elseif (ct_test_lib('cc_processor_beanstream.lib'))	// if beanstream library exists...
			$form_errors[]=save_ctconf_setting('paymentCreditCardExternal','boolean');

		$form_errors[]=save_ctconf_setting('paymentPaypal','boolean');
		$form_errors[]=save_ctconf_setting('paymentPaypalDemo','boolean');
		$form_errors[]=save_ctconf_setting('paymentPaypalAccount');
		$form_errors[]=save_ctconf_setting('paymentPaypalCurrency');

		$form_errors[]=save_ctconf_setting('paymentTransfer','boolean');
		$form_errors[]=save_ctconf_setting('paymentTransferAccountHolder');
		$form_errors[]=save_ctconf_setting('paymentTransferAccountNo');
		$form_errors[]=save_ctconf_setting('paymentTransferBankName');
		$form_errors[]=save_ctconf_setting('paymentTransferBankCode');
		$form_errors[]=save_ctconf_setting('paymentTransferSWIFT');
		$form_errors[]=save_ctconf_setting('paymentTransferIBAN');
		$form_errors[]=save_ctconf_setting('paymentExtra1','boolean');
		$form_errors[]=save_ctconf_setting('paymentExtra2','boolean');
		$form_errors[]=save_ctconf_setting('paymentExtra3','boolean');
	}
	// remove empty entries
	foreach ($form_errors as $index => $value) { if (empty($value)) unset($form_errors[$index]); }
	// Show message to user
	if (count($form_errors)==0) {
		$session->put_infobox(ct('S_INFO_SAVE'),ct('S_INFO_SAVE_SUCCESS'));
		ct_redirect(ct_pageurl('adminToolMasterData')); // Show new title etc.
	} #else {
	#	ct_errorbox(ct('S_ERROR_SAVE'),ct('S_ERROR_SAVE_FAILED'));
	#}
	#ct_print_r($form_errors);
} else {
	if (ct_participants_exist()) {
		ct_warningbox(ct('S_ERROR_EDITPARTICIPATIONDATA'),ct('S_ERROR_EDITPARTICIPATIONDATA_PARTICIPATS_EXISTS'));
	}
	#if (ct_papers_exist()) {
	#	ct_warningbox(ct('S_ERROR_EDITPAPERDATA'),ct('S_ERROR_EDITPAPERDATA_PAPERS_EXIST'));
	#}
}

echo "<h1>".ct('S_ADMIN_TOOL_MASTERDATA_TITLE')."</h1>\n";
echo "<p class=\"fontnormal font10\">".ct('S_ADMIN_TOOL_MASTERDATA_INTRO')."</p>\n";

$form = new CTform(ct_pageurl('adminToolMasterData'), 'post',$form_errors);
$form->width='99%';
$form->align='center';
$form->formname='masterdata';
$form->warningmessage=true;
$form->return2tab=true;

$form->add_separator(ct('S_ADMIN_TOOL_MASTERDATA_MAIN'));
$form->add_textarea(ct('S_ADMIN_TOOL_MASTERDATA_NAME'),'form_conferenceName', ctconf_get('conferenceName','Your Conference 2007'), 50, 2, '', ct('S_ADMIN_TOOL_MASTERDATA_NAME_INFO').'<br>'.ct('S_FORM_HTML_OK'));
$form->add_text(ct('S_ADMIN_TOOL_MASTERDATA_SHORTNAME'),'form_conferenceShortName', ctconf_get('conferenceShortName','Conference \'07'), 15, 255,false, '<br>'.ct('S_ADMIN_TOOL_MASTERDATA_SHORTNAME_INFO').'<br>'.ct('S_FORM_PLAINTEXT_ONLY'));
$form->add_text(ct('S_ADMIN_TOOL_MASTERDATA_URI'),'form_conferenceURI', ctconf_get('conferenceURI','http://www.conftool.net/'), 50, 255,false, '<br>'.ct('S_ADMIN_TOOL_MASTERDATA_URI_INFO'));
$form->add_text(ct('S_ADMIN_TOOL_MASTERDATA_ORGANIZER'),'form_conferenceOrganizer', ctconf_get('conferenceOrganizer','Jane Doe'), 50, 255);
$form->add_text(ct('S_ADMIN_TOOL_MASTERDATA_CONFERENCECITY'),'form_conferenceCity', ctconf_get('conferenceCity','Hamburg-Harburg'), 30, 64);
$form->add_text(ct('S_ADMIN_TOOL_MASTERDATA_CONTACTEMAIL'),'form_conferenceContactEmail', ctconf_get('conferenceContactEmail',ctconf_get('mail/contact','info@conftool.net')), 20, 255);

$form->add_separator(ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_OFFSET'));
$form->add_select(ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_OFFSET'),'form_timezoneOffset', 1, 
				array( array((-23*3600), ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_OFFSET_DIFFERENCE',array('-23'))), 
					   array((-22*3600), ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_OFFSET_DIFFERENCE',array('-22'))), 
					   array((-21*3600), ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_OFFSET_DIFFERENCE',array('-21'))), 
					   array((-20*3600), ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_OFFSET_DIFFERENCE',array('-20'))), 
					   array((-19*3600), ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_OFFSET_DIFFERENCE',array('-19'))), 
					   array((-18*3600), ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_OFFSET_DIFFERENCE',array('-18'))), 
					   array((-17*3600), ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_OFFSET_DIFFERENCE',array('-17'))), 
					   array((-16*3600), ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_OFFSET_DIFFERENCE',array('-16'))), 
					   array((-15*3600), ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_OFFSET_DIFFERENCE',array('-15'))), 
					   array((-14*3600), ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_OFFSET_DIFFERENCE',array('-14'))), 
					   array((-13*3600), ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_OFFSET_DIFFERENCE',array('-13'))), 
					   array((-12*3600), ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_OFFSET_DIFFERENCE',array('-12'))), 
					   array((-11*3600), ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_OFFSET_DIFFERENCE',array('-11'))), 
					   array((-10*3600), ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_OFFSET_DIFFERENCE',array('-10'))), 
					   array((-9*3600), ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_OFFSET_DIFFERENCE',array('-9'))), 
					   array((-8*3600), ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_OFFSET_DIFFERENCE',array('-8'))), 
					   array((-7*3600), ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_OFFSET_DIFFERENCE',array('-7'))), 
					   array((-6*3600), ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_OFFSET_DIFFERENCE',array('-6'))), 
					   array((-5*3600), ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_OFFSET_DIFFERENCE',array('-5'))), 
					   array((-4*3600), ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_OFFSET_DIFFERENCE',array('-4'))), 
					   array((-3*3600), ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_OFFSET_DIFFERENCE',array('-3'))), 
					   array((-2*3600), ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_OFFSET_DIFFERENCE',array('-2'))), 
					   array((-1*3600), ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_OFFSET_DIFFERENCE',array('-1'))), 
					   array(( 0*3600), ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_OFFSET_DIFFERENCE',array('0'))), 
					   array(( 1*3600), ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_OFFSET_DIFFERENCE',array('+1'))), 
					   array(( 2*3600), ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_OFFSET_DIFFERENCE',array('+2'))), 
					   array(( 3*3600), ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_OFFSET_DIFFERENCE',array('+3'))), 
					   array(( 4*3600), ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_OFFSET_DIFFERENCE',array('+4'))), 
					   array(( 5*3600), ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_OFFSET_DIFFERENCE',array('+5'))), 
					   array(( 6*3600), ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_OFFSET_DIFFERENCE',array('+6'))), 
					   array(( 7*3600), ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_OFFSET_DIFFERENCE',array('+7'))), 
					   array(( 8*3600), ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_OFFSET_DIFFERENCE',array('+8'))), 
					   array(( 9*3600), ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_OFFSET_DIFFERENCE',array('+9'))), 
					   array((10*3600), ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_OFFSET_DIFFERENCE',array('+10'))), 
					   array((11*3600), ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_OFFSET_DIFFERENCE',array('+11'))), 
					   array((12*3600), ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_OFFSET_DIFFERENCE',array('+12'))), 
					   array((13*3600), ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_OFFSET_DIFFERENCE',array('+13'))), 
					   array((14*3600), ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_OFFSET_DIFFERENCE',array('+14'))), 
					   array((15*3600), ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_OFFSET_DIFFERENCE',array('+15'))), 
					   array((16*3600), ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_OFFSET_DIFFERENCE',array('+16'))), 
					   array((17*3600), ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_OFFSET_DIFFERENCE',array('+17'))), 
					   array((18*3600), ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_OFFSET_DIFFERENCE',array('+18'))), 
					   array((19*3600), ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_OFFSET_DIFFERENCE',array('+19'))), 
					   array((20*3600), ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_OFFSET_DIFFERENCE',array('+20'))), 
					   array((21*3600), ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_OFFSET_DIFFERENCE',array('+21'))), 
					   array((22*3600), ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_OFFSET_DIFFERENCE',array('+22'))), 
					   array((23*3600), ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_OFFSET_DIFFERENCE',array('+23')))),
 				array(ctconf_get('timezoneOffset','0')), false, '<br>'.ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_OFFSET_HINT',array('<b>'.ct_datetime_format(time()).'</b>')));
$form->add_text(ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_NAME'),'form_timezoneName', ctconf_get('timezoneName','CET'), 20, 255,false,'<br>'.ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_NAME_HINT'));
if (ctconf_get('timezoneName','')!='') 
	$form->add_label(ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_CURRENT'),ct_datetime_format(ct_time()).' '.ctconf_get('timezoneName',''));

$form->add_separator(ct('S_ADMIN_TOOL_MASTERDATA_DISPLAY'));
$form->add_select(ct('S_ADMIN_TOOL_MASTERDATA_DISPLAY_PERPAGE'),'form_display_perpage', 1, 
				array( array('10', '10'), 
						array("15","15"),
						array("20","20"),
						array("25","25"),
						array("50","50"),
						array("100","100"),
						array("250","250"),
						array("500","500"),
						array("1000","1000")),   
 				array(ctconf_get('display_perpage','20')), false);
$form->add_select(ct('S_ADMIN_TOOL_MASTERDATA_DISPLAY_PERPAGE_SUBMITTING'),'form_display_perpage_submitting', 1, 
				array(	array("25","25"),
						array("50","50"),
						array("100","100"),
						array("250","250"),
						array("500","500")),   
 				array(ctconf_get('display_perpage_submitting','100')), false);
	
if (ctconf_get('submission/enabled')) {
	$form->add_separator(ct('S_ADMIN_TOOL_MASTERDATA_UPLOADDATA'));
	$form->add_text(ct('S_ADMIN_TOOL_MASTERDATA_UPLOAD_FILETYPES'),'form_uploadFileTypes', ctconf_get('uploadFileTypes','pdf'), 15, 32, false, '<br>'.ct('S_ADMIN_TOOL_MASTERDATA_UPLOAD_FILETYPES_INFO').'<br>'.ct('S_FORM_CSV'));
	/*$form->add_textarea_lang(ct('S_ADMIN_TOOL_MASTERDATA_UPLOAD_FILEINFO'),'form_uploadFileInfo',
					ctconf_get('uploadFileInfo','Please do only use <strong>PostScript</strong> or <strong>PDF</strong> as document format and compress the file only with <strong>ZIP</strong> or <strong>gzip</strong>.'),
					ctconf_get('uploadFileInfo2','Verwenden Sie bitte als Dokumentformat ausschlielich <strong>PostScript</strong> oder <strong>PDF</strong> und komprimieren Sie nur mit <strong>ZIP</strong> oder <strong>gzip</strong>.'),
					ctconf_get('uploadFileInfo3','Slo se aceptan los formatos <b>PostScript</b> o <b>PDF</b> sin comprimir.'),
					ctconf_get('uploadFileInfo4','Merci de n\'utiliser que <b>PostScript</b> ou <b>PDF</b> comme format et <b>ZIP</b> ou <b>gzip</b> comme compresseur.'),
					50, 3, ct('S_FORM_HTML_OK'));
	*/
}
if (ctconf_get('submission/enabled')) {
	$form->add_separator(ct('S_ADMIN_TOOL_MASTERDATA_REVIEW'));
	$form->add_select(ct('S_ADMIN_TOOL_MASTERDATA_METAREVIEWS'),'form_metaReviews', 1, array(array('1', ct('S_YES')), array('0', ct('S_NO'))), array(ctconf_get('metaReviews','0')), false, '<br>'.ct('S_ADMIN_TOOL_MASTERDATA_METAREVIEWS_HINT'));
	if (ct_test_lib('multi_track.lib'))	{// if multi_track library exists...
		$form->add_select(ct('S_ADMIN_TOOL_MASTERDATA_TRACKS_ASSIGN_CHAIRS'),'form_chairTrackSelect', 1, array(array('1', ct('S_YES')), array('0', ct('S_NO'))), array(ctconf_get('chairTrackSelect','0')), false, '<br>'.ct('S_ADMIN_TOOL_MASTERDATA_TRACKS_ASSIGN_CHAIRS_HINT'));
		$form->add_select(ct('S_ADMIN_TOOL_MASTERDATA_TRACKS_ASSIGN_PCS'),'form_pcTrackSelect', 1, array(array('1', ct('S_YES')), array('0', ct('S_NO'))), array(ctconf_get('pcTrackSelect','0')), false, '<br>'.ct('S_ADMIN_TOOL_MASTERDATA_TRACKS_ASSIGN_PCS_HINT'));
		$form->add_select(ct('S_ADMIN_TOOL_MASTERDATA_TRACKS_ASSIGN_TOPICS'),'form_topicsTrackSelect', 1, array(array('1', ct('S_YES')), array('0', ct('S_NO'))), array(ctconf_get('topicsTrackSelect','0')), false, '<br>'.ct('S_ADMIN_TOOL_MASTERDATA_TRACKS_ASSIGN_TOPICS_HINT'));

	}
	$form->add_select(ct('S_ADMIN_TOOL_MASTERDATA_FORUM_DOWNLOADS'),'form_forumDownloads', 1, array(array('1', ct('S_YES')), array('0', ct('S_NO'))), array(ctconf_get('forumDownloads','0')), false, '<br>'.ct('S_ADMIN_TOOL_MASTERDATA_FORUM_DOWNLOADS_HINT'));
}

if (ctconf_get('participation/enabled')) {
	$form->add_separator(ct('S_ADMIN_TOOL_MASTERDATA_REGISTRATION'));
	$form->add_select(ct('S_ADMIN_TOOL_MASTERDATA_REGISTRATION_MEMBERNUMBER'),'form_memberNumber', 1, array(array('1', ct('S_YES')), array('0', ct('S_NO'))), array(ctconf_get('memberNumber',ctconf_get('participation/status_membernumber'))), false, '<br>'.ct('S_ADMIN_TOOL_MASTERDATA_REGISTRATION_MEMBERNUMBER_HINT'));
	$form->add_select(ct('S_ADMIN_TOOL_MASTERDATA_REGISTRATIONTERMS'),'form_registrationTerms', 1, array(array('1', ct('S_YES')), array('0', ct('S_NO'))), array(ctconf_get('registrationTerms',ctconf_get('participation/confirmation'))), false, '<br><span class="font8">'.ct('S_ADMIN_TOOL_MASTERDATA_REGISTRATIONTERMS_HINT').'<br>'.ct('S_PARTICIPATION_REGISTRATIONTERMS').'</span>');
	#$form->add_select(ct('S_ADMIN_TOOL_MASTERDATA_PARTICIPATIONIDENTITIES'),'form_participationIdentities', 1, array(array('false', ct('S_NO')), array('normal', ct('S_ONLIST')), array('online', ct('S_ONLINELIST')), array('full', ct('S_IDENTITIES'))), array(ctconf_get('registrationTerms',ctconf_get('participation/confirmation'))), false, '<br>'.ct('S_ADMIN_TOOL_MASTERDATA_PARTICIPATIONIDENTITIES_HINT'));
	
	$form->add_separator(ct('S_ADMIN_TOOL_MASTERDATA_CURRENCYDATA'));
	$form->add_text(ct('S_ADMIN_TOOL_MASTERDATA_CURRENCY_CODE'),'form_currencyCode', ctconf_get('currencyCode','EUR'), 12, 16);
	$form->add_text(ct('S_ADMIN_TOOL_MASTERDATA_CURRENCY_SYMBOL'),'form_currencySymbol', ctconf_get('currencySymbol','&euro;'), 12, 16);
	
	$form->add_separator(ct('S_ADMIN_TOOL_MASTERDATA_INVOICEDATA'));
	$form->add_select(ct('S_ADMIN_TOOL_MASTERDATA_INVOICE_WITHVAT'),'form_conferenceWithVAT', 1, array(array('1', ct('S_YES')), array('0', ct('S_NO'))), array(ctconf_get('conferenceWithVAT','1')), false, ct('S_ADMIN_TOOL_MASTERDATA_INVOICE_WITHVAT_HINT'));
	$form->add_select(ct('S_ADMIN_TOOL_MASTERDATA_INVOICE_NETGROSS'),'form_conferenceNetPrices', 1, array(array('1', ct('S_ADMIN_TOOL_MASTERDATA_INVOICE_NET')), array('0', ct('S_ADMIN_TOOL_MASTERDATA_INVOICE_GROSS'))), array(ctconf_get('conferenceNetPrices','0')), false, '<br>'.ct('S_ADMIN_TOOL_MASTERDATA_INVOICE_NETGROSS_HINT'));
	$form->add_spacer();
	$form->add_select(ct('S_ADMIN_TOOL_MASTERDATA_INVOICE_PROFORMA'),'form_invoiceProforma', 1, array(array('1', ct('S_YES')), array('0', ct('S_NO'))), array(ctconf_get('invoiceProforma','0')), false, ct('S_ADMIN_TOOL_MASTERDATA_INVOICE_PROFORMA_HINT'));
	$form->add_textarea(ct('S_ADMIN_TOOL_MASTERDATA_INVOICE_SENDER'),'form_invoiceSender', ctconf_get('invoiceSender',"Department abc<br>\nUniversity of ABC<br>\nProf. Dr. XYZ<br>\nStreet 000<br>\nZIP, Town<br>\nCountry"), 40, 5, false, ct('S_FORM_HTML_OK'));
	$form->add_text(ct('S_ADMIN_TOOL_MASTERDATA_INVOICE_SENDERCITY'),'form_invoiceSenderCity', ctconf_get('invoiceSenderCity','Hamburg'), 30, 64);
	$form->add_text(ct('S_ADMIN_TOOL_MASTERDATA_INVOICE_TAXNO'),'form_invoiceTaxNo', ctconf_get('invoiceTaxNo','DE-123451234'), 20, 30, false, '<br>'.ct('S_ADMIN_TOOL_MASTERDATA_INVOICE_TAXNO_INFO'));
	$form->add_textarea(ct('S_ADMIN_TOOL_MASTERDATA_INVOICE_HEADER'),'form_invoiceHeader', ctconf_get('invoiceHeader',''), 50, 3, '', ct('S_FORM_PRINTONLY').'<br>'.ct('S_FORM_HTML_OK'));
	$form->add_textarea(ct('S_ADMIN_TOOL_MASTERDATA_INVOICE_FOOTER'),'form_invoiceFooter', ctconf_get('invoiceFooter',''), 50, 3, '', ct('S_FORM_PRINTONLY').'<br>'.ct('S_FORM_HTML_OK'));
	$form->add_text(ct('S_ADMIN_TOOL_MASTERDATA_INVOICEPREFIX'),'form_invoicePrefix', ctconf_get('invoicePrefix','CT-'), 15, 255);
	$form->add_text(ct('S_ADMIN_TOOL_MASTERDATA_INVOICENO_DIGITS'),'form_invoiceDigits', ctconf_get('invoiceDigits','5'), 2, 2);
	$form->add_text(ct('S_ADMIN_TOOL_MASTERDATA_INVOICENO_NEXT'),'form_invoiceNo', ctconf_get('invoiceNo','00001'), 11, 11);
	
	$form->add_separator(ct('S_ADMIN_TOOL_MASTERDATA_PAYMENT'));
	$form->add_label('',ct('S_ADMIN_TOOL_MASTERDATA_PAYMENT_INFO'));
	$form->add_select(ct('S_ADMIN_TOOL_MASTERDATA_PAYMENT_CASH'),'form_paymentCash', 1, array(array('1', ct('S_YES')), array('0', ct('S_NO'))), array(ctconf_get('paymentCash','0')), false, '');
	$form->add_subseparator(ct('S_ADMIN_TOOL_MASTERDATA_PAYMENT_CHEQUE'));
	$form->add_select(ct('S_ADMIN_TOOL_MASTERDATA_PAYMENT_CHEQUE'),'form_paymentCheque', 1, array(array('1', ct('S_YES')), array('0', ct('S_NO'))), array(ctconf_get('paymentCheque','0')), false, '');
	$form->add_text(ct('S_ADMIN_TOOL_MASTERDATA_PAYMENT_CHEQUE_PAYABLETO'),'form_paymentChequePayableTo', ctconf_get('paymentChequePayableTo','Jane Doe, University of Hamburg'), 50, 255);
	$form->add_textarea(ct('S_ADMIN_TOOL_MASTERDATA_PAYMENT_CHEQUE_RECEIVER'),'form_paymentChequeReceiver', ctconf_get('paymentChequeReceiver',"Department abc\nUniversity of ABC\nMrs. Jane Smith\nStreet 000\nZIP, Town\nCountry"), 40, 5, false, ct('S_FORM_PLAINTEXT_ONLY'));

	$form->add_subseparator(ct('S_ADMIN_TOOL_MASTERDATA_PAYPALDATA'));
	$form->add_select(ct('S_ADMIN_TOOL_MASTERDATA_PAYPAL'),'form_paymentPaypal', 1, array(array('1', ct('S_YES')), array('0', ct('S_NO'))), array(ctconf_get('paymentPaypal','0')), false, '<br>'.ct('S_ADMIN_TOOL_MASTERDATA_PAYPAL_HINT'));
	$form->add_select(ct('S_ADMIN_TOOL_MASTERDATA_PAYPAL_DEMO'),'form_paymentPaypalDemo', 1, array(array('1', ct('S_YES')), array('0', ct('S_NO'))), array(ctconf_get('paymentPaypalDemo','1')), false, '<br><a href="https://developer.paypal.com/">PayPal Developer Central</a>');
	$form->add_text(ct('S_ADMIN_TOOL_MASTERDATA_PAYPAL_ACCOUNT'),'form_paymentPaypalAccount', ctconf_get('paymentPaypalAccount','harald@weinreichs.de'), 40, 255, false, '<br>'.ct('S_ADMIN_TOOL_MASTERDATA_PAYPAL_ACCOUNT_INFO'));
	$form->add_text(ct('S_ADMIN_TOOL_MASTERDATA_PAYPAL_CURRENCY'),'form_paymentPaypalCurrency', ctconf_get('paymentPaypalCurrency','EUR'), 4, 7, false, '<br>'.ct('S_ADMIN_TOOL_MASTERDATA_PAYPAL_CURRENCY_INFO'));

	$form->add_subseparator(ct('S_ADMIN_TOOL_MASTERDATA_TRANSFERDATA'));
	$form->add_select(ct('S_ADMIN_TOOL_MASTERDATA_TRANSFER'),'form_paymentTransfer', 1, array(array('1', ct('S_YES')), array('0', ct('S_NO'))), array(ctconf_get('paymentTransfer','1')), false, '');
	$form->add_text(ct('S_ADMIN_TOOL_MASTERDATA_TRANSFER_ACCOUNTHOLDER'),'form_paymentTransferAccountHolder', ctconf_get('paymentTransferAccountHolder','XXX Jon Doe XXX'), 40, 40);
	$form->add_text(ct('S_ADMIN_TOOL_MASTERDATA_TRANSFER_ACCOUNTNO'),'form_paymentTransferAccountNo', ctconf_get('paymentTransferAccountNo','XXX 012345678 XXX'), 20, 32);
	$form->add_text(ct('S_ADMIN_TOOL_MASTERDATA_TRANSFER_BANKNAME'),'form_paymentTransferBankName', ctconf_get('paymentTransferBankName','XXX Weltbank XXX, D-20000 Hamburg'), 40, 64);
	$form->add_text(ct('S_ADMIN_TOOL_MASTERDATA_TRANSFER_BANKCODE'),'form_paymentTransferBankCode', ctconf_get('paymentTransferBankCode','XXX 10010011 XXX'), 20, 32);
	$form->add_text(ct('S_ADMIN_TOOL_MASTERDATA_TRANSFER_SWIFT'),'form_paymentTransferSWIFT', ctconf_get('paymentTransferSWIFT','GEXX YY X00'), 12, 20, false, '<br>'.ct('S_ADMIN_TOOL_MASTERDATA_TRANSFER_INFO'));
	$form->add_text(ct('S_ADMIN_TOOL_MASTERDATA_TRANSFER_IBAN'),'form_paymentTransferIBAN', ctconf_get('paymentTransferIBAN','DE00 1111 2222 3333 4444 55'), 30, 32, false, '<br>'.ct('S_ADMIN_TOOL_MASTERDATA_TRANSFER_INFO'));
	
	$form->add_separator(ct('S_ADMIN_TOOL_MASTERDATA_CREDITCARDDATA'));
	$form->add_text(ct('S_ADMIN_TOOL_MASTERDATA_CREDITCARD_TYPES'),'form_paymentCreditCardTypes', ctconf_get('paymentCreditCardTypes','Visa, Mastercard, Diners, American Express'), 50, 255, false, '<br>'.ct('S_ADMIN_TOOL_MASTERDATA_CREDITCARD_TYPES_INFO').'<br>'.ct('S_FORM_CSV'));
	$form->add_select(ct('S_ADMIN_TOOL_MASTERDATA_CREDITCARD_USE_CVC'),'form_paymentCreditCardUseCVC', 1, array(array('1', ct('S_YES')), array('0', ct('S_NO'))), array(ctconf_get('paymentCreditCardUseCVC','1')), false, '');
	$form->add_select(ct('S_ADMIN_TOOL_MASTERDATA_CREDITCARD_USE_ISSUENO'),'form_paymentCreditCardUseIssueNo', 1, array(array('1', ct('S_YES')), array('0', ct('S_NO'))), array(ctconf_get('paymentCreditCardUseIssueNo','0')), false, '<br>'.ct('S_PARTICIPATE_CCISSUE_HINT') );
	
	$form->add_subseparator(ct('S_ADMIN_TOOL_MASTERDATA_PAYMENT_FAXDATA'));
	$form->add_select(ct('S_ADMIN_TOOL_MASTERDATA_PAYMENT_FAX'),'form_paymentFax', 1, array(array('1', ct('S_YES')), array('0', ct('S_NO'))), array(ctconf_get('paymentFax','0')), false, '');
	$form->add_textarea(ct('S_ADMIN_TOOL_MASTERDATA_FAX_RECEIVER'),'form_faxReceiver', ctconf_get('faxReceiver',"Department abc<br>\nUniversity of ABC<br>\nProf. Dr. XYZ<br>\nStreet 000<br>\nZIP, Town<br>\nCountry"), 40, 5, false, ct('S_FORM_HTML_OK'));
	$form->add_text(ct('S_ADMIN_TOOL_MASTERDATA_FAXNO_NATIONAL'),'form_faxNoNational', ctconf_get('faxNoNational','040-1234567'), 20, 32);
	$form->add_text(ct('S_ADMIN_TOOL_MASTERDATA_FAXNO_INTERNATIONAL'),'form_faxNoInternational', ctconf_get('faxNoInternational','++49-40-1234567'), 20, 32);
	
	$form->add_subseparator(ct('S_ADMIN_TOOL_MASTERDATA_CREDITCARDDATA_ONLINE'));
	$form->add_select(ct('S_ADMIN_TOOL_MASTERDATA_CREDITCARD'),'form_paymentCreditCard', 1, array(array('1', ct('S_YES')), array('0', ct('S_NO'))), array(ctconf_get('paymentCreditCard','0')), false, '');
	$form->add_select(ct('S_ADMIN_TOOL_MASTERDATA_CREDITCARD_USE_ADDRESS'),'form_paymentCreditCardUseAddress', 1, array(array('1', ct('S_YES')), array('0', ct('S_NO'))), array(ctconf_get('paymentCreditCardUseAddress','0')), false, '');
	
	if (ct_test_lib('cc_processor_payflow_link.lib')) {	// if payflow exists...
		$form->add_spacer();
		$form->add_select(ct('S_ADMIN_TOOL_MASTERDATA_CREDITCARD_USE_PAYFLOW'),'form_paymentCreditCardUsePayflow', 1, array(array('1', ct('S_YES')), array('0', ct('S_NO'))), array(ctconf_get('paymentCreditCardUsePayflow','0')), false, '');
	}
	if (ct_test_lib('cc_processor_saferpay.lib')) {	// if saferpay exists...
		$form->add_spacer();
		$form->add_select(ct('S_ADMIN_TOOL_MASTERDATA_CREDITCARD_USE_EXTERNALPROCESSOR', array('SAFERPAY')),'form_paymentCreditCardExternal', 1, array(array('1', ct('S_YES')), array('0', ct('S_NO'))), array(ctconf_get('paymentCreditCardExternal','0')), false, '');
	}
	elseif (ct_test_lib('cc_processor_beanstream.lib'))	{ // if beanstream exists...
		$form->add_spacer();
		$form->add_select(ct('S_ADMIN_TOOL_MASTERDATA_CREDITCARD_USE_EXTERNALPROCESSOR', array('BEANSTREAM')),'form_paymentCreditCardExternal', 1, array(array('1', ct('S_YES')), array('0', ct('S_NO'))), array(ctconf_get('paymentCreditCardExternal','0')), false, '');
	}
	
	$form->add_separator(ct('S_ADMIN_TOOL_MASTERDATA_PAYMENTEXTRA'));
	$form->add_label('',ct('S_ADMIN_TOOL_MASTERDATA_EXTRA_INFO'));
	$form->add_select(ct('S_ADMIN_TOOL_MASTERDATA_EXTRA1'),'form_paymentExtra1', 1, array(array('1', ct('S_YES')), array('0', ct('S_NO'))), array(ctconf_get('paymentExtra1','0')), false, '<br>'.ct('S_PARTICIPATE_PAYMENT_EXTRA1').'<br>'.ct('S_INVOICE_PAYMENT_EXTRA1'));
	$form->add_select(ct('S_ADMIN_TOOL_MASTERDATA_EXTRA2'),'form_paymentExtra2', 1, array(array('1', ct('S_YES')), array('0', ct('S_NO'))), array(ctconf_get('paymentExtra2','0')), false, '<br>'.ct('S_PARTICIPATE_PAYMENT_EXTRA2').'<br>'.ct('S_INVOICE_PAYMENT_EXTRA2'));
	$form->add_select(ct('S_ADMIN_TOOL_MASTERDATA_EXTRA3'),'form_paymentExtra3', 1, array(array('1', ct('S_YES')), array('0', ct('S_NO'))), array(ctconf_get('paymentExtra3','0')), false, '<br>'.ct('S_PARTICIPATE_PAYMENT_EXTRA3').'<br>'.ct('S_INVOICE_PAYMENT_EXTRA3'));
}

$form->add_submit('cmd_masterdata_save', ct('S_BUTTON_SAVE'));
$form->add_submit('cmd_masterdata_cancel', ct('S_BUTTON_CANCEL'));

if (ctconf_get('demomode')) $form->demomode=true;
$form->show();


?>