<?php
//
// PAGE:		adminToolPhases
// DESC:		Define dates for different conference phases to activate and deactivate
//		   	    several conftool functions (also automatically by date).
//

ct_requireadmin();
ct_pagepath(array('index','adminTool'));

ct_load_class('CTForm');
ct_load_lib('datetime.lib');


$form_errors=array();
// Save data.
if (isset($http['cmd_phases_save'])) {
	$phases = array('userregistration',
	                'submission', 'selecttopics', 'paperbids', 'reviewing', 'reviewdiscussion', 'reviewresults', 'finalupload',
	                'participation',
	                'frontdesk', 'browseparticipants', 'browsesessions' );
	foreach ($phases as $p) {
		$startdate = $http['form_'.$p.'_start_year']."-".$http['form_'.$p.'_start_month']."-".$http['form_'.$p.'_start_day']." ".$http['form_'.$p.'_start_hour'].":".$http['form_'.$p.'_start_minute'].":".$http['form_'.$p.'_start_second'];
		if ($http['form_'.$p.'_end_hour']==0 and $http['form_'.$p.'_end_minute']==0 and $http['form_'.$p.'_end_second']==0)
			$enddate = $http['form_'.$p.'_end_year']."-".$http['form_'.$p.'_end_month']."-".$http['form_'.$p.'_end_day']." 23:59:59";
	    else
			$enddate = $http['form_'.$p.'_end_year']."-".$http['form_'.$p.'_end_month']."-".$http['form_'.$p.'_end_day']." ".$http['form_'.$p.'_end_hour'].":".$http['form_'.$p.'_end_minute'].":".$http['form_'.$p.'_end_second'];
		if (ct_datetime_2_timestamp($startdate)>ct_datetime_2_timestamp($enddate)) {
			ct_errorbox(ct('S_ERROR_SAVEPHASES'),ct('S_ERROR_SAVEPHASES_DATES'));
			$form_errors[]= 'form_'.$p.'_start';
			$form_errors[]= 'form_'.$p.'_end';
		} else {
			$res = $db->select('phases', 'ID', "ID='".$p."'");
			if ($res and ($db->num_rows($res) > 0)) {
			    $db->update('phases', "ID='".$p."'", array('ID'=>$p,'starts'=>$startdate,'ends'=>$enddate,'active'=>($http['form_'.$p.'_active']=="1" ? "1" : "0")));
			} else {
				$db->insert_into('phases', array('ID'=>$p,'starts'=>$startdate,'ends'=>$enddate,'active'=>($http['form_'.$p.'_active']=="1" ? "1" : "0")));
			}	
		}
	}
	ct_load_phases();
	$session->put_infobox(ct('S_INFO_SAVE'),ct('S_INFO_SAVE_SUCCESS'));
	ct_redirect(ct_pageurl('adminToolPhases')); // Show new title etc.
}



echo "<h1>".ct('S_ADMIN_TOOL_PHASES_TITLE')."</h1>\n";
echo "<p class=\"fontnormal font10\">".ct('S_ADMIN_TOOL_PHASES_INTRO')."</p>\n";

echo '<p class="fontbold font10">'.ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_NAME').': '.ctconf_get('timezoneName','CET').'. '.ct('S_ADMIN_TOOL_MASTERDATA_TIMEZONE_CURRENT').': '.ct_datetime_format(ct_time()).' '.ctconf_get('timezoneName','')."</p>\n\n";


$res = $db->select('phases','ID, starts as starttime, ends as endtime, active');
if ($res and ($db->num_rows($res) > 0)) {
	$phases = array();
	for ($i = 0; $i < $db->num_rows($res); $i++) {
		$row = $db->fetch($res);
		$phases[$row['ID']] = $row;
	}
}

$form = new CTform(ct_pageurl('adminToolPhases'), 'post', $form_errors);
$form->width='100%';
$form->align='center';
$form->formname='phases';
$form->warningmessage=true;

if (ctconf_get('demomode')) $form->demomode=true;

// -- Register new user -----------------------
$form->add_separator(ct('S_ADMIN_TOOL_PHASES_USERREGISTRATION'));
add_phase_form($form,'userregistration',$phases);

// -- submission and reviewing -------------------	
if (ctconf_get('submission/enabled')) { 
	$form->add_separator(ct('S_ADMIN_TOOL_PHASES_SUBMISSION_REVIEW'));

	$form->add_subseparator(ct('S_ADMIN_TOOL_PHASES_SUBMISSION'));
	add_phase_form($form,'submission',$phases);
	if (!ct_check_phase_deactivated('submission')) {
		$form->add_label(ct('S_ADMIN_TOOL_PHASES_CONTRIBUTIONDETAILS'),
				ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_DEADLINE').':</span><br>'.
				get_deadlines_all_contributiontypes('deadline',$phases['submission']['starttime'],$phases['submission']['endtime']).
				''); // '<br><span class="fontbold font8">'.ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_DEADLINE_INFO'));
		$form->add_label(ct('S_ADMIN_TOOL_PHASES_CONTRIBUTIONDETAILS'),
				ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_DEADLINE_UPLOAD').':</span><br>'.
				get_deadlines_all_contributiontypes('deadline_upload',$phases['submission']['starttime'],$phases['submission']['endtime']).
				''); //'<br><span class="fontbold font8">'.ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_DEADLINE_UPLOAD_INFO'));
	}
	
	$form->add_subseparator(ct('S_ADMIN_TOOL_PHASES_SELECTTOPICS'));
	add_phase_form($form,'selecttopics',$phases);
	
	$form->add_subseparator(ct('S_ADMIN_TOOL_PHASES_PAPERBIDS'));
	add_phase_form($form,'paperbids',$phases);
	
	$form->add_subseparator(ct('S_ADMIN_TOOL_PHASES_REVIEWING'));
	add_phase_form($form,'reviewing',$phases);
	if (!ct_check_phase_deactivated('reviewing')) {
		$form->add_label(ct('S_ADMIN_TOOL_PHASES_CONTRIBUTIONDETAILS'),
				ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_DEADLINE_REVIEW').':</span><br>'.
			 	get_deadlines_all_contributiontypes('deadline_review',$phases['reviewing']['starttime'],$phases['reviewing']['endtime']).
				''); //'<br><span class="fontbold font8">'.ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_DEADLINE_REVIEW_INFO'));
	}
	
	$form->add_subseparator(ct('S_ADMIN_TOOL_PHASES_REVIEWDISCUSSION'));
	add_phase_form($form,'reviewdiscussion',$phases);
	
	$form->add_subseparator(ct('S_ADMIN_TOOL_PHASES_REVIEWRESULTS'));
	add_phase_form($form,'reviewresults',$phases);
	if (!ct_check_phase_deactivated('reviewresults')) {
		$form->add_label(ct('S_ADMIN_TOOL_PHASES_CONTRIBUTIONDETAILS'),
				ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_DEADLINE_RESULTS').':</span><br>'. 
				get_deadlines_all_contributiontypes('deadline_results',$phases['reviewresults']['starttime'],$phases['reviewresults']['endtime']).
				''); //'<br><span class="fontbold font8">'.ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_DEADLINE_RESULTS_INFO'));
	}
		
	$form->add_subseparator(ct('S_ADMIN_TOOL_PHASES_FINALUPLOAD'));
	add_phase_form($form,'finalupload',$phases);
	if (!ct_check_phase_deactivated('finalupload')) {
		$form->add_label(ct('S_ADMIN_TOOL_PHASES_CONTRIBUTIONDETAILS'), 
				ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_DEADLINE_FINAL').':</span><br>'.
				get_deadlines_all_contributiontypes('deadline_final',$phases['finalupload']['starttime'],$phases['finalupload']['endtime']).
				''); //'<br><span class="fontbold font8">'.ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_DEADLINE_FINAL_INFO'));
	}
}

// -- conference participation -------------------	
if (ctconf_get('participation/enabled')) {
	$form->add_separator(ct('S_ADMIN_TOOL_PHASES_PARTICIPATION'));
	add_phase_form($form,'participation',$phases);
}

// ---------------------	
$form->add_separator(ct('S_ADMIN_TOOL_PHASES_CONFERENCE'));

// -- frontdesk functions -------------------	
if (ctconf_get('participation/enabled')) {
	$form->add_subseparator(ct('S_ADMIN_TOOL_PHASES_FRONTDESK'));
	add_phase_form($form,'frontdesk',$phases);
}

// -- identity management: List of participants -------------------	
if (ctconf_get('participation/identities')) {
	$form->add_subseparator(ct('S_ADMIN_TOOL_PHASES_BROWSEPARTICIPANTS'));
	add_phase_form($form,'browseparticipants',$phases);
}

// -- browsesessions -------------------	
if (ctconf_get('submission/enabled')) { 
	$form->add_subseparator(ct('S_ADMIN_TOOL_PHASES_BROWSESESSIONS').' (BETA!! - Use with care)');
	add_phase_form($form,'browsesessions',$phases);
}
	
// ---------------------	
$form->add_submit('cmd_phases_save', ct('S_ADMIN_TOOL_PHASES_SAVECMD'));

$form->show();

//-----------------------------------------
// Special functions
//-----------------------------------------

function add_phase_form(&$form,$p,$phases) {
	#$form->add_datetime(ct('S_ADMIN_TOOL_PHASES_STARTTIME'), 'form_'.$p.'_start',true,explode(" ",str_replace("-"," ", str_replace(":"," ", $phases[$p]['starttime'] ) ) ));
	$form->add_date(ct('S_ADMIN_TOOL_PHASES_STARTTIME'), 'form_'.$p.'_start',true,explode(" ",str_replace("-"," ", str_replace(":"," ", $phases[$p]['starttime'] ) ) ));
	$form->add_datetime(ct('S_ADMIN_TOOL_PHASES_ENDTIME'), 'form_'.$p.'_end',true,explode(" ",str_replace("-"," ", str_replace(":"," ", $phases[$p]['endtime'] ) ) ));
	$form->add_check(ct('S_ADMIN_TOOL_PHASES_ACTIVE'), array(array('form_'.$p.'_active','1','',$phases[$p]['active'])));
	$form->add_label(ct('S_ADMIN_TOOL_PHASES_ISACTIVE'),  get_current_state_string($p));
}	

function get_current_state_string($phase) {
	if (ct_check_phases($phase))
		return '<span class="fontpositive fontbold font10">'.ct('S_ADMIN_TOOL_PHASES_ACTIVE_YES').'</span><br>'.ct('S_PHASES_TIMELEFT').': '.ct_get_phase_timeout_formatted($phase);
	else
		return '<span class="fontnegative fontbold font10">'.ct('S_ADMIN_TOOL_PHASES_ACTIVE_NO').'</span>';
}

// I know this is clumsy code... I will change that for one of the next versions...
function get_deadlines_all_contributiontypes($deadline,$masterstart,$masterend) {
	$return = '';
	ct_load_lib('papers.lib');
	$ctypes = ct_get_contributiontypes();
	$return.= "<table width='100%' cellpadding=2 class=\"table_noborder\">";
	while (list(,$v) = each($ctypes)) {
		if ($v['active']!='true' && ($deadline=='deadline' || $deadline=='deadline_upload')) {
			$class = 'fontnegative';
			$deadlinetext = ct('S_NEWPAPER_SUBMISSIONDEACTIVATED').'</span><br><span class="font8 fontgray">('.ct_datetime_format($masterstart).' - '.ct_datetime_format($v[$deadline]).")";
		// The contributiontype can have an earlier ending deadline
		} elseif ($deadline=='deadline' || $deadline=='deadline_upload' || $deadline=='deadline_review' || $deadline=='deadline_final') { 
			$contributiondeadline = $v[$deadline];
			// If deadline of this submission is after the upload deadline, the uploads are also allowed until the submission deadline.
			if ($deadline=='deadline_upload' && ct_datetime_2_timestamp($v['deadline_upload'])<ct_datetime_2_timestamp($v['deadline'])) { $contributiondeadline = $v['deadline']; }
			if (ct_datetime_2_timestamp($masterstart)<ct_time() &&
					(ct_datetime_2_timestamp($contributiondeadline)>ct_time() && ct_datetime_2_timestamp($masterend)>ct_time())) {
				$class = 'fontpositive';	// OK, active
			} else {
				$class = 'fontnegative';	// Not OK, disabled.
			}
			if (ct_datetime_2_timestamp($contributiondeadline)<=ct_datetime_2_timestamp($masterend)) {
				// An earlier deadline was set.
				$deadlinetext = ct_datetime_format($masterstart).' - '.ct_datetime_format($v[$deadline]);	// A later deadline was set
				$class .= ' fontbold';
			} else {
				$deadlinetext = ct_datetime_format($masterstart).' - '.ct_datetime_format($masterend).'</span><br><span class="font8 fontgray">('.ct_datetime_format($masterstart).' - '.ct_datetime_format($contributiondeadline).")";
			}
		// The contributiontype can have a later starting date
		} elseif ($deadline=='deadline_results') { 
			if (ct_datetime_2_timestamp($masterend)>ct_time() &&
					(ct_datetime_2_timestamp($v[$deadline])>ct_time() || ct_datetime_2_timestamp($masterstart)>ct_time())) {
				$class = 'fontnegative';
			} else {
				$class = 'fontpositive';
			}
			if (ct_datetime_2_timestamp($v[$deadline])>=ct_datetime_2_timestamp($masterstart)) {
				// An later deadline was set.
				$deadlinetext = ct_datetime_format($v[$deadline]).' - '.ct_datetime_format($masterend);	
				$class .= ' fontbold';
			} else {
				$deadlinetext = ct_datetime_format($masterstart).' - '.ct_datetime_format($masterend).'</span><br><span class="font8 fontgray">('.ct_datetime_format($v[$deadline]).' - '.ct_datetime_format($masterend).")";
			}
		} else {
			$class = 'fontnegative';
			$deadlinetext = ct_datetime_format($v[$deadline]);
		}
		$return.= "<tr><td valign=top class='topline_white'><span class='font8 $class'>".ct_form_encode($v[ctlx($v,'title')])."</span></td>";
		$return.= "<td valign=top class='topline_white' nowrap><span class='font8 $class'>".$deadlinetext."</span></td></tr>\n";
	}
	$return .= "</table>\n";
	return $return;
}


?>
