<?php
//
// PAGE:		adminToolSessions
// DESC:		Enter, edit and show Sessions of conference.
//

ct_requireadmin();
ct_pagepath(array('index','adminTool'));

ct_load_lib('papers.lib');
ct_load_class('CTForm');

$session->del('db_sessions'); // delete buffered sessions...
$session->del('db_session_room_names'); // Also delete session rooms...

$form_errors=array();

if (isset($http['cmd_sessions_save']) && $http['form_shorttitle']!='') {
	if ($http['form_starttime_day'] > 0 && $http['form_starttime_year'] > 0) {
		$http['form_starttime'] = $http['form_starttime_year']."-".$http['form_starttime_month']."-".$http['form_starttime_day']." ".$http['form_starttime_hour'].":".$http['form_starttime_minute'].":".$http['form_starttime_second'];
		$http['form_endtime'] = $http['form_starttime_year']."-".$http['form_starttime_month']."-".$http['form_starttime_day']." ".$http['form_endtime_hour'].":".$http['form_endtime_minute'].":".$http['form_endtime_second'];
	}
	$db->replace_into('sessions', array('ID'=>$http['form_id'],
													'shorttitle'=>$http['form_shorttitle'],
													'chairID'=>$http['form_chairID'],
													'title'=>$http['form_title'], 'title2'=>$http['form_title2'], 'title3'=>$http['form_title3'], 'title4'=>$http['form_title4'],
													'info'=>$http['form_info'], 'info2'=>$http['form_info2'], 'info3'=>$http['form_info3'], 'info4'=>$http['form_info4'],
													'roomID'=>$http['form_roomID'],
													'starttime'=>$http['form_starttime'],
													'endtime'=>$http['form_endtime'],
													'show_abstracts'=>$http['form_show_abstracts'],'show_downloads'=>$http['form_show_downloads']));
}
if (isset($http['cmd_sessions_create']) && $http['form_shorttitle']!='') {
	if ($http['form_starttime_day'] > 0 && $http['form_starttime_year'] > 0) {
		$http['form_starttime'] = $http['form_starttime_year']."-".$http['form_starttime_month']."-".$http['form_starttime_day']." ".$http['form_starttime_hour'].":".$http['form_starttime_minute'].":".$http['form_starttime_second'];
		$http['form_endtime'] = $http['form_starttime_year']."-".$http['form_starttime_month']."-".$http['form_starttime_day']." ".$http['form_endtime_hour'].":".$http['form_endtime_minute'].":".$http['form_endtime_second'];
	}
	$r = $db->select("sessions","ID","shorttitle='".$http['form_shorttitle']."'");
	if ($r && ($db->num_rows($r) > 0)) {
		ct_errorbox(ct('S_ERROR_SAVE'),ct('S_ERROR_SAVE_EXISTS'));
		$form_errors[]="form_shorttitle";
	} else
		$db->insert_into('sessions', array('ID'=>0, 'shorttitle'=>$http['form_shorttitle'],
													'chairID'=>$http['form_chairID'],
													'title'=>$http['form_title'], 'title2'=>$http['form_title2'], 'title3'=>$http['form_title3'], 'title4'=>$http['form_title4'],
													'info'=>$http['form_info'], 'info2'=>$http['form_info2'], 'info3'=>$http['form_info3'], 'info4'=>$http['form_info4'],
													'roomID'=>$http['form_roomID'],
													'starttime'=>$http['form_starttime'],
													'endtime'=>$http['form_endtime'],
													'show_abstracts'=>$http['form_show_abstracts'],'show_downloads'=>$http['form_show_downloads']));

}
if (isset($http['cmd_sessions_delete'])) {
	if (ct_papers_exist("track=".$http['form_session'])) ct_errorbox(ct('S_ERROR_EDITPAPERDATA'),ct('S_ERROR_EDITPAPERDATA_NODELETE'));
	else $db->delete("sessions","id='".$http['form_session']."'");
}

echo "<h1>".ct('S_ADMIN_TOOL_SESSIONS_TITLE')."</h1>\n";
echo "<p class=\"fontnormal font10\">".ct('S_ADMIN_TOOL_SESSIONS_INTRO')."</p>\n";

$sessions = ct_list_sessions();

// Put all chairs in one array...
$chairs=array();
$chairs[] = array('0',ct('S_ADMIN_TOOL_SESSIONS_NOCHAIR'));
$r = $db->query("select ID, name, firstname, organisation, country from persons order by name");
if ($r and ($db->num_rows($r) > 0)) {
	for ($i = 0; $i < $db->num_rows($r); $i++) {
		$row = $db->fetch($r);
		$chairs[] = array($row['ID'], ($row['name'].', '.$row['firstname'].' ('.((strlen($row['organisation'])>20)?(substr($row['organisation'],0,20).'...'):$row['organisation']).', '.$row['country'].')'));
	}
}

// Put all rooms in one array...
$rooms=array();
$rooms[] = array('0',ct('S_ADMIN_TOOL_SESSIONS_NOROOM'));
$rooms=array_merge($rooms,ct_list_session_rooms());


$form1 = new CTform(ct_pageurl('adminToolSessions'), 'post');
$form1->width='550';
$form1->align='center';
if (ctconf_get('demomode')) $form1->demomode=true;
$form1->add_select(ct('S_PAPER_FORM_SESSIONS'), 'form_session', 10, $sessions, array(), false);
$form1->add_submit('cmd_sessions_delete', ct('S_ADMIN_TOOL_SESSIONS_DELETECMD'));
$form1->add_submit('cmd_sessions_edit', ct('S_ADMIN_TOOL_SESSIONS_EDITCMD'));
$form1->add_submit('cmd_sessions_copy', ct('S_ADMIN_TOOL_SESSIONS_COPYCMD'));
$form1->show();

$form2 = new CTForm(ct_pageurl('adminToolSessions'), 'post', $form_errors);
$form2->width='100%';
$form2->align='center';
$form2->formname='sessions';
$form2->warningmessage=true;

if (ctconf_get('demomode')) $form2->demomode=true;

if (isset($http['cmd_sessions_edit']) && isset($http['form_session']) && ($http['form_session'] != "")) {
	echo "<p class=\"fontnormal font10\">".ct('S_ADMIN_TOOL_SESSIONS_EDITINTRO')."</p>\n";
	$form2->add_hidden(array(array('form_id', $http['form_session'])));
	$form2->add_label(ct('S_ID'),$http['form_session']);
	$r = $db->query("select * from sessions where id='".$http['form_session']."'");
	if ($r && ($db->num_rows($r) > 0)) {
		$s = $db->fetch($r);
	}
	$form2->add_submit('cmd_sessions_save', ct('S_ADMIN_TOOL_SESSIONS_SAVECMD'));
	$form2->add_submit('cmd_sessions_cancel', ct('S_BUTTON_CANCEL'));
} elseif (isset($http['cmd_sessions_copy']) && isset($http['form_session']) && ($http['form_session'] != "")) {
	echo "<p class=\"fontnormal font10\">".ct('S_ADMIN_TOOL_SESSIONS_NEWINTRO')."</p>\n";
	$form2->add_submit('cmd_sessions_create', ct('S_ADMIN_TOOL_SESSIONS_CREATECMD'));
	$form2->add_submit('cmd_sessions_cancel', ct('S_BUTTON_CANCEL'));
	$r = $db->query("select * from sessions where id='".$http['form_session']."'");
	if ($r && ($db->num_rows($r) > 0)) {
		$s = $db->fetch($r);
	}
} elseif (count($form_errors)>0) {
	echo "<p class=\"fontnormal font10\">".ct('S_ADMIN_TOOL_SESSIONS_NEWINTRO')."</p>\n";
	$form2->add_submit('cmd_sessions_create', ct('S_ADMIN_TOOL_SESSIONS_CREATECMD'));
	// Set default values
   	$s=ct_form_array_convert($http);
} else {
	echo "<p class=\"fontnormal font10\">".ct('S_ADMIN_TOOL_SESSIONS_NEWINTRO')."</p>\n";
	$form2->add_submit('cmd_sessions_create', ct('S_ADMIN_TOOL_SESSIONS_CREATECMD'));
	// Set default values
	$s['shorttitle']='';
	$s['title']=$s['title2']=$s['title3']=$s['title4']='';
	$s['starttime']=$s['endtime']='';
	$s['chair']=$s['room']='-';
	$s['info']=$s['info2']=$s['info3']=$s['info4']='';
	$s['show_abstracts']='true';
	$s['show_downloads']='false';
}

$form2->add_text(ct('S_ADMIN_TOOL_SESSIONS_FORM_SHORTTITLE'),'form_shorttitle', $s['shorttitle'], 10, 10);
$form2->add_text_lang(ct('S_ADMIN_TOOL_SESSIONS_FORM_TITLE'),'form_title', $s['title'],$s['title2'],$s['title3'],$s['title4'], 50, 255);
$form2->add_spacer();
$form2->add_datetime(ct('S_ADMIN_TOOL_SESSIONS_FORM_STARTTIME'),'form_starttime', true, explode(" ",str_replace("-"," ", str_replace(":"," ", $s['starttime'] ) ) ));
$form2->add_time(ct('S_ADMIN_TOOL_SESSIONS_FORM_ENDTIME'),'form_endtime', explode(" ",str_replace("-"," ", str_replace(":"," ", $s['endtime'] ) ) ));
$form2->add_spacer();
$form2->add_select(ct('S_ADMIN_TOOL_SESSIONS_FORM_CHAIR'), 'form_chairID', 1, $chairs, array($s['chairID']), false);
$form2->add_select(ct('S_ADMIN_TOOL_SESSIONS_FORM_ROOM'), 'form_roomID', 1, $rooms, array($s['roomID']), false);
$form2->add_text_lang(ct('S_ADMIN_TOOL_SESSIONS_FORM_INFO'),'form_info', $s['info'],$s['info2'],$s['info3'],$s['info4'], 50, 255);
$form2->add_separator(ct('S_ADMIN_TOOL_SESSIONS_FORM_SHOW'));
$form2->add_select(ct('S_ADMIN_TOOL_SESSIONS_FORM_SHOW_ABSTRACTS'), 'form_show_abstracts', 1, array(array('true',ct('S_YES')),array('false',ct('S_NO'))), array($s['show_abstracts']), false);
$form2->add_select(ct('S_ADMIN_TOOL_SESSIONS_FORM_SHOW_DOWNLOADS'), 'form_show_downloads', 1, array(array('true',ct('S_YES')),array('false',ct('S_NO'))), array($s['show_downloads']), false);

$form2->show();
?>

