<?php
//
// PAGE:		adminToolVats
// DESC: 	Show, enter and edit VAT rates (Mehrwehrtsteuer)
//

ct_requireadmin();
ct_pagepath(array('index','adminTool'));

ct_load_class('CTForm');
ct_load_lib('participation.lib');


if (isset($http['cmd_vats_save'])) {
	$db->replace_into('vats', array('ID'=>$http['form_id'], 'percentage'=>ct_number_unformat($http['form_percentage'])));
	ct_infobox(ct('S_INFO_SAVE'), ct('S_INFO_SAVE_SUCCESS'));
} elseif (isset($http['cmd_vats_create']) && $http['form_percentage']!="") {
	$db->insert_into('vats', array('ID'=>0, 'percentage'=>ct_number_unformat($http['form_percentage'])));
	ct_infobox(ct('S_INFO_SAVE'), ct('S_INFO_SAVE_SUCCESS'));
} elseif (isset($http['cmd_vats_delete'])) {
	if (ct_participants_exist() || $http['form_vat']<2) ct_errorbox(ct('S_ERROR_EDITPARTICIPATIONDATA'),ct('S_ERROR_EDITPARTICIPATIONDATA_NODELETE'));
    else $db->delete("vats","id='".$http['form_vat']."'");
} elseif (isset($http['form_vat']) && $http['form_vat'] != "" && $http['form_vat'] <2 ) {
	ct_errorbox(ct('S_ERROR_EDITPARTICIPATIONDATA'),ct('S_ERROR_EDITPARTICIPATIONDATA_NOEDIT'));
} elseif (ct_participants_exist()) {
	ct_warningbox(ct('S_ERROR_EDITPARTICIPATIONDATA'),ct('S_ERROR_EDITPARTICIPATIONDATA_PARTICIPATS_EXISTS'));
}

echo "<h1>".ct('S_ADMIN_TOOL_VATS_TITLE')."</h1>\n";
echo "<p class=\"fontnormal font10\">".ct('S_ADMIN_TOOL_VATS_INTRO')."</p>\n";

$form1 = new CTform(ct_pageurl('adminToolVats'), 'post');
$form1->width='300';
$form1->align='center';
$form1->add_select(ct('S_PARTICIPATION_FORM_VATS'), 'form_vat', 6, ct_list_vats(), array(), false);
$form1->add_submit('cmd_vats_delete', ct('S_ADMIN_TOOL_VATS_DELETECMD'));
$form1->add_submit('cmd_vats_edit', ct('S_ADMIN_TOOL_VATS_EDITCMD'));
$form1->show();

$form2 = new CTForm(ct_pageurl('adminToolVats'), 'post');
$form2->width='400';
$form2->align='center';
if (ctconf_get('demomode')) $form2->demomode=true;

if (isset($http['cmd_vats_edit']) && isset($http['form_vat']) && $http['form_vat'] != "" && $http['form_vat'] >1 ) {
	echo "<p class=\"fontnormal font10\">".ct('S_ADMIN_TOOL_VATS_EDITINTRO')."</p>\n";
	$form2->add_hidden(array(array('form_id', $http['form_vat'])));
	$r = $db->query("select * from vats where id='".$http['form_vat']."'");
	if ($r && ($db->num_rows($r) > 0)) {
		$vat = $db->fetch($r);
	}
	$form2->add_label(ct('S_ID'),$vat['ID']);
	$form2->add_text(ct('S_ADMIN_TOOL_VATS_FORM_VAT'),'form_percentage', ct_number_format($vat['percentage'],1), 5, 5, false, "%");
	$form2->add_submit('cmd_vats_save', ct('S_ADMIN_TOOL_VATS_SAVECMD'));
} else {
	echo "<p class=\"fontnormal font10\">".ct('S_ADMIN_TOOL_VATS_NEWINTRO')."</p>\n";
	$form2->add_text(ct('S_ADMIN_TOOL_VATS_FORM_VAT'),'form_percentage', ct_number_format(0,1), 5, 5, false, "%");
	$form2->add_submit('cmd_vats_create', ct('S_ADMIN_TOOL_VATS_CREATECMD'));
}
$form2->show();
?>

