<?php
//
// PAGE		adminTracksAssignPCs
// DESC		Assign Reviewers / PC members to Contributiontypes = Tracks of the conference
// needs multi-track library!
//

ct_requireconferenceChair();
ct_pagepath(array('index', 'adminTool'));

if (ctconf_get('pcTrackSelect',false) && ct_test_lib('multi_track.lib')) {	// if multi-track library exists...
	ct_load_lib('multi_track.lib');
} else {
	ct_redirect($session->get_besturl());
}


ct_load_lib('datetime.lib');
ct_load_lib('papers.lib');
ct_load_class('CTPerson');
ct_load_class('CTForm');

$person = new CTPerson();

// check if submitdata was clicked.....
$didsave=false;
// unassign PCs
if (in_http('form_cmd','cmd_unassign') && in_http('form_person') && is_array($http['form_person'])) {
	foreach ($http['form_person'] as $id) {
		$r = $db->delete("contributiontypes2pcs","typeID='".$http['form_id']."' and personID='".$id."'");
		$didsave=true;
	}
}

// assign reviewers
if (in_http('form_cmd','cmd_assign') && in_http('form_person') && is_array($http['form_person'])) {
	foreach ($http['form_person'] as $id) {
		$r = $db->insert_into('contributiontypes2pcs',array('typeID'=>$http['form_id'],'personID'=>$id));
		$didsave=true;
	}
}
if ($didsave) ct_infobox(ct('S_INFO_SAVE'), ct('S_INFO_SAVE_SUCCESS'));

// ------------------------------------------------------------

// show page header
echo "<H1>".ct('S_ADMIN_TRACK_ASSIGN_PCS')."</H1>\n";
echo "<p class=\"fontnormal font10\">".ct('S_ADMIN_TRACK_ASSIGN_PCS_INTRO')."</p>\n";

// get data of contributiontype/track
$type = ct_get_contributiontypes($http['form_id']);
if (count($type)==0) ct_redirect($session->get_besturl());

// Show filter to maybe select another track/type
$form = new CTform('adminTracksAssignPCs', 'get');
$form->width='100%';
$form->align='center';
if (!isset($http['form_id'])) 
	$tracks=array_merge (array(array(0,ct('S_ADMIN_TRACK_ASSIGN_PLEASESELECT'))), ct_list_contributiontypes());
else	
	$tracks=ct_list_contributiontypes();
$form->add_select_autosubmit(ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_CONTRIBUTIONTYPE'), 'form_id', $tracks, array($http['form_id']), false);
$form->add_submit_noscriptonly('cmd_select', ct('S_BUTTON_SUBMIT'));
$form->show();

// this page is useless without an ID for a paper, so only show the rest if ID was set...
if (isset($http['form_id'])) {

	// get already assigned PCs
	$assignedpcs = array();
	$qr = $db->query("SELECT * FROM contributiontypes2pcs where typeID='".$http['form_id']."'");
	if ($qr && ($db->num_rows($qr) > 0)) {
		for ($i = 0; $i < $db->num_rows($qr); $i++) {
			$p = $db->fetch($qr);
			$assignedpcs[]=$p['personID'];
		}
	}
	
	echo mt_get_track_overview($type,'100%');
	
	// Show assigned PC-Members -----------------------------------
	
	echo "<p class=\"fontlabel fontbold  font12\">".ct('S_ADMIN_TRACK_ASSIGN_ALREADYASSIGNED').":</p>";
	
	
	// Create List 
	echo "<form method=\"post\" action=\"".ct_pageurl('adminTracksAssignPCs')."\">\n";
	echo "<input type=hidden name='form_cmd' value=\"cmd_unassign\">\n";
	echo "<input type=hidden name='form_id' value=\"".$http['form_id']."\">";
		
	echo "<table width=\"100%\" align=\"center\">\n";
	if (count($assignedpcs)>0) {
		for ($i = 0; $i < count($assignedpcs); $i++) {
			$person->load_by_id($assignedpcs[$i]);
			mt_show_assign_person('unassign',$i,$person);
		}
		echo "<tr><td colspan=3 align=right class=\"mediumbg_gradient\" width=\"15%\"><input type=\"submit\" class=\"button\" value=\"".ct('S_BUTTON_SAVE')."\"></td></tr>\n";
	} else {
		echo "<tr class=\"oddrow_del\"><td><span class=\"fontbold font10\">&nbsp;".ct('S_REVIEW_ASSIGN_NONEYET')."</span></td></tr>\n";
	}
	echo "</table>\n</form>\n";
	// -------------------------------------------------
	
	
	
	// Show all remaining PC members  -------------------------------------------------
	echo "<p class=\"fontlabel fontbold  font12\">".ct('S_ADMIN_TRACK_ASSIGN_AVAILABLE').":</p>";
	
	
	// Start table output
	echo "<form method=\"post\" action=\"".ct_pageurl('adminTracksAssignPCs')."\">\n";
	echo "<input type=hidden name='form_cmd' value=\"cmd_assign\">\n";
	echo "<input type=hidden name='form_id' value=\"".$http['form_id']."\">";
	
	echo "<table width=\"100%\" align=\"center\">\n";
	
	// now show the rest.
	$qr = $db->query("select * FROM persons WHERE deleted=0 and FIND_IN_SET('pc',persons.status)>0 or FIND_IN_SET('reviewer',persons.status)>0 order by persons.name, persons.firstname");
	
	$i=0;
	if ($qr && ($db->num_rows($qr)>0)) {
		for ($j = 0; $j < $db->num_rows($qr); $j++) {
			$pdata = $db->fetch($qr);
			if (!in_array($pdata['ID'],$assignedpcs)) {
				$person->pdata = $pdata;
				mt_show_assign_person('assign',$i,$person);
				$i++;
			}
		}
	}
	
	echo "<tr><td colspan=3 align=\"right\" class=\"mediumbg_gradient\"><input type=\"submit\" class=\"button\" value=\"".ct('S_BUTTON_SAVE')."\"></td></tr>\n";
	echo "</table>\n</form>\n";
}


?>