<?php
//
// PAGE:		adminTracksAssignTopics
// DESC:		Assign topics to Contributiontypes / Tracks
//

ct_requireconferenceChair();
ct_pagepath(array('index', 'adminTool'));

ct_load_class('CTForm');
ct_load_lib('papers.lib');

if (ctconf_get('topicsTrackSelect',false) && ct_test_lib('multi_track.lib')) {	// if multi-track library exists...
	ct_load_lib('multi_track.lib');
} else {
	ct_redirect($session->get_besturl());
}


// Save data...
if (isset($http['cmd_types2topics_save']) && in_http('form_id')) {
	$db->delete("contributiontypes2topics","typeID='".$http['form_id']."'");
	if (isset($http['form_topics']) && is_array($http['form_topics']) && (sizeof($http['form_topics']) > 0)) {
		foreach ($http['form_topics'] as $id) {
			$db->insert_into('contributiontypes2topics',array('typeID'=>$http['form_id'],'topicID'=>$id));
		}
		ct_infobox(ct('S_INFO_SAVE'),ct('S_INFO_SAVE_SUCCESS'));
	} else { // Nothing selected: Try again!
		#ct_errorbox(ct('S_ERROR_SAVE'), ct('S_ERROR_SAVE_FAILED'));
	}
}

echo "<H1>".ct('S_ADMIN_TRACK_ASSIGN_TOPICS')."</H1>\n";
echo "<p class=\"fontnormal font10\">".ct('S_ADMIN_TRACK_ASSIGN_TOPICS_INTRO')."</p>\n";

// get data of contributiontype/track
$type = ct_get_contributiontypes($http['form_id']);
if (count($type)==0) ct_redirect($session->get_besturl());

// Show filter to maybe select another track/type
$form1 = new CTform('adminTracksAssignTopics', 'get');
$form1->width='80%';
$form1->align='center';
if (!isset($http['form_id'])) 
	$tracks=array_merge (array(array(0,ct('S_ADMIN_TRACK_ASSIGN_PLEASESELECT'))), ct_list_contributiontypes());
else	
	$tracks=ct_list_contributiontypes();
$form1->add_select_autosubmit(ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_CONTRIBUTIONTYPE'), 'form_id', $tracks, array($http['form_id']), false);
$form1->add_submit_noscriptonly('cmd_select', ct('S_BUTTON_SUBMIT'));
$form1->show();

// this page is useless without an ID for a paper, so only show the rest if ID was set...
if (isset($http['form_id'])) {

	// get already assigned chairs
	$assignedtopics = array();
	$qr = $db->query("SELECT * FROM contributiontypes2topics where typeID='".$http['form_id']."'");
	if ($qr && ($db->num_rows($qr) > 0)) {
		for ($i = 0; $i < $db->num_rows($qr); $i++) {
			$p = $db->fetch($qr);
			$assignedtopics[]=$p['topicID'];
		}
	}
	
	echo mt_get_track_overview($type,'80%');
	
	ct_vspacer('10');
	
	$form2 = new CTform(ct_pageurl('adminTracksAssignTopics'), 'post');
	$form2->width='500';
	$form2->align='center';
	$form2->add_hidden(array(array('form_id', $http['form_id'])));
	
	$topics = ct_get_topics();
	$topicboxes = array();	// Create array for topics...
	foreach ($topics as $t) {
		$topicboxes[]=array('form_topics[]',$t[0],$t[1],in_array($t[0],$assignedtopics),false);
	}
	$form2->add_check("* ".ct('S_PAPER_FORM_TOPICS'), $topicboxes);
	
	$form2->add_submit('cmd_types2topics_save', ct('S_PC2TOPICS_FORM_SAVECMD'));
	$form2->show();
}

ct_vspacer('10');

?>
