<?php
//
// PAGE:		adminUsersBrowse
// DESC:		Show a list of all Conftool users
//

ct_requireassistantorconferencechair();
ct_pagepath(array('index','adminUsers'));

ct_load_class('CTForm');
ct_load_lib('admin.lib');


$session->set_besturl(ct('S_ADMIN_USERS_BROWSE_QUICK'));
echo "<H1>".ct('S_ADMIN_USERS_BROWSE_CMD')."</H1>\n";
echo "<p class=\"fontnormal font10\">".ct('S_ADMIN_USERS_BROWSE_INTRO')."</p>\n";

$where = "where 1 ";

// Search string from navbar
$search     = isset($http['navbar_search'])?$http['navbar_search']:"";
if ($search!="") {
 	if ( preg_match("/^[0-9]+$/", $search) ) {
		$where .= " && (persons.ID = ".$search.") ";
	} else {
		$where .= " && UPPER(CONCAT(persons.name,'|',persons.firstname,'|',persons.organisation,'|',persons.city,'|',persons.country,'|',persons.email,'|',persons.username)) LIKE UPPER('%".$search."%') ";
	}
}

if (!isset($http['form_deleted']) || $http['form_deleted']=="no") {
	$where .= " && deleted=0";
} elseif ($http['form_deleted']=="yes") {
	# NIL
} elseif ($http['form_deleted']=="only") {
	$where .= " && deleted=1";
}

if (isset($http['form_status']) && !$http['form_status']==0 ) {
	if ($http['form_status']=='NONE')
		$where .= " && status=''";
	elseif ($http['form_status']=='NOTparticipant')
		$where .= " && FIND_IN_SET('participant',status)=0";
	elseif ($http['form_status']=='authorNOTparticipant')
		$where .= " && FIND_IN_SET('participant',status)=0 && FIND_IN_SET('author',status)>0";
	else
		$where .= " && FIND_IN_SET('".$http['form_status']."',status)>0";
}

// Set order of list
$order = ' order by name asc, firstname asc';
if (isset($http['listorder'])) {
	switch ($http['listorder']) {
		case 'org':
		$order = ' order by organisation asc, name asc';
		break;
		case 'username':
		$order = ' order by username asc';
		break;
		case 'id':
		$order = ' order by id asc';
		break;
		case 'name':
		$order = ' order by name asc, firstname asc';
		break;
		case 'country':
		$order = ' order by country asc, name asc, firstname asc';
		break;
	}
}

$query = "select persons.*, count(papers.ID) as papercount from persons";
$query.= " LEFT JOIN papers ON (persons.ID=papers.personID AND papers.withdrawn=0)";
$query.= " $where GROUP BY persons.ID $order";
// echo $query;
$r = $db->query($query);

// Here comes the filter...
$form1 = new CTform('adminUsersBrowse', 'get');
$form1->width='100%';
$form1->align='center';
$form1->add_hidden(hash2aa(ct_http_array(array('filter'=>'show'))));
$form1->add_select_autosubmit(ct('S_USER_STATUS_ONLY'), 'form_status', array(array('0',ct('S_ADMIN_TOOL_ALLPERSONS')),
	array('author',ct('S_USER_STATUS_AUTHOR')),
	array('coauthor',ct('S_USER_STATUS_COAUTHOR')),
	array('0','------'),
	array('participant',ct('S_USER_STATUS_PARTICIPANT')),
	array('NOTparticipant',ct('S_USER_STATUS_NOTPARTICIPANT')),
	array('authorNOTparticipant',ct('S_USER_STATUS_AUTHOR_NOTPARTICIPANT')),
	array('0','------'),
	array('chair',ct('S_USER_STATUS_CHAIR')),
	array('pc',ct('S_USER_STATUS_PC')),
	array('reviewer',ct('S_USER_STATUS_REVIEWER')),
	array('0','------'),
	array('admin',ct('S_USER_STATUS_ADMIN')),
	array('conferenceChair',ct('S_USER_STATUS_CONFERENCECHAIR')),
	array('assistant',ct('S_USER_STATUS_ASSISTANT')),
	array('frontdesk',ct('S_USER_STATUS_FRONTDESK')),
	array('NONE',ct('S_USER_STATUS_NONE'))),
	array($http['form_status']), false);
if ($user->is_admin()) {
	$form1->add_select_autosubmit(ct('S_ADMIN_USERS_BROWSE_DELETED'), 'form_deleted', array(
		array('no',ct('S_ADMIN_USERS_BROWSE_HIDEDELETED')),
		array('yes',ct('S_ADMIN_USERS_BROWSE_SHOWDELETED')),
		array('only',ct('S_ADMIN_USERS_BROWSE_ONLYDELETED'))),
		array($http['form_deleted']), false);
}
$form1->add_submit_noscriptonly('cmd_search', ct('S_ADMIN_TOOL_SUBMIT'));
$form1->show();

if ($r >= 0) {
	ctadm_listusers($r, 'adminUsersBrowse'); // -> admin.lib
}

?>
