<?php
//
// PAGE: adminUsersEditDelete
// Edit/delete/undelete user of ConfTool.
//

ct_pagepath(array('index'));

ct_requireassistantorconferencechair();

ct_load_lib('mail.lib');
ct_load_lib('person.lib');
ct_load_lib('password.lib');
ct_load_class('CTForm');
ct_load_class('CTPerson_Form');

$person = new CTPerson_Form;
$oldperson = new CTPerson;
$form_errors = array();
$sameusername=0;
$samemail=0;

// check if user is allowed to edit the user data and necessary parameters are present.
if  (!isset($http['form_userID']) && !isset($http['form_id']) && !isset($http['form_delete_id'])) {
	$session->put_errorbox(ct('S_ERROR_PERSON_EDIT'), ct('S_ERROR_PERSON_EDIT_NOACCESS'));
	ct_redirect(ct_pageurl('error'));
}

// Save person data?
if (isset($http['cmd_save_person'])) {

	// load old data as default (some values like the status or internal remarks may not be submitted
	$person->load_by_id($http['form_id']);
	// load also a copy of the current person.	
	$oldperson->load_by_id($http['form_id']);

	// test form entries...
	$person->process_form();
	if ($http['form_gender']=="") 		 $form_errors[]='form_gender';
	if ($http['form_name']=="") 		 $form_errors[]='form_name';
	if ($http['form_firstname']=="") 	 $form_errors[]='form_firstname';
	if (strlen($http['form_country'])<2) $form_errors[]='form_country';
	// Check email. It may also stay the same as before, even if it was invalid...
	if ($person->get('email')!=$oldperson->get('email') && !ct_validate_email($http['form_email']) ) 
										$form_errors[]='form_email';
	// Only admin can change username and password!
	if ($user->is_admin()) {
		if (!ct_validate_username($http['form_username'])) 
			$form_errors[]='form_username';
		if ($person->get('passwordencrypted') && stristr($http['form_pwd'],'*****') && stristr($http['form_pwd2'],'*****')) {
			//NOP - password was already encrypted, checked before and was not changed.
		} else { 
			$msg = ct_validate_password($http['form_pwd'],$person);
			if (count($msg)>0) {
				ct_errorbox(ct('S_ERROR_SAVEUSER'), '<ul><li>'.implode('<li>',$msg).'</ul>');
				$form_errors[]='form_pwd';
			}
			if ($http['form_pwd']!=$http['form_pwd2']) {
				ct_errorbox(ct('S_ERROR_SAVEUSER'), ct('S_ERROR_REGISTER_PASSWORD_NOMATCH'));
				$form_errors[]='form_pwd2';
			}
		}
		// test if username exists (also consider deleted users)
		if (isset($http['form_username']) && $http['form_username']!="") {
			$r = $db->query("select ID from persons where username='".$http['form_username']."' and ID!='".$http['form_id']."'");
			$sameusername = $db->num_rows($r);
		}
	}

	// test if mail exists (don't consider deleted users.)
	if (isset($http['form_email']) && $http['form_email']!="") { 
		$r = $db->query("select ID from persons where (email='".$http['form_email']."' or email2='".$http['form_email']."') and (deleted=0) AND ID!='".$http['form_id']."'");
		$samemail = $db->num_rows($r);
	}

	/// -----------------------
	
	// try to SAVE user data
	if ( count($form_errors)==0 && $sameusername==0 && ( $samemail==0 || $person->get('email')==$oldperson->get('email') )  ) {
		// No critical errors: SAVE DATA

		if ($samemail>0) // warning that mail already exists...
			$session->put_warningbox(ct('S_WARNING_ADMIN_USERS_NEW'), ct('S_WARNING_ADMIN_USERS_NEW_MAILEXISTS'));

		if ($person->get('deleted')!=0) {
			$person->undelete();
			$session->put_infobox(ct('S_INFO_UNDELETEUSER'), ct('S_INFO_UNDELETEUSER_SUCCESS'));
		} else {
	 		$person->persist();
			$session->put_infobox(ct('S_INFO_SAVEUSER'),ct('S_INFO_SAVEUSER_SUCCESS'));
		}
 		if ($person->get('username')!=$oldperson->get('username'))
	        $session->put_warningbox(ct('S_INFO_SAVEUSER'),ct('S_INFO_SAVEUSER_NEWUSERNAME',array($person->get('username'))));
 		if ($person->get('password')!=$oldperson->get('password') && strlen($oldperson->get('password'))==32)
	        $session->put_warningbox(ct('S_INFO_SAVEUSER'),ct('S_INFO_SAVEUSER_NEWPASSWORD'));
		
		$user->reload(); // reload user data, maybe it changed...

		ct_redirect($session->get_besturl());

	// Too many errors: do not save		
	} else {
		if (is_array($form_errors) && in_array("form_email",$form_errors)) 
			ct_errorbox(ct('S_ERROR_SAVEUSER'), ct('S_ERROR_REGISTER_EMAIL_INVALID'));
		elseif ($sameusername) {
			ct_errorbox(ct('S_ERROR_SAVEUSER'), ct('S_ERROR_PERSON_EDIT_USERNAMEEXISTS'));
			$form_errors[]='form_username';
		} elseif ($samemail) {
			ct_errorbox(ct('S_ERROR_SAVEUSER'), ct('S_ERROR_REGISTER_EMAILEXISTS'));
			$form_errors[]='form_email';
		} else
		ct_errorbox(ct('S_ERROR_SAVEUSER'), ct('S_ERROR_SAVEUSER_FAILED'));
		// => show form again 
		echo "<h1>".ct('S_EDITPERSON_TITLE')."</h1>\n";
		$person->show_form(ct_pageurl('adminUsersEditDelete'), $form_errors);
	}
}
// cancel?
else if(isset($http['cmd_cancel'])){
	ct_redirect($session->get_besturl());
}
// confirm delete person?
else if (isset($http['form_delete_id']) ) {
	// Don't delete Administrator or yourself
	$person->load_by_id($http['form_delete_id']);
	if ($http['form_delete_id']!=$user->get('ID') && $person->get_id()!=1 && ($user->is_admin() || !$person->is_admin()) ) {
		echo "<h1>".ct('S_DELETEUSER_TITLE')."</h1>\n";
		echo "<p class=\"fontnormal font10\">".ct('S_DELETEUSER_QUERY')."</p>\n";
		$person->show_shortinfo('600');
		$form = new CTForm(ct_pageurl('adminUsersEditDelete'), 'post', array());
		$form->width='600';
		$form->align='center';
		$form->add_hidden(array(array('form_userID', $http['form_delete_id'])));
		$form->add_submit('cmd_delete_person', ct('S_DELETEUSER_CONFIRM'));
		$form->add_submit('cmd_cancel', ct('S_BUTTON_CANCEL'));
		$form->show();
	} else {
		$session->put_errorbox(ct('S_ERROR_DELETEUSER'), ct('S_ERROR_DELETEUSER_FAILED'));
		ct_redirect($session->get_besturl());
	}
	
}
// delete person?
else if (isset($http['cmd_delete_person'])) {
	$person->load_by_id($http['form_userID']);
	$person->check_author();
	$person->check_coauthor();
	$person->check_participant();
	$person->persist();
	if ($http['form_userID']!=$user->get('ID') && $person->get_id()!=1 && 
				($user->is_admin() || !$person->is_admin()) ) {
		if ($person->delete()) {
			$session->put_infobox(ct('S_INFO_DELETEUSER'), ct('S_INFO_DELETEUSER_SUCCESS'));
		} else {
			$session->put_errorbox(ct('S_ERROR_DELETEUSER'), ct('S_ERROR_DELETEUSER_FAILED'));
		}
		ct_redirect($session->get_besturl());
	} else {
		$session->put_errorbox(ct('S_ERROR_DELETEUSER'), ct('S_ERROR_DELETEUSER_FAILED'));
		ct_redirect(ct_pageurl('error'));
	}
} 
// Show edit person screen
elseif (isset($http['form_userID'])) {
	// read data from database
	if ($person->load_by_id($http['form_userID'])) {
		$person->check_author();
		$person->check_coauthor();
		$person->check_participant();
		$person->persist();
		if ($person->get('deleted')!=0) {
			// undelete person: show other header...
			echo "<h1 class=\"oddrow_del\">".ct('S_INFO_UNDELETEUSER')."</h1>\n";
		} else {
			echo "<h1>".ct('S_EDITPERSON_TITLE')."</h1>\n";
			echo "<p class=\"fontnormal font10\">".ct('S_EDITPERSON_INTRO')."</p>\n";
		}
		$person->show_form(ct_pageurl('adminUsersEditDelete'), $form_errors);
	} else {
		$session->put_errorbox(ct('S_ERROR_PERSON_EDIT'), ct('S_ERROR_IDENTITY_PERSONNOTFOUND'));
		ct_redirect(ct_pageurl('error'));
	}
// nothing applies, show an error!
} else {
	$session->put_errorbox(ct('S_ERROR_PERSON_EDIT'), ct('S_ERROR_PERSON_EDIT_NOACCESS'));
	ct_redirect(ct_pageurl('error'));
}

?>
