<?php
//
// PAGE:		adminUsersNew
// DESC:		allows admins to create a new user account
//

ct_requirefrontdesk(); # Frontdesk people can now also create users - but to
					   # create a participant they still need assistant status - needs to be fixed.
ct_pagepath(array('index','admin','adminUsers'));

ct_load_lib('mail.lib');
ct_load_lib('mail_person.lib');
ct_load_lib('person.lib');
ct_load_lib('password.lib');
ct_load_class('CTPerson_Form');

$person = new CTPerson_Form();
$form_errors = array();

if (isset($http['cmd_save_person']) || isset($http['cmd_save_person_register'])) {
	// test if username exists
	$sameusername=0;
	$samemail=0;
	$form_errors = array();

	// Generate user name and or password
	if (isset($http['form_pwdgenerate']) && $http['form_name']!="") {
		generate_userandpass(); // see below
	}

	if (isset($http['form_username']) && $http['form_username']!="") {
		$sameusername=ct_testusername($http['form_username']);
	}
	// test if mail exists
	if (isset($http['form_email']) && $http['form_email']!="") {
		$r = $db->query("select ID from persons where (email='".$http['form_email']."') and (deleted=0)");
		$samemail = $db->num_rows($r);
	}

	$person->process_form();
	if ($http['form_gender']=="")  		$form_errors[]='form_gender';
	if ($http['form_name']=="") 		$form_errors[]='form_name';
	if ($http['form_firstname']=="") 	$form_errors[]='form_firstname';
	if ($http['form_username']=="") 	$form_errors[]='form_username';
	if (count(ct_validate_password($http['form_pwd']))!=0) $form_errors[] = 'form_pwd';
	// test form entries...
	if (isset($http['form_pwdmail']) && $http['form_pwdmail']=='sendmail') {
		if ($http['form_organisation']=="") 	$form_errors[]='form_organisation';
		if (strlen($http['form_country'])<2)	$form_errors[]='form_country';
		if (!isset($http['form_email']) || $http['form_email'] == '' || !ct_validate_email($http['form_email']))
												$form_errors[]='form_email';
	}
	
	if ($sameusername == 0 && // user OK
			($samemail == 0 || (isset($http['form_pwdmail']) && $http['form_pwdmail']=='nomail')) // mail OK
			 && !$form_errors) { // No critical errors, everything OK.

		if ($samemail>0) // mail already exists...
			$session->put_warningbox(ct('S_WARNING_ADMIN_USERS_NEW'), ct('S_WARNING_ADMIN_USERS_NEW_MAILEXISTS'));

		// send mail to user?
		if (isset($http['form_pwdmail']) && $http['form_pwdmail']=='sendmail' && $person->get('email')!="") {
			// email settings

			// Get text about user status (mail_person.lib).
			$extratext = ct_mail_get_userstatustext($person); 

			// send registration e-mail to user
			ct_mail_user_registration_confirmation($person, true, $extratext);

			$session->put_infobox(ct('S_INFO_ADMIN_USERS_NEW'), ct('S_INFO_ADMIN_USERS_NEW_SUCCESS_MAIL'));
		} else {
			$session->put_infobox(ct('S_INFO_ADMIN_USERS_NEW'), ct('S_INFO_ADMIN_USERS_NEW_SUCCESS'));
		}
		// Persist now, as the password is encoded for this...
		$person->persist(false); // do not encrypt the password, yet.
		
		// Done. Redirec to to right screen...
		if (isset($http['cmd_save_person_register']))
			ct_redirect(ct_pageurl("adminParticipantsEditDelete",array("form_personID"=>$person->get_id())));
		else
			ct_redirect($session->get_besturl());
	} else {
		ct_errorbox(ct('S_ERROR_REGISTER'), ct('S_ERROR_REGISTER_INCOMPLETE'));
		if ($sameusername>0) {
			$form_errors[] = "form_username";
			ct_errorbox(ct('S_ERROR_REGISTER'), ct('S_ERROR_PERSON_EDIT_USERNAMEEXISTS'));
		} elseif ($samemail>0) {
			$form_errors[] = "form_email";
			ct_errorbox(ct('S_ERROR_REGISTER'), ct('S_WARNING_ADMIN_USERS_NEW_MAILEXISTS'));
		} elseif (in_array("form_email",$form_errors)) {
			ct_errorbox(ct('S_ERROR_REGISTER'), ct('S_ERROR_REGISTER_EMAIL_INVALID'));
		}
		if (in_array("form_pwd",$form_errors)) {
			ct_errorbox(ct('S_ERROR_REGISTER'), ct('S_ERROR_REGISTER_PASSWORD_TOO_SHORT'));
		}
	}
}

echo "<h1>".ct('S_ADMIN_USERS_NEW_TITLE')."</h1>\n";
echo "<p class=\"fontnormal font10\">".ct('S_ADMIN_USERS_NEW_INTRO')."</p>\n";

$person->show_form(ct_pageurl('adminUsersNew'), $form_errors);

?>