<?php
//
// PAGE:		adminUsersPC
// DESC:		Show list of all PC members
//

ct_requireassistantorchair();
ct_pagepath(array('index','adminUsers'));

ct_load_lib('admin.lib');
ct_load_lib('papers.lib');
ct_load_class('CTForm');

$session->set_besturl(ct('S_ADMIN_USERS_PC_QUICK'));

$order = ' order by name asc, firstname asc';
if (isset($http['listorder'])) {
	switch ($http['listorder']) {
		case 'org':
		$order = ' order by organisation asc, name asc';
		break;
		case 'username':
		$order = ' order by username asc';
		break;
		case 'id':
		$order = ' order by id asc';
		break;
		case 'name':
		$order = ' order by name asc, firstname asc';
		break;
		case 'country':
		$order = ' order by country asc, name asc, firstname asc';
		break;
	}
}

$select = "*";
$tables = "persons";
$leftjoin = "";
$where = "persons.deleted=0 ";
$wherepc = "(FIND_IN_SET('pc',persons.status)>0 || FIND_IN_SET('reviewer',persons.status)>0) ";
$wherechair = "FIND_IN_SET('chair',persons.status)>0 ";
$having = "";

// Search string from navbar
$search = isset($http['navbar_search'])?$http['navbar_search']:"";
if ($search!="") {
 	if ( preg_match("/^[0-9]+$/", $search) ) {
		$where .= " && (persons.ID = '".$search."') ";
	} else {
		$where .= " && UPPER(CONCAT(persons.name,'|',persons.firstname,'|',persons.organisation,'|',persons.city,'|',persons.country,'|',persons.email)) LIKE UPPER('%".$search."%') ";
	}
}

if (isset($http['form_status']) && !$http['form_status']==0 ) {
	if ($http['form_status']=='NOTparticipant') {
		$where .= " && FIND_IN_SET('participant',persons.status)=0";
	} elseif ($http['form_status']=='pc_lazy') {
		$select  = "persons.*";
		$tables .= ", reviews";
		$where  .= " && persons.ID=reviews.personID && reviews.creationdate=0 ";
	} elseif ($http['form_status']=='pc_lazy2') {
		$select  = "persons.*, count(pc2topics.topicID) as topiccount";
		$leftjoin = "LEFT JOIN pc2topics ON persons.ID=pc2topics.personID ";
		$having = " HAVING topiccount=0";
	} else
		$where .= " && FIND_IN_SET('".$http['form_status']."',persons.status)>0";
}

// All available Contribution Types / Track for filter...
$assigned_ctypes = array();

// get a list of all valid contributiontypes for this user,
// so only chairs in the same group and assigned PC members will be shown...

// First filter to show only the chairs of the same track.
if (ctconf_get('chairTrackSelect',false)) {
	$ctypeIDs = $user->get_contributiontypes_as_chair(); 
	if ( (!$user->is_admin() && !$user->is_conferenceChair()) || (isset($http['form_tracks']) && $http['form_tracks']!=0) )  {
		$tables .= ", contributiontypes2chairs as c2c";
		$wherechair.= " AND c2c.personID=persons.ID";
	}
	if (!$user->is_admin() && !$user->is_conferenceChair()) {
		$wherechair.= " AND c2c.typeID IN ('".implode("', '", $ctypeIDs)."')";
	}
	if (isset($http['form_tracks']) && $http['form_tracks']!=0){
		$wherechair.= " AND c2c.typeID='".$http['form_tracks']."'";
	}
}

// If also pcs are assigned to tracks, here are is more filtering done...
if (ctconf_get('pcTrackSelect',false) && ctconf_get('chairTrackSelect',false)) { // Only pc members of certain tracks
	// filter pc members as well.
	if ( (!$user->is_admin() && !$user->is_conferenceChair()) || (isset($http['form_tracks']) && $http['form_tracks']!=0) )  {
		$tables .= ", contributiontypes2pcs as c2p";
		$wherepc.= " AND c2p.personID=persons.ID";
	}
	// show only the pc members of the same tracks
	if (!$user->is_admin() && !$user->is_conferenceChair()) {
		$ctypeIDs = $user->get_contributiontypes_as_chair(); 
		$wherepc.= " AND c2p.typeID IN ('".implode("', '", $ctypeIDs)."')";
	}
	// now apply the filter as well...
	if (isset($http['form_tracks']) && $http['form_tracks']!=0){
		$wherepc.= " AND c2p.typeID='".$http['form_tracks']."'";
	}
	// Create a list of available contributiontypes for the filter...
	$ctypeIDs = $user->get_contributiontypes_as_chair(); 
	foreach ($ctypeIDs as $c) {
		$ctype = ct_get_contributiontypes($c);
		$assigned_ctypes[] = array($ctype['ID'], $ctype[ctlx($ctype,'title')]);
	}
}


$query = "SELECT $select FROM $tables $leftjoin WHERE ($where) AND (($wherepc) or ($wherechair)) GROUP BY persons.ID $having $order";
#echo $query;
$res = $db->query($query);

echo "<h1>".ct('S_ADMIN_USERS_PC_CMD')."</h1>\n";
echo "<p class=\"fontnormal font10\">".ct('S_ADMIN_USERS_PC_INTRO')."</p>\n";
if ($res && ($db->num_rows($res) < 3) && $search=='' && (!in_http('form_status') || $http['form_status']===0)) {
	echo "<p class=\"fontbold font10\">".ct('S_ADMIN_USERS_PC_INVITATIONHINT')."</p>\n";
	if (isset($http['form_tracks']) && $http['form_tracks']!=0)
		echo "<p class=\"fontbold font10\">".ct('S_ADMIN_USERS_PC_ASSIGNTRACKS')."</p>\n";
}


$form1 = new CTform('adminUsersPC', 'get');
$form1->width='100%';
$form1->align='center';
$form1->add_hidden(hash2aa(ct_http_array(array('filter'=>'show'))));
$form1->add_select_autosubmit(ct('S_ADMIN_USERS_PC_STATUS_ONLY'), 'form_status', 
array(array('0',ct('S_USER_STATUS_REVIEWER_OR_PC')),
array('reviewer',ct('S_USER_STATUS_REVIEWER')),
array('pc',ct('S_USER_STATUS_PC')),
array('pc_lazy2',ct('S_ADMIN_MAILER_SELECT_TOLAZYREVIEWERS2')),
array('pc_lazy',ct('S_ADMIN_MAILER_SELECT_TOLAZYREVIEWERS')),
array('0','---'),
array('chair',ct('S_USER_STATUS_CHAIR')),
array('author',ct('S_USER_STATUS_AUTHOR')),
array('coauthor',ct('S_USER_STATUS_COAUTHOR')),
array('participant',ct('S_USER_STATUS_PARTICIPANT')),
array('NOTparticipant',ct('S_USER_STATUS_NOTPARTICIPANT')),
array('0','---'),
array('admin',ct('S_USER_STATUS_ADMIN')),
array('conferenceChair',ct('S_USER_STATUS_CONFERENCECHAIR')),
array('assistant',ct('S_USER_STATUS_ASSISTANT')),
array('frontdesk',ct('S_USER_STATUS_FRONTDESK'))),
array($http['form_status']), false);
if (count($assigned_ctypes)>1) {
	$tracks=array_merge (array(array(0,ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_ALLTYPES'))), $assigned_ctypes);
	$form1->add_select_autosubmit(ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_CONTRIBUTIONTYPE'), 'form_tracks', $tracks, array($http['form_tracks']), false);
}
$form1->add_submit_noscriptonly('cmd_search', ct('S_ADMIN_TOOL_SUBMIT'));
$form1->show();

if ($res && ($db->num_rows($res) > 0)) {
	ctadm_listusers($res, 'adminUsersPC'); // -> admin.lib
}



?>