<?php
//
// PAGE:	adminUsersPCDetails
// DESC:    Show all details of a PC-Member.
//

ct_requirechair();

ct_pagepath(array('index','adminPapers'));

echo "<h1>".ct('S_ADMIN_USERS_REVIEWS')."</h1>\n";
echo "<p class=\"fontnormal font10\">".ct('S_ADMIN_USERS_REVIEWS_INTRO')."</p>\n";

if (isset($http['form_id'])) {
	$person = new CTPerson;
	if ($person->load_by_id($http[form_id]) && ($person->is_pc() || $person->is_reviewer() || $person->count_assigned_reviews()>0)) {

		// Check if the PC member is in the same track / has access to the same contributiontypes.
		if (ctconf_get('chairTrackSelect',false) && ctconf_get('pcTrackSelect',false)) {
			$assigned_ctypeIDs = $person->get_contributiontypes_as_pc();
			if (!$user->has_chair_access($assigned_ctypeIDs)) ct_redirect($session->get_besturl());
		}
		
		// Now show all reviews...
		$person->show_shortinfo('100%');

		// Show review overview information of a PC member on his details page...
		$width="95%";
		$align='center';
		ct_load_lib('datetime.lib');

		if (ctconf_get('chairTrackSelect',false) && ct_test_lib('multi_track.lib')) {	// if multi-track library exists...
			ct_load_lib('multi_track.lib');
			$assigned_ctypeIDs = $user->get_contributiontypes_as_chair();
		} else {
			$assigned_ctypeIDs = ct_get_contributiontypeIDs(); // get all contributiontype-IDs
		}
		
		if (($person->count_assigned_reviews()>0) && ($user->is_admin() || $user->is_chair() || $user->is_conferenceChair() )	) {
			$reviews = $person->get_reviews();
			while (list(,$review) = each($reviews)) {
				echo "<br>";
				$paper=$review->get_paper();

				if (in_array($paper->get('contributiontypeID'),$assigned_ctypeIDs)) {
					$paper->show_infobox($width,$align);
					echo "<table width=\"$width\" align=\"$align\" cellspacing=1 border=0 cellpadding=2 class=\"darkbg\">\n";
					echo "<tr><td class=\"tbldialog\" align=left valign=top width=\"95%\">";
					if ($review->get('downloaddate') > 0)
						echo "<span class=\"fontnormal font10\">".ct('S_REVIEW_DATE_DOWNLOADED').": ".ct_datetime_format_timezone($review->get('downloaddate'))."</span><br>\n";
					elseif ($paper->get('originalname')!='')
						echo "<span class=\"fontnegative font10\">".ct('S_REVIEW_DATE_NODOWNLOAD')."</span><br>\n";
					if ($review->get('creationdate') > 0)
						echo "<span class=\"fontnormal font10\">".ct('S_REVIEW_DATE_ENTERED').": ".ct_datetime_format_timezone($review->get('creationdate'))."</span><br>\n";
					else
						echo "<span class=\"fontnegative fontbold font10\">".ct('S_REVIEW_DATE_NOTENTERED')."</span><br>\n";
					echo "</td></tr>\n";
					echo "</table>";
	
					if ($review->get('creationdate') > 0)
						$review->show_infobox($width,$align);
					echo "&nbsp;<br>";
				} else {

					echo "<div align=\"$align\">\n";
					echo "<table width=\"$width\" cellspacing=1 border=0 cellpadding=2 class=\"darkbg\">\n";
					echo "<tr><td class=\"whitebg\" align=center valign=middle width=\"8%\" rowspan=\"1\">";
					echo "<span class=\"fontbold font20\">".$paper->get_id()."</span></td>\n";
					echo "<td class=\"tbldialog\" align=left valign=top width=\"92%\">";
					echo "<span class=\"fontlabel font9\">".ct('S_PAPER_CONTRIBUTIONTYPE').": </span><span class=\"fontbold font9\">".$paper->_get_contributiontype_title()."</span><br>\n";
					if ($review->get('creationdate') > 0)
						echo "<span class=\"fontnormal font8\">".ct('S_REVIEW_DATE_ENTERED').": ".ct_datetime_format_timezone($review->get('creationdate'))."</span><br>\n";
					else
						echo "<span class=\"fontnegative fontbold font8\">".ct('S_REVIEW_DATE_NOTENTERED')."</span><br>\n";
					echo "</td></tr>\n";
					echo "</table>";
					echo "&nbsp;<br>";

				}
				
			}
		}

	} else {
		ct_redirect($session->get_besturl());			
	}
}

?>
