<?php
//
// PAGE:		discussResults
// DESC:		This page shows the contributions that are still not decided.
//				and shall be discussed...
//

// if user has no admin rights, check if is pc member and "paperbids" is active
if (! ($user->is_admin() || ($user->is_pc() and ct_check_phases("reviewdiscussion")))) {
	$session->put_errorbox(ct('S_ERROR_PHASE'), ct('S_ERROR_PHASE_INACTIVE'));
	ct_redirect(ct_pageurl('error'));
}

ct_load_class('CTForm');
ct_load_class('CTPaper');
ct_load_class('CTReview');
ct_load_lib('papers.lib');
ct_load_lib('navbar.lib');

$session->set_besturl(ct('S_PC_DISCUSS_RESULTS_QUICK'));
$colors = array("review1","review2","review3","review4","review5","review6","review7","review8","review9","review10");

$paper  = new CTPaper();
$review = new CTReview();
ct_load_class('CTPCMessage');
$pcmessage=new CTPCMessage();

// Get all contributiontypeIDs that shall be accessible by this PC member. The where clause is set later...
if (ctconf_get('pcTrackSelect',false) && ct_test_lib('multi_track.lib')) {	// if multi-track library exists...
	ct_load_lib('multi_track.lib');
	$assigned_ctypeIDs = $user->get_contributiontypes_as_pc();
} else {
	$assigned_ctypeIDs = ct_get_contributiontypeIDs(); // get all contributiontype-IDs
}


// get valid contribution types for discussion
$ctypes = ct_get_contributiontypes();
$valid_ctypes = array();
$valid_ctypeIDs = array();
while (list(,$v) = each($ctypes)) {
	if ($v['do_discussion']=='true' && in_array($v['ID'],$assigned_ctypeIDs)) {
		$valid_ctypes[] = $v;
		$valid_ctypeIDs[] = $v['ID'];
	}
}

// Order the output...
$sort = "score desc, title asc";
switch($http['form_sort']) {
     case "score": $sort = "score desc, title asc"; break;
     case "count": $sort = "count desc, count desc, title asc"; break;
     case "span": $sort = "span desc, score desc, title asc"; break;
     case "id": $sort = "ID asc"; break;
     case "title": $sort = "title asc"; break;
     case "tendency": $sort = "votes desc"; break;
}

$tables = "";
$where = "";	// Main condition, only related to table "papers as p"
$where2 = "";	// Extra condition, may be related to other tables
$where3 = "";	// Extra condition for search filter
$having = "";
$myReviewIDs = array();

// Filter 1
#if (!empty($ctypes_for_discussion))
$where.=" && p.contributiontypeID IN ('".implode("', '", $valid_ctypeIDs)."')";
if (isset($http['form_tracks']) && $http['form_tracks']!=0){
	$where.=" && p.contributiontypeID='".$http['form_tracks']."'";
}	

// Filter 2
if (!isset($http['form_status'])) $http['form_status']="0"; // set default to "0" = hold
if (isset($http['form_status']) && $http['form_status']!="-" && $http['form_status']>-5 && $http['form_status']<5 ){
	$where2.=" && p.acceptstatus='".$http['form_status']."'";
}
if (isset($http['form_topic']) && $http['form_topic']!="-"){
	$tables.=", topics2papers as t2p ";
	$where2.=" and t2p.paperID=p.ID and t2p.topicID='".$http['form_topic']."'";
}
if (isset($http['specialfilter']) && $http['specialfilter']!="-"){
	if (STRPOS($http['specialfilter'],'fewreviews_')===0) {
		$having  .= " HAVING COUNT(r.personID)<='".substr($http['specialfilter'],11)."' ";
	} elseif (STRPOS($http['specialfilter'],'span_')===0) {
		$having  .= " HAVING span>'".substr($http['specialfilter'],5)."' ";
	} elseif ($http['specialfilter']=='iwasreviewer') {
		$mr = $db->query('select paperID from reviews where personID="'.$user->get_id().'" order by paperID asc');
		if ($mr) {
			for	($i	= 0; $i	< $db->num_rows($mr); $i++) {
				$row = $db->fetch($mr);
				$myReviewIDs[] = $row['paperID'];
			}
		}
	}
}

// Search string from navbar
$search     = isset($http['navbar_search'])?$http['navbar_search']:"";
if ($search!="") {
	$where3 = " && UPPER(CONCAT(p.author,'|',p.title)) LIKE UPPER('%".$search."%')";
}

$sessions = array();
$sessions[0] = "none";

$q = "select ID, shorttitle from sessions order by shorttitle";
$r = $db->query($q);
if ($r and ($db->num_rows($r) > 0)) {
	for ($i = 0; $i < $db->num_rows($r); $i++) {
		$row = $db->fetch($r);
		$sessions[$row['ID']] = $row['shorttitle'];
	}
}

$q = "select p.ID as id, p.personID as authorID, author, title, ".
"round(greatest(0,(sum((".
"(evaluation*".  $review->reviewfactor['evaluation'].")+".
"(significance*".$review->reviewfactor['significance'].")+".
"(originality*". $review->reviewfactor['originality'].")+".
"(relevance*".   $review->reviewfactor['relevance'].")+".
"(readability*". $review->reviewfactor['readability'].")+".
"(overall*".     $review->reviewfactor['overall']."))".
($review->reviewfactor['familiarity']==1?"*familiarity":"").
"/10)".
"/count(r.paperID)".
($review->reviewfactor['familiarity']==1?"/avg(familiarity)":"").
")),1) as score, ".
"count(r.paperID) as count, ".
"sum(r.bestpaper) as bestpapers, ".
//"count(m.vote) as messages, ".  // number of votes so far...
//"avg(m.vote) as votes, ".  // average vote of the messages
"b.bidding as bidding, ".  // bidding of user for that paper -> to identify conflicts
"round(max((evaluation*".$review->reviewfactor['evaluation']."+".
      "significance*".$review->reviewfactor['significance']."+".
      "originality*".$review->reviewfactor['originality']."+".
      "relevance*".$review->reviewfactor['relevance']."+".
      "readability*".$review->reviewfactor['readability']."+".
      "overall*".$review->reviewfactor['overall'].")/10)-".
  "min((evaluation*".$review->reviewfactor['evaluation']."+".
      "significance*".$review->reviewfactor['significance']."+".
      "originality*".$review->reviewfactor['originality']."+".
      "relevance*".$review->reviewfactor['relevance']."+".
      "readability*".$review->reviewfactor['readability']."+".
      "overall*".$review->reviewfactor['overall'].")/10),1) as span, ".
"acceptstatus, track, contributiontypeID ".
"FROM papers AS p $tables ".
//"left join pcdiscussionmessages AS m on p.ID = m.paperID ".
"LEFT JOIN reviews AS r ON p.ID = r.paperID AND r.creationdate > 0 ".
"LEFT JOIN biddings AS b on p.ID=b.paperID AND b.personID='".$user->get_id()."' ".
"where p.withdrawn=0  ". // Only not-withdrawn papers
(($user->is_admin() || $user->is_chair() || $user->is_conferenceChair())?"":"AND (b.bidding>-2 OR b.bidding IS NULL) AND p.personID!=".$user->get_id()."  "). // Hide conflict of interests...
"$where  $where2  $where3  ". // and r.creationdate != '' ".  // Additional contions...
"GROUP BY p.ID ".
"$having ".
"ORDER BY $sort";
#echo $q; // show for debugging if you are an SQL wizard ;-)
$r = $db->query($q);

// Start the output! --------------------------------------------------------------------

echo "<h1>".ct('S_PC_DISCUSS_RESULTS_TITLE')."</h1>";
echo "<span class=\"fontnormal font10\">".ct('S_PC_DISCUSS_RESULTS_INTRO')."</span><br>";
//echo "$q<br>\n";

// Show already rejected and accepted papers... ---------------------------------------
$accepted=0;
$rejected=0;

$ra = $db->select("papers as p", "count(ID) as accepted", "p.acceptstatus=1 $where");
if ($ra and ($db->num_rows($ra) > 0)) {
	$row = $db->fetch($ra);
	$accepted=$row['accepted'];
}

$ra = $db->select("papers as p", "count(ID) as rejected", "p.acceptstatus=-1 $where");
if ($ra and ($db->num_rows($ra) > 0)) {
	$row = $db->fetch($ra);
	$rejected=$row['rejected'];
}

if($accepted>0 || $rejected>0)
	echo "<span class=\"fontnormal font10\">".ct('S_PC_DISCUSS_RESULTS_ALREADY_DECIDED',array($accepted,$rejected))."</span><br>";


if (!$user->is_admin() && !$user->is_chair() && !$user->is_conferenceChair()) {
	// Show hidden papers (conflict papers...)
	$hidden=0;
	$query = "SELECT COUNT(DISTINCT(p.ID)) as hidden FROM papers as p ".
				"LEFT JOIN biddings as b ON p.ID = b.paperID AND b.personID='".$user->get_id()."' ".
				"LEFT JOIN emails2papers AS e2p ON e2p.paperID=p.ID ".
				"WHERE (p.personID='".$user->get_id()."' OR b.bidding<=-2 OR e2p.email='".$user->get('email')."' OR e2p.email='".$user->get('email2')."') $where ";
	#echo "\n<br>$query<br>\n"; 
	$ra = $db->query($query);
	if ($ra and ($db->num_rows($ra) > 0)) {
		$row=$db->fetch($ra);
		$hidden=$row['hidden'];
	}
	#if ($hidden>0)
		echo "<span class=\"fontnegative fontbold font10\">".ct('S_PC_DISCUSS_RESULTS_NOTSHOWN',array($hidden))."</spab><br>";
}

echo "<br>";

// Show the filter... ---------------------------------------------------------------
if (isset($http['filter']) && $http['filter'] == "hide") {
	echo "<table width=\"100%\" class=\"whitebg\" align=center border=0><tr><td>\n";
	echo "&gt;&gt;&gt; <a class=\"fontbold font10\" href=\"".ct_pageurl('browseDiscussResults', ct_http_array(array('filter'=>'show','form_tracks'=>'','form_status'=>'0')))."\">".ct('S_ADMIN_FILTER_SHOW')."</a>\n";
	echo "</td></tr></table>\n";
#	echo "<br>";
} else {
	echo "<table width=\"100%\" align=center class=\"whitebg\"><tr><td>\n";
	echo "&lt;&lt;&lt; <a class=\"fontbold font10\" href=\"".ct_pageurl('browseDiscussResults', ct_http_array(array('filter'=>'hide','form_tracks'=>'','form_status'=>'0')))."\">".ct('S_ADMIN_FILTER_HIDE')."</a>\n";
	echo "</td></tr></table>\n";
	$form1 = new CTform('browseDiscussResults', 'get');
	$form1->width='100%';
	$form1->align='center';
	$form1->add_hidden(hash2aa(ct_http_array(array('filter'=>'show'))));
	$ftracks=array(array(0,ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_ALLTYPES')));
	reset($valid_ctypes);
	while (list(,$v) = each($valid_ctypes)) $ftracks[] = array($v['ID'],$v[ctlx($v,'title')]);
	if (count($valid_ctypeIDs)>1) 
		$form1->add_select_autosubmit(ct('S_ADMIN_TOOL_CONTRIBUTIONTYPES_FORM_CONTRIBUTIONTYPE'), 'form_tracks', $ftracks, array($http['form_tracks']), false);
	$fstates=array_merge (array(array("-",ct('S_ADMIN_PAPERS_RESULTS_ALLSTATES'))), ct_list_accessstates());
	$form1->add_select_autosubmit(ct('S_ADMIN_PAPERS_RESULTS_STATUS'), 'form_status', $fstates, array($http['form_status']), false);
	$topics=ct_list_topics();
	if (count($topics)>1) {
		$selecttopics=array_merge (array(array("-",ct('S_ADMIN_FILTER_ALLTOPICS'))), $topics);
		$form1->add_select_autosubmit(ct('S_ADMIN_FILTER_TOPICS'), 'form_topic', $selecttopics, array($http['form_topic']));
	}
	$form1->add_select_autosubmit(ct('S_ADMIN_PAPERS_BROWSE_FILTER'), 'specialfilter',
								array(array('-',ct('S_ADMIN_PAPERS_BROWSE_FILTER_NO')),
	 							array('iwasreviewer',ct('S_ADMIN_PAPERS_BROWSE_FILTER_IWASREVIEWER')),
	 							array('span_5',ct('S_ADMIN_PAPERS_BROWSE_FILTER_BIGSPAN',array('5'))), array('span_10',ct('S_ADMIN_PAPERS_BROWSE_FILTER_BIGSPAN',array('10'))),array('span_15',ct('S_ADMIN_PAPERS_BROWSE_FILTER_BIGSPAN',array('15'))),array('span_20',ct('S_ADMIN_PAPERS_BROWSE_FILTER_BIGSPAN',array('20'))),array('span_25',ct('S_ADMIN_PAPERS_BROWSE_FILTER_BIGSPAN',array('25'))),array('span_30',ct('S_ADMIN_PAPERS_BROWSE_FILTER_BIGSPAN',array('30'))),array('span_35',ct('S_ADMIN_PAPERS_BROWSE_FILTER_BIGSPAN',array('35'))),array('span_40',ct('S_ADMIN_PAPERS_BROWSE_FILTER_BIGSPAN',array('40'))),array('span_50',ct('S_ADMIN_PAPERS_BROWSE_FILTER_BIGSPAN',array('50'))),array('span_60',ct('S_ADMIN_PAPERS_BROWSE_FILTER_BIGSPAN',array('60'))),
	 							array('fewreviews_2',ct('S_ADMIN_PAPERS_BROWSE_FILTER_FEWREVIEWS',array('2'))),array('fewreviews_3',ct('S_ADMIN_PAPERS_BROWSE_FILTER_FEWREVIEWS',array('3'))),array('fewreviews_4',ct('S_ADMIN_PAPERS_BROWSE_FILTER_FEWREVIEWS',array('4'))),array('fewreviews_5',ct('S_ADMIN_PAPERS_BROWSE_FILTER_FEWREVIEWS',array('5')))), 
	 							array($http['specialfilter']));
	$form1->add_submit_noscriptonly('cmd_search', ct('S_ADMIN_PAPERS_BROWSE_SUBMIT'));
	$form1->show();
}


// Show navigation bar -------------------------------------------------------------

$items      = $db->num_rows($r);
ct_navbar("browseDiscussResults",$items);

$perpage    = isset($http['navbar_perpage']) && $http['navbar_perpage']!=""?$http['navbar_perpage']:ctconf_get('display_perpage',20);
$pageno     = isset($http['navbar_page'])?$http['navbar_page']:0; // default is 0
$maxpage    = intval(($items-1)/($perpage));


// Show rows...
// ------------------------------------------------------------------------------------

$num = $db->num_rows($r);
if ($num > 0) {

	echo "<table width=\"100%\" cellspacing=1 cellpadding=3 border=0>";
	echo "<tr class=\"listheader\">";
	echo "<td align=center width=\"6%\"><a href=\"".ct_pageurl("browseDiscussResults", ct_http_array(array("form_sort"=>"score")))."\" class=\"listheader_label\">".ct('S_ADMIN_PAPERS_RESULTS_POINTS')."</a></td>";
	echo "<td align=center width=\"6%\"><a class=\"fontbold font8\" href=\"".ct_pageurl("browseDiscussResults", ct_http_array(array("form_sort"=>"count")))."\" class=\"listheader_label\">".ct('S_ADMIN_PAPERS_RESULTS_COUNT')."</a><br><img src=\"".ct_getbaseurl()."icons/darkblue.gif\" height=1 width=40><br>";
	echo "<a class=\"fontbold font8\" href=\"".ct_pageurl("browseDiscussResults", ct_http_array(array("form_sort"=>"span")))."\" class=\"listheader_label\">".ct('S_ADMIN_PAPERS_RESULTS_SPAN')."</a></td>";
	echo "<td align=center width=\"5%\"><a href=\"".ct_pageurl("browseDiscussResults", ct_http_array(array("form_sort"=>"id")))."\" class=\"listheader_label\">".ct('S_ADMIN_PAPERS_RESULTS_ID')."</a></td>";
	echo "<td width=\"32%\"><a href=\"".ct_pageurl("browseDiscussResults", ct_http_array(array("form_sort"=>"title")))."\" class=\"listheader_label\">".ct('S_ADMIN_PAPERS_RESULTS_TITLE')."</a></td>";
	echo "<td width=\"30%\"><span class=\"listheader_label\">".ct('S_ADMIN_PAPERS_RESULTS_AUTHORS')."</span></td>";
	echo "<td align=center width=\"15%\"><span class=\"listheader_label\">".ct('S_PC_DISCUSS_RESULTS_MESSAGES')."</span></td>";
//	echo "<td align=center width=\"5%\"><a href=\"".ct_pageurl("browseDiscussResults", ct_http_array(array("form_sort"=>"tendency")))."\" class=\"listheader_label\">ct('S_PC_DISCUSS_RESULTS_TENDENCY')."</a></td>";
	echo "<td align=center width=\"6%\"><span class=\"fontbold font8\">".ct('S_PC_DISCUSS_RESULTS_TENDENCY')."/ ".ct('S_ADMIN_PAPERS_RESULTS_STATUS')."</span></td>";
	echo "</tr>\n";

	for ($i = 0; $i < $num; $i++) {

		$row = $db->fetch($r);

		if (intval($i/$perpage)==$pageno) {
			$author = new CTPerson;
			$author->load_by_id($row['authorID']);
			$paper->load_by_id($row['id']);
			
			$class = $i%2?"oddrow":"evenrow";
			
			// Hide conflic of interests papers...
			if (!$user->is_admin() && !$user->is_chair() && !$user->is_conferenceChair() && 
					(($row['bidding']!=null && $row['bidding']<=-2)|| 
						$row['authorID']==$user->get_id() ||
						$user->has_review_conflict($paper))) { // CONFLICT!!!
			/*	echo "<tr class=\"".$class."2\">";
				echo "<td>&nbsp;</td>\n";
				echo "<td>&nbsp;</td>\n";

				echo "<td align=center><span class=\"fontnormal font12\">".$row['id']."</span></td>\n";
				echo "<td valign=\"top\"><a class=\"fontbold font10\" href=\"".ct_pageurl("paperDetails", array("form_id"=>$row['id']))."\">".$row['title']."</a><BR>";
				echo "<span class=\"fontnormal font8\">".$paper->_get_contributiontype_title($row['contributiontypeID'])."</span>";
				echo "</td>";

				echo "<td align=left valign=top><span class=\"fontnormal font10\">".$row['author']."</span><br>\n";
				echo "<span class=\"fontnormal font8\">".$author->get('organisation').",&nbsp;".$author->get('city').",&nbsp;".$author->get('country')."</span></td>\n";

				echo "<td colspan=\"2\" align=center class=\"".$class."_del\">".ct('S_PC_DISCUSS_RESULTS_CONFLICT')."</td>";

				echo "</tr>\n";
			*/
			// No conflict of interest. Just check if filter "Show only my reviews" was selected.
			} elseif (count($myReviewIDs)==0 || in_array($row['id'],$myReviewIDs)) {
				$reviews = $row['count'];
				$messages=$pcmessage->count_messages($row['id']);
				$mymessages=$pcmessage->count_mymessages($row['id']);
				$votes = 0;

				if ($messages>0) {
					// $votes=round($row['votes'],1);
					$votes=round($pcmessage->get_average_vote($row['id']),1);
				}

 				echo "<tr class=\"$class\" ";
				echo "onmouseover=\"ct_row( this, 'on', '$class', '".$class."_highlight');\" ";
				echo "onmouseout=\"ct_row( this, 'off', '$class', '".$class."_highlight');\">\n";

				echo "<td align=center ";
				if ($reviews != 0) {
					echo "class=\"".$colors[round(($row['score']/10)-1)]."\"";
				}
				echo ">";
				echo "<span class=\"fontbold font11\">".($row['score']!=""?$row['score']:"-")."</span><br>";
				for ($j = 0; $j < $row['bestpapers']; $j++) {
					echo "<img src=\"".ct_getbaseurl()."icons/star.gif\" alt=\"".ct('S_REVIEW_FORM_BESTPAPER')."\" title=\"".ct('S_REVIEW_FORM_BESTPAPER')."\" align=top>";
				}
				echo "</td>\n";
				echo "<td align=center>";
				if ($reviews < 2) { echo "<span class=\"fontnegative fontbold font10\">"; }
				else { echo "<span class=\"fontnormal font10\">"; }
				echo $reviews;
				echo "</span><br>";
				if ($row['span'] >= 30) { echo "<span class=\"fontnegative fontbold font10\">"; }
				else { echo "<span class=\"fontbold font10\">"; }
				echo ($row['span']!=""?$row['span']:"-");
				echo "</span></td>\n";

				echo "<td align=center><span class=\"fontnormal font9\">".$row['id']."</span></td>\n";

				echo "<td valign=\"top\"><a class=\"fontbold font8\" href=\"".ct_pageurl("paperPCDetails", array("form_id"=>$row['id']))."\">".ct_form_encode($row['title'])."</a><BR>";
				echo "<span class=\"fontnormal font8\">".$paper->_get_contributiontype_title($row['contributiontypeID'])."</span>";
				echo "</td>";

				echo "<td align=left valign=top>";
				ct_load_lib('address.lib');
				$ctype = $paper->_get_contributiontype($row['contributiontypeID']);
				if ($user->is_admin() || $user->is_conferenceChair() || $user->is_chair() || $ctype['review_anonymous']=='false' || $paper->get('personID') == $user->get_id()) {
					echo "<span class=\"fontbold font8\">".ct_form_encode($row['author'])."</span><br>\n";
					echo "<span class=\"fontnormal font8\">".$author->get_special('organisation').", ";
					echo ct_get_country($author->get('country'))."</span></td>\n";
				} else {
					echo "<span class=\"fontbold font8\">".ct('S_PC_DISCUSS_RESULTS_ANONYMOUS')."</span><br>\n";
					echo "<span class=\"fontnormal font8\">";
					echo ct_get_country($author->get('country'))."</span></td>\n";
				}

				echo "<td align=center nowrap=\"nowrap\">\n";
				if ($messages==0) {
					echo "<span class=\"fontnormal font9\">".ct('S_PC_DISCUSS_RESULTS_NUMBER_MESSAGES',array($messages))."&nbsp;</span><br>\n";
					if ($row['acceptstatus']==0) echo "<a href=\"".ct_pageurl('editMessagePC', array('paperID'=>$row['id']))."\" class=\"fontbold font8\">".ct('S_PC_DISCUSS_RESULTS_CREATE_MESSAGE')."&nbsp;</a>\n";
				} else {
					if ($messages==1)
						echo "<a href=\"".ct_pageurl('browsePCMessages', array('paperID'=>$row['id']))."\" class=\"fontbold font8\" >".ct('S_PC_DISCUSS_RESULTS_NUMBER_MESSAGE',array($messages))."&nbsp;</a><br>\n";
					else
						echo "<a href=\"".ct_pageurl('browsePCMessages', array('paperID'=>$row['id']))."\" class=\"fontbold font8\" >".ct('S_PC_DISCUSS_RESULTS_NUMBER_MESSAGES',array($messages))."&nbsp;</a><br>\n";
					if ($mymessages>0)
						echo "<span class=\"fontnormal font8\">(".ct("S_PC_DISCUSS_RESULTS_MESSAGES_BY_ME",array($mymessages)).")</span><br>";
					if ($row['acceptstatus']==0 || 
							$user->is_admin() || $user->is_chair() || $user->is_conferenceChair()) 
						echo "<a class=\"fontnormal font8\" href=\"".ct_pageurl('editMessagePC', array('paperID'=>$row['id']))."\" >".ct('S_PC_DISCUSS_RESULTS_CREATE_MESSAGE')."&nbsp;</a>\n";
				}
				echo "</td>";

				// Last Row.
				echo "<td align=\"center\" valign=middle nowrap><span class=\"fontbold font10\">";
				if ($row['acceptstatus']>0) {
					echo "<span class=\"fontpositive fontbold font10\">";
					echo $paper->get_acceptstatus_short($row['acceptstatus']);
					echo "</span>\n";
					echo "<br>";
				} elseif ($row['acceptstatus']<0) {
					echo "<span class=\"fontother fontbold font10\">";
					echo $paper->get_acceptstatus_short($row['acceptstatus']);
					echo "</span>\n";
					echo "<br>";
				}
				echo "<span class=\"fontbold font10\">";
				$pcmessage->show_tendency($votes);
				echo "</span></td>\n";

				echo "</tr>\n";
			}
		} 
	}
	echo "</table>";
	if ($maxpage>0) ct_navbar_small($page,$items);

} elseif ($where2=="" && $where3=="") {
	echo "<P class=\"fontbold font14\">".ct('S_PC_DISCUSS_RESULTS_ALL_ALREADY_DECIDED')."</P>\n";
}





?>
