
<?php
//
// PAGE:		browseOfficialParticipants
// DESC:		Show a list of all identities of the conference
//




// if user has no admin rights, check if is pc member and "conference" is active
if (! ($user->is_admin() || $user->is_frontdesk() || $user->is_assistant() ||
		 ($user->is_participant() and ct_check_phases('browseparticipants')))) {
	$session->put_errorbox(ct('S_ERROR_PHASE'), ct('S_ERROR_PHASE_INACTIVE'));
	ct_redirect(ct_pageurl('error'));
}

$session->set_besturl(ct('S_BROWSE_OFFICIALPARTICIPANTS_QUICK'));

ct_load_lib('navbar.lib');
ct_load_class('CTIdentity');
$identity = new CTIdentity;

echo "<H1>".ct('S_BROWSE_OFFICIALPARTICIPANTS_CMD')."</H1>\n";

$query="select * from identities";
$where = ' where 1';
if (!$user->is_admin() && !$user->is_frontdesk() && !$user->is_assistant() )
	$where .= ' && FIND_IN_SET("onlist", visibility)>0 && deleted=0';

//$where=" where participants.personID=persons.ID and participants.regdate != '0000-00-00 00:00:00' ";
//if (isset($http['form_event']) && $http['form_event']){
//	$where.=" and participants2events.eventID= \"".$http['form_event']."\" and participants.personID=participants2events.personID and participants2events.number>0";
//}

// Search string from navbar
$search     = isset($http['navbar_search'])?$http['navbar_search']:"";
if ($search!="") {
	$where .= " && UPPER(CONCAT(identities.fullname,'|',identities.firstname,'|',identities.name,'|',identities.organisation,'|',identities.country) LIKE UPPER('%".$search."%'))";
}

$order = ' order by identities.name, identities.firstname asc';

if (isset($http['listorder'])) {
	switch ($http['listorder']) {
		case 'org':
		$order = ' order by identities.organisation asc, identities.name asc';
		break;
		case 'name':
		$order = ' order by identities.name, identities.firstname asc';
		break;
		case 'country':
		$order = ' order by identities.country asc, identities.name asc';
		break;
	}
	
}

$query="$query $where $order";

# echo $query;

$res = $db->query($query);

echo "<p class=\"fontnormal font10\">".ct('S_BROWSE_OFFICIALPARTICIPANTS_INTRO')."</p>\n";

$items      = $db->num_rows($res);
ct_navbar($page,$items);
$perpage    = isset($http['navbar_perpage']) && $http['navbar_perpage']!=""?$http['navbar_perpage']:ctconf_get('display_perpage',20);
$pageno     = isset($http['navbar_page'])?$http['navbar_page']:0; // default is 0
$maxpage    = intval(($items-1)/($perpage));
	
$page_i     = 0;
	
if (($res >= 0) && ($db->num_rows($res) > 0)) {
	echo "<table width=\"100%\" cellspacing=1 cellpadding=2 border=0>\n";
	// show headers with links for different sorting...
	echo "<tr class=\"listheader\">\n";
	echo "<td width=\"30%\"><a href=\"".ct_pageurl($page,ct_http_array(array('listorder' => 'name')))."\" class=\"listheader_label\">".ct('S_USER_FULLNAME')."</a></td>\n";
	echo "<td width=\"35%\"><a href=\"".ct_pageurl($page,ct_http_array(array('listorder' => 'org')))."\" class=\"listheader_label\">".ct('S_USER_ORGANISATION')."</a></td>\n";
	echo "<td width=\"30%\"><a href=\"".ct_pageurl($page,ct_http_array(array('listorder' => 'country')))."\" class=\"listheader_label\">".ct('S_USER_COUNTRY')."</a></td>\n";
	if ($user->is_admin() || $user->is_assistant() ) 
		echo "<td width=\"5%\"><span class=\"fontbold font10\">".ct('S_ADMIN_USERS_ACTIONS')."</span></td>\n";
	echo "</tr>\n";
	for ($i=0; $i < $db->num_rows($res); $i++) {
		$identity->data = $db->fetch($res);
		if (intval($i/$perpage)==$pageno) {
			$identity->show_row(($i%2?"oddrow":"evenrow"), $page);
			$page_i++;
		}
	}
	// show sums...
	if ($maxpage>0) {
		echo "<tr class=\"dimbg\">\n";
		echo "<td colspan=\"6\"><span class=\"form_label\">".ct('S_ADMIN_PARTICIPANTS_BROWSE_PAGE_SUM1')." $page_i ".ct('S_ADMIN_PARTICIPANTS_BROWSE_PAGE_SUM2')."</span></td>\n";
		echo "</tr>\n";
	}
	echo "<tr class=\"darkbg\">\n";
	echo "<td colspan=\"6\"><span class=\"form_label\">".ct('S_ADMIN_PARTICIPANTS_BROWSE_SUM1')." $i ".ct('S_ADMIN_PARTICIPANTS_BROWSE_SUM2')."</span></td>\n";
	echo "</tr>\n";
	echo "</table>\n";
}


?>
