
<?php
//
// PAGE:		browsePCMessages
// DESC:		Show a list of all messages written by the PC members
//


// if user has no admin rights, check if he is a pc member and "reviewdiscussion" is active
// if user has no admin rights, check if he is a pc member and "reviewdiscussion" is active
if (! ($user->is_admin() ||
        $user->is_chair() ||
        $user->is_conferenceChair() || ($user->is_pc() and ct_check_phases("reviewdiscussion")))) {
        $session->put_errorbox(ct('S_ERROR_PHASE'), ct('S_ERROR_PHASE_INACTIVE'));
        ct_redirect(ct_pageurl('error'));
}

ct_pagepath(array('index','browseDiscussResults'));

ct_load_class('CTPCMessage');
$pcmessage=new CTPCMessage();
ct_load_class('CTPaper');
$paper=new CTPaper();

$order="m.creationdate";
if (isset($http['form_sort'])) {
	switch($http['form_sort']) {
		case "author": $order = "p.name asc, m.creationdate"; break;
		case "message": $order = "m.creationdate"; break;
		case "vote": $order = "vote desc, m.creationdate"; break;
	}
}
$messages=$pcmessage->get_messages($http['paperID'],$order);
if (!$paper->load_by_id($http['paperID'])) {
	ct_redirect($session->get_besturl());
}

// Is the user allowed to access this discussion?
if ( !( $user->is_admin() || 
		$user->is_chair() || 
		$user->is_conferenceChair() ||	// can do anything...
	    (ct_check_phases("reviewdiscussion") && 
	     $user->is_pc() && 
	     $user->get_id()!=$paper->get('personID') && 
	     $paper->get_bidding($user->get_id())>-2 ) ) ||
	   $paper->get('deleted')>0 ) { 
	$session->put_errorbox(ct('S_ERROR_PC_DISCUSSION'), ct('S_ERROR_PC_DISCUSSION_NOACCESS'));
	ct_redirect(ct_pageurl('error'));

}	  	

// Discussion already closed?
if ($paper->get('acceptstatus')!=0) { 
	ct_warningbox(ct('S_ERROR_PC_MESSAGE_CLOSED'),ct('S_ERROR_PC_MESSAGE_CLOSED_INFO'));
}

// Get contributiontype and check if it is included in the discussion phase
$ctype = $paper->_get_contributiontype();
if ($ctype['do_discussion']=='false') {
	$session->put_errorbox(ct('S_ERROR_PC_DISCUSSION'), ct('S_ERROR_PC_DISCUSSION_NOACCESS'));
	ct_redirect($session->get_besturl());
}

$paper->show_detailed("98%");
$paper->show_accept_status("98%");

echo "<H1>".ct('S_BROWSEPCMESSAGES_TITLE')."</H1>\n";
echo "<p class=\"fontnormal font10\">".ct('S_BROWSEPCMESSAGES_INTRO')."</p>\n";

if (ct_check_phases("reviewdiscussion")) show_createmessagelink($paper);
 
if (sizeof($messages)>0) {
	echo "<table width=\"100%\" cellspacing=1 cellpadding=2 border=0>";
	echo "<tr class=\"listheader\">";
	echo "<td align=center width=\"22%\"><a href=\"".ct_pageurl("browsePCMessages", ct_http_array(array("form_sort"=>"author")))."\" class=\"listheader_label\">".ct('S_BROWSEPCMESSAGES_AUTHOR')."</a></td>";
	echo "<td width=\"68%\"><a href=\"".ct_pageurl("browsePCMessages", ct_http_array(array("form_sort"=>"message")))."\" class=\"listheader_label\">".ct('S_BROWSEPCMESSAGES_MESSAGE')."</a></td>";
	echo "<td width=\"10%\" align=\"center\"><a href=\"".ct_pageurl("browsePCMessages", ct_http_array(array("form_sort"=>"vote")))."\" class=\"listheader_label\">".ct('S_BROWSEPCMESSAGES_VOTE')."</a></td>";
	echo "</tr>\n";
	for ($i=0; $i < sizeof($messages); $i++) {
		$pcmessage->data = $messages[$i];
		$pcmessage->show_row($i%2?"evenrow":"oddrow");
		echo "<tr><td colspan=\"4\" valign=top align=left class=\"mediumbg_gradient\">";
		echo "<img src=\"".ct_getbaseurl()."icons/spacer.gif\" width=1 height=1>";
		echo "</td></tr>\n";
	}
	echo "</table>\n\n";
}

if (ct_check_phases("reviewdiscussion")) show_createmessagelink($paper);
 
function show_createmessagelink($paper) {
	global $session, $http;
	$user=$session->get_user();
	if ($paper->get('acceptstatus')==0 || 
		$user->is_admin() || $user->is_chair() || $user->is_conferenceChair() ) { // allow entering new messages
		echo "<table align=\"center\" border=0 cellpadding=3 cellspacing=7><tr>\n";
		echo "<td class=\"lightbg\"><a href=\"".ct_pageurl('editMessagePC', array('paperID'=>$http['paperID']))."\" class=\"fontbold font10\">".ct('S_PC_DISCUSS_RESULTS_CREATE_MESSAGE')."&nbsp;</a></td>\n";
		echo "<td class=\"lightbg\"><a href=\"".$session->get_besturl()."\" class=\"fontbold font10\">".ct('S_PC_DISCUSS_RESULTS_RETURN')."</a></td>\n";
		echo "</tr></table>\n";
	}	
}
	
?>
