<?php
//
// PAGE:		browseSessions
// DESC:		This page shows all sessions in a printable format.
//

// if user has no admin rights, check if he is a chair or the phase "conference" is active
if (!ct_check_phases('browsesessions') &&
	!(is_object($user) && ($user->is_admin() || $user->is_conferenceChair() || $user->is_chair()))) { // Chairs can access
	$session->put_errorbox(ct('S_ERROR_PHASE'), ct('S_ERROR_PHASE_INACTIVE'));
	ct_redirect(ct_pageurl('error'));
}

ct_pagepath(array('index'));
ct_load_lib('sessions.lib');
ct_load_lib('papers.lib');
ct_load_lib('datetime.lib');
ct_load_class('CTPaper');
ct_load_class('CTPerson');

$paper  = new CTPaper();
$width = "90%"; // 640 is Fine for printouts, set below...
$num_sessions = 0;
$page = $http['page'];

// Filter
$where = 'where 1 ';
$where2 = '';

if (isset($http['form_room']) && $http['form_room']!=0){
	$where.=" and s.roomID='".$http['form_room']."'";
	$where2.=" and s.roomID='".$http['form_room']."'";
}
if (isset($http['form_date']) && $http['form_date']!=""){
	$timestamp = ct_datetime_2_timestamp($http['form_date']." 00:00:00");
	$start     = ct_timestamp_2_datetime($timestamp);
	$end       = ct_timestamp_2_datetime($timestamp + 86400);
	$where.=" and s.starttime>='".$start."' and s.endtime<'".$end."'";
	$where2.=" and s.starttime>='".$start."' and s.endtime<'".$end."'";
}

if (isset($http['form_session']) && $http['form_session']!="-" && $http['form_session']>0 ){
	$where.=" and s.ID='".$http['form_session']."'";
	$where2.=" and p.track='".$http['form_session']."'";
	$http['presentations']='show';
}
/*
if (isset($http['form_tracks']) && $http['form_tracks']!=0){
	$where2.=" and p.contributiontypeID=".$http['form_tracks'];
}
if (isset($http['form_status']) && $http['form_status']!="-" && $http['form_status']>-5 && $http['form_status']<5 ){
	$where2.=" and p.acceptstatus='".$http['form_status']."'";
}
*/


if (!in_http('print') ||  $http['print']!="yes") {
	// Show header of page
	echo "<h1>".ct('S_SESSIONS_BROWSE_TITLE')."</h1>";
	echo "<p class=\"fontnormal font10\">".ct('S_SESSIONS_BROWSE_INTRO')."</p>";
} else {
	$width = 640;
}


// Show line options of presentation
if (!in_http('print') ||  $http['print']!="yes") {
	echo "<table align=center cellspacing=0 cellpadding=4 border=1>";
	echo "<tr>";
	// Showhide presentations of the sessions
	if (in_http('form_session') || in_http('form_room') || in_http('form_date')) {
		if (isset($http['form_session']) && $http['form_session']!="-" && $http['form_session']>0 ){
			#echo "<td align=center class=\"lightbg\">";
			#echo "<span class=\"fontgray fontbold font8\" >".ct('S_SESSIONS_BROWSE_HIDE_PRESENTATIONS')."</span>";
			#echo "</td>\n";
		} else {
			echo "<td align=center class=\"lightbg\">";
			if (in_http('presentations','show')) {
				echo "<a class=\"fontbold font8\" href=\"".ct_pageurl($page,ct_http_array(array('presentations' => 'hide')))."\" >".ct('S_SESSIONS_BROWSE_HIDE_PRESENTATIONS')."</a>";
			} else {
				echo "<a class=\"fontbold font8\" href=\"".ct_pageurl($page,ct_http_array(array('presentations' => 'show')))."\" >".ct('S_SESSIONS_BROWSE_SHOW_PRESENTATIONS')."</a>";
			}
			echo "</td>\n";
		}
	}

	if (in_http('presentations','show')) {
		echo "<td align=center class=\"lightbg\">";
		if (in_http('abstracts','show')) {
			echo "<a class=\"fontbold font8\" href=\"".ct_pageurl($page,ct_http_array(array('abstracts' => 'hide')))."\" >".ct('S_SESSIONS_BROWSE_HIDE_ABSTRACTS')."</a>";
		} else {
			echo "<a class=\"fontbold font8\" href=\"".ct_pageurl($page,ct_http_array(array('abstracts' => 'show')))."\" >".ct('S_SESSIONS_BROWSE_SHOW_ABSTRACTS')."</a>";
		}
		echo "</td>\n";
	}

	// Downloads are only accessible when users are logged in!
	if ($session->loggedin() && in_http('presentations','show')) {
		echo "<td align=center class=\"lightbg\">";
		if (in_http('downloads','show')) {
			echo "<a class=\"fontbold font8\" href=\"".ct_pageurl($page,ct_http_array(array('downloads' => 'hide')))."\" >".ct('S_SESSIONS_BROWSE_HIDE_DOWNLOADS')."</a>";
		} else {
			echo "<a class=\"fontbold font8\" href=\"".ct_pageurl($page,ct_http_array(array('downloads' => 'show')))."\" >".ct('S_SESSIONS_BROWSE_SHOW_DOWNLOADS')."</a>";
		}
		echo "</td>\n";
	}
	if (in_http('presentations','show')) {
		echo "<td align=center class=\"lightbg\">";
		if (in_http('metadata','show')) {
			echo "<a class=\"fontbold font8\" href=\"".ct_pageurl($page,ct_http_array(array('metadata' => 'hide')))."\" >".ct('S_SESSIONS_BROWSE_HIDE_METADATA')."</a>";
		} else {
			echo "<a class=\"fontbold font8\" href=\"".ct_pageurl($page,ct_http_array(array('metadata' => 'show')))."\" >".ct('S_SESSIONS_BROWSE_SHOW_METADATA')."</a>";
		}
		echo "</td>\n";
	}
	// Open new window with print view
	echo "<td align=center class=\"lightbg\">";
	echo "<a class=\"fontbold font8\" target=\"_blank\" href=\"".ct_pageurl($page,ct_http_array(array('print' => 'yes')))."\" >".ct('S_CTFOOT_PRINTVIEW')."&nbsp;<img src=\"icons/printer.gif\" alt=\"".ct('S_CTFOOT_PRINTVIEW')."\" border=0 style=\"vertical-align: bottom\"></a>";
	echo "</td>\n";
	echo "</tr>";
	echo "</table>";

	ct_vspacer('8');

}

// ------------------------------------------------------------------------


// Show session overview only when not in print mode and if no session was selected.
if (!in_http('print') ||  $http['print']!="yes" || !in_http('form_session')) {

	// Allways show link to show all sessions
	echo "<table  width=\"$width\" align=\"center\" cellspacing=1 border=0 cellpadding=2 class=\"blackbg\">";
	if (!in_http('print') ||  $http['print']!="yes") {
		echo "<tr><td colspan=2 valign=top align=center class=\"whitebg\">\n";
		echo '<a class="fontbold font14" href="'.ct_pageurl($page).'">'.ct('S_SESSIONS_BROWSE_OVERVIEW').'</a><br>';
		echo "</td></tr>\n";
	}

	if (!in_http('form_session')){
		// Query. User can filter by room, date and session id
		$q = "select s.*, p.title as title1, p.gender as gender1, p.name as name1, p.firstname as firstname1, p.organisation as organisation1, p.country as country1, ".
		#" p2.title as title2, p2.gender as gender2, p2.name as name2, p2.firstname as firstname2, p2.organisation as organisation2, p2.country as country2, ".
		" COUNT(pa.ID) as countpapers".
	    " FROM sessions AS s ".
	    " LEFT JOIN persons AS p ON s.chairID=p.ID".
	    #" LEFT JOIN persons AS p2 ON s.chair2ID=p2.ID ".
	    " LEFT JOIN papers as pa ON s.ID=pa.track $where GROUP BY s.ID ORDER BY s.starttime, s.shorttitle, s.title "; // s.roomID,
		#echo "$q<br>\n";
		$s = $db->query($q);
		$num_sessions = $db->num_rows($s);
		if ($num_sessions > 0) {
			$lastdate='';
			for ($i = 0; $i < $num_sessions; $i++) {
				$row = $db->fetch($s);

				// Get details about all papers of this session
				$sq = "SELECT p.* FROM papers AS p, sessions AS s WHERE ";
				$sq .="p.withdrawn=0 AND p.track=s.ID and p.track='".$row['ID']."' GROUP by p.ID order by p.numberInTrack, p.title";
				$sr= $db->query($sq);
				$presentations_exist = ($sr && $db->num_rows($sr)> 0);
				#echo "$sq<br>\n";

				if ($lastdate != ct_date_format($row['starttime'])) {
					// Formatting for filter and "how by day"
					$form_date=date("Y-m-d",ct_datetime_2_timestamp($row['starttime']));
					echo "<tr><td colspan=2 valign=top align=left class=\"listheader\">\n";
					if (in_http('print') &&  $http['print']=="yes") ct_vspacer(8);
		  			echo '<a class="fontbold font12" href="'.ct_pageurl($page, ct_http_array(array('form_date'=>$form_date, 'form_room'=>'','form_session'=>''))).'">';
					echo ct('S_SESSIONS_BROWSE_DATE').': '.ct_get_dow($row['starttime']).', '.ct_date_format($row['starttime'])."</a>\n";
					echo "</td></tr>\n";
					$lastdate = ct_date_format($row['starttime']);
				}

				// Left Column: Show the day...
				echo '<tr><td class="brightbg topline_printonly" align=center valign="middle" width="20%">';
				echo '<span class="fontbold font10">';
				echo ct_time_format($row['starttime']);
				if ($row['endtime']>0 && $row['starttime']!=$row['endtime']) {
					echo ' - ';
					echo ct_time_format($row['endtime']);
				}
				echo '</span></td>';

				// Right Column: Show the name of the session
				echo '<td rowspan="2" class="whitebg topline_printonly leftline_printonly" align=left valign=top>';
				echo get_session_header_small($page,$row,$presentations_exist);
				echo "</td></tr>\n";

				// left column, second row, show the room of the session
				echo '<tr><td class="lightbg" align=center valign="middle" width="20%">';
				if ($row['roomID']!="") {
		  			echo '<a class="fontbold font10" href="'.ct_pageurl($page ,ct_http_array(array('form_room'=>$row['roomID'], 'form_session'=>'', 'form_date'=>''))).'">';
		  			echo ct_get_session_room($row['roomID']).'</a>';
				}
				echo "&nbsp;</td></tr>\n";

				// Show presentations / contribtions to this session as well
				if (in_http('presentations') && $http['presentations']=='show' && // Show presentations?
					 $presentations_exist) { // Are there any presentations?

					# left column for presentations
					echo '<tr><td class="whitebg" align=center valign="top" width="20%">';
					ct_vspacer('4');
					#echo "<span class=\"font12\">".ct('S_SESSIONS_BROWSE_PRESENTATIONS')."</span>\n";
					echo "</td>\n";

					# right column for presentations
					echo '<td class="whitebg leftline_printonly" align=left valign="top" width="80%">';

					echo show_session_presentations($sr,(in_http('metadata','show')),(in_http('abstracts','show')),(in_http('downloads','show')));

				}
			}
		}
	}
	echo "</table>\n";
} // End hide session overview for printout.

ct_vspacer('16');


// Show contribtions and abstracts of one session...
if (in_http('form_session') && $http['form_session']!='-' && $http['form_session']>0) {

	// Print view?
	if (in_http('print') &&  $http['print']=="yes")
		echo "<table width=\"$width\" align=\"center\" cellpadding=0 class=\"table_noborder\">";
	else
		echo "<table width=\"$width\" align=\"center\" cellpadding=5 class=\"table_blackborder1px\">";

	if (isset($http['form_session']) && $http['form_session']!="-" && $http['form_session']>0 ){
		echo "<tr><td valign=top align=left class=\"listheader\">\n";
		echo "<span class=\"fontbold font14\">".ct('S_ADMIN_PAPERS_RESULTS_SESSION')."</span>\n";
		echo "</td></tr>\n";

		echo get_session_header($http['form_session']);

	}

	// Show presentations.
	// -------------------

	$q = "select p.* FROM papers AS p, sessions AS s WHERE ";
	$q .= "p.withdrawn=0 AND p.track=s.ID $where2 GROUP by p.ID order by p.numberInTrack, p.title";
	$r= $db->query($q);
	# echo "$q<br>\n";

	$num = $db->num_rows($r);
	if ($num > 0) {

		echo "<tr><td valign=top align=left class=\"lightbg\">\n";
		echo "<span class=\"fontbold font14\">".ct('S_SESSIONS_BROWSE_PRESENTATIONS')."</span>\n";
		echo "</td></tr>\n";
		echo "<tr><td class=\"whitebg topline_black\" align=left valign=top>";

		echo show_session_presentations($r,(in_http('metadata','show')),(in_http('abstracts','show')),(in_http('downloads','show')));

		echo "</table>\n";

	} else {
		echo "<tr><td class=\"whitebg\" align=left valign=top>";
		echo '<span class="fontnegative fontbold font10">'.ct('S_SESSIONS_BROWSE_NOCONTRIBUTIONS').'</span>';
		echo "</td></tr>\n";
		echo "</table>\n";
		echo "<br />";
	}
}

echo "<br />\n";

?>
