<?php
//
// PAGE:		editFinalPaper
// DESC:		Edit final data of paper
//

// this page does only make sense if an ID for a paper was provided. If not,
// we redirect to the index page

ct_pagepath(array("index"));


if (!isset($http['form_id'])) {
	$session->put_errorbox(ct('S_ERROR_PAPER_EDIT'), ct('S_ERROR_PAPER_EDIT_NOACCESS'));
	ct_redirect(ct_pageurl('index'));
}


ct_load_class('CTPaper');
$paper = new CTPaper;


// redirect to index if id does not correspond to a real paper
if (!$paper->load_by_id($http['form_id'])) {
	$session->put_errorbox(ct('S_ERROR_PAPER_EDIT'), ct('S_ERROR_PAPER_EDIT_NOACCESS'));
	ct_redirect(ct_pageurl('index'));
}

// Get correct paper class name
$classname = $paper->get_paperClass();
ct_load_class($classname);
eval('$paperclass = new '.$classname.'();');
$paperclass = ct_type_cast($paper,$classname);


// if user has no admin rights, check if phase "finalupload" is active
if ($user->is_admin() || 
		(ct_check_phases(array("finalupload")) && $paperclass->is_upload_active())) {
	
	$author =& $paperclass->get_author(); 
	$errors = array();
	
	// check if user is allowed to edit paper information. access is denied
	// if user has no admin rights and is not the author of the paper
	if (!$user->is_admin() && ($user->get('ID') != $author->get('ID'))) {
		$session->put_errorbox(ct('S_ERROR_PAPER_EDIT'), ct('S_ERROR_PAPER_EDIT_NOACCESS'));
		ct_redirect(ct_pageurl('index'));
	}

	if (isset($http['cmd_save'])) {
		$errors = $paperclass->process_form_finals();
		if ($errors===false) {
			$paperclass->persist();
			// All uploads OK! Show such a message!
			$session->put_infobox(ct('S_INFO_SAVE'), ct('S_INFO_SAVE_SUCCESS'));
		 	ct_redirect($session->get_besturl());
		 	// ct_redirect(ct_pageurl('submissions'));
		}
	} 
	
	echo "<h1>".ct('S_PAPER_FINALUPLOAD_TITLE')."</h1>\n";
	echo "<p class=\"fontnormal font10\">".ct('S_PAPER_FINALUPLOAD_INTRO')."</p>";
	$paperclass->show_detailed('90%');
	#echo "<table  width=\"90%\" align=\"center\" cellspacing=1 border=0 cellpadding=2 class=\"blackbg\">";
	#echo "<tr><td class=\"whitebg\" align=left valign=top>";
	#$paperclass->show_formatted(true,true);
	#echo "</td></tr></table>\n";	
	$paperclass->show_finaluploadform(ct_pageurl('editFinalPaper'),$errors);
} else {
	$session->put_errorbox(ct('S_ERROR_PHASE'), ct('S_ERROR_PHASE_INACTIVE'));
	ct_redirect(ct_pageurl('error'));
}

?>