<?php
//
// PAGE:     editIdentity
// Edit personal data for Identity management...
//

ct_pagepath(array('index'));

ct_load_class('CTIdentity');

$person = new CTPerson;
$identity = new CTIdentity;
$form_errors = array();

if (in_http('nextpage','submissions'))
	$nextpage="submissions";
else 
	$nextpage="index";

// check if user is allowed to edit the identity data.
// if user has no admin rights and is not the person himself he gets his own page...
// of if no http param is set, use the personID of the current user
if ((!$user->is_admin() && !$user->is_assistant() &&
	 (isset($http['form_personID']) || isset($http['form_id'])) ) ||
	 (!isset($http['form_personID']) && !isset($http['form_id']))) {
	$http['form_personID']=$user->get_id();
}


// Load person...
if (isset($http['form_personID'])) {
	$identity->load_by_personID($http['form_personID']);
} elseif (isset($http['form_id'])) {
	$identity->load_by_id($http['form_id']);
} else {
	$session->put_errorbox(ct('S_ERROR_IDENTITY'), ct('S_ERROR_IDENTITY_PERSONNOTFOUND'));
	ct_redirect(ct_pageurl('error'));
}

// User identity not yet defined: Fill with defaults...
if ($identity->get_id()=="")  {
	if ($person->load_by_id($http['form_personID'])) {
		// Set default data...
		$identity->set('personID',$person->get_id());
		$identity->set('title',$person->get('title'));
		$identity->set('name',$person->get('name'));
		$identity->set('firstname',$person->get('firstname'));
		$identity->set('fullname',trim($person->get('firstname').' '.$person->get('name')));
		$identity->set('gender',$person->get('gender'));
		$identity->set('organisation',$person->get('organisation'));
		$identity->set('nickname',$person->get('firstname'));
		$identity->set('city',$person->get('city'));
		$identity->set('state',$person->get('state'));
		$identity->set('country',$person->get('country'));
		$identity->set('email',$person->get('email'));
		$identity->set('url',$person->get('url'));
		$identity->set('visibility', 'onlist');
		// ct_load_lib('password.lib');
		// $identity->set('password', ct_randString());  // Session key for external Meeting Mirror
		$identity->persist();
	    $identity->load_by_personID($http['form_personID']); // Load another time to get identityID!
	} else {
		$session->put_errorbox(ct('S_ERROR_IDENTITY'), ct('S_ERROR_IDENTITY_PERSONNOTFOUND'));
		ct_redirect(ct_pageurl('error'));
	}
}


// cancel...	
if (isset($http['cmd_cancel'])) {
	if ($user->is_admin() || $user->is_assistant() || $user->is_frontdesk ) {
		ct_redirect($session->get_besturl());
	} else {
		ct_redirect(ct_pageurl($nextpage));
	}
}


// Delete Icon
if (isset($http['cmd_delete_icon'])) {
	$identity->deleteIcon();
	$identity->persist();
	$session->put_infobox(ct('S_INFO_IDENTITY'),ct('S_INFO_IDENTITY_ICONDELETED'));
	ct_redirect(ct_pageurl('editIdentity',array("form_personID"=>$identity->get_personID(),'nextpage'=>$nextpage)));
}


// Save identity
if (isset($http['cmd_save_identity'])) {
	$form_errors = $identity->process_form();
	if (!$form_errors) { 
		$identity->undelete();
		$identity->persist();
		$session->put_infobox(ct('S_INFO_IDENTITY'),ct('S_INFO_IDENTITY_SAVE'));
		if ($user->is_admin() || $user->is_assistant() || $user->is_frontdesk ) {
			ct_redirect($session->get_besturl());
		} else {
			ct_redirect(ct_pageurl($nextpage));
		}
	} else {
		ct_errorbox(ct('S_ERROR_IDENTITY'), ct('S_ERROR_IDENTITY_SAVEFAILED'));
	}
	
// Save identity and upload image...
} elseif (isset($http['cmd_upload_icon'])) {
	
	$form_errors = $identity->process_form();

	if (!$form_errors) { 
	
		$submit_error=true;
		global $_FILES;
		$file = $_FILES['form_filename'];

		// Process icon upload
		if ($file['name'] != 'none' && $file['name'] != '' ) {
		
			$fname = addslashes($file['name']);
		
			if ($identity->isLegalIconType($fname)) {
				if (is_uploaded_file($file['tmp_name'])) {
					$icon_file = fopen($file['tmp_name'],"r");
					$fileContents = fread($icon_file, filesize($file['tmp_name']));
					if ($identity->isLegalIconSize($fileContents)) {
						$identity->set('iconname', $fname);
						$identity->set('communityicon', addslashes($fileContents));
						$submit_error=false;
					} else {
						ct_errorbox(ct('S_ERROR_IDENTITY'), ct('S_ERROR_IDENTITY_ILLEGAL_FILESIZE')." ".strlen($fileContents)." Bytes.");
					}
				} else {
					ct_errorbox(ct('S_ERROR_IDENTITY'), ct('S_ERROR_IDENTITY_ILLEGAL_FILESIZE'));
				}
					
			} else {
				ct_errorbox(ct('S_ERROR_IDENTITY'), ct('S_ERROR_IDENTITY_ILLEGAL_FILETYPE'));
			}
		} else {
			ct_errorbox(ct('S_ERROR_IDENTITY'), ct('S_ERROR_IDENTITY_NO_FILE'));
		}
		// icon upload suceeded!
		$identity->undelete();
		$identity->persist();
		if ($submit_error) {
			// ct_infobox(ct('S_INFO_IDENTITY'),ct('S_INFO_IDENTITY_SAVE'));
		} else {
			ct_infobox(ct('S_INFO_IDENTITY'),ct('S_INFO_IDENTITY_SAVEICON'));
			if ($user->is_admin() || $user->is_assistant() || $user->is_frontdesk ) {
				ct_redirect($session->get_besturl());
			} else {
				ct_redirect(ct_pageurl($nextpage));
			}
		}
	} else {
		ct_errorbox(ct('S_ERROR_IDENTITY'), ct('S_ERROR_IDENTITY_SAVEFAILED'));
	}
} 

echo "<h1>".ct('S_IDENTITY_EDIT_TITLE')."</h1>\n";
echo "<p class=\"fontnormal font10\">".ct('S_IDENTITY_EDIT_INTRO')."</p>\n";
$identity->show_form(ct_pageurl('editIdentity'), $form_errors);


?>
