<?php
//
// PAGE:		editMessagePC
// DESC:		enter or edit a message for the PC discussion forum
//

// if user has no admin rights, check if is pc member and "paperbids" is active
if (! ($user->is_admin() ||
        $user->is_chair() ||
        $user->is_conferenceChair() || ($user->is_pc() and ct_check_phases("reviewdiscussion")))) {
        $session->put_errorbox(ct('S_ERROR_PHASE'), ct('S_ERROR_PHASE_INACTIVE'));
        ct_redirect(ct_pageurl('error'));
}

ct_load_class('CTForm');
ct_load_class('CTPCMessage');
ct_load_class('CTPaper');

$pcmessage=new CTPCMessage();

ct_pagepath(array('index','browseDiscussResults','browsePCMessages'));

$form_errors=array();

// Load paper data
$paper = new CTPaper();
if (isset($http['paperID']) && $http['paperID']>0) { // Came from forum page, load by paperID
	if (!$paper->load_by_id($http['paperID'])) {
		ct_redirect($session->get_besturl());
	}
	$pcmessage->set('paperID',$http['paperID']);
	$pcmessage->set('personID',$user->get_id());
} elseif (isset($http['form_paperID']) && $http['form_paperID']>0) { // Error creating new message. Show data again using form data!
	if (!$paper->load_by_id($http['form_paperID'])) {
		ct_redirect($session->get_besturl());
	}
} else {
	$session->put_errorbox(ct('S_ERROR_PC_DISCUSSION'), ct('S_ERROR_PC_DISCUSSION_NOACCESS'));
	ct_redirect($session->get_besturl());
}

// get contributiontype and check if it will be discussed as well...
$ctype = $paper->_get_contributiontype();
if ($ctype['do_discussion']=='false') {
	$session->put_errorbox(ct('S_ERROR_PC_DISCUSSION'), ct('S_ERROR_PC_DISCUSSION_NOACCESS'));
	ct_redirect($session->get_besturl());
}

// User wants to access message by ID
if (isset($http['messageID']) && $http['messageID']>0) { 
	if ($pcmessage->load_by_id($http['messageID']) && 
			($user->is_admin() || $user->is_chair() || $user->is_conferenceChair() ||
			 $pcmessage->get_personID()==$user->get_id() ) ) {
		// OK access to message granted
		if (isset($http['delete'])) {
			echo "<h1>".ct('S_DELETEMESSAGE_TITLE')."</h1>\n";
			echo "<p class=\"fontnormal font10\">".ct('S_DELETEMESSAGE_QUERY')."</p>\n";
			$pcmessage->show_shortinfo('600');
			$form = new CTForm(ct_pageurl('editMessagePC'), 'post', array());
			$form->width='600';
			$form->align='center';
			$form->add_hidden(array(array('messageID', $http['messageID'])));
			$form->add_hidden(array(array('paperID', $http['paperID'])));
			$form->add_submit('cmd_delete', ct('S_DELETEMESSAGE_CONFIRM'));
			$form->add_submit('cmd_cancel', ct('S_BUTTON_CANCEL'));
			$form->show();
		} elseif (isset($http['cmd_cancel'])){
			ct_redirect(ct_pageurl('browsePCMessages', array('paperID'=>$http['paperID'])));
		} elseif (isset($http['cmd_delete'])) {
			if ($pcmessage->delete() && $pcmessage->persist()) {
				$session->put_infobox(ct('S_INFO_DELETEMESSAGE'), ct('S_INFO_DELETEMESSAGE_SUCCESS',array($pcmessage->get('subject'))));
				ct_redirect(ct_pageurl('browsePCMessages', array('paperID'=>$http['paperID'])));
			} else {
				$session->put_errorbox(ct('S_ERROR_PC_DISCUSSION'), ct('S_ERROR_PC_DISCUSSION_NOACCESS'));
				ct_redirect(ct_pageurl('error'));
			}
		}
	// access failed...			
	} else {
		$session->put_errorbox(ct('S_ERROR_PC_DISCUSSION'), ct('S_ERROR_PC_DISCUSSION_NOACCESS'));
		ct_redirect($session->get_besturl());
	}
} else 
// Now check if access to editing messages is permitted.
if ( ($user->is_admin()) || $user->is_chair() || $user->is_conferenceChair() ||	// can do anything...
	 (ct_check_phases("reviewdiscussion") && $user->is_pc() && $user->get_id()!=$paper->get('personID')) ) { 

	// Is the user allowed to create new messages, or is the discussion already closed?
	if ($paper->get('acceptstatus')!=0 && 
			!$user->is_admin() && !$user->is_chair() && !$user->is_conferenceChair()) { 
		$session->put_warningbox(ct('S_ERROR_PC_MESSAGE_CLOSED'),ct('S_ERROR_PC_MESSAGE_CLOSED_INFO'));
		ct_redirect($session->get_besturl());
	}
	 	
	// Try to create a new message.
 	if (isset($http['cmd_create'])) {
		$form_errors = $pcmessage->process_form();
		if (!count($form_errors) && $user->get_id()==$pcmessage->get('personID')) { // Fill in all fields and do not fake the userID!
			$pcmessage->persist();
			$session->put_infobox(ct('S_INFO_PC_MESSAGE_CREATE'), ct('S_INFO_PC_MESSAGE_CREATE_SAVED'));
			ct_redirect(ct_pageurl('browsePCMessages', array('paperID'=>$http['form_paperID'])));
		} else {
			ct_errorbox(ct('S_ERROR_PC_MESSAGE_CREATE'), ct('S_ERROR_PC_MESSAGE_CREATE_FAILED'));
		}
	} 
	// Now show the input form	
 	echo "<h1>".ct('S_PC_MESSAGE_EDIT_TITLE')."</h1>\n";
	echo "<p class=\"fontnormal font10\">".ct('S_PC_MESSAGE_EDIT_INTRO')."</p>\n";
	$paper->show_detailed('90%');
	echo "<br>";

	$pcmessage->show_form(ct_pageurl('editMessagePC'),$form_errors); 
 
} else {
	$session->put_errorbox(ct('S_ERROR_PC_DISCUSSION'), ct('S_ERROR_PC_DISCUSSION_NOACCESS'));
	ct_redirect(ct_pageurl('error'));
}
 

?>
