<?php
//
// PAGE:	 editParticipant
// DESC:     Users may edit their own! participation data (only for few conferences required)
//

ct_pagepath(array('index'));
#$session->del('db_timediscounts'); // delete cache!
#$session->del('db_groups');

ct_load_class('CTForm');
ct_load_class('CTParticipation'); 
ct_load_class('CTParticipation_Form'); 

$form_errors = array();
$participation = new CTParticipation_Form;

if (!($user->is_participant() && $participation->pdata['payamount']==0 && ctconf_get('participation/useredit'))){ // Allow editing if enabled and if not yet payed.
	ct_redirect(ct_pageurl('index'));
}

// check if phase "participation" is active
if (!ct_check_phases("participation")) {
	$session->put_errorbox(ct('S_ERROR_PHASE'), ct('S_ERROR_PHASE_INACTIVE'));
	ct_redirect(ct_pageurl('error'));
}

$form_errors = array();

if (isset($http['cmd_save_participant'])) {
	$participation->load_by_id($user->get_ID());
	$form_errors = $participation->process_form_useredit();
	if (!$form_errors) {
		$participation->persist();
		$user->reload(); // reload user data, maybe it changed...

		// SAFERPAY: Create a new link with the new amount!
		if ($participation->get('paymethod')=='ccexternal' && 
			$participation->get('total')>1 && $participation->get('total')-$participation->get('payamount')>1 && // at least 1$!
			ct_test_lib('cc_processor_saferpay.lib') ) {
			ct_load_lib('cc_processor_saferpay.lib'); 			// Use payflow link to process credit card data!
			cc_process_registration($participation);
		}
		
		$session->put_infobox(ct('S_INFO_EDITPARTICIPANT'),ct('S_INFO_EDITPARTICIPANT_SUCCESS'));
		ct_redirect(ct_pageurl('index'));
	} else {
		ct_errorbox(ct('S_ERROR_EDITPARTICIPANT'), ct('S_ERROR_EDITPARTICIPANT_FAILED'));
		$participation->show_form_useredit(ct_pageurl('editParticipant'), $form_errors);
	}
} elseif(isset($http['cmd_cancel'])) {
	ct_redirect($session->get_besturl());
} else {
	if ($participation->load_by_id($user->get_ID()) === true) { // Already known? -> Edit
		if ($participation->get('deleted') == 1) {
			echo "<h1>".ct('S_UNDELETEPARTICIPANT_TITLE')."</h1>\n";
		} else {
			echo "<h1>".ct('S_EDITPARTICIPANT_TITLE')."</h1>\n";
		}
		$participation->show_participant_status('99%','center');
		$participation->show_form_useredit(ct_pageurl('editParticipant'), $form_errors);
	}
}
?>
