<?php
//
// PAGE:     editPerson
// Edit personal data.
//

ct_pagepath(array('index'));

ct_load_lib('mail.lib');
ct_load_lib('person.lib');
ct_load_lib('password.lib');
ct_load_class('CTPerson_Form');

$person = new CTPerson_Form();
$person->load_by_id($user->get_id());

$form_errors = array();

// Save person data
if (isset($http['cmd_save_person'])) {

	// test form entries...
	$form_errors = $person->process_form();

	// test if username exists (also consider deleted users)
	$sameusername=0;
	if (isset($http['form_username']) && $http['form_username']!="") {
		$r = $db->query("select * from persons where username='".$http['form_username']."' and ID!='".$user->get_id()."'");
		$sameusername = $db->num_rows($r);
	}

	// test if mail exists (don't consider deleted users or if user did not change his address...
	$samemail=0;
	if (isset($http['form_email']) && $http['form_email']!="" && $person->get('email')!=$user->get('email')) { 
		$r = $db->query("select * from persons where ".
						"(email='".$http['form_email']."' or email2='".$http['form_email']."') ".
						"and (deleted=0) AND ID!=".$user->get_id());
		$samemail = $db->num_rows($r);
	}

	// try to save user
	if ( !$form_errors && $sameusername==0 && $samemail==0 ) {

		// save data: Password will be encrypted now.
 		$person->persist();

 		// Show messages...
 		if ($person->get('username')!=$user->get('username'))
	        $session->put_warningbox(ct('S_INFO_SAVEUSER'),ct('S_INFO_SAVEUSER_NEWUSERNAME',array($person->get('username'))));
 		if ($person->get('password')!=$user->get('password'))
	        $session->put_warningbox(ct('S_INFO_SAVEUSER'),ct('S_INFO_SAVEUSER_NEWPASSWORD'));
        $session->put_infobox(ct('S_INFO_SAVEUSER'),ct('S_INFO_SAVEUSER_SUCCESS'));
	        	
		$user->reload(); // reload user data, maybe it changed...
		
		ct_redirect(ct_pageurl('index'));

	// don't save		
	} else {
		if (is_array($form_errors) && (in_array('form_email',$form_errors) || in_array('form_email2',$form_errors)))
			ct_errorbox(ct('S_ERROR_SAVEUSER'), ct('S_ERROR_REGISTER_EMAIL_INVALID'));
		if (is_array($form_errors) && in_array("form_pwd",$form_errors)) {
			$msg = ct_validate_password($http['form_pwd'],$person);
			ct_errorbox(ct('S_ERROR_SAVEUSER'), '<ul><li>'.implode('<li>',$msg).'</ul>');
		} elseif (is_array($form_errors) && in_array('form_pwd2',$form_errors)) {
			ct_errorbox(ct('S_ERROR_SAVEUSER'), ct('S_ERROR_REGISTER_PASSWORD_NOMATCH'));
		}
		if ($sameusername) {
			ct_errorbox(ct('S_ERROR_SAVEUSER'), ct('S_ERROR_PERSON_EDIT_USERNAMEEXISTS'));
			$form_errors[]='form_username';
		} elseif ($samemail) {
			ct_errorbox(ct('S_ERROR_SAVEUSER'), ct('S_ERROR_REGISTER_EMAILEXISTS'));
			$form_errors[]='form_email';
		} else
			ct_errorbox(ct('S_ERROR_SAVEUSER'), ct('S_ERROR_SAVEUSER_FAILED'));
		// => show form again (see below...)
	}
}

echo "<h1>".ct('S_EDITPERSON_TITLE')."</h1>\n";
echo "<p class=\"fontnormal font10\">".ct('S_EDITPERSON_INTRO')."</p>\n";
$person->show_form(ct_pageurl('editPerson'), $form_errors);

?>
