<?php
//
// PAGE:		frontdesk
// The frontdesk is to be used at the conference registration desk. This is the main page for
// the registration staff...
//

ct_requirefrontdesk();

if (!ct_check_phases('frontdesk')) {
	$session->put_errorbox(ct('S_ERROR_PHASE'), ct('S_ERROR_PHASE_INACTIVE'));
	ct_redirect(ct_pageurl('error'));
}

ct_load_lib('participation.lib');
ct_load_lib('admin.lib');

ct_pagepath(array('index'));

$session->set_besturl(ct('S_FRONTDESK_CMD'));

echo "<H1><A HREF=\"".ct_pageurl('frontdesk')."\">".ct('S_FRONTDESK_CMD')."</A></H1>\n";

if ((isset($http['listLetter']) || (isset($http['navbar_search']) && $http['navbar_search']!='' ) || isset($http['isarrived']) ) && !(isset($http['form_nonregistered'])  && $http['form_nonregistered']==1) ) {
	$query="select participants.* from participants, persons";

	$where=" where participants.personID=persons.ID";

	if ($http['form_deleted']!="yes") {
		$where .= " and participants.deleted=0";
	}

	if (isset($http['listLetter']) && $http['listLetter']!="all" ) {
		$where .= " and UPPER(persons.name) LIKE '".$http['listLetter']."%'";
		echo "<H3>".ct('S_FRONTDESK_PARTICIPANTS').": ".ct_form_encode($http['listLetter'])."...</H3>";
	}

	if (isset($http['navbar_search'])) {
		if (preg_match("/^[0-9]+$/", $http['navbar_search']) ) {
			$where .= " AND (persons.ID = ".$http['navbar_search'].")";
			echo "<H3>".ct('S_FRONTDESK_QUERY').": ".ct('S_USER_ID')." ".ct_form_encode($http['navbar_search'])."</H3>";
		} else {
			$where .= " AND ((UPPER(persons.name) LIKE \"%".strtoupper($http['navbar_search'])."%\") OR ";
			$where .= " (UPPER(persons.firstname) LIKE \"%".strtoupper($http['navbar_search'])."%\") OR ";
			$where .= " (UPPER(persons.organisation) LIKE \"%".strtoupper($http['navbar_search'])."%\"))";
			echo "<H3>".ct('S_FRONTDESK_QUERY').": ...".ct_form_encode($http['navbar_search'])."...</H3>";
		}
	}

	if (isset($http['isarrived'])) {
		if ($http['isarrived'] == "yes") {
			$where .= " AND participants.frontdesk like '%arrived%'"; // FIND_IN_SET('arrived',frontdesk)>0; also works
			echo "<H3>".ct('S_FRONTDESK_LIST_ARRIVED').": ".ct_form_encode($http['navbar_search'])."</H3>";
		} else {
			$where .= " AND !(participants.frontdesk like '%arrived%')";
			echo "<H3>".ct('S_FRONTDESK_LIST_MISSING').": ".ct_form_encode($http['navbar_search'])."</H3>";
		}
	}

	$order = ' order by persons.name asc, persons.firstname asc';

	$query.=$where;
	$query.=$order;
	// echo $query;

	$r = $db->query($query);

	if ($r >= 0) {
		listfrontdesk($r, 'frontdesk');  // -> see below!
	} else {
		echo "<H3>".ct('S_ADMIN_PARTICIPANTS_BROWSE_NONE')."</H3>\n";
	}
} else if ((isset($http['navbar_search']) && $http['navbar_search']!='' ) && isset($http['form_nonregistered']) && $http['form_nonregistered']==1) {
	// show all users
	$query="select * from persons ";

	$where="WHERE deleted=0 ";

	if (isset($http['navbar_search'])) {
		if (preg_match("/^[0-9]+$/", $http['navbar_search']) ) {
			$where .= " AND (persons.ID = '".$http['navbar_search']."')";
		} else {
			$where .= " AND ((UPPER(persons.name) LIKE \"%".strtoupper($http['navbar_search'])."%\") OR ";
			$where .= " (UPPER(persons.firstname) LIKE \"%".strtoupper($http['navbar_search'])."%\") OR ";
			$where .= " (UPPER(persons.organisation) LIKE \"%".strtoupper($http['navbar_search'])."%\"))";
		}
		echo "<H3>".ct('S_FRONTDESK_QUERY2').": ...".ct_form_encode($http['navbar_search'])."...</H3>";
	}

	$order = ' order by persons.name asc, persons.firstname asc';

	$query.=$where;
	$query.=$order;
	//echo $query;

	$r = $db->query($query);

	if ($r >= 0) {
		ctadm_listusers($r, 'frontdesk'); // -> admin.lib
	} else {
		echo "<H3>".ct('S_ADMIN_USERS_BROWSE_NONE')."</H3>\n";
	}
} else {
	echo "<p class=\"fontnormal font10\">".ct('S_FRONTDESK_INTRO')."</p>\n";
}

echo "\n<br>\n";

ct_frontdesk_searchmask();

// list users and participants for frontdesk user
function listfrontdesk($res,$page,$filter=array()) {
	global $db, $http, $ctconf;
	ct_load_class('CTParticipation');
	$participation= new CTParticipation;
	$feetotal = 0;
	$paidtotal = 0;
	$eventsum = 0;

	ct_load_lib('navbar.lib');
	$items      = $db->num_rows($res);
	ct_navbar($page,$items);
	$perpage    = isset($http['navbar_perpage']) && $http['navbar_perpage']!=""?$http['navbar_perpage']:ctconf_get('display_perpage',20);
	$pageno     = isset($http['navbar_page'])?$http['navbar_page']:0; // default is 0
	$maxpage    = intval(($items-1)/($perpage));

	if (($res >= 0) && ($db->num_rows($res) > 0)) {
		echo "<table width=\"100%\" cellspacing=1 cellpadding=2 border=0>\n";
		echo "<tr class=\"listheader\">\n";
		echo "<td width=\"3%\" align=\"center\"><span class=\"listheader_label\">".ct('S_USER_COUNT')."</span></td>\n";
		echo "<td width=\"3%\" align=\"center\"><span class=\"listheader_label\">".ct('S_USER_ID')."</span></td>\n";
		echo "<td width=\"32%\">".ct('S_USER_FULLNAME')."<br>\n";
		echo "<span class=\"fontnormal font8\">".ct('S_USER_EMAIL')."</span></td>\n";
		echo "<td width=\"27%\">".ct('S_USER_ORGANISATION')."<br>";
		echo "<span class=\"fontnormal font8\">".ct('S_USER_COUNTRY')."</span></td>\n";
		echo "<td align=\"center\" width=\"5%\">".ct('S_PARTICIPATE_PAYMENT_METHOD')."<BR>\n";
		echo "<span class=\"fontnormal font8\">".ct('S_PARTICIPATE_REGDATE_SHORT')."</span></td>\n";
		echo "<td width=\"5%\" align=\"right\">".ct('S_PARTICIPATE_TOTALFEE')."<BR>\n";
		echo "<span class=\"fontnormal font8\">".ct('S_PARTICIPATE_INVOICEDATE_SHORT')."</span></td>\n";
		echo "<td width=\"5%\" align=\"right\">".ct('S_PARTICIPATE_PAYAMOUNT')."<BR>\n";
		echo "<span class=\"fontnormal font8\">".ct('S_PARTICIPATE_PAYDATE_SHORT')."</span></td>\n";
		echo "<td width=\"5%\" align=\"right\"><span class=\"listheader_label\">".ct('S_ADMIN_USERS_ACTIONS')."</span></td>\n";
		echo "</tr>\n";
		for ($i=0; $i < $db->num_rows($res); $i++) {
			$row= $db->fetch($res);
			if (intval($i/$perpage)==$pageno) {
				$participation->_init();
				$participation->pdata=$row; 		 // Fill participant data from query output
				$participation->_load_persondata();  // load the persondata
				$participation->show_row(($i%2?"oddrow":"evenrow"),$i,$http['form_event'],$page);
			}
		}
		echo "<tr class=\"darkbg\">\n";
		echo "<td colspan=\"9\"><span class=\"form_label\">".ct('S_ADMIN_PARTICIPANTS_BROWSE_SUM1')." $i ".ct('S_ADMIN_PARTICIPANTS_BROWSE_SUM2')."</span></td>\n";
		echo "</tr>\n";
		echo "</table>\n";
		if ($maxpage>0) ct_navbar_small($page,$items);
	}
}


?>
