<?php
//
// PAGE:		index
// The main page of the Conftool showing all menu options.
//

if ($user->is_participant()){
	$participation = new CTParticipationData;
	$participation->load_by_id($user->get_id());
}

$session->set_besturl();

echo "<h1>".ct('S_INDEX_WELCOME')." ".ct_form_encode($user->get_fullname())."!</h1>\n";

echo "<p class=\"fontnormal font10\">".ct('S_INDEX_YOUARELOGGEDIN')." <b>".$user->get_special('username')."</b>.</p>\n";

// Participation and payment info (hide for Admin...)
if(ctconf_get('participation/enabled') && ctconf_get('payment/enabled') ) { // && !(ct_check_phases("submission") || ct_check_phases("reviewing")) ) {
	if ($user->is_participant()){
		echo "<p><span class=\"fontlabel font10\">".ct('S_INDEX_YOUAREPARTICIPANT')." ";
		echo ct('S_PARTICIPATE_TOTALFEE').":</span> <span class=\"fontnormal font10\">".ct_currency_format($participation->pdata['total'])."</span><br>\n";
		echo "<span class=\"fontlabel font10\">".ct('S_PARTICIPATE_PAYMENT_SELECTEDMETHOD').":</span> <span class=\"fontnormal font10\">";

		ct_load_lib('payment.lib');
		echo ct_get_payment_description($participation->get('paymethod'));

		echo "</span></p>\n";
		if ($participation->get('total')>0 || $participation->get('payamount')!=0) {
			ct_show_payment_info($participation);
			if ($participation->get('total')-$participation->get('payamount')>0.01) {
				echo "\n<table border=0 width='85%' class='whitebg'><tr><td>";
				ct_show_paymethod_details($participation,true);
				echo "</td></tr></table>\n";
				echo "<br>\n";
			}
		}
	} elseif (ct_check_phases("participation") && $user->get_id()!= 1) {
		echo "<p class=\"oddrow_del\"><span class=\"fontnormal font10\">".ct('S_INDEX_YOUARENOPARTICIPANT')."</span></p>\n";
	}
}

//#### general actions available to all users
echo "<a name=\"menu\"></a>";
echo "<table cellpadding=5 align=center width=\"100%\">\n";

echo "<tr><td colspan=2 class=\"mediumbg_gradient\">\n";
echo "<span class=\"fontbold font10\">".ct('S_INDEX_YOUHAVEOPTIONS').":</span>\n";
echo "</td></tr><tr><td width=\"5%\" class=\"mediumbg\">&nbsp;</td>";
echo "<td width=\"95%\" valign=top align=left class=\"lightbg\">\n";
echo "<dl>\n";

//#### Show or edit personal user data
echo "<dt><a class=\"cmda\" href=\"".ct_pageurl('editPerson')."\">".ct('S_INDEX_CMD_EDITPERSON')."</a></dt>\n";
echo "<dd class=\"fontnormal font10\">".ct('S_INDEX_OPTION_EDITPERSON')."</dd>\n";

### Submit and manage contributions
if (ctconf_get('submission/enabled')) {
	$submissions = $user->count_submitted_papers();
	$next_deadline = ct_get_next_submission_deadline();
	// Only show if user did already submit something or at least one deadline is still to come and user is not root admin.
	if ((($next_deadline>ct_time() || $user->is_admin()) && $user->get_id()!=1) || $submissions>0) {
		echo "<dt><a class=\"cmda\" href=\"".ct_pageurl('submissions')."\">".ct('S_INDEX_CMD_SUBMISSIONS')."</a>";
		if ((!ct_check_phases("submission") || !$next_deadline>ct_time()) && $user->is_admin() && $submissions==0)
			echo "<span class=\"fontnegative fontbold font10\"> - ".ct('S_NEWPAPER_SUBMISSIONDEACTIVATED')."</span></dt>\n";
		echo "</dt>\n";
		echo "<dd class=\"fontnormal font10\">".ct('S_INDEX_OPTION_SUBMISSIONS')."</dd>\n";
		#echo "<dd class=\"fontlabel font10\">".ct('S_PHASES_TIMELEFT').': '.ct_get_phase_timeout_formatted("submission")."</dd>\n";
		if ($next_deadline>ct_time() && ($next_deadline-ct_time())<3600*24*60) // Do not display more than two months here...
			echo "<dd class=\"fontlabel font10\">".ct('S_PHASES_NEXTDEADLINE').': '.ct_format_timeleft(ct_time(),$next_deadline)."</dd>\n";
		if ($submissions>0)
			echo "<dd class=\"fontlabel font10\">".ct('S_INDEX_OPTION_SUBMISSIONS_INFO',array($submissions))."</dd>\n";
	}
}

//#### Show participation info? -> The root admin does not participate.
if((ct_check_phases("participation") || $user->is_admin()) && $user->get_id()!= 1 && ctconf_get('participation/enabled')) {
	echo "<dt><a class=\"cmda\" href=\"".ct_pageurl('participate')."\">";
	//show participation form or info
	if ($user->is_participant()){
		echo ct('S_INDEX_CMD_PARTICIPATE_INFO');
	} else {
		echo ct('S_INDEX_CMD_PARTICIPATE');
	}
	echo "</a>\n";
	if (!ct_check_phases("participation") && $user->is_admin()) echo ' - <span class="fontnegative font10">'.ct('S_INDEX_CMD_ADMINONLY').'</span>';
	echo "</dt>\n";
	echo "<dd class=\"fontnormal font10\">";
	if ($user->is_participant()){
		echo ct('S_INDEX_OPTION_PARTICIPATE_INFO');
	} else {
		echo ct('S_INDEX_OPTION_PARTICIPATE');
	}
	echo "</dd>\n";
}

//show invoice link
if ($user->is_participant() && ctconf_get('payment/enabled') && ctconf_get('participation/invoices') && ctconf_get('participation/enabled')){
	if ($participation->get('payamount')<$participation->get('total') && ctconf_get('invoiceProforma','0')) {  // Pro-Forma Invoice
		echo "<dt><a class=\"cmda\" href=\"".ct_pageurl('invoice')."&amp;print=yes\" target=\"_blank\">".ct('S_INDEX_CMD_PROFORMA_INVOICE')."&nbsp;<img src=\"icons/newwindow.gif\" border=0></a></dt>\n";
		echo "<dd class=\"fontnormal font10\">".ct('S_INDEX_OPTION_PROFORMA_INVOICE')."</dd>\n";
 	} else {
		echo "<dt><a class=\"cmda\" href=\"".ct_pageurl('invoice')."&amp;print=yes\" target=\"_blank\">".ct('S_INDEX_CMD_INVOICE')."&nbsp;<img src=\"icons/newwindow.gif\" border=0></a></dt>\n";
		echo "<dd class=\"fontnormal font10\">".ct('S_INDEX_OPTION_INVOICE')."</dd>\n";
 	}
}

//show EDIT participation data link
if ($user->is_participant() && $participation->get('payamount')==0 && ctconf_get('participation/useredit') && ctconf_get('participation/enabled')){ // Allow editing if enabled and if not yet payed.
	echo "<dt><a class=\"cmda\" href=\"".ct_pageurl('editParticipant')."\">".ct('S_INDEX_CMD_EDITPARTICIPANT')."</a></dt>\n<dd class=\"fontnormal font10\">".ct('S_INDEX_OPTION_EDITPARTICIPANT')."</dd>\n";
}

//show DELETE participation data link
if ($user->is_participant() && $participation->get('payamount')==0 && ctconf_get('participation/userdelete') && ctconf_get('participation/enabled')){
	echo "<dt><a class=\"cmda\" href=\"".ct_pageurl('cancelParticipant')."\">".ct('S_INDEX_CMD_CANCELPARTICIPANT')."</a></dt>\n<dd class=\"fontnormal font10\">".ct('S_INDEX_OPTION_CANCELPARTICIPANT')."</dd>\n";
}

//show session overview...
if (ctconf_get('submission/enabled') && (ct_check_phases('browsesessions') || $user->is_admin() || $user->is_conferenceChair() || $user->is_chair())) {
	ct_load_lib('papers.lib');
	if (count(ct_get_sessions())>0) { // only show session overview if there is at least one session!
		echo "<dt><a class=\"cmda\" href=\"".ct_pageurl('browseSessions')."\">".ct('S_INDEX_CMD_BROWSESESSIONS')."</a>\n";
		if (!ct_check_phases('browsesessions')) echo ' - <span class="fontnegative font10">'.ct('S_INDEX_CMD_ADMINCHAIRONLY').'</span>';
		echo "</dt>\n";
		echo "<dd class=\"fontnormal font10\">".ct('S_INDEX_OPTION_BROWSESESSIONS')."</dd>\n";
	}
}

//logout link
echo "\n<dt><a class=\"cmda\" href=\"".ct_pageurl('logout')."\">".ct('S_INDEX_CMD_LOGOUT')."</a></dt>\n";
echo "<dd class=\"fontnormal font10\">".ct('S_INDEX_OPTION_LOGOUT')."</dd>\n";

//logout and return to conference site
echo "\n<dt><a class=\"cmda\" target=\"_top\" href=\"".ct_pageurl('logoutReturn')."\">".ct('S_INDEX_CMD_LOGOUT_RETURN')."</a></dt>\n";
echo "<dd class=\"fontnormal font10\">".ct('S_INDEX_OPTION_LOGOUT_RETURN',array(strip_tags(ctconf_get('conferenceName','UNKNOWN CONFERENCE'))))."</dd>\n";

echo "</dl>\n";
echo "</td></tr>\n";

// options available only if community / identity functions shall be used
if (ctconf_get('participation/identities') && ctconf_get('participation/enabled') &&
		(ct_check_phases('browseparticipants') || ct_check_phases("participation")) &&
		($user->is_participant() || $user->is_admin() || $user->is_frontdesk() || $user->is_assistant())) {
	echo "<tr><td colspan=2 class=\"mediumbg_gradient\">\n";
	echo "<span class=\"fontbold font10\">".ct('S_INDEX_COMMUNITY').":</span>\n";
	echo "</td></tr><tr><td width=\"5%\" class=\"mediumbg\">&nbsp;</td>";
	echo "<td width=\"95%\" valign=top align=left class=\"lightbg\">\n";
	echo "<dl>\n";

	// Give registered participant the option to edit his/her Identity data.
	if ($user->is_participant()) {
		echo "<dt><a class=\"cmda\" href=\"".ct_pageurl('editIdentity')."\">".ct('S_INDEX_CMD_IDENTITY')."</a></dt>\n";
		echo "<dd class=\"fontnormal font10\">".ct('S_INDEX_OPTION_IDENTITY')."</dd>\n";
	}

	// External link to meeting mirror (Experimental!)
	#if (($user->is_participant() && ct_check_phases('browseparticipants')) || ($user->get_id()!=1 && ($user->is_admin() || $user->is_frontdesk() || $user->is_assistant())){
	#	ct_load_class("CTIdentity");
	#	$identity=new CTIdentity();
	#	if ($identity->load_by_personID($user->get_id())) {
	#		echo "<dt><a class=\"cmda\" href=\"http://mm.in.tum.de/login?userID=".$identity->get_id()."&pass=".$identity->get("password")."\">".ct('S_INDEX_CMD_EXTERNAL')."</a></dt>\n";
	#		echo "<dd class=\"fontnormal font10\">".ct('S_INDEX_OPTION_EXTERNAL')."</dd>\n";
	#	}
	#}

	//show link to official list of participants
	if (ct_check_phases('browseparticipants') || $user->is_admin() || $user->is_frontdesk() || $user->is_assistant()) {
		echo "<dt><a class=\"cmda\" href=\"".ct_pageurl('browseOfficialParticipants')."\">".ct('S_INDEX_CMD_OFFICIALPARTICIPANTS')."</a>";
		if (!ct_check_phases('browseparticipants')) echo ' - <span class="fontnegative font10">'.ct('S_INDEX_CMD_ADMINONLY').'</span>';
		echo "</dt>\n";
		echo "<dd class=\"fontnormal font10\">".ct('S_INDEX_OPTION_OFFICIALPARTICIPANTS')."</dd>\n";
	}

	echo "</dl>\n";
	echo "</td></tr>\n";

}

// PC section: options only available if pc status is set
if (ctconf_get('submission/enabled') && ($user->is_pc() || $user->is_reviewer()) &&
	((ct_check_phases('selecttopics') && count($user->list_topics())>0) ||
 	  ct_check_phases("paperbids") || ct_check_phases("reviewing") ||
	 (ct_check_phases("reviewdiscussion") && $user->is_pc())) ) {
	echo "<tr><td colspan=2 class=\"mediumbg_gradient\">\n";
	echo "<span class=\"fontbold font10\">".ct('S_INDEX_OPTIONSASPC')."</span>\n";
	echo "</td></tr><tr><td width=\"5%\" class=\"mediumbg\">&nbsp;</td>";
	echo "<td width=\"95%\" valign=top align=left class=\"lightbg\">\n";
	echo "<dl>\n";
	// PC MEMBERS shall select their special subjects
	if (ct_check_phases('selecttopics') && count($user->list_topics())>0) {
		echo "<dt><a class=\"cmda\" href=\"".ct_pageurl('pc2topics')."\">".ct('S_INDEX_CMD_TOPICS')."</a></dt>\n";
		echo "<dd class=\"fontnormal font10\">".ct('S_INDEX_OPTION_TOPICS')."</dd>\n";
		$topics = $user->count_topics();
		if ($topics == 0)
			echo "<dd class=\"fontnegative fontbold font10\">".ct('S_INDEX_OPTION_TOPICS_INFO',array($topics))."</dd>\n";
		else
			echo "<dd class=\"fontlabel font10\">".ct('S_INDEX_OPTION_TOPICS_INFO',array($topics))."</dd>\n";
	}

	if (ct_check_phases("paperbids")) {
		echo "<dt><a class=\"cmda\" href=\"".ct_pageurl('browseBidPapers')."\">".ct('S_INDEX_CMD_BIDFORPAPERS')."</a></dt>\n";
		echo "<dd class=\"fontnormal font10\">".ct('S_INDEX_OPTION_BIDFORPAPERS')."</dd>\n";
		echo "<dd class=\"fontlabel font10\">".ct('S_PHASES_TIMELEFT').': '.ct_get_phase_timeout_formatted("paperbids")."</dd>\n";
	}

	if (ct_check_phases("reviewing")) {
		echo "<dt><a class=\"cmda\" href=\"".ct_pageurl('browseAssignedPapers')."\">".ct('S_INDEX_CMD_REVIEW')."</a></dt>\n";
		echo "<dd class=\"fontnormal font10\">".ct('S_INDEX_OPTION_REVIEW')."</dd>\n";
		echo "<dd class=\"fontlabel font10\">".ct('S_INDEX_OPTION_REVIEW_INFO', array($user->count_assigned_reviews(),$user->count_entered_reviews()))."</dd>\n";
		// echo "<dd class=\"fontlabel font10\">".ct('S_PHASES_TIMELEFT').': '.ct_get_phase_timeout_formatted("reviewing")."</dd>\n";
	}
	if ($user->count_assigned_reviews()>0 and ct_check_phase_active_or_over('reviewing')) {
		echo "<dt><a class=\"cmda\" href=\"".ct_pageurl('browseReviews')."\">".ct('S_BROWSEREVIEWS_TITLE')."</a></dt>\n";
		echo "<dd class=\"fontnormal font10\">".ct('S_BROWSEREVIEWS_INFO')."</dd>\n";
		// echo "<dd class=\"fontlabel font10\">".ct('S_INDEX_OPTION_REVIEW_INFO', array($user->count_assigned_reviews(),$user->count_entered_reviews()))."</dd>\n";
	}
	if (ct_check_phases("reviewdiscussion") && $user->is_pc()) {
		echo "<dt><a class=\"cmda\" href=\"".ct_pageurl('browseDiscussResults')."\">".ct('S_INDEX_CMD_DISCUSS')."</a></dt>\n";
		echo "<dd class=\"fontnormal font10\">".ct('S_INDEX_OPTION_DISCUSS')."</dd>\n";
		echo "<dd class=\"fontlabel font10\">".ct('S_PHASES_TIMELEFT').': '.ct_get_phase_timeout_formatted("reviewdiscussion")."</dd>\n";
	}

	echo "</dl>\n";
	echo "</td></tr>\n";
}

// Admin Section: options available only if admin status is set
if ($user->is_admin()) {
	// admin header
	echo "<tr><td colspan=2 class=\"mediumbg_gradient\">\n";
	echo "<span class=\"fontbold font10\">".ct('S_INDEX_OPTIONSASADMIN')."</span>\n";
	echo "</td></tr><tr><td width=\"5%\" class=\"mediumbg\">&nbsp;</td>";
	echo "<td width=\"95%\" valign=top align=left class=\"lightbg\">\n";
	echo "<dl>\n";

	// Settings
	echo "<dt><a class=\"cmda\" href=\"".ct_pageurl('adminTool')."\">".ct('S_INDEX_CMD_TOOL')."</a></dt>\n";
	echo "<dd class=\"fontnormal font10\">".ct('S_INDEX_OPTION_TOOL')."</dd>\n";
}

echo "\n\n";
// -- users ---------------------------------------------------------

// Show this if the person is conference assistant but not admin
if ($user->is_assistant() && !$user->is_admin()) {
	echo "<tr><td colspan=2 class=\"mediumbg_gradient\">\n";
	echo "<span class=\"fontbold font10\">".ct('S_INDEX_OPTIONSASASSISTANT')."</span>\n";
	echo "</td></tr><tr><td width=\"5%\" class=\"mediumbg\">&nbsp;</td>";
	echo "<td width=\"95%\" valign=top align=left class=\"lightbg\">\n";
	echo "<dl>\n";
}


// Admins and assistants have access to users, participants and payments
if ($user->is_assistant() || $user->is_admin()) {
    if (ctconf_get('participation/enabled')) {
		echo "<dt><a class=\"cmda\" href=\"".ct_pageurl('adminUsers')."\">".ct('S_INDEX_CMD_USERS')."</a></dt>\n";
		echo "<dd class=\"fontnormal font10\">".ct('S_INDEX_OPTION_USERS')."</dd>\n";
    } else {
		echo "<dt><a class=\"cmda\" href=\"".ct_pageurl('adminUsers')."\">".ct('S_INDEX_CMD_USERSONLY')."</a></dt>\n";
		echo "<dd class=\"fontnormal font10\">".ct('S_INDEX_OPTION_USERSONLY')."</dd>\n";
    }
	echo "<dd class=\"fontbold font9\">".ct('S_ADMIN_USERS_CMD_QUICK').": ";
	echo "<a class=\"fontnormal font9\" href=\"".ct_pageurl('adminUsersBrowse')."\">".ct('S_ADMIN_USERS_BROWSE_QUICK')."</a>, \n";
	echo "<a class=\"fontnormal font9\" href=\"".ct_pageurl('adminUsersLoginsBrowse')."\">".ct('S_ADMIN_USERS_LOGINS_BROWSE_QUICK')."</a>, \n";
	echo "<a class=\"fontnormal font9\" href=\"".ct_pageurl('adminUsersNew')."\">".ct('S_ADMIN_USERS_NEW_QUICK')."</a>\n";
    if (ctconf_get('participation/enabled')) {
		echo " | \n";
		echo "<a class=\"fontnormal font9\" href=\"".ct_pageurl('adminParticipantsBrowse')."\">".ct('S_ADMIN_PARTICIPANTS_BROWSE_QUICK')."</a>, \n";
		echo "<a class=\"fontnormal font9\" href=\"".ct_pageurl('adminPaymentsBrowse')."\">".ct('S_ADMIN_PAYMENTS_BROWSE_QUICK')."</a>, \n";
		#echo "<a class=\"fontnormal font9\" href=\"".ct_pageurl('adminParticipantsEventsBrowse')."\">".ct('S_ADMIN_PARTICIPANTS_EVENTS_BROWSE_QUICK')."</a>, \n";
		echo "<a class=\"fontnormal font9\" href=\"".ct_pageurl('adminParticipantsTable')."\">".ct('S_ADMIN_PARTICIPANTS_TABLE_QUICK')."</a>. \n";
    }
	echo "</dd>\n";
}

if (($user->is_conferenceChair() || $user->is_chair()) && $user->is_assistant() && !$user->is_admin()) {
	echo "</dl>\n";
	echo "</td></tr>\n\n";
}

echo "\n\n";
// -- review administration

// Show this if the person is chair but not admin
if ($user->is_conferenceChair() && !$user->is_admin()) {
	echo "<tr><td colspan=2 class=\"mediumbg_gradient\">\n";
	echo "<span class=\"fontbold font10\">".ct('S_INDEX_OPTIONSASCONFERENCECHAIR')."</span>\n";
	echo "</td></tr><tr><td width=\"5%\" class=\"mediumbg\">&nbsp;</td>";
	echo "<td width=\"95%\" valign=top align=left class=\"lightbg\">\n";
	echo "<dl>\n";
}

// if she is conferenceChair but not assistant or admin, show another menu...
if ($user->is_conferenceChair() && !($user->is_assistant() || $user->is_admin())) {
	echo "<dt><a class=\"cmda\" href=\"".ct_pageurl('adminUsers')."\">".ct('S_INDEX_CMD_USERS')."</a></dt>\n";
	echo "<dd class=\"fontnormal font10\">".ct('S_INDEX_OPTION_USERS')."</dd>\n";
	echo "<dd class=\"fontbold font10\">".ct('S_ADMIN_USERS_CMD_QUICK').": ";
	echo "<a class=\"fontnormal font9\" href=\"".ct_pageurl('adminUsersBrowse')."\">".ct('S_ADMIN_USERS_BROWSE_QUICK')."</a>, \n";
	echo "<a class=\"fontnormal font9\" href=\"".ct_pageurl('adminUsersNew')."\">".ct('S_ADMIN_USERS_NEW_QUICK')."</a>";
	if (ctconf_get('participation/enabled')) {
		echo " | \n";
		echo "<a class=\"fontnormal font9\" href=\"".ct_pageurl('adminParticipantsBrowse')."\">".ct('S_ADMIN_PARTICIPANTS_BROWSE_QUICK')."</a>, \n";
		#echo "<a class=\"fontnormal font9\" href=\"".ct_pageurl('adminParticipantsEventsBrowse')."\">".ct('S_ADMIN_PARTICIPANTS_EVENTS_BROWSE_QUICK')."</a>, \n";
		echo "<a class=\"fontnormal font9\" href=\"".ct_pageurl('adminParticipantsTable')."\">".ct('S_ADMIN_PARTICIPANTS_TABLE_QUICK')."</a>.</dd> \n";
	}
}

// Show this if the person is chair but not admin
if ($user->is_chair() && !$user->is_conferenceChair() && !$user->is_admin()) {
	echo "<tr><td colspan=2 class=\"mediumbg_gradient\">\n";
	echo "<span class=\"fontbold font10\">".ct('S_INDEX_OPTIONSASCHAIR')."</span>\n";
	echo "</td></tr><tr><td width=\"5%\" class=\"mediumbg\">&nbsp;</td>";
	echo "<td width=\"95%\" valign=top align=left class=\"lightbg\">\n";
	echo "<dl>\n";
}

// Options set if person is chair or admin
if (ctconf_get('submission/enabled') &&
    ($user->is_chair() || $user->is_conferenceChair() || $user->is_admin())) {
	echo "<dt><a class=\"cmda\" href=\"".ct_pageurl('adminPapers')."\">".ct('S_INDEX_CMD_PAPERS')."</a></dt>\n";
	echo "<dd class=\"fontnormal font10\">".ct('S_INDEX_OPTION_PAPERS')."</dd>\n";
	echo "<dd class=\"fontbold font9\">".ct('S_ADMIN_USERS_CMD_QUICK').": ";
	echo "<a class=\"fontnormal font9\" href=\"".ct_pageurl('adminPapersBrowse')."\">".ct('S_ADMIN_PAPERS_BROWSE_QUICK')."</a>, \n";
	echo "<a class=\"fontnormal font9\" href=\"".ct_pageurl('adminUsersPC')."\">".ct('S_ADMIN_USERS_PC_QUICK')."</a>, \n";
	echo "<a class=\"fontnormal font9\" href=\"".ct_pageurl('adminPapersResults')."\">".ct('S_ADMIN_PAPERS_RESULTS_QUICK')."</a>, \n";
	echo "<a class=\"fontnormal font9\" href=\"".ct_pageurl('adminPapersBrowse',array('version'=>'final','form_status'=>1,'filter'=>'show'))."\">".ct('S_ADMIN_PAPERS_BROWSE_FINAL_QUICK')."</a>, \n";
	echo "<a class=\"fontnormal font9\" href=\"".ct_pageurl('adminSessionsBrowse')."\">".ct('S_ADMIN_SESSIONS_BROWSE_QUICK')."</a>. \n";
	echo "</dd> \n";
}

// Show Mailer Menu
if ($user->is_admin() || $user->is_assistant() || $user->is_conferenceChair() ) {
	echo "<dt><a class=\"cmda\" href=\"".ct_pageurl('adminMailer')."\">".ct('S_ADMIN_MAILER')."</a></dt>\n";
	echo "<dd class=\"fontnormal font10\">".ct('S_ADMIN_MAILER_INTRO')."</dd>\n";
#	echo "<dd class=\"fontbold font9\">".ct('S_ADMIN_USERS_CMD_QUICK').": ";
#	echo "<a class=\"fontnormal font9\" href=\"".ct_pageurl('adminMailerPersons')."\">".ct('S_ADMIN_MAILER_PERSONS_QUICK')."</a>, \n";
#	echo "<a class=\"fontnormal font9\" href=\"".ct_pageurl('adminMailerAuthors')."\">".ct('S_ADMIN_MAILER_AUTHORS_QUICK')."</a>.\n";
}
// Show Data export menu
if ($user->is_admin() || $user->is_assistant() || $user->is_conferenceChair() ) {
	echo "<dt><a class=\"cmda\" href=\"".ct_pageurl('adminImportExport')."\">".ct('S_ADMIN_IMPORTEXPORT')."</a></dt>\n";
	echo "<dd class=\"fontnormal font10\">".ct('S_ADMIN_IMPORTEXPORT_INTRO')."</dd>\n";
}

if ($user->is_admin() || $user->is_assistant() || $user->is_frontdesk() || $user->is_chair() || $user->is_conferenceChair()) {
	echo "</dl>\n";
	echo "</td></tr>\n";
}

// Show this if the person is frontdesk member
if ($user->is_frontdesk() && ct_check_phases('frontdesk') ) {
	echo "<tr><td colspan=2 class=\"mediumbg_gradient\">\n";
	echo "<span class=\"fontbold font10\">".ct('S_INDEX_OPTIONSASFRONTDESK')."</span>\n";
	echo "</td></tr><tr><td width=\"5%\" class=\"mediumbg\">&nbsp;</td>";
	echo "<td width=\"95%\" valign=top align=left class=\"lightbg\">\n";
	echo "<dl>\n";
	echo "<dt><a class=\"cmda\" href=\"".ct_pageurl('frontdesk')."\">".ct('S_FRONTDESK_CMD')."</a></dt>\n";
	echo "<dd class=\"fontnormal font10\">".ct('S_FRONTDESK_HINT')."</dd>\n";
	echo "</dl>\n";
	echo "</td></tr>\n";
}

echo "</table>\n";

?>