<?php
//
// PAGE:		login
// Show login screen.
//

if ($session->loggedin()) {
	$session->put_infobox(ct('S_INFO_USERS_LOGOUT'), ct('S_INFO_USERS_LOGOUT_SUCCESS',array(ct_form_encode(trim($user->get_fullname())))));
	$session->logout();
}

$session->set_besturl();

// has user entered name and password and pressed submit? ------------------
if (isset($http['ctusername']) && isset($http['ctpassword']) && $http['ctpassword']<>"" && isset($http['cmd_login']) ) {
	// data was sent: try to login
	if ($session->login($http['ctusername'], $http['ctpassword'])) {
		// login successful
		// check if participation registration has already started
		$user=$session->get_user();
		if (!$user->is_participant() && !$user->is_assistant() && !$user->is_admin() && $user->get_id()!=1){
			if(ct_check_phases("participation")) {
				// yes, so show info message
				$session->put_infobox(ct('S_INFO_PARTICIPATE'), ct('S_INFO_PARTICIPATE_REMINDER'));
			}
		}
		// login successfull: redirect to index page
		if (in_http('requested_page') && $http['requested_page']!='login' && $http['requested_page']!='logout' 
				 && $http['requested_page']!='error' && $http['requested_page']!='register'	&&
				 ct_test_page($http['requested_page'])) 
			ct_redirect(ct_pageurl($http['requested_page'],ct_http_array(array('ctusername'=>'','ctpassword'=>'','requested_page'=>''))));
		else
			ct_redirect(ct_pageurl("index"));
	} else {	// failed
		ct_errorbox(ct('S_ERROR_LOGIN'), ct('S_ERROR_LOGIN_FAILED'));
		sleep(1); // wait one second for security reasons.
		#ct_redirect(ct_pageurl("login", array("ctusername"=>$http['ctusername'])));
	}
}
// user wants to create account? No password was entered... -----------------
elseif (isset($http['ctusername']) && isset($http['cmd_login']) ) {
	global $db;

	$query="select count(*) as count from persons where (username=\"".$http['ctusername']."\" or email=\"".$http['ctusername']."\") and deleted=0";
	$r = $db->query($query);
	if ($r && ($db->num_rows($r) > 0)) {
		$t = $db->fetch($r);
		if ($t[count]>0) {
			// username already known - display error message and return to login screen
			ct_errorbox(ct('S_ERROR_REGISTER'), ct('S_ERROR_REGISTER_USERNAMEEXISTS'));
		} else {
			ct_redirect(ct_pageurl("register", array("ctusername"=>$http['ctusername'])));
		}
	}
	// redirect him to register page
}
// No data was sent: show login screen... ------------------

ct_vspacer();
echo "<form name=\"loginform\" method=\"post\" action=\"".ct_pageurl("login")."\">\n";
// Add parameters as hidden values...
$http_vars = hash2aa(ct_http_array(array('ctusername'=>'','ctpassword'=>''))); // list all http variables with values
if (sizeof($http_vars) > 0) {
	while (list(,$h) = each($http_vars)) echo "<input type=\"hidden\" name=\"".ct_form_encode($h[0])."\" value=\"".ct_form_encode($h[1])."\">\n";
}
if ($_REQUEST['page']!="" && $_REQUEST['page']!='login' && $_REQUEST['page']!='logout' && 
		$_REQUEST['page']!='register' && $_REQUEST['page']!='error'  && $_REQUEST['page']!='imprint')
	echo "<input type=\"hidden\" name=\"requested_page\" value=\"".ct_form_encode($_REQUEST['page'])."\">\n";
	
echo "<table width=\"80%\" align=\"center\" class=\"tbldialog\" cellspacing=0 cellpadding=3 border=0>\n";
echo "<tr><td colspan=2>\n";
echo "<h2 align=center>".ct('S_LOGIN_TITLE')."</h2>\n";
echo "</td></tr>\n";
echo "<tr><td colspan=2>\n";
if (!ctconf_get('participation/enabled'))
	echo ct('S_LOGIN_WELCOME_SUBMIT');
elseif (!ctconf_get('submission/enabled'))
	echo ct('S_LOGIN_WELCOME_PARTICIPATE');
else
	echo ct('S_LOGIN_WELCOME');
echo "<br><br>\n";
echo "</td></tr>\n";

echo "<tr><td class=\"td_dlg_title\" height=42>&nbsp;</td>\n";
echo "<td class=\"td_dlg_title\"><H3>".ct('S_LOGIN_FORMTITLE')."</H3>\n";
echo "</td></tr>\n";

if(ct_check_phases("userregistration")) {	//registration allowed?
	echo "<tr><td class=\"mediumbg\" align=\"right\">\n";
	echo "<span class=\"fontbold font10\">".ct('S_LOGIN_NEWUSER')."</span>\n";
	echo "</td><td class=\"mediumbg_gradient\">&nbsp;</td></tr>";
	echo "<tr><td class=\"td_dlg_label\" width=\"33%\" align=right>&nbsp;</td>\n";
	echo "<td class=\"td_dlg_label\" width=\"67%\" align=left>";
	ct_vspacer('2');
	echo "<a class=\"fontbold font10\" href=\"".ct_pageurl('register')."\" tabindex=1>";
	if (!ctconf_get('participation/enabled'))
		echo ct('S_LOGIN_CREATEACCOUNT_SUBMIT');
	elseif (!ctconf_get('submission/enabled'))
		echo ct('S_LOGIN_CREATEACCOUNT_PARTICIPATE');
	else
		echo ct('S_LOGIN_CREATEACCOUNT');

	echo "</a><br>";
	#if (ct_check_phases("participation")) 	echo "<a href=\"".ct_pageurl('register',array('form_action'=>'participate'))."\">".ct('S_LOGIN_CREATEACCOUNT_PARTICIPATE')."</a><br>";
	#if (ct_check_phases("submission")) 	echo "<a href=\"".ct_pageurl('register',array('form_action'=>'submit'))."\">".ct('S_LOGIN_CREATEACCOUNT_CONTRIBUTE')."</a><br>";
	ct_vspacer('6');
	echo "</td></tr>";
} else {
	echo "<tr><td class=\"mediumbg\" align=\"right\">\n";
	echo "<span class=\"fontgray fontbold font10\">".ct('S_LOGIN_NEWUSER')."</span>\n";
	echo "</td><td class=\"mediumbg_gradient\">&nbsp;</td></tr>";
	echo "<tr><td class=\"td_dlg_label\" width=\"33%\" align=right>&nbsp;</td>\n";
	echo "<td class=\"td_dlg_label\" width=\"67%\" align=left>";
	ct_vspacer('2');
	echo "<span class=\"fontnegative font10\">".ct('S_LOGIN_CREATEACCOUNT_CLOSED')."</span><br>";
	ct_vspacer('6');
	echo "</td></tr>";
}

echo "<tr><td class=\"mediumbg\" align=\"right\">\n";
echo "<span class=\"fontbold font10\">".ct('S_LOGIN_OLDUSER')."</span>\n";
echo "</td><td class=\"mediumbg_gradient\">&nbsp;</td></tr>\n";

echo "<tr><td width=\"33%\" align=right><span class=\"fontlabel font10\">".ct('S_LOGIN_USERNAME').":</span></td>\n";
echo "<td width=\"67%\" align=left><input type=\"text\" name=\"ctusername\" ";
if (isset($http['ctusername']))
	echo "value=\"".ct_form_encode($http['ctusername'])."\" ";
echo "size=16 tabindex=2>";
echo "&nbsp;&nbsp;&nbsp;&middot;&nbsp;&nbsp;&nbsp;";
echo "<a class=\"fontbold font10\" href=\"".ct_pageurl('sendUsername')."\" tabindex=5>".ct('S_LOGIN_SENDUSERNAME')."</a>";
echo "</td></tr>\n";

echo "<tr><td width=\"33%\" align=right><span class=\"fontlabel font10\">".ct('S_LOGIN_PASSWORD').":</span></td>\n";
echo "<td class=\"td_dlg_label\" width=\"67%\">\n";
echo "<input type=password name=\"ctpassword\" size=16 tabindex=3>&nbsp;&nbsp;&nbsp;&middot;&nbsp;&nbsp;&nbsp;";
echo "<a class=\"fontbold font10\" href=\"".ct_pageurl('sendPassword')."\" tabindex=6>".ct('S_LOGIN_SENDPASSWORD')."</a>";
echo "</td></tr>\n";

echo "<tr><td class=\"td_dlg_label\">&nbsp;";
echo "<input type=hidden name=\"cmd_login\" value=\"yes\">\n";
echo "</td>\n";
echo "<td class=\"td_dlg_label\"><input class=\"button\" type=submit name=\"cmd_login\" value=\"".ct('S_BUTTON_LOGIN')."\" tabindex=4><br><br>\n";
echo "</td></tr>\n";

echo "</table>\n</form>\n";

?>