<?php
//
// PAGE:		newPaper
// DESC:		create a new paper record and upload a file
//


ct_pagepath(array('index','submissions'));

ct_load_class('CTPaper');
ct_load_lib('address.lib');
ct_load_lib('papers.lib');
ct_load_lib('datetime.lib');

// if user has no admin rights, check if phase "submission" is active
if (!$user->is_admin() and !ct_check_phases("submission")) {
	$session->put_errorbox(ct('S_ERROR_PHASE'), ct('S_ERROR_PHASE_INACTIVE'));
	ct_redirect(ct_pageurl('error'));
}

$paper_data = new CTPaperData;
$author = new CTPerson();

// Show Form Step 1 "normal", Contribution type has be selected on submission page
if (isset($http['form_contributiontypeID']) && in_http('newpaper')) {
	if ($user->is_admin() || $paper_data->is_contributiontype_active($http['form_contributiontypeID'])) {
		// Process data of step 1
		$paper_data =& $session->get('__paper');
		if (!is_object($paper_data) || $paper_data==NULL || $paper_data->get("title")=="") {
			$paper_data = new CTPaperData;
			// The default data is set when the empty form is called.
		}
		$paper_data->set('personID', $user->get('ID'));
		$paper_data->set('contributiontypeID', $http['form_contributiontypeID']);
		$session->putref('__paper', $paper_data);

		// Get correct paper class name
		$classname = $paper_data->get_paperClass();
		ct_load_class($classname);
		eval('$paperclass = new '.$classname.'();');
		$paperclass = ct_type_cast($paper_data,$classname);

		// Show header...
		echo "<h1>".ct('S_NEWPAPER_TITLE_STEP1')."</h1>\n";
		echo "<p class=\"font10\">".ct('S_NEWPAPER_INTRO_STEP1')."</p>\n";

		// show deadline...
		$type=ct_get_contributiontypes($paperclass->get('contributiontypeID'));
		$deadline=ct_get_submission_deadline($type);
		echo "<p class=\"font10 fontbold\">".ct('S_INDEX_PAPER_EDIT_UPDATE_UNTIL',array(ct_datetime_format_timezone($deadline)))."</p>\n";

		// Show form
		$paperclass->show_form_step1(ct_pageurl('newPaper'));
	} else {
		$session->put_errorbox(ct('S_ERROR_PHASE'), ct('S_ERROR_PHASE_INACTIVE'));
		ct_redirect(ct_pageurl('submissions'));
	}
}

// Show form step 1 for "admin" only. PersonID has to be set.
elseif (in_http('form_personID') && $user->is_admin()) {
	if (!$author->load_by_id($http['form_personID'])) {	// does person exist?
		$session->put_errorbox(ct('S_ERROR_NEWPAPER'), ct('S_ERROR_NEWPAPER_MISSINGINFO'));
		ct_redirect($session->get_besturl());
	}
	$paper_data =& $session->get('__paper');
	if (!is_object($paper_data) || $paper_data==NULL || $paper_data->get("title")=="") {
		$paper_data = new CTPaperData;
		$ctype=ct_list_contributiontypes();
		$ctype=array_pop($ctype);
		$paper_data->set('contributiontypeID', $ctype[0]);
	}
	$paper_data->set('personID', $http['form_personID']);
	$session->putref('__paper', $paper_data);

	// Get correct paper class name
	$classname = $paper_data->get_paperClass();
	ct_load_class($classname);
	eval('$paperclass = new '.$classname.'();');
	$paperclass = ct_type_cast($paper_data,$classname);

	echo "<h1>".ct('S_NEWPAPER_TITLE_STEP1')."</h1>\n";
	echo "<p class=\"font10 fontbold\">".ct('S_NEWPAPER_INTRO_STEP1')."</p>\n";

	$paperclass->show_form_step1(ct_pageurl('newPaper'), array(), true);


// Admin may change type of contribution.
} elseif (isset($http['cmd_paper_updateview']) && in_http('form_contributiontypeID')) {
	$paper_data =& $session->get('__paper');
	if (!is_object($paper_data) || $paper_data==NULL) {
		$session->put_errorbox(ct('S_ERROR_NEWPAPER'), ct('S_ERROR_NEWPAPER_MISSINGINFO'));
		ct_redirect($session->get_besturl());
	}
	// change contributiontype
	if (in_http('form_contributiontypeID') &&
			($user->is_admin() || $user->is_conferenceChair()) )  // && isset($http['cmd_paper_updateview']))
		$paper_data->set('contributiontypeID',$http['form_contributiontypeID']);

	// Get correct paper class name
	$classname = $paper_data->get_paperClass();
	ct_load_class($classname);
	eval('$paperclass = new '.$classname.'();');
	$paperclass = ct_type_cast($paper_data,$classname);

	$errors = $paperclass->process_form_step1();

	echo "<h1>".ct('S_NEWPAPER_TITLE_STEP1')."</h1>\n";
	echo "<p class=\"font10\">".ct('S_NEWPAPER_INTRO_STEP1')."</p>\n";
	$paperclass->show_form_step1(ct_pageurl('newPaper'), $errors, true);

// Back to step 1
} elseif (isset($http['cmd_newpaper_back_to_step1'])) {
	$paper_data =& $session->get('__paper');
	if (!is_object($paper_data) || $paper_data==NULL || $paper_data->get("title")=="") {
		$session->put_errorbox(ct('S_ERROR_NEWPAPER'), ct('S_ERROR_NEWPAPER_MISSINGINFO'));
		ct_redirect($session->get_besturl());
	} elseif ($user->is_admin() || $paper_data->is_contributiontype_active()) {
		// Get correct paper class name
		$classname = $paper_data->get_paperClass();
		ct_load_class($classname);
		eval('$paperclass = new '.$classname.'();');
		$paperclass = ct_type_cast($paper_data,$classname);

		// Show header...
		echo "<h1>".ct('S_NEWPAPER_TITLE_STEP1')."</h1>\n";
		echo "<p class=\"font10\">".ct('S_NEWPAPER_INTRO_STEP1')."</p>\n";

		// show deadline...
		$type=ct_get_contributiontypes($paperclass->get('contributiontypeID'));
		$deadline=ct_get_submission_deadline($type);
		echo "<p class=\"font10\">".ct('S_INDEX_PAPER_EDIT_UPDATE_UNTIL',array(ct_datetime_format_timezone($deadline)))."</p>\n";

		// Show form
		$paperclass->show_form_step1(ct_pageurl('newPaper'));
	} else {
		$session->put_errorbox(ct('S_ERROR_PHASE'), ct('S_ERROR_PHASE_INACTIVE'));
		ct_redirect($session->get_besturl());
	}
}

// Form Step 2: Save or Save and Upload
elseif (isset($http['cmd_paper_save'])) {
	// Process data of step 1
	$paper_data =& $session->get('__paper');
	if (!is_object($paper_data) || $paper_data==NULL || $paper_data->get("contributiontypeID")=="") {
		$session->put_errorbox(ct('S_ERROR_NEWPAPER'), ct('S_ERROR_NEWPAPER_MISSINGINFO'));
		ct_redirect($session->get_besturl());
	}
	if ($user->is_admin() || $paper_data->is_contributiontype_active()) {

		// change contributiontype
		if (in_http('form_contributiontypeID') &&
				($user->is_admin() || $user->is_conferenceChair()) )  // && isset($http['cmd_paper_updateview']))
			$paper_data->set('contributiontypeID',$http['form_contributiontypeID']);

		// Get correct paper class name
		$classname = $paper_data->get_paperClass();
		ct_load_class($classname);
		eval('$paperclass = new '.$classname.'();');
		$paperclass = ct_type_cast($paper_data,$classname);

		$errors = $paperclass->process_form_step1();

		if ($errors===false) {
			echo "<h1>".ct('S_NEWPAPER_TITLE_STEP2')."</h1>\n";
			$paperclass->show_form_step2(ct_pageurl('newPaper'));
		} else {
			ct_errorbox(ct('S_ERROR_NEWPAPER'), ct('S_ERROR_NEWPAPER_INCOMPLETE'));
			echo "<h1>".ct('S_NEWPAPER_TITLE_STEP1')."</h1>\n";
			echo "<p class=\"font10\">".ct('S_NEWPAPER_INTRO_STEP1')."</p>\n";
			$paperclass->show_form_step1(ct_pageurl('newPaper'), $errors);
		}

		// Save paper data in session
		$paper_data = ct_type_cast($paperclass,"CTPaperData");
		$session->putref('__paper', $paper_data);

	} else {
		$session->put_errorbox(ct('S_ERROR_PHASE'), ct('S_ERROR_PHASE_INACTIVE'));
		ct_redirect(ct_pageurl('error'));
	}
}

// Process data of step 2: Upload selected
elseif (isset($http['cmd_paper_upload'])) {

	$paper_data =& $session->get('__paper');

	if (!is_object($paper_data) || $paper_data==NULL || $paper_data->get("title")=="" || $paper_data->get("contributiontypeID")=="") {
		$session->put_errorbox(ct('S_ERROR_NEWPAPER'), ct('S_ERROR_NEWPAPER_MISSINGINFO'));
		ct_redirect($session->get_besturl());
	}
	// Get correct paper class name
	$classname = $paper_data->get_paperClass();
	ct_load_class($classname);
	eval('$paperclass = new '.$classname.'();');
	$paperclass = ct_type_cast($paper_data,$classname);

	if ($user->is_admin() || $paperclass->is_upload_active()) {
		// Check uploads
		$uploads = $paperclass->process_uploadform(""); // Returns: OK, ERROR, MISSING, EXISTS
		# ct_print_r($uploads);
		if (in_array('ERROR',$uploads) || in_array('MISSING',$uploads)) { // if there was an error, show it and stay on this page
			// Upload failed!
			// Show messages
			for ($i=1; $i<=count($uploads); $i++) {
				if (count($uploads)>1)
					$file_number_text = ct_get_file_number_text($i).': ';
				else
					$file_number_text = '';

				if ($uploads[$i]=="MISSING")
					ct_warningbox($file_number_text.ct('S_ERROR_PAPER_UPLOAD'), ct('S_ERROR_PAPER_UPLOAD_NO_FILE'));
			}
			echo "<h1>".ct('S_NEWPAPER_TITLE_STEP2')."</h1>\n";
			$paperclass->show_form_step2(ct_pageurl('newPaper'));
			// Save what has already been uploaded...
			$paper_data = ct_type_cast($paperclass,"CTPaperData");
			$session->putref('__paper', $paper_data);
		} else { // Either all uploads succeeded or are already on the server!
			$paperclass->persist();

			$author=$paperclass->get_author();
			$author->add_status('author');
			$author->persist();
			$paperclass->set_coauthors(true);

			$user->reload(); // reload user data, maybe it changed...

			// send email:
			ct_load_lib('mail_papers.lib');
			ct_mail_author_submission_confirmation($paperclass,true);

			$session->del('__paper');

			$session->put_infobox(ct('S_INFO_NEWPAPER'), ct('S_INFO_NEWPAPER_SUBMITTED'));
			ct_redirect($session->get_besturl());
		}
	}
}

// Process data of setp2: Skip Upload selected
elseif (isset($http['cmd_newpaper_skipupload'])) {
	// Skipped upload
	$paper_data =& $session->get('__paper');

	if (!is_object($paper_data) || $paper_data==NULL || $paper_data->get("title")=="" || $paper_data->get("contributiontypeID")=="") {
		$session->put_errorbox(ct('S_ERROR_NEWPAPER'), ct('S_ERROR_NEWPAPER_MISSINGINFO'));
		ct_redirect($session->get_besturl());
	}
	// Get correct paper class name
	$classname = $paper_data->get_paperClass();
	ct_load_class($classname);
	eval('$paperclass = new '.$classname.'();');
	$paperclass = ct_type_cast($paper_data,$classname);

	if (is_object($paperclass) && $paperclass->get("title")!="") {
		$paperclass->persist();

		$author=$paperclass->get_author();
		$author->add_status('author');
		$author->persist();
		$paperclass->set_coauthors(true);

		$user->reload(); // reload user data, maybe it changed...

		// send email:
		ct_load_lib('mail_papers.lib');
		ct_mail_author_submission_confirmation($paperclass,true);

		// show messages
		// 1. are there uploads missing?
		$uploads = $paperclass->_number_of_uploads_for_contributiontype();
		for ($i=1; $i<=$uploads; $i++) {
			if ($uploads > 1)
				$file_number_text = ct_get_file_number_text($i).': ';
			else
				$file_number_text = '';

			if ($paperclass->get($paperclass->get_ffname('originalname','',$i))=='')
				$session->put_warningbox($file_number_text.ct('S_INFO_PAPER_MISSING'), ct('S_INFO_PAPER_MISSING_NOTFORGET'));
		}

		// Submission done! :-)
		$session->put_infobox(ct('S_INFO_NEWPAPER'), ct('S_INFO_NEWPAPER_SUBMITTED'));

		$session->del('__paper');

		ct_redirect($session->get_besturl());
	} else {
		$session->put_errorbox(ct('S_ERROR_NEWPAPER'), ct('S_ERROR_NEWPAPER_MISSINGINFO'));
		ct_redirect(ct_pageurl('newPaper'));
	}
}
// nothing set: Error! ...something strange is going on.
else {
	// If the command is POST: Most likely the user tried to upload a big
	// file and the server settings are wrong, so the post message was truncated...
	if ($_SERVER["REQUEST_METHOD"]=="POST")
		$session->put_errorbox(ct('S_ERROR_PAPER_UPLOAD'), ct('S_ERROR_PAPER_UPLOAD_FAILED'));
	ct_redirect($session->get_besturl());
}

?>