<?php
//
// PAGE:		paperDetails
// Show details to a paper. Used for bidding for papers...
//


ct_pagepath(array('index'));

ct_load_class('CTPaper');

// check if phase "paperbids" is active
if (!ct_check_phases("paperbids")) {
	$session->put_errorbox(ct('S_ERROR_PHASE'), ct('S_ERROR_PHASE_INACTIVE'));
	ct_redirect(ct_pageurl('error'));
}

// this page does only make sense if an ID for a paper was provided. If not,
// we redirect to the index page
if (!in_http('form_id')) {
	ct_redirect($session->get_besturl());
}

$paper = new CTPaper;
if ($paper->load_by_id($http['form_id'])) { // does paper exist?

	// Get correct paper class name
	$classname = $paper->get_paperClass();
	ct_load_class($classname);
	eval('$paperclass = new '.$classname.'();');
	$paperclass = ct_type_cast($paper,$classname);
	
	$author =& $paperclass->get_author();
	$ctype = $paperclass->_get_contributiontype();

	// check if user is allowed to edit paper information. access is denied
	// if user has no admin rights and is not the author of the paper
	if ( ($user->is_admin()) || $user->is_chair() || $user->is_conferenceChair() || 	// can do anything...
			(ct_check_phases("paperbids") && 						// bidding phase?
					($user->is_pc() || $user->is_reviewer()) && 	// pc member?
					$ctype['do_bidding']=='true' && 				// is considered in biddings?
					$user->has_pc_access($ctype['ID'])) ) { 		// has access to this track?
		$paperclass->show_detailed('95%','center');
		$paperclass->show_abstract('95%','center');
		// Show bibliography only if non-anonymous reviews...
		if (($user->is_admin() || $user->is_conferenceChair() || $user->is_chair() || $ctype['review_anonymous']=='false' || $paperclass->get('personID') == $user->get_id())) {
			$paperclass->show_bibliography('95%','center');
		}
	} else {
		$session->put_errorbox(ct('S_ERROR_PAPER_DETAILED'), ct('S_ERROR_PAPER_DETAILED_NOACCESS'));
		ct_redirect(ct_pageurl('error'));
	}
}

?>