<?php
//
// PAGE:		paperPCDetails
// Show details to a paper including a survey of all reviews. Used for the Online-PC-Meeting
//


ct_pagepath(array('index'));

ct_load_class('CTPaper');

// check if phase "reviewdiscussion" is active
if (!ct_check_phases("reviewdiscussion")) {
	$session->put_errorbox(ct('S_ERROR_PHASE'), ct('S_ERROR_PHASE_INACTIVE'));
	ct_redirect(ct_pageurl('error'));
}

// this page does only make sense if an ID for a paper was provided. If not,
// we redirect to the index page
if (!in_http('form_id')) {
	ct_redirect($session->get_besturl());
}

$paper = new CTPaper;
if ($paper->load_by_id($http['form_id'])) { // does paper exist?

	// Get correct paper class name
	$classname = $paper->get_paperClass();
	ct_load_class($classname);
	eval('$paperclass = new '.$classname.'();');
	$paperclass = ct_type_cast($paper,$classname);

	$author =& $paperclass->get_author();
	$ctype = $paperclass->_get_contributiontype();

	// check if user is allowed to edit paper information. access is denied
	// if user has no admin rights and is not the author of the paper
	if ( ($user->is_admin()) || $user->is_chair() || $user->is_conferenceChair() || 	// can do anything...
			(ct_check_phases("reviewdiscussion") && 						// bidding phase?
					($user->is_pc() || $user->is_reviewer()) && 	// pc member?
					!$user->has_review_conflict($paperclass) &&		// no conflict for this reviewer...
					$ctype['do_discussion']=='true' && 				// is considered in biddings?
					$user->has_pc_access($ctype['ID'])) ) { 		// has access to this track?

		$paperclass->show_detailed(650,'center');
		$paperclass->show_abstract(650,'center');
		if ($ctype['review_anonymous']=='false') {
			$paperclass->show_bibliography(650,'center');
		}

		//if ($paperclass->get('externalremark')!="") $paperclass->show_remark(650,'center');
		if (ctconf_get('forumDownloads','0')) {
			$paperclass->show_downloads('',650,'center');
			if ($ctype['upload_final']>0 && ct_check_phase_active_or_over("finalupload"))
				$paperclass->show_downloads('final',650,'center');
		}
				
		$paperclass->show_accept_status(650,'center');
		$paperclass->show_review_results(true,650,'center');
	} else {
		$session->put_errorbox(ct('S_ERROR_PAPER_DETAILED'), ct('S_ERROR_PAPER_DETAILED_NOACCESS'));
		ct_redirect(ct_pageurl('error'));
	}
}

?>