<?php
//
// PAGE:     PCR = passwordChangeRequested (also "pcr.php")
// User clicked a link to change his password.
//

// logout user...
if ($session->loggedin()) {
	$user=$session->get_user();
	$user->logout();
}

// key was set?
if (!in_http('key') || strlen($http['key'])<30) { 
	$session->put_errorbox(ct('S_ERROR_NEWPW'),ct('S_ERROR_NEWPW_KEY',array(ct_encodeMail(ctconf_get('conferenceContactEmail')))));
	ct_redirect(ct_pageurl('logout'));
}
	
// key found in DB?	
$person = new CTPerson();
if (!$person->load_by_requestkey($http['key'])) {
	$session->put_errorbox(ct('S_ERROR_NEWPW'),ct('S_ERROR_NEWPW_KEY',array(ct_encodeMail(ctconf_get('conferenceContactEmail')))));
	ct_redirect(ct_pageurl('logout'));
}

// one hour timeout
if ((ct_time()-ct_datetime_2_timestamp($person->get('passwordrequestdatetime')))>=3600) {
	$session->put_errorbox(ct('S_ERROR_NEWPW'),ct('S_ERROR_NEWPW_EXPIRED',array(ct_encodeMail(ctconf_get('conferenceContactEmail')))));
	ct_redirect(ct_pageurl('logout'));
}

// now load libraries...
ct_load_lib('mail.lib');
ct_load_lib('person.lib');
ct_load_lib('password.lib');
ct_load_class('CTForm');
$form_errors=array();

// Check if user tries to set a new username
if (in_http('cmd_change_password') || (in_http('form_username') && in_http('form_pwd') && in_http('form_pwd2') ) ) {

	ct_http_trim(array('username','pwd','pwd2'));
	
	if (!in_http('form_username') || $http['form_username']!=$person->get('username')) {
		$session->put_errorbox(ct('S_ERROR_NEWPW'),ct('S_ERROR_NEWPW_USERNAME'));
		ct_redirect(ct_pageurl('logout'));
	}
	
	// New password was set and it is unencrypted...
	$pwdcheck = ct_validate_password($http['form_pwd'],$person);
	if (count($pwdcheck)!=0) {
		$form_errors[] = 'form_pwd';
		$form_errors[] = 'form_pwd2';
	}
	// Check if fields match?
	if ($http['form_pwd']!=$http['form_pwd2']) { // fields do not match!
		$form_errors[] = 'form_pwd2';
		ct_errorbox(ct('S_ERROR_SAVEUSER'),ct('S_ERROR_REGISTER_PASSWORD_NOMATCH'));
	}				
	
	// try to save new password
	if ( count($form_errors)==0 ) {	// no errors
		$person->set('password', $http['form_pwd']);
		$person->set('passwordencrypted',0); 
		$person->set('passwordrequestkey',''); 
		// save changed password...
 		$person->persist();
 		// Message that password has been changed.
		$session->put_infobox(ct('S_INFO_SAVEUSER'),ct('S_INFO_SAVEUSER_NEWPASSWORD'));
 		// now try to login with the new password!
		if ($session->login($person->get('username'), $http['form_pwd'])) {
			// check if participation registration has already started
			$user=$session->get_user();
			if (!$user->is_participant() && !$user->is_assistant() && !$user->is_admin() && $user->get_id()!=1){
				if(ct_check_phases("participation")) {
					// yes, so show info message
					$session->put_infobox(ct('S_INFO_PARTICIPATE'), ct('S_INFO_PARTICIPATE_REMINDER'));
				}
			}
			// login successfull: redirect to index page
			ct_redirect(ct_pageurl("index"));
		} else {	// failed
			$session->put_errorbox(ct('S_ERROR_LOGIN'), ct('S_ERROR_LOGIN_FAILED'));
			ct_redirect(ct_pageurl("login", array("ctusername"=>$http['ctusername'])));
		}
	} else {
		$msg = ct_validate_password($http['form_pwd'],$person);
		ct_errorbox(ct('S_ERROR_SAVEUSER'), '<ul><li>'.implode('<li>',$msg).'</ul>');
	}
}

echo "<br><br><br>";	
$form = new CTForm(ct_pageurl('passwordChangeRequested'),"post",$form_errors);
$form->width = '550';
$form->align = 'center';
	
$form->add_hidden(array(array('key',$http['key'])));
$form->add_separator(ct('S_LOGIN_SENDPASSWORD'));
$form->add_label("",ct('S_NEWPW_DESCRIPTION'));
$form->add_text(ct('S_NEWPW_USERNAME'), 'form_username', $http['form_username'], 20, 255);
#$form->add_label("",ct('S_SENDPW_DESCRIPTION'));
$form->add_spacer();
$form->add_pass("* ".ct('S_NEWPW_PASSWORD'),	'form_pwd',	 $http['form_pwd'],	10,	64, false, ct('S_USER_PASSWORD_HINT'));
$form->add_pass("* ".ct('S_NEWPW_PASSWORD2'),   'form_pwd2', $http['form_pwd2'], 10, 64, false, ct('S_USER_PASSWORD_HINT2'));
$form->add_spacer();
$form->add_submit('cmd_change_password', ct('S_NEWPW_SUBMIT'));
	
$form->show();
echo "<br><br>";

?>
