<?php
//
// PAGE:		register
// Register new Conftool users
//


// check if phase "userregistration" is active
if (!ct_check_phases("userregistration")) {
	$session->put_errorbox(ct('S_ERROR_PHASE'), ct('S_ERROR_PHASE_INACTIVE'));
	ct_redirect(ct_pageurl('error'));
}

if ($session->loggedin()) {
	$session->put_infobox(ct('S_INFO_USERS_LOGOUT'), ct('S_INFO_USERS_LOGOUT_SUCCESS',array(ct_form_encode(trim($user->get_fullname())))));
	$session->logout();
}

ct_load_lib('mail.lib');
ct_load_lib('mail_person.lib');
ct_load_lib('person.lib');

ct_load_class('CTPerson_Form');
$person = new CTPerson_Form();
$form_errors = array();

// Save was pressed
if (isset($http['cmd_save_person']) || isset($http['cmd_save_person_register']) || isset($http['cmd_save_person_submit']) ) {

	// Generate username and password? (Only if at least name of user was entered!
	if (in_http('form_reg_options','generate') && $http['form_name']!="") {
		generate_userandpass(); 
	}
	
	$form_errors = $person->process_form();
	$query = "select * from persons where ((username='".$http['form_username']."' and '".$http['form_username']."'!='') OR ".
						"(email='".$http['form_email']."' AND '".$http['form_email']."'!='') OR ".
						"(email2='".$http['form_email']."' and '".$http['form_email']."'!='') OR ".
						"(email='".$http['form_email2']."' and '".$http['form_email2']."'!='') OR ".
						"(email2='".$http['form_email2']."' and '".$http['form_email2']."'!='')) and ".
						"deleted=0";
	$r = $db->query($query);
	if ($r && $db->num_rows($r) == 0) {
		if (!$form_errors) {
			// send registration e-mail to user
			ct_mail_user_registration_confirmation($person,in_http('form_reg_options','generate')||in_http('form_reg_options','send_password'));

			// persist data: now the password will be encrypted.			
			$person->persist();
			
			$session->put_infobox(ct('S_INFO_REGISTER'), ct('S_INFO_REGISTER_SUCCESS'));
			$session->login($http['form_username'], $http['form_pwd']);
			
			// if the registration for participation is open and submissions and finaluploads and reviews are finished, jump
			// directly to the participation registration page...
			if (isset($http['cmd_save_person_register'])) {
				ct_redirect(ct_pageurl('participate'));
			} elseif (isset($http['cmd_save_person_submit'])) {
				ct_redirect(ct_pageurl('submissions'));
			} else {
				ct_redirect(ct_pageurl('index'));
			}
		} 
	} 
	if ($form_errors) {
		ct_errorbox(ct('S_ERROR_REGISTER'), ct('S_ERROR_REGISTER_INCOMPLETE'));
		// => show form again (see below...)
		if (is_array($form_errors) && (in_array('form_email',$form_errors) || in_array('form_email2',$form_errors))) 
			ct_errorbox(ct('S_ERROR_REGISTER'), ct('S_ERROR_REGISTER_EMAIL_INVALID'));
		if (is_array($form_errors) && in_array('form_pwd',$form_errors)) {
			$msg = ct_validate_password($http['form_pwd'],$person);
			ct_errorbox(ct('S_ERROR_REGISTER'), '<ul><li>'.implode('<li>',$msg).'</ul>');
		} elseif (is_array($form_errors) && in_array('form_pwd2',$form_errors)) {
			ct_errorbox(ct('S_ERROR_REGISTER'), ct('S_ERROR_REGISTER_PASSWORD_NOMATCH'));
		}
	}
	if ($r && $db->num_rows($r) > 0) {
		for ($i=0; $i<$db->num_rows($r); $i++) {
			$row = $db->fetch($r); // get users where the username or email was doubled...
			if ($row['username'] == $http['form_username']) {
				$form_errors[] = "form_username";
				ct_errorbox(ct('S_ERROR_REGISTER'), ct('S_ERROR_REGISTER_USERNAMEEXISTS')." (".$http['form_username'].")");
			} 
			if ($http['form_email']!='' && ($row['email'] == $http['form_email'] || $row['email2'] == $http['form_email'])) {
				$form_errors[] = "form_email";
				ct_errorbox(ct('S_ERROR_REGISTER'), ct('S_ERROR_REGISTER_EMAILEXISTS')." (".$http['form_email'].")");
			}
			if ($http['form_email2']!='' && ($row['email'] == $http['form_email2'] || $row['email2'] == $http['form_email2'])) {
				$form_errors[] = "form_email2";
				ct_errorbox(ct('S_ERROR_REGISTER'), ct('S_ERROR_REGISTER_EMAILEXISTS')." (".$http['form_email2'].")");
			}
		}
	} 
} 

echo "<h1>".ct('S_REGISTER_TITLE')."</h1>\n";
echo "<p class=\"fontnormal font10\">".ct('S_REGISTER_INTRO')."</p>\n";

if (isset($http['ctusername'])) {
	if (preg_match("/^.*@.*\.[a-z]+/i",$http['ctusername'])) {
		$person->set("email",$http['ctusername']);
		$person->set("username",$http['ctusername']);
	} else {
		$person->set("username",$http['ctusername']);
	}
}

$person->show_form(ct_pageurl('register'), $form_errors);

?>
