<?php
//
// PAGE:		reviewDetails
// DESC:		Show details to a review
//

ct_pagepath(array("index", "reviewResults"));
ct_load_class('CTPaper');

// check if required phases are active
if (!
		(ct_check_phases("reviewresults") // Results are visible, go ahead
		||	$user->is_admin() || $user->is_chair() || $user->is_conferenceChair() // These always have access to the results
		|| (($user->is_pc() || $user->is_reviewer()) && ct_check_phases("reviewing"))  // In the review phase, PCs and Reviewers have access.
		|| ($user->is_pc() && ct_check_phases("reviewdiscussion"))) ) {	// And PCs have in the discussion phase access to the reviews.
	// You did not pass, bye bye.
	$session->put_errorbox(ct('S_ERROR_PHASE'), ct('S_ERROR_PHASE_INACTIVE'));
	ct_redirect(ct_pageurl('error'));
}

// Are all parameters present?
if (in_http('form_personID') && in_http('form_paperID')) {
	
	$paper = new CTPaper();
	if ($paper->load_by_id($http['form_paperID'])) {

		// get correct class name for paper
		$classname = $paper->get_paperClass();
		ct_load_class($classname);
		eval('$paperclass = new '.$classname.'();');
		$paperclass = ct_type_cast($paper,$classname);

		// get correct class for review
		$classname = $paperclass->get_reviewClass();
		ct_load_class($classname);
		eval('$review = new '.$classname.'();');

		// who is the author?
		$author =& $paperclass->get_author();

		// check if user is allowed to view this review. access is denied
		// if user has no admin rights and is not the author of the paper or the reviewer
		// or a meta-reviewer...
		if (($user->is_admin() ||              					// Admin is OK
	   		 $user->is_chair() ||							 	// Chair is OK as well
	   		 $user->is_conferenceChair() ||							  // ConferenceChair is OK as well
	   		 ($user->is_pc() && ct_check_phases("reviewdiscussion")) ||  // PC members are OK as well (this is not completely save yet, but they will see the review anyway...)
	  		 $user->get_id() == $http['form_personID'] ||      // Reviewer may see the review he entered
	  		 $user->is_metareviewer_for($paperclass->get_id()) || // Maybe he is the meta-reviewer?
	  		 ($user->get_id() == $paperclass->get('personID') && 
					ct_check_phases("reviewresults") &&	
					$paperclass->get('acceptstatus')!=0 &&
					$paperclass->get_reviewresults_deadline()<ct_time() &&
					$ctype['review_details_to_author']=='true' )) &&  // Authors may see their reviews... sometimes...
		     $review->load($http['form_paperID'], $http['form_personID'])) { // does review exist?

		     	$paperclass->show_detailed(600,'center');
		    	$review->show_detailed(650,'center');

		    	if ($user->is_admin()) $review->show_edit_options(650,'center');
		    		
	    } else { // Access denied...
				$session->put_errorbox(ct('S_ERROR_PAPER_DETAILED'), ct('S_ERROR_PAPER_DETAILED_NOACCESS'));
				ct_redirect(ct_pageurl('error'));
		}
	} else {
		ct_redirect(ct_pageurl('error'));
	}
} else {
	ct_redirect($session->get_besturl());
}
?>
