<?php
//
// PAGE		reviewPaper
// DESC		Enter or change the review to a paper that was assigned to you...
// REQUIRES	PC-status, assignment to paper
//

ct_pagepath(array('index'));
ct_load_class('CTReview');
ct_load_lib('datetime.lib');

// if user has no admin rights, check if phase "reviewing" is active
if (!$user->is_admin() and !ct_check_phases("reviewing")) {
	$session->put_errorbox(ct('S_ERROR_PHASE'), ct('S_ERROR_PHASE_INACTIVE'));
	ct_redirect(ct_pageurl('error'));
}

if (in_http('error', 'yes')) {
	$review =& $session->get('__review');
	if (!is_object($review)) {
		ct_redirect(ct_pageurl('browseAssignedPapers'));
	}
} else {
	$review = new CTReview();
	if (!in_http('form_personID') || !$user->is_admin() ) {  // only admin may see other reviews.
		$http['form_personID'] = $user->get('ID');
	}
	if (!$review->load($http['form_paperID'], $http['form_personID'] )) {
		$session->put_errorbox(ct('S_ERROR_REVIEW'), ct('S_ERROR_REVIEW_NOTALLOWED'));
		ct_redirect(ct_pageurl('browseAssignedPapers'));
	}
}

echo "<H3>".ct('S_REVIEW_PAPER')."</H3>\n";
echo "<p class=\"fontnormal font10\">".ct('S_REVIEW_PAPER_INTRO')."\n";
if (!in_http('print','yes')) {
	echo " &nbsp;&nbsp;<a target=\"_blank\" href=\"".ct_pageurl('reviewPaper',ct_http_array(array('print' => "yes")))."\">".ct('S_CTFOOT_PRINTVIEW')."&nbsp;<img src=\"icons/printer.gif\" alt=\"".ct('S_CTFOOT_PRINTVIEW')."\" border=0 style=\"vertical-align: bottom\"></a>";
}
echo "</p>\n";

#$type=ct_get_contributiontypes($paperclass->get('contributiontypeID'));
#$deadline=ct_get_submission_deadline($type);
#echo "<p class=\"fontnormal font10\">".ct('S_REVIEW_PAPER_UPDATE_UNTIL',array(ct_datetime_format_timezone($deadline)))."</p><br>\n";

ct_vspacer('6');
$classname = $review->get_reviewClass();
ct_load_class($classname);
eval('$review_form = new '.$classname.'();');
$review_form = ct_type_cast($review,$classname);
$review_form->show_reviewform("95%", $review->errors);

?>
