<?php
//
// PAGE:		reviewResultsMetareviewer
// Shows paper information and a survey of all reviews to the meta reviewer
// For admins etc. see the function adminPaperResults
//


ct_pagepath(array('index'));

ct_load_class('CTPaper');

// this page only makes sense if an ID for a paper was provided. If not,
// we redirect to the index page
if (!in_http('form_id')) {
	ct_redirect($session->get_besturl());
}

// now load the paper
$paper = new CTPaper;
if (!$paper->load_by_id($http['form_id'])) {  // does it exist?
	// unknown paper
	$session->put_errorbox(ct('S_ERROR_PAPER_DETAILED'), ct('S_ERROR_PAPER_DETAILED_NOACCESS'));
	ct_redirect(ct_pageurl('error'));
}

// check if phase "reviewing" is active, otherwise meta-reviewers cannot enter their review any more.
if ( !ct_check_phases("reviewing") ) {  // Review phase still active...
	$session->put_errorbox(ct('S_ERROR_PHASE'), ct('S_ERROR_PHASE_INACTIVE'));
	ct_redirect(ct_pageurl('error'));
}

// Now convert paper to correct class...
$classname = $paper->get_paperClass();
ct_load_class($classname);
eval('$paperclass = new '.$classname.'();');
$paperclass = ct_type_cast($paper,$classname);

#$author =& $paperclass->get_author();

// check if user is allowed to access the results of the review...
if ( $user->is_metareviewer_for($paperclass->get_id()) ) { 
	$paperclass->show_detailed(600,'center');
	// $paperclass->show_abstract(600,'center');
	echo "<br>\n";
	$paperclass->show_accept_status('100%','center');
	echo "<br>\n";

	// Test if details of review shall be shown to author...
	$paperclass->show_review_results(true, '100%', 'center');
	// List Details
	$reviews = $paperclass->get_reviews(true);	// get only reviews that are complete...
	$rcount = count($reviews);
	for ($i=0; $i < $rcount; $i++) {
		echo "<br>\n";
		echo "<br>\n";
		$reviews[$i]->show_detailed_header($i+1, "100%",'center');
		$reviews[$i]->show_detailed("100%",'center');
	}
} else { // access denied!
	$session->put_errorbox(ct('S_ERROR_PAPER_DETAILED'), ct('S_ERROR_PAPER_DETAILED_NOACCESS'));
	ct_redirect(ct_pageurl('error'));
}

?>