<?php
//
// PAGE		saveReview
// REQUIRES	PC-status, assignment to paper
//

// if user has no admin rights, check if phase "reviewing" is active
if (!$user->is_admin() and !ct_check_phases("reviewing")) {
	$session->put_errorbox(ct('S_ERROR_PHASE'), ct('S_ERROR_PHASE_INACTIVE'));
	ct_redirect(ct_pageurl('error'));
}

ct_load_class('CTReview');

$review = new CTReview();
// check if this review is assigned
if ($review->load($http['form_paperID'], $http['form_personID'])) {
	// check if user is allowed to save this review
	### Test and show timeout for this review type.
	if (!$user->is_admin() && ($user->get('ID') != $http['form_personID'])) {
		$session->put_errorbox(ct('S_ERROR_REVIEW'), ct('S_ERROR_REVIEW_NOTALLOWED'));
		ct_redirect(ct_pageurl('index'));
	}

	$classname = $review->get_reviewClass();
	ct_load_class($classname);
	eval('$review_form = new '.$classname.'();');
	$review_form = ct_type_cast($review,$classname);
	
	$errors = $review_form->process_form();
	if ($errors && in_http('cmd_savereview')) {
		// Now we have to cast the type of the review to store it in the session variable...
		$review = ct_type_cast($review_form,"CTReview");
		$session->put('__review', $review);
		$session->put_errorbox(ct('S_ERROR_REVIEW'), ct('S_ERROR_REVIEW_INCOMPLETE'));
		ct_redirect(ct_pageurl('reviewPaper', array('error'=>'yes')));
	}
	// No errors
	if (in_http('cmd_savereview')) { // Save button was clicked
		if ($review_form->get('creationdate') == 0) {
			$review_form->set('creationdate',ct_timestamp_2_datetime(ct_time()));
		}
		$review_form->persist();
		$session->del('__review');
		$session->put_infobox(ct('S_INFO_REVIEW'), ct('S_INFO_REVIEW_SAVED'));
	/*} elseif (in_http('cmd_savedraft')) { // Save draft button was clicked
		$review_form->persist();
		$session->del('__review');
		$session->put_infobox(ct('S_INFO_REVIEW'), ct('S_INFO_REVIEW_DRAFT_SAVED')); */
	} else { // Something odd happend => Redirect to edit screen...
		$review = ct_type_cast($review_form,"CTReview");
		$session->put('__review', $review);
		ct_redirect(ct_pageurl('reviewPaper', array('error'=>'yes')));
	}
} else {
	$session->put_errorbox(ct('S_ERROR_REVIEW'), ct('S_ERROR_REVIEW_NOTASSIGNED'));
}
ct_redirect(ct_pageurl('browseAssignedPapers'));

?>