<?php
//
// PAGE:		sendPassword
// DESC:		Send forgotten password to user... If there are any problems, check your mail server configuration!
//

ct_load_class('CTForm');
ct_load_lib("person.lib");
ct_load_lib("datetime.lib");
ct_load_lib("mail.lib");
ct_load_lib("mail_person.lib");
ct_load_lib("password.lib");

if (isset($http['cmd_send_password']) || isset($http['form_username'])) {
	sleep(.5);	// Wait a bit for security reasons. Prevent flooding...
	if ($http['form_username']=="") {
		$session->put_errorbox(ct('S_ERROR_PASSWORD'), ct('S_ERROR_PASSWORD_EMPTY'));
		ct_redirect(ct_pageurl('sendPassword'));
	} else {
		$username = ct_mysql_escape_string(stripslashes(trim($http['form_username'])));
		$query="select * from persons where username='$username' and deleted=0";
		$r = $db->query($query);
		if ($r && ($db->num_rows($r) ==0)) {
			$session->put_errorbox(ct('S_ERROR_PASSWORD'), ct('S_ERROR_PASSWORD_FAILED',array($http['form_username'],ct_encodeMail(ctconf_get('conferenceContactEmail')))));
		} elseif ($r && ($db->num_rows($r) == 1)) {
			// user exists!
			$t = $db->fetch_raw($r);
			$person = new CTPerson();

			// send email
			if ($person->load_by_id($t['ID'])) {
				$person->set('passwordrequestkey',ct_randstring(32,true));	// new key to create new password
				$person->set('passwordrequestdatetime',ct_timestamp_2_datetime(ct_time()));	// time when password change was requested. Only one hour available.
				$person->set('passwordrequesthost',ct_get_client_ip());	// IP address of request host... not really necessary, but looks nice.
				$person->persist();
				ct_mail_user_newpasswordlink($person);
				sleep(1);	// Wait a bit for security reasons. Prevent flooding...
				$session->put_infobox(ct('S_INFO_PASSWORD_SUCCESS'), ct('S_INFO_PASSWORD_SUCCESS_INFO'));
			} else {
				$session->put_errorbox(ct('S_INFO_PASSWORD_FAILED'), ct('S_INFO_PASSWORD_FAILED_INFO'));
			}
				
			ct_redirect(ct_pageurl("login", array("ctusername"=>$http['form_username'])));
		} else {
			$session->put_errorbox(ct('S_ERROR_PASSWORD'), ct('S_ERROR_PASSWORD_SEVERAL')." ".ct_encodeMail(ctconf_get('conferenceContactEmail')));
		}
		ct_redirect(ct_pageurl("login"));
	}
	
} else {
	
	echo "<br><br><br>";	
	$form = new CTForm(ct_pageurl('sendPassword'),"post");
	$form->width = '550';
	$form->align = 'center';
	$form->waitmessage = true;
	
	$form->add_separator(ct('S_LOGIN_SENDPASSWORD'));
	$form->add_label("",ct('S_SENDPW_DESCRIPTION2',array(ct_encodeMail(ctconf_get('conferenceSenderEmail'))))); // New description. User has to enter the username.
	$form->add_text(ct('S_SENDPW_USERNAME'), 'form_username', '', 20, 255);
	$form->add_submit('cmd_send_password', ct('S_SENDPW_SUBMIT'));
	
	$form->show();
	echo "<br><br>";
}


?>