<?php
//
// PAGE:		sendPassword
// DESC:		Send forgotten password to user... If there are any problems, check your mail server configuration!
//

ct_load_class('CTForm');
ct_load_lib("mail.lib");
ct_load_lib("mail_person.lib");

if (isset($http['cmd_send_username']) || isset($http['form_email'])) {
	sleep(.5);	// Wait a bit for security reasons. Prevent flooding...
	if ($http['form_email']=="" || !ct_validate_email($http['form_email'])) {
		$session->put_errorbox(ct('S_ERROR_USERNAME'), ct('S_ERROR_USERNAME_EMPTY',array(ct_encodeMail(ctconf_get('conferenceContactEmail')))));
		ct_redirect(ct_pageurl('sendUsername'));
	} else {
		// Make sure string is perfectly fine for the query...
		$email = ct_mysql_escape_string(stripslashes(str_replace(' ','',strtolower($http['form_email']))));
		// Do query for first email address.
		$query="select ID from persons where LOWER(email)='$email' and deleted=0";
		$r = $db->query($query);
		if ($r && ($db->num_rows($r)==0)) {
			// not found, try second email address...
			$query="select ID from persons where LOWER(email2)='$email' and deleted=0";
			$r = $db->query($query);
			if ($r && ($db->num_rows($r)==0)) {
				$session->put_errorbox(ct('S_ERROR_USERNAME'), ct('S_ERROR_USERNAME_FAILED',array($http['form_email'], ctconf_get('conferenceShortName'), ct_encodeMail(ctconf_get('conferenceContactEmail')))));
				ct_redirect(ct_pageurl("login"));
			}
		} 
		
		if ($r && ($db->num_rows($r) == 1)) {
			// user exists!
			$t = $db->fetch_raw($r);
			$person = new CTPerson();

			// send email
			if ($person->load_by_id($t['ID']) && ct_mail_username($person,$email))
				$session->put_infobox(ct('S_INFO_USERNAME'), ct('S_INFO_USERNAME_SUCCESS'));
			else
				$session->put_errorbox(ct('S_ERROR_USERNAME'), ct('S_ERROR_USERNAME_MAILERROR',array(ct_encodeMail(ctconf_get('conferenceContactEmail')))));
				
			sleep(1);	// Wait a bit for security reasons. Prevent flooding...
			ct_redirect(ct_pageurl("login"));
		} else { // more than one...
			$session->put_errorbox(ct('S_ERROR_USERNAME'), ct('S_ERROR_USERNAME_SEVERAL',array(ct_encodeMail(ctconf_get('conferenceContactEmail')))));
		}
	}
	
} else {
	echo "<br><br><br>";	
	$form = new CTForm(ct_pageurl('sendUsername'),"post");
	$form->width = '600';
	$form->align = 'center';
	$form->waitmessage = true;
	
	$form->add_separator(ct('S_LOGIN_SENDUSERNAME'));
	$form->add_label("",ct('S_SENDUSERNAME_DESCRIPTION',array(ct_encodeMail(ctconf_get('conferenceSenderEmail')))));
	$form->add_text(ct('S_SENDUSERNAME_EMAIL'), 'form_email', '', 40, 255);
	$form->add_submit('cmd_send_username', ct('S_SENDUSERNAME_SUBMIT'));
	
	$form->show();
	echo "<br><br>";
}


?>