<?php
//
// PAGE:		showCommunityIcon
// DESC:		displays a Community Icon which is stored in the database
// PARAM:		form_id 	The number of the identity!
//				width  The maximum width of the image.
//				height The maximum height  of the image.
//	The image may be resized using form_width, however the gd_lib has to be installed on
//  the computer and to be integrated in php. See:
//  http://us4.php.net/manual/en/ref.image.php

if (!in_http('form_id')) {
	ct_redirect(ct_pageurl('index'));
}

ct_load_class('CTIdentity');

$identity = new CTIdentity;
$identity->load_by_id($http['form_id']);
$width=$http['width'];
$height=$http['height'];

// get filename
$filename = $identity->get('iconname');

if ($identity->get_id()=="" ||
    (!$user->is_admin() && !$user->is_assistant() && !$identity->check_visibility('online') && $identity->get_personID()!=$user->get_id()) ||
	($filename=="") )  {
		$session->put_errorbox(ct('S_ERROR_SYSTEM'), ct('S_ERROR_SYSTEM_FILENOTFOUND'));
		ct_redirect(ct_pageurl('error'));
}

// get extension.
eregi(".*\.(.{2,4})$",$filename,$regs);
$extension = $regs[1];

// get image data
$icondata = $identity->getIcon();

#var_dump(gd_info()); die;

// Resize if the gd_library is present...
if (function_exists("gd_info") && ($width!="" || $height!="")) {
	if ($width==""  || $width >1024 || $width <0)  $width =1024;	// Maximum values...
	if ($height=="" || $height>1024 || $height<0)  $height=1024;
	$src = imagecreatefromstring($icondata);
	$w = imagesx($src);
	$h = imagesy($src);
	$old_a = $h/$w;
	$new_a = $height/$width;
	if ($old_a < $new_a) {
	   	$new_w = $width;
   		$new_h = abs($new_w * $old_a);
	}else {
   		$new_h = $height;
	   	$new_w = abs($new_h / $old_a);
	}
	$img = imagecreatetruecolor($new_w,$new_h);
	if (function_exists("imageCopyResampled")) {
		if (!@ImageCopyResampled($img,$src,0,0,0,0,$new_w,$new_h,$w,$h)) {
    		ImageCopyResized($img,$src,0,0,0,0,$new_w,$new_h,$w,$h);
    	}
	} else {
   		ImageCopyResized($img,$src,0,0,0,0,$new_w,$new_h,$w,$h);
	}
	$extension="jpg";
} else {
	$img = "";
}

ob_end_clean();

// determine mime-type from extension
$header = "Content-Type: ";
switch ($extension) {
	case "gif": case "GIF":
 	$header .= "image/gif"; break;
	case "jpg": case "JPG":
	$header .= "image/jpeg"; break;
	case "png": case "PNG":
	$header .= "image/png"; break;
	case "html": case "HTML":  case "htm": case "HTM":
	$header .= "text/html"; break;
	case "txt": case "TXT":
	$header .= "text/plain"; break;
	default:
#	$header .= "image/jpeg"; break;
	$header.= "application/octet-stream";
}
// now send header...
header($header);

header('Last-Modified: ' . gmdate("D, d M Y H:i:s") . " GMT");	 // always changed...
header('Expires: Sun, 13 Dec 1998 05:00:00 GMT');			     // always outdated...
header('Pragma: no-cache');     							   // HTTP 1.0
header('Cache-Control: no-store, no-cache, must-revalidate, post-check=0, pre-check=0, max-age=0, private');  // HTTP 1.1

// ...and image.
if ($img!="") {
	imagejpeg($img);
	ImageDestroy($src);
	ImageDestroy($img);
} else {
	print  $icondata;
}	
exit();

?>
