<?php
#
# PAGE:		showIdentity
# DESC:     Shows the conference Identity of a participant (if available...)
# HINT:		
#


// if user has no admin rights, check if is pc member and "conference" is active
if (! ($user->is_admin()  || $user->is_frontdesk() || $user->is_assistant() || 
		($user->is_participant() and ct_check_phases('browseparticipants')))) {
	$session->put_errorbox(ct('S_ERROR_PHASE'), ct('S_ERROR_PHASE_INACTIVE'));
	ct_redirect(ct_pageurl('error'));
}

if (!in_http('form_id')) {
	ct_redirect(ct_pageurl('browseOfficialParticipants'));
}

ct_load_class('CTIdentity');
$identity = new CTIdentity;

# check if identity is existing...
if (isset($http['form_personID'])) {
	$identity->load_by_personID($http['form_personID']);
} elseif (isset($http['form_id'])) {
	$identity->load_by_id($http['form_id']);
} else {
	$session->put_errorbox(ct('S_ERROR_IDENTITY'), ct('S_ERROR_IDENTITY_PERSONNOTFOUND'));
	ct_redirect(ct_pageurl('browseOfficialParticipants'));
}

# check if ideintity is accessible...
// check if user is allowed to edit the identity data.
// if user has no admin rights and is not the person himself he gets his own page...
// of if no http param is set, use the personID of the current user
if (!$user->is_admin() && !$user->is_assistant() && 
		(!is_string(strstr($identity->get('visibility'),'onlist')) || $identity->get('deleted')==1)) {
	$session->put_errorbox(ct('S_ERROR_IDENTITY'), ct('S_ERROR_IDENTITY_PERSONNOTFOUND'));
	ct_redirect(ct_pageurl('browseOfficialParticipants'));
}

$identity->show_details();

?>