<?php
//
// PAGE:		submissions
// DESC:		list all submissions of authors and allow to submit new papers
//


ct_pagepath(array('index'));

$session->set_besturl(ct('S_INDEX_CMD_SUBMISSIONS_SHORT'));

ct_load_class('CTPaper');
ct_load_lib('papers.lib');
ct_load_lib('address.lib');
ct_load_lib('datetime.lib');

$session->del('db_contributiontypes'); // reset cached contributiontypes...

$papers = $user->get_papers();
$copapers = array(); 
#$copapers = $user->get_coauthor_papers(); // Does not work, yet: email-Addresses have to be ckecked!

	// if user has no admin rights, check if phase "submission" is active
if (!$user->is_admin() and !ct_check_phases("submission") and count($papers)==0 and count($copapers)==0) {
	$session->put_errorbox(ct('S_ERROR_PHASE'), ct('S_ERROR_PHASE_INACTIVE'));
	ct_redirect(ct_pageurl('error'));
}

if(ctconf_get('participation/enabled') && ctconf_get('payment/enabled') &&
	ct_check_phases("participation") && $user->get_id()!= 1 &&
	!$user->is_participant() && $user->is_author() ) {
	ct_warningbox(ct('S_INFO_PARTICIPATE'),ct('S_INFO_PARTICIPATE_AUTHOR_REMINDER',array("<a class='cmda' href='".ct_pageurl('participate')."'>","</a>")));
}

echo "<h1>".ct('S_INDEX_CMD_SUBMISSIONS')."</h1>\n";
echo "<p class=\"fontnormal font10\">".ct('S_INDEX_OPTION_SUBMISSIONS')."</p>\n";


// options available only if author status is set
if ($user->is_author()) {
	echo "<table cellpadding=5 align=center width=\"100%\">\n";
	
	echo "<tr><td colspan=2 class=\"mediumbg_gradient\">\n";
		echo "<span class=\"fontbold font10\">".ct('S_INDEX_OPTIONSASAUTHOR')."</span>\n";
		echo "</td></tr><tr><td width=\"5%\" class=\"mediumbg\">&nbsp;</td>";
		echo "<td width=\"95%\" valign=top align=left class=\"lightbg\">\n";
	
		for ($i=0; $i < sizeof($papers); $i++) {
			$papers[$i]->show_infobox('98%');
			ct_vspacer();
		}
	
		echo "</td></tr>\n";
	
	echo "</table>";
}

// options available only if co-author status is set
if (count($copapers)>0) {
	echo "<table cellpadding=5 align=center width=\"100%\">\n";
	
	echo "<tr><td colspan=2 class=\"mediumbg_gradient\">\n";
		echo "<span class=\"fontbold font10\">".ct('S_INDEX_OPTIONSASCOAUTHOR')."</span>\n";
		echo "</td></tr><tr><td width=\"5%\" class=\"mediumbg\">&nbsp;</td>";
		echo "<td width=\"95%\" valign=top align=left class=\"lightbg\">\n";
	
		for ($i=0; $i < sizeof($copapers); $i++) {
			$copapers[$i]->show_infobox('98%');
			ct_vspacer();
		}
	
		echo "</td></tr>\n";
	
	echo "</table>";
}


// List options for new submissions
if (ct_check_phases("submission") || $user->is_admin()) { 
	echo "<table cellpadding=5 align=center width=\"100%\">\n";
	echo "<tr><td colspan=2 class=\"mediumbg_gradient\">\n";
	echo "<span class=\"fontbold font10\">".ct('S_INDEX_CMD_SUBMITPAPER')."</span>\n";
	if ((!ct_check_phases("submission") || !$next_deadline>ct_time()) && $user->is_admin()) 
		echo "<span class=\"fontnegative fontbold font10\"> - ".ct('S_NEWPAPER_SUBMISSIONDEACTIVATED')."</span></dt>\n";
	echo "</td></tr>\n";
	echo "<tr><td width=\"5%\" class=\"mediumbg\">&nbsp;</td>";
	echo "<td width=\"95%\" valign=top align=left class=\"lightbg\">\n";

	echo ct('S_INDEX_OPTION_SUBMITPAPER')." ";
	echo ct('S_INDEX_OPTION_SUBMITPAPER_INFO')."<br>";
	ct_vspacer('6');
	echo "<dl>\n";
	$types=ct_get_contributiontypes();
	while (list(,$v) = each($types)) {
		$deadline=ct_get_submission_deadline($v);
		$upload_deadline=ct_get_upload_deadline($v);
		if ($v['active']=='true' && $deadline>ct_time() && ct_check_phases("submission")) {
			echo "<dt><a class=\"cmda\" href=\"".ct_pageurl('newPaper',array('form_contributiontypeID'=>$v['ID'], 'newpaper'=>'true'))."\">".$v[ctlx($v,'title')]."</a></dt>\n";
			if ($v[ctlx($v,'info')]!='')
				echo "<dd class=\"fontnormal font10\">".$v[ctlx($v,'info')]."</dd>\n";
			echo "<dd><span class=\"fontlabel font10\">".ct('S_PHASES_DEADLINE').':</span> ';
			echo ct_datetime_format_timezone($deadline);
			echo ', ';
			echo "<span class=\"fontlabel font10\">".ct('S_PHASES_TIMELEFT').':</span> ';
			echo ct_format_timeleft(ct_time(),$deadline)."</dd>\n";
			if ($upload_deadline>$deadline) {
				echo "<dd><span class=\"fontlabel font10\">".ct('S_PAPER_UPLOAD_DEADLINE').':</span> ';
				echo ct_datetime_format_timezone($upload_deadline);
				echo ', ';
				echo "<span class=\"fontlabel font10\">".ct('S_PHASES_TIMELEFT').':</span> ';
				echo ct_format_timeleft(ct_time(),$upload_deadline)."</dd>\n";
			}

		} elseif ($v['active']=='true' || $user->is_admin()) {
			if ($user->is_admin())
				echo "<dt><a class=\"cmda\" href=\"".ct_pageurl('newPaper',array('form_contributiontypeID'=>$v['ID'], 'newpaper'=>'true'))."\">".$v[ctlx($v,'title')]."</a>";
			else
				echo "<dt><span class=\"fontbold font10\" >".$v[ctlx($v,'title')]."</span>";

			if ($v['active']=='true')
				echo " <span class=\"fontnegative fontbold font10\">(".ct('S_NEWPAPER_SUBMISSIONCLOSED').")</span></dt>\n";
			else // invisible for normal users!
				echo " <span class=\"fontnegative fontbold font10\">(".ct('S_NEWPAPER_SUBMISSIONDEACTIVATED').")</span></dt>\n";

			if ($v[ctlx($v,'info')]!='')
				echo "<dd class=\"fontnormal font10\">".$v[ctlx($v,'info')]."</dd>\n";
			if ($deadline>ct_time() && ct_check_phases("submission")) {
				echo "<dd><span class=\"fontlabel font10\">".ct('S_PHASES_DEADLINE').':</span> ';
				echo ct_datetime_format_timezone($deadline);
				echo ', ';
				echo "<span class=\"fontlabel font10\">".ct('S_PHASES_TIMELEFT').':</span> ';
				echo ct_format_timeleft(ct_time(),$deadline)."</dd>\n";
			}
			if ($upload_deadline>ct_time() && ct_check_phases("submission")) {
				echo "<dd><span class=\"fontlabel font10\">".ct('S_PAPER_UPLOAD_DEADLINE').':</span> ';
				echo ct_datetime_format_timezone($upload_deadline);
				echo ', ';
				echo "<span class=\"fontlabel font10\">".ct('S_PHASES_TIMELEFT').':</span> ';
				echo ct_format_timeleft(ct_time(),$upload_deadline)."</dd>\n";
			}
		}
		
		if (!empty($v['email_chair']) && ($v['active']=='true' || $user->is_admin()) ) {
			echo "<dd><span class=\"fontlabel font10\">".ct('S_NEWPAPER_CHAIRCONTACT').':</span> '.ct_encodeMail($v['email_chair'])."</dd>\n";
		}
		if ($v['active']=='true' || $user->is_admin()) {
			echo "<dt>"; ct_vspacer('10'); echo "</dt>\n";
		}
	}
	echo "</dl>\n";
	
	echo "</td></tr>\n";

echo "</table>";

}



?>