<?php
//
// PAGE:		uploadPaper
// DESC:		Upload a contribution. 
//			    If there are any problems with big files, see the INSTALL documentation!
//

// this page does only make sense if an ID for a paper was provided. If not,
// we redirect to the index page

ct_pagepath(array("index"));

ct_load_class('CTPaper');
ct_load_lib('papers.lib');

if (!isset($http['form_id'])) {
	$session->put_errorbox(ct('S_ERROR_PAPER_UPLOAD'), ct('S_ERROR_PAPER_UPLOAD_FAILED'));
	ct_redirect(ct_pageurl('index'));
}

$paper = new CTPaper;

// redirect to index if id does not correspond to a real paper
if (!$paper->load_by_id($http['form_id'])) {
	$session->put_errorbox(ct('S_ERROR_PAPER_UPLOAD'), ct('S_ERROR_PAPER_UPLOAD_FAILED'));
	ct_redirect(ct_pageurl('index'));
}

// Get correct paper class name
$classname = $paper->get_paperClass();
ct_load_class($classname);
eval('$paperclass = new '.$classname.'();');
$paperclass = ct_type_cast($paper,$classname);


// if user has no admin rights, check if phase "submission" is active
if ($user->is_admin() || 
		(ct_check_phases(array("submission")) && $paperclass->is_upload_active())) {

	$author =& $paperclass->get_author(); 
	
	// check if user is allowed to edit paper information. access is denied
	// if user has no admin rights and is not the author of the paper
	if (!$user->is_admin() && ($user->get('ID') != $author->get('ID'))) {
		$session->put_errorbox(ct('S_ERROR_PAPER_UPLOAD'), ct('S_ERROR_PAPER_UPLOAD_NOACCESS'));
		ct_redirect(ct_pageurl('index'));
	}
	
	if (isset($http['cmd_paper_upload'])) {
		global $session;
	
		$uploads = $paperclass->process_uploadform(""); // Returns: OK, ERROR, MISSING, EXISTS
		$paperclass->persist();
		# ct_print_r($uploads);
		if (in_array('ERROR',$uploads)) { // if there was an error, show it and stay on this page
			// message was already create by upload method.						
		} elseif (!in_array('OK',$uploads)) { // if non upload succeeded, but there was no error, stay on this page and show a message
			ct_warningbox($file_number_text.ct('S_ERROR_PAPER_UPLOAD'), ct('S_ERROR_PAPER_UPLOAD_NO_FILE'));
		} elseif(in_array('OK',$uploads)) {			
			for ($i=1; $i<=count($uploads); $i++) {
				if (count($uploads)>1) 
					$file_number_text = ct_get_file_number_text($i).': ';
				else 
					$file_number_text = '';
				if ($uploads[$i]=="OK")
					$session->put_infobox($file_number_text.ct('S_INFO_PAPER_UPLOAD'), ct('S_INFO_PAPER_UPLOAD_SUCCESS'));
				if ($uploads[$i]=="MISSING")
					$session->put_warningbox($file_number_text.ct('S_INFO_PAPER_MISSING'), ct('S_INFO_PAPER_MISSING_NOTFORGET'));
				# if ($uploads[$i]=="EXISTS") => No message required.
				# if ($uploads[$i]=="ERROR") => Message was already displayed.
			}
			// send email:
			ct_load_lib('mail_papers.lib');
			ct_mail_author_submission_confirmation($paperclass,false);

		 	ct_redirect($session->get_besturl());
		 	// ct_redirect(ct_pageurl('submissions'));
		}
	} 
	echo "<h1>".ct('S_PAPER_UPLOAD_TITLE')."</h1>\n";
	echo "<p class=\"fontnormal font10\">".ct('S_PAPER_UPLOAD_INTRO')."</p>";
	$paperclass->show_detailed('90%');
	$paperclass->show_downloads('','90%');
	
	#echo "<table  width=\"90%\" align=\"center\" cellspacing=1 border=0 cellpadding=2 class=\"blackbg\">";
	#echo "<tr><td class=\"whitebg\" align=left valign=top>";
	#$paperclass->show_formatted(true,true);
	#echo "</td></tr></table>\n";	
	$paperclass->show_uploadform(ct_pageurl('uploadPaper'));
} else {
	$session->put_errorbox(ct('S_ERROR_PHASE'), ct('S_ERROR_PHASE_INACTIVE'));
	ct_redirect(ct_pageurl('error'));
}

?>