<?php
//
// PAGE:		withdrawPaper
// DESC:		Withdraw a contribution... Either your own or any for the admin.
//

// this page does only make sense if an ID for a paper was provided. If not,
// we redirect to the index page
if (!isset($http['form_id'])) {
	ct_redirect(ct_pageurl('index'));
}

ct_pagepath(array("index"));

ct_load_class('CTPaper');
ct_load_class('CTForm');


$paper = new CTPaper;
// redirect to index if id does not correspond to a real paper
if (!$paper->load_by_id($http['form_id'])) {
	$session->put_errorbox(ct('S_ERROR_PAPER_WITHDRAW'), ct('S_ERROR_PAPER_WITHDRAW_NOACCESS'));
	ct_redirect($session->get_besturl());
}

// if user has no admin rights, check if phase "submission" is active
if (!$user->is_admin() and !ct_check_phases("submission")) {
	$session->put_errorbox(ct('S_ERROR_PHASE'), ct('S_ERROR_PHASE_INACTIVE'));
	ct_redirect($session->get_besturl());
}

// Get correct paper class name
#$classname = $paper->get_paperClass();
#ct_load_class($classname);
#eval('$paperclass = new '.$classname.'();');
#$paperclass = ct_type_cast($paper,$classname);

// Get main author
$author =& $paper->get_author();

// check if user is allowed to delete the paper. access is denied
// if user has no admin rights and is not the author of the paper
if (!$user->is_admin() && ($user->get('ID') != $author->get('ID'))) {
	$session->put_errorbox(ct('S_ERROR_PAPER_WITHDRAW'), ct('S_ERROR_PAPER_WITHDRAW_NOACCESS'));
	ct_redirect($session->get_besturl());
}

if (isset($http['cmd_delete_yesconfirm'])) {
	if ($paper->withdraw()) {
		ct_load_lib('mail_papers.lib');
		ct_mail_author_withdrawn_confirmation($paper,$extratext='');

		$author->check_author();
		$author->persist();
		$paper->set_coauthors(false);

		$user->reload(); // reload user data, maybe it changed...

		$session->put_infobox(ct('S_INFO_PAPER_WITHDRAW'), ct('S_INFO_PAPER_WITHDRAW_SUCCESS'));
	} else {
		$session->put_errorbox(ct('S_ERROR_PAPER_WITHDRAW'), ct('S_ERROR_PAPER_WITHDRAW_FAILED'));
	}
	ct_redirect($session->get_besturl());
} else {
	if (isset($http['cmd_delete_noconfirm'])) {
		ct_redirect($session->get_besturl());
	} else {
		$form = new CTForm(ct_pageurl('withdrawPaper'), 'post');
		$form->width = 600;
		$form->align = 'center';
		$form->add_hidden(array(array('form_id', $paper->get('ID'))));
		$form->add_label(ct('S_PAPER_FORM_ID'), $paper->get('ID'));
		$form->add_label(ct('S_PAPER_FORM_TITLE'), $paper->get_special('title'));
		$form->add_label(ct('S_PAPER_FORM_AUTHOR'), $paper->get_special('author'));
		$form->add_submit('cmd_delete_yesconfirm', ct('S_PAPER_WITHDRAW_YESCONFIRM'));
		$form->add_submit('cmd_delete_noconfirm', ct('S_PAPER_WITHDRAW_NOCONFIRM'));
		
		echo "<h1>".ct('S_PAPER_WITHDRAW_TITLE')."</h1>\n";
		echo "<p class=\"fontnormal font10\">".ct('S_PAPER_WITHDRAW_INTRO')."</p>\n";
		$form->show();
	}
}


